-- useful HUD functions
freeslot("SPR_AIMR")	-- bit of a hack for the crosshair, lol

PSO.lib.HUD_screenCoords = function(v, p, c, mx, my, mz)
	local camx, camy, camz, camangle, camaiming
	if p.awayviewtics then
		camx = p.awayviewmobj.x
		camy = p.awayviewmobj.y
		camz = p.awayviewmobj.z
		camangle = p.awayviewmobj.angle
		camaiming = p.awayviewaiming
	elseif c.chase then
		camx = c.x
		camy = c.y
		camz = c.z
		camangle = c.angle
		camaiming = c.aiming
	else
		camx = p.mo.x
		camy = p.mo.y
		camz = p.viewz-20*FRACUNIT
		camangle = p.mo.angle
		camaiming = p.aiming
	end

	-- Lat: I'm actually very lazy so mx can also be a mobj!
	if type(mx) == "userdata" and mx.valid
		my = mx.y
		mz = mx.z
		mx = mx.x	-- life is easier
	end

	local x = camangle-R_PointToAngle2(camx, camy, mx, my)

	local distfact = cos(x)
	if not distfact then
		distfact = 1
	end -- MonsterIestyn, your bloody table fixing...

	if x > ANGLE_90 or x < ANGLE_270 then
		return -9, -9, 0
	else
		x = FixedMul(tan(x, true), 160<<FRACBITS)+160<<FRACBITS
	end

	local y = camz-mz
	--print(y/FRACUNIT)
	y = FixedDiv(y, FixedMul(distfact, R_PointToDist2(camx, camy, mx, my)) or 1)
	y = (y*160)+(100<<FRACBITS)
	y = y+tan(camaiming, true)*160

	local scale = FixedDiv(160*FRACUNIT, FixedMul(distfact, R_PointToDist2(camx, camy, mx, my)) or 1)
	--print(scale)

	return x, y, scale
end


-- progress is used for the item tekker anim, 0-100
PSO.lib.HUD_drawItemRarity = function(v, x, y, flags, rarity, progress)
		
	local dx = x
	
	if progress == nil	-- normal handler
		
		for i = 1, max(rarity, 9)
			
			local pname = "H_STAR0"
			if i <= rarity
				pname = "H_STAR"..((i-1)/3 +1)
			end
			
			v.draw(dx, y, v.cachePatch(pname), flags)
			dx = $+9
		end
	else	-- ay dios mio
		
		-- we wanna fill out the stars as we go depending on total rarity so that we leave about a 0.5s delay before filling out the last star
		-- 0-1s: fill out the first stars
		-- 1.5s-1.7s: fill out the last star
		-- 1.7~2s: shine!
		
		local firsttarget = rarity-1
		local firstduration = TICRATE
		local delay = firstduration/firsttarget
		local animtime = 8	-- 8 frames to show the star!
		
		-- always draw the 9 vacant slots in the back...
		for i = 1, 9
			v.draw(x + (i-1)*9, y, v.cachePatch("H_STAR0"), flags)
		end
		
		for i = 1, rarity
			
			if i <= rarity
				local tt = (progress - delay*(i-1))
				local pp = "H_STAR"..((i-1)/3 +1)
				
				if i == rarity
					tt = $ - TICRATE/2
				end
				
				if tt > 0
					local anim = max(0, animtime-tt)
					local scale = FRACUNIT + (anim*FRACUNIT/3 * (i == rarity and 3 or 1))
					local tflag = max(0, 9-tt*3/2)<<V_ALPHASHIFT
					v.drawScaled(dx*FRACUNIT, y*FRACUNIT, scale, v.cachePatch(pp), flags|tflag)
				end
			end
			
			dx = $+9
		end
	end
end

PSO.lib.HUD_damageNumberWidth = function(v, num, drawplus, fac)
	num = abs(num)
	local first
	local totalw = 0
	--local fac = halfscale and 3 or 1
	fac = $ or 1
	
	while num
		
		local drawnum = num%10
		local patch = v.cachePatch("PSODMN"..drawnum)
		local w = patch.width / fac
		
		if first
			totalw = $+w
		end
		first = true
		
		num = $/10
	end

	
	if drawplus
		local patch = v.cachePatch("PSODMNP")
		local w = patch.width / fac
		
		totalw = $+w
	end
	return totalw
end

PSO.lib.HUD_drawDamageNumber = function(v, x, y, num, flags, colour, drawplus, fac, drawpp, drawcrit)
	
	fac = $ or 1
	x = $ + PSO.lib.HUD_damageNumberWidth(v, num, drawplus, fac) /2
	--local fac = halfscale and 3 or 1
	local tflag = 0	--halfscale and V_50TRANS or 0
	
	num = abs(num)
	
	if num == 0
		v.drawScaled(x*FRACUNIT, y*FRACUNIT, FRACUNIT/fac, v.cachePatch("PSODMBL"), flags|tflag, v.getColormap(TC_DEFAULT, colour))
		return
	end
	
	local first
	local drawextra
	
	while num
		
		local drawnum = num%10
		local patch = v.cachePatch("PSODMN"..drawnum)
		local w = patch.width / fac
		
		local xoff = 0
		local yoff = 0
		
		if drawcrit
			xoff = v.RandomRange(-1, 1)
			yoff = v.RandomRange(-1, 1)
		end
		
		if first
			x = $-w
		elseif drawpp
		and not drawextra
			local patch = v.cachePatch("PSODMNA")
			v.drawScaled((x+w)*FRACUNIT, y*FRACUNIT, FRACUNIT/fac, patch, flags|tflag, v.getColormap(TC_DEFAULT, colour))	
			drawextra = true

		elseif drawcrit
		and not drawextra
			local patch = v.cachePatch("PSODMNE")
			for i = 1, 2
				v.drawScaled((x+w+ (i==2 and 6 or 0) + xoff)*FRACUNIT, (y+yoff)*FRACUNIT, FRACUNIT/fac, patch, flags|tflag, v.getColormap(TC_DEFAULT, colour))
				xoff = v.RandomRange(-1, 1)
				yoff = v.RandomRange(-1, 1)			
			end
			drawextra = true
			
		end
		first = true
		
		v.drawScaled((x+xoff)*FRACUNIT, (y+yoff)*FRACUNIT, FRACUNIT/fac, patch, flags|tflag, v.getColormap(TC_DEFAULT, colour))
		
		num = $/10
	end
	
	if drawplus
		local patch = v.cachePatch("PSODMNP")
		local w = patch.width / fac
		
		x = $-w
		v.drawScaled(x*FRACUNIT, y*FRACUNIT, FRACUNIT/fac, patch, flags|tflag, v.getColormap(TC_DEFAULT, colour))	
	end
end

-- less lazy triangle drawer
PSO.lib.HUD_drawTriangle = function(v, x1, y1, x2, y2, x3, y3, color)
	color = $ or 0
	local points = {
		{x=x1, y=y1},
		{x=x2, y=y2},
		{x=x3, y=y3}		-- << use fixed point to make it easier to deal with trig when we supply coords
	}
	table.sort(points, function(a, b)
		if a.y == b.y then
			return a.x <= b.x
		else
			return a.y <= b.y
		end
	end)
	-- sort points so that y1 <= y2 <= y3
	local A, B, C = points[1], points[2], points[3]
	local dx1 = (B.y-A.y > 0) and FixedDiv((B.x-A.x), (B.y-A.y)) or 0
	local dx2 = (C.y-A.y > 0) and FixedDiv((C.x-A.x), (C.y-A.y)) or 0
	local dx3 = (C.y-B.y > 0) and FixedDiv((C.x-B.x), (C.y-B.y)) or 0

	local ix, iy = A.x, A.y	-- start coords
	local ex, ey = ix, iy	-- end coords
	if dx1 > dx2 then
		while iy <= B.y
			v.drawFill(ix/FRACUNIT, iy/FRACUNIT, max(1, (ex-ix)/FRACUNIT), 1, color)	-- << divide ex-ix because we will get errors if we bitshift
			iy = $+FRACUNIT
			ix = $+dx2
			ex = $+dx1
		end
		ex, ey = B.x, B.y
		while iy < C.y
			v.drawFill(ix/FRACUNIT, iy/FRACUNIT, max(1, (ex-ix)/FRACUNIT), 1, color)
			iy = $+FRACUNIT
			ix = $+dx2
			ex = $+dx3
		end

	else
		while iy <= B.y
			v.drawFill(ix/FRACUNIT, iy/FRACUNIT, max(1, (ex-ix)/FRACUNIT), 1, color)
			iy = $+FRACUNIT
			ix = $+dx1
			ex = $+dx2
		end
		ix, iy = B.x, B.y
		while iy < C.y
			v.drawFill(ix/FRACUNIT, iy/FRACUNIT, max(1, (ex-ix)/FRACUNIT), 1, color)
			iy = $+FRACUNIT
			ix = $+dx3
			ex = $+dx2
		end
	end
end

local function pointInBound(x, y, bound)
	return x >= bound[1] and x <= bound[3] and y >= bound[2] and y <= bound[4]
end

-- these two funcs handle steep lines, we don't need them outside of here since R_drawLine will do this for us
local function R_LineLow(v, x0,y0, x1,y1, c, bound)
	local dx = x1 - x0
	local dy = y1 - y0
	local yi = 1

	if dy < 0
		yi = -1
		dy = -dy
	end

	local D = 2*dy - dx
	local y = y0

	for x = x0, x1
		
		if not bound
		or pointInBound(x, y, bound)
			v.drawFill(x, y, 1, 1, c)
		end	
		
		if D > 0
			y = y + yi
			D = D - 2*dx
		end
		D = D + 2*dy
	end
end

local function R_LineHigh(v, x0,y0, x1,y1, c, bound)
	local dx = x1 - x0
	local dy = y1 - y0
	local xi = 1

	if dx < 0
		xi = -1
		dx = -dx
	end

	local D = 2*dx - dy
	local x = x0

	for y = y0, y1
		if not bound
		or pointInBound(x, y, bound)
			v.drawFill(x, y, 1, 1, c)
		end	

		if D > 0
			x = x + xi
			D = D - 2*dy
		end
		D = D + 2*dx
	end
end

-- lazy line drawer
PSO.lib.drawLine = function(v, x0, y0, x1, y1, c, bound)
	if abs(y1 - y0) < abs(x1 - x0)
		if x0 > x1
			R_LineLow(v, x1, y1, x0, y0, c, bound)
		else
			R_LineLow(v, x0, y0, x1, y1, c, bound)
		end
	else
		if y0 > y1
			R_LineHigh(v, x1, y1, x0, y0, c, bound)
		else
			R_LineHigh(v, x0, y0, x1, y1, c, bound)
		end
	end
 end