-- Gyrrey Agnes
/*

*/

freeslot("MT_PSO_ANGE", "S_PSO_ANGE_DIE", "SPR_ANGE", "SPR_ANG2", "MT_PSO_ANGE_PROJECTILE", "sfx_bchrg", "sfx_bshot")

mobjinfo[MT_PSO_ANGE] = {
	doomednum = 2556,
	spawnhealth = 1000,
	deathstate = S_PSO_ANGE_DIE,
	spawnstate = S_THOK,
	height = 450<<FRACBITS,
	radius = 127<<FRACBITS,
	flags = MF_ENEMY|MF_SHOOTABLE,
}

mobjinfo[MT_PSO_ANGE_PROJECTILE] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 24<<FRACBITS,
	height = 64<<FRACBITS,
	flags = MF_NOGRAVITY|MF_MISSILE,
}

local PROJ_BASESPEED = 140*FRACUNIT
local PROJ_BASEACCEL = FRACUNIT*3

-- basic chase thinker for illgrants
addHook("MobjThinker", function(mo)
	
	if not mo.target or not mo.target.valid
	or not mo.target.pso or not mo.target.pso.hp
		P_RemoveMobj(mo)
		return
	end
	
	local target = mo.tracer
	if not target or not target.valid
		P_RemoveMobj(mo)
		return
	end
	
	local illgrants_speed = mo.projspeed or PROJ_BASESPEED
	local illgrants_accel = mo.projaccel or PROJ_BASEACCEL
	
	local dist = P_AproxDistance(P_AproxDistance(target.x - mo.x, target.y - mo.y), target.z - mo.z)
	
	-- normalize vakues
	local dx = FixedDiv(target.x - mo.x, dist)
	local dy = FixedDiv(target.y - mo.y, dist)
	local dz = FixedDiv((target.z + target.height*6/10) - mo.z, dist)
	
	-- the values we want:
	local desired_momx = FixedMul(dx, illgrants_speed)
	local desired_momy = FixedMul(dy, illgrants_speed)
	local desired_momz = FixedMul(dz, illgrants_speed)
	
	-- how much we'd have to change by
	local steeringx = desired_momx - mo.momx
	local steeringy = desired_momy - mo.momy
	local steeringz = desired_momz - mo.momz
	
	-- cap acceleration
	if abs(steeringx) > illgrants_accel
		steeringx = (steeringx > 0 and 1 or -1) * illgrants_accel
	end

	if abs(steeringy) > illgrants_accel
		steeringy = (steeringy > 0 and 1 or -1) * illgrants_accel
	end
	
	if abs(steeringz) > illgrants_accel
		steeringz = (steeringz > 0 and 1 or -1) * illgrants_accel
	end	
	
	-- apply
	mo.momx = $ + steeringx
	mo.momy = $ + steeringy
	mo.momz = $ + steeringz
	
	local preva = (leveltime-1)*ANG1*20
	local a = leveltime*ANG1*20
	local dists = 4
	
	local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	s.tics = 2
	s.color = mo.color or SKINCOLOR_TAN
	s.colorized = true
	s.sprite = SPR_SSPK
	s.frame = B|FF_FULLBRIGHT|FF_ADD
	s.scale = mo.scale + cos(a)/16
	
	-- trail
	if mo.prevx ~= nil
		for i = 1, 5
			
			local x = PSO.lib.lerp(mo.prevx, mo.x, FRACUNIT/5 *i)
			local y = PSO.lib.lerp(mo.prevy, mo.y, FRACUNIT/5 *i)
			local z = PSO.lib.lerp(mo.prevz, mo.z, FRACUNIT/5 *i)
			
			local t = P_SpawnMobj(x, y, z + mo.scale*12, MT_THOK)
			t.fuse = 20
			--t.scale = $*2
			t.destscale = 1
			t.scalespeed = FRACUNIT/17
			t.tics = 17
			t.colorized = true
			t.color = mo.color or SKINCOLOR_TAN
			t.sprite = SPR_ENRG
			t.frame = $|FF_ADD|FF_FULLBRIGHT
		end
	end
		
	mo.prevx = mo.x
	mo.prevy = mo.y
	mo.prevz = mo.z

	
	--print(dist)
	if mo.tracer and mo.tracer.valid and mo.tracer.type == MT_THOK
	and dist < mo.scale*48
		P_RemoveMobj(mo)
	end
	
end, MT_PSO_ANGE_PROJECTILE)

local num_elipse = 32
local elipse_radius = 680

local function ange_spawnSegs(mo)

	local diff = PSO.lib.questDifficulty()
	local spr = diff >= DIFF_HARD and SPR_ANG2 or SPR_ANGE
	local bright = (diff >= DIFF_HARD and FF_FULLBRIGHT or 0)
	
	-- it's for segment, not sex you mongrel
	-- nevermind the concept of top and bottom
	if not mo.bottomsegs
		
		mo.rottimer = 0
		mo.segzsep = 0
		mo.bottomsegs = {}
		for i = 1, 4
			
			local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			s.sprite = spr
			s.frame = A|bright
			s.tics = -1
			s.scale = 1
			s.destscale = FRACUNIT*4
			s.renderflags = $ |(RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_NOSPLATROLLANGLE)
			P_CreateFloorSpriteSlope(s)	-- used for later
			
			mo.bottomsegs[#mo.bottomsegs+1] = s
		end		

		mo.topsegs = {}
		for i = 1, 4
			
			local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			s.sprite = spr
			s.frame = B|bright
			s.tics = -1
			s.scale = 1
			s.destscale = FRACUNIT*4
			s.renderflags = $ |(RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_NOSPLATROLLANGLE)
			P_CreateFloorSpriteSlope(s)	-- used for later
			
			mo.topsegs[#mo.topsegs+1] = s
		end	
		
		mo.elipse = {}
		mo.elipsestick = 0
		mo.elipseradius = elipse_radius
		mo.elipseangle = 0
		mo.elipsexy = ANG1*20
		
		for i = 1, num_elipse
			
			local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			s.sprite = spr
			s.frame = D|bright
			s.tics = -1
			s.scale = 1
			s.destscale = FRACUNIT
			s.renderflags = $ |(RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_NOSPLATROLLANGLE)
			P_CreateFloorSpriteSlope(s)	-- used for later
			
			mo.elipse[#mo.elipse+1] = s
			
		end
		
	end
end


local function ange_updateSegs(mo, shake)
	
	local radius = 192 - 16
	
	local a1 = ANG1*mo.rottimer/2
	local a2 = -ANG1*mo.rottimer/2
	
	local ogz1 = mo.z - mo.segzsep/2
	local ogz2 = mo.z + (FRACUNIT*96 + FRACUNIT*24)*4 + mo.segzsep/2
	
	if shake
		ogz1 = $ + P_RandomRange(-96, 96)*FRACUNIT
		ogz2 = $ + P_RandomRange(-96, 96)*FRACUNIT		
	end
	
	for i = 1, #mo.bottomsegs
		
		local s = mo.bottomsegs[i]
		
		local sx = mo.x + radius*cos(a1)
		local sy = mo.y + radius*sin(a1)
		if shake
			sx = $ + P_RandomRange(-96, 96)*FRACUNIT
			sy = $ + P_RandomRange(-96, 96)*FRACUNIT
		end
		
		s.angle = a1

		local origin = {x=sx, y=sy, z=ogz1}
		local xydir = a1
		local za = ANG1*45
		
		P_MoveOrigin(s, sx, sy, ogz1)
		
		s.floorspriteslope.o = origin
		s.floorspriteslope.xydirection = xydir
		s.floorspriteslope.zangle = za
		--PSO.lib.fixSplatScale(s)
		
		a1 = $+ANG1*90
	end

	for i = 1, #mo.topsegs
		
		local s = mo.topsegs[i]
		
		local sx = mo.x + radius*cos(a2)
		local sy = mo.y + radius*sin(a2)
		if shake
			sx = $ + P_RandomRange(-96, 96)*FRACUNIT
			sy = $ + P_RandomRange(-96, 96)*FRACUNIT
		end		
		s.angle = a2

		local origin = {x=sx, y=sy, z=ogz2}
		local xydir = a2
		local za = -ANG1*45
		
		P_MoveOrigin(s, sx, sy, ogz2)
		
		s.floorspriteslope.o = origin
		s.floorspriteslope.xydirection = xydir
		s.floorspriteslope.zangle = za
		--PSO.lib.fixSplatScale(s)
		
		a2 = $+ANG1*90
	end
	
	
	local curr_elipse_radius = mo.elipseradius
	local elipse_xy = mo.elipsexy
	local elipse_za = ANG1*30
	local elipse_origin = {x=mo.x, y=mo.y, z=(mo.z+FRACUNIT*96*4)}
	local elipse_a = mo.elipseangle
	
	
	for i = 1, #mo.elipse
		local s = mo.elipse[i]
		
		local sx = mo.x + curr_elipse_radius*cos(elipse_a)
		local sy = mo.y + curr_elipse_radius*sin(elipse_a)
		local z = elipse_origin.z
		if shake
			sx = $ + P_RandomRange(-96, 96)*FRACUNIT
			sy = $ + P_RandomRange(-96, 96)*FRACUNIT
			z = $ + P_RandomRange(-96, 96)*FRACUNIT
		end
		
		P_MoveOrigin(s, sx, sy, z)
		s.rollangle = elipse_a
		
		s.floorspriteslope.o = elipse_origin
		s.floorspriteslope.xydirection = elipse_xy
		s.floorspriteslope.zangle = elipse_za
		
		elipse_a = $ + (360/num_elipse)*ANG1 - mo.elipsestick
		
		-- afterimage effects
		if mo.swipe and mo.swipe > TICRATE*2/3 and mo.swipe < TICRATE*3
			
			local g = P_SpawnGhostMobj(s)
			P_CreateFloorSpriteSlope(g)
			g.floorspriteslope.o = elipse_origin
			g.floorspriteslope.xydirection = elipse_xy
			g.floorspriteslope.zangle = elipse_za
			g.colorized = true
			g.color = SKINCOLOR_TAN
			g.frame = $|FF_ADD
			P_InstaThrust(g, g.angle, FRACUNIT*32)
			g.destscale = $*8
			g.rollangle = s.rollangle
			g.tics = 8	
		end
	end

	-- halo
	local scale = {FRACUNIT*4, FRACUNIT*6}
	local angs = {ANG1*2, -ANG1*2}
	
	for i = 1, 2
		local halo = P_SpawnMobj(mo.x, mo.y, mo.z+mo.height + FRACUNIT*512, MT_THOK)
		halo.sprite = SPR_BFLW
		halo.frame = D|FF_ADD
		halo.flags2 = $ | MF2_SPLAT
		halo.renderflags = $|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD|RF_FULLBRIGHT
		halo.tics = 1
		halo.rollangle = leveltime*angs[i]
		halo.scale = scale[i]
		halo.colorized = true
		halo.color = SKINCOLOR_WHITE
	end	
	
	mo.elipseangle = $+ANG1
	mo.rottimer = $+1
	
end

function A_AngeDie(mo)
	
	if not mo.die
		server.angedie = 0
		mo.die = 1
		
		if mo.shredders
			for i = 1, #mo.shredders
				P_RemoveMobj(mo.shredders[i])
			end
			mo.shredders = nil
		end
	end
	
	server.angedie = $ and $+1 or 1
	if server.angedie == 1
		S_FadeOutStopMusic(400)
	end
	
	if leveltime%4 == 0
		local rx = mo.x + P_RandomRange(-1024, 1024)*mo.scale
		local ry = mo.y + P_RandomRange(-1024, 1024)*mo.scale
		local rz = mo.z + P_RandomRange(16, 2048)*mo.scale
		
		for i = 1, 64
			
			local t = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			t.color = i & 1 and SKINCOLOR_WHITE or SKINCOLOR_MASTER
			t.fuse = 11
			t.scale = $*2
			t.destscale = 1
			t.momx = P_RandomRange(-128, 128)*FRACUNIT
			t.momy = P_RandomRange(-128, 128)*FRACUNIT
			t.momz = P_RandomRange(-128, 128)*FRACUNIT
			
		end
		
		S_StartSound(nil, sfx_cdfm28)
		S_StartSound(nil, sfx_cdfm36)
	end	
	
	if server.angedie == TICRATE*7 -50
		for m in mobjs.iterate()
			if m and m.valid and m.type == MT_PSO_AIS --and m.extrainfo == ais.extrainfo
			and m.options & 8 and m.extrainfo == 15
				for p2 in players.iterate
					P_SetOrigin(p2.mo, m.x, m.y, m.z)
					p2.mo.angle = m.angle
					PSO.lib.playerDeactivateAIS(p2, true)
				end
				break
			end
		end	
	end
	
	if server.angedie > TICRATE*7+2
		P_RemoveMobj(mo)
		return
	end
	
	ange_updateSegs(mo, true)
end

-- VV annoying VV
hud.add(function(v, p, c)
	if server.angedie
		local timer = server.angedie
		
		local delay = TICRATE*3
		local t = (timer - delay)/5
		
		if t >= 0
		and timer <= TICRATE*7 -50
			v.fadeScreen(0, min(10, t))
		end
		
		if timer >= TICRATE*7 -50
		and timer <= TICRATE*7
			local t2 = (timer - (TICRATE*7-50)) /5
			v.fadeScreen(0, max(0, 10-t2))
		end
		
	end
end)

states[S_PSO_ANGE_DIE] = {SPR_NULL, A, 1, A_AngeDie, 0, 0, S_PSO_ANGE_DIE}

local function ange_trackPlayer(mo)
	if mo.target and mo.target.valid
		mo.angle =  R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
		
		local targetangle = mo.angle + ANG1*120
		mo.elipsexy = targetangle
		
	end
end

local function ange_pinch(mo)
	return mo.pso.hp < mo.pso.maxhp*6/10
end	

local function ange_prepbeam(mo, n, r, d)
	mo.beam = 1
	mo.beamangle = mo.angle
	mo.beamhitboxes = {}
	mo.shields = {}
	mo.numbeams = n or 1
	mo.beamrotate = r or 0
	mo.beamduration = d or TICRATE*7
	
	mo.pso.mitigations = {}
	
	
	for i = 1, #mo.elipse
		local e = mo.elipse[i]
		e.destscale = 1
	end
	
	
end


local function ange_dobeam(mo)

	local shield_dist = 512
	local laser_potency = 1200
	
	if mo.beamrotate
	and mo.beam > TICRATE*2 + TICRATE/2
		local tt = mo.beam - (TICRATE*2 + TICRATE/2)
		local ttt = TICRATE/2 - tt
		
		local angval = mo.beamrotate / max(1, ttt)
		mo.beamangle = $ + angval
	end
	
	if mo.beam > mo.beamduration
		mo.beam = nil
		mo.shields = nil
		for i = 1, #mo.elipse
			local e = mo.elipse[i]
			e.destscale = FRACUNIT
		end
		
		return
	end
	
	for i = 1, mo.numbeams
			
		local t = mo.beam
		
		local addang = 360 / mo.numbeams
		
		local ang = mo.beamangle + (addang*(i-1))*ANG1
		
		local tx = mo.x + shield_dist*cos(ang)
		local ty = mo.y + shield_dist*sin(ang)
			
		if t == 10
			--print("A")
			local s = P_SpawnMobj(tx, ty, mo.z + mo.height*3/2, MT_THOK)
			s.sprite = SPR_ANGE
			s.frame = D|FF_ADD|FF_FULLBRIGHT|FF_PAPERSPRITE
			s.scale = 1
			s.tics = -1
			s.destscale = FRACUNIT*16
			s.scalespeed = FRACUNIT*3/2
			mo.shields[i] = s
			
			if i == 1
				S_StartSound(nil, sfx_s3k73)
				S_StartSound(nil, sfx_bchrg)
			end
			
			mo.pso.mitigations[i] = {
				ang - ANG1*60, 
				ang + ANG1*60
			}
			
		elseif t > 10
			local s = mo.shields[i]
			s.rollangle = $ + ANG1*2
			
			P_MoveOrigin(s, tx, ty, s.z)
			s.angle = ang + ANG1*90
			
			if t > (mo.beamduration - TICRATE)
				s.destscale = 1
				s.tics = TICRATE*2
				s.momz = -FRACUNIT*64
				mo.pso.mitigations = {}
			end
			
			if t%15 == 0
			and t < (mo.beamduration - TICRATE)
				local g = P_SpawnGhostMobj(s)
				g.scale = 1
				g.destscale = FRACUNIT*99
				g.scalespeed = FRACUNIT*5
				g.momz = FRACUNIT*64
				
			end
			
			if t < TICRATE*3/2
				local d = P_SpawnMobj(s.x + P_RandomRange(-512, 512)*FRACUNIT, s.y + P_RandomRange(-512, 512)*FRACUNIT, mo.z + mo.height + P_RandomRange(-512, 512)*FRACUNIT, MT_THOK)
				d.color = SKINCOLOR_TAN
				d.colorized = true
							
				d.momx = (s.x - d.x)/16
				d.momy = (s.y - d.y)/16
				d.momz = (s.z - d.z)/16
				d.scale = FRACUNIT*2
				d.destscale = 1
				d.tics = 16
				d.fuse = 16
			end
		end
		
		if t == TICRATE*2
			mo.beamhitboxes[i] = {}
			local tbl = mo.beamhitboxes[i]
			for j = 1, 48
				local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z - FRACUNIT*48, 127<<FRACBITS, 512<<FRACBITS, mo, laser_potency, DMT_TECHNIQUE, mo.beamduration - TICRATE*2, RT_NONE)
				hb.angle = mo.beamangle
				hb.scale = FRACUNIT*4
				tbl[#tbl+1] = hb
			end

			if i == 1
				S_StartSound(nil, sfx_bshot)
			end
			
			-- this ensures the player can't be hit by more than 1 of those hitboxes
			for j = 1, 48
				tbl[j].pso.links = tbl
			end
		end
		
		if t >= TICRATE*2
			local hitbox_dist = 128 + leveltime%3 * (64/3)
			for j = 1, 48
				
				local hb = mo.beamhitboxes[i][j]
				
				if not hb or not hb.valid
					continue
				end
				
				local tx = mo.x + hitbox_dist*cos(ang)
				local ty = mo.y + hitbox_dist*sin(ang)
				local tz = mo.z
				
				P_MoveOrigin(hb, tx, ty, tz)
				hb.angle = ang
				
				hb.sprite = SPR_ENRG
				hb.frame = A|FF_FULLBRIGHT|TR_TRANS20|FF_ADD
				hb.colorized = true
				hb.color = SKINCOLOR_TAN
				
				if hb.tics < TICRATE
					hb.scale = max(1, hb.tics * (FRACUNIT*4) / (TICRATE))
					hb.momz = FRACUNIT*32
					if leveltime & 1
						hb.sprite = SPR_NULL
					end
				end	
				
				hitbox_dist = $+128
			end
		end
	end	
	
	mo.beam = $+1
	
end

local function ange_prephoming(mo)
	
	mo.homing = 1
	
	mo.pannels = {}
	
	for i = 1, #mo.elipse
		local e = mo.elipse[i]
		e.destscale = 1
	end
end

local function ange_dohoming(mo)
	
	local range = 1024
	local proj_potency = 300
	
	if mo.homing == TICRATE/2
		
		for i = 1, 8
			local x = mo.x + P_RandomRange(-range, range)*FRACUNIT
			local y = mo.y + P_RandomRange(-range, range)*FRACUNIT
			local z = mo.z + P_RandomRange(630, 1536)*FRACUNIT
			
			local p = P_SpawnMobj(x, y, z, MT_THOK)
			p.tics = -1
			p.sprite = SPR_ANGE
			p.frame = D|FF_PAPERSPRITE
			p.rollangle = P_RandomRange(0, 359)*ANG1
			p.angle = p.rollangle
			p.scale = 1
			p.destscale = FRACUNIT*2
			p.scalespeed = FRACUNIT/4
			p.angrot = P_RandomRange(0, 1) and 1 or -1
			
			mo.pannels[i] = p
		end
	end
	
	for i = 1, #mo.pannels
		local tt = mo.homing - (i*3)
		local p = mo.pannels[i]
		p.angle = $ + ANG1*4*p.angrot
		
		if tt == TICRATE
			local zp = p.z - FRACUNIT*192
				
			local s = P_SpawnMobj(p.x, p.y, zp, MT_THOK)
			s.state = S_MEGISTAR1
			s.color = SKINCOLOR_WHITE
			s.scale = FRACUNIT*8
			s.destscale = 1
			s.scalespeed = FRACUNIT	
			S_StartSound(nil, sfx_s3k78)
		elseif tt == TICRATE*3/2
			local msl = PSO.lib.spawnMissile(mo, MT_PSO_ANGE_PROJECTILE, 0, 0, proj_potency, DMT_TECHNIQUE, 0, 0, mo.height/2, 0)
			msl.tracer = mo.target
			P_SetOrigin(msl, p.x, p.y, p.z)
			
			local a = R_PointToAngle2(mo.x, mo.y, p.x, p.y)
			local z = abs(p.z - mo.z)
			
			P_InstaThrust(msl, a, FRACUNIT*64)
			msl.momz = z/64
			msl.fuse = TICRATE*10
			S_StartSound(nil, sfx_s3ka8)
		end
		
		if mo.homing == TICRATE*4
			p.destscale = 1
			p.tics = TICRATE*2
		end
	end
	
	if mo.homing == TICRATE*4
		mo.pannels = {}
	elseif mo.homing == TICRATE*4 + TICRATE/2
		for i = 1, #mo.elipse
			local e = mo.elipse[i]
			e.destscale = FRACUNIT
		end	
		
		mo.homing = nil
		return
	end
	
	mo.homing = $+1
end

local function ange_prepknockback(mo)
	mo.knockback = 1
	S_StartSound(nil, sfx_kc68)
end

local function ange_doknockback(mo)
	
	local range = 4048<<FRACBITS
	
	if mo.knockback < TICRATE
		
		mo.segzsep = (leveltime & 1 and -16 or 16)*FRACUNIT
		
	elseif mo.knockback == TICRATE
		
		mo.segzsep = FRACUNIT*512
		S_StartSound(nil, sfx_kc40)

		for i = 1, 60
				
			local t = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height, MT_THOK)
			t.tics = TICRATE
			t.color = SKINCOLOR_TAN
			t.frame = A|FF_ADD
			t.scale = mo.scale*2
			t.destscale = 1
				
			P_InstaThrust(t, a, FRACUNIT*128)
			a = $ + (360/60)*ANG1
		end
		
		for p in players.iterate do
			local pmo = p.mo
			
			if pmo and pmo.valid and R_PointToDist2(mo.x, mo.y, pmo.x, pmo.y) < range
				
				local a = R_PointToAngle2(mo.x, mo.y, pmo.x, pmo.y)
				P_InstaThrust(pmo, a, FRACUNIT*220)
				pmo.momz = FRACUNIT*4
				--p.pso.stagger = TICRATE/4
				
			end
		end
		
	else
		mo.segzsep = max(0, $ - 32*FRACUNIT)
		mo.rottimer = $ + 16
		
		if mo.knockback > TICRATE*2
			mo.segzsep = 0
			mo.knockback = nil
			return
		end
	end
	
	mo.knockback = $+1
	
end

local function ange_prepblast(mo)
	mo.blast = 1
	S_StartSound(nil, sfx_trpowr)
end

local function ange_doblast(mo)
	
	local windup = TICRATE*4
	local charge_visual_speed = TICRATE/2
	local charge_range = 1600
	local blast_range = 2500
	
	local blast_potency = 5000
	
	if mo.blast < windup
		
		for i = 1, 4
			local t = P_SpawnMobj(mo.x + P_RandomRange(-charge_range, charge_range)*mo.scale, mo.y + P_RandomRange(-charge_range, charge_range)*mo.scale, mo.z + P_RandomRange(-charge_range, charge_range)*mo.scale, MT_THOK)
			t.tics = charge_visual_speed
			t.color = SKINCOLOR_TAN
			t.frame = A|FF_ADD
			t.scale = mo.scale*3
			t.destscale = 1
			t.scalespeed = mo.scale/12
							
			t.momx = (mo.x - t.x)/charge_visual_speed
			t.momy = (mo.y - t.y)/charge_visual_speed
			t.momz = (mo.z - t.z)/charge_visual_speed	
		end
		
		if mo.blast > windup/4
			for p in players.iterate do
				if p and p.mo and p.mo.valid
				and R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y) < blast_range*FRACUNIT
					PSO.lib.attackMarker(p.mo.x, p.mo.y, p.mo.z + FRACUNIT*360, MARKER_USEBLOCK, FRACUNIT, true)
				end
			end
		end
		
		local visual_duration = TICRATE/2
		
		if mo.blast%(TICRATE/2) == 0
		and mo.blast < windup-visual_duration
			local a = 0
			
			
			for i = 1, 60
				
				local t = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				t.tics = visual_duration
				t.color = SKINCOLOR_TAN
				t.frame = A|FF_ADD
				t.scale = mo.scale*2
				t.destscale = 1
				t.scalespeed = (mo.scale/visual_duration)
				
				P_InstaThrust(t, a, FRACUNIT*(blast_range / visual_duration))
				a = $ + (360/60)*ANG1
			end
		end
		
		local spinspeed = min(20, mo.blast)
		mo.rottimer = $+spinspeed
		
	elseif mo.blast == windup
		
		for i = 1, 128
			local t = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SUPERSPARK)
			t.tics = TICRATE/2
			t.color = SKINCOLOR_TAN
			t.frame = A|FF_ADD
			t.scale = mo.scale*8
			t.destscale = 1	
			t.angle = P_RandomRange(0, 359)*ANG1
			if i & 1
				t.colorized = true
				t.state = mobjinfo[MT_SUPERSPARK].spawnstate
			end
			P_InstaThrust(t, t.angle, P_RandomRange(32, 128)*FRACUNIT)
			t.momz = P_RandomRange(-40, 40)*FRACUNIT
		end
		
		S_StartSound(nil, sfx_bkpoof)
		
		for p in players.iterate
			local pmo = p.mo
			
			if P_CheckSight(pmo, mo)
				P_FlashPal(p, 1, 4)
			end
			
			if R_PointToDist2(mo.x, mo.y, pmo.x, pmo.y) < blast_range*FRACUNIT
				local hb = PSO.lib.spawnHurtBox(pmo.x, pmo.y, pmo.z, 96<<FRACBITS, 580<<FRACBITS, mo, blast_potency, DMT_STRIKE, 2, RT_NONE)
			end
			
		end
	elseif mo.blast > windup and mo.blast < windup + TICRATE*2
		
		local tt = mo.blast-windup
		local spinspeed = max(0, 20 - tt)
		mo.rottimer = $ + spinspeed
				
	elseif mo.blast > windup + TICRATE*2
		mo.blast = nil
		return
	end
	
	mo.blast = $+1
	
end

local function ange_prepswipe(mo)
	mo.swipe = 1
	S_StartSound(nil, sfx_s3k8e)
end

local function ange_doswipe(mo)
	
	local targetradius = 2400
	local swipe_prep = TICRATE*3/4
	local swipe_time = TICRATE*3
	local swipe_end = TICRATE*4
	local swipe_potency = 600
	local swipe_maxspeed = ange_pinch(mo) and 48 or 28
	
	if mo.swipe < swipe_prep
		
		mo.elipseangle = $ - ANG1/2
		
		if mo.swipe
			mo.elipsestick = $+(ANG1/2)
		end
	elseif mo.swipe < swipe_time
		
		if mo.swipe == swipe_prep
			S_StartSound(nil, sfx_s3k81)
		end
		
		local angval = min(swipe_maxspeed, (mo.swipe - (swipe_prep))) *ANG1
		
		if mo.swipe > TICRATE*2/3
			mo.elipseradius = min(targetradius, $ + 30)
		end
		mo.elipseangle = $ + angval
		
		local target = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
		local diff = PSO.lib.angDiff(mo.elipseangle, target)
		
		if abs(diff) < 45
			if not mo.hitbox or not mo.hitbox.valid
				
				local x = mo.x + mo.elipseradius*cos(target)
				local y = mo.y + mo.elipseradius*sin(target)
				local z = mo.z 
				
				local links = {}
				local radius = 512<<FRACBITS
				
				local pos = {
					
					{x - radius/2, y - radius/2},
					{x - radius/2, y},
					{x - radius/2, y + radius/2},
					{x, y - radius/2},
					{x, y},
					{x, y + radius/2},
					{x + radius/2, y - radius/2},
					{x + radius/2, y},
					{x + radius/2, y + radius/2},					
				}
				
				for i = 1, #pos
					
					local sx = pos[i][1]
					local sy = pos[i][2]
					
					local hb = PSO.lib.spawnHurtBox(sx, sy, z, radius, 580<<FRACBITS, mo, swipe_potency, DMT_STRIKE, 10, RT_NONE)
					mo.hitbox = hb
					links[#links+1] = hb
					hb.pso.links = links
					
				end
				S_StartSound(nil, sfx_s3ka2)
			end
		end
	else
		local t = mo.swipe - swipe_time
		local addang = max(0, swipe_maxspeed - t)
		
		mo.elipseangle = $ + addang
		mo.elipsestick = max(0, $ - ANG1/2)
		mo.elipseradius = max(elipse_radius, $-100)
		
		if mo.swipe > swipe_end
			mo.swipe = nil
			mo.elipsestick = 0
			mo.elipseradius = elipse_radius
			return
		end
	end
	
	mo.swipe = $+1
end

-- handdle Gylir Shredders and whatnot
local MAX_SHREDDERS = 24

local function handleShredders(mo)
	if mo.shredders
		local i = #mo.shredders
		while i
			
			local s = mo.shredders[i]
			if not s or not s.valid
				table.remove(mo.shredders, i)
			end
			
			i = $-1
		end
	end
end

-- spawns Gylir Shredders around the boss
local function spawnShredders(mo, amount)
	
	mo.shredders = $ or {}
	
	if #mo.shredders >= MAX_SHREDDERS
		return
	end
	
	for i = 1, amount
		
		local dist = P_RandomRange(768, 2048)
		local a = P_RandomRange(0, 359)*ANG1
		
		local x = mo.x + dist*cos(a)
		local y = mo.y + dist*sin(a)
		
		local en = PSO.lib.spawnEnemyFromEnemy(mo, x, y, mo.z, MT_PSO_GYLIR_SHREDDER)
		-- buff them everrrr so slightly lmao...
		en.scale = $*4
		--en.pso.maxhp = $*4
		--en.pso.hp = en.pso.maxhp
		
		mo.shredders[#mo.shredders+1] = en
		
		if #mo.shredders >= MAX_SHREDDERS
			return
		end
		
	end
end

-- Ragrants
freeslot("MT_PSO_ANGE_RAGRANTS")

mobjinfo[MT_PSO_ANGE_RAGRANTS] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	radius = 32<<FRACBITS,
	height = 32<<FRACBITS,
	spawnhealth = 1000,
	flags = MF_NOGRAVITY,
}

addHook("MobjThinker", function(mo)
	
	if mo.delay
		
		if leveltime & 1
			local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			s.sprite = SPR_TARG
			s.frame = (leveltime%14)/2 |FF_FULLBRIGHT
			s.tics = 2
			s.scale = $*3
		end
		
		if mo.delay > TICRATE
			P_InstaThrust(mo, mo.angle, FRACUNIT*12)
		else
			P_InstaThrust(mo, 0, 0)
		end
		
		mo.delay = $-1
		mo.duration = TICRATE*30
		mo.spritexscale = 1
		
		if not mo.delay
			S_StartSound(mo, sfx_s3k83)
		end
		
		return
	end
	
	mo.duration = $-1

	mo.sprite = SPR_BFLW
	mo.frame = (B + leveltime%4 / 2)|FF_FULLBRIGHT
	mo.colorized = true
	mo.color = SKINCOLOR_TAN
	--mo.scale = FRACUNIT
	
	
	if mo.duration < TICRATE*2
		mo.spritexscale = $*9/10
		if leveltime & 1
			mo.flags2 = $|MF2_DONTDRAW
		else
			mo.flags2 = $ & ~MF2_DONTDRAW
		end
	else
		mo.spritexscale = min(3*FRACUNIT, $+FRACUNIT/2)
		
		if leveltime%5 == 0
			local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z - FRACUNIT*48, 127<<FRACBITS, 512<<FRACBITS, mo.target, 200, DMT_TECHNIQUE, 4, RT_NONE)		
		end
	end
	mo.spriteyscale = FRACUNIT*48
	
	if not mo.duration
		P_RemoveMobj(mo)
	end
	
end, MT_PSO_ANGE_RAGRANTS)

PSO.info.enemies[MT_PSO_ANGE] = {
		
		name = "Gyrrey Agnes",
		sprite = SPR_NULL,
		frame = A,
		painframe = A,
		boss = true,
		bossmusic = "BOSS5",
		
		bhp = 11500,
		satk = 50,
		ratk = 50,
		tatk = 50,
		def = 25,
		exp = 200,
		weight = 4,
		range = 10999,
		
		drops = {
			{"vita pine", 1, 50, 1, 100},
			{"vita claymore", 1, 50, 1, 100},
			{"vita doubliss", 1, 50, 1, 100},
			{"vita doublecutter", 1, 50, 1, 100},				
			{"vita shooter", 1, 50, 1, 100},
			{"vita burster", 1, 50, 1, 100},						
			{"vita shot", 1, 50, 1, 100},
			{"vita concentrator", 1, 50, 1, 100},			
			{"vita crest", 1, 50, 1, 100},
			{"vita crescent", 1, 50, 1, 100},			
			{"vita claw", 1, 50, 1, 100},
			{"vita cutter", 1, 50, 1, 100},					
			{"vita beamgun", 1, 50, 1, 100},
			{"vita peacekeeper", 1, 50, 1, 100},						
			{"vita hammer", 1, 50, 1, 100},
			{"vita scepter", 1, 50, 1, 100},
			{"vita joust", 1, 50, 1, 100},
			{"vita drivel", 1, 50, 1, 100},
			{"vita fork", 1, 50, 1, 100},
			{"vita grenade", 1, 50, 1, 100},
			
			{"unit_ppsatk_2", 1, 50, 2, 50},
			{"unit_pptatk_2", 1, 50, 2, 50},
			{"unit_ppratk_2", 1, 50, 2, 50},
			{"unit_rainbow_2", 1, 50, 2, 50},
			{"unit_satk_3", 1, 50, 1, 50},
			{"unit_ratk_3", 1, 50, 1, 50},
			{"unit_tatk_3", 1, 50, 1, 50},			
			
			{"hart frame", 36, 60, 1, 100},
			{"scape doll", 36, 60, 1, 40},
			
			{"orakl sword", 30, 50, 1, 200},
			{"orakl doublesaber", 30, 50, 1, 200},
			{"orakl soaringblade", 30, 50, 1, 200},
			{"orakl partizan", 30, 50, 1, 200},
			{"orakl launcher", 30, 50, 1, 200},
			{"orakl tcsm", 30, 50, 1, 200},
			{"orakl rifle", 30, 50, 1, 200},
			{"orakl shot", 30, 50, 1, 200},
			{"orakl orphan", 30, 50, 1, 200},
			{"orakl rod", 30, 50, 1, 200},
			{"orakl wand", 30, 50, 1, 200},
			{"digrinder", 1, 50, 6, 50},

			-- Lv51+
			{"abnormal shard", 51, 79, 1, 1000},
			
			{"orakl sword", 51, 200,1, 150},
			{"orakl doublesaber", 51, 200,1, 150},
			{"orakl soaringblade", 51, 200,1, 150},
			{"orakl partizan", 51, 200,1, 150},
			{"orakl launcher", 51, 200,1, 150},
			{"orakl tcsm", 51, 200,1, 150},
			{"orakl rifle", 51, 200,1, 150},
			{"orakl shot", 51, 200,1, 150},
			{"orakl orphan", 51, 200,1, 150},
			{"orakl rod", 51, 200,1, 150},
			{"orakl wand", 51, 200,1, 150},
			
			{"makel frame", 51, 79,1, 150},
			{"aberrant frame", 51, 79, 1, 200},
			{"flow frame", 51, 79,1, 60},
			{"steel hearts", 51, 79,1, 700},
			{"seal case", 51, 79,1, 700},
			{"zanba", 51, 79, 1, 1000},
			{"last survivor", 51, 79, 1, 1000},
			{"chainsawd", 51, 79, 1, 4000},
			{"dragon slayer", 51, 79, 1, 4000},
			{"monkey king bar", 51, 79,1, 700},
			{"girasole", 51, 79,1, 700},
			{"d. saber legacy", 51, 79, 1, 1000},
			{"eternal heat", 51, 79, 1, 1000},
			{"vivienne", 51, 79, 1, 4000},
			{"double cannon", 51, 79, 1, 4000},			
			{"basilleon", 51, 79,1, 700},
			{"longinus", 51, 79,1, 700},
			{"meteor lancer", 51, 79, 1, 1000},
			{"brionac", 51, 79, 1, 1000},
			{"vjaya", 51, 79, 1, 4000},
			{"soul eater", 51, 79, 1, 4000},			
			{"sarblight", 51, 79,1, 700},
			{"forblight", 51, 79,1, 700},	
			{"grand cross", 51, 79, 1, 1000},
			{"red saber", 51, 79, 1, 1000},
			{"elysion", 51, 79, 1, 4000},
			{"axeon", 51, 79, 1, 4000},
			{"full cylinder", 51, 79,1, 700},
			{"assassin", 51, 79,1, 700},
			{"yasminkov 3000r", 51, 79, 1, 1000},
			{"strauss", 51, 79, 1, 1000},
			{"firearms", 51, 79, 1, 4000},
			{"frozen shooter", 51, 79, 1, 4000},			
			{"wide smack", 51, 79,1, 700},
			{"heimdall", 51, 79,1, 700},
			{"barett", 51, 79, 1, 1000},
			{"crush bullet", 51, 79, 1, 1000},
			{"spread needle", 51, 79, 1, 4000},
			{"final impact", 51, 79, 1, 4000},			
			{"photon launcher", 51, 79,1, 700},
			{"saint kilda", 51, 79,1, 700},
			{"charge howzer", 51, 79, 1, 1000},
			{"gur bazga", 51, 79, 1, 1000},
			{"sspm launcher", 51, 79, 1, 4000},
			{"inferno bazooka", 51, 79, 1, 4000},			
			{"yasminkov 2000h", 51, 79,1, 700},
			{"sarcueid", 51, 79,1, 700},
			{"varista", 51, 79, 1, 1000},
			{"bravace", 51, 79, 1, 1000},
			{"pandora extreme", 51, 79, 1, 4000},
			{"ruby bullet", 51, 79, 1, 4000},			
			{"clarita visas", 51, 79,1, 700},
			{"red processor", 51, 79,1, 700},
			{"battle verge", 51, 79, 1, 1000},
			{"brave hammer", 51, 79, 1, 1000},
			{"siren hammer", 51, 79, 1, 4000},
			{"demonic fork", 51, 79, 1, 4000},			
			{"windmill", 51, 79,1, 700},
			{"hexigraph", 51, 79,1, 700},
			{"serdote", 51, 79, 1, 1000},
			{"rose quartz", 51, 79, 1, 1000},
			{"rykros staff", 51, 79, 1, 4000},
			{"evil curst", 51, 79, 1, 4000},			
			{"tcsm_crawla4", 51, 79,1, 700},
			
			{"unit_hpsatk_3", 51, 200,1, 50},
			{"unit_hpratk_3", 51, 200,1, 50},
			{"unit_hptatk_3", 51, 200,1, 50},
			{"unit_ppsatk_3", 51, 200,1, 50},
			{"unit_ppratk_3", 51, 200,1, 50},
			{"unit_pptatk_3", 51, 200,1, 50},			
			{"unit_power_3", 51, 200,1, 50},
			{"unit_rainbow_3", 51, 200,1, 50},
			
			{1000, nil, nil, 1, 1},
			
		},
		
		stagger_duration = TICRATE/2,
		
		attribute = ATTR_HARBINGER,
		weakness = ELEM_DARK,
		
		thinker = function(mo)
			
			local diff = PSO.lib.questDifficulty()
			
			PSO.lib.enemyManageAggro(mo)
			
			ange_spawnSegs(mo)
			ange_updateSegs(mo)
			
			if mo.target and mo.target.valid
				
				ange_trackPlayer(mo)
				mo.momz = 0
				
				-- test
				--PSO.lib.attackMarker(mo.target.x, mo.target.y, mo.target.z + FRACUNIT*360, MARKER_USEBLOCK, FRACUNIT, true)
				
				-- spawn motherfuckers!! (and keep track of them)
				--if diff >= DIFF_HARD
				local spawndelay = TICRATE*20
				
				mo.spawntimer = $ and $+1 or 1
				if diff >= DIFF_HARD
					if mo.spawntimer == 1
					or mo.spawntimer % spawndelay == 0
						spawnShredders(mo, min(6, PSO.lib.countPlayers() +3))
					end
						
					handleShredders(mo)
				end
					
				local lasertimer = mo.spawntimer - TICRATE*20
				local laserdelay = TICRATE*45
					
				if lasertimer >= 0
				and lasertimer % laserdelay == 0
				or lasertimer == 1
						
					for i = 1, diff >= DIFF_HARD and 5 or 3
						local ls = PSO.lib.spawnMissile(mo, MT_PSO_ANGE_RAGRANTS, 0, 0, 200, DMT_TECHNIQUE, 0, 0, mo.height/2, 0)
						P_SetOrigin(ls, mo.x, mo.y, mo.z)
						ls.angle = P_RandomRange(0, 359)*ANG1
						ls.delay = P_RandomRange(2, 8)*TICRATE
					end
				end
				
				
				if mo.knockback
					ange_doknockback(mo)
					return
				end
				
				if mo.swipe
					ange_doswipe(mo)
					return
				end
				
				if mo.blast
					ange_doblast(mo)
					return
				end
				
				if mo.homing
					ange_dohoming(mo)
					return
				end
				
				if mo.beam
					ange_dobeam(mo)
					return
				end
				
				mo.waittimer = $ and $+1 or 1
				
				if mo.waittimer > TICRATE*4
					
					if not mo.pinchatk
					and ange_pinch(mo)
						
						ange_prepbeam(mo, 4, ANG1*3/4, TICRATE*15)
						
						mo.waittimer = 0
						mo.pinchatk = true
						return
					end
					
					local range = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
					
					if range < 1536*FRACUNIT
						mo.closecount = $ and $+1 or 1
						
						if mo.closecount < 2
							
							if P_RandomRange(0, 1)
								ange_prepswipe(mo)
							else
								ange_prepblast(mo)
							end
						else
							ange_prepknockback(mo)
							if P_RandomRange(0, 1)
								if ange_pinch(mo)
									ange_prepbeam(mo, 2, ANG1/2)
								else
									ange_prepbeam(mo)
								end
							else
								ange_prephoming(mo)
							end
							
							mo.closecount = 0
						end
					else
						
						mo.closecount = 0
						
						if range < 2500*FRACUNIT
						and P_RandomRange(0, 3) == 0
							ange_prepswipe(mo)
						
						elseif P_RandomRange(0, 1)
							
							ange_prephoming(mo)
						else
							if ange_pinch(mo)
								ange_prepbeam(mo, 2, ANG1/2)
							else
								ange_prepbeam(mo)
							end
						end
						
						
					end
					
					--ange_prepswipe(mo)
					--ange_prepblast(mo)
					--ange_prephoming(mo)
					--ange_prepbeam(mo)	--, 4, ANG1/2, TICRATE*12)
					--ange_prepknockback(mo)
					mo.waittimer = 0
				end
				
			end
			
			
		end,
		
}

-- teleports all players in front of agnes
addHook("LinedefExecute", function(l, m)
	
	-- find the boss...
	--print("A")
	local b
	for i = 1, #server.psorooms
		local room = server.psorooms[i]
		for j = 1, #room.waves
			local wave = room.waves[j]
			for k = 1, #wave
				local en = wave[k]
				if en and en.valid and en.type == MT_PSO_ANGE
					b = en
					break 3
				end
			end
		end
	end
	--print(b)
	if b and b.valid
		
		local posx = b.x + 3184*cos(b.angle)
		local posy = b.y + 3184*sin(b.angle)
		local posz = b.z
		
		for p in players.iterate do
			if p.mo and p.mo.valid
				P_SetOrigin(p.mo, posx, posy, posz)
				p.mo.angle = R_PointToAngle2(p.mo.x, p.mo.y, b.x, b.y)
			end
		end
	end
	
end, "ANGESTART")