-- Dark Falz.
-- It's clamplicated.

local PASSIVEFLAGS = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
local ACTIVEFLAGS = MF_NOGRAVITY|MF_ENEMY|MF_SHOOTABLE|MF_NOCLIPHEIGHT

freeslot("MT_PSO_DARKFALZ_FINAL", "MT_PSO_DARKFALZ_PART", "MT_PSO_DARKFALZ_RAMEGID", "S_PSO_DARKFALZ_F_DIE")
mobjinfo[MT_PSO_DARKFALZ_FINAL] = {
	doomednum = 2558,
	spawnstate = S_INVISIBLE,
	deathstate = S_PSO_DARKFALZ_F_DIE,
	spawnhealth = 1000,
	radius = 32<<FRACBITS,
	height = 32<<FRACBITS,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_ENEMY|MF_NOCLIPHEIGHT,	-- untargettable
}

mobjinfo[MT_PSO_DARKFALZ_PART] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	deathstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 32<<FRACBITS,
	height = 48<<FRACBITS,
	flags = PASSIVEFLAGS,	-- untargettable
}

mobjinfo[MT_PSO_DARKFALZ_RAMEGID] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	deathstate = S_NULL,
	spawnhealth = 1000,
	radius = 64<<FRACBITS,
	height = 32<<FRACBITS,
	flags = MF_NOGRAVITY,
}
-- ramegid thinker, and stuff...

addHook("MobjThinker", function(mo)
	
	-- spawn delay
	-- we use this to spawn them all at once without needing timer fuckery lol
	if mo.delay
		mo.delay = $-1
		return
	end
	
	mo.existtimer = $ and $+1 or 1
	mo.duration = $ or TICRATE*5
	
	if mo.existtimer <= TICRATE*3/2
		if mo.existtimer % (TICRATE/8) == 0
			local x = mo.x + P_RandomRange(-128, 128)*FRACUNIT
			local y = mo.y + P_RandomRange(-128, 128)*FRACUNIT
			local pool = P_SpawnMobj(x, y, mo.z + FRACUNIT*80, MT_THOK)
			pool.frame = A
			pool.color = SKINCOLOR_BLACK
			pool.renderflags = $|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD|RF_FULLBRIGHT
			pool.scale = 1
			pool.destscale = FRACUNIT*3
			pool.tics = -1
			pool.fuse = mo.duration - mo.existtimer
		end
	end
	
	if mo.existtimer >= TICRATE*2
	and leveltime%5 == 0
		local x = mo.x + P_RandomRange(-128, 128)*FRACUNIT
		local y = mo.y + P_RandomRange(-128, 128)*FRACUNIT
		local msl = P_SpawnMobj(x, y, mo.z, MT_PSO_MEGID_ENEMY)
		msl.target = mo.target
		msl.momz = P_RandomRange(40, 70)*FRACUNIT
		msl.fuse = TICRATE
		msl.passive = true	-- don't actually spawn hurtboxes...
		msl.scale = FRACUNIT*2

		-- ...but do SPAWN THIS ONE!
		local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 256<<FRACBITS, 384<<FRACBITS, mo, mo.pso.potency, DMT_TECHNIQUE, 3, RT_BLOWDOWN)
		hb.angle = mo.angle
		hb.pso.reactionradialangle = true
	end
	
	if mo.existtimer > mo.duration
		P_RemoveMobj(mo)
		return
	end
end, MT_PSO_DARKFALZ_RAMEGID)

local function DF_reset(mo)

	mo.target_bobamp = 15
	mo.target_hbobamp = 15
	mo.no_arm_anim = false
end

/*
################################
ADDITIONAL HARD MODE ATTACK:
HALF-CLEAVE (not stolen from queen eternal!!!)
################################
*/
freeslot("MT_PSO_DARKFALZ_HALFCLEAVE")
mobjinfo[MT_PSO_DARKFALZ_HALFCLEAVE] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	radius = 1,
	height = 1,
	flags = MF_NOGRAVITY,
}

local function killMeteor(blocked)
	for i = 1, 8
		local debris = P_SpawnMobj(blocked.x, blocked.y, blocked.z, MT_THOK)
		debris.sprite = blocked.sprite
		debris.frame = blocked.frame
		debris.tics = TICRATE*4
		debris.rollangle = P_RandomRange(0, 359)*ANG1
		debris.momx = P_RandomRange(-8, 8)*FRACUNIT
		debris.momy = P_RandomRange(-8, 8)*FRACUNIT
		debris.momz = P_RandomRange(8, 20)*FRACUNIT
	end
	P_RemoveMobj(blocked)
	S_StartSound(nil, sfx_crumbl)
end

/*
		
	delay: time in tics before the shit goes off
	visual effects appear 5 seconds before it fires
	
	cleaveX: 0/1
	cleaveY: 0/1
	
	if cleaveX = 0, then damage is taken if mo's X position is lower than this object's target's X position
	if it's 1, then it's if the position is greater to the target's X position
	
	same with cleaveY.
	
	yes, you can do stupid shit and do both!!
*/

local CLEAVE_VISUAL_COUNT = 2
local CLEAVE_VISUAL_RANGE = 2048
local CLEAVE_POTENCY = 650

addHook("MobjThinker", function(mo)
	
	if not mo.target or not mo.target.valid
	or mo.target.dpsend
		if mo.child
			P_RemoveMobj(mo.child)
		end
		P_RemoveMobj(mo)
		return
	end
	
	if not mo.timer
		mo.timer = 1

		mo.sprite = SPR_BFLW
		mo.frame = D|FF_ADD|FF_PAPERSPRITE|FF_FULLBRIGHT
		mo.color = SKINCOLOR_MASTER	
		mo.angle = mo.target.angle + ANG1*90
		mo.scale = 1
		mo.destscale = FRACUNIT*8
		
		mo.child = P_SpawnMobj(mo.x, mo.y, mo.z+mo.destscale*10, MT_THOK)
		mo.child.sprite = mo.sprite
		mo.child.frame = mo.frame
		mo.child.color = mo.color
		mo.child.angle = mo.angle
		mo.child.scale = 1
		mo.child.destscale = mo.destscale
		mo.child.scalespeed = mo.destscale/mo.delay
		mo.child.momz = (mo.child.z - mo.z) / mo.delay
		mo.child.tics = -1
		
	end
	mo.timer = $+1
	
	mo.rollangle = $ + ANG1*2
	mo.child.rollangle = $ - ANG1*2
	
	if not mo.delay return end	-- lol
	
	local timeleft = mo.delay - mo.timer
	
	if timeleft < -TICRATE*3/4
		P_RemoveMobj(mo.child)
		P_RemoveMobj(mo)
		return
	end
	
	if timeleft == TICRATE*3
		S_StartSound(nil, sfx_bchrg)
	end
	
	if timeleft < TICRATE*4
		local startx = mo.x/FRACUNIT
		local endx = mo.x/FRACUNIT
		local starty = mo.y/FRACUNIT
		local endy = mo.y/FRACUNIT
		
		local amount = timeleft <= 0 and CLEAVE_VISUAL_COUNT*16 or CLEAVE_VISUAL_COUNT*((timeleft/TICRATE) + 1)
		
		if mo.cleaveX ~= nil
			
			startx = mo.target.x/FRACUNIT - CLEAVE_VISUAL_RANGE
			endx = mo.target.x/FRACUNIT
			
			if mo.cleaveX
				startx = mo.target.x/FRACUNIT
				endx = mo.target.x/FRACUNIT + CLEAVE_VISUAL_RANGE
			end
		elseif mo.cleaveY ~= nil
			starty = mo.target.y/FRACUNIT
			endy = mo.target.y/FRACUNIT + CLEAVE_VISUAL_RANGE		
		
			if mo.cleaveY
				starty = mo.target.y/FRACUNIT - CLEAVE_VISUAL_RANGE
				endy = mo.target.y/FRACUNIT
			end
		end
		
		if timeleft == 0	-- deal damage and destroy rocks
			
			P_StartQuake(FRACUNIT*40, 7)
			S_StartSound(nil, sfx_bshot)
			
			local g = P_SpawnGhostMobj(mo)
			g.detscale = mo.scale*8
			g.tics = $*6
			g.fuse = $*6
			
			local objects = {}
			
			-- add players
			for p in players.iterate do
				local pmo = p.mo
				
				if P_CheckSight(mo, pmo)
					objects[#objects+1] = pmo
				end
			end
			
			-- add rocks
			for m in mobjs.iterate()
				if m and m.valid and m.type == MT_PSO_DARKFALZ_METEOR
					objects[#objects+1] = m
				end
			end	
			
			for i = 1, #objects
				local o = objects[i]
				
				if mo.cleaveX == 0
				and o.x >= mo.target.x
				or mo.cleaveX == 1
				and o.x <= mo.target.x
				or mo.cleaveY == 0
				and o.y >= mo.target.y
				or mo.cleaveY == 1
				and o.y <= mo.target.y
					
					if o.type == MT_PLAYER
						PSO.lib.spawnHurtBox(o.x, o.y, o.z, 64<<FRACBITS, 64<<FRACBITS, mo.target, mo.pso.potency, DMT_TECHNIQUE, TICRATE/2, RT_STAGGER, COND_CORRUPTION, 100)
			
					elseif o.type == MT_PSO_DARKFALZ_METEOR
						killMeteor(o)
					end
				end
			end
		end
		
		for i = 1, amount
			
			if timeleft > 0
				
				local s =  P_SpawnMobj(P_RandomRange(startx, endx)*FRACUNIT, P_RandomRange(starty, endy)*FRACUNIT, mo.z + P_RandomRange(-512, 512)*FRACUNIT, MT_THOK)
				s.sprite = SPR_NTHK
				s.frame = A|FF_FULLBRIGHT|FF_ADD|FF_PAPERSPRITE
				s.color = mo.color
				s.angle = mo.target.angle
				s.tics = TICRATE*2
				s.scale = FRACUNIT/2
				s.spritexscale = FRACUNIT*6
				s.spriteyscale = FRACUNIT/2
				P_InstaThrust(s, mo.target.angle, FRACUNIT*85)
			else
				local s =  P_SpawnMobj(P_RandomRange(startx, endx)*FRACUNIT, P_RandomRange(starty, endy)*FRACUNIT, mo.z + P_RandomRange(-512, 512)*FRACUNIT, MT_SONIC3KBOSSEXPLODE)
				
				if i & 1
					s.state = S_INVISIBLE
					s.sprite = SPR_THOK
					s.frame = A|FF_FULLBRIGHT
					s.color = mo.color
					s.tics = TICRATE*2
					s.scale = FRACUNIT*2
				else
					s.color = mo.color
					s.colorized = true
					s.angle = mo.target.angle
					s.scale = FRACUNIT*8
				end
				P_InstaThrust(s, mo.target.angle, FRACUNIT*180)			
				--MT_SONIC3KBOSSEXPLODE
			end
		end
	end
end, MT_PSO_DARKFALZ_HALFCLEAVE)

-- dir = 0: left of the boss
-- dir = 1: right of the boss
local function prep_halfCleave(mo, dir, delay)
	local a = dir and -ANG1*45 or ANG1*45
	local dist = 768
	
	local x = mo.basecoords[1] + dist*cos(a)
	local y = mo.basecoords[2] + dist*sin(a)
	
	local msl = PSO.lib.spawnMissile(mo, MT_PSO_DARKFALZ_HALFCLEAVE, mo.angle, 0, CLEAVE_POTENCY, DMT_TECHNIQUE, 0, 0, mo.height/2, RT_NONE)
	P_SetOrigin(msl, x, y, mo.platformz + FRACUNIT*128)
	msl.delay = delay
	
	if dir == 1
		msl.cleaveY = 1
	else
		msl.cleaveY = 0
	end
end

/*
################################
FIST SLAM ATTACK
################################
*/

local SLAM_WINDUP = TICRATE*2
local SLAM_TIME = TICRATE/2
local SLAM_LASER = TICRATE*5 + TICRATE/2
local SLAM_WAIT = TICRATE*10
local SLAM_END = TICRATE*2
local SLAM_POTENCY = 400

local function prep_slam(mo, openeye, waittime, middle)
	mo.slamtimer = 1
	mo.slamwait = waittime or SLAM_WAIT
	mo.slammiddle = middle	-- hard mode p2 behaviour
	
	mo.initcoords = {mo.x, mo.y}
	mo.hand.frame = O
	mo.target_bobamp = 0
	mo.target_hbobamp = 0
	P_InstaThrust(mo, mo.angle, -FRACUNIT*50)
	S_StartSound(nil, sfx_beflap)
	
	if openeye
		mo.slamlaser = SLAM_LASER
	end
end

local function do_slam(mo)
	if mo.slamtimer
		
		
		mo.slamtimer = $+1
		mo.no_arm_anim = true
		
		if mo.slamtimer < SLAM_WINDUP
			mo.frame = C
			
			-- arm horizontal angle...
			local ang_diff = min(130, 90 + mo.slamtimer/2)
			mo.arm_hangle = mo.angle - (ang_diff*ANG1)
			mo.farm_hangle = mo.angle	--mo.arm_hangle
			
			-- arm vertical angle
			local vang_diff = min(75, -50 + (mo.slamtimer*3))
			mo.arm_vangle = vang_diff*ANG1
			mo.farm_vangle = mo.arm_vangle
			
			mo.wrist_vangle = mo.farm_vangle
			
		elseif mo.slamtimer < (SLAM_WINDUP+SLAM_TIME)
			
			local tt = mo.slamtimer-SLAM_WINDUP
			
			if tt == 1
				P_InstaThrust(mo, mo.angle, FRACUNIT*50)
				S_StartSound(nil, sfx_belnch)

				-- bit of an offset to line the hand properly w the floor...
				mo.arm_vangle = $ - ANG1*3
				mo.farm_vangle = $ - ANG1*3
				
			end
			mo.momx = $*9/10
			mo.momy = $*9/10
			
			if mo.slamtimer < SLAM_WINDUP + 8
				mo.frame = A
			else
				mo.frame = B
			end
			
			local targetangle = mo.angle  + (not mo.slammiddle and ANG1*20 or ANG1*40)	-- we imagine shit.
			
			
			mo.arm_hangle = mo.angle
			mo.farm_hangle = targetangle
			
			mo.arm_vangle = $ - ANG1*(tt^2/17) - ANG1/6
			mo.farm_vangle = $ - ANG1*(tt^2/17) - ANG1/6
			
			mo.hand.frame = R
			mo.hand.scale = mo.scale/2
		elseif mo.slamtimer == SLAM_WINDUP + SLAM_TIME
			
			-- spawn a damage box etc...
			P_StartQuake(FRACUNIT*40, 10)
			S_StartSound(nil, sfx_brakrx)
			
			mo.hand.flags = ACTIVEFLAGS

			local hb = PSO.lib.spawnHurtBox(mo.hand.x, mo.hand.y, mo.hand.z-FRACUNIT*128, 380<<FRACBITS, 512<<FRACBITS, mo, SLAM_POTENCY, DMT_MELEE, 2, RT_BLOWDOWN)
			hb.pso.radialangle = true
			
			local z = mo.hand.floorz
			for i = 1, 2
				for j = 1, 16
									
					local d = P_SpawnMobj(mo.hand.x, mo.hand.y, z, MT_SPINDUST)
					local a = (360/16)*j*ANG1
					d.angle = a + ANG1*90
					d.renderflags = $|RF_PAPERSPRITE
									
					if i > 1
						d.spritexscale = $*2
					end
					d.scale = $*3
					d.destscale = $*8
									
					P_InstaThrust(d, a, 96*FRACUNIT*i)
				end
			end
			
			if mo.slammiddle	-- attack both sides ofthe arena

				local closein_potency = 400
				local ang = mo.angle + ANG1*5
				local angdir = 1
				
				--print("A")

				for i = 1, 2
					
					for j = 1, 8
						
						local dist = 512
						for k = 1, 24
							
							local x = mo.x + dist*cos(ang)
							local y = mo.y + dist*sin(ang)
							
							-- try spawning the thing
							local try = PSO.lib.spawnMissile(mo, MT_PSO_DARKFALZ_RAMEGID, 0, 0, closein_potency, DMT_TECHNIQUE, 0, 0, mo.height/2, 0)
							P_SetOrigin(try, x, y, mo.platformz)
							try.momx = 0
							try.momy = 0
							try.momz = 0
							
							--P_SpawnMobj(x, y, mo.platformz, MT_THOK)
							
							if try.floorz < mo.platformz
								P_RemoveMobj(try)
							else
								try.angle = -ANG1*90*angdir
								try.delay = (j - (angdir == -1 and 1 or 0))*TICRATE
								
								try.duration = TICRATE*2 + TICRATE/3
							end
							
							dist = $+192
						end
						
						ang = $ + ANG1*5*angdir
					end
					
					ang = mo.angle
					angdir = -1
				end
			
			else	-- normal behaviour
				
				local attack_potency = 25
				for i = 1, 16
					local msl = PSO.lib.spawnMissile(mo, MT_PSO_MEGID_ENEMY, mo.angle, 6*FRACUNIT, attack_potency, DMT_TECHNIQUE, 0, 0, mo.height/2, RT_NONE)
					P_InstaThrust(msl, 360/16*i*ANG1, FRACUNIT*4)
					P_SetOrigin(msl, mo.hand.x, mo.hand.y, z + FRACUNIT*32)
					msl.scale = FRACUNIT
					msl.fuse = TICRATE*10
				end
			end
		elseif mo.slamtimer >= SLAM_WINDUP+SLAM_TIME+mo.slamwait
			
			-- slowly remove the arm and stuff
			local tt = mo.slamtimer - (SLAM_WINDUP+SLAM_TIME+mo.slamwait)
			
			if tt == 1
				P_InstaThrust(mo, mo.angle, FRACUNIT*30)
			end
			
			if mo.slamtimer == SLAM_WINDUP+SLAM_TIME+mo.slamwait
				mo.hand.flags = PASSIVEFLAGS
				
				mo.arm_currangle = mo.arm_hangle
				mo.arm_currvangle = mo.arm_vangle
				mo.farm_currangle = mo.farm_hangle
				mo.farm_currvangle = mo.farm_vangle
				
				mo.frame = A
				PSO.lib.DF_closeEye(mo)
			end
			
			local target_arm_hangle = mo.angle - ANG1*90
			local target_arm_vangle = -ANG1*50 + FixedAngle(cos(leveltime*ANG1)*10)	
			local target_farm_hangle = target_arm_hangle
			local target_farm_vangle = -90*ANG1 + FixedAngle(sin(leveltime*ANG1)*10)
			local target_wrist_hangle = 0
			local target_wrist_vangle = -90*ANG1 - FixedAngle(sin(leveltime*ANG1)*5)
			
			--mo.arm_hangle = $ + FixedAngle(FixedMul(AngleFixed(target_arm_hangle) - AngleFixed(mo.arm_hangle), FRACUNIT*10/100))
			
			mo.arm_hangle = $ + (((target_arm_hangle/ANG1) - ($/ANG1)) / 30)*ANG1
			mo.arm_vangle = $ + (((target_arm_vangle/ANG1) - ($/ANG1)) / 30)*ANG1
			mo.farm_hangle = $ + (((target_farm_hangle/ANG1) - ($/ANG1)) / 30)*ANG1
			mo.farm_vangle = $ + (((target_farm_vangle/ANG1) - ($/ANG1)) / 30)*ANG1
			mo.wrist_hangle = $ + (((target_wrist_hangle/ANG1) - ($/ANG1)) / 30)*ANG1
			mo.wrist_vangle = $ + (((target_wrist_vangle/ANG1) - ($/ANG1)) / 30)*ANG1
		end
		
		if mo.slamtimer == SLAM_WINDUP+SLAM_TIME+mo.slamwait+SLAM_END
			mo.slamtimer = nil
			P_MoveOrigin(mo, mo.basecoords[1], mo.basecoords[2], mo.z)
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			DF_reset(mo)
			return
		end
		
		if mo.slamlaser
			mo.slamlaser = $-1
			
			if mo.slamlaser == TICRATE*2
				PSO.lib.DF_openEye(mo)
			elseif mo.slamlaser < TICRATE*3/2
			
				local head_x = mo.head.x + 8*cos(mo.angle)
				local head_y = mo.head.y + 8*sin(mo.angle)
				local head_z = mo.head.z + 8*mo.scale	
				
				local s = P_SpawnMobj(head_x + P_RandomRange(-256, 256)*FRACUNIT, head_y + P_RandomRange(-256, 256)*mo.scale, head_z + P_RandomRange(-256, 256)*mo.scale, MT_THOK)
				s.color = SKINCOLOR_MASTER
				s.frame = FF_ADD|FF_FULLBRIGHT
				s.tics = 10
				s.scale = mo.scale*3/4
				s.destscale = 1
					
				s.momx = (head_x - s.x)/10
				s.momy = (head_y - s.y)/10
				s.momz = (head_z - s.z)/10	
			end
			
			if mo.slamlaser <= 10
			and (mo.slamlaser % 2) == 0
				
				local proj_potency = 80

				local head_x = mo.head.x + 32*cos(mo.angle)
				local head_y = mo.head.y + 32*sin(mo.angle)
				local head_z = mo.head.z + 8*mo.scale	
				
				local msl = PSO.lib.spawnMissile(mo, MT_PSO_ANGE_PROJECTILE, 0, 0, proj_potency, DMT_TECHNIQUE, 0, 0, mo.height/2, 0)
				msl.tracer = mo.target
				
				local a = mo.angle + P_RandomRange(-60, 60)*ANG1
				P_InstaThrust(msl, a, FRACUNIT*60)
				msl.momz = P_RandomRange(10, 30)*FRACUNIT
				
				msl.color = SKINCOLOR_MASTER
				msl.scale = $/6
				msl.fuse = TICRATE*3 + TICRATE/2
				P_SetOrigin(msl, head_x, head_y, head_z)
				
				msl.projspeed = FRACUNIT*32
				msl.projaccel = FRACUNIT
			end
		end
		
		mo.momx = $*94/100
		mo.momy = $*94/100		
		
	end
end

/*
################################
CLOSE - UP LASER
################################
*/

local function prep_closeLaser(mo, closein)
	
	local closein_potency = 400
	local ang = mo.angle + ANG1*50
	local angdir = 1

	mo.target_bobamp = 0
	mo.target_hbobamp = 0
	mo.no_arm_anim = true
	
	mo.closelaser = 1
	
	S_StartSound(nil, sfx_bejet1)
	
	if closein
		for i = 1, 2
			
			for j = 1, 6
				
				local dist = 128
				for k = 1, 24
					
					local x = mo.x + dist*cos(ang)
					local y = mo.y + dist*sin(ang)
					
					-- try spawning the thing
					local try = PSO.lib.spawnMissile(mo, MT_PSO_DARKFALZ_RAMEGID, 0, 0, closein_potency, DMT_TECHNIQUE, 0, 0, mo.height/2, 0)
					P_SetOrigin(try, x, y, mo.platformz)
					try.momx = 0
					try.momy = 0
					try.momz = 0
					
					
					if try.floorz < mo.platformz
						P_RemoveMobj(try)
					else
						try.duration = TICRATE*3
						try.angle = -ANG1*90*angdir
						try.delay = (j-1)*TICRATE*3/4
					end
					
					dist = $+128
				end
				
				ang = $ - ANG1*5*angdir
			end
			
			ang = mo.angle - ANG1*50
			angdir = -1
		end
	end
	
	PSO.lib.DF_openEye(mo)
end

local MOVEBACK = TICRATE*3
local MOVEAMP = 2048*FRACUNIT
local MOVEZAMP = -590*FRACUNIT
local LUNGE = TICRATE*6
local LUNGEDURATION = TICRATE/2
local LUNGEDIST = 2148*FRACUNIT + MOVEAMP
local LASER = LUNGE+LUNGEDURATION+TICRATE/2
local LASER_POTENCY = 450

local function do_closeLaser(mo)
	
	if mo.closelaser
		
		mo.closelaser = $+1
		
		-- make DF move back for the first few seconds
		if mo.closelaser < MOVEBACK
			
			local prevpercent = (mo.closelaser-1)*FRACUNIT / MOVEBACK
			local easepercent = mo.closelaser*FRACUNIT / MOVEBACK
			
			local prev = ease.inoutsine(prevpercent, 0, MOVEAMP)
			local curr = ease.inoutsine(easepercent, 0, MOVEAMP)
			
			P_InstaThrust(mo, mo.angle, -(curr-prev))
			
			-- ditto with momz
			
			local zprev = ease.inoutsine(prevpercent, 0, MOVEZAMP)
			local zcurr = ease.inoutsine(easepercent, 0, MOVEZAMP)
			mo.basez = $ + (zcurr-zprev)
			
		elseif mo.closelaser >= LUNGE
		and mo.closelaser <= (LUNGE+LUNGEDURATION)
			
			local t = mo.closelaser-LUNGE
			local prevpercent = (t-1)*FRACUNIT / LUNGEDURATION
			local easepercent = t*FRACUNIT / LUNGEDURATION
			
			local prev = ease.inoutsine(prevpercent, 0, LUNGEDIST)
			local curr = ease.inoutsine(easepercent, 0, LUNGEDIST)
			
			P_InstaThrust(mo, mo.angle, curr-prev)
			--print(prev-curr)
		end	
		
		if mo.closelaser == LUNGE+LUNGEDURATION
			P_StartQuake(FRACUNIT*60, 20)
			P_InstaThrust(mo, 0, 0)
			S_StartSound(nil, sfx_bgxpld)

			local s = P_SpawnMobj(mo.head.x + 128*cos(mo.angle), mo.head.y + 128*sin(mo.angle), mo.head.z-FRACUNIT*840, MT_THOK)
			s.state = S_MEGISTAR1
			s.color = SKINCOLOR_WHITE
			s.scale = FRACUNIT*32
			s.destscale = 1
			s.scalespeed = FRACUNIT*6
			
			mo.head.flags = ACTIVEFLAGS
		elseif mo.closelaser == LASER
		
		--elseif mo.closelaser > LASER
			
			local hitbox = {}
			
			for i = 1, 128
				local dist = 96 + i*32
				local x = mo.head.x + dist*cos(mo.angle)
				local y = mo.head.y + dist*sin(mo.angle)
				local z = mo.head.z + 48*mo.head.scale
						
				if i == 1
					for j = 1, 3
						local d = P_SpawnMobj(x, y, z, MT_THOK)
						d.sprite = SPR_NTHK
						d.frame = B|FF_FULLBRIGHT|FF_ADD|FF_PAPERSPRITE
						d.color = SKINCOLOR_MASTER
						d.angle = mo.angle + ANG1*90
						d.scale = FRACUNIT*6
						d.detscale = FRACUNIT*j*8
						d.scalespeed = FRACUNIT*j
						d.tics = j*10
						d.fuse = d.tics
						P_InstaThrust(d, d.angle, FRACUNIT*i)
					end
				end
						
				local s = P_SpawnMobj(x, y, z, MT_THOK)
				s.sprite = SPR_NTHK
				s.frame = A|FF_FULLBRIGHT|FF_ADD
				s.color = SKINCOLOR_TAN
				s.tics = 16 +(i-1)/8
				s.fuse = 16 +(i-1)/8
				s.scale = max(1, FRACUNIT - i*(FRACUNIT/128))
				s.destscale = FRACUNIT*6
				s.momz = FRACUNIT
				s.scalespeed = FRACUNIT
				
				-- hitbox
				local hb = PSO.lib.spawnHurtBox(x, y, z-FRACUNIT*320, 256<<FRACBITS, 1024<<FRACBITS, mo, LASER_POTENCY, DMT_TECHNIQUE, 3, RT_BLOWDOWN)
				hb.angle = mo.angle
				hitbox[#hitbox+1] = hb
			end
			
			for i = 1, #hitbox
				hitbox[i].pso.links = hitbox
			end
		end
		
		-- eye effects
		if mo.closelaser > TICRATE
		and mo.closelaser < LUNGE-10
			local head_x = mo.head.x + 8*cos(mo.angle)
			local head_y = mo.head.y + 8*sin(mo.angle)
			local head_z = mo.head.z + 8*mo.scale
		
			local s = P_SpawnMobj(head_x + P_RandomRange(-256, 256)*FRACUNIT, head_y + P_RandomRange(-256, 256)*mo.scale, head_z + P_RandomRange(-256, 256)*mo.scale, MT_THOK)
			s.color = SKINCOLOR_MASTER
			s.frame = FF_ADD|FF_FULLBRIGHT
			s.tics = 10
			s.scale = mo.scale*3/4
			s.destscale = 1

				
			s.momx = (head_x - s.x)/10
			s.momy = (head_y - s.y)/10
			s.momz = (head_z - s.z)/10	
			
			if leveltime%20 == 0
				s = P_SpawnMobj(head_x, head_y, head_z, MT_THOK)
				s.sprite = SPR_NTHK
				s.color = SKINCOLOR_MASTER
				s.frame = B|FF_ADD|FF_FULLBRIGHT
				s.tics = 20
				s.scale = FRACUNIT*100
				s.momz = -FRACUNIT*130
				s.destscale = 1
				s.scalespeed = FRACUNIT*4
			end
		end
		
		if mo.closelaser > LASER + TICRATE
			mo.closelaser = nil
			--print("nil")
		end
	end
end

/*
################################
LASER SWEEP
(TO BE USED WHEN CLOSE TO THE PLATFORM)
################################
*/

-- +1: +
-- -1: -

local SWEEP_CHARGE = TICRATE*5
local SWEEP_ANGLESTART = ANG1*90
local SWEEP_DURATION = TICRATE*5
local SWEEP_POTENCY = 700

local function prep_laserSweep(mo, dir)
	mo.lasersweep = 1
	mo.laserdir = dir
	mo.laserangle = mo.angle + SWEEP_ANGLESTART*dir
end

local function do_laserSweep(mo)
	
	if mo.lasersweep
		
		if mo.lasersweep == SWEEP_CHARGE-TICRATE*3
			S_StartSound(nil, sfx_s3k53)
		end
		
		if mo.lasersweep < SWEEP_CHARGE

			local head_x = mo.head.x + 8*cos(mo.angle)
			local head_y = mo.head.y + 8*sin(mo.angle)
			local head_z = mo.head.z + 8*mo.scale

			local s = P_SpawnMobj(head_x + P_RandomRange(-256, 256)*FRACUNIT, head_y + P_RandomRange(-256, 256)*mo.scale, head_z + P_RandomRange(-256, 256)*mo.scale, MT_THOK)
			s.color = SKINCOLOR_MASTER
			s.frame = FF_ADD|FF_FULLBRIGHT
			s.tics = 10
			s.scale = mo.scale*3/4
			s.destscale = 1
					
			s.momx = (head_x - s.x)/10
			s.momy = (head_y - s.y)/10
			s.momz = (head_z - s.z)/10
		
		elseif mo.lasersweep == SWEEP_CHARGE	
			-- sound/visuals here
			
			-- prep hitboxes...
			mo.laserhitboxes = {}
			for i = 1, 32
				local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z - FRACUNIT*48, 96<<FRACBITS, 96<<FRACBITS, mo, SWEEP_POTENCY, DMT_TECHNIQUE, SWEEP_DURATION, RT_BLOWDOWN)
				hb.pso.reactionstrength = 16	
				hb.scale = FRACUNIT*2
				mo.laserhitboxes[#mo.laserhitboxes+1] = hb
			end
			
			-- this ensures the player can't be hit by more than 1 of those hitboxes
			for i = 1, 32
				mo.laserhitboxes[i].pso.links = mo.laserhitboxes
			end
			
			S_StartSound(nil, sfx_bshot)
			P_StartQuake(FRACUNIT*30, 5)
		end
		
		if mo.lasersweep >= SWEEP_CHARGE
			-- move the hitboxes along and create the laser... also rotate it as we go.
			local t = mo.lasersweep - SWEEP_CHARGE
			local hitbox_dist = 128 + leveltime%3 * (64/3)
			local spd = min(ANG1, FixedAngle(2*sin( (t*180/SWEEP_DURATION)*ANG1 )))
			
			for i = 1, #mo.laserhitboxes
				
				local hb = mo.laserhitboxes[i]
				
				if not hb or not hb.valid
					continue
				end
				
				local tx = mo.head.x + hitbox_dist*cos(mo.laserangle)
				local ty = mo.head.y + hitbox_dist*sin(mo.laserangle)
				local tz = mo.head.z
				
				P_MoveOrigin(hb, tx, ty, tz)
				hb.angle = mo.angle - ANG1*90 * mo.laserdir
				
				hb.sprite = SPR_ENRG
				hb.frame = A|FF_FULLBRIGHT|TR_TRANS20|FF_ADD
				hb.colorized = true
				hb.color = SKINCOLOR_TAN
				
				if hb.tics < TICRATE*2
					hb.scale = max(1, hb.tics * (FRACUNIT*2) / (TICRATE*2))
					if leveltime & 1
						hb.sprite = SPR_NULL
					end
				end
				
				hitbox_dist = $+64
			end
			
			mo.laserangle = $ - spd*mo.laserdir
		end
		
		mo.lasersweep = $+1
		
		if mo.lasersweep == SWEEP_CHARGE+SWEEP_DURATION+TICRATE
			mo.lasersweep = nil
		end
	end
end

/*
################################
STACK MARKER
TO BE USED WITH OTHER ATTACKS!
################################
*/

-- this is JUST the visual
-- to be tethered to MT_PSO_STACKMARKER
freeslot("MT_PSO_DARKFALZ_STACKMARKER")
mobjinfo[MT_PSO_DARKFALZ_STACKMARKER] = {
	doomednum = -1,
	spawnhealth = 1000,
	spawnstate = S_INVISIBLE,
	flags = MF_NOGRAVITY|MF_NOCLIP,
	height = 32<<FRACBITS,
	radius = 32<<FRACBITS,
}

addHook("MobjThinker", function(mo)
	
	local tracer = mo.tracer
	if tracer and tracer.valid
		if not mo.delay
			mo.delay = tracer.delay + 10
			mo.time = 1
			mo.radius = tracer.radius
			S_StartSound(nil, sfx_s3k9d)
		end
		
		P_MoveOrigin(mo, mo.tracer.x, mo.tracer.y, mo.tracer.z)
	end
	
	mo.time = $+1
	
	if mo.time < mo.delay
	and mo.time > mo.delay - TICRATE/2
		
		-- we have like 16 frames to make this work
		local tt = mo.time - (mo.delay-(TICRATE/2))
		local a = FixedAngle(FixedDiv(FRACUNIT*360, FRACUNIT*16)) * tt
		
		local x = mo.x + mo.radius*cos(a)
		local y = mo.y + mo.radius*sin(a)
		
		local s = P_SpawnMobj(x, y, mo.z, MT_THOK)
		s.state = S_ICESPARK1
		s.color = SKINCOLOR_WHITE
		s.scale = FRACUNIT*3
	elseif mo.time > mo.delay
		for i = 1, 16
			local a = FixedAngle(FixedDiv(FRACUNIT*360, FRACUNIT*16)) * i
			
			local x = mo.x + mo.radius*cos(a)
			local y = mo.y + mo.radius*sin(a)
			
			local t = P_SpawnMobj(x, y, mo.z-FRACUNIT*48, MT_SONIC3KBOSSEXPLODE)

			t.colorized = true
			t.renderflags = $|RF_FULLBRIGHT
			t.scale = $*5
			t.color = SKINCOLOR_EMERALD
			t.destscale = FRACUNIT*12
			t.scalespeed = mo.scale/4
			t.angle = a + P_RandomRange(-20, 20)*ANG1
			P_InstaThrust(t, t.angle, FRACUNIT*128)
			--t.momz = P_RandomRange(-6, 6)*FRACUNIT
		end
	end
	
	if mo.time == mo.delay - TICRATE/2
		S_StartSound(mo, sfx_sparks)
	elseif mo.time > mo.delay + TICRATE
		P_RemoveMobj(mo)
	end
end, MT_PSO_DARKFALZ_STACKMARKER)

/*
################################
SHADOW PUNCH
################################
*/

/*
	
	We'll flash target markers in all areas that will be struck
	then all the attacks will come, the last one leaves a damageable hitbox for a while
	
*/

local SPUNCH_DIST = 1644 + 512
local SPUNCH_XLEN = 512
local SPUNCH_YLEN = 768
local SPUNCH_COUNT = 12
local SPUNCH_WAIT = TICRATE*8

local function prep_shadowPunch(mo, megid, punchwait)
	mo.shadowpunch = 1
	mo.shadowpunches = {}
	mo.rbasez = mo.basez
	mo.shadowpunchmegid = megid
	mo.shadowpunchwait = punchwait or SPUNCH_WAIT

	-- center of the hitbox
	local x = mo.x + SPUNCH_DIST*cos(mo.angle)
	local y = mo.y + SPUNCH_DIST*sin(mo.angle)
	
	-- ready all the markers...
	for i = 1, SPUNCH_COUNT
		local rx = x + P_RandomRange(-SPUNCH_XLEN, SPUNCH_XLEN)*FRACUNIT
		local ry = y + P_RandomRange(-SPUNCH_YLEN, SPUNCH_YLEN)*FRACUNIT
		
		mo.shadowpunches[#mo.shadowpunches+1] = {rx, ry}
	end
	
	S_StartSound(nil, sfx_s3k93)
end

local function do_shadowPunch(mo)
	
	local punch_potency = 350
	
	if mo.shadowpunch
		
		mo.shadowpunch = $+1
		--print("A: "..mo.shadowpunch)
		
		if mo.shadowpunch < TICRATE
			mo.basez = $ - FRACUNIT*3*mo.shadowpunch
		else
			mo.flags2 = $|MF2_DONTDRAW
		end
		
		for i = 1, #mo.shadowpunches
			local punch = mo.shadowpunches[i]
			
			local t = mo.shadowpunch - TICRATE*3 - (i*8)
			local px = punch[1]
			local py = punch[2]
			
			if t > 0 and t < TICRATE*3/2
				
				if leveltime & 1	
					local s = P_SpawnMobj(px, py, mo.platformz, MT_THOK)
					s.flags = $ & ~MF_NOCLIPHEIGHT
					s.sprite = SPR_TARG
					s.scale = FRACUNIT*2
					s.frame = (leveltime%14)/2 |FF_FULLBRIGHT
					s.tics = 1

					if t <= 2	-- don't ask.
						PSO.lib.spawnAOEMarker(mo, s.x, s.y, s.z, 380, TICRATE*2, SKINCOLOR_RED)
						S_StartSound(nil, sfx_s3k7c)
					end
				end
			end
			
			-- punch
			if t > 8*SPUNCH_COUNT + TICRATE/3
				local tt = t - (8*SPUNCH_COUNT + TICRATE/3)
				local last = (i == SPUNCH_COUNT)
				
				if last or tt < TICRATE
					
					local s = P_SpawnMobj(px, py, mo.platformz, MT_THOK)
					s.flags = $ & ~MF_NOCLIPHEIGHT
					s.sprite = SPR_DAFA
					s.scale = mo.scale
					s.frame = S | ((not last) and FF_SUBTRACT or 0)
					s.tics = 2
					s.spriteyscale = min(FRACUNIT, tt*FRACUNIT/4)

					
					if tt == 3
						P_StartQuake(FRACUNIT*40, 3)
						S_StartSound(nil, sfx_s3k59)
						S_StartSound(nil, sfx_s3k61)
						
						for j = 1, 16
							local x = s.x + P_RandomRange(-128, 128)*FRACUNIT
							local y = s.y + P_RandomRange(-128, 128)*FRACUNIT
							local p = P_SpawnMobj(x, y, s.z, MT_THOK)
							p.color = SKINCOLOR_BLACK
							p.momz = P_RandomRange(8, 64)*FRACUNIT
							p.tics = -1
							p.fuse = 12
						end
						
						if mo.shadowpunchmegid
							--print("A")
							local attack_potency = 25
							for i = 1, 8
								local msl = PSO.lib.spawnMissile(mo, MT_PSO_MEGID_ENEMY, mo.angle, 6*FRACUNIT, attack_potency, DMT_TECHNIQUE, 0, 0, mo.height/2, RT_NONE)
								P_InstaThrust(msl, 360/8*i*ANG1, FRACUNIT*4)
								P_SetOrigin(msl, s.x, s.y, s.z + FRACUNIT*32)
								msl.scale = FRACUNIT
								msl.fuse = TICRATE*8
							end
						end
						
						-- hit players in range!
						for p in players.iterate
							local pmo = p.mo
							if not pmo or not pmo.valid continue end
							
							if R_PointToDist2(pmo.x, pmo.y, s.x, s.y) <= 380*FRACUNIT
								local hb = PSO.lib.spawnHurtBox(pmo.x, pmo.y, pmo.z, 48<<FRACBITS, 48<<FRACBITS, mo, punch_potency, DMT_MELEE, 2, RT_BLOWDOWN)
								hb.angle = R_PointToAngle2(s.x, s.y, pmo.x, pmo.y)
								hb.pso.reactionstrength = 12
								--hb.pso.nododge = true
								-- todo: make unblockable in VH+
							end
						end
						
						-- teleport an actual hitbox we can hit.
						if last
							P_SetOrigin(mo.hand, s.x, s.y, s.z)
							mo.hand.flags = ACTIVEFLAGS
							mo.hand.flags2 = $|MF2_DONTDRAW
							mo.hand.scale = mo.scale/3
							mo.hand.momz = 0
						end
					end
					
					if tt > (TICRATE-10) and not last
						s.frame = S | (tt - (TICRATE-10))<<FF_TRANSSHIFT
					end
					
					-- end the attack
					if last and tt == mo.shadowpunchwait
						for p in players.iterate do
							P_FlashPal(p, 1, 10)
						end
						
						S_StartSound(nil, sfx_mixup)
						
						mo.flags2 = $ & ~MF2_DONTDRAW
						mo.nodraw = nil
						mo.hand.flags = PASSIVEFLAGS
						mo.hand.flags2 = $ & ~MF2_DONTDRAW
						mo.hand.scale = mo.scale
						mo.basez = mo.rbasez
						P_RemoveMobj(s)
						mo.shadowpunch = nil
						
					end
				end
			end
		end
	end
end


/*
################################
METEORS
################################
*/

/*
	meteor handler.
	meteors are to be spawned above the ground they will fall on where they will leave a target marker.
	
	meteors will stay above the ground for mo.delay tics and impact when tics hit 0 (they begin falling when delay <= 10)
	meteors will damage players based off of their 'potency' variable (based off of their source's stats)
	meteors will knock players back based on their 'reactionstrength' variable.
	
	meteors will explode and deal damage to all players based on 'failpotency' after 'failtimeout' tics
	(leaving failtimeout nil makes it not decay, leaving failpotency nil makes the meteor deal no damage on timeout)
*/


freeslot("MT_PSO_DARKFALZ_METEOR")

mobjinfo[MT_PSO_DARKFALZ_METEOR] = {
	doomednum = -1,
	spawnhealth = 1000,
	spawnstate = S_INVISIBLE,
	flags = MF_NOGRAVITY|MF_NOCLIP,
	height = 32<<FRACBITS,
	radius = 16<<FRACBITS,
}
local function collider(mo1, mo2)
	if mo1 and mo1.valid and mo1.type == MT_PSO_DARKFALZ_METEOR
	and mo2 and mo2.valid and mo2.type == MT_PLAYER
		return false
	end
end
addHook("MobjCollide", collider, MT_PSO_DARKFALZ_METEOR)
addHook("MobjMoveCollide", collider, MT_PSO_DARKFALZ_METEOR)

addHook("MobjThinker", function(mo)
	
	if not mo.zdiff
		mo.zdiff = mo.z - mo.floorz
	end
	
	mo.existtimer = $ and $+1 or 1
	
	if mo.delay
		
		if mo.track 
			if mo.tracer and mo.tracer.valid
				P_MoveOrigin(mo, mo.tracer.x, mo.tracer.y, mo.z)
			end
			mo.track = $-1
		end
		
		mo.delay = $-1
		
		local vistimer = mo.existtimer % TICRATE
		local visz = (TICRATE - vistimer)*32*FRACUNIT
		local vis = P_SpawnMobj(mo.x, mo.y, mo.floorz+visz, MT_THOK)
		vis.sprite = SPR_ROIG
		vis.frame = FF_ADD|FF_FULLBRIGHT
		vis.scale = FRACUNIT*3
		vis.colorized = true
		vis.color = SKINCOLOR_PINK
		P_SpawnGhostMobj(vis)
		
		
		if mo.existtimer & 1 == 0
		
			local s = P_SpawnMobj(mo.x, mo.y, mo.floorz, MT_THOK)
			s.flags = $ & ~MF_NOCLIPHEIGHT
			s.sprite = SPR_TARG
			s.scale = FRACUNIT*(mo.track and 1 or 2)
			s.frame = (leveltime%14)/2 |FF_FULLBRIGHT
			s.tics = 2
			s.colorized = true
			s.color = SKINCOLOR_PINK
			
			if mo.track and mo.track < 3
				local g = P_SpawnGhostMobj(s)
				g.destscale = g.scale*4
				
				S_StartSound(mo, sfx_menu1)
			end

			if mo.existtimer % (TICRATE) < 2
				PSO.lib.enemyKnockbackBurstVisual(s)
			end
		end
		
		if mo.delay == 10
			mo.momz = -mo.zdiff/14
			mo.flags = $|MF_NOGRAVITY
			mo.sprite = SPR_ROIG
			mo.scale = FRACUNIT*3
		end
		
		if not mo.track
			for p in players.iterate
				local pmo = p.mo
				if not pmo or not pmo.valid continue end
			
				if P_CheckSight(mo, pmo)
					PSO.lib.enemyKnockbackMarker(pmo, mo)
				end
			end
		end
		
		if not mo.delay
			
			-- nope!
			if P_CheckDeathPitCollide(mo)
				P_RemoveMobj(mo)
				return
			end
			
			for p in players.iterate
				local pmo = p.mo
				if not pmo or not pmo.valid continue end
							
				if P_CheckSight(mo, pmo)
					local hb = PSO.lib.spawnHurtBox(pmo.x, pmo.y, pmo.z, 48<<FRACBITS, 48<<FRACBITS, mo.target, mo.potency, DMT_MELEE, 2, RT_KNOCKBACK)
					hb.angle = R_PointToAngle2(mo.x, mo.y, pmo.x, pmo.y)
					hb.pso.reactionstrength = mo.reactionstrength
					hb.pso.nododge = true
					hb.pso.ignorephysique = true	-- reaction ignores hunter physique's weight mechanic
					pmo.momz = -FRACUNIT*8
				end
			end

			for i = 1, 8
				local d = P_SpawnMobj(mo.x + P_RandomRange(-16, 16)*FRACUNIT, mo.y + P_RandomRange(-16, 16)*FRACUNIT, mo.z, MT_SPINDUST)
				d.momz = P_RandomRange(8, 24)*mo.scale
				d.scale = mo.scale*2
				d.spriteyscale = FRACUNIT*4
				d.tics = $ + P_RandomRange(1, 6)
				d.destscale = mo.scale*8
			end

			for i = 1, 2
				for j = 1, 16
									
					local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
					local a = (360/16)*j*ANG1
					d.angle = a + ANG1*90
					d.renderflags = $|RF_PAPERSPRITE
									
					if i > 1
						d.spritexscale = $*2
					end
									
					d.destscale = $*4
									
					P_InstaThrust(d, a, 32*FRACUNIT*i)
					d.momx = $ + mo.momx
					d.momy = $ + mo.momy
				end
			end	
			
		end
	else
		mo.waittimer = $ and $+1 or 1
		
		if mo.waittimer == 3
			mo.flags = MF_SOLID
			mo.momz = 0
		end
	end
	
	if mo.failtimeout
		mo.failtimeout = $-1
		
		if mo.failtimeout < TICRATE*5
		and leveltime%10 < 2
			mo.colorized = true
			mo.color = SKINCOLOR_RED
		else
			mo.colorized = false
		end
		
		if mo.failtimeout == 0
			
			if mo.failpotency

				for i = 1, 32
					local debris = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SONIC3KBOSSEXPLODE)
					debris.momx = P_RandomRange(-64, 64)*FRACUNIT
					debris.momy = P_RandomRange(-64, 64)*FRACUNIT
					debris.momz = P_RandomRange(2, 20)*FRACUNIT
					debris.scale = $*3
				end
				
				S_StartSound(nil, sfx_crumbl)
				S_StartSound(nil, sfx_bkpoof)
				
				for p in players.iterate do
					local pmo = p.mo
					if not pmo or not pmo.valid continue end
					
					if P_CheckSight(mo, pmo)
						local hb = PSO.lib.spawnHurtBox(pmo.x, pmo.y, pmo.z, 48<<FRACBITS, 48<<FRACBITS, mo.target, mo.failpotency, DMT_MELEE, 2, RT_STAGGER)
						hb.pso.nododge = true						
					end
				end
				
			else

				for i = 1, 8
					local debris = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
					debris.sprite = mo.sprite
					debris.frame = mo.frame
					debris.tics = TICRATE*4
					debris.rollangle = P_RandomRange(0, 359)*ANG1
					debris.momx = P_RandomRange(-8, 8)*FRACUNIT
					debris.momy = P_RandomRange(-8, 8)*FRACUNIT
					debris.momz = P_RandomRange(2, 8)*FRACUNIT
				end
				
				S_StartSound(nil, sfx_crumbl)
			end
			
			P_RemoveMobj(mo)
		end
	end

end, MT_PSO_DARKFALZ_METEOR)


/*
################################
SIGHT ATTACK
################################
*/

/*
	DF sight attack
	Player must hide behind a meteor to evade it.
	The meteor will be destroyed after blocking the attack.
	
*/

local SIGHT_DELAY = TICRATE
local SIGHT_WAIT = TICRATE*6
local SIGHT_POTENCY = 600

local function prep_sightAttack(mo, count, duration)
	mo.sightattack = 1
	mo.sightcount = count or 1
	mo.pso.targetlock = true
	mo.sightduration = duration or SIGHT_WAIT+SIGHT_DELAY
	
	PSO.lib.DF_openEye(mo)
	
end

local function do_sightAttack(mo)
	
	if not mo.sightattack return end
	
	if mo.sightattack
		mo.sightattack = $+1
		
		if mo.sightattack == SIGHT_DELAY
			S_StartSound(nil, sfx_s3k53)
		end
		
		if mo.sightattack > SIGHT_DELAY
		and mo.sightattack < mo.sightduration
		
			if mo.sightattack < mo.sightduration - TICRATE/2
				local head_x = mo.head.x + 8*cos(mo.angle)
				local head_y = mo.head.y + 8*sin(mo.angle)
				local head_z = mo.head.z + 8*mo.scale

				local s = P_SpawnMobj(head_x + P_RandomRange(-256, 256)*FRACUNIT, head_y + P_RandomRange(-256, 256)*mo.scale, head_z + P_RandomRange(-256, 256)*mo.scale, MT_THOK)
				s.color = SKINCOLOR_MASTER
				s.frame = FF_ADD|FF_FULLBRIGHT
				s.tics = 10
				s.scale = mo.scale*3/4
				s.destscale = 1
					
				s.momx = (head_x - s.x)/10
				s.momy = (head_y - s.y)/10
				s.momz = (head_z - s.z)/10
			end
			
			PSO.lib.enemySightMarker(mo.head, mo.target, PSO.lib.quickSightCheck)
		end
	end
	if mo.sightattack == mo.sightduration
		-- fire laser
		local seen = true
		local blocked
			
		local fn = function(s)
			
			if PSO.lib.quickSightCheck(s, mo.head)
				s.sprite = SPR_THOK
				s.frame = FF_FULLBRIGHT
				s.color = SKINCOLOR_EMERALD
				s.destscale = 1
				s.scalespeed = FRACUNIT/12
				s.fuse = 12
				s.tics = 12
			else
				s.state = S_INVISIBLE
				seen = nil
					
				if not blocked	-- find closest meteor!
					local x1 = s.x-256*FRACUNIT
					local x2 = s.x+256*FRACUNIT
					local y1 = s.y-256*FRACUNIT
					local y2 = s.y+256*FRACUNIT
						
					local sfn = function(search, found)
							
						if found and found.valid and found.type == MT_PSO_DARKFALZ_METEOR
							blocked = found
							return
						end
					end	
						
					searchBlockmap("objects", sfn, s, x1, x2, y1, y2)
				end
			end
		end
				
		S_StartSound(nil, sfx_s3k54)
			
		PSO.lib.spawnLine(mo.head, mo.target, 128, fn)
			
		if blocked	-- meteor blocked it!
			killMeteor(blocked)
			P_StartQuake(FRACUNIT*40, 6)
			S_StartSound(nil, sfx_bkpoof)
		else
			-- the player didn't hide!
			local hb = PSO.lib.spawnHurtBox(mo.target.x, mo.target.y, mo.target.z, 80<<FRACBITS, 40<<FRACBITS, mo, SIGHT_POTENCY, DMT_RANGED, 3, RT_BLOWDOWN)
			hb.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)	
			hb.pso.nododge = true
		end
		
		mo.sightcount = $-1
		if not mo.sightcount
			mo.sightattack = nil
			mo.pso.targetlock = nil
			PSO.lib.DF_closeEye(mo)
		else
			mo.sightattack = 1
		end
	end
end

/*
################################
TARGETTED LINGERING ATTACK
################################
*/

local function prep_lingering(mo)
	mo.lingering = 1
	mo.pso.targetlock = true
	mo.lingeringpos = {}
	/*
		{
			{x, y, z},
			{x, y, z},
			{x, y, z},
			{x, y, z}
		}
	*/
	
end

local NUM_LINGERING = 4
local LINGERING_DELAY = TICRATE
local LINGERING_WAIT = TICRATE*4
local LINGERING_START = TICRATE*6
local RAMEGID_POTENCY = 350

local function do_lingering(mo)
	if mo.lingering
		mo.lingering = $+1
		
		for i = 1, NUM_LINGERING
			local t = mo.lingering - (i-1)*LINGERING_DELAY
			
			if t >0
				
				if t < LINGERING_WAIT
					mo.lingeringpos[i] = {mo.target.x, mo.target.y, mo.target.z}
				end
				
				if t == LINGERING_WAIT
					local try = PSO.lib.spawnMissile(mo, MT_PSO_DARKFALZ_RAMEGID, 0, 0, RAMEGID_POTENCY, DMT_TECHNIQUE, 0, 0, mo.height/2, 0)
					try.duration = TICRATE*40
					P_SetOrigin(try, mo.lingeringpos[i][1], mo.lingeringpos[i][2], mo.platformz)
				end
				
				if t < LINGERING_START
					if leveltime & 1
					or t == LINGERING_WAIT-1
						local s = P_SpawnMobj(mo.lingeringpos[i][1], mo.lingeringpos[i][2], mo.platformz, MT_THOK)
						s.flags = $ & ~MF_NOCLIPHEIGHT
						s.sprite = SPR_TARG
						s.frame = (leveltime%14)/2 |FF_FULLBRIGHT
						s.tics = 1
						
						-- visual to show that it's being placed
						if t == LINGERING_WAIT-1
							s.tics = 10
							s.destscale = FRACUNIT*8
							s.fuse = 10
							S_StartSound(mo.target, sfx_menu1)
						end
					end
				end
			end
		end
		
		-- wait until we finish
		if mo.lingering == (NUM_LINGERING*LINGERING_DELAY) + LINGERING_START
			mo.pso.targetlock = nil
			mo.lingering = nil
		end
	end
end

/*
################################
ATTACK PATTERNS WHEN CLOSE TO PLATFORM
################################
*/

local function explosionPatterns(mo, shift)
	local range = 16
	local potency = 400
	local ang = mo.angle - ANG1*80 - (shift and 15 or 0)*ANG1
			
	for j = 1, 8
		for i = 1, range
			local dist = 224 + 96*i
						
			local x = mo.x + dist*cos(ang)
			local y = mo.y + dist*sin(ang)
						
			local msl = PSO.lib.spawnMissile(mo, MT_PSO_BFLOW_EXPLOSION, 0, 0, potency, DMT_RANGED, 0, 0, 0)
			msl.scale = FRACUNIT*2
			P_MoveOrigin(msl, x, y, mo.platformz + FRACUNIT*16)
			msl.delay = i*TICRATE / 6
			msl.angle = ang
		end
		ang = $ + ANG1*30
	end
end

local function resetPosition(mo)
		for p in players.iterate do
			P_FlashPal(p, 1, 10)
		end
						
		S_StartSound(nil, sfx_mixup)
						
		mo.flags2 = $ & ~MF2_DONTDRAW
		mo.nodraw = nil
		mo.hand.flags2 = $ & ~MF2_DONTDRAW
		mo.hand.scale = mo.scale
			
		P_SetOrigin(mo, mo.basecoords[1], mo.basecoords[2], mo.basecoords[3])
		mo.basez = mo.basecoords[3]
		PSO.lib.DF_closeEye(mo)
		mo.head.flags = PASSIVEFLAGS
		
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
end

-- knock players back, used to get players furhter away for other attacks
local function prep_closeKnockback(mo)
	mo.knockback = 1
end

local function do_closeKnockback(mo)
	if mo.knockback
		
		mo.knockback = $+1
		
		-- stack marker
		if mo.knockback == 2

			local kdist = 512
			local x = mo.x + kdist*cos(mo.angle)
			local y = mo.y + kdist*sin(mo.angle)

			local m = PSO.lib.spawnStackMarker(mo, x, y, mo.platformz, 384, TICRATE*5 + TICRATE/2, 500, DMT_TECHNIQUE, RT_KNOCKBACK, 8)

			local vis = P_SpawnMobj(m.x, m.y, m.z, MT_PSO_DARKFALZ_STACKMARKER)
			vis.tracer = m
		end
		
		-- knockback indicator
		if mo.knockback < TICRATE*6
			if leveltime & 1
				local kdist = 128
				local x = mo.x + kdist*cos(mo.angle)
				local y = mo.y + kdist*sin(mo.angle)
				
				local s = P_SpawnMobj(x, y, mo.platformz, MT_THOK)
				s.flags = $ & ~MF_NOCLIPHEIGHT
				s.sprite = SPR_TARG
				s.scale = FRACUNIT*2
				s.frame = (leveltime%14)/2 |FF_FULLBRIGHT
				s.tics = 2
				s.colorized = true
				s.color = SKINCOLOR_PINK

				if leveltime % (TICRATE) < 2
					PSO.lib.enemyKnockbackBurstVisual(s)
				end
				
			end
			
			for p in players.iterate
				local pmo = p.mo
				if pmo and pmo.valid and P_CheckSight(mo.head, pmo)
					PSO.lib.enemyKnockbackMarker(pmo, mo.head, 1)
				end
			end
		end
			
		-- send players packing!!
		if mo.knockback == TICRATE*6
			
			--print("A")
			for p in players.iterate
				local pmo = p.mo
				if not pmo or not pmo.valid continue end
							
				if P_CheckSight(mo.head, pmo)
					local hb = PSO.lib.spawnHurtBox(pmo.x, pmo.y, pmo.z, 48<<FRACBITS, 48<<FRACBITS, mo, 10, DMT_MELEE, 2, RT_KNOCKBACK)
					hb.angle = R_PointToAngle2(mo.x, mo.y, pmo.x, pmo.y)
					hb.pso.reactionstrength = 24
					hb.pso.nododge = true
					hb.pso.ignorephysique = true	-- reaction ignores hunter physique's weight mechanic
					pmo.momz = -FRACUNIT*8
				end
			end
		elseif mo.knockback == TICRATE*6 + TICRATE/2	-- spawn line attacks!	
			explosionPatterns(mo)

		-- teleport back
		elseif mo.knockback == TICRATE*21
			
			resetPosition(mo)
			mo.knockback = nil
			mo.close = false
		end
	end
end


/*
################################
DPS CHECK BALL!

Ball will periodically push the player away and sends AOEs.
Succeeding the DPS check will deal 20% of the boss' HP worth of damage going the final phase
Failing will reduce all players' HP to 1

################################
*/


local DPSC_THRESHOLD = 20	-- 20% HP
local DPSC_TIMER = TICRATE*60
-- this makes for a dps requirement of about 500 which is average with okay gear at lv50

local DPSC_WINDUP = TICRATE*6
local DPSC_TIME = TICRATE/2
local DPSC_KNOCKBACK = TICRATE*12


local function prep_dpscheck(mo)
	mo.dpsctimer = 1
	
	mo.initcoords = {mo.x, mo.y}
	mo.hand.frame = O
	mo.target_bobamp = 0
	mo.target_hbobamp = 0
	P_InstaThrust(mo, mo.angle, -FRACUNIT*65)
	S_StartSound(nil, sfx_beflap)
	
	mo.pso.minhp = 1
	
	S_FadeOutStopMusic(1500)
end

local function do_dpscheck(mo)
	if mo.dpsctimer
		
		
		mo.dpsctimer = $+1
		mo.no_arm_anim = true
		
		-- knockback marker...
		if mo.dpsctimer < DPSC_WINDUP+DPSC_TIME
		or mo.dpsball and mo.dpsball.knockback and mo.dpsball.knockback > (DPSC_KNOCKBACK/2)
			
			if ((mo.dpsctimer - DPSC_WINDUP - DPSC_TIME) < (DPSC_TIMER-TICRATE*10))
			and not mo.dpscheckstate
				
				local dist = 1740 + 128
				local ang = mo.angle
				local x = mo.basecoords[1] + dist*cos(ang)
				local y = mo.basecoords[2] + dist*sin(ang)
				
				-- reference mobj
				local s = P_SpawnMobj(x, y, mo.platformz, MT_THOK)
				s.state = S_INVISIBLE
				s.tics = 2
				
				-- visual
				if leveltime & 1
				
					local s = P_SpawnMobj(x, y, mo.platformz, MT_THOK)
					s.flags = $ & ~MF_NOCLIPHEIGHT
					s.sprite = SPR_TARG
					s.scale = FRACUNIT*2
					s.frame = (leveltime%14)/2 |FF_FULLBRIGHT
					s.tics = 1
					s.colorized = true
					s.color = SKINCOLOR_PINK

					if leveltime % (TICRATE) < 2
						PSO.lib.enemyKnockbackBurstVisual(s)
					end
					
				end
				
				-- charge visual
				if mo.dpsball.knockback and mo.dpsball.knockback < (DPSC_KNOCKBACK-10)
					local s = P_SpawnMobj(mo.dpsball.x + P_RandomRange(-256, 256)*FRACUNIT, mo.dpsball.y + P_RandomRange(-256, 256)*mo.scale, mo.dpsball.z + P_RandomRange(-256, 256)*mo.scale, MT_THOK)
					s.color = SKINCOLOR_MASTER
					s.frame = FF_ADD|FF_FULLBRIGHT
					s.tics = 20
					s.scale = FRACUNIT*2
					s.destscale = 1
							
					s.momx = (mo.dpsball.x - s.x)/20
					s.momy = (mo.dpsball.y - s.y)/20
					s.momz = (mo.dpsball.z - s.z)/20				
				end
				
				for p in players.iterate
					local pmo = p.mo
					if not pmo or not pmo.valid continue end
				
					PSO.lib.enemyKnockbackMarker(pmo, (mo.dpsball.knockback and mo.dpsball or s), 1)
				end
			end
		end
		
		if mo.dpsctimer < DPSC_WINDUP
			mo.frame = C
			
			-- arm horizontal angle...
			local ang_diff = min(130, 90 + mo.dpsctimer/2)
			mo.arm_hangle = mo.angle - (ang_diff*ANG1)
			mo.farm_hangle = mo.angle	--mo.arm_hangle
			
			-- arm vertical angle
			local vang_diff = min(75, -50 + (mo.dpsctimer*3))
			mo.arm_vangle = vang_diff*ANG1
			mo.farm_vangle = mo.arm_vangle
			
			mo.wrist_vangle = mo.farm_vangle
			
			-- charging visual
			local s = P_SpawnMobj(mo.hand.x + P_RandomRange(-256, 256)*FRACUNIT, mo.hand.y + P_RandomRange(-256, 256)*mo.scale, mo.hand.z + P_RandomRange(-256, 256)*mo.scale, MT_THOK)
			s.color = SKINCOLOR_MASTER
			s.frame = FF_ADD|FF_FULLBRIGHT
			s.tics = 10
			s.scale = mo.scale*3/4
			s.destscale = 1
					
			s.momx = (mo.hand.x - s.x)/10
			s.momy = (mo.hand.y - s.y)/10
			s.momz = (mo.hand.z - s.z)/10
			
		elseif mo.dpsctimer < (DPSC_WINDUP+DPSC_TIME)
			
			local tt = mo.dpsctimer-DPSC_WINDUP
			
			if tt == 1
				P_InstaThrust(mo, mo.angle, FRACUNIT*50)
				S_StartSound(nil, sfx_belnch)

				-- bit of an offset to line the hand properly w the floor...
				mo.arm_vangle = $ - ANG1*3
				mo.farm_vangle = $ - ANG1*3
				
			end
			mo.momx = $*9/10
			mo.momy = $*9/10
			
			if mo.dpsctimer < DPSC_WINDUP + 8
				mo.frame = A
			else
				mo.frame = B
			end
			
			local targetangle = mo.angle  + ANG1*35	-- this places it more-or-less at the center of the arena in front of the boss!
			
			mo.arm_hangle = mo.angle
			mo.farm_hangle = targetangle
			
			mo.arm_vangle = $ - ANG1*(tt^2/17) - ANG1/6
			mo.farm_vangle = $ - ANG1*(tt^2/17) - ANG1/6
			
			mo.hand.frame = R
			mo.hand.scale = mo.scale/2
		elseif mo.dpsctimer == DPSC_WINDUP + DPSC_TIME
			
			-- move the dps check part
			P_StartQuake(FRACUNIT*40, 10)
			S_StartSound(nil, sfx_brakrx)
			
			--mo.hand.flags = ACTIVEFLAGS
			mo.hand.frame = P
			
			local z = mo.hand.floorz
			for i = 1, 2
				for j = 1, 16
									
					local d = P_SpawnMobj(mo.hand.x, mo.hand.y, z, MT_SPINDUST)
					local a = (360/16)*j*ANG1
					d.angle = a + ANG1*90
					d.renderflags = $|RF_PAPERSPRITE
									
					if i > 1
						d.spritexscale = $*2
					end
					d.scale = $*3
					d.destscale = $*8
									
					P_InstaThrust(d, a, 96*FRACUNIT*i)
				end
			end
		
		-- dps check ball!
		elseif mo.dpsctimer > (DPSC_WINDUP + DPSC_TIME)
			-- make it appear!
			
			local tt = mo.dpsctimer - (DPSC_WINDUP+DPSC_TIME)
			
			if tt == 2
				local dist = 128
				P_SetOrigin(mo.dpsball, mo.hand.x + dist*cos(mo.angle), mo.hand.y + dist*sin(mo.angle), mo.hand.z)
				mo.dpsball.flags = ACTIVEFLAGS
				mo.dpsball.scale = mo.scale/2
				mo.dpsball.knockback = 1	-- intialize knockback timer
				
			end
			
			mo.hand.rollangle = 0
			
			-- animation
			mo.dpsball.sprite = SPR_MEGD
			mo.dpsball.frame = (leveltime%32 /2)|TR_TRANS20|FF_SUBTRACT|FF_FULLBRIGHT
			mo.dpsball.color = SKINCOLOR_MASTER
			
			-- dpscheck success/failure
			if not mo.dpscheckstate
				if mo.pso.hp == 1	-- passed!
					mo.dpscheckstate = 1
					S_StartSound(nil, sfx_bgxpld)
					S_StartSound(nil, sfx_s3k93)
					
				elseif tt >= DPSC_TIMER	-- failed
					S_StartSound(nil, sfx_bgxpld)
					S_StartSound(nil, sfx_s3k93)				
				
					mo.dpscheckstate = 2
				end
			else
				mo.dpsball.flags = PASSIVEFLAGS
				mo.dpsend = $ and $+1 or 1	-- timer for animation end
				mo.dpsball.destscale = FRACUNIT*99
				mo.dpsball.scalespeed = $*2
				P_StartQuake(FRACUNIT*40, TICRATE*3)
				
				if mo.dpsend > TICRATE/2
					-- players:
					for p in players.iterate do
						
						local pmo = p.mo
						if not pmo or not pmo.valid continue end
						
						if mo.dpsend == 1
							p.pso.target = nil
							PSO.lib.resetPlayerAction(p)
							P_DoPlayerPain(p)
							pmo.fadecolor = nil
							pmo.fadestrength = nil
						end
						pmo.state = S_PLAY_PAIN
						pmo.momz = FRACUNIT*2
						P_InstaThrust(pmo, mo.angle, FRACUNIT*4)
						p.powers[pw_nocontrol] = 32767
						
						pmo.fadecolor = leveltime%8 < 4 and 88 or 89
						
						if mo.dpsend % 3 == 0
							pmo.fadestrength = min(10, $ and $+1 or 1)
						end
					end
				end
				
				-- show that we did a bunch of damage!
				if mo.dpsend == TICRATE*2
				and mo.dpscheckstate == 1
					PSO.lib.spawnDamageNumber(mo.x, mo.y, mo.head.z + mo.height/2, mo.pso.maxhp/5, 0, mo, 0, displayplayer.mo, 0, true)
				end
				
				if mo.dpsend == TICRATE*4
					-- set new stats for next phase...
					mo.pso.maxhp = $/2
					mo.pso.hp = mo.pso.maxhp
					
					if mo.dpscheckstate == 1
						PSO.lib.damageObject(mo, nil, mo.pso.maxhp/5)
					end
					
					P_SetOrigin(mo, mo.basecoords[1], mo.basecoords[2], mo.basecoords[3])
					mo.basez = mo.basecoords[3]
					
					for p in players.iterate do
						
						local pmo = p.mo
						if pmo and pmo.valid
							p.powers[pw_nocontrol] = 0
							P_SetOrigin(pmo, mo.tbasecoords[1], mo.tbasecoords[2], mo.tbasecoords[3])
							
							if mo.dpscheckstate == 2	-- failed...
								p.pso.injury = 33
								PSO.lib.damageObject(p.mo, nil, p.pso.hp-1 or 1)	-- ok you still die if you have 1 hp lmao
							end
						end
					end

					mo.dpsctimer = nil
					mo.dpsend = nil
					mo.dpsstate = nil
					mo.dpsball.state = S_INVISIBLE	-- remove it
					mo.finaldown = 1
					
				end
				
				return
			end
			
			if mo.dpsball.knockback
				mo.dpsball.knockback = $+1
			end
			
			-- color and effects when the dps check is failing...
			if tt > DPSC_TIMER-TICRATE*20
				mo.dpsball.color = SKINCOLOR_RED
				P_StartQuake(FRACUNIT*10, 5)
				
				-- uh-oh!
				if tt > DPSC_TIMER-TICRATE*10
					local s = P_SpawnMobj(mo.dpsball.x + P_RandomRange(-256, 256)*FRACUNIT, mo.dpsball.y + P_RandomRange(-256, 256)*mo.scale, mo.dpsball.z + P_RandomRange(-256, 256)*mo.scale, MT_THOK)
					s.color = SKINCOLOR_RED
					s.frame = FF_ADD|FF_FULLBRIGHT
					s.tics = 20
					s.scale = FRACUNIT*3
					s.destscale = 1
							
					s.momx = (mo.dpsball.x - s.x)/20
					s.momy = (mo.dpsball.y - s.y)/20
					s.momz = (mo.dpsball.z - s.z)/20					
				end
			end
			
			-- dps check FAILURE!!!
			--print(tt)
			/*if tt >= DPSC_TIMER
				local t = P_SpawnMobj(mo.dpsball.x, mo.dpsball.y, mo.dpsball.z + FRACUNIT*32, MT_SONIC3KBOSSEXPLODE)

				t.colorized = true
				t.renderflags = $|RF_FULLBRIGHT
				t.scale = $*5
				t.color = SKINCOLOR_EMERALD
				t.destscale = FRACUNIT*12
				t.scalespeed = mo.scale/4
				
				t.momx = P_RandomRange(-90, 90)*FRACUNIT
				t.momy = P_RandomRange(-90, 90)*FRACUNIT
				t.momz = P_RandomRange(-90, 90)*FRACUNIT

				for p in players.iterate
					local pmo = p.mo
					if not pmo or not pmo.valid continue end

					local hb = PSO.lib.spawnHurtBox(pmo.x, pmo.y, pmo.z, 48<<FRACBITS, 48<<FRACBITS, mo, 9001, DMT_MELEE, 2)
					hb.pso.nododge = true
					hb.pso.ignorephysique = true	-- reaction ignores hunter physique's weight mechanic
				end
			end*/
			
			-- deal knockback and attack]
			if PSO.lib.questDifficulty() >= DIFF_HARD
			and mo.dpsball.knockback == DPSC_KNOCKBACK-TICRATE*8
				prep_halfCleave(mo, P_RandomRange(0, 1), TICRATE*10)
			end
			
			if mo.dpsball.knockback == DPSC_KNOCKBACK-TICRATE*2
				S_StartSound(nil, sfx_s3k84)
			end
			
			if (tt == 2 or mo.dpsball.knockback == DPSC_KNOCKBACK)
			and tt < (DPSC_TIMER-TICRATE*5)
				mo.hand.flags = PASSIVEFLAGS
				mo.dpsball.knockback = 1
				
				S_StartSound(nil, sfx_s3k83)
				
				-- change music and skybox!!
				if tt == 2
					P_LinedefExecute(300)
					S_ChangeMusic("_TITLE", true)
				end
				
				P_StartQuake(FRACUNIT*40, 10)
				
				for p in players.iterate
					local pmo = p.mo
					if not pmo or not pmo.valid continue end
					
					if P_CheckSight(mo.dpsball, pmo)
						local hb = PSO.lib.spawnHurtBox(pmo.x, pmo.y, pmo.z, 48<<FRACBITS, 48<<FRACBITS, mo, 10, DMT_MELEE, 2, RT_KNOCKBACK)
						hb.angle = R_PointToAngle2(mo.dpsball.x, mo.dpsball.y, pmo.x, pmo.y)
						hb.pso.reactionstrength = 20
						hb.pso.nododge = true
						hb.pso.ignorephysique = true	-- reaction ignores hunter physique's weight mechanic
						pmo.momz = -FRACUNIT*8
						
						P_FlashPal(p, 1, 4)
					end
				end
				
				-- also spawn attacks!
				if tt > 2	-- but only for subsequent knockback effects
					
					mo.dpsball.spritexscale = $ + FRACUNIT/6
					mo.dpsball.spriteyscale = $ + FRACUNIT/6
					
					local shift = P_RandomRange(0, 1)
					local range = 16
					local potency = 300
					local ang = mo.angle - ANG1*80 - (shift and 15 or 0)*ANG1
							
					for j = 1, 8
						for i = 1, range
							local dist = 224 + 96*i
										
							local x = mo.dpsball.x + dist*cos(ang)
							local y = mo.dpsball.y + dist*sin(ang)
										
							local msl = PSO.lib.spawnMissile(mo, MT_PSO_BFLOW_EXPLOSION, 0, 0, potency, DMT_RANGED, 0, 0, 0)
							msl.scale = FRACUNIT*2
							P_MoveOrigin(msl, x, y, mo.platformz + FRACUNIT*16)
							msl.delay = TICRATE/2 + i*TICRATE / 6
							msl.angle = ang
						end
						ang = $ + ANG1*30
					end
				end
			end
		end
		
		mo.momx = $*94/100
		mo.momy = $*94/100		
		
	end
end


/*
################################
FINAL DOWN STUFF!
################################
*/

-- sets base values for the final down stance
local function DF_setDownStance(mo, redo)
	--mo.finaldown = true
	
	mo.bobamp = 0
	mo.hbobamp = 5
	mo.target_bobamp = mo.bobamp
	mo.target_hbobamp = 5
	mo.head.rollangle = ANG1*20
	
	mo.frame = B
	mo.hand.frame = T
	mo.hand.scale = mo.scale/2
	mo.hand.flags = ACTIVEFLAGS
	
	if redo
		P_SetOrigin(mo, mo.basecoords[1], mo.basecoords[2], mo.basecoords[3])
		mo.basez = mo.basecoords[3]
	else	-- set coords for the first time

		mo.basez = $-FRACUNIT*150
		mo.head_height = $ - FRACUNIT*30
	
		local dist = 64
		local newx = mo.x + dist*cos(mo.angle)
		local newy = mo.y + dist*sin(mo.angle)
		P_SetOrigin(mo, newx, newy, mo.z)
		
		mo.basecoords = {mo.x, mo.y, mo.basez}
	end
	
	-- base arm angles
	mo.shoulder_zdist = 10
	
	mo.arm_vangle = -ANG1*10
	mo.arm_hangle = mo.angle	--ANG1*50
	mo.farm_vangle = 0
	mo.farm_hangle = mo.angle + ANG1*80
	mo.wrist_vangle = -ANG1*90
	
	mo.hand.spriteyoffset = FRACUNIT*50
	
	--print("A")
end

/*
-- debug
COM_AddCommand("set_arm_hangle", function(p, n)
	p.arm_hangle = tonumber(n)*ANG1
end)

COM_AddCommand("set_arm_vangle", function(p, n)
	p.arm_vangle = tonumber(n)*ANG1
end)

COM_AddCommand("set_farm_hangle", function(p, n)
	p.farm_hangle = tonumber(n)*ANG1
end)

COM_AddCommand("set_farm_vangle", function(p, n)
	p.farm_vangle = tonumber(n)*ANG1
end)

COM_AddCommand("set_wrist_vangle", function(p, n)
	p.wrist_vangle = tonumber(n)*ANG1
end)*/

-- slam fist
local function prep_downSlam(mo, count)
	mo.downslam = 1
	mo.downslamcount = count or 1
	mo.downslamwait = 0
	mo.hand.flags = PASSIVEFLAGS
end

local DF_DS_LIFTSPEED = ANG1*5/2
local DF_DS_LIFTTIME = TICRATE*6/10	-- 21
local DF_DS_WAITTIME = TICRATE/5
local DF_DS_SLAMTIME = DF_DS_LIFTTIME/3	+1 -- 7
local DF_DS_SLAMSPEED = DF_DS_LIFTSPEED*3

local function do_downSlam(mo)
	
	if mo.downslam
		mo.downslam = $+1
		
		if mo.downslam <= DF_DS_LIFTTIME
			mo.farm_vangle = $ + DF_DS_LIFTSPEED
		end
		
		if mo.downslam > DF_DS_LIFTTIME + DF_DS_WAITTIME
		and mo.downslam < DF_DS_LIFTTIME + DF_DS_WAITTIME + DF_DS_SLAMTIME
			mo.farm_vangle = $ - DF_DS_SLAMSPEED
		end
		
		if mo.downslam == DF_DS_LIFTTIME + DF_DS_WAITTIME + DF_DS_SLAMTIME
			mo.downslamcount = $-1
			
			--PSO.lib.damageObject(mo.target, nil, P_RandomRange(60, 80))
			P_StartQuake(FRACUNIT*40, 10)
			S_StartSound(nil, sfx_brakrx)

			local hb = PSO.lib.spawnHurtBox(mo.hand.x, mo.hand.y, mo.hand.z-FRACUNIT*128, 380<<FRACBITS, 512<<FRACBITS, mo, SLAM_POTENCY, DMT_MELEE, 2, RT_BLOWDOWN)
			hb.pso.radialangle = true
			
			local z = mo.hand.floorz
			for i = 1, 2
				for j = 1, 16
									
					local d = P_SpawnMobj(mo.hand.x, mo.hand.y, z, MT_SPINDUST)
					local a = (360/16)*j*ANG1
					d.angle = a + ANG1*90
					d.renderflags = $|RF_PAPERSPRITE
									
					if i > 1
						d.spritexscale = $*2
					end
					d.scale = $*3
					d.destscale = $*8
									
					P_InstaThrust(d, a, 96*FRACUNIT*i)
				end
			end

			local attack_potency = 25
			for i = 1, 16
				local msl = PSO.lib.spawnMissile(mo, MT_PSO_MEGID_ENEMY, mo.angle, 6*FRACUNIT, attack_potency, DMT_TECHNIQUE, 0, 0, mo.height/2, RT_NONE)
				P_InstaThrust(msl, 360/16*i*ANG1, FRACUNIT*4)
				P_SetOrigin(msl, mo.hand.x, mo.hand.y, z + FRACUNIT*32)
				msl.scale = FRACUNIT
				msl.fuse = TICRATE*10
			end
			
			
			mo.farm_vangle = 0
			
			if mo.downslamcount
				mo.downslam = 1
			else
				mo.hand.flags = ACTIVEFLAGS
			end
		end
		
		-- time out when we're done to leave some time for the player to strike
		if not mo.downslamcount
			mo.downslamwait = $+1
				
			if mo.downslamwait > TICRATE*5
				mo.downslam = nil
			end
		end
		
	end
end

-- go up and blast everything in sight!!
local function prep_downChestBlast(mo)
	mo.downchestblast = 1
	mo.hand.flags = PASSIVEFLAGS
	
	-- gimme a meteor to stand hide behind!!
	local a = mo.angle + (P_RandomRange(0, 1) and 1 or -1)*24*ANG1
	local x = mo.x + 1536*cos(a)
	local y = mo.y + 1536*sin(a)
						
	local meteor = P_SpawnMobj(x, y, mo.platformz + FRACUNIT*800, MT_PSO_DARKFALZ_METEOR)
	meteor.target = mo
	meteor.potency = 5
	meteor.reactionstrength = 28
	meteor.delay = TICRATE*5
	meteor.failtimeout = TICRATE*30	-- this can't actually happen
	meteor.failpotency = 600
	
	-- in HM, the meteor tracks
	if PSO.lib.questDifficulty() >= DIFF_HARD
		meteor.tracer = mo.target
		meteor.track = TICRATE*5 + TICRATE/2
		meteor.delay = $+ TICRATE*3
		
		-- also do a half cleave for good measure!
		prep_halfCleave(mo, P_RandomRange(0, 1), TICRATE*10)
	end
	
end

local DF_CB_LEANTIME = TICRATE*2
local DF_CB_EXPLOSIONTIME = TICRATE*11 + TICRATE/2

local function do_downChestBlast(mo)
	if mo.downchestblast
		mo.downchestblast = $+1
		
		if mo.downchestblast == (DF_CB_LEANTIME+DF_CB_EXPLOSIONTIME - TICRATE*3)
			S_StartSound(nil, sfx_s3k53)
		end
		
		-- lean forward...
		if mo.downchestblast < DF_CB_LEANTIME
			P_InstaThrust(mo, mo.angle, FRACUNIT*5)
			mo.basez = $ + FRACUNIT*2
			mo.arm_vangle = $ - ANG1/6
			mo.farm_hangle = $ + ANG1/4

			if leveltime%6 == 0
				S_StartSound(nil, sfx_s3k6f)
			end
			
		elseif mo.downchestblast == DF_CB_LEANTIME
			P_InstaThrust(mo, mo.angle, -FRACUNIT*160)
			P_StartQuake(FRACUNIT*60, 10)
			mo.momz = FRACUNIT*60
			S_StartSound(nil, sfx_belnch)
		
		elseif mo.downchestblast < DF_CB_LEANTIME+DF_CB_EXPLOSIONTIME
			
			local tt = mo.downchestblast - (DF_CB_LEANTIME)
			mo.frame = A
			
			mo.basez = $+mo.momz
			mo.momx = $*9/10
			mo.momy = $*9/10
			mo.momz = $*9/10
			
			if tt < 20
				mo.arm_hangle = $ - (ANG1*9)/2
				mo.farm_hangle = $ - (ANG1*10)/2
				mo.arm_vangle = $ - ANG1
				mo.farm_vangle = $ - ANG1*4
			
			elseif tt == 20
				mo.arm_vangle_save = mo.arm_vangle
				mo.farm_vangle_save = mo.farm_vangle
				
				S_StartSound(nil, sfx_bechrg)
			else
				-- eratically move the angles around...
				mo.arm_vangle = mo.arm_vangle_save + P_RandomRange(-8, 8)*ANG1
				mo.farm_vangle = mo.farm_vangle_save + P_RandomRange(-8, 8)*ANG1
				mo.head.rollangle = P_RandomRange(-45, 45)*ANG1
				
				-- and charging a huge ass explosion that WILL wipe anyone not hiding, kehehe~
				local chest_x = mo.x + 320*cos(mo.angle + ANG1*65)
				local chest_y = mo.y + 320*sin(mo.angle + ANG1*65)
				local chest_z = mo.z + 32*mo.scale
			
				local s = P_SpawnMobj(chest_x + P_RandomRange(-256, 256)*FRACUNIT, chest_y + P_RandomRange(-256, 256)*mo.scale, chest_z + P_RandomRange(-256, 256)*mo.scale, MT_THOK)
				s.color = SKINCOLOR_MASTER
				s.frame = FF_ADD|FF_FULLBRIGHT
				s.tics = 10
				s.scale = mo.scale*3/4
				s.destscale = 1

					
				s.momx = (chest_x - s.x)/10
				s.momy = (chest_y - s.y)/10
				s.momz = (chest_z - s.z)/10	
				
				if leveltime%20 == 0
					s = P_SpawnMobj(chest_x, chest_y, chest_z, MT_THOK)
					s.sprite = SPR_NTHK
					s.color = SKINCOLOR_MASTER
					s.frame = B|FF_ADD|FF_FULLBRIGHT
					s.tics = 30
					s.fuse = 30
					s.scale = FRACUNIT*100
					s.momz = -FRACUNIT*130
					s.destscale = 1
					s.scalespeed = FRACUNIT*4
				end
				
				if tt > TICRATE*4
					for p in players.iterate
						if p and p.mo and P_CheckSight(mo, p.mo)
							PSO.lib.enemySightMarker(mo, mo.target, PSO.lib.quickSightCheck)
						end
					end
				end
				
				P_StartQuake(FRACUNIT*8, 5)
			end	
			
			-- remake hand pos
			if tt == 10
				mo.hand.frame = L
			end
		
		elseif mo.downchestblast == DF_CB_LEANTIME+DF_CB_EXPLOSIONTIME
			-- basically kill anyone not hiding...
			S_StartSound(nil, sfx_bkpoof)
			P_StartQuake(FRACUNIT*80, TICRATE*3)
			for p in players.iterate
				if p and p.mo and PSO.lib.quickSightCheck(mo, p.mo)
					PSO.lib.damageObject(p.mo, nil, 999999)
				end
				--P_FlashPal(p, PAL_RECYCLE, TICRATE)
			end
			
			-- remove the meteor, too
			for m in mobjs.iterate() do
				if m and m.valid and m.type == MT_PSO_DARKFALZ_METEOR
					local blocked = m
					killMeteor(blocked)
				end
			end
		
		elseif mo.downchestblast == DF_CB_LEANTIME+DF_CB_EXPLOSIONTIME + TICRATE-5
			-- reset position n stuff
			--mo.downchestblast = nil
			DF_setDownStance(mo, true)
		end
		
		-- fade color handling...
		if mo.downchestblast >= DF_CB_LEANTIME+DF_CB_EXPLOSIONTIME
			
			local tt = mo.downchestblast - (DF_CB_LEANTIME+DF_CB_EXPLOSIONTIME)
			local col = leveltime%4 < 2 and 88 or 89
			
			for p in players.iterate
				if tt < 8
					p.mo.fadestrength = $ and $+1 or 1
				end
				
				if tt > TICRATE/2
				and tt % 5 == 0
				and tt < TICRATE
					p.mo.fadestrength = min(10, $+1)
				end
				
				if tt >= TICRATE*3/2
				and tt % 5 == 0
					p.mo.fadestrength = max(0, $-1)
				end
				
				p.mo.fadecolor = col
			end
		end
		
		if mo.downchestblast >= DF_CB_LEANTIME+DF_CB_EXPLOSIONTIME + TICRATE*4
			for p in players.iterate
				if p.mo and p.mo.valid
					p.mo.fadecolor = nil
					p.mo.fadestrength = nil
				end
			end
			mo.downchestblast = nil
		end
		
	end
end

/*
################################
GENERIC THINKERS & DEFINITIONS
################################
*/

-- this hack swaps dark falz's hand and head for parts that we can attack.
local function DF_spawnParts(mo)
	
	local newhead = PSO.lib.enemyCreatePart(mo, 0, 0, 0, MT_PSO_DARKFALZ_PART)
	newhead.sprite = mo.head.sprite
	newhead.frame = mo.head.frame
	newhead.scale = mo.head.scale	-- ok that's good
	--print(newhead.radius)
	--print(newhead.radius/FRACUNIT)
	newhead.radius = $*2
	P_SetOrigin(newhead, mo.head.x, mo.head.y, mo.head.z)
	newhead.shadowscale = 0
	
	P_RemoveMobj(mo.head)
	mo.head = newhead
	
	-- do the same for the hand
	local newhand = PSO.lib.enemyCreatePart(mo, 0, 0, 0, MT_PSO_DARKFALZ_PART)
	newhand.sprite = mo.hand.sprite
	newhand.frame = mo.hand.frame
	newhand.scale = mo.hand.scale	-- ok that's good
	P_SetOrigin(newhand, mo.hand.x, mo.hand.y, mo.hand.z)
	newhand.shadowscale = 0
	
	P_RemoveMobj(mo.hand)
	mo.hand = newhand
	
	-- DPS check ball for that one phase
	local dpsball = PSO.lib.enemyCreatePart(mo, 0, 0, 0, MT_PSO_DARKFALZ_PART)
	dpsball.sprite = SPR_NULL
	dpsball.flags = PASSIVEFLAGS
	dpsball.shadowscale = 0
	
	mo.dpsball = dpsball
end

-- idle arm animation.
local function armAnimation(mo)
	mo.arm_hangle = mo.angle - ANG1*90
	
	mo.arm_vangle = -ANG1*50 + FixedAngle(cos(leveltime*ANG1)*10)	
	mo.farm_hangle = mo.arm_hangle
	mo.farm_vangle = -90*ANG1 + FixedAngle(sin(leveltime*ANG1)*10)
	mo.wrist_hangle = 0
	mo.wrist_vangle = -90*ANG1 - FixedAngle(sin(leveltime*ANG1)*5)
end

-- death anim
function A_DarkFalz_F_Death(mo)
	
	mo.deathanim = $ and $+1 or 1
	
	-- keep updating the parts or we're gonna look real silly...
	
	local tt = mo.deathanim
	
	if tt == 1
		--PSO.lib.DF_spawn(mo, FRACUNIT*7)
		DF_setDownStance(mo)	-- set to true on actual version
		
		mo.frame = A
		mo.head.sprite = SPR_DAFA
		mo.hand.sprite = SPR_DAFA
		mo.head.frame = F
		mo.hand.frame = L
		mo.head_height = 140*FRACUNIT
		mo.head.rollangle = 0
		mo.halo.sprite = SPR_NULL
		
		mo.momz = FRACUNIT*40
		P_InstaThrust(mo, mo.angle, -FRACUNIT*90)
		
		for p in players.iterate
			p.powers[pw_nocontrol] = 32767
		end
		
		S_FadeOutStopMusic(3000)
		
	elseif tt < TICRATE*3/2
		mo.momx = $*94/100
		mo.momy = $*94/100
		mo.basez = $ + mo.momz
		mo.momz = $*94/100
		
		P_StartQuake(FRACUNIT*tt*4, 5)
		
		-- move the arms in about 2 seconds (70 frames)
		if tt < (TICRATE*2)
			mo.arm_hangle = $ - ANG1*90 /70
			mo.arm_vangle = $ + ANG1*30 /70
			mo.farm_hangle = $ + ANG1*170 /70
			mo.farm_vangle = $ + ANG1*40 /70
		end
		
		--make the player screen fade...
		local fade = tt/8
		for p in players.iterate do
			local pmo = p.mo
			if not pmo continue end
			pmo.fadecolor = 0
			pmo.fadestrength = min(10, fade)
		end
	
	elseif tt == TICRATE*3/2	-- spawn alternate camera
		
		mo.flags2 = $|MF2_DONTDRAW
		mo.head.flags2 = $|MF2_DONTDRAW
		
		local x = mo.basecoords[1] - 1600*cos(mo.angle)
		local y = mo.basecoords[2] - 1600*sin(mo.angle)
		local z = mo.basecoords[3] + 512*FRACUNIT
		local cam = P_SpawnMobj(x, y, z, MT_THOK)
		cam.state = S_INVISIBLE
		cam.angle = mo.angle + ANG1*180
		cam.tics = -1
		
		for p in players.iterate do
			p.awayviewmobj = cam
			p.awayviewtics = -1
		end
		
		P_InstaThrust(mo, 0, 0)
		
		x = $ - 768*cos(mo.angle)
		y = $ - 768*sin(mo.angle)
		z = $ - 512*FRACUNIT
		
		/*local x = mo.x - 768*cos(mo.angle)
		local y = mo.y - 768*sin(mo.angle)
		local z = mo.z - 400*FRACUNIT*/
		local hand = P_SpawnMobj(x, y, z, MT_THOK)
		hand.state = S_INVISIBLE
		hand.sprite = SPR_DAFA
		hand.scale = $*5
		hand.frame = U
		hand.tics = -1
		hand.momz = FRACUNIT*5
		hand.basecoords = {hand.x, hand.y}
		
		mo.lasthand = hand
		
		-- move the arm n stuff
		-- then teleport the player away and finally finish the quest
	elseif tt >= TICRATE*3/2
		for p in players.iterate do
			local pmo = p.mo
			if not pmo continue end
			pmo.fadecolor = 0
			
			if tt < TICRATE*3
			or tt > TICRATE*7
				pmo.fadestrength = max(0, $-1)
			elseif tt%8 == 0
				pmo.fadestrength = min(10, $+1)
			end
		end
		
		local hand = mo.lasthand
		if hand.momz > 0
			P_SetOrigin(hand, hand.basecoords[1] + P_RandomRange(-8, 8)*FRACUNIT, hand.basecoords[2] + P_RandomRange(-8, 8)*FRACUNIT, hand.z)
		end
		hand.momz = $ - FRACUNIT/8
		
		if tt == TICRATE*7
			--print("A")
			local dest
			for m in mobjs.iterate()
					
				if m and m.valid and m.type == MT_PSO_TELEPORT_DEST
				and m.mtangle == 100	-- specifically this
					dest = m
					break
				end
			end
			
			for p in players.iterate do
				if p.mo and p.mo.valid
					P_SetOrigin(p.mo, dest.x, dest.y, dest.z)
					p.powers[pw_nocontrol] = 0
					p.awayviewmobj = nil
					p.awayviewtics = 0
					p.mo.angle = ANG1*90	-- force that.
					p.pso.pitcoords = {p.mo.x, p.mo.y, p.mo.z, p.mo.angle}
					p.pso.backuppitcoords = {p.mo.x, p.mo.y, p.mo.z, p.mo.angle}
				end
			end
			
			-- update this just in case.
			server.keycheckpoint = P_SpawnMobj(dest.x, dest.y, dest.z, MT_THOK)
			server.keycheckpoint.state = S_INVISIBLE
			server.keycheckpoint.tics = -1
			server.defaultspawnpoint = {server.keycheckpoint.x, server.keycheckpoint.y, server.keycheckpoint.z, server.keycheckpoint.angle}
			
			P_LinedefExecute(301)
			S_ChangeMusic("ROSE", true)
		
		elseif tt == TICRATE*8
			P_RemoveMobj(mo)
			return	-- KILLING MYSELF
		end
	end
	
	
	PSO.lib.DF_updateParts(mo)
end

states[S_PSO_DARKFALZ_F_DIE] = {SPR_DAFA, A, 1, A_DarkFalz_F_Death, 0, 0, S_PSO_DARKFALZ_F_DIE}

PSO.info.enemies[MT_PSO_DARKFALZ_PART] = {
		
		name = "Dark Falz",
		sprite = SPR_NULL,
		frame = A,
		painframe = A,
		
		part = true,			-- enemy is a part of another enemy
		partlinkdamage = true,	-- damage taken by the part is also taken by the main body
		
		bhp = 1000,	--% HP of the source object that spawned it.
		satk = 40,
		ratk = 40,
		tatk = 40,
		def = 25,
		exp = 0,
		weight = 4,
}

PSO.info.enemies[MT_PSO_DARKFALZ_FINAL] = {
		
		name = "Dark Falz",
		sprite = SPR_NULL,
		frame = A,
		painframe = A,
		boss = true,		-- enemy is a major boss!
		disaster = true,	-- do emergency code disaster
		bossmusic = "DF1",
		
		bhp = 12500,
		satk = 37,
		ratk = 37,
		tatk = 37,
		def = 25,
		exp = 500,
		weight = 4,		
		skipsight = true,
		
		drops = {
			
			{"chaos shard", 1, 200, 1, 75},
			{"chaos cluster", 51, 200, 1, 300},
			{"abnormal shard", 51, 200, 1, 300},
			
			-- Lv1+
			{"orakl sword", 1, 51,1, 150},
			{"orakl doublesaber", 1, 51,1, 150},
			{"orakl soaringblade", 1, 51,1, 150},
			{"orakl partizan", 1, 51,1, 150},
			{"orakl launcher", 1, 51,1, 150},
			{"orakl tcsm", 1, 51,1, 150},
			{"orakl rifle", 1, 51,1, 150},
			{"orakl shot", 1, 51,1, 150},
			{"orakl orphan", 1, 51,1, 150},
			{"orakl rod", 1, 51,1, 150},
			{"orakl wand", 1, 51,1, 150},
			
			{"makel frame", 1, 51,1, 150},
			{"flow frame", 1, 51,1, 60},
			{"steel hearts", 1, 51,1, 800},
			{"seal case", 1, 51,1, 800},
			{"monkey king bar", 1, 51,1, 800},
			{"girasole", 1, 51,1, 800},
			{"basilleon", 1, 51,1, 800},
			{"longinus", 1, 51,1, 800},
			{"sarblight", 1, 51,1, 800},
			{"forblight", 1, 51,1, 800},			
			{"full cylinder", 1, 51,1, 800},
			{"assassin", 1, 51,1, 800},
			{"wide smack", 1, 51,1, 800},
			{"heimdall", 1, 51,1, 800},
			{"photon launcher", 1, 51,1, 800},
			{"saint kilda", 1, 51,1, 800},
			{"yasminkov 2000h", 1, 51,1, 800},
			{"sarcueid", 1, 51,1, 800},
			{"clarita visas", 1, 51,1, 800},
			{"red processor", 1, 51,1, 800},
			{"windmill", 1, 51,1, 800},
			{"hexigraph", 1, 51,1, 800},
			{"tcsm_crawla4", 1, 51,1, 800},
			
			{"unit_hpsatk_3", 1, 51,1, 20},
			{"unit_hpratk_3", 1, 51,1, 20},
			{"unit_hptatk_3", 1, 51,1, 20},
			{"unit_ppsatk_3", 1, 51,1, 20},
			{"unit_ppratk_3", 1, 51,1, 20},
			{"unit_pptatk_3", 1, 51,1, 20},			
			{"unit_power_3", 1, 51,1, 20},
			{"unit_rainbow_3", 1, 51,1, 20},

			-- Lv51+
			{"orakl sword", 52, 81,1, 150},
			{"orakl doublesaber", 52, 81,1, 150},
			{"orakl soaringblade", 52, 81,1, 150},
			{"orakl partizan", 52, 81,1, 150},
			{"orakl launcher", 52, 81,1, 150},
			{"orakl tcsm", 52, 81,1, 150},
			{"orakl rifle", 52, 81,1, 150},
			{"orakl shot", 52, 81,1, 150},
			{"orakl orphan", 52, 81,1, 150},
			{"orakl rod", 52, 81,1, 150},
			{"orakl wand", 52, 81,1, 150},
			
			{"makel frame", 52, 81,1, 150},
			{"aberrant frame", 52, 81, 1, 200},
			{"flow frame", 52, 81,1, 60},
			{"steel hearts", 52, 81,1, 100},
			{"seal case", 52, 81,1, 100},
			{"zanba", 52, 81, 1, 200},
			{"last survivor", 52, 81, 1, 200},
			{"chainsawd", 52, 81, 1, 500},
			{"dragon slayer", 52, 81, 1, 500},
			{"monkey king bar", 52, 81,1, 100},
			{"girasole", 52, 81,1, 100},
			{"d. saber legacy", 52, 81, 1, 200},
			{"eternal heat", 52, 81, 1, 200},
			{"vivienne", 52, 81, 1, 500},
			{"double cannon", 52, 81, 1, 500},			
			{"basilleon", 52, 81,1, 100},
			{"longinus", 52, 81,1, 100},
			{"meteor lancer", 52, 81, 1, 200},
			{"brionac", 52, 81, 1, 200},
			{"vjaya", 52, 81, 1, 500},
			{"soul eater", 52, 81, 1, 500},			
			{"sarblight", 52, 81,1, 100},
			{"forblight", 52, 81,1, 100},	
			{"grand cross", 52, 81, 1, 200},
			{"red saber", 52, 81, 1, 200},
			{"elysion", 52, 81, 1, 500},
			{"axeon", 52, 81, 1, 500},
			{"full cylinder", 52, 81,1, 100},
			{"assassin", 52, 81,1, 100},
			{"yasminkov 3000r", 52, 81, 1, 200},
			{"strauss", 52, 81, 1, 200},
			{"firearms", 52, 81, 1, 500},
			{"frozen shooter", 52, 81, 1, 500},			
			{"wide smack", 52, 81,1, 100},
			{"heimdall", 52, 81,1, 100},
			{"barett", 52, 81, 1, 200},
			{"crush bullet", 52, 81, 1, 200},
			{"spread needle", 52, 81, 1, 500},
			{"final impact", 52, 81, 1, 500},			
			{"photon launcher", 52, 81,1, 100},
			{"saint kilda", 52, 81,1, 100},
			{"charge howzer", 52, 81, 1, 200},
			{"gur bazga", 52, 81, 1, 200},
			{"sspm launcher", 52, 81, 1, 500},
			{"inferno bazooka", 52, 81, 1, 500},			
			{"yasminkov 2000h", 52, 81,1, 100},
			{"sarcueid", 52, 81,1, 100},
			{"varista", 52, 81, 1, 200},
			{"bravace", 52, 81, 1, 200},
			{"pandora extreme", 52, 81, 1, 500},
			{"ruby bullet", 52, 81, 1, 500},			
			{"clarita visas", 52, 81,1, 100},
			{"red processor", 52, 81,1, 100},
			{"battle verge", 52, 81, 1, 200},
			{"brave hammer", 52, 81, 1, 200},
			{"siren hammer", 52, 81, 1, 500},
			{"demonic fork", 52, 81, 1, 500},			
			{"windmill", 52, 81,1, 100},
			{"hexigraph", 52, 81,1, 100},
			{"serdote", 52, 81, 1, 200},
			{"rose quartz", 52, 81, 1, 200},
			{"rykros staff", 52, 81, 1, 500},
			{"evil curst", 52, 81, 1, 500},			
			{"tcsm_crawla4", 52, 81,1, 200},
			
			{"unit_hpsatk_3", 52, 81,1, 50},
			{"unit_hpratk_3", 52, 81,1, 50},
			{"unit_hptatk_3", 52, 81,1, 50},
			{"unit_ppsatk_3", 52, 81,1, 50},
			{"unit_ppratk_3", 52, 81,1, 50},
			{"unit_pptatk_3", 52, 81,1, 50},			
			{"unit_power_3", 52, 81,1, 50},
			{"unit_rainbow_3", 52, 81,1, 50},
			
			{1000, nil, nil, 1, 1},
		},
		
		stagger_duration = TICRATE/2,
		
		attribute = ATTR_ABERRATION,
		weakness = ELEM_LIGHT,
		weakness2 = ELEM_FIRE,
		
		reset =	function(mo)
			if not mo.pso.blowdown
				mo.flags = $|MF_NOGRAVITY
				mo.momz = 0
			end
		end,
		
		thinker = function(mo)
			
			local diff = PSO.lib.questDifficulty()

			PSO.lib.enemyManageAggro(mo)
			
			if not mo.init
				PSO.lib.DF_spawn(mo, FRACUNIT*7)
				DF_spawnParts(mo)	-- shush.
				mo.attacktimer = 0
				
				mo.pso.minhp = mo.pso.maxhp*DPSC_THRESHOLD/100
				
				-- TEST
				--mo.pso.hp = 1
				--mo.pso.minhp = 0
			end
			if not mo.no_arm_anim
				if not mo.finaldown
					armAnimation(mo)	-- basic standstill arm animation
				end
			end
			
			if not mo.target or not mo.target.valid				
				PSO.lib.DF_updateParts(mo)
				return 
			end
				
			if not mo.platformz
				mo.platformz = mo.target.floorz
			end
			
			-- attack anims go here and must be processed before df_updateparts
			do_slam(mo)
			do_closeLaser(mo)
			do_shadowPunch(mo)
			do_sightAttack(mo)
			do_closeKnockback(mo)
			do_lingering(mo)
			do_laserSweep(mo)
			do_dpscheck(mo)
			do_downSlam(mo)
			do_downChestBlast(mo)
			
			PSO.lib.DF_updateParts(mo)

			-- for teleporting ourselves back after some attacks
			if not mo.basecoords
				mo.basecoords = {mo.x, mo.y, mo.basez}
			end
			
			-- for teleporting the target in some instances
			if not mo.tbasecoords and mo.target and mo.target.valid
				mo.tbasecoords = {mo.target.x, mo.target.y, mo.target.z}
			end
			
			-- don't try to do a new attack when we arent in a neutral state
			if mo.slamtimer
			or mo.closelaser
			or mo.lasersweep
			or mo.shadowpunch
			or mo.sightattack
			or mo.lingering
			or mo.knockback
			or mo.dpsctimer
			or mo.downslam
			or mo.downchestblast
				return
			end
			
			mo.attacktimer = $+1
			mo.attackcount = $ or 0
			--mo.attackcount = $ or 2
			--mo.attackcount = 4
			
			-- test for final down
			/*if 1
				if not mo.finaldown
					DF_setDownStance(mo)
				end
				
				mo.testtime = $ and $+1 or 1
				if mo.testtime == TICRATE*6
					--prep_downSlam(mo, 3)
					prep_downChestBlast(mo)
				end
				
				return
			end*/
			
			-- transition to DPS check!
			if mo.pso.hp <= mo.pso.minhp
			and not mo.dpscheck_done
				
				if mo.attacktimer >= TICRATE*5
					mo.dpscheck_done = true	-- set this flag so we don't do this twice lmao
					
					-- this can happen!
					if mo.closepos
						resetPosition(mo)
					end
					mo.closepos = nil
					
					prep_dpscheck(mo)
					mo.attacktimer = 1
				end
				
				return
			elseif mo.finaldown
				
				mo.finaldown = $+1
				
				if mo.finaldown == 2
					DF_setDownStance(mo)
					mo.pso.minhp = 0 -- let him die
				end
					
				if mo.finaldown > TICRATE/4
				and mo.finaldown < TICRATE
					-- remove fade
					mo.attacktimer = 1	-- reset attack timer
					mo.attackcount = 1	-- and attack count
					
					for p in players.iterate do
						local pmo = p.mo
						if not pmo or not pmo.valid continue end
					
						if not pmo.fadestrength
							pmo.fadestrength = nil
							pmo.fadecolor = nil
						else
							pmo.fadestrength = $-1
						end
					end
				end
				
				--print(mo.attacktimer)
				if mo.attacktimer == TICRATE*4
					
					local cnt = mo.attackcount%4
					if cnt == 0
						prep_downChestBlast(mo)
					elseif cnt == 1
					or cnt == 3
						prep_downSlam(mo, P_RandomRange(2, 3))
					elseif cnt == 2
						prep_lingering(mo)
					end
					
					mo.attackcount = $+1
					mo.attacktimer = 1
				end
				
				return
			end
			
			-- hard mode patterns
			if diff == DIFF_HARD
				
				-- Phase 1: HP > 75%
				
				if mo.pso.hp > mo.pso.maxhp*3/4 --and false
					
					-- here we follow a sequence of 6 attacks:
					-- the same as normal mode phase 2.
					/*
						Slam or Shadow Punch (pinch version)
						Slam or Shadow Punch (pinch version)
						2 stack markers -> Closeup Laser
						Explosion patterns while close
						Explosion patterns while close
						Lingering placeable attack
						Repeat
					*/
					
					if mo.attackcount % 6 == 5	-- attack #6, do lingering attack
						prep_lingering(mo)
						mo.attackcount = $+1
						mo.attacktimer = 0
								
					elseif mo.attackcount % 6 == 2	-- attack #3, 2 stack markers followed by a close laser
								
						-- select angles
						if mo.attacktimer == 1
							local a = ANG1*15
							local rng = P_RandomRange(0,1)
							if rng == 0
								mo.stacka1 = mo.angle-a
								mo.stacka2 = mo.angle+a
							else
								mo.stacka1 = mo.angle+a
								mo.stacka2 = mo.angle-a
							end
						end
								
						-- put the stack markers!
						-- 1 (left or right)
						if mo.attacktimer == TICRATE*3
							local x = mo.x + 2048*cos(mo.stacka1)
							local y = mo.y + 2048*sin(mo.stacka1)
									
							local m = PSO.lib.spawnStackMarker(mo, x, y, mo.platformz, 384, TICRATE*5, 500, DMT_TECHNIQUE, RT_KNOCKBACK, 8)

							local vis = P_SpawnMobj(m.x, m.y, m.z, MT_PSO_DARKFALZ_STACKMARKER)
							vis.tracer = m
						-- 2 (opposite)
						elseif mo.attacktimer == TICRATE*6
							local x = mo.x + 2048*cos(mo.stacka2)
							local y = mo.y + 2048*sin(mo.stacka2)
									
							local m = PSO.lib.spawnStackMarker(mo, x, y, mo.platformz, 384, TICRATE*6, 500, DMT_TECHNIQUE, RT_KNOCKBACK, 8)

							local vis = P_SpawnMobj(m.x, m.y, m.z, MT_PSO_DARKFALZ_STACKMARKER)
							vis.tracer = m
						-- center + closelaser
						elseif mo.attacktimer == TICRATE*9
							local x = mo.x + 2048*cos(mo.angle)
							local y = mo.y + 2048*sin(mo.angle)
									
							local m = PSO.lib.spawnStackMarker(mo, x, y, mo.platformz, 384, TICRATE*5, 500, DMT_TECHNIQUE, RT_KNOCKBACK, 8)

							local vis = P_SpawnMobj(m.x, m.y, m.z, MT_PSO_DARKFALZ_STACKMARKER)
							vis.tracer = m
							mo.closepos = true
							prep_closeLaser(mo)
									
							mo.attacktimer = 0
							mo.attackcount = $+1
						end					
							
					elseif mo.attackcount % 6 == 3	-- attack #4/5: explosion patterns
					or mo.attackcount % 6 == 4
								
						if mo.attacktimer == TICRATE*4
							explosionPatterns(mo, P_RandomRange(0, 1))
								
						elseif mo.attacktimer == TICRATE*13
							-- reset position after the last attack...
							if mo.attackcount %6 == 4
								resetPosition(mo)
								mo.closepos = nil
							end
									
							mo.attacktimer = 0
							mo.attackcount = $+1
						end
								
					else	-- normal random attack stuff!
									
						if mo.attacktimer == TICRATE*3
							local rng = P_RandomRange(0, 1)
							
							if rng == 0
								prep_slam(mo, true, SLAM_WAIT*16/10)
								--prep_slam(mo, nil, SLAM_WAIT*16/10, true)
							elseif rng == 1
								prep_shadowPunch(mo, true, SPUNCH_WAIT*2)
							end
										
							mo.attackcount = $+1
							mo.attacktimer = 0
						end
					end
				
				elseif not mo.startphase2	-- attack to transition into the meat of the fight...
				--and (mo.attacktimer < TICRATE or mo.phase2confirm)
					
					if not mo.phase2confirm
						mo.attacktimer = 1
					end
					
					mo.phase2confirm = true	-- we're good to go and not doing anything else...
					
					-- 2 half cleaves followed by a meteor, half cleave and 
					if mo.attacktimer == TICRATE
					--and mo.closepos
						resetPosition(mo)
						mo.closepos = nil
					
					elseif mo.attacktimer == TICRATE*3
							
						local dir = P_RandomRange(0, 1)
							
						prep_halfCleave(mo, dir, TICRATE*7)
						prep_halfCleave(mo, dir == 0 and 1 or 0, TICRATE*8)
					
					elseif mo.attacktimer == TICRATE*12
							
						local meteor = P_SpawnMobj(mo.target.x, mo.target.y, mo.platformz + FRACUNIT*800, MT_PSO_DARKFALZ_METEOR)
						meteor.target = mo
						meteor.tracer = mo.target
						meteor.track = TICRATE*6
						meteor.potency = 5
						meteor.reactionstrength = 35
						meteor.delay = TICRATE*8
						meteor.failtimeout = TICRATE*20
						meteor.failpotency = 600	
						
						prep_halfCleave(mo, dir, TICRATE*10)
					
					elseif mo.attacktimer == TICRATE*12 + TICRATE*8
					
						prep_sightAttack(mo, 1, TICRATE*5)
					
					elseif mo.attacktimer == TICRATE*12+TICRATE*8+TICRATE*5
						mo.startphase2 = true
						mo.attacktimer = 0	-- go back to normal gameplan...
						mo.attackcount = 0
					end
				
				else
				-- PROPER PHASE 2

					if mo.attackcount % 6 == 5	-- attack #6, do lingering attack
						
						resetPosition(mo)
						mo.closepos = nil
						
						prep_lingering(mo)
						prep_halfCleave(mo, P_RandomRange(0, 1), TICRATE*10)
						mo.attackcount = $+1
						mo.attacktimer = 0
								
					elseif mo.attackcount % 6 == 2	-- attack #3, 2 stack markers followed by a close laser
								
						-- select angles
						if mo.attacktimer == 1
							local a = ANG1*25
							local rng = P_RandomRange(0,1)
							if rng == 0
								mo.stacka1 = mo.angle-a
								mo.stacka2 = mo.angle+a
							else
								mo.stacka1 = mo.angle+a
								mo.stacka2 = mo.angle-a
							end
						end
								
						-- put the stack markers!
						-- 1 (left or right)
						if mo.attacktimer == TICRATE*3
							local x = mo.x + 2048*cos(mo.stacka1)
							local y = mo.y + 2048*sin(mo.stacka1)
									
							local m = PSO.lib.spawnStackMarker(mo, x, y, mo.platformz, 384, TICRATE*5, 500, DMT_TECHNIQUE, RT_KNOCKBACK, 8)

							local vis = P_SpawnMobj(m.x, m.y, m.z, MT_PSO_DARKFALZ_STACKMARKER)
							vis.tracer = m
						-- 2 (opposite)
						elseif mo.attacktimer == TICRATE*6
							local x = mo.x + 2048*cos(mo.stacka2)
							local y = mo.y + 2048*sin(mo.stacka2)
									
							local m = PSO.lib.spawnStackMarker(mo, x, y, mo.platformz, 384, TICRATE*6, 500, DMT_TECHNIQUE, RT_KNOCKBACK, 8)

							local vis = P_SpawnMobj(m.x, m.y, m.z, MT_PSO_DARKFALZ_STACKMARKER)
							vis.tracer = m
						-- center + closelaser
						elseif mo.attacktimer == TICRATE*9
							local x = mo.x + 2048*cos(mo.angle)
							local y = mo.y + 2048*sin(mo.angle)
									
							local m = PSO.lib.spawnStackMarker(mo, x, y, mo.platformz, 384, TICRATE*5, 500, DMT_TECHNIQUE, RT_KNOCKBACK, 8)

							local vis = P_SpawnMobj(m.x, m.y, m.z, MT_PSO_DARKFALZ_STACKMARKER)
							vis.tracer = m
							mo.closepos = true
							
							prep_halfCleave(mo, P_RandomRange(0, 1), TICRATE*7)
							prep_closeLaser(mo)
									
							mo.attacktimer = 0
							mo.attackcount = $+1
						end					
							
					elseif mo.attackcount % 6 == 3	-- attack #4: explosion patterns
					--or mo.attackcount % 6 == 4
						
						if mo.attacktimer == 2
							prep_halfCleave(mo, P_RandomRange(0, 1), TICRATE*7)
						
						elseif mo.attacktimer == TICRATE*4
							explosionPatterns(mo, P_RandomRange(0, 1))
								
						elseif mo.attacktimer == TICRATE*13
									
							mo.attacktimer = 0
							mo.attackcount = $+1
						end
					
					elseif mo.attackcount % 6 == 4	-- laser chase
						
						if mo.attacktimer == TICRATE*5
							
							local dir = P_RandomRange(0,1) and -1 or 1
							local a = mo.angle + ANG1*60*dir
							local x = mo.x + 1024*cos(a)
							local y = mo.y + 1024*sin(a)
									
							local m = PSO.lib.spawnStackMarker(mo, x, y, mo.platformz, 384, TICRATE*5, 500, DMT_TECHNIQUE, RT_KNOCKBACK, 8)

							local vis = P_SpawnMobj(m.x, m.y, m.z, MT_PSO_DARKFALZ_STACKMARKER)
							vis.tracer = m
								
							prep_laserSweep(mo, dir)
							
							mo.attackcount = $+1
							mo.attacktimer = 0
						end
								
					else	-- normal random attack stuff!
									
						if mo.attacktimer == TICRATE*3
							local rng = P_RandomRange(0, 1)
							
							if rng == 0
								prep_slam(mo, nil, SLAM_WAIT*16/10, true)
							elseif rng == 1
								prep_shadowPunch(mo, true, SPUNCH_WAIT*2)
							end
							
							prep_halfCleave(mo, P_RandomRange(0, 1), TICRATE*6)
										
							mo.attackcount = $+1
							mo.attacktimer = 0
						end
					end
				
				end
				

				
			-- normal mode regular patterns.
			elseif diff == DIFF_NORMAL
				
				-- phase 1: opening attacks and >65% HP
				
				if mo.attackcount < 4 or mo.pso.hp > (mo.pso.maxhp*65/100)
					-- first attacks will be the same in sequence, afterwards things get more random!
					if not mo.attackcount
						
						-- always open with a basic punch
						if mo.attacktimer == TICRATE*5
							prep_slam(mo, false)
							mo.attacktimer = 0
							mo.attackcount = 1
						end
						
						-- shadow punch
					elseif mo.attackcount == 1
						if mo.attacktimer == TICRATE*4
							prep_shadowPunch(mo)
							mo.attacktimer = 0
							mo.attackcount = $+1
						end
						
						-- closing in!
					elseif mo.attackcount == 2
						if mo.attacktimer == TICRATE*3
							
							local x = mo.x + 2048*cos(mo.angle)
							local y = mo.y + 2048*sin(mo.angle)
							
							local m = PSO.lib.spawnStackMarker(mo, x, y, mo.platformz, 384, TICRATE*5, 500, DMT_TECHNIQUE, RT_KNOCKBACK, 8)

							local vis = P_SpawnMobj(m.x, m.y, m.z, MT_PSO_DARKFALZ_STACKMARKER)
							vis.tracer = m
							
							mo.attacktimer = 0
							prep_closeLaser(mo)
							mo.close = true	-- we're close to the platform now!
							mo.attackcount = $+1
						end
					
					elseif mo.attackcount == 3	-- at this point, we're close to the platform
						if mo.attacktimer == TICRATE*3
							--print("A")
							prep_closeKnockback(mo)
							mo.attackcount = $+1
							mo.attacktimer = 0
						end
					
					-- attacks from there on out are random up until certain HP thresholds
					elseif mo.attackcount >= 4
						
						if mo.attacktimer == TICRATE*3
						
							if mo.attackcount % 4 == 0	-- every 4 attacks, do this.
								prep_lingering(mo)
							else
						
								local rng = P_RandomRange(0, 1)
								
								if rng == 0
									prep_slam(mo, false)
								elseif rng == 1
									prep_shadowPunch(mo)
								end
							end
							
							mo.attackcount = $+1
							mo.attacktimer = 0
						end
					end
				
				else	-- phase 2: opening attacks have passed and HP is <= 65%
					if not mo.startphase2
					
						if not mo.phase2confirm
							mo.attacktimer = 1
							mo.phase2confirm = true
						end					
					
						-- 2 meteors back to back followed by 2 sight attacks!
						if mo.attacktimer == TICRATE*3
							
							if mo.closepos
								resetPosition(mo)
								mo.closepos = nil
							end
							
							local x = mo.x + 2100*cos(ANG1*24)
							local y = mo.y + 2100*sin(ANG1*24)
							
							local meteor = P_SpawnMobj(x, y, mo.platformz + FRACUNIT*800, MT_PSO_DARKFALZ_METEOR)
							meteor.target = mo
							meteor.potency = 5
							meteor.reactionstrength = 28
							meteor.delay = TICRATE*5
							meteor.failtimeout = TICRATE*20
							meteor.failpotency = 600						
						
						elseif mo.attacktimer == TICRATE*8
							local x = mo.x + 2100*cos(ANG1*-24)
							local y = mo.y + 2100*sin(ANG1*-24)
							
							local meteor = P_SpawnMobj(x, y, mo.platformz + FRACUNIT*800, MT_PSO_DARKFALZ_METEOR)
							meteor.target = mo
							meteor.potency = 5
							meteor.reactionstrength = 28
							meteor.delay = TICRATE*5
							meteor.failtimeout = TICRATE*20
							meteor.failpotency = 600	
						
						elseif mo.attacktimer == TICRATE*11
							prep_sightAttack(mo, 2)
							mo.startphase2 = true
							mo.attackcount = 6	-- set this to start the cycle anew!
							mo.attacktimer = 0
						end
					
					else	-- ok we're good!
						
						-- here we follow a sequence of 6 attacks:
						/*
							Slam or Shadow Punch (pinch version)
							Slam or Shadow Punch (pinch version)
							2 stack markers -> Closeup Laser
							Explosion patterns while close
							Explosion patterns while close
							Lingering placeable attack
							Repeat
						*/
						if mo.attackcount % 6 == 5	-- attack #6, do lingering attack
							prep_lingering(mo)
							mo.attackcount = $+1
							mo.attacktimer = 0
							
						elseif mo.attackcount % 6 == 2	-- attack #3, 2 stack markers followed by a close laser
							
							-- select angles
							if mo.attacktimer == 1
								local a = ANG1*15
								local rng = P_RandomRange(0,1)
								if rng == 0
									mo.stacka1 = mo.angle-a
									mo.stacka2 = mo.angle+a
								else
									mo.stacka1 = mo.angle+a
									mo.stacka2 = mo.angle-a
								end
							end
							
							-- put the stack markers!
							-- 1 (left or right)
							if mo.attacktimer == TICRATE*3
								local x = mo.x + 2048*cos(mo.stacka1)
								local y = mo.y + 2048*sin(mo.stacka1)
								
								local m = PSO.lib.spawnStackMarker(mo, x, y, mo.platformz, 384, TICRATE*5, 500, DMT_TECHNIQUE, RT_KNOCKBACK, 8)

								local vis = P_SpawnMobj(m.x, m.y, m.z, MT_PSO_DARKFALZ_STACKMARKER)
								vis.tracer = m
							-- 2 (opposite)
							elseif mo.attacktimer == TICRATE*6
								local x = mo.x + 2048*cos(mo.stacka2)
								local y = mo.y + 2048*sin(mo.stacka2)
								
								local m = PSO.lib.spawnStackMarker(mo, x, y, mo.platformz, 384, TICRATE*6, 500, DMT_TECHNIQUE, RT_KNOCKBACK, 8)

								local vis = P_SpawnMobj(m.x, m.y, m.z, MT_PSO_DARKFALZ_STACKMARKER)
								vis.tracer = m
							-- center + closelaser
							elseif mo.attacktimer == TICRATE*9
								local x = mo.x + 2048*cos(mo.angle)
								local y = mo.y + 2048*sin(mo.angle)
								
								local m = PSO.lib.spawnStackMarker(mo, x, y, mo.platformz, 384, TICRATE*5, 500, DMT_TECHNIQUE, RT_KNOCKBACK, 8)

								local vis = P_SpawnMobj(m.x, m.y, m.z, MT_PSO_DARKFALZ_STACKMARKER)
								vis.tracer = m
								mo.closepos = true
								prep_closeLaser(mo)
								
								mo.attacktimer = 0
								mo.attackcount = $+1
							end					
						
						elseif mo.attackcount % 6 == 3	-- attack #4/5: explosion patterns
						or mo.attackcount % 6 == 4
							
							if mo.attacktimer == TICRATE*4
								explosionPatterns(mo, P_RandomRange(0, 1))
							
							elseif mo.attacktimer == TICRATE*13
								-- reset position after the last attack...
								if mo.attackcount %6 == 4
									resetPosition(mo)
									mo.closepos = nil
								end
								
								mo.attacktimer = 0
								mo.attackcount = $+1
							end
							
						else	-- normal random attack stuff!
								
							if mo.attacktimer == TICRATE*3
								local rng = P_RandomRange(0, 1)
										
								if rng == 0
									prep_slam(mo, true, SLAM_WAIT*16/10)
								elseif rng == 1
									prep_shadowPunch(mo, true, SPUNCH_WAIT*2)
								end
									
								mo.attackcount = $+1
								mo.attacktimer = 0
							end
						end
					end
				end
			end
			
			-- debug thinker, this is where i tested all the shit lol.
			--if mo.attacktimer == TICRATE*3
				--prep_slam(mo)
				--prep_closeLaser(mo)
				--prep_shadowPunch(mo)
				
				/*local meteor = P_SpawnMobj(mo.target.x, mo.target.y, mo.target.z + FRACUNIT*800, MT_PSO_DARKFALZ_METEOR)
				meteor.target = mo
				meteor.potency = 5
				meteor.reactionstrength = 25
				meteor.delay = TICRATE*5
				meteor.failtimeout = TICRATE*20
				meteor.failpotency = 10000*/
				
				--if not mo.stackmarker
					-- test:
					-- source, x, y, z, radius, delay, potency, damagetype, reaction, strength)
					/*local m = PSO.lib.spawnStackMarker(mo, mo.target.x, mo.target.y, mo.target.z, 384, TICRATE*5, 500, DMT_TECHNIQUE, RT_KNOCKBACK, 8)
					local vis = P_SpawnMobj(m.x, m.y, m.z, MT_PSO_DARKFALZ_STACKMARKER)
					vis.tracer = m
					
					mo.stackmarker = m
				elseif mo.stackmarker and mo.stackmarker.valid
					P_MoveOrigin(mo.stackmarker, mo.target.x, mo.target.y, mo.target.z)
				end*/
			--elseif mo.attacktimer == TICRATE*10
			--	prep_sightAttack(mo)
			--end
		end,
}