/*
	
*/

freeslot("MT_PSO_GANNIL_SHOT", "MT_PSO_GANNIL_BULLET", "MT_PSO_GANNIL_DOT")

mobjinfo[MT_PSO_GANNIL_SHOT] = {
	doomednum = 2704,
	spawnstate = S_INVISIBLE,
	deathstate = S_PSO_GANNIL_DEATH,
	spawnhealth = 1000,
	radius = 48<<FRACBITS,
	height = 120<<FRACBITS,
	flags = MF_ENEMY|MF_ENEMY|MF_SHOOTABLE,
}

mobjinfo[MT_PSO_GANNIL_BULLET] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	deathstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 24<<FRACBITS,
	height = 49<<FRACBITS,
	flags = MF_MISSILE|MF_NOGRAVITY,
}

mobjinfo[MT_PSO_GANNIL_DOT] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	deathstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 24<<FRACBITS,
	height = 49<<FRACBITS,
	flags = MF_NOGRAVITY,
}

addHook("MobjThinker", function(mo)
	
	if not mo.target or not mo.target.valid
		P_RemoveMobj(mo)
		return
	end
	
	if leveltime & 1
		local f = P_SpawnMobj(mo.x, mo.y, mo.z, MT_IVSP)
		f.colorized = true
		f.color = SKINCOLOR_TAN
	end
	
	mo.colorized = true
	mo.color = SKINCOLOR_TAN
	mo.sprite = SPR_SSPK
	mo.frame = (leveltime%6 /2)|FF_FULLBRIGHT
	
	-- exploded
	if mo.flags & MF_NOCLIPTHING
		
		local potency = 100
		local msl = PSO.lib.spawnMissile(mo.target, MT_PSO_GANNIL_DOT, 0, 0, potency, DMT_RANGED, 0, 0, mo.height/2, 0)
		P_SetOrigin(msl, mo.x, mo.y, mo.floorz)
		msl.fuse = TICRATE*10
		
		P_RemoveMobj(mo)
	end
	
end, MT_PSO_GANNIL_BULLET)                                                                                                                                                                                     


/*addHook("MobjDeath", function(mo)
	
	if mo and mo.valid and mo.target and mo.target.valid

	end
	
end, MT_PSO_GANNIL_BULLET)*/

addHook("MobjThinker", function(mo)
	
	local a = leveltime*ANG1*6
	local r = 160

	if not mo.target or not mo.target.valid
		P_RemoveMobj(mo)
		return
	end
	
	if leveltime & 1
		for i = 1, 8
			
			local x = mo.x + r*cos(a)
			local y = mo.y + r*sin(a)
			local z = mo.z
			
			local s = P_SpawnMobj(x, y, z, MT_SUPERSPARK)
			s.colorized = true
			s.color = SKINCOLOR_TAN
			s.momz = FRACUNIT*20
			
			a = $+ANG1*45
		end
	end
	
	if leveltime%10 == 0
		for i = 1, 8
			local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SUPERSPARK)
			s.colorized = true
			s.color = SKINCOLOR_TAN
			local a = 360/8*ANG1*i
			P_InstaThrust(s, a, r*FRACUNIT/6)
		end
	end
	
	if leveltime%10 == 0
		local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, (2*r)<<FRACBITS, 580<<FRACBITS, mo.target, mo.pso.potency/24, DMT_RANGED, 2, RT_NONE)
		hb.pso.element = mo.pso.element
	end
	
end, MT_PSO_GANNIL_DOT)

local function spawn_elements(mo)

	local diff = PSO.lib.questDifficulty()
	local spr = diff >= DIFF_HARD and SPR_HRB2 or SPR_HRBG
	local bright = (diff >= DIFF_HARD and FF_FULLBRIGHT or 0)
	
	-- chest
	mo.elements = {}
	
	for i = 1, 2 --5
		local p = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		p.sprite = spr
		p.frame = (I+(i-1))--(F+(i-1))
		/*if i > 1 and i < 4
			p.renderflags = $ |(RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_NOSPLATROLLANGLE)
			P_CreateFloorSpriteSlope(p)	-- used for later
		else*/
			p.frame = $|FF_PAPERSPRITE|bright
		--end
		p.tics = -1
		--p.scale = $*3/2
		mo.elements[#mo.elements+1] = p
	end
	
	-- diamonds
	mo.diamonds = {}
	
	for i = 1, 4
		local p = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		p.sprite = spr	
		p.frame = D|bright
		p.tics = -1
		mo.diamonds[#mo.diamonds+1] = p
	end
	
	-- legs
	mo.legs = {}
	
	for i = 1, 2
		local p = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		p.sprite = spr
		p.frame = K|FF_PAPERSPRITE|bright
		p.tics = -1
		mo.legs[#mo.legs+1] = p
		
	end
	
	local offarm = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	offarm.sprite = spr
	offarm.frame = N|FF_PAPERSPRITE|bright
	offarm.tics = -1
	mo.offarm = offarm
	P_CreateFloorSpriteSlope(offarm)
	
	local mainarm = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	mainarm.sprite = spr
	mainarm.frame = L|FF_PAPERSPRITE|bright
	mainarm.tics = -1
	mo.mainarm = mainarm
	P_CreateFloorSpriteSlope(mainarm)

	local head = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	head.sprite = spr
	head.frame = O|bright
	head.tics = -1
	head.renderflags = $ |(RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_NOSPLATROLLANGLE)
	P_CreateFloorSpriteSlope(head)
	mo.head = head
	
	local halo = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	halo.sprite = SPR_BFLW
	halo.frame = D|FF_ADD|FF_FULLBRIGHT
	halo.renderflags = $ |(RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_NOSPLATROLLANGLE)
	halo.color = SKINCOLOR_MASTER
	halo.tics = -1
	mo.halo = halo
	
	if diff >= DIFF_HARD
		mo.halo.flags2 = $|MF2_DONTDRAW
	end
	
	mo.body_angle = mo.angle
	mo.offarm_angle = mo.angle - ANG1*90
	mo.offarm_rollangle = 0
	mo.offarm_zoff = 0
	mo.mainarm_splat = {}
	
	mo.mainarm_angle = mo.angle + ANG1*90
	mo.mainarm_rollangle = ANG1*6
	mo.mainarm_zoff = 0
	mo.mainarm_splat = {}
end

local function update_elements(mo)
	
	local body_z = mo.z + FRACUNIT*160
	local body_angle = mo.body_angle --+ leveltime*ANG2
	
	local chest_dist = 0	--cv_dist.value
	local chestx = mo.x --+ chest_dist*cos(body_angle)
	local chesty = mo.y --+ chest_dist*sin(body_angle)

	
	-- top of head
	P_SetOrigin(mo.head, mo.x, mo.y, body_z + mo.scale*40)
	mo.head.floorspriteslope.o = {x=mo.x, y=mo.y, z= body_z + mo.scale*40}
	mo.head.floorspriteslope.xydirection = mo.angle
	mo.head.floorspriteslope.zangle = -ANG1*45
	mo.head.rollangle = mo.angle + ANG1*180
	mo.head.tics = 2
	
	if mo.leaping
	and leveltime & 1
		P_SpawnGhostMobj(mo.head)
	end

	P_MoveOrigin(mo.halo, mo.x, mo.y, body_z + mo.scale*80)
	mo.halo.angle = mo.angle + ANG1*90
	mo.halo.rollangle = $ + ANG1
	mo.halo.tics = 2
	
	-- bottom parts of the body
	chestx = mo.x + 10*cos(body_angle)
	chesty = mo.y + 10*sin(body_angle)	
	for i = 1, 2
		
		local p = mo.elements[i]
		
		P_MoveOrigin(p, chestx, chesty, body_z)
		p.angle = body_angle - (ANG1*(90+30))*(i==1 and 1 or -1)
		p.tics = 2
		if mo.leaping
		and leveltime & 1
			P_SpawnGhostMobj(p)
		end		
	end
	
	-- diamonds
	for i = 1, #mo.diamonds
		
		local a = body_angle + ANG1*90 + (i-1)*180*ANG1
		local z = body_z
		local dist = 32
		local p = mo.diamonds[i]
		
		if i > 2
			a = mo.angle + ANG1*90 + (i-1)*180*ANG1
			z = $ - mo.scale*64
			dist = 16
		end
		
		local x = mo.x + dist*cos(a)
		local y = mo.y + dist*sin(a)
		
		P_MoveOrigin(p, x, y, z)
		p.tics = 2
	end
	
	-- legs
	for i = 1, #mo.legs
		
		local p = mo.legs[i]
		local d = mo.diamonds[i+2]
		
		P_MoveOrigin(p, d.x, d.y, d.z-mo.scale*6)
		p.angle = mo.angle + ANG1*90 + (i-1)*180*ANG1
		p.rollangle = ANG1*5
		p.tics = 2
		if mo.leaping
		and leveltime & 1
			P_SpawnGhostMobj(p)
		end		
	end
	
	
	-- arms
	local names = {"mainarm", "offarm"}
	
	for i = 1, 2
	
		local d1 = mo.diamonds[i]
		local index = names[i]
		local splat = mo[index.."_splat"]
		local zhelp = 0
		if not splat or not splat.o
			zhelp = 64*sin(mo[index.."_rollangle"])
		end
		zhelp = $ + mo[index.."_zoff"]
		
		P_MoveOrigin(mo[index], d1.x, d1.y, d1.z - 8*mo.scale + zhelp)
		
		mo[index].angle = mo[index.."_angle"]
		mo[index].rollangle = mo[index.."_rollangle"]
		
		if splat and splat.o
			mo[index].floorspriteslope.o = splat.o
			mo[index].floorspriteslope.xydirection = splat.xy
			mo[index].floorspriteslope.zangle = splat.za
			mo[index].renderflags = $ |(RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_NOSPLATROLLANGLE)
			mo[index].frame = $ & ~FF_PAPERSPRITE
		else
			mo[index].renderflags = $ & ~(RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_NOSPLATROLLANGLE)
			mo[index].frame = $ |FF_PAPERSPRITE			
		end
		
		mo[index].tics = 2
		if mo.leaping
		and leveltime & 1
			P_SpawnGhostMobj(mo[index])
		end
		
	end
	
end

local function prep_normalshot(mo, n)
	mo.normalshot = 1
	mo.numshots = n or 1
	S_StartSound(mo, sfx_s3k5a)
end


local function do_normalshot(mo)
	
	local raises = TICRATE/4
	local lowers = TICRATE/4
	
	local windup = TICRATE/2
	local wait = TICRATE/4
	local swingtime = TICRATE/2
	
	local firerate = 6
	
	if mo.normalshot == 1
		mo.mainarm_angle = mo.angle + ANG1*90
	end
	
	if mo.normalshot < raises
		
		mo.body_angle = $ - ANG1*2
		mo.mainarm_rollangle = $ + ANG1*21 	--+ ANG1/2
		mo.mainarm_angle = $ - ANG1*8
		mo.mainarm_zoff = $ + FRACUNIT*6
	
	elseif mo.normalshot >= raises and mo.normalshot < raises+lowers
		
		local t = mo.normalshot - (windup+wait)
		mo.mainarm_angle = mo.angle - ANG1*10
		
		mo.mainarm_zoff = max(0, $ - FRACUNIT*10)
		mo.mainarm_rollangle = $ - ANG1*11 + ANG1/4
	
	elseif mo.normalshot == raises+lowers
		mo.mainarm_rollangle = ANG1*70
		mo.mainarm_zoff = -FRACUNIT*64
		mo.shot = 0
		
	elseif mo.normalshot > raises+lowers	
		
		if mo.normalshot % firerate == 0
		and mo.numshots

			local potency = 400
			local msl = PSO.lib.spawnMissile(mo, MT_PSO_GANNIL_BULLET, mo.angle, FRACUNIT*40, potency, DMT_RANGED, 0, 0, mo.height/2, 0)
			
			local a = mo.angle + ANG1*30
			local x = mo.x + 128*cos(a)
			local y = mo.y + 128*sin(a)
			local z = mo.z + mo.height/2
			
			P_SetOrigin(msl, x, y, z)
			PSO.lib.aimMissile(msl, mo.target)
			
			S_StartSound(msl, sfx_s3k83)
			
			mo.numshots = $-1
			mo.shot = $+1
		end
	end
	
	if mo.shot and mo.normalshot > raises+lowers+(mo.shot*firerate) + TICRATE/2

		mo.body_angle = mo.angle
		mo.offarm_angle = mo.angle - ANG1*90
		mo.mainarm_rollangle = 0
		mo.mainarm_zoff = 0	
		mo.shot = nil
		mo.normalshot = nil
		return
	end
	
	mo.normalshot = $+1
	
end

local function prep_shotgun(mo)
	mo.shotgun = 1
	S_StartSound(mo, sfx_s3k5a)
end


local function do_shotgun(mo)
	
	local twirl = TICRATE*2/3
	
	local firerate = 6
	
	if mo.shotgun == 1
		mo.mainarm_angle = mo.angle + ANG1*90
	end
	
	if mo.shotgun < twirl
		
		local angt = ANG1*18
		mo.body_angle = $ - angt
		mo.mainarm_rollangle = min(ANG1*70, $ + ANG1*8) 	--+ ANG1/2
		
		mo.mainarm_angle = $ - ANG1*21
		mo.offarm_angle = $ - angt
		mo.mainarm_zoff = $ - FRACUNIT*2
	
	elseif mo.shotgun == twirl+1
		
		local xp = mo.x + 192*cos(mo.angle)
		local yp = mo.y + 192*sin(mo.angle)
		local zp = mo.z - FRACUNIT*192
		
		local s = P_SpawnMobj(xp, yp, zp, MT_THOK)
		s.state = S_MEGISTAR1
		s.color = SKINCOLOR_WHITE
		s.scale = FRACUNIT*8
		s.destscale = 1
		s.scalespeed = FRACUNIT	
	end
	
	for i = 1, 4
	
		if mo.shotgun == twirl + TICRATE/8 + (i*3)
			
			local xp = mo.x + 192*cos(mo.angle) + P_RandomRange(-96, 96)*FRACUNIT
			local yp = mo.y + 192*sin(mo.angle) + P_RandomRange(-96, 96)*FRACUNIT
			local zp = mo.z + mo.height/2 + P_RandomRange(-96, 96)*FRACUNIT
			
			local s = P_SpawnMobj(xp, yp, zp, MT_THOK)
			s.state = S_PSO_LAEXPL1
			s.colorized = true
			s.color = SKINCOLOR_TAN

			local soundhelp = P_SpawnMobj(xp, yp, zp, MT_THOK)
			soundhelp.state = S_INVISIBLE
			soundhelp.tics = TICRATE*2
			S_StartSound(soundhelp, sfx_s3k4e)
			
			-- spawn an explosion hitbox:
			if i == 1
				local xh = mo.x + 140*cos(mo.angle)
				local yh = mo.y + 140*sin(mo.angle)
				local zh = mo.z 
				local h = PSO.lib.spawnHurtBox(xh, yh, zh, 320<<FRACBITS, 512<<FRACBITS, mo, 400, DMT_RANGED, 4, RT_BLOWDOWN)
				h.angle = mo.angle
			end
				
			if consoleplayer and R_PointToDist2(consoleplayer.mo.x, consoleplayer.mo.y, mo.x, mo.y) < FRACUNIT*4096
				P_StartQuake(FRACUNIT*32, 10)
			end
				
			for i = 1, 4
					
				local d = P_SpawnMobj(xp + P_RandomRange(-128, 128)*FRACUNIT, yp + P_RandomRange(-128, 128)*FRACUNIT, zp + P_RandomRange(0, 256)*FRACUNIT, MT_TNTDUST)
				d.scale = P_RandomRange(2, 4)*FRACUNIT
				d.momz = P_RandomRange(1, 8)*FRACUNIT
			end
		end
	end
	
	if mo.shotgun > twirl + TICRATE/3

		mo.body_angle = mo.angle
		mo.offarm_angle = mo.angle - ANG1*90
		mo.offarm_angle = mo.angle + ANG1*90
		mo.mainarm_rollangle = 0
		mo.mainarm_zoff = 0	
		mo.shotgun = nil
		return
	end
	
	mo.shotgun = $+1
	
end


 
PSO.info.enemies[MT_PSO_GANNIL_SHOT] = {
		
		name = "Gannil Shot",
		sprite = SPR_NULL,
		frame = A,
		painframe = A,
		
		bhp = 650,
		satk = 20,
		ratk = 35,
		tatk = 20,
		def = 25,
		exp = 21,
		weight = 4,
		
		
		drops = {

			-- Lv1-50
			{650, 1, 50, 1, 15},
			{"burster", 1, 200, 1, 20},
			{"alva burster", 1, 200, 1, 35},
			{"vita burster", 1, 200, 1, 40},
			{"orakl rifle", 1, 200, 1, 55},	
			{"fehler frame", 1, 200, 1, 50},
			{"hart frame", 1, 200, 1, 55},
			{"monomate", 1, 50, 1, 35},
			{"dimate", 1, 200, 1, 35},
			{"trimate", 1, 200, 1, 35},

			{"makel frame", 51, 79, 1, 100},
			{"crimson frame", 51, 79, 1, 100},
			{"full cylinder", 51, 79, 1, 100},
			{"assassin", 51, 79, 1, 100},
			{"yasminkov 3000r", 51, 79, 1, 250},
			{"strauss", 51, 79, 1, 250},
			
		},
		
		stagger_duration = TICRATE/2,
		
		attribute = ATTR_HARBINGER,
		weakness = ELEM_DARK,
		weakness2 = ELEM_ELEC,
		
		reset =	function(mo)
			if not mo.pso.blowdown
				mo.momz = 0
			end
		end,
		
		thinker = function(mo)
			
			local diff = PSO.lib.questDifficulty()


			PSO.lib.enemyManageAggro(mo)
			PSO.lib.enemySetCorruption(mo)
			
			if not mo.elements
				spawn_elements(mo)
			end
			update_elements(mo)
			
			if mo.leaping
				
				if P_IsObjectOnGround(mo)
					mo.leaping = nil
					P_InstaThrust(mo, 0,0)
				end
				
				if mo.target and mo.target.valid
					mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
					mo.body_angle = mo.angle
				end
				
				return
			end
			
			if mo.target and mo.target.valid
				
				/*if mo.swordswing
					do_swordswing(mo)
					return
				end*/
				
				if mo.normalshot
					do_normalshot(mo)
					return
				end
				
				if mo.shotgun
					do_shotgun(mo)
					return
				end
				
				mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
				mo.body_angle = mo.angle
				P_InstaThrust(mo, mo.angle, mo.scale*3/2)
				
				mo.idletimer = $ and $+1 or 1
				
				if mo.idletimer > TICRATE*4

					
					local dist = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
					local diffcheck = diff >= DIFF_HARD
					
					mo.idletimer = 0
					
					if dist < mo.scale*512
						
						if diffcheck and P_RandomRange(0, 2) == 0
							
							mo.z = $+1
							
							mo.leaping = true
							mo.momz = mo.scale*5
							P_InstaThrust(mo, mo.angle, -mo.scale*32)
							prep_normalshot(mo, 1)
							
							return
						end
						
						prep_shotgun(mo)
						
					else
						
						prep_normalshot(mo, diffcheck and 3 or 1)
						
					end
				end
			end

			if PSO.lib.enemyPitCheck(mo)
				P_InstaThrust(mo, 0, 0)
			end
			
		end,
}