/*
	
*/

freeslot("MT_PSO_GANNIL_SLASH", "S_PSO_GANNIL_DEATH")
freeslot("MT_PSO_OVERGRANTS")
mobjinfo[MT_PSO_OVERGRANTS] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16<<FRACBITS,
	height = 16<<FRACBITS,
	flags = MF_NOGRAVITY,
}

local function debris(mo)
	mo.rollangle = $ + (mo.rolldir and -1 or 1)*ANG1*8
	if leveltime & 1
		mo.flags2 = $ | MF2_DONTDRAW
	else
		mo.flags2 = $ & ~MF2_DONTDRAW
	end
	mo.tics = 2
end

local function randmom(mo)
	if not mo or not mo.valid return end

	if not mo.extravalue2
		mo.renderflags = $ & ~(RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_NOSPLATROLLANGLE)
		mo.momx = P_RandomRange(-7, 7)*FRACUNIT
		mo.momy = P_RandomRange(-7, 7)*FRACUNIT
		mo.momz = P_RandomRange(-7, 7)*FRACUNIT
		mo.rolldir = P_RandomRange(0, 1)
		mo.tics = TICRATE/2
		mo.extravalue2 = 1
	else
		debris(mo)
	end
end

function A_GannilDie(mo)
	
	if not mo.extravalue2
		
		local g = P_SpawnGhostMobj(mo.halo)
		g.destscale = FRACUNIT*8
		g.scalespeed = $*4
		
		mo.extravalue2 = 1
		mo.cusval = TICRATE/2
	end
	
	randmom(mo.head)
	randmom(mo.elements[2])
	randmom(mo.elements[3])
		
	for i = 1, 4
		randmom(mo.diamonds[i])
	end
		
	for i = 1, 2
		randmom(mo.legs[i])
	end
		
	randmom(mo.mainarm)
	randmom(mo.offarm)
	
	mo.cusval = $-1
	
	if leveltime%4 == 0
		local rx = mo.x + P_RandomRange(-48, 48)*mo.scale
		local ry = mo.y + P_RandomRange(-48, 48)*mo.scale
		local rz = mo.z + P_RandomRange(16, 128)*mo.scale
		
		for i = 1, 16
			
			local t = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			t.color = i & 1 and SKINCOLOR_WHITE or SKINCOLOR_MASTER
			t.fuse = 11
			t.destscale = 1
			t.momx = P_RandomRange(-32, 32)*FRACUNIT
			t.momy = P_RandomRange(-32, 32)*FRACUNIT
			t.momz = P_RandomRange(-32, 32)*FRACUNIT
			
		end
		
		S_StartSound(mo, sfx_cdfm28)
		S_StartSound(mo, sfx_cdfm36)
	end
	
	if not mo.cusval
		P_RemoveMobj(mo)
	end
end

states[S_PSO_GANNIL_DEATH] = {SPR_NULL, A, 1, A_GannilDie, 0, 0, S_PSO_GANNIL_DEATH}

addHook("MobjThinker", function(mo)
	
	if not mo.target or not mo.target.valid or not P_CheckSight(mo, mo.target)
		P_RemoveMobj(mo)
		return
	end
	
	mo.extravalue1 = $-1
	
	if mo.extravalue1 == 1
		
		for i = 1, 8
			local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SUPERSPARK)
			s.colorized = true
			s.color = SKINCOLOR_TAN
			s.angle = 360/8*i*ANG1
			P_InstaThrust(s, s.angle, FRACUNIT*32)
		end

		for i = 1, 16
			local s = P_SpawnMobj(mo.x + P_RandomRange(-32, 32)*mo.scale, mo.y + P_RandomRange(-32, 32)*mo.scale, mo.z, MT_SUPERSPARK)
			s.colorized = true
			s.color = SKINCOLOR_TAN
			s.momz = P_RandomRange(4, 32)*FRACUNIT
		end
		
		local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 355<<FRACBITS, 580<<FRACBITS, mo.target, mo.pso.potency, DMT_TECHNIQUE, 4, RT_BLOWDOWN)
		hb.pso.element = mo.pso.element
		hb.pso.potency = mo.pso.potency
		
		S_StartSound(mo, sfx_s3k9f)
		mo.fuse = TICRATE/2
	end
	
end, MT_PSO_OVERGRANTS)


spriteinfo[SPR_HRBG] = {
    pivot = {
		L = {x = 8, y = 16},
        M = {x = 8, y = 16},
		P = {x = 12, y = 16},
		O = {x = 35, y = 25},
		--N = {x = 8, y = 4},
    },
}

spriteinfo[SPR_HRB2] = {
    pivot = {
		L = {x = 8, y = 16},
        M = {x = 8, y = 16},
		P = {x = 12, y = 16},
		O = {x = 35, y = 25},
		--N = {x = 8, y = 4},
    },
}

mobjinfo[MT_PSO_GANNIL_SLASH] = {
	doomednum = 2703,
	spawnstate = S_INVISIBLE,
	deathstate = S_PSO_GANNIL_DEATH,
	spawnhealth = 1000,
	radius = 48<<FRACBITS,
	height = 120<<FRACBITS,
	flags = MF_ENEMY|MF_ENEMY|MF_SHOOTABLE,
}

local function spawn_elements(mo)
	
	local diff = PSO.lib.questDifficulty()
	local spr = diff >= DIFF_HARD and SPR_HRB2 or SPR_HRBG
	local bright = (diff >= DIFF_HARD and FF_FULLBRIGHT or 0)
	
	-- chest
	mo.elements = {}
	
	for i = 1, 2 --5
		local p = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		p.sprite = spr
		p.frame = (I+(i-1))--(F+(i-1))
		/*if i > 1 and i < 4
			p.renderflags = $ |(RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_NOSPLATROLLANGLE)
			P_CreateFloorSpriteSlope(p)	-- used for later
		else*/
			p.frame = $|FF_PAPERSPRITE|bright
		--end
		p.tics = -1
		--p.scale = $*3/2
		mo.elements[#mo.elements+1] = p
	end
	
	-- diamonds
	mo.diamonds = {}
	
	for i = 1, 4
		local p = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		p.sprite = spr
		p.frame = D|bright
		p.tics = -1
		mo.diamonds[#mo.diamonds+1] = p
	end
	
	-- legs
	mo.legs = {}
	
	for i = 1, 2
		local p = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		p.sprite = spr
		p.frame = K|FF_PAPERSPRITE|bright
		p.tics = -1
		mo.legs[#mo.legs+1] = p
		
	end
	
	local offarm = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	offarm.sprite = spr
	offarm.frame = N|FF_PAPERSPRITE|bright
	offarm.tics = -1
	mo.offarm = offarm
	P_CreateFloorSpriteSlope(offarm)
	
	local mainarm = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	mainarm.sprite = spr
	mainarm.frame = M|FF_PAPERSPRITE|bright
	mainarm.tics = -1
	mo.mainarm = mainarm
	P_CreateFloorSpriteSlope(mainarm)

	local head = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	head.sprite = spr
	head.frame = O|bright
	head.tics = -1
	head.renderflags = $ |(RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_NOSPLATROLLANGLE)
	P_CreateFloorSpriteSlope(head)
	mo.head = head
	
	local halo = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	halo.sprite = SPR_BFLW
	halo.frame = D|FF_ADD|FF_FULLBRIGHT
	halo.renderflags = $ |(RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_NOSPLATROLLANGLE)
	halo.color = SKINCOLOR_MASTER
	halo.tics = -1
	mo.halo = halo
	
	if diff >= DIFF_HARD
		mo.halo.flags2 = $|MF2_DONTDRAW
	end
	
	mo.body_angle = mo.angle
	mo.offarm_angle = mo.angle - ANG1*90
	mo.offarm_rollangle = 0
	mo.offarm_zoff = 0
	mo.mainarm_splat = {}
	
	mo.mainarm_angle = mo.angle + ANG1*90
	mo.mainarm_rollangle = ANG1*6
	mo.mainarm_zoff = 0
	mo.mainarm_splat = {}
end

/*
local cv_dist = CV_RegisterVar({
	name = "cv_hdist",
	defaultvalue = 8,
	PossibleValue = CV_Unsigned,
})

local cv_xy = CV_RegisterVar({
	name = "cv_xy",
	defaultvalue = 340,
	PossibleValue = CV_Unsigned,
})

local cv_za = CV_RegisterVar({
	name = "cv_za",
	defaultvalue = 80,
	PossibleValue = CV_Unsigned,
})

local cv_a = CV_RegisterVar({
	name = "cv_a",
	defaultvalue = 0,
	PossibleValue = CV_Unsigned,
})*/

local function update_elements(mo)
	
	local body_z = mo.z + FRACUNIT*160
	local body_angle = mo.body_angle --+ leveltime*ANG2
	
	/*local back = mo.elements[1]
	P_MoveOrigin(back, mo.x, mo.y, body_z)
	back.angle = body_angle + ANG1*90
	back.flags2 = $|MF2_DONTDRAW*/
	
	local chest_dist = 0	--cv_dist.value
	local chestx = mo.x --+ chest_dist*cos(body_angle)
	local chesty = mo.y --+ chest_dist*sin(body_angle)
	
	/*
	local sidex1 = chestx + 22*cos(body_angle-ANG1*90)
	local sidey1 = chesty + 22*sin(body_angle-ANG1*90)

	local sidex2 = chestx + 22*cos(body_angle+ANG1*90)
	local sidey2 = chesty + 22*sin(body_angle+ANG1*90)
	
	local positions = {
		
		-- chest, L
		{
			xy = -ANG1*40,	--cv_xy.value,
			o = {x=sidex1,y=sidey1,z=body_z},
			za = -ANG1*45,	--cv_za.value,
		},

		-- chest, R
		{
			xy = ANG1*40,	--cv_xy.value,
			o = {x=sidex2,y=sidey2,z=body_z},
			za = -ANG1*45,	--cv_za.value,
		},
	}
	
	-- top parts of the body
	for i = 1, #positions
		
		local index = i+1
		local p = mo.elements[index]
		local pos = positions[i]
		
		P_MoveOrigin(p, chestx, chesty, body_z)
		p.floorspriteslope.o = pos.o
		p.floorspriteslope.xydirection = pos.xy + body_angle
		p.floorspriteslope.zangle = pos.za
		p.rollangle = cv_za.value*ANG1	--InvAngle(body_angle)
		--p.angle = body_angle
		
	end*/

	
	-- top of head
	P_SetOrigin(mo.head, mo.x, mo.y, body_z + mo.scale*40)
	mo.head.floorspriteslope.o = {x=mo.x, y=mo.y, z= body_z + mo.scale*40}
	mo.head.floorspriteslope.xydirection = mo.angle
	mo.head.floorspriteslope.zangle = -ANG1*45
	mo.head.rollangle = mo.angle + ANG1*180
	mo.head.tics = 2
	
	if mo.leaping
	and leveltime & 1
		P_SpawnGhostMobj(mo.head)
	end

	P_MoveOrigin(mo.halo, mo.x, mo.y, body_z + mo.scale*80)
	mo.halo.angle = mo.angle + ANG1*90
	mo.halo.rollangle = $ + ANG1
	mo.halo.tics = 2
	
	-- bottom parts of the body
	chestx = mo.x + 10*cos(body_angle)
	chesty = mo.y + 10*sin(body_angle)	
	for i = 1, 2
		
		local p = mo.elements[i]
		
		P_MoveOrigin(p, chestx, chesty, body_z)
		p.angle = body_angle - (ANG1*(90+30))*(i==1 and 1 or -1)
		p.tics = 2
		if mo.leaping
		and leveltime & 1
			P_SpawnGhostMobj(p)
		end		
	end
	
	-- diamonds
	for i = 1, #mo.diamonds
		
		local a = body_angle + ANG1*90 + (i-1)*180*ANG1
		local z = body_z
		local dist = 32
		local p = mo.diamonds[i]
		
		if i > 2
			a = mo.angle + ANG1*90 + (i-1)*180*ANG1
			z = $ - mo.scale*64
			dist = 16
		end
		
		local x = mo.x + dist*cos(a)
		local y = mo.y + dist*sin(a)
		
		P_MoveOrigin(p, x, y, z)
		p.tics = 2
	end
	
	-- legs
	for i = 1, #mo.legs
		
		local p = mo.legs[i]
		local d = mo.diamonds[i+2]
		
		P_MoveOrigin(p, d.x, d.y, d.z-mo.scale*6)
		p.angle = mo.angle + ANG1*90 + (i-1)*180*ANG1
		p.rollangle = ANG1*5
		p.tics = 2
		if mo.leaping
		and leveltime & 1
			P_SpawnGhostMobj(p)
		end		
	end
	
	
	-- arms
	local names = {"mainarm", "offarm"}
	
	for i = 1, 2
	
		local d1 = mo.diamonds[i]
		local index = names[i]
		local splat = mo[index.."_splat"]
		local zhelp = 0
		if not splat or not splat.o
			zhelp = 64*sin(mo[index.."_rollangle"])
		end
		zhelp = $ + mo[index.."_zoff"]
		
		P_MoveOrigin(mo[index], d1.x, d1.y, d1.z - 8*mo.scale + zhelp)
		
		mo[index].angle = mo[index.."_angle"]
		mo[index].rollangle = mo[index.."_rollangle"]
		
		if splat and splat.o
			mo[index].floorspriteslope.o = splat.o
			mo[index].floorspriteslope.xydirection = splat.xy
			mo[index].floorspriteslope.zangle = splat.za
			mo[index].renderflags = $ |(RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_NOSPLATROLLANGLE)
			mo[index].frame = $ & ~FF_PAPERSPRITE
		else
			mo[index].renderflags = $ & ~(RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD|RF_NOSPLATROLLANGLE)
			mo[index].frame = $ |FF_PAPERSPRITE			
		end
		
		mo[index].tics = 2
		if mo.leaping
		and leveltime & 1
			P_SpawnGhostMobj(mo[index])
		end
		
	end
	
end

local function prep_overend(mo)
	mo.overend = 1
	S_StartSound(mo, sfx_s3k5a)
end



local function prep_swordswing(mo)
	mo.swordswing = 1
	S_StartSound(mo, sfx_s3k60)
end



local function sword_trail(mo, pos, prevswordpos)
	
	local spr = SPR_HRBG
	local frame = P
	local steps = 5
	local tr = FF_ADD
	
	for i = 0, steps
							
		local x = PSO.lib.lerp(mo.x + FixedMul(prevswordpos[1], mo.scale), mo.x + FixedMul(pos[2], mo.scale), FRACUNIT/steps *i)
		local y = PSO.lib.lerp(mo.y + FixedMul(prevswordpos[2], mo.scale), mo.y + FixedMul(pos[3], mo.scale), FRACUNIT/steps *i)
		local z = PSO.lib.lerp(mo.z + FixedMul(prevswordpos[3], mo.scale), mo.z + FixedMul(pos[4], mo.scale), FRACUNIT/steps *i)
		local a = PSO.lib.lerp(prevswordpos[4], pos[6], FRACUNIT/steps *i)
							
		local trail = P_SpawnMobj(x, y, z - mo.scale*8, MT_THOK)
		
		if pos[7] and pos[7].use
			
			P_CreateFloorSpriteSlope(trail)
						
			trail.flags2 = $ | MF2_SPLAT
			trail.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
			trail.floorspriteslope.o = pos[7].o
			trail.floorspriteslope.xydirection = pos[7].xy
			trail.floorspriteslope.zangle = pos[7].za
						
			trail.sprite = spr
			trail.frame = frame|tr
			
			trail.angle = 0	
			trail.rollangle = a			
			--PSO.lib.fixSplatScale(trail)
			
		else
			trail.sprite = spr
			trail.frame = frame|tr|FF_PAPERSPRITE
			trail.angle = mo.angle
			trail.spritexscale = FRACUNIT
			trail.spriteyscale = FRACUNIT
			
			trail.rollangle = a
		end
		
		trail.tics = 10
		trail.fuse = 10						
	end
end

local function do_overend(mo)
	
	local windup = TICRATE/2
	local wait = TICRATE/4
	local swingtime = TICRATE/2
	
	if mo.overend == 1
		mo.mainarm_angle = mo.angle + ANG1*90
	end
	
	if mo.overend < windup
		
		mo.body_angle = $ - ANG1
		mo.mainarm_rollangle = $ + ANG1*10 + ANG1/2
		mo.mainarm_angle = $ - ANG1*4
		mo.mainarm_zoff = $ + FRACUNIT*3
		
	elseif mo.overend < windup+wait
		
		if mo.overend == windup
			local afteri = P_SpawnMobj(mo.mainarm.x, mo.mainarm.y, mo.mainarm.z, MT_THOK)
			afteri.sprite = SPR_HRBG
			afteri.frame = P|FF_FULLBRIGHT|FF_ADD|FF_PAPERSPRITE
			afteri.angle = mo.mainarm.angle
			afteri.rollangle = mo.mainarm.rollangle
			afteri.fuse = 8
			S_StartSound(mo, sfx_s3k9f)
		end
		
		if leveltime%4 == 0
			
			local afteri = P_SpawnMobj(mo.mainarm.x, mo.mainarm.y, mo.mainarm.z, MT_THOK)
			afteri.sprite = SPR_HRBG
			afteri.frame = P|FF_FULLBRIGHT|FF_ADD|FF_PAPERSPRITE
			afteri.angle = mo.mainarm.angle
			afteri.rollangle = mo.mainarm.rollangle
			afteri.fuse = 4
			afteri.destscale = $*4
			afteri.scalespeed = $*8
		end
		local s = P_SpawnMobj(mo.mainarm.x + P_RandomRange(-32, 32)*mo.scale, mo.mainarm.y + P_RandomRange(-32, 32)*mo.scale, mo.mainarm.z, MT_SUPERSPARK)
		s.momz = FRACUNIT*12
		s.colorized = true
		s.color = SKINCOLOR_TAN
	
	elseif mo.overend > windup+wait and mo.overend < windup+wait+swingtime
		
		local t = mo.overend - (windup+wait)
		mo.mainarm_angle = mo.angle - ANG1*10
		
		local newpos = {
			nil,	-- unused for enemies
			mo.mainarm.x-mo.x,
			mo.mainarm.y-mo.y,
			mo.mainarm.z-mo.z,
			mo.mainarm_angle,
			mo.mainarm_rollangle,
			{}
		}
		
		if mo.prevswordpos
			sword_trail(mo, newpos, mo.prevswordpos)
		end

		
		mo.prevswordpos = {
			mo.mainarm.x-mo.x,
			mo.mainarm.y-mo.y,
			mo.mainarm.z-mo.z,
			mo.mainarm_rollangle,
		}
		
		if t < 5
			mo.mainarm_zoff = $ - FRACUNIT*30
			mo.mainarm_rollangle = $ - ANG1*30
		end
		
		if t == 5
			
			if displayplayer and displayplayer.valid and displayplayer.mo and displayplayer.mo.valid
			and R_PointToDist2(mo.x, mo.y, displayplayer.mo.x, displayplayer.mo.y) < 2048*mo.scale
				P_StartQuake(FRACUNIT*40, 5)
			end
			S_StartSound(mo, sfx_s3k9b)
			
			local grants_potency = 400
			for i = 1, 32
				local dist = 64*i
				local x = mo.x + dist*cos(mo.angle)
				local y = mo.y + dist*sin(mo.angle)
				
				local msl = PSO.lib.spawnMissile(mo, MT_PSO_OVERGRANTS, 0, 0, grants_potency, DMT_TECHNIQUE, 0, 0, mo.height/2)
				P_SetOrigin(msl, x, y, mo.z)
				msl.extravalue1 = i*2 +1
			end
		end
		
	elseif mo.overend > windup+wait+swingtime

		mo.body_angle = mo.angle
		mo.offarm_angle = mo.angle - ANG1*90
		mo.mainarm_rollangle = 0
		mo.mainarm_zoff = 0	
		mo.overend = nil
		return
	end
	
	mo.overend = $+1
	
end

local function do_swordswing(mo)
	
	local windup = TICRATE/2
	local wait = TICRATE/4
	local swingtime = TICRATE/2
	local attack_potency = 400
	
	if mo.swordswing < windup
		
		mo.body_angle = $ + ANG1*4
		mo.mainarm_rollangle = $ + ANG1*7
		mo.mainarm_angle = $ + (ANG1*7)
		
	elseif mo.swordswing == windup
		
		local afteri = P_SpawnMobj(mo.mainarm.x, mo.mainarm.y, mo.mainarm.z, MT_THOK)
		afteri.sprite = SPR_HRBG
		afteri.frame = P|FF_FULLBRIGHT|FF_ADD|FF_PAPERSPRITE
		afteri.angle = mo.mainarm.angle
		afteri.rollangle = mo.mainarm.rollangle
		afteri.fuse = 8
		S_StartSound(mo, sfx_s3k9f)
		
		local g = P_SpawnGhostMobj(afteri)
		afteri.destscale = $*4
		afteri.scalespeed = $*8
	
	elseif mo.swordswing > windup+wait and mo.swordswing < windup+wait+swingtime
		
		local t = mo.swordswing - (windup+wait)
		local angleadd = ANG1*max(0, (70-(t*6)))
		
		if t == 5
			S_StartSound(mo, sfx_kc4d)
			local hx = mo.x + 256*cos(mo.angle)
			local hy = mo.y + 256*sin(mo.angle)
			local hb = PSO.lib.spawnHurtBox(hx, hy, mo.z, 455<<FRACBITS, 455<<FRACBITS, mo, attack_potency, DMT_STRIKE, 4, RT_BLOWDOWN)
			mo.hitbox = hb
			hb.angle = mo.angle
		end
		
		local newpos = {
			nil,	-- unused for enemies
			mo.mainarm.x-mo.x,
			mo.mainarm.y-mo.y,
			mo.mainarm.z-mo.z,
			mo.mainarm.angle,
			mo.mainarm.rollangle,
			mo.mainarm_splat
		}
		
		if mo.prevswordpos
			sword_trail(mo, newpos, mo.prevswordpos)
		end

		
		
		mo.prevswordpos = {
			mo.mainarm.x-mo.x,
			mo.mainarm.y-mo.y,
			mo.mainarm.z-mo.z,
			mo.mainarm_rollangle,
		}
		
		mo.mainarm_splat = {
			use=true,	-- this is a stupid hack but it's necessary for this
			o = {x= mo.x, y=mo.y, z=mo.mainarm.z},
			xy = mo.angle,
			za = -ANG1*30,
		}
		
		mo.mainarm_rollangle = mo.body_angle - ANG1*90
		
		mo.body_angle = $ - angleadd
		
		
	elseif mo.swordswing > windup+wait+swingtime

		mo.body_angle = mo.angle
		mo.offarm_angle = mo.angle - ANG1*90
		mo.mainarm_rollangle = 0
		mo.mainarm_zoff = 0	
		mo.mainarm_splat = {}
		mo.swordswing = nil
		return
	end
	
	mo.swordswing = $+1
	
end

PSO.info.enemies[MT_PSO_GANNIL_SLASH] = {
		
		name = "Gannil Slash",
		sprite = SPR_NULL,
		frame = A,
		painframe = A,
		
		bhp = 650,
		satk = 35,
		ratk = 30,
		tatk = 20,
		def = 25,
		exp = 30,
		weight = 4,
		
		
		drops = {

			-- Lv1-50
			{650, 1, 50, 1, 15},
			{"claymore", 1, 200, 1, 20},
			{"alva claymore", 1, 200, 1, 35},
			{"vita claymore", 1, 200, 1, 40},
			{"orakl sword", 1, 200, 1, 55},	
			{"fehler frame", 1, 200, 1, 50},
			{"hart frame", 1, 200, 1, 55},
			{"monomate", 1, 50, 1, 35},
			{"dimate", 1, 200, 1, 35},
			{"trimate", 1, 200, 1, 35},
			
			{"baston frame", 51, 79,1, 100},
			{"makel frame", 51, 79, 1, 100},
			{"crimson frame", 51, 79, 1, 100},
			{"steel hearts", 51, 79, 1, 100},
			{"seal case", 51, 79, 1, 100},
			{"zanba", 51, 79, 1, 200},
			{"last survivor", 51, 79, 1, 200},
		},
		
		stagger_duration = TICRATE/2,
		
		attribute = ATTR_HARBINGER,
		weakness = ELEM_DARK,
		weakness2 = ELEM_EARTH,
		
		reset =	function(mo)
			if not mo.pso.blowdown
				mo.momz = 0
			end
		end,
		
		thinker = function(mo)
			
			local diff = PSO.lib.questDifficulty()


			PSO.lib.enemyManageAggro(mo)
			PSO.lib.enemySetCorruption(mo)
			
			if not mo.elements
				spawn_elements(mo)
			end
			update_elements(mo)
			
			if mo.leaping
				
				if P_IsObjectOnGround(mo)
				or PSO.lib.enemyPitCheck(mo)
					mo.leaping = nil
					P_InstaThrust(mo, 0,0)
				end
				
				if mo.target and mo.target.valid
					mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
					mo.body_angle = mo.angle
				end
				
				return
			end
			
			if mo.target and mo.target.valid
				
				if mo.swordswing
					do_swordswing(mo)
					return
				end
				
				if mo.overend
					do_overend(mo)
					return
				end
				
				mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
				mo.body_angle = mo.angle
				P_InstaThrust(mo, mo.angle, mo.scale*3/2)
				
				mo.idletimer = $ and $+1 or 1
				
				if mo.idletimer > TICRATE*4
					
					local dist = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
					local diffcheck = diff >= DIFF_HARD
					
					mo.idletimer = 0
					
					if dist < mo.scale*512
						
						if diffcheck and P_RandomRange(0, 2) == 0
							
							mo.z = $+1
							if P_RandomRange(0, 1)
								local dir = P_RandomRange(0, 1) and ANG1*45 or -ANG1*45
								P_InstaThrust(mo, mo.angle + dir, mo.scale*32)
								mo.momz = mo.scale*2
								mo.leaping = true
								prep_swordswing(mo)
								
							else
							
								mo.leaping = true
								mo.momz = mo.scale*5
								P_InstaThrust(mo, mo.angle, -mo.scale*32)
								prep_overend(mo)
							end
							
							return
						end
						
						prep_swordswing(mo)
						
					else
						
						if diffcheck and P_RandomRange(0, 3) == 0 and dist < 2048*mo.scale

							P_InstaThrust(mo, mo.angle, mo.scale*32)
							mo.momz = mo.scale*5
							mo.leaping = true
							prep_swordswing(mo)
							
							return
						end
						
						prep_overend(mo)
						
					end
					
					--prep_swordswing(mo)
					--prep_overend(mo)
				end
				
			end
		end,
}