-- Jetty Syn Bomber
/*
	Floats and tries to maintain a constant distance to the player
	Every so often, leaps above the player to drop a bomb. It's easy to avoid but has high potency and leaves a lingering DoT.
	
	Corrupted: Megid ring!11!!!!
*/

PSO.info.enemies[MT_JETTBOMBER] = {
		
		name = "J.Syn Bomber",
		sprite = SPR_JETB,
		frame = A,
		painframe = A,
		
		bhp = 225,
		satk = 20,
		ratk = 30,
		tatk = 20,
		def = 25,
		exp = 11,
		weight = 1,
		
		
		drops = {

			-- Lv1-50
			{650, 1, 50, 1, 15},
			{"beamgun", 1, 50, 1, 30},
			{"alva beamgun", 1, 50, 1, 45},
			{"vita beamgun", 1, 50, 1, 60},
			{"rostig frame", 1, 50, 1, 20},		
			{"aileron frame", 1, 200, 1, 50},
			{"hart frame", 1, 200, 1, 205},
			{"monomate", 1, 50, 1, 35},
			{"dimate", 1, 50, 1, 35},
			{"trimate", 1, 50, 1, 35},
			
			{850, 51, 79, 1, 15},
			{"photon launcher", 51, 79,1, 250},
			{"saint kilda", 51, 79,1, 250},
			{"charge howzer", 51, 79, 1, 450},
			{"gur bazga", 51, 79, 1, 450},	
			
		},
		
		stagger_duration = TICRATE/2,
		
		attribute = ATTR_BADNIK,
		weakness = ELEM_ELEC,
		weakness2 = ELEM_ICE,
		
		reset =	function(mo)
			if not mo.pso.blowdown
				mo.flags = $|MF_NOGRAVITY
				mo.momz = 0
			end
		end,
		
		thinker = function(mo)
			
			local diff = PSO.lib.questDifficulty()
			local attack_potency = 600
			local targetz = mo.floorz + mo.scale*32
			local rate = FRACUNIT*8/10

			local melee_dist = FRACUNIT*384
			local charge_visual_speed = 10
			local speed_closein = FRACUNIT*10
			
			local waittime = diff >= DIFF_HARD and TICRATE*5/2 or TICRATE*4

			if mo.spawnz == nil
				mo.spawnz = mo.z 
			end
			
			if mo.spawnz - targetz > FRACUNIT*320
				targetz = mo.spawnz + mo.scale*32
			end

			PSO.lib.enemyManageAggro(mo)
			PSO.lib.enemySetCorruption(mo)
			
			mo.flags = $ & ~(MF_FLOAT|MF_NOGRAVITY)
			
			if not mo.jump
				if mo.z < targetz
					mo.momz = $ + rate
				elseif mo.momz < 0
					mo.momz = min(-mo.scale, $ + rate*2)
				end
			end
			
			if mo.msl and mo.msl.valid
				if P_IsObjectOnGround(mo.msl)
					-- spawn lingering attack!

					local fire = P_SpawnMobj(mo.msl.x, mo.msl.y, mo.msl.floorz, MT_PSO_VIPERAFTERLASER)
					fire.colorized = true
					fire.color = SKINCOLOR_ORANGE
					fire.pso = {}
					fire.target = mo
					for k,v in pairs(mo.msl.pso)
						fire.pso[k] = v
					end
					
					fire.tics = TICRATE*10
					
					if mo.pso.corrupted
						local megid_potency = 200
							
						for i = 1, 16
							local msl = PSO.lib.spawnMissile(mo, MT_PSO_MEGID_ENEMY, mo.angle, 4*FRACUNIT, megid_potency, DMT_TECHNIQUE, 0, 0, mo.height/2, RT_NONE)
							P_SetOrigin(msl, mo.msl.x, mo.msl.y, mo.msl.z)
							P_InstaThrust(msl, 360/16*i*ANG1, FRACUNIT*4)
							msl.fuse = TICRATE*10
							msl.pso.element = ELEM_DARK
						end	
						
						fire.color = SKINCOLOR_MASTER
					end
					
					P_KillMobj(mo.msl)
					mo.msl = nil
					
				end
			end
			
			if mo.target and mo.target.valid
				-- do different actions depending on how far the player is
				
				if mo.jump
					
					mo.jump = $+1

					if (mo.jump == TICRATE or R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y) < 96*FRACUNIT)
					and not mo.jumpdrop
					and not (mo.msl and mo.msl.valid)
						S_StartSound(mo, sfx_s3k51)

						local msl = PSO.lib.spawnMissile(mo, MT_MINE, 0, 0, attack_potency, DMT_RANGED, 0, 0, mo.height/2, RT_NONE)
						msl.flags = $ & ~(MF_NOCLIP|MF_NOCLIPTHING|MF_NOBLOCKMAP|MF_MISSILE)
						msl.radius = $*2
						mo.msl = msl
						msl.fuse = TICRATE
						
						mo.jumpdrop = true
						
					end
					
					if leveltime & 1
						P_SpawnGhostMobj(mo)
					end
					
					if P_IsObjectOnGround(mo)
						mo.jump = nil
						mo.rollangle = 0
						mo.waittimer = -TICRATE*2
						mo.superarmor = nil
						mo.jumpdrop = nil
					end
					
				else
					
					mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
					
					local dist = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
					
					local movespeed = (dist - melee_dist*3/4) / 96
					if movespeed < 0	-- make it faster when backpedalling
						movespeed = $*2
					end
					-- calculate movespeed based on distance to player
					-- clamp it between the target speeds
					movespeed = min($, speed_closein)
					movespeed = max($, -speed_closein)
					
					P_InstaThrust(mo, mo.angle, movespeed)	
					
					if dist < melee_dist*2
						mo.waittimer = $ and $+1 or 1
						
						if mo.waittimer > waittime
							mo.jump = 1
							P_InstaThrust(mo, mo.angle, 9*FRACUNIT)
							mo.momz = 12*FRACUNIT
							mo.superarmor = true	-- cancelling from here would be problematic
						end
					end
				end
			end

			if PSO.lib.enemyPitCheck(mo)
				P_InstaThrust(mo, 0, 0)
			end
			
			mo.sprite = SPR_JETB
			mo.frame = leveltime%4 /2
		end,
}