-- Popup Turret
/*
	Periodically pops in and out to shoot players.
	Bullets deal no knockback but travel quite fast.
	
	HARD MODE: Shoots 3 bullets instead of 1
	
	CORRUPTED: Shoots 2 Megids instead of 3 bullets
*/

PSO.info.enemies[MT_POPUPTURRET] = {
		
		name = "Turret",
		sprite = SPR_TURR,
		frame = A,
		painframe = I,
		
		bhp = 35,
		satk = 10,
		ratk = 25,
		tatk = 25,
		def = 5,
		exp = 2,
		weight = 4,
		
		attribute = ATTR_BADNIK,
		
		drops = {
			-- Lv 1-10
			{50, 1, 9, 1, 15},				-- meseta (100% mult) 2/5 (Lv1-10)
			{"sword", 1, 9, 1, 100},		-- sword: 	1/100 (Lv1-10)
			{"rifle", 1, 9, 1, 100},		-- rifle: 	1/100 (Lv1-10)
			{"rod", 1, 9, 1, 100},			-- rod: 	1/100 (Lv1-10)
			{"beam", 1, 9, 1, 100},
			{"launcher", 1, 9, 1, 100},
			{"bomber", 1, 9, 1, 100},
			
			{"monomate", 1, 9, 1, 25},	-- monomate: 1/5 (Lv1-10)
			
			-- Lv10-19
			
			{100, 10, 19, 1, 15},
			{"gigush", 10, 19, 1, 100},
			{"beam", 10, 19, 1, 100},
			{"cane", 10, 19, 1, 100},
			{"monomate", 10, 19, 1, 25},
			{"laser", 10, 19, 1, 100},
			{"bomber", 10, 19, 1, 100},
			{"tagvalve", 10, 19, 1, 100},			

			-- Lv20-29
			{150, 20, 29, 1, 15},
			{"breaker", 20, 29, 1, 150},
			{"doublegladius", 20, 29, 1, 150},
			{"laser", 20, 29, 1, 75},
			{"tagvalve", 10, 19, 1, 75},
			{"canon", 20, 29, 1, 150},
			{"ulrod", 20, 29, 1, 150},
			{"burster", 20, 29, 1, 100},
			{"dimate", 20, 29, 1, 25},

			-- Lv30-50
			{200, 30, 50, 1, 15},
			{"shooter", 30, 50, 1, 50},
			{"grenade", 30, 50, 1, 50},
			{"alva shooter", 30, 50, 1, 100},
			{"alva grenade", 30, 50, 1, 50},
			{"vita shooter", 30, 50, 1, 150},
			{"vita grenade", 30, 50, 1, 50},
			{"dimate", 30, 50, 1, 35},

			-- Lv51-70
			{550, 51, 200,1, 15},
			{"vita peacekeeper", 51, 79,1, 60},
			{"makel frame", 51, 79, 1, 700},
			{"crimson frame", 51, 79, 1, 1000},
			{"yasminkov 2000h", 51, 79, 1, 600},
			{"sarcueid", 51, 79, 1, 600},
			{"bravace", 51, 79, 1, 900},
			{"varista", 51, 79, 1, 900},			
			{"rostig frame", 51, 79,1, 50},
			{"fehler frame", 51, 79,1, 100},
			{"dimate", 51, 79 ,1, 35},
			
		},
		
		thinker = function(mo)
			
			local diff = PSO.lib.questDifficulty()
			local attack_potency = 150
			local delay = mo.mtangle or TICRATE*2
			local numbullets = diff > DIFF_NORMAL and 3 or 1
			
			local frame = A

			PSO.lib.enemySetCorruption(mo)
			if mo.pso.corrupted
				numbullets = 2
			end
			
			if mo.pso.shifta
				delay = $*7/10
			end
			
			PSO.lib.enemyManageAggro(mo)
			
			if mo.target and mo.target.valid
				if mo.shooting
					
					frame = min(I, mo.shooting)
					mo.shooting = $+1
					mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
					
					for i = 1, numbullets
						if mo.shooting == TICRATE-10 + (i-1)*10
							S_StartSound(mo, sfx_trfire)
							
							if not mo.pso.corrupted
								local cond
								local rate
								if diff >= DIFF_HARD
									cond = COND_SHOCK
									rate = 10
								end
								
								local msl = PSO.lib.spawnMissile(mo, MT_JETTBULLET, mo.angle, 30*FRACUNIT, attack_potency, DMT_RANGED, 0, 0, mo.height/2, RT_NONE, cond, rate)
								PSO.lib.aimMissile(msl, mo.target)
								msl.flags = $ & ~(MF_NOCLIP|MF_NOCLIPTHING|MF_NOBLOCKMAP)
							else
								local msl = PSO.lib.spawnMissile(mo, MT_PSO_MEGID_ENEMY, mo.angle, 8*FRACUNIT, attack_potency*2/3, DMT_TECHNIQUE, 0, 0, mo.height/2, RT_NONE)
								PSO.lib.aimMissile(msl, mo.target)
								msl.pso.element = ELEM_DARK
								msl.flags = $ & ~(MF_NOCLIP|MF_NOCLIPTHING|MF_NOBLOCKMAP)							
							end
						end
					end
					
					if mo.shooting > TICRATE*3/2 + (numbullets-1)*10
						local t = mo.shooting - (TICRATE*3/2 + (numbullets-1)*10)
						frame = max(A, I-t)
						
						if not frame
							mo.shooting = nil
							mo.delay = nil
						end
					end
				
				elseif not mo.delay
					mo.delay = delay
				else
					mo.delay = $-1
					
					if not mo.delay
						mo.shooting = 1
						S_StartSound(mo, sfx_s3k64)
					end
				end
			end
			
			mo.sprite = SPR_TURR
			mo.frame = frame
			
		end,
}