-- Red Crawla
/*
	Drives towards players.
	Once close enough, attempt to charge with a quick charge that closes the gap. Has a cooldown.
	
	HARD MODE: Charges attack faster
	
	CORRUPTED: Disappears at the end of the dash, becoming temporarily untargettable.
				Reappears once again after 1s and dashes again towards the target.
*/

PSO.info.enemies[MT_REDCRAWLA] = {
		
		name = "Red Crawla",
		sprite = SPR_SPOS,
		frame = A,
		painframe = A,
		
		bhp = 310,
		satk = 35,
		ratk = 20,
		tatk = 20,
		def = 25,
		exp = 8,
		weight = 1,
		
		
		drops = {
			-- Lv 1-10
			{100, 1, 9, 1, 15},				-- meseta (100% mult) 2/5 (Lv1-10)
			{"spear", 1, 9, 1, 90},
			{"launcher", 1, 9, 1, 90},	
			{"rod", 1, 9, 1, 100},			-- rod: 	1/100 (Lv1-10)
			{"lockgun", 1, 9, 1, 50},
			{"tcsm_crawla2", 4, 200, 1, 140},
			
			{"monomate", 1, 9, 1, 25},	-- monomate: 1/5 (Lv1-10)
			
			-- Lv10-19
			
			{200, 10, 19, 1, 15},
			{"gigush", 10, 19, 1, 100},
			{"pike", 10, 19, 1, 100},
			{"beam", 10, 19, 1, 100},
			{"bomber", 10, 19, 1, 100},
			{"cane", 10, 19, 1, 100},
			{"monomate", 10, 19, 1, 25},
			{"autogun", 10, 19, 1, 50},

			-- Lv20-29
			{300, 20, 29, 1, 15},
			{"breaker", 20, 29, 1, 150},
			{"doublegladius", 20, 29, 1, 150},
			{"laser", 20, 29, 1, 150},
			{"canon", 20, 29, 1, 150},
			{"ulrod", 20, 29, 1, 150},
			{"lance", 20, 29, 1, 150},
			{"tagvalve", 20, 29, 1, 150},
			{"peacekeeper", 20, 29, 1, 50},
			{"dimate", 20, 29, 1, 25},

			-- Lv30-50
			{650, 30, 50, 1, 15},
			{"claw", 30, 50, 1, 50},
			{"alva claw", 30, 50, 1, 75},
			{"vita claw", 30, 50, 1, 100},
			{"poss shooter", 30, 50, 1, 200},
			{"rostig frame", 30, 50, 1, 30},
			{"fehler frame", 30, 50, 1, 100},
			{"hart frame", 30, 50, 1, 250},
			{"dimate", 30, 50, 1, 35},

			{700, 30, 50, 1, 15},
			
			-- Lv51-70
			{900, 51, 200,1, 15},
			{"vita peacekeeper", 51, 79,1, 60},
			{"poss shooter", 51, 200,1, 150},
			{"tcsm_crawla4", 51, 79,1, 100},
			{"baston frame", 51, 79,1, 80},
			{"makel frame", 51, 79, 1, 700},
			{"crimson frame", 51, 79, 1, 700},
			{"full cylinder", 51, 79, 1, 200},
			{"assassin", 51, 79, 1, 200},
			{"yasminkov 3000r", 51, 79, 1, 450},
			{"strauss", 51, 79, 1, 450},			
			{"rostig frame", 51, 79,1, 30},
			{"fehler frame", 51, 79,1, 60},
			{"dimate", 51, 79 ,1, 35},
			
		},
		
		stagger_duration = TICRATE/2,
		
		attribute = ATTR_BADNIK,
		weakness = ELEM_ICE,
		weakness2 = ELEM_ELEC,
		
		reset = function(mo)
			mo.actiontimer = nil
			mo.attackcooldown = TICRATE
		end,
		
		thinker = function(mo)
			
			local diff = PSO.lib.questDifficulty()
			
			local attack_potency = 250
			local move_speed = mo.scale*(diff >= DIFF_HARD and 4 or 3)
			local attack_range = mo.scale*356
			local attack_charge = diff >= DIFF_HARD and TICRATE*2/3 or TICRATE
			local attack_duration = TICRATE
			local attack_delay = TICRATE
			local attack_speed = mo.scale*50
			local anim_speed = 1

			if mo.pso.shifta
				move_speed = $*12/10	-- +20% movement speed w shifta
			end
			
			PSO.lib.enemySetCorruption(mo)
			
			PSO.lib.enemyManageAggro(mo)
			
			mo.sprite = SPR_SPOS
			mo.frame = A
			
			if mo.teleportwait
				
				mo.teleportwait = $-1

				mo.flags2 = $|MF2_DONTDRAW
				mo.flags = $|MF_NOCLIPTHING|MF_NOBLOCKMAP
				
				if not mo.teleportwait
					
					mo.flags2 = $ & ~MF2_DONTDRAW
					mo.flags = $ & ~(MF_NOCLIPTHING|MF_NOBLOCKMAP)
							
					for i = 1, 16
						local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SUPERSPARK)
						s.colorized = true
						s.color = SKINCOLOR_MASTER
						s.momx = P_RandomRange(-32, 32)*mo.scale
						s.momy = P_RandomRange(-32, 32)*mo.scale
						s.momz = P_RandomRange(-32, 32)*mo.scale
					end	
					
					if mo.target and mo.target.valid
						A_FaceTarget(mo)
						mo.actiontimer = attack_charge -1
					end
				end
				return
			end
			
			if mo.target and mo.target.valid
				
				if not mo.actiontimer
					A_FaceTarget(mo)
					P_InstaThrust(mo, mo.angle, move_speed)
					
					mo.frame = (leveltime%(anim_speed*6)) /anim_speed
					
					-- wait for a cooldown
					if mo.attackcooldown
						mo.attackcooldown = $-1
					elseif R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y) < attack_range
						mo.actiontimer = 1
						S_StartSound(mo, sfx_spndsh)
					end
				else
					mo.actiontimer = $+1
					
					if mo.actiontimer < attack_charge
						if mo.actiontimer % 10 == 0
							S_StartSound(mo, sfx_spndsh)
						end
						
						mo.teleported = false
						
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
						dust.angle = mo.angle + ANG1*180 + P_RandomRange(-30, 30)*ANG1
						P_InstaThrust(dust, dust.angle, P_RandomRange(8, 16)*FRACUNIT)
						dust.momz = P_RandomRange(4, 8)*FRACUNIT
						
					
					elseif mo.actiontimer == attack_charge
						mo.superarmor = true
						P_InstaThrust(mo, mo.angle, attack_speed)
						S_StartSound(mo, sfx_zoom)

						local hx = mo.x + 64*cos(mo.angle)
						local hy = mo.y + 64*sin(mo.angle)
						
						local hb = PSO.lib.spawnHurtBox(hx, hy, mo.z, 80<<FRACBITS, 40<<FRACBITS, mo, attack_potency, DMT_STRIKE, attack_duration, RT_KNOCKBACK)
						mo.hitbox = hb
						hb.angle = mo.angle
						hb.pso.reactionstrength = 80
						
					end
					
					if mo.actiontimer >= attack_charge
					and mo.actiontimer < attack_charge + attack_duration
						if mo.hitbox and mo.hitbox.valid
							local hx = mo.x + 64*cos(mo.angle)
							local hy = mo.y + 64*sin(mo.angle)
							
							P_MoveOrigin(mo.hitbox, hx, hy, mo.z)
						end
						
						P_SpawnGhostMobj(mo)
					
					elseif mo.actiontimer >= attack_charge + attack_duration
					
						if mo.pso.corrupted
						and not mo.teleported
							
							mo.teleported = true
							
							mo.momx = 0
							mo.momy = 0
							mo.flags2 = $|MF2_DONTDRAW
							mo.flags = $|MF_NOCLIPTHING|MF_NOBLOCKMAP
							
							for i = 1, 16
								local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SUPERSPARK)
								s.colorized = true
								s.color = SKINCOLOR_MASTER
								s.momx = P_RandomRange(-32, 32)*mo.scale
								s.momy = P_RandomRange(-32, 32)*mo.scale
								s.momz = P_RandomRange(-32, 32)*mo.scale
							end
							
							mo.teleportwait = TICRATE
							
							return
						end
					
						mo.momx = $*94/100
						mo.momy = $*94/100
					
						if FixedHypot(mo.momx, mo.momy) < move_speed
							mo.superarmor = nil
							mo.actiontimer = 0
							mo.attackcooldown = TICRATE*5
						end
					end
				end
				
				if PSO.lib.enemyPitCheck(mo)
					P_InstaThrust(mo, 0, 0)
				end
			end
		end,
		
}
