-- Spring SHell
/*
	Drives towards players.
	Once they get close enough, charge for 1/4th of a second and lunge forward at higher speed, ending in lag
	Tethers to every enemy close to itself.
	As long as it is tethered, set def to 9999999
	
	HARD MODE: Tethered allies periodically receive Deband
*/


PSO.info.enemies[MT_SPRINGSHELL] = {
		
		name = "Spring Shell",
		sprite = SPR_SSHL,
		frame = A,
		painframe = A,
		
		bhp = 250,
		satk = 30,
		ratk = 20,
		tatk = 20,
		def = 30,
		exp = 15,
		weight = 4,
		
		
		drops = {
			
			-- Lv 1-10
			{100, 1, 9, 1, 15},				-- meseta (100% mult) 2/5 (Lv1-10)
			{"sword", 1, 9, 1, 100},		-- sword: 	1/100 (Lv1-10)
			{"rifle", 1, 9, 1, 100},		-- rifle: 	1/100 (Lv1-10)
			{"rod", 1, 9, 1, 100},			-- rod: 	1/100 (Lv1-10)
			{"lockgun", 1, 9, 1, 100},
			
			{"monomate", 1, 9, 1, 25},	-- monomate: 1/5 (Lv1-10)
			
			-- Lv10-19
			
			{200, 10, 19, 1, 15},
			{"gigush", 10, 19, 1, 100},
			{"beam", 10, 19, 1, 100},
			{"cane", 10, 19, 1, 100},
			{"monomate", 10, 19, 1, 25},
			{"autogun", 10, 19, 1, 100},

			-- Lv20-29
			{300, 20, 29, 1, 15},
			{"breaker", 20, 29, 1, 150},
			{"doublegladius", 20, 29, 1, 150},
			{"laser", 20, 29, 1, 150},
			{"canon", 20, 29, 1, 150},
			{"ulrod", 20, 29, 1, 150},
			{"peacekeeper", 20, 29, 1, 100},
			{"dimate", 20, 29, 1, 25},

			-- Lv30-50
			{500, 30, 50, 1, 15},
			{"peacekeeper", 30, 50, 1, 50},
			{"alva peacekeeper", 30, 50, 1, 100},
			{"vita peacekeeper", 30, 50, 1, 150},
			{"rostig frame", 30, 50, 1, 60},
			{"fehler frame", 30, 50, 1, 200},
			{"hart frame", 30, 50, 1, 500},
			{"dimate", 30, 50, 1, 35},
			
			-- Lv51-60
			{550, 51, 200,1, 15},
			{"vita peacekeeper", 51, 200,1, 60},
			{"baston frame", 51, 200,1, 500},
			{"makel frame", 51, 200,1, 4000},
			{"hart frame", 30, 50, 1, 200},
			{"rostig frame", 51, 200,1, 30},
			{"fehler frame", 51, 200,1, 80},
			{"dimate", 51, 200,1, 35},
			
		},
		
		stagger_duration = TICRATE/2,
		
		attribute = ATTR_BADNIK,
		weakness = ELEM_FIRE,
		weakness2 = ELEM_LIGHT,
		
		reset =	function(mo)
			mo.actiontimer = 0	-- reset action if we get staggered etc.
			mo.outranged = 0
		end,
		
		deathfunc = function(mo)
			
			local coords = mo.pso.pitcoords
			
			local s = P_SpawnMobj(coords[1], coords[2], coords[3], MT_YELLOWSPRING)
			s.flags = $ & ~MF_NOGRAVITY
			s.momz = FRACUNIT*8
			
			for i = 1, 16
				local d = P_SpawnMobj(coords[1], coords[2], coords[3], MT_SPINDUST)
				d.momx = P_RandomRange(-16, 16)*FRACUNIT
				d.momy = P_RandomRange(-16, 16)*FRACUNIT
				d.momz = P_RandomRange(-16, 16)*FRACUNIT
			end
		end,
		
		thinker = function(mo)
			
			local diff = PSO.lib.questDifficulty()
			
			local attack_potency = 250
			local move_speed = mo.scale*3/2 * (diff >= DIFF_HARD and 2 or 1)
			local attack_range = mo.scale*80
			local attack_charge = TICRATE/2
			local attack_delay = TICRATE
			local attack_speed = mo.scale*14
			local anim_speed = 3 
			
			local shoot_wait = TICRATE*5
			local shoot_charge = TICRATE*3/4
			local shoot_knockback = TICRATE*3/4
			
			
			if mo.pso.shifta
				move_speed = $*12/10	-- +20% movement speed w shifta
			end
			
			PSO.lib.enemySetCorruption(mo)
			--mo.pso.corrupted = true
			
			PSO.lib.enemyManageAggro(mo)
			
			mo.sprite = SPR_SSHL
			mo.frame = A
			mo.savedef = $ or mo.pso.def
			
			-- tether stuff
			-- gain a def boost when enemies are nearby
			local range = 768*FRACUNIT	
			local x1 = mo.x - range*2
			local x2 = mo.x + range*2
			local y1 = mo.y - range*2
			local y2 = mo.y + range*2
			local tethers = {}

			local function search(ref, found)
				
				if found and (found.flags & (MF_ENEMY|MF_SHOOTABLE)) and found.type ~= MT_PLAYER
				
					if PSO.info.enemies[found.type]
					and found.pso
					and not found.pso.boss	-- do not tether to bosses
					and found ~= ref
					and found ~= MT_SPRINGSHELL
					and abs(found.z - mo.z) < 256*mo.scale
						tethers[#tethers+1] = found
					end
				end
			end
			
			searchBlockmap("objects", search, mo, x1, x2, y1, y2)	
			
			if #tethers
				-- basically make me invincible
				mo.pso.def = 999999
				
				for i = 1, #tethers
					
					local t = tethers[i]
					
					if leveltime & 1
						local s = P_SpawnMobj(t.x, t.y, t.z, MT_SUPERSPARK)
						s.colorized = true
						s.color = SKINCOLOR_BLUE
						s.momx = (mo.x - t.x)/10
						s.momy = (mo.y - t.y)/10
						s.momz = (mo.z - t.z)/10
					end
					
					if diff >= DIFF_HARD	
						if not t.pso.deband
							PSO.lib.addDeband(t, TICRATE*15)
						end
					end
					
				end
				
			else
				mo.pso.def = mo.savedef
			end
			
			if mo.prevhp and mo.prevhp > mo.pso.hp and #tethers		
				local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				s.sprite = SPR_FORC
				s.frame = A|FF_ADD
				s.destscale = FRACUNIT*8
				s.scalespeed = FRACUNIT/7
				s.fuse = 16
				s.tics = s.fuse
			end
			
			mo.prevhp = mo.pso.hp
			
			if mo.target and mo.target.valid
				
				if not mo.actiontimer
					A_FaceTarget(mo)
					P_InstaThrust(mo, mo.angle, move_speed)
					
					mo.frame = (leveltime%(anim_speed*3)) /anim_speed
					
					--print(mo)
					if R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y) < attack_range
						mo.actiontimer = 1
						mo.outranged = 0
						S_StartSound(mo, sfx_spndsh)
					end

				elseif mo.actiontimer
					mo.actiontimer = $+1
					
					if mo.actiontimer == attack_charge
						P_InstaThrust(mo, mo.angle, attack_speed)
						S_StartSound(mo, sfx_zoom)
						
						local hx = mo.x + 64*cos(mo.angle)
						local hy = mo.y + 64*sin(mo.angle)
						
						local hb = PSO.lib.spawnHurtBox(hx, hy, mo.z, 80<<FRACBITS, 40<<FRACBITS, mo, attack_potency, DMT_STRIKE, 3, RT_STAGGER)
						hb.angle = mo.angle
						P_InstaThrust(hb, hb.angle, attack_speed)
						
					elseif mo.actiontimer > attack_charge
					and mo.actiontimer < attack_delay
						mo.momx = $*98/100
						mo.momy = $*98/100
					
					elseif mo.actiontimer >= attack_delay
						mo.actiontimer = 0
					end
				end
				
				if PSO.lib.enemyPitCheck(mo)
					P_InstaThrust(mo, 0, 0)
				end
				
			end
		end,	
}

--print("Best test: "..PSO.lib.findBestEnemyDrop(MT_BLUECRAWLA, 40))