-- Unidus
/*
	When near players, tries to stay near them to continuously hurt them.
	When afar, throws their balls periodically until they run out
*/

addHook("MobjSpawn", function(mo)
	return true	-- override normal behaviour
end, MT_UNIDUS)

freeslot("MT_PSO_UNIBALL", "S_PSO_UNIBALL")
mobjinfo[MT_PSO_UNIBALL] = {
	
	doomednum = -1,
	spawnstate = S_PSO_UNIBALL,
	flags = MF_NOGRAVITY|MF_MISSILE,
	height = 48<<FRACBITS,
	radius = 24<<FRACBITS,
	spawnhealth = 1000,
}

states[S_PSO_UNIBALL] = {SPR_UNID, B, -1, nil, 0, 0, S_PSO_UNIBALL}

addHook("MobjThinker", function(mo)
	
	mo.angle = $ + ANG1*10
	if leveltime & 1
		P_SpawnGhostMobj(mo)
	end
end, MT_PSO_UNIBALL)

PSO.info.enemies[MT_UNIDUS] = {
		
		name = "Unidus",
		sprite = SPR_UNID,
		frame = A,
		painframe = A,
		
		bhp = 300,
		satk = 40,
		ratk = 40,
		tatk = 10,
		def = 25,
		exp = 8,
		weight = 4,
		
		
		drops = {
			{300, 1, 29, 1, 15},
			{"breaker", 1, 29, 1, 150},
			{"doublegladius", 1, 29, 1, 150},
			{"laser", 1, 29, 1, 150},
			{"canon", 1, 29, 1, 150},
			{"ulrod", 1, 29, 1, 150},
			{"dimate", 1, 29, 1, 25},
			{"tcsm_unidus", 1, 200, 1, 75},

			-- Lv30-50
			{650, 30, 50, 1, 15},
			{"scepter", 30, 50, 1, 50},
			{"alva scepter", 30, 50, 1, 75},
			{"vita scepter", 30, 50, 1, 100},
			{"asterod", 30, 50, 1, 200},
			{"rostig frame", 30, 50, 1, 30},
			{"fehler frame", 30, 50, 1, 100},
			{"permafrost frame", 51, 200,1, 250},
			{"hart frame", 30, 50, 1, 300},
			{"digrinder", 30, 50, 1, 25},
			{"dimate", 30, 50, 1, 35},	

			{700, 50, 79, 1, 15},
			{"vita scepter", 51, 200,1, 50},
			{"asterod", 51, 200,1, 100},
			{"permafrost frame", 51, 200,1, 100},
			{"baston frame", 51, 79,1, 80},
			{"makel frame", 51, 79, 1, 700},
			{"crimson frame", 51, 79, 1, 700},
			{"windmill", 51, 79, 1, 200},
			{"hexigraph", 51, 79, 1, 200},
			{"serdote", 51, 79, 1, 400},
			{"rose quartz", 51, 79, 1, 400},
			{"rostig frame", 51, 200,1, 30},
			{"fehler frame", 51, 200,1, 80},
			{"dimate", 51, 200,1, 35},	
			
		},
		
		stagger_duration = TICRATE/2,
		
		attribute = ATTR_BADNIK,
		weakness = ELEM_EARTH,
		weakness2 = ELEM_DARK,
		
		reset =	function(mo)
			if not mo.pso.blowdown
				mo.flags = $|MF_NOGRAVITY
				mo.momz = 0
			end
		end,
		
		thinker = function(mo)
			
			local diff = PSO.lib.questDifficulty()
			
			local ball_potency = 70
			local ball_throw_potency = 220
			
			local targetz = mo.floorz + mo.scale*12
			local rate = FRACUNIT*8/10
			
			local numballs = (diff >= DIFF_HARD and 6 or 3)
			
			local distance_threshold = 768
			local ballthrow_wait = TICRATE*2

			if mo.spawnz == nil
				mo.spawnz = mo.z 
			end
			
			if mo.spawnz - targetz > FRACUNIT*320
				targetz = mo.spawnz + mo.scale*32
			end
			
			mo.sprite = SPR_UNID
			mo.frame = A
			
			PSO.lib.enemyManageAggro(mo)
			PSO.lib.enemySetCorruption(mo)
			
			mo.flags = $ & ~(MF_FLOAT|MF_NOGRAVITY)
			
			if not mo.spawnedballs
				
				mo.balls = {}
				local angdiff = (360 / numballs) *ANG1
				for i = 1, numballs
					
					local ball = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
					ball.angle = mo.angle + angdiff*i
					ball.tics = -1
					ball.fuse = -1
					ball.sprite = SPR_UNID
					ball.frame = B
					mo.balls[#mo.balls+1] = ball
				end
				
				mo.spawnedballs = true
			end
			
			if mo.balls and #mo.balls
				
				local ball_dist = 64
				local hitboxes = {}
				
				for i = 1, #mo.balls do
					
					local ball = mo.balls[i]
					local bx = mo.x + ball_dist*cos(ball.angle)
					local by = mo.y + ball_dist*sin(ball.angle)
					
					P_MoveOrigin(ball, bx, by, mo.z)
					
					ball.angle = $ + ANG1*2
					ball.tics = 2
					
					if mo.pso.corrupted
						ball.sprite = SPR_MEGD
						ball.frame = (leveltime%32 /2)|TR_TRANS20|FF_SUBTRACT|FF_FULLBRIGHT
						ball.color = SKINCOLOR_MASTER					
					end
					
					if leveltime % 10 == 0
						
						local hb = PSO.lib.spawnHurtBox(bx, by, mo.z, 40<<FRACBITS, 40<<FRACBITS, mo, ball_potency, DMT_STRIKE, 2, RT_NONE, COND_POISON, 5)
						hitboxes[#hitboxes+1] = hb
					end
				end
				
				for i = 1, #hitboxes
					hitboxes[i].pso.links = hitboxes	-- make sure they don't all hurt us at once
				end
			end
			
			if mo.target and mo.target.valid
				local dist = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
				mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
				
				P_InstaThrust(mo, mo.angle, FRACUNIT*(diff >= DIFF_HARD and 4 or 2))
				
				if dist > distance_threshold*FRACUNIT
					mo.waittimer = $ and $+1 or 1
					
					if mo.waittimer > ballthrow_wait
						
						if mo.balls and #mo.balls
							
							local ball = mo.balls[#mo.balls]


							if not mo.pso.corrupted
								local msl = PSO.lib.spawnMissile(mo, MT_PSO_UNIBALL, mo.angle, 20*FRACUNIT, ball_throw_potency, DMT_RANGED, 0, 0, 0)
								P_MoveOrigin(msl, ball.x, ball.y, ball.z)
								msl.angle = R_PointToAngle2(msl.x, msl.y, mo.target.x, mo.target.y)
								P_InstaThrust(msl, msl.angle, FRACUNIT*20)
								
								PSO.lib.aimMissile(msl, mo.target)

							else
								local msl = PSO.lib.spawnMissile(mo, MT_PSO_MEGID_ENEMY, mo.angle, 15*FRACUNIT, ball_throw_potency/2, DMT_TECHNIQUE, 0, 0, mo.height/2, RT_NONE)
								P_MoveOrigin(msl, ball.x, ball.y, ball.z)
								msl.angle = R_PointToAngle2(msl.x, msl.y, mo.target.x, mo.target.y)
								P_InstaThrust(msl, msl.angle, FRACUNIT*15)
								msl.fuse = TICRATE*10
								msl.pso.element = ELEM_DARK
								
								PSO.lib.aimMissile(msl, mo.target)
							end
							
							P_RemoveMobj(ball)
							mo.balls[#mo.balls] = nil
						end
						
						mo.waittimer = 0
					end
				else
					mo.waittimer = 0
				end
				
			end
			
			if mo.z < targetz
				mo.momz = $ + rate
			elseif mo.momz < 0
				mo.momz = min(-mo.scale, $ + rate*2)
			end

			if PSO.lib.enemyPitCheck(mo)
				P_InstaThrust(mo, 0, 0)
			end
			
		end,
}