freeslot("MT_PSO_NPC", "MT_PSO_NPC_INTERACT")

mobjinfo[MT_PSO_NPC] = {
	
	doomednum = 2602,
	spawnstate = S_PLAY_STND,
	spawnhealth = 1000,
	flags = MF_SOLID,
	radius = 32<<FRACBITS,
	height = 64<<FRACBITS,
}

mobjinfo[MT_PSO_NPC_INTERACT] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT,
	radius = 64<<FRACBITS,
	height = 64<<FRACBITS,
}

-- this is for NPCs that open menus. This is defined locally because we don't wanna mess with these.
local npc_menu_names = {
	
	"QUEST COUNTER",
	"TYPE COUNTER",
	"TEKKER",
	"SHOP",
	"STORAGE",
	"MEDBAY",
	"CAFE"
}

local npc_menus = {
	"quest_map",
	"type",
	"tekker",	--"tekker",
	"shop",
	"storage",
	"heal",
	"cafe",
}

-- this is for NPCs with actual dialogue.
-- To avoid having to modify every map, NPCs have an offset relative to the MEDBAY NPC.
-- yes, this is A SHITTY ASS HACK. But I don't want to paste object layouts for every single map lmao.
PSO.info.NPCData = {
	
	["ogi"] = {
		name = "Ogi",
		skin = "metalsonic",
		type = TYPE_RANGER,
		color = SKINCOLOR_WHITE,
		offset = {3364, 944, 0},
		angle = ANG1*270,
		weapon = "shotgun",	-- weapon on their backs.
		
		-- generic lines unrelated to quest progression status.
		generictext = {
			"I think the Ranger Type is best for beginners while also having a lot of room for growth, you got all your bases covered with Rifles, Shotguns and Launchers!",
			"If you're having trouble keeping up with your ranged weapons' Photon usage, try using a melee weapon like a Saber too.",
			"Eventful day as always...",
		},
	},

	["alis"] = {
		name = "Alis",
		skin = "sonic",
		color = SKINCOLOR_PINK,
		offset = {5280, 96, 0},
		type = TYPE_HUNTER,
		angle = ANG1*270,
		weapon = "saber",	-- weapon on their backs.
		weapon2 = "handgun",
		
		-- generic lines unrelated to quest progression status.
		generictext = {
			"It can't ever hurt to be well prepared for a mission...",
			"There are tough enemies out here, best to be prepared...",
			"Watch yourself out here.",
			"Sabers are great, they allow you to move so freely compared to these heavy swords. Plus, you can even carry a backup weapon like a handgun.",
		},
	},

	["ursula"] = {
		name = "Ursula",
		skin = "amy",
		color = SKINCOLOR_MIDNIGHT,
		offset = {2626, 2224, 0},
		type = TYPE_FORCE,
		angle = 0,
		weapon = "wand",	-- weapon on their backs.
		weapon2 = "handgun",
		
		-- generic lines unrelated to quest progression status.
		generictext = {
			"There's a lot of Techniques to choose from... So it's not a bad idea to have multiple Wands or Rods on you.",
			"No matter your Type, having something to cast support Techniques for yourself is a good idea.",
			"This Cafe not only provides us with food, but the owners are good with equipment too. If you find unusual weapons, you can bring them here.",
		},
	},

	["lumia"] = {
		name = "Lumia",
		skin = "tails",
		color = SKINCOLOR_BLUEBELL,
		offset = {1824, -448, 0},
		type = TYPE_FORCE,
		angle = 0,
		weapon = "rod",
		
		-- generic lines unrelated to quest progression status.
		generictext = {
			"Not many people know this, but Techniques cast by a Rod are stronger than those cast by other Technique weapons which will instead cast them faster.",
			"Wether Techniques build or break Chain depends on where you assign them on your weapon. The first and fourth slots will build chains whereas other slots will break it!",
			"If you ever have trouble getting your hands on new Techniques, you can always check the item shop, they sometimes update their supply.",
		},
	},

	["flowen"] = {
		name = "Flowen",
		skin = "knuckles",
		color = SKINCOLOR_MARINE,
		offset = {2416, 688, 0},
		type = TYPE_HUNTER,
		angle = ANG1*120,
		weapon = "sword",
		
		-- generic lines unrelated to quest progression status.
		generictext = {
			"It isn't enough to just swing your sword around, try to position yourself in an advantageous position to strike multiple targets at once if you can.",
			"Melee weapons typically leave you vulnerable after you finish attacking, but don't just stand there, dodge away to minimize that window!",
			"Even an adept swordmaster such as I must admit that having a ranged weapon is a great help for some situations, so don't neglect that equipment.",
		},
	},

	["bernie"] = {
		name = "Bernie",
		skin = "fang",
		color = SKINCOLOR_BLUE,
		offset = {2688, -1280, 0},
		type = TYPE_RANGER,
		angle = ANG1*90,
		weapon = "rifle",
		
		-- generic lines unrelated to quest progression status.
		generictext = {
			"Going on a quest today?",
			"Need something?",
		},
	},

	["lukot"] = {
		name = "Lukot",
		skin = "metalsonic",
		color = SKINCOLOR_LEMON,
		offset = {272, -1120, 0},
		type = TYPE_HUNTER,
		angle = 0,
		weapon = "doublesaber",
		
		-- generic lines unrelated to quest progression status.
		generictext = {
			"Feeling alright? Make sure to take a rest every once in a while...",
			"I'm not the best at fighting, so I sometimes hang here and assist the wounded.",
			"I may not be great at fighting, but double sabers make quick work of whatever is threatening my teammates.",
		},
	},

	["sue"] = {
		name = "Sue",
		skin = "tails",
		color = SKINCOLOR_PURPLE,
		offset = {3807, -960, 0},
		type = TYPE_HUNTER,
		angle = ANG1*270,
		weapon = "doublesaber",
		
		-- generic lines unrelated to quest progression status.
		generictext = {
			"Not sure what kind of job I'm going to take today...",
			"Most of the quests today are just routine cleanup... I want something more exciting!",
			"Mhh? I'm busy trying to make a living here, go bother someone else!",
		},
	},

	["pharia"] = {
		name = "Pharia",
		skin = "sonic",
		color = SKINCOLOR_CLOUDY,
		offset = {2832, 3712, 0},
		type = TYPE_RANGER,
		angle = ANG1*90,
		weapon = "launcher",
		
		-- generic lines unrelated to quest progression status.
		generictext = {
			"Mh...? No, it's not too heavy.",
			"Launchers are slow, but one hit is usually all it takes.",
			"Mh...? No, I'm not hungry.",
		},
	},

	["garoa"] = {
		name = "Garoa",
		skin = "knuckles",
		color = SKINCOLOR_AQUAMARINE,
		offset = {-736, -1344, 0},
		type = TYPE_RHUNTER,
		angle = ANG1*120,
		weapon = "spear",
		
		-- generic lines unrelated to quest progression status.
		generictext = {
			"Ugh... I took a bad beating last time... That's what I get for thinking I can take it on all by myself...",
			"I'll be right as rain soon enough, maybe I'll show you how good I am with a spear when the time comes, too!",
		},
	},
	
}

local function setupNPC(mo, mt)
	mo.tics = -1
	mo.shadowscale = FRACUNIT/2

	
	-- Code courtesy of Sal
	-- Spawn followmobjs:
    if (skins[mo.skin].followitem > 0)
        local followitem = skins[mo.skin].followitem
        local followstate = mobjinfo[followitem].spawnstate

        if (followitem == MT_TAILSOVERLAY)
            -- Welp I wasn't expecting that
            followstate = S_TAILSOVERLAY_STAND
        end

        if (followstate != S_NULL)
            local a = mo.angle	--mt.angle * ANG1
            local followx = mo.x + P_ReturnThrustX(mo, a, -FRACUNIT)
            local followy = mo.y + P_ReturnThrustY(mo, a, -FRACUNIT)
            local followz = mo.z + 3*FRACUNIT
            local followmobj = P_SpawnMobj(followx, followy, followz, followitem)
            followmobj.angle = a
            followmobj.skin = mo.skin
            followmobj.color = mo.color

            followmobj.state = followstate

            mo.tracer = followmobj
            followmobj.tracer = mo
        end
    end	
	
	-- weapons?
	-- this is a half copypaste from the sheathe system for players, but more limited.
	-- animated weapons do NOT work here.
	if mo.weapon
		local weapons = {mo.weapon, mo.weapon2}
		
		for i = 1, #weapons
			local wp = weapons[i]
			--print(wp)
			
			if not wp continue end
			local info = PSO.lib.itemInfo(wp)
			
			local sheatheinfo = info.sheatheinfo or PSO.info.defaultSheathePosition[info.weapontype]
							
			-- update positions to sheathe the weapon:
			local sheatheangle
			if sheatheinfo[6] ~= nil then sheatheangle = sheatheinfo[6] else sheatheangle = mo.angle+ANG1*180 end
							
			local x = sheatheinfo[1]*cos(mo.angle+sheatheangle)
			local y = sheatheinfo[2]*sin(mo.angle+sheatheangle)
			local z = FixedDiv(mobjinfo[MT_PLAYER].height*sheatheinfo[3]/100, mo.scale)
											
			local wps = P_SpawnMobj(mo.x+x, mo.y+y, mo.z+z, MT_THOK)
			wps.tics = -1
			wps.sprite = info.sprite
			wps.frame = info.frame|FF_PAPERSPRITE
			wps.angle = mo.angle + sheatheinfo[4]
			wps.rollangle = sheatheinfo[5]
			wps.color = info.color or SKINCOLOR_NONE
		end
	end
end

addHook("MapThingSpawn", function(mo, mt)
	
	-- how many skins we got?
	local i = 0
	while skins[i] and skins[i].valid
		i = $+1
	end
		
	-- random NPC clerks handling
	-- these guys are set randomly from any skin currently loaded.
	local skinnum = P_RandomRange(0, i-1)
	mo.skin = skins[skinnum].name or "sonic"
	mo.color = P_RandomRange(1, SKINCOLOR_ROSY)	-- uuuuuh yeah that'll do lol
	mo.tics = -1
	mo.shadowscale = FRACUNIT/2
		
	local extrainfo
	if udmf
		extrainfo = mt.args[5]
	else
		extrainfo = mt.extrainfo
	end
		
	if extrainfo
		local x = mo.x + 128*cos(mt.angle*ANG1)
		local y = mo.y + 128*sin(mt.angle*ANG1)
		local it = P_SpawnMobj(x, y, mo.z, MT_PSO_NPC_INTERACT)
		it.target = mo
		mo.pso = {name = (npc_menu_names[extrainfo] or "INVALID"), subtext = "INTERACT"}
			
		-- this is a hack...
		if extrainfo == 6
			-- spawn all other NPCs...
			for k,v in pairs(PSO.info.NPCData)
					
				local npc = P_SpawnMobj(mo.x + v.offset[1]*FRACUNIT, mo.y + v.offset[2]*FRACUNIT, mo.z + v.offset[3]*FRACUNIT, MT_PSO_NPC)
				npc.setnpc = k
				npc.skin = v.skin
				npc.angle = v.angle
				npc.color = v.color
				npc.weapon = v.weapon
				npc.weapon2 = v.weapon2
				npc.pso = {name=v.name, subtext="TALK"}

				local it = P_SpawnMobj(npc.x, npc.y, npc.z, MT_PSO_NPC_INTERACT)
				it.target = npc
				
				setupNPC(npc)
					
			end
		end
			
	end

	setupNPC(mo, mt)
	
end, MT_PSO_NPC)

PSO.lib.NPCInteract = function(p, mo)
	p.pso.lastnpc = mo
	mo.timestalked = $ or 1
	
	if mo.setnpc	-- normal npc.
	and p == consoleplayer
		-- do NOT USE P_RANDOM HERE, EVER!!
		local txt = PSO.info.NPCData[mo.setnpc].generictext[mo.timestalked % #PSO.info.NPCData[mo.setnpc].generictext +1]
		
		-- are we undertaking a quest?
		local qinfo = PSO.lib.questInfo()
		if qinfo
			
			local index = 1
			-- is the quest completed?
			if server.questdata and server.questdata.complete
				index = 2
			end
			
			if qinfo.npcdialogue
			and qinfo.npcdialogue[mo.setnpc]
			and qinfo.npcdialogue[mo.setnpc][index]
				txt = qinfo.npcdialogue[mo.setnpc][index]
			end
		
		elseif mo.timestalked == 1
			-- use the clear text (index 2) of whatever campaign quest we last completed at random
			local myprog = PSO.lib.getLocalQuestProgress()
			--print(myprog)
			if myprog
				local q = PSO.info.quests[1].quests[myprog]
				
				if q and q.npcdialogue and q.npcdialogue[mo.setnpc] and q.npcdialogue[mo.setnpc][2]
					txt = q.npcdialogue[mo.setnpc][2]
				end
			end
		end
		
		PSO.lib.spawnChatBox(mo, mo.pso.name, txt)
		mo.timestalked = $+1
	else	-- clerk
	
		if npc_menus[mo.extrainfo]
			
			local menu = npc_menus[mo.extrainfo]
			if p.psologin
				PSO.lib.openMenu(p, menu or "")
			end

		elseif p == consoleplayer
			PSO.lib.spawnChatBox(mo, mo.pso.name, "Sorry, we aren't open yet! Come back at a later update!")
		end
	end
end