-- some visuals for the final map
freeslot("MT_PSO_PETALSPAWNER", "S_PSO_PETAL", "MT_PSO_COMETSPAWNER", "SPR_PFIN")

mobjinfo[MT_PSO_PETALSPAWNER] = {
	doomednum = 2538,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	flags = MF_NOGRAVITY,
	radius = 1,
	height = 1
}

states[S_PSO_PETAL] = {SPR_PFIN, B|FF_ANIMATE, -1, nil, 1, 4, S_PSO_PETAL}

mobjinfo[MT_PSO_COMETSPAWNER] = {
	doomednum = 2539,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	flags = MF_NOGRAVITY,
	radius = 1,
	height = 1
}

-- petal spawner:
-- angle = radius
-- special flag: spawn rocks instead of petals (used for DF fight background lmao)

addHook("MobjThinker", function(mo)
	
	local radius = mo.mtangle
		
	local x = mo.x + P_RandomRange(-radius, radius)*FRACUNIT
	local y = mo.y + P_RandomRange(-radius, radius)*FRACUNIT
	local p = P_SpawnMobj(x, y, mo.z, MT_THOK)
	
	if mo.options & 1	-- spawn ... rocks instead
		p.sprite = SPR_ROIG
		p.frame = A
		p.momz = P_RandomRange(FRACUNIT/2, FRACUNIT)
		p.fuse = P_RandomRange(6, 12)*TICRATE
		p.tics = p.fuse
		P_SetScale(p, P_RandomRange(FRACUNIT/6, FRACUNIT-1), true)
		p.rollangle = P_RandomRange(0, 359)*ANG1
		
		if mo.options & 4
			p.colorized = true
			p.color = SKINCOLOR_RED
			p.momz = $*4
		end
		
		local ps = R_PointInSubsector(p.x, p.y).sector
		local ss = ps.f_slope
		
		if ss
			local nz = P_GetZAt(ss, p.x, p.y)
			p.z = nz
		end
	else	-- actual spawn petals
		p.state = S_PSO_PETAL
		p.fuse = TICRATE*4
		P_InstaThrust(p, 0, P_RandomRange(2, 5)*FRACUNIT)
		p.momz = P_RandomRange(2, 4)*FRACUNIT
	end
end, MT_PSO_PETALSPAWNER)

-- meteor spawner
-- angle is the direction they'll go in, the radius is fixed
addHook("MobjThinker", function(mo)
	
	if leveltime%(mo.options & 1 and 10 or 20) == 0
		local dist = P_RandomRange(0, 2048)
		local m = P_SpawnMobj(mo.x+dist*cos(mo.angle), mo.y+dist*sin(mo.angle), mo.z, MT_THOK)
		m.sprite = SPR_PFIN
		m.frame = (mo.options & 1 and D or A)|FF_FULLBRIGHT
		m.angle = mo.angle
		P_InstaThrust(m, m.angle, FRACUNIT*24)
		m.momz = -FRACUNIT*24
		
		if not (mo.options & 1)
			m.fuse = TICRATE*3/4
		else
			m.scale = $*2
			m.fuse = TICRATE*4
		end
		m.tics = m.fuse
	end
end, MT_PSO_COMETSPAWNER)	