-- shows a barrier on linedefs tagged with IMPASSIBLE in sectors tagged 'barrier_tag'

local barrier_tag = 1455
local min_barrier_dist = 1536

local function doAISBarrier(p)
	local mo = p.mo
	
	if mo.subsector.sector and mo.subsector.sector.tag == barrier_tag
		local s = mo.subsector.sector
		
		if leveltime%8 == 0
			
			for i = 0, #s.lines -1	-- we love c arrays
				
				local l = s.lines[i]
				if l.flags & ML_IMPASSIBLE
					
					
					local px, py = P_ClosestPointOnLine(mo.x, mo.y, l)
					--P_SpawnMobj(px, py, mo.z, MT_THOK)
					
					if R_PointToDist2(mo.x, mo.y, px, py) < min_barrier_dist*FRACUNIT
						
						local a = R_PointToAngle2(l.v1.x, l.v1.y, l.v2.x, l.v2.y)
						
						local base_spawnx = px + 32*cos(a-ANG1*90)
						local base_spawny = py + 32*sin(a-ANG1*90)
						--P_SpawnMobj(base_spawnx, base_spawny, mo.z, MT_THOK)
						--P_MoveOrigin(mo, base_spawnx, base_spawny, mo.z)
						
						local dist = P_RandomRange(-256, 256)
						local real_spawnx = base_spawnx + dist*cos(a)
						local real_spawny = base_spawny + dist*sin(a)
						local real_spawnz = mo.z + P_RandomRange(-128, 128)*FRACUNIT
						
						local w = P_SpawnMobj(real_spawnx, real_spawny, real_spawnz, MT_PSO_LOBBYWINDOW)
						w.nopass = true
						w.color = SKINCOLOR_RED
						w.fuse = P_RandomRange(20, 50)
						w.angle = a
						
						-- only display for local player
						if p ~= consoleplayer
							w.flags2 = $|MF2_DONTDRAW
						end
						
					end
				end
			end
		end
	end
end

PSO.lib.registerPlayerFunc(doAISBarrier)