-- Mine Trap

-- Is invisible, materializes when the player gets near and explodes afterwards, dealing damage and inflicting the player with burn.

freeslot("MT_PSO_MINETRAP", "MT_PSO_MINE")
mobjinfo[MT_PSO_MINETRAP] = {
	doomednum = 2536,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 512<<FRACBITS,
	height = 256<<FRACBITS,
	flags = MF_NOGRAVITY|MF_SOLID,
}

mobjinfo[MT_PSO_MINE] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1,
	radius = 32<<FRACBITS,
	height = 64<<FRACBITS,
	flags = MF_NOGRAVITY,
}


local function minetrapCollide(mo1, mo2)
	
	if mo1 and mo1.valid and mo1.type == MT_PSO_MINETRAP
	and mo2 and mo2.valid and mo2.type == MT_PLAYER
		
		if mo1.tracer and mo1.tracer.valid and not mo1.extravalue1
			mo1.extravalue1 = 1
			mo1.tracer.frame = A
			mo1.tracer.momz = mo1.scale*32
			mo1.tracer.extravalue1 = TICRATE
		end
	end
	return false
end

addHook("MobjCollide", minetrapCollide, MT_PSO_MINETRAP)
addHook("MobjMoveCollide", minetrapCollide, MT_PSO_MINETRAP)

addHook("MobjDeath", function(mo)
	
	local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.floorz, 512<<FRACBITS, 512<<FRACBITS, mo, 10, DMT_STRIKE, TICRATE, RT_NONE)
	hb.pso.fixedpercent = true
	hb.pso.status = COND_BURN
	hb.pso.statuschance = 100
	hb.pso.statusduration = TICRATE*4

	for i = 1, 16
		local e = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SONIC3KBOSSEXPLODE)
		e.scale = mo.scale*3/2
		e.destscale = 1
		e.scalespeed = mo.scale/12
		e.momx = P_RandomRange(-32, 32)*mo.scale
		e.momy = P_RandomRange(-32, 32)*mo.scale
		e.momz = P_RandomRange(-32, 32)*mo.scale
	end
	
	S_StartSound(mo, sfx_foie)
	mo.sprite = SPR_NULL
	mo.tics = TICRATE
	return true
	
end, MT_PSO_MINE)

addHook("MobjThinker", function(mo)
	
	-- spawn mine
	if not mo.extravalue2
		
		local mine = P_SpawnMobj(mo.x, mo.y, mo.z + mo.scale*48, MT_PSO_MINE)
		mine.tics = -1
		mine.sprite = SPR_DETN
		mine.frame = A|TR_TRANS80
		mine.angle = mo.angle
		mine.pso = {name="Mine Trap"}
		
		mo.tracer = mine
		mo.extravalue2 = 1
	end
	
	-- from now on, if anything happens to our tracer, vanish.
	if not mo.tracer or not mo.tracer.valid
		P_RemoveMobj(mo)
		return
	end
	
	mo.tracer.momz = $/2
	if mo.tracer.extravalue1
		
		if mo.tracer.extravalue1 % 5 == 0
			S_StartSound(mo.tracer, sfx_deton)
		end
		
		mo.tracer.extravalue1 = $-1
		
		if not mo.tracer.extravalue1
			
			P_KillMobj(mo.tracer)
			P_RemoveMobj(mo)
		end
	end
	
end, MT_PSO_MINETRAP)