freeslot("MT_PSO_TURRET")

mobjinfo[MT_PSO_TURRET] = {
	doomednum = 2535,
	spawnstate = S_INVISIBLE,
	height = 40<<FRACBITS,
	radius = 40<<FRACBITS,
	spawnhealth = 1000,
	flags = 0,
}

local charge_visual_speed = 8


addHook("MobjThinker", function(mo)
	
	mo.sprite = SPR_TRET
	mo.frame = A
	mo.pso = {}
	
	-- death
	if mo.extravalue2
		local t = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		t.state = S_XPLD1
		S_StartSound(t, sfx_pop)
		P_RemoveMobj(mo)
		return
	end
	
	if mo.noshot
		mo.noshot = $-1
		return
	end
	
	local maxdelay = TICRATE*3
		
	-- find the closest player...
	local closestp
	local range = 4096*mo.scale
	
	for p in players.iterate
		local pmo = p.mo
		if not pmo or not pmo.valid continue end
		
		if not P_CheckSight(mo, pmo) continue end
		local dist = R_PointToDist2(mo.x, mo.y, pmo.x, pmo.y)
		
		if dist < range
			closestp = p
			range = dist
		end
	end
	
	if closestp and mo.firedelay
		local pmo = closestp.mo
		
		if mo.firedelay == maxdelay
			S_StartSound(mo, sfx_trpowr)
		end
		
		mo.firedelay = $-1
		
		if mo.firedelay > TICRATE/3
			local t = P_SpawnMobj(mo.x + P_RandomRange(-128, 128)*mo.scale, mo.y + P_RandomRange(-128, 128)*mo.scale, mo.z + P_RandomRange(-128, 128)*mo.scale, MT_THOK)
			t.tics = charge_visual_speed
			t.color = SKINCOLOR_RED
			t.frame = A|FF_ADD
			t.scale = mo.scale
			t.destscale = 1
			t.scalespeed = mo.scale/12
							
			t.momx = (mo.x - t.x)/charge_visual_speed
			t.momy = (mo.y - t.y)/charge_visual_speed
			t.momz = (mo.z - t.z)/charge_visual_speed
		end
		
		if leveltime & 1
			local s = P_SpawnMobj(pmo.x, pmo.y, pmo.z, MT_THOK)
			s.sprite = SPR_TARG
			s.frame = (leveltime%14)/2 |FF_FULLBRIGHT
			s.tics = 2	
			
			-- spawn a line between us and the target to help us know where harm is coming from
			PSO.lib.spawnLine(mo, pmo, 24)
		end
		PSO.lib.attackMarker(pmo.x, pmo.y, pmo.z + FRACUNIT*64, MARKER_SIGHT)
		
		
		if not mo.firedelay
			local fn = function(s)
				s.sprite = SPR_THOK
				s.frame = FF_FULLBRIGHT
				s.color = SKINCOLOR_RED
				s.destscale = 1
				s.scalespeed = FRACUNIT/12
				s.fuse = 12
				s.tics = 12
			end
			
			S_StartSound(mo, sfx_s3k54)
			S_StartSound(pmo, sfx_s3k54)
			
			PSO.lib.spawnLine(mo, pmo, 128, fn)
			
			local hb = PSO.lib.spawnHurtBox(pmo.x, pmo.y, pmo.z, 80<<FRACBITS, 40<<FRACBITS, mo, 30, DMT_RANGED, 3, RT_BLOWDOWN)
			hb.angle = R_PointToAngle2(mo.x, mo.y, pmo.x, pmo.y)	
			hb.pso.fixedpercent = true
			hb.pso.nododge = true
			
			mo.noshot = maxdelay/2
			mo.firedelay = maxdelay
		end
		
	else
		S_StopSound(mo)
		mo.firedelay = maxdelay
	end
	
end, MT_PSO_TURRET)