
PSO.info.items = {}

freeslot("SPR_SWD1", "SPR_RIF1", "SPR_ROD1")

rawset(_G, "HAND_BOTH", 0)
rawset(_G, "HAND_RIGHT", 2)
rawset(_G, "HAND_LEFT", 1)

-- list of available photon arts per weapon

local technique_list = {
	"foie",
	"gifoie",
	"rafoie",
	"safoie",
	"foverse",
	"shifta",
	"jellen",

	"barta",
	"gibarta",
	"rabarta",
	"sabarta",
	"nabarta",
	"deband",
	"zalure",
	
	"zonde",
	"gizonde",
	"razonde",
	"nazonde",
	"zondeel",
	
	"diga",
	"gidiga",
	"radiga",
	"nosdiga",
	"diverse",
	
	"grants",
	"gigrants",
	"ragrants",
	"ilgrants",
	"resta",
	
	"megid",
	"gimegid",
	"ramegid",
	"samegid",
	"ilmegid",
}
PSO.info.weaponPhotonArts = {
	
	[WPT_SWORD] = {
		"sword_normal",
		"sword_pa_spindrop",
		"sword_pa_extendcutter",
		"sword_pa_spiralbreak",
		"sword_pa_risingedge",
		"sword_pa_overend",
	},
	
	[WPT_RIFLE] = {
		"rifle_normal",
		"rifle_charge",
		"rifle_pa_piercinground",
		"rifle_pa_slideshot",
		"rifle_pa_skyfiresalvo",
		"rifle_pa_revoltaim",
	},
	
	--[WPT_ROD] = technique_list,
	
	[WPT_DOUBLESABER] = {
		"dsaber_normal",
		"dsaber_pa_deadlyarcher",
		"dsaber_pa_spinadvance",
		"dsaber_pa_tornadodance",
		"dsaber_pa_surprisedunk",
		"dsaber_pa_quickgash",
	},
	
	[WPT_SHOTGUN] = {
		"shotgun_normal",
		"shotgun_pa_zerodistance",
		"shotgun_pa_impactrecoil",
		"shotgun_pa_gloriousrain",
		"shotgun_pa_slugburst",
		"shotgun_pa_trickblast",
	},

	[WPT_SPEAR] = {
		"spear_normal",
		"spear_pa_assaultbuster",
		"spear_pa_millionskewer",
		"spear_pa_raptorthrow",
		"spear_pa_scythecleave",
		"spear_pa_bandersnatch",
	},

	[WPT_TWINSABERS] = {
		"dsaber_normal",
		"dsaber_pa_deadlyarcher",
		"dsaber_pa_spinadvance",
		"dsaber_pa_tornadodance",
	},	

	[WPT_LAUNCHER] = {
		"launcher_normal",
		"launcher_pa_divinelauncher",
		"launcher_pa_infernoquake",
		"launcher_pa_homerunhavoc",
		"launcher_pa_fallenimpact",
		"launcher_pa_feareraser",
	},

	[WPT_TWINHANDGUNS] = {
		"rifle_normal",
		"rifle_charge",
		"rifle_pa_piercinground",
		"rifle_pa_slideshot",
	},	
	
	[WPT_SABER] = {
		"saber_normal",
		"saber_pa_crushingleap",
		"saber_pa_ragedance",
		"saber_pa_strezwei",
	},
	
	[WPT_HANDGUN] = {
		"handgun_normal",
		"handgun_pa_charge",
		"handgun_pa_ricochet",
		"handgun_pa_homingshell",
	},
	
	/*[WPT_WAND] = {
		"wand_normal",
	},*/
	
	techniques = technique_list,
}

PSO.info.weaponDefaultActions = {
	
	[WPT_SWORD] = {
		"sword_normal",
		"sword_pa_spindrop",
	},
	
	[WPT_RIFLE] = {
		"rifle_normal",
		"rifle_charge",
	},
	
	[WPT_ROD] = {
		"barta",
		"foie",
		nil,
		"zonde",
		"diga",
	},
	
	[WPT_DOUBLESABER] = {
		"dsaber_normal",
		"dsaber_pa_deadlyarcher",
	},

	[WPT_SPEAR] = {
		"spear_normal",
		"spear_pa_assaultbuster",
	},	

	[WPT_TWINSABERS] = {
		"dsaber_normal",
		"dsaber_pa_deadlyarcher",
	},	

	[WPT_LAUNCHER] = {
		"launcher_normal",
		"launcher_pa_divinelauncher",
	},

	[WPT_TWINHANDGUNS] = {
		"rifle_normal",
		"rifle_charge",
	},	
	
	[WPT_SHOTGUN] = {
		"shotgun_normal",
		"shotgun_pa_zerodistance",
	},
	
	[WPT_SABER] = {
		"saber_normal",
		"saber_pa_crushingleap",
	},
	
	[WPT_HANDGUN] = {
		"handgun_normal",
		"handgun_pa_charge",
	},

	[WPT_TECHMAG] = {
		"barta",
		"foie"
	},
	
	[WPT_WAND] = {
		"barta",
		"foie",
		--"wand_normal",
	}
}

PSO.info.defaultSheathePosition = {
	
	[WPT_SWORD] = {
		16,	-- x (behind player)
		16,	-- y (behind player)
		100,	-- height % of player
		
		ANG1*90,	-- angle
		-ANG1*110,	-- rollangle	
		ANG1*180,	-- sheatheangle
	},
	
	[WPT_DOUBLESABER] = {
		16,
		16,
		70,
		
		ANG1*90,
		-ANG1*45,
		ANG1*180,	-- sheatheangle
	},

	[WPT_SPEAR] = {
		16,
		16,
		110,
		
		ANG1*90,
		ANG1*105,
		ANG1*180,	-- sheatheangle
	},

	[WPT_TWINSABERS] = {
		16,
		16,
		70,
		
		ANG1*90,
		-ANG1*45,
		ANG1*180,	-- sheatheangle
	},	
	
	[WPT_RIFLE] = {
		16,	-- x (behind player)
		16,	-- y (behind player)
		33,	-- height % of player
		
		ANG1*90,	-- angle
		ANG1*30,	-- rollangle
		ANG1*180,	-- sheatheangle
	},
	
	[WPT_SHOTGUN] = {
		16,	-- x (behind player)
		16,	-- y (behind player)
		33,	-- height % of player
		
		ANG1*90,	-- angle
		ANG1*30,	-- rollangle
		ANG1*180,	-- sheatheangle
	},	

	[WPT_LAUNCHER] = {
		16,	-- x (behind player)
		16,	-- y (behind player)
		33,	-- height % of player
		
		ANG1*90,	-- angle
		ANG1*30,	-- rollangle
		ANG1*180,	-- sheatheangle
	},

	[WPT_TWINHANDGUNS] = {
		16,	-- x (behind player)
		16,	-- y (behind player)
		33,	-- height % of player
		
		ANG1*90,	-- angle
		ANG1*30,	-- rollangle
		ANG1*180,	-- sheatheangle
	},
	
	[WPT_ROD] = {
		16,	-- x (behind player)
		16,	-- y (behind player)
		75,	-- height % of player
		
		ANG1*90,	-- angle
		ANG1*110,	-- rollangle
		ANG1*180,	-- sheatheangle
	},

	[WPT_SABER] = {
		16,	-- x (behind player)
		16,	-- y (behind player)
		50,	-- height % of player
		
		ANG1*90,	-- angle
		-ANG1*60,	-- rollangle	
		ANG1*180,	-- sheatheangle
	},

	[WPT_HANDGUN] = {
		24,	-- x (behind player)
		24,	-- y (behind player)
		50,	-- height % of player
		
		ANG1*90,	-- angle
		ANG1*30,	-- rollangle
		ANG1*180,	-- sheatheangle
	},

	[WPT_WAND] = {
		16,	-- x (behind player)
		16,	-- y (behind player)
		55,	-- height % of player
		
		ANG1*90,	-- angle
		ANG1*110,	-- rollangle
		ANG1*180,	-- sheatheangle
	},	

	[WPT_TECHMAG] = {
		24,	-- x (behind player)
		24,	-- y (behind player)
		130,	-- height % of player
		
		ANG1*0,	-- angle
		ANG1*0,	-- rollangle
		ANG1*120,	-- sheatheangle
	},	
	
}

-- default cast "art" for each weapon type
PSO.info.castArt = {
	[WPT_SWORD] = "rod_cast",
	[WPT_DOUBLESABER] = "rod_cast",
	[WPT_RIFLE] = "rod_cast",
	[WPT_SHOTGUN] = "rod_cast",
	[WPT_ROD] = "rod_cast",
	[WPT_SABER] = "wand_cast",
	[WPT_HANDGUN] = "rod_cast",
	[WPT_WAND] = "wand_cast",
	[WPT_TECHMAG] = "tmag_cast",
}

PSO.info.weaponHand = {
	[WPT_SWORD] = HAND_BOTH,
	[WPT_SPEAR] = HAND_BOTH,
	[WPT_DOUBLESABER] = HAND_BOTH,
	[WPT_TWINSABERS] = HAND_BOTH,
	[WPT_RIFLE] = HAND_BOTH,
	[WPT_SHOTGUN] = HAND_BOTH,
	[WPT_LAUNCHER] = HAND_BOTH,
	[WPT_TWINHANDGUNS] = HAND_BOTH,
	[WPT_ROD] = HAND_BOTH,
	[WPT_SABER] = HAND_RIGHT,
	[WPT_HANDGUN] = HAND_LEFT,
	[WPT_WAND] = HAND_RIGHT,
	[WPT_TECHMAG] = HAND_LEFT,
}

-- true if weapon should use techs
PSO.info.isTechWeapon = {
	[WPT_ROD] = true,
	[WPT_WAND] = true,
	[WPT_TECHMAG] = true,
}

PSO.lib.itemInfo = function(it)
	if type(it) == "string"
		return PSO.info.items[it] or PSO.info.items["noref"]
	elseif it
		return PSO.info.items[it.ref] or PSO.info.items["noref"]
	else
		return nil
	end
end

PSO.lib.itemPrice = function(it)
	local info = PSO.lib.itemInfo(it)
	
	if info.cost ~= nil
		return info.cost
	end
	
	if info.type == IT_WEAPON
		return it.atk*100*it.rarity/2
	
	elseif info.type == IT_ARMOR
		return it.def*100*it.rarity/2
	end
	
	return it.rarity*1000 or 1
end

-- In the context of getting a weapon or an armour, we need to create a new instance of it.
-- dta is an extra table:
-- edta[element, element value] for weapons and armours
PSO.lib.makeItem = function(it, edta, unidentified)
	
	local dta = PSO.info.items[it]
	
	-- oops
	if not dta
		print("\x82".."WARNING:".." Item "..it.." doesn't exist")
		return it
	end
	
	if dta.type == IT_WEAPON
		
		local ret = {}
		
		ret.type = dta.type
		ret.weapontype = dta.weapontype
		ret.rarity = dta.rarity
		ret.atk = dta.atk
		ret.req = dta.req
		
		ret.range = dta.range
		ret.angle = dta.angle
		
		ret.pa_cost = dta.pa_cost or 100
		ret.pa_damage = dta.pa_damage or 100
		ret.pa_cost_base = ret.pa_cost
		ret.pa_damage_base = ret.pa_damage
		
		ret.level = 1	
		ret.ref = it	-- keep a reference
		ret.element = edta and edta[1] or ELEM_FIRE
		ret.elementv = edta and edta[2] or 0
		ret.grind = 0
		ret.maxgrind = PSO.info.MAXGRIND
		
		if not edta
			if dta.elem
				ret.element = dta.elem
				ret.elementv = P_RandomRange(min(60, ret.rarity*5), min(60, ret.rarity*10))
			else
				ret.element = P_RandomRange(ELEM_FIRE, ELEM_DARK)
				ret.elementv = P_RandomRange(0, min(60, ret.rarity*10))
			end
		end
		
		ret.actions = {}
		local actionlist = PSO.info.weaponDefaultActions[dta.patype or ret.weapontype]
		
		for i = 1, #actionlist
			ret.actions[i] = actionlist[i]
		end
		
		ret.unidentified = unidentified
		
		return ret
	elseif dta.type == IT_ARMOR
		
		local ret = {}
		ret.type = dta.type
		ret.rarity = dta.rarity
		ret.def = dta.def
		ret.req = dta.req
		
		ret.slots = {}
		ret.ref = it	-- keep a reference
		ret.element = edta and edta[1] or ELEM_FIRE
		ret.elementv = edta and edta[2] or 0
		ret.grind = 0

		if not edta
			if dta.element
				ret.element = dta.element
			else
				ret.element = P_RandomRange(ELEM_FIRE, ELEM_DARK)
			end
			
			ret.elementv = P_RandomRange(0, min(60, ret.rarity*10))
		end
		
		return ret
	elseif dta.type == IT_UNIT
		local ret = {}
		for k, v in pairs(dta)
			if k == "desc" continue end
			ret[k] = v
		end
		
		ret.ref = it
		
		return ret
	end
	
	return it	-- the string is fine.
end

-- fixes a unit's stats in case of balance changes
PSO.lib.reloadUnit = function(it)
	local info = PSO.lib.itemInfo(it)
	if not info return end	-- do nothing, this is probably a modded item.
	
	it.hp = info.hp or 0
	it.pp = info.pp or 0
	it.satk = info.satk or 0
	it.ratk = info.ratk or 0
	it.tatk = info.tatk or 0
	it.ppregen = info.ppregen or 0
	it.actionspd = info.actionspd or 0
	it.critdamage = info.critdamage or 0
	it.critrate = info.critrate or 0
end

-- grind reference table.
-- gives how much increase each level should give per rarity...
PSO.lib.limitBreakGrindValues = {
	[20] = {
		16,
		15,
		14,
		13,
		12,
		11,
		9,
		6,
		3,
	}
	
}

-- calculates the intended stat an item should have.
PSO.lib.calcItemStat = function(it)
	
	local info = PSO.lib.itemInfo(it)
	if not info return end	-- do nothing, this is probably a modded item.
	
	local usestat = info.atk and "atk" or "def"
	
	local normalgrind = min(PSO.info.MAXGRIND, it.grind)
	it[usestat] = info[usestat] + normalgrind*(1 + (info.rarity-1)/3)
	
	-- limit break grind.
	if it.grind > PSO.info.MAXGRIND
		local currgrind = it.grind - PSO.info.MAXGRIND
		local addstat = PSO.lib.limitBreakGrindValues[it.maxgrind][info.rarity]
		if not addstat return end
		
		it[usestat] = $+currgrind*addstat
	end
end

-- Returns true if the armour has a valid unit setup or false if not.
-- this is to do with prototype units
PSO.lib.validateUnits = function(it)
	
	local slots = PSO.lib.itemInfo(it).slots
	
	if not slots or not it.slots return false end
	
	local proto = {}
	
	for i = 1, slots
		local slot = it.slots[i]
		
		if not slot continue end
		
		local slotinfo = PSO.lib.itemInfo(slot)
		if slotinfo.rarity > PSO.lib.itemInfo(it).rarity
		and PSO.info.items[it.ref]	-- leave modded items alone	
		
			slot.equippedarmours = $-1
			if not slot.equippedarmours
				slot.equipped = nil
			end
			
			print("ANTI CHEAT: Unit had to be removed for violating rarity restrictions")
			it.slots[i] = nil
			
		elseif slotinfo.proto
			
			-- 2 protos OR same proto...
			if #proto >= 2
			or proto[1] and slotinfo == PSO.lib.itemInfo(proto[1])
				-- !????
				slot.equippedarmours = $-1
				if not slot.equippedarmours
					slot.equipped = nil
				end
				
				print("ANTI CHEAT: Unit had to be removed for violating prototype restrictions")
				it.slots[i] = nil
				continue
			else
				proto[#proto+1] = slot
			end
		end
	end
end

PSO.lib.canUseProto = function(armour, unit)
		
	local uinfo = PSO.lib.itemInfo(unit)
	local ainfo = PSO.lib.itemInfo(armour)
	
	local slots = ainfo.slots
	
	if not slots or not armour.slots return false end
	if uinfo and not uinfo.proto return true end	-- this is fine!
	
	local proto
	
	-- first pass, this unit is already equipped in which case we're probably trying to remove it
	for i = 1, slots
		local slot = armour.slots[i]
		if slot == unit return true end
	end
	
	-- second pass, rules
	for i = 1, slots
		local slot = armour.slots[i]
		
		if not slot continue end
		
		local slotinfo = PSO.lib.itemInfo(slot)
			
		if slotinfo.proto
			
			if proto return false end	-- wtf we already have two!!
			
			proto = slot
			
			if slotinfo == uinfo
				return false
			end
		end
	end	
	
	return true
end

-- return true if it can be extended via extit
PSO.lib.canExtendItem = function(it, extit)
	local info = PSO.lib.itemInfo(it)
	local infoext = PSO.lib.itemInfo(extit)
	
	-- nope.
	if info.type ~= IT_WEAPON
		return false
	end
	
	-- nope.
	if info.rarity >= infoext.rarity
		return false
	end
	
	local grindattempt = infoext.extendmax or 10
	local currmaxgrind = it.maxgrind or PSO.info.MAXGRIND
	if currmaxgrind >= grindattempt
		return false
	end
	
	return true
end

PSO.lib.extendItem = function(it, extit)
	local infoext = PSO.lib.itemInfo(extit)
	if PSO.lib.canExtendItem(it, extit)
		it.maxgrind = infoext.extendmax
		it.equiplevel = infoext.extendlv
		return true
	end
	return false
end

PSO.lib.grindItem = function(it, grind_amount)
	local grindcount = 0
	if it.grind ~= nil
		for i = 1, (grind_amount or 1)
			if it.grind < (it.maxgrind or PSO.info.MAXGRIND)	
				it.grind = $+1
				PSO.lib.calcItemStat(it)
				
				grindcount = $+1
			end
		end
		
		return grindcount > 0
	end
	return false	-- couldn't grind
end

PSO.lib.getItemIcon = function(it)
	
	local info = PSO.lib.itemInfo(it)
	
	if info.icon
		return info.icon
	else
		
		if info.type == IT_WEAPON
			return "H_WICO"..PSO.info.weaponnums[(info.weapontype or 1)]
		else
			if info.type == IT_MATERIAL	
				return "H_IICOB"
			end
			return "H_IICO"..(info.type or 1)
		end
	end
end

PSO.lib.getItemName = function(it)
	
	if it.unidentified
		return "SPECIAL WEAPON?"
	elseif it.grind
		return PSO.lib.itemInfo(it).name.."+"..it.grind
	end
	
	return PSO.lib.itemInfo(it).name or "INVALID"
end	

PSO.info.weaponToIcon = {
	[WPT_SWORD] = "H_SWRD",
	[WPT_DOUBLESABER] = "H_DSABER",
	[WPT_RIFLE] = "H_RIFL",
	[WPT_SHOTGUN] = "H_SHOTG",
	[WPT_ROD] = "H_ROD",
	[WPT_SABER] = "H_SABR",
	[WPT_HANDGUN] = "H_HGUN",
	[WPT_WAND] = "H_WAND",
	[WPT_SPEAR] = "H_SPEAR",
	[WPT_TWINSABERS] = "H_TSABR",
	[WPT_LAUNCHER] = "H_LAUNCH",
	[WPT_TWINHANDGUNS] = "H_THGUN",
	[WPT_TECHMAG] = "H_TMAG",
	
}

PSO.info.weaponDamageType = {
	[WPT_SWORD] = DMT_STRIKE,
	[WPT_DOUBLESABER] = DMT_STRIKE,
	[WPT_RIFLE] = DMT_RANGED,
	[WPT_SHOTGUN] = DMT_RANGED,
	[WPT_ROD] = DMT_TECHNIQUE,
	[WPT_SABER] = DMT_STRIKE,
	[WPT_HANDGUN] = DMT_RANGED,
	[WPT_WAND] = DMT_TECHNIQUE,
	[WPT_SPEAR] = DMT_STRIKE,
	[WPT_TWINSABERS] = DMT_STRIKE,
	[WPT_LAUNCHER] = DMT_RANGED,
	[WPT_TWINHANDGUNS] = DMT_RANGED,
	[WPT_TECHMAG] = DMT_TECHNIQUE,	
}

PSO.info.weaponDesc = {
	[WPT_SWORD] = "Two handed melee weapon. Large sword that excels in crowd control while remaining powerful in single combat.",
	[WPT_DOUBLESABER] = "Two handed melee weapon. A fast double bladed saber that excels at building chains and single target combat.",
	[WPT_RIFLE] = "Two handed ranged weapon. A medium range firearm that excels at building chains in single target combat.",
	[WPT_SHOTGUN] = "Two handed ranged weapon. A close range firearm with a wide bullet spread that excels at taking on groups of enemies.",
	[WPT_ROD] = "Two handed technique weapon. Allows using a versatile, highly potent array of Techniques.",
	[WPT_SABER] = "Right handed melee weapon. Allows using fast flurries of slashes. It's less powerful than a sword but much faster.",
	[WPT_HANDGUN] = "Left handed ranged weapon. Less powerful but more efficient than a Rifle, it's great for medium range combat.",
	[WPT_WAND] = "Right handed technique weapon. Allows casting Techniques faster than Rods can, although they will be far less potent.",
	
	[WPT_SPEAR] = "Two handed melee weapon. A spear that excels at taking enemies in a line. It has powerful charged attacks.",
	[WPT_TWINSABERS] = "Two handed melee weapons. They attack quickly and can take on single targets or groups of enemies alike.",
	[WPT_LAUNCHER] = "Two handed ranged weapon. A heavy firearm that can fire explosives and beams from any range to decimate groups of enemies.",
	[WPT_TWINHANDGUNS] = "Two handed ranged weapons. Their high rate of fire allows you to unleash a never ending onslaught against single targets.",
	[WPT_TECHMAG] = "Left handed technique weapon. Allows casting low power Techniques extremely quickly, ideal for support Techniques!",
}