freeslot("SPR_SHTG", "sfx_sblst1", "sfx_sblst2")

-- 1star
PSO.info.items["shotgun"] = {
		
		name = "Shotgun",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 1,
		atk = 20,
		
		sprite = SPR_SHTG,
		frame = A,
		color = SKINCOLOR_FLAME,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 100,
		
		sound = sfx_sblst1,
		
		potential = "state of the art",
		
		desc = "Mass produced Shotgun. A good power with manageable recoil for beginners.",
		
}

-- 2 star
PSO.info.items["azul burst"] = {
		
		name = "Azul Burst",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 2,
		atk = 35,
		req = 4,
		
		elem = ELEM_ICE,
		
		sprite = SPR_SHTG,
		frame = L,
		color = SKINCOLOR_BLUE,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 100,
		
		sound = sfx_sblst1,
		
		potential = "lifespring",
		
		desc = "A shotgun made from mossy rock and water held together by photons. It radiates life.",
}

PSO.info.items["spread"] = {
		
		name = "Spread",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 2,
		atk = 35,
		req = 4,
		
		sprite = SPR_SHTG,
		frame = A,
		color = SKINCOLOR_BLUE,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 100,
		
		sound = sfx_sblst1,
		
		potential = "state of the art",
		
		desc = "An improved shotgun that can manage to fire more powerful shells with no change to its recoil.",
}

-- 3 star
PSO.info.items["exiled burst"] = {
		
		name = "Exiled Burst",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 3,
		atk = 45,
		req = 8,
		
		sprite = SPR_SHTG,
		frame = M,
		
		elem = ELEM_EARTH,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 100,
		
		sound = sfx_sblst1,
		
		potential = "firm stance",
		
		desc = "A Shotgun dating from the first Badnik invasion's futile attempts at resistance... It has been abandonned and left at the mercy of the harsh weather, damaging the barrels.",
}

PSO.info.items["canon"] = {
		
		name = "Cannon",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 3,
		atk = 45,
		req = 8,
		
		sprite = SPR_SHTG,
		frame = A,
		color = SKINCOLOR_MINT,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 100,
		
		sound = sfx_sblst1,
		
		potential = "state of the art",
		
		desc = "The original shotgun model pushed to its limit, it's incredibly powerful for how cheap it is to manufacture.",
}

-- 4 star
PSO.info.items["boreal burst"] = {
		
		name = "Boreal Burst",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 4,
		atk = 60,
		req = 13,
		
		sprite = SPR_SHTG,
		frame = N,
		
		elem = ELEM_ICE,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 100,
		
		sound = sfx_sblst1,
		
		potential = "soulspring",
		
		desc = "A Shotgun forged by photonic reactions with unique geometrical properties of surrounding icicles, giving it perfectly straight edges.",
}


PSO.info.items["shot"] = {
		
		name = "Shot",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 4,
		atk = 55,
		
		req = 16,
		
		sprite = SPR_SHTG,
		frame = D,
		color = SKINCOLOR_FLAME,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 100,
		
		sound = sfx_sblst1,
		potential = "photonic keeper",
		
		desc = "A new shotgun model based off of the design of the original, it has higher quality reactors.",	
}

PSO.info.items["concentrator"] = {
		
		name = "Concentrator",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 4,
		atk = 54,
		
		req = 16,
		
		sprite = SPR_SHTG,
		frame = C,
		color = SKINCOLOR_FLAME,
		
		range = 1024,
		pa_damage = 90,
		pa_cost = 90,
		
		sound = sfx_sblst1,
		potential = "photonic keeper",
		
		desc = "An impopular shotgun model due to its bulky design, but none can dismiss its higher photon efficiency which makes it used to this day.",	
}

-- 5 star
PSO.info.items["resurgent burst"] = {
		
		name = "Resurgent Burst",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 5,
		atk = 75,
		
		req = 23,	-- lv req
		
		sprite = SPR_SHTG,
		frame = P,
		effectcolor = SKINCOLOR_RED,
		
		range = 1024,
		
		iyoffset = -10,
		
		sound = sfx_sblst1,
		potential = "hopeless manoeuver",
		
		desc = "A Shotgun dating from the initial Badnik invasion. Its tip is heated up to hundreds of degrees with a thermal battery, making it the first ever truly effective weaponry against Badniks.",
		
}

PSO.info.items["alva shot"] = {
		
		name = "Alva Shot",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 5,
		atk = 69,
		
		req = 24,
		
		sprite = SPR_SHTG,
		frame = D,
		color = SKINCOLOR_PURPLE,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 100,
		
		sound = sfx_sblst1,
		potential = "photonic keeper",
		
		desc = "An improved version of the new shotgun model, it has a higher output at no other loss.",	
}

PSO.info.items["alva concentrator"] = {
		
		name = "Alva Concentrator",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 5,
		atk = 68,
		
		req = 24,
		
		sprite = SPR_SHTG,
		frame = C,
		color = SKINCOLOR_PURPLE,
		
		range = 1024,
		pa_damage = 90,
		pa_cost = 90,
		
		sound = sfx_sblst1,
		potential = "photonic keeper",
		
		desc = "An improved version of the new shotgun model that keeps its high photon efficiency, it's still unwieldy...",	
}

-- 6 star
for i = 1, 3
PSO.info.items["shotgun proto "..i] = {
		
		name = "SG-AR00"..i,
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 6,
		atk = 80,
		req = 34,
		
		sprite = SPR_SHTG,
		frame = A,
		color = SKINCOLOR_GREY,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 100,
		
		sound = sfx_sblst1,
		
		potential = "prototype unit ver."..i,
		
		desc = "An experimental weapon reusing mass produced designs. The inner workings are actually completely different, but still needs a lot of fixing...",
		
}

end

PSO.info.items["shotgun proto 4"] = {
		
		name = "SG-AR004",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 6,
		atk = 80,
		req = 34,
		
		sprite = SPR_SHTG,
		frame = A,
		color = SKINCOLOR_GREY,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 100,
		
		sound = sfx_sblst1,
		
		potential = "prototype modchip",
		
		desc = "A fusion of the different modifications performed on recent prototypes. The result is an unconventional weapon that doesn't feel meant to be used by anyone sane...",
}

PSO.info.items["shotgun proto 5"] = {
		
		name = "SG-AR005",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 6,
		atk = 80,
		req = 34,
		
		sprite = SPR_SHTG,
		frame = A,
		color = SKINCOLOR_GREY,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 100,
		
		sound = sfx_sblst1,
		
		potential = "tame prototype",
		
		desc = "A fusion of the different modifications performed on recent prototypes. The result is a weapon with no special properties whatsoever but has unparalled stability.",
}


PSO.info.items["vita shot"] = {
		
		name = "Vita Shot",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 6,
		atk = 85,
		
		req = 31,
		
		sprite = SPR_SHTG,
		frame = D,
		color = SKINCOLOR_GOLD,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 110,
		
		sound = sfx_sblst1,
		potential = "photonic keeper",
		
		desc = "A final version of the new shotgun model released despite its obvious flaw in photon efficiency, the model was then discontinued.",	
}

PSO.info.items["vita concentrator"] = {
		
		name = "Vita Concentrator",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 6,
		atk = 85,
		
		req = 31,
		
		sprite = SPR_SHTG,
		frame = C,
		color = SKINCOLOR_GOLD,
		
		range = 1024,
		pa_damage = 90,
		pa_cost = 100,
		
		sound = sfx_sblst1,
		potential = "photonic keeper",
		
		desc = "A final version of the bulky model, the capacitors paid off as the photon efficiency has not gone nearly as bad as the other model.",	
}

-- 7 star
PSO.info.items["gyras burst"] = {
		
		name = "Gyras Burst",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 7,
		atk = 111,
		
		req = 40,	-- lv req
		
		elem = ELEM_LIGHT,
		effectcolor = SKINCOLOR_TAN,
		
		sprite = SPR_SHTG,
		frame = Q,

		iyoffset = -10,
		
		sound = sfx_sblst1,
		potential = "aberration slayer",
		
		desc = "A Shotgun taken from a Harbinger. A warm light seems to have taken over the weapon after being separated from its original wielder...",
}

PSO.info.items["fusiel burst"] = {
		
		name = "Fusiel Burst",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 7,
		atk = 99,
		req = 35,
		
		sprite = SPR_SHTG,
		frame = O,
		
		elem = ELEM_ICE,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 100,
		
		sound = sfx_sblst1,
		
		potential = "serene spirit",
		
		desc = "A Shotgun created by hand using parts of atypical weaponry, drawing out the best within each of them.",
}

PSO.info.items["orakl shot"] = {
		
		name = "Orakl Shot",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 7,
		atk = 110,
		
		req = 41,
		
		sprite = SPR_SHTG,
		frame = B,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 90,
		
		sound = sfx_sblst1,
		potential = "perfect rhythm",
		
		desc = "An obviously modified Assault Rifle, you can tell where the scope used to be. It looks like it was MADE by ARKS, but there exists no record of it.",	
}

PSO.info.items["command shot"] = {
		
		name = "Command Shot",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 7,
		atk = 101,
		
		req = 35,
		
		sprite = SPR_SHTG,
		frame = E,
		effectcolor = SKINCOLOR_RED,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 105,
		potential = "glorious leap",
		
		sound = sfx_sblst1,
		
		desc = "A makeshift Shotgun from a Crawla Commander's laser cannon headpiece. It's actually very powerful and looks kind of menacing.",	
}

-- 8star
PSO.info.items["wide smack"] = {
		
		name = "Wide Smack",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 8,
		atk = 140,
		
		req = 50,
		
		sprite = SPR_SHTG,
		frame = F,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 90,
		
		sound = sfx_sblst1,
		potential = "traditional slugs",
		
		desc = "An old tactical shotgun from a bygone era. It has good power but only few remain.",	
}

PSO.info.items["heimdall"] = {
		
		name = "Heimdall",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 8,
		atk = 140,
		
		req = 50,
		
		sprite = SPR_SHTG,
		frame = G,
		
		range = 1024,
		pa_damage = 110,
		pa_cost = 100,
		
		sound = sfx_sblst1,
		potential = "huge capacity",
		
		desc = "A Shotgun modelled after fictional weapons. It converts Photons into lasers that pierce through enemies.",	
}

-- 9star
PSO.info.items["resplendant burst"] = {
		
		name = "Resplendent Burst",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 9,
		atk = 155,
		
		req = 55,	-- lv req
		
		sprite = SPR_SHTG,
		frame = R,
		effectcolor = SKINCOLOR_ORANGE,
		
		range = 1024,
		
		iyoffset = -10,
		
		sound = sfx_sblst1,
		potential = "glimmer of hope",
		
		desc = "The combined properties of the Resurgent weapon's ingenious design and fine tuning of prototypes allowed harnessing the power of the Light.",
}

PSO.info.items["crush bullet"] = {
		
		name = "Crush Bullet",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 9,
		atk = 170,
		
		req = 60,
		
		sprite = SPR_SHTG,
		frame = H,
		
		range = 1024,
		pa_damage = 90,
		pa_cost = 70,
		
		sound = sfx_sblst1,
		
		potential = "overwhelming presence",
		
		desc = "A Shotgun based on old models more akin to Launchers. This lets it be more efficient at the loss of some power and ease of use.",	
}

PSO.info.items["barett"] = {
		
		name = "Barett",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 9,
		atk = 170,
		
		req = 60,
		
		sprite = SPR_SHTG,
		frame = I,
		
		range = 1024,
		pa_damage = 90,
		pa_cost = 70,
		
		sound = sfx_sblst1,
		
		potential = "well worn overheating",
		
		desc = "A Shotgun used during the initial Badnik incursion. It has been modified to use Photons instead of bullets for more efficiency. It remains strong.",	
}

-- 10star
PSO.info.items["spread needle"] = {
		
		name = "Spread Needle",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 10,
		atk = 200,
		
		req = 70,
		
		sprite = SPR_SHTG,
		frame = J,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 130,
		
		sound = sfx_sblst1,
		potential = "ancient darts",
		
		desc = "A Shotgun that fires darts extremely quickly. However, its Photon affinity is poor.",	
}

PSO.info.items["final impact"] = {
		
		name = "Final Impact",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 10,
		atk = 200,
		
		req = 70,
		
		sprite = SPR_SHTG,
		frame = K,
		
		range = 1024,
		pa_damage = 100,
		pa_cost = 130,
		
		sound = sfx_sblst1,
		potential = "king's yield",
		
		desc = "A Shotgun based on a Launcher, letting it land decisive blows.",	
}

PSO.info.items["warrior's pompe"] = {
		
		name = "Warrior's Pompe",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 10,
		atk = 191,
		
		req = 70,	-- lv req
		
		sprite = SPR_SHTG,
		frame = T,
		
		pa_cost = 135,
		pa_damage = 100,
		effectcolor = SKINCOLOR_BLUEBELL,
		
		sound = sfx_sblst1,
		potential = "dynamo charge",
		
		iyoffset = -10,
		range = 1536,
		
		desc = "An experimental Shotgun awarded only to those who have proven themselves able to push their limits. It uses the heat of battle to power itself up.",
}

freeslot("sfx_pnic1", "sfx_pnic2", "sfx_pnic3")
PSO.info.items["fortress panic"] = {
		
		name = "Fortress Panic",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 11,
		atk = 211,
		
		req = 74,	-- lv req
		
		sprite = SPR_SHTG,
		frame = U,
		
		pa_cost = 100,
		pa_damage = 100,
		effectcolor = SKINCOLOR_YELLOW,
		
		sound = sfx_pnic1,
		potential = "panic attack",
		
		iyoffset = -10,
		range = 1536,
		
		desc = "An unconventional Shotgun made of what seenms to be refurbished parts. It uniquely has a barrel to store bullets before firing them all in a row.",
}

-- 11*
PSO.info.items["lumiel burst"] = {
		
		name = "Lumiel Burst",
		type = IT_WEAPON,
		weapontype = WPT_SHOTGUN,
		rarity = 11,
		atk = 210,
		
		req = 80,	-- lv req
		
		sprite = SPR_SHTG,
		frame = S,
		
		elem = ELEM_LIGHT,
		effectcolor = SKINCOLOR_ORANGE,

		iyoffset = -10,
		
		sound = sfx_sblst1,
		range = 1536,
		
		potential = "spark of hope",
		
		desc = "The masterful combination of two weapons drawing the best out of their components creates this unique elemental mixture of Ice and Light that quells hatred and dispells Darkness.",
}