freeslot("sfx_heal")

PSO.info.items["noref"] = {
		name = "UNKNOWN",
		type = IT_CONSUMABLE,
		rarity = 1,
		paletteico = "H_MATE1",
		nopalette = true,
		canuse = function() return false end,
		
		cost = 1,
		rarity = 1,
		
		-- if used as a weapon/armor for whatever reason
		weapontype = WPT_SWORD,
		atk = 1,
		sprite = SPR_SWD1,
		frame = A,
		splatframe = B,	-- while swinging.
		color = SKINCOLOR_NONE,
		effectcolor = SKINCOLOR_NONE,
		
		def = 1,
		
		desc = "Modded item currently not loaded. It will not work properly unless the apropriate mod(s) are loaded.",
}

PSO.info.items["skipto_canyon"] = {
		name = "T/ Canyon",
		type = IT_CONSUMABLE,
		rarity = 10,
		
		carrylimit = 1,
		cost = 1,
		
		desc = "Consumable item, grants 650 EXP, items and unlocks new areas on use.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						return false
					end,
		
		use =	function(p)
					PSO.lib.givePlayerExp(p, 650)
					
					local items = {"gigush", "doublerapier", "beam", "spread", "baton", "shell frame"}
					
					for i = 1, #items
						local it = PSO.lib.makeItem(items[i], {ELEM_ICE, 10})
						PSO.lib.playerGetItem(p, it, 1)
					end
					PSO.lib.rollPlayerShop(p)
					
					PSO.lib.unlockQuest(2, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(2, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 1, DIFF_NORMAL)
				end,
}

PSO.info.items["skipto_peaks"] = {
		name = "T/ Peaks",
		type = IT_CONSUMABLE,
		rarity = 10,
		
		carrylimit = 1,
		cost = 1,
		
		desc = "Consumable item, grants 7,500 EXP, items and unlocks new areas on use.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						return false
					end,
		
		use =	function(p)
					PSO.lib.givePlayerExp(p, 7500)
					
					local items = {"pine", "doubliss", "shot", "shooter", "crescent", "cutter", "beamgun", "scepter", "tutel frame", "unit_hp_1", "unit_pp_1", "unit_satk_1", "unit_tatk_1", "unit_ratk_1"}
					
					for i = 1, #items
						local it = PSO.lib.makeItem(items[i], {ELEM_ICE, 10})
						PSO.lib.playerGetItem(p, it, 1)
					end
					PSO.lib.rollPlayerShop(p)

					PSO.lib.unlockQuest(2, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(2, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 1, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(4, 1, DIFF_NORMAL)
				end,
}

PSO.info.items["skipto_depths"] = {
		name = "T/ Depths",
		type = IT_CONSUMABLE,
		rarity = 10,
		
		carrylimit = 1,
		cost = 1,
		
		desc = "Consumable item, grants 15,000 EXP, items and unlocks new areas on use.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						return false
					end,
		
		use =	function(p)
					PSO.lib.givePlayerExp(p, 15000)
					
					local items = {"trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "alva pine", "alva doubliss", "alva shot", "alva shooter", "alva crescent", "alva cutter", "alva beamgun", "alva scepter", "knight frame", "unit_hp_2", "unit_pp_2", "unit_satk_2", "unit_tatk_2", "unit_ratk_2"}
					
					for i = 1, #items
						--print(items[i])
						local it = PSO.lib.makeItem(items[i], {ELEM_ICE, 10})
						PSO.lib.playerGetItem(p, it, 1)
					end
					PSO.lib.rollPlayerShop(p)

					PSO.lib.unlockQuest(2, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(2, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 1, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(4, 1, DIFF_NORMAL)
					PSO.lib.unlockQuest(4, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(4, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(5, 1, DIFF_NORMAL)
					
				end,
}

PSO.info.items["skipto_hard"] = {
		name = "T/ HARDMODE",
		type = IT_CONSUMABLE,
		rarity = 10,
		
		carrylimit = 1,
		cost = 1,
		
		desc = "Consumable item, grants 21,000 EXP, items and unlocks new areas on use.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						return false
					end,
		
		use =	function(p)
					PSO.lib.givePlayerExp(p, 21000)
					
					local items = {"trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "alva pine", "alva doubliss", "alva shot", "alva shooter", "alva crescent", "alva cutter", "alva beamgun", "alva scepter", "knight frame", "unit_hp_2", "unit_pp_2", "unit_satk_2", "unit_tatk_2", "unit_ratk_2"}
					
					for i = 1, #items
						--print(items[i])
						local it = PSO.lib.makeItem(items[i], {ELEM_ICE, 10})
						PSO.lib.playerGetItem(p, it, 1)
					end
					PSO.lib.rollPlayerShop(p)
					
					PSO.lib.unlockQuest(2, 1, DIFF_HARD)
					PSO.lib.unlockQuest(2, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(2, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 1, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(4, 1, DIFF_NORMAL)
					PSO.lib.unlockQuest(4, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(4, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(5, 1, DIFF_NORMAL)
					
				end,
}

local atomizer_radius = 896

PSO.info.items["star atomizer"] = {
		name = "Star Atomizer",
		type = IT_CONSUMABLE,
		rarity = 6,
		paletteico = "H_ATMZR1",	-- must be set for a consumable to be usable on the palette!
		
		carrylimit = 5,
		cost = 2000,
		
		desc = "Consumable item, heals the user as well as nearby allies for half of their max HP with no penalties.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						for pl in players.iterate
							if pl.mo and pl.mo.valid and pl.pso
							and R_PointToDist2(p.mo.x, p.mo.y, pl.mo.x, pl.mo.y) < atomizer_radius*p.mo.scale
							and pl.pso.hp < pl.pso.maxhp
							and pl.pso.hp > 0	-- don't count dead players lol
								return true
							end	-- if any player can be healed we good
						end
					end,
		
		use =	function(p)
					for pl in players.iterate
						if pl.mo and pl.mo.valid and pl.pso
						and R_PointToDist2(p.mo.x, p.mo.y, pl.mo.x, pl.mo.y) < atomizer_radius*p.mo.scale
						and pl.pso.hp > 0	-- don't heal dead players
							PSO.lib.healObject(pl.mo, pl.mo, pl.pso.maxhp/2)
						end	-- if any player can be healed we good
					end
					
					for i = 1, 8
						local s = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SUPERSPARK)
						P_InstaThrust(s, (360/8)*i*ANG1, p.mo.scale*32)
					end
					
					S_StartSound(p.mo, sfx_heal)
				end,
}

PSO.info.items["sol atomizer"] = {
		name = "Sol Atomizer",
		type = IT_CONSUMABLE,
		rarity = 6,
		paletteico = "H_ATMZR3",	-- must be set for a consumable to be usable on the palette!
		
		carrylimit = 10,
		cost = 500,
		
		desc = "Consumable item, cleanses negative status conditions from the user and nearby allies.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						for pl in players.iterate
							if pl.mo and pl.mo.valid and pl.pso
							and R_PointToDist2(p.mo.x, p.mo.y, pl.mo.x, pl.mo.y) < atomizer_radius*p.mo.scale
							and pl.pso.condition
								return true
							end	-- if any player can be healed we good
						end
					end,
		
		use =	function(p)
					for pl in players.iterate
						if pl.mo and pl.mo.valid and pl.pso
						and R_PointToDist2(p.mo.x, p.mo.y, pl.mo.x, pl.mo.y) < atomizer_radius*p.mo.scale
						and pl.pso.condition
							PSO.lib.removeStatus(p.mo)
						end
					end
					
					for i = 1, 8
						local s = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SUPERSPARK)
						P_InstaThrust(s, (360/8)*i*ANG1, p.mo.scale*32)
					end
					
					S_StartSound(p.mo, sfx_heal)
				end,
}

PSO.info.items["shiftaride"] = {
		name = "Shiftaride",
		type = IT_CONSUMABLE,
		rarity = 6,
		paletteico = "H_ATMZR4",	-- must be set for a consumable to be usable on the palette!
		
		carrylimit = 10,
		cost = 300,
		
		desc = "Consumable item, applies Shifta to the user and nearby allies for 90s, increasing active and passive PP recovery by 15%.",
		
		use =	function(p)
					local t = PSO.lib.spawnMissile(p.mo, MT_THOK, 0, 0, 1, DMT_TECHNIQUE, 0, 0, 0)
					P_SetOrigin(t, p.mo.x, p.mo.y, p.mo.z)
					
					S_StartSound(p.mo, sfx_shifta)
					PSO.info.photonArts["shifta"].spawnfunc(t)
				end,
}

PSO.info.items["debanride"] = {
		name = "Debanride",
		type = IT_CONSUMABLE,
		rarity = 6,
		paletteico = "H_ATMZR5",	-- must be set for a consumable to be usable on the palette!
		
		carrylimit = 10,
		cost = 300,
		
		desc = "Consumable item, applies Deband to the user and nearby allies for 90s, recovering HP on Chain Break.",
		
		use =	function(p)
					local t = PSO.lib.spawnMissile(p.mo, MT_THOK, 0, 0, 1, DMT_TECHNIQUE, 0, 0, 0)
					P_SetOrigin(t, p.mo.x, p.mo.y, p.mo.z)
					
					S_StartSound(p.mo, sfx_deband)
					PSO.info.photonArts["deband"].spawnfunc(t)
				end,
}

PSO.info.items["moon atomizer"] = {
		name = "Moon Atomizer",
		type = IT_CONSUMABLE,
		rarity = 6,
		paletteico = "H_ATMZR2",	-- must be set for a consumable to be usable on the palette!
		
		carrylimit = 5,
		cost = 2000,
		
		desc = "Consumable item, revives incapacitated allies around the user with half of their max HP. Revived allies will be in a state of weakness for some time.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						for pl in players.iterate
							if pl.mo and pl.mo.valid and pl.pso
							and R_PointToDist2(p.mo.x, p.mo.y, pl.mo.x, pl.mo.y) < atomizer_radius*p.mo.scale
							and pl.pso.hp <= 0
								return true
							end	-- if any player can be healed we good
						end
					end,
		
		use =	function(p)
					for pl in players.iterate
						if pl.mo and pl.mo.valid and pl.pso
						and R_PointToDist2(p.mo.x, p.mo.y, pl.mo.x, pl.mo.y) < atomizer_radius*p.mo.scale
						and pl.pso.hp <= 0
							PSO.lib.revivePlayer(pl, p)
							if pl.pso.rweakness
								pl.pso.rbrink = TICRATE*45
								pl.pso.rweakness = 0
							else
								pl.pso.rweakness = TICRATE*45
							end
						end
					end
					
					for i = 1, 8
						local s = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SUPERSPARK)
						P_InstaThrust(s, (360/8)*i*ANG1, p.mo.scale*32)
					end
					
					S_StartSound(p.mo, sfx_heal)
				end,
}

PSO.info.items["monomate"] = {
		name = "Monomate",
		type = IT_CONSUMABLE,
		rarity = 1,
		paletteico = "H_MATE1",	-- must be set for a consumable to be usable on the palette!
		
		carrylimit = 10,
		cost = 50,
		
		desc = "Consumable item, potent drink that heals a third of your HP. The user will feel diziness for a short time after consumption. Can be set to your Action Palette.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						return p.pso.hp < p.pso.maxhp and not p.pso.matesickness
					end,
		
		use =	function(p)
					PSO.lib.healObject(p.mo, p.mo, p.pso.maxhp/3)
					S_StartSound(p.mo, sfx_heal)
					p.pso.matesickness = TICRATE*20
				end,
}

PSO.info.items["dimate"] = {
		name = "Dimate",
		type = IT_CONSUMABLE,
		rarity = 2,
		paletteico = "H_MATE2",	-- must be set for a consumable to be usable on the palette!
		
		carrylimit = 10,
		cost = 250,
		
		desc = "Consumable item, potent drink that heals two thirds of your HP. The user will feel diziness for a short time after consumption. Can be set to your Action Palette.",

		canuse = 	function(p)
						return p.pso.hp < p.pso.maxhp and not p.pso.matesickness
					end,

		use =	function(p)
					PSO.lib.healObject(p.mo, p.mo, p.pso.maxhp*2/3)
					S_StartSound(p.mo, sfx_heal)
					p.pso.matesickness = TICRATE*20
				end,
		
}

PSO.info.items["trimate"] = {
		name = "Trimate",
		type = IT_CONSUMABLE,
		rarity = 3,
		paletteico = "H_MATE3",	-- must be set for a consumable to be usable on the palette!
		
		carrylimit = 10,
		cost = 1000,
		
		desc = "Consumable item, potent drink that heals all your HP. The user will feel diziness for a short time after consumption. Can be set to your Action Palette.",

		canuse = 	function(p)
						return p.pso.hp < p.pso.maxhp and not p.pso.matesickness
					end,

		use =	function(p)
					PSO.lib.healObject(p.mo, p.mo, p.pso.maxhp)
					S_StartSound(p.mo, sfx_heal)
					p.pso.matesickness = TICRATE*20
				end,
		
}

-- returns whether a telepipe can be created.
-- this is a separate function as Ryuker also reuses it.
PSO.lib.canMakeTelepipe = function(p)
	if gamemap == PSO.info.LOBBY_MAP
	or PSO.lib.arenaQuestActive()
	or (server.questdata and server.questdata.noreturn)
	or (p.mo.y < PSO.info.LOBBY_YPOS*FRACUNIT)
	or p.pso.inboss
		
		return false
	end
	return true
end

-- creates a telepipe
-- this is a separate function as Ryuker also reuses it.
PSO.lib.makeTelepipe = function(p)
	local mo = p.mo
	
	-- only 1 pipe per player
	if p.pso.placedtelepipe and p.pso.placedtelepipe.valid
		P_KillMobj(p.pso.placedtelepipe)
	end
	
	local tp = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PSO_TELEPORTER)
	tp.mtangle = 1	-- lobby teleport point
	tp.options = 1	-- teleport to lobby
	tp.telepipe = true	-- flag to change colour / text
	
	p.pso.placedtelepipe = tp
end

PSO.info.items["telepipe"] = {
		name = "Telepipe",
		type = IT_CONSUMABLE,
		rarity = 5,
		paletteico = "H_TPIPE",	-- must be set for a consumable to be usable on the palette!
		
		carrylimit = 10,
		cost = 500,
		
		desc = "Consumable item. Creates a two-way teleporter back to the Low Orbit Station. Can be set to your Action Palette. Cannot be used in certain situations.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						return PSO.lib.canMakeTelepipe(p)
					end,
		
		use =	function(p)
					S_StartSound(p.mo, sfx_heal)
					PSO.lib.makeTelepipe(p)
				end,
}

PSO.info.items["scape doll"] = {
		name = "Scape Doll",
		type = IT_CONSUMABLE,
		rarity = 7,
		cost = 2500,
		carrylimit = 1,
		
		desc = "Rare item resembling a doll that can revive its owner should they get incapacitated. Best to hold on to it!",
}

PSO.info.items["monogrinder"] = {
		name = "Monogrinder",
		type = IT_CONSUMABLE,
		rarity = 4,
		grinder = 1,
		cost = 1000,
		
		desc = "Consumable item. Select a weapon or an armour to enhance its grind by 1 level, increasing its ATK or DEF.",
}

PSO.info.items["digrinder"] = {
		name = "Digrinder",
		type = IT_CONSUMABLE,
		rarity = 5,
		grinder = 2,
		cost = 5000,
		
		desc = "Consumable item. Select a weapon or an armour to enhance its grind by 2 levels, increasing its ATK or DEF.",
}

PSO.info.items["trigrinder"] = {
		name = "Trigrinder",
		type = IT_CONSUMABLE,
		rarity = 6,
		grinder = 3,
		cost = 12500,
		
		desc = "Consumable item. Select a weapon or an armour to enhance its grind by 3 levels, increasing its ATK or DEF.",
}

PSO.info.items["excube"] = {
		name = "EX-Cube",
		type = IT_MATERIAL,
		rarity = 10,
		cost = 0,
		
		desc = "Crystalized photons obtained from attaining one's true potential, containing unique energy used to create special items. Can be exchanged at the Low Orbit Station's Cafe.",
}

-- future proofing.
PSO.info.items["excube_legacy"] = {
		name = "EX-Cube",
		type = IT_MATERIAL,
		rarity = 10,
		cost = 0,
		
		desc = "Crystalized photons obtained from attaining one's true potential, containing unique energy used to create special items. Will be exchangeable for items in a future update.",
}

PSO.info.items["weaponsbadge_1"] = {
		name = "Crimson Medal",
		type = IT_MATERIAL,
		rarity = 9,
		cost = 0,
		
		desc = "A diamond shaped crimson badge awarded as proof of mission completion. Can be exchanged for weapons at the Low Orbit Station's Cafe.",
}

PSO.info.items["weaponsbadge_2"] = {
		name = "ARKS Badge: Gold",
		type = IT_MATERIAL,
		rarity = 10,
		cost = 0,
		
		desc = "A diamond shaped gold badge awarded as proof of mission completion. Can be exchanged for weapons at the Low Orbit Station's Cafe.",
}

PSO.info.items["arenabadge_1"] = {
		name = "Arena Medal",
		type = IT_MATERIAL,
		rarity = 9,
		cost = 0,
		
		desc = "A diamond shaped blue badge awarded as proof of victory in the Arena's relentless training program. Can be exchanged for utility items at the Low Orbit Station's Cafe.",
}

PSO.info.items["azul core"] = {
		name = "Azul Core",
		type = IT_MATERIAL,
		rarity = 2,
		cost = 0,
		
		desc = "An etherial water core around which small rocks orbit. Can be used to create weapons at the Low Orbit Station's Cafe.",
}

PSO.info.items["exiled remnants"] = {
		name = "Exiled Remnants",
		type = IT_MATERIAL,
		rarity = 3,
		cost = 0,
		
		desc = "A pile of metal pieces among which are mixed bits of what seems to be bones? Can be used to create weapons at the Low Orbit Station's Cafe.",
}

PSO.info.items["boreal diamond"] = {
		name = "Boreal Diamond",
		type = IT_MATERIAL,
		rarity = 4,
		cost = 0,
		
		desc = "A Diamond around which orbit smaller diamonds. It radiates photons. Can be used to create weapons at the Low Orbit Station's Cafe.",
}

PSO.info.items["black matter"] = {
		name = "Black Matter",
		type = IT_MATERIAL,
		rarity = 7,
		cost = 0,
		
		desc = "A strange material with unique properties that allow it to meld other material together. Some also name it 'Miracle Matter' because of it. ...It is unfortunately hard to come by and no one knows what the origin of it is. Can be used to create weapons at the Low Orbit Station's Cafe.",
}

PSO.info.items["resurgent cell"] = {
		name = "Resurgent Cell",
		type = IT_MATERIAL,
		rarity = 5,
		cost = 0,
		
		desc = "A battery containing a really hot liquid. It's thankfully heatproof so it's safe to hold so long as you don't break it. Can be used to create weapons at the Low Orbit Station's Cafe.",
}

PSO.info.items["prototype chip"] = {
		name = "Prototype Chip",
		type = IT_MATERIAL,
		rarity = 6,
		cost = 0,
		
		desc = "A chip extracted from an experimental weapon. One shudders to imagine the dreadful lines of code it contains. Can be used to create weapons at the Low Orbit Station's Cafe.",
}

PSO.info.items["light fragment"] = {
		name = "Light Fragment",
		type = IT_MATERIAL,
		rarity = 7,
		cost = 0,
		
		desc = "A part torn from a Harbinger's weapon. Warm light oozes from it... Can be used to create weapons at the Low Orbit Station's Cafe.",
}

PSO.info.items["chaos shard"] = {
		name = "Chaos Shard",
		type = IT_MATERIAL,
		rarity = 9,
		cost = 0,
		
		desc = "A fragment once belonging to a jewel of near infinite power. Some may say it can be used to turn dreams into reality. Can be exchanged at the Low Orbit Station's Cafe.",
}

PSO.info.items["chaos cluster"] = {
		name = "Chaos Cluster",
		type = IT_MATERIAL,
		rarity = 11,
		cost = 0,
		
		desc = "A part of a jewel radiating positive energy as you clutch it in your hand. Its reaction to your emotions make it almost seem conscious. Can be exchanged at the Low Orbit Station's Cafe.",
}

PSO.info.items["abnormal shard"] = {
		name = "Abnormal Shard",
		type = IT_MATERIAL,
		rarity = 11,
		cost = 0,
		
		desc = "An unstable material whose shape keeps changing, it's like it doesn't belong in this dimension. It could probably be stabilized with the help of the Cafe's owner.",
}

PSO.info.items["extend code"] = {
		name = "Extend Code",
		type = IT_CONSUMABLE,
		icon = "H_IICOA",
		rarity = 10,
		grinder = 1,
		extendmax = 20,
		extendlv = 80,
		cost = 15000,

		canuse = 	function(p)
						return p.pso.level >= 80
					end,
		
		desc = "Consumable item. Raises the maximum grind level of a weapon of rarity 9 or below to 20 and increases its equipment level requirement to Lv80. Item can only be used by players Lv80 or above.",
}

PSO.info.items["element0"] = {
		name = "Element: None",
		type = IT_CONSUMABLE,
		icon = "H_IICOA",
		rarity = 10,
		grinder = 1,
		setelem = ELEM_NONE,
		cost = 15000,
		
		desc = "Consumable item. Changes a weapon or armour's Element to Elementless. Elemental value is kept after transition.",
}

PSO.info.items["element1"] = {
		name = "Element: Fire",
		type = IT_CONSUMABLE,
		icon = "H_IICOA",
		rarity = 10,
		grinder = 1,
		setelem = ELEM_FIRE,
		cost = 15000,
		
		desc = "Consumable item. Changes a weapon or armour's Element to Fire. Elemental value is kept after transition.",
}

PSO.info.items["element2"] = {
		name = "Element: Ice",
		type = IT_CONSUMABLE,
		icon = "H_IICOA",
		rarity = 10,
		grinder = 1,
		setelem = ELEM_ICE,
		cost = 15000,
		
		desc = "Consumable item. Changes a weapon or armour's Element to Ice. Elemental value is kept after transition.",
}

PSO.info.items["element3"] = {
		name = "Element: Elec",
		type = IT_CONSUMABLE,
		icon = "H_IICOA",
		rarity = 10,
		grinder = 1,
		setelem = ELEM_ELEC,
		cost = 15000,
		
		desc = "Consumable item. Changes a weapon or armour's Element to Elec. Elemental value is kept after transition.",
}

PSO.info.items["element4"] = {
		name = "Element: Earth",
		type = IT_CONSUMABLE,
		icon = "H_IICOA",
		rarity = 10,
		grinder = 1,
		setelem = ELEM_EARTH,
		cost = 15000,
		
		desc = "Consumable item. Changes a weapon or armour's Element to Earth. Elemental value is kept after transition.",
}

PSO.info.items["element5"] = {
		name = "Element: Light",
		type = IT_CONSUMABLE,
		icon = "H_IICOA",
		rarity = 10,
		grinder = 1,
		setelem = ELEM_LIGHT,
		cost = 15000,
		
		desc = "Consumable item. Changes a weapon or armour's Element to Light. Elemental value is kept after transition.",
}

PSO.info.items["element6"] = {
		name = "Element: Dark",
		type = IT_CONSUMABLE,
		icon = "H_IICOA",
		rarity = 10,
		grinder = 1,
		setelem = ELEM_DARK,
		cost = 15000,
		
		desc = "Consumable item. Changes a weapon or armour's Element to Dark. Elemental Value is kept after transition.",
}

PSO.info.items["element+5"] = {
		name = "Element +5%",
		type = IT_CONSUMABLE,
		icon = "H_IICOA",
		rarity = 7,
		grinder = 1,
		boostelem = 5,
		cost = 5000,
		
		desc = "Consumable item. Boosts a weapon or armour's Elemental Value by 5% to a maximum of 60%, even low rarity equipment with lower Elemental value caps.",
}

PSO.info.items["element+10"] = {
		name = "Element +10%",
		type = IT_CONSUMABLE,
		icon = "H_IICOA",
		rarity = 8,
		grinder = 1,
		boostelem = 10,
		cost = 5000,
		
		desc = "Consumable item. Boosts a weapon or armour's Elemental Value by 10% to a maximum of 60%, even low rarity equipment with lower Elemental value caps.",
}

PSO.info.items["element+20"] = {
		name = "Element +20%",
		type = IT_CONSUMABLE,
		icon = "H_IICOA",
		rarity = 9,
		grinder = 1,
		boostelem = 20,
		cost = 15000,
		
		desc = "Consumable item. Boosts a weapon or armour's Elemental Value by 20% to a maximum of 60%, even low rarity equipment with lower Elemental value caps.",
}

PSO.info.items["element+30"] = {
		name = "Element +30%",
		type = IT_CONSUMABLE,
		icon = "H_IICOA",
		rarity = 10,
		grinder = 1,
		boostelem = 30,
		cost = 15000,
		
		desc = "Consumable item. Boosts a weapon or armour's Elemental Value by 30% to a maximum of 60%, even low rarity equipment with lower Elemental value caps.",
}