-- Player prefs IO

local loadingprefs

COM_AddCommand("pso_prefs_toggles", function(p, arglockon, argapal, argbpal, argrare, argshake)
	
	if not p return end
	if not p.pso return end
	
	local vals = {arglockon, argapal, argbpal, argrare, argshake}
	local vars = {"toggle_lockon", "toggle_apalette", "toggle_bpalette", "pref_raredrop", "pref_screenshake"}
	
	for i = 1, #vals
		local val = false
		local argv = vals[i]:lower()
		
		if i > 3
			
			val = tonumber(vals[i]) or 0
			-- HACK...
			if i == 4
				val = max(7, $)
				val = min($, 15)
			else
				val = max($, 0)
				val = min($, 10)
			end
		else
			if tonumber(vals[i]) 
			or argv == "yes" or argv == "true" or argv == "on"
				val = true
			end
		end
		
		p.pso[vars[i]] = val
	end
	
	if not loadingprefs
		PSO.lib.playerSavePrefs(p)
	end
end)

local function splitstr(str, sep)
	local t={}
	for s in string.gmatch(str, "([^"..sep.."]+)") do
		table.insert(t, s)
	end
	return t
end

local ipt_list = {IPT_CONFIRM, IPT_BACK, IPT_EVADE, IPT_ATTACK, IPT_ATTACK2, IPT_PALETTE, IPT_SECONDPALETTE, IPT_LOCKON, IPT_MENU, IPT_INTERACT, IPT_ATTACK3, IPT_MEXTRA}
COM_AddCommand("pso_prefs_inputs", function(p, arg)
	
	if not p return end
	if not p.pso return end
	
	-- hack
	if not arg
		p.pso.alloweditinputs = nil
		return
	end
	
	-- player must be allowed to edit inputs
	-- makes it so they can't fuck their game.
	if not p.mo or not p.pso.alloweditinputs
		CONS_Printf(p, "Cannot edit inputs manually through this command.")
		return
	end
	
	p.pso.alloweditinputs = nil
	
	local args = splitstr(arg, " ")
	local usedkeys = {}
	local nilkey
	
	for i = 1, #args
		local val = tonumber(args[i])
		
		if val ~= 8	-- 2.2.15, why are YOU LIKE THIS (this was BT_SHIELD!!!!)
			p.pso.inputs[ipt_list[i]] = val
		else
			nilkey = true
		end
		
		-- this is used for save compat, see below
		-- we check for > 2 because we don't want ipt_confirm or ipt_back
		if i > 2 and i < #ipt_list
			usedkeys[val] = true
		end
	end
	
	if not loadingprefs
		PSO.lib.playerSavePrefs(p)
	else
		-- this one is a doozy but check if we have a duplicate on the last value...
		-- this is for savefile compatibility.
		/*local newkey = p.pso.inputs[ipt_list[#ipt_list]]
		if usedkeys[newkey]
			p.pso.inputs[ipt_list[#ipt_list]] = nil
			--print("AAAAAA")
			PSO.lib.openMenu(p, "options_inputs")
		end*/	
		
		if nilkey
			PSO.lib.openMenu(p, "options_inputs")
		end	
	end
end)

COM_AddCommand("pso_end_input", function(p)
	if p == consoleplayer
		loadingprefs = nil
	end
	p.pso.alloweditinputs = nil
end)

rawset(_G, "cv_useminimap",  CV_RegisterVar({
	name = "pso_prefs_minimap",
	defaultvalue = 1,
	PossibleValue = CV_OnOff,
}))

rawset(_G, "cv_maprotation",  CV_RegisterVar({
	name = "pso_prefs_minimaprotation",
	defaultvalue = 0,
	PossibleValue = CV_OnOff,
}))

PSO.lib.playerSavePrefs = function(p)
	if p == consoleplayer
		
		print("Saving preferences...")
		
		local f = io.openlocal("client/"..PSO.info.playerPrefFile, "w")
		-- the pref file only has 2 lines thankfully so it's very fast!
		
		assert(f, "Cannot open file to save preferences. Check your folder permissions and disk space.")
		
		-- minimap stuff
		local str = "pso_prefs_minimap "..cv_useminimap.value.."\n"
		f:write(str)
		
		str = "pso_prefs_minimaprotation "..cv_maprotation.value.."\n"
		f:write(str)
		
		-- toggles:
		str = "pso_prefs_toggles"
		local vars = {"toggle_lockon", "toggle_apalette", "toggle_bpalette", "pref_raredrop", "pref_screenshake"}
		for i = 1, #vars
			
			if i > 3
				str = $.." "..(tonumber(p.pso[vars[i]] or 0))
			else
			
				if p.pso[vars[i]]
					str = $.." 1"
				else
					str = $.." 0"
				end
			end
		end
		
		str = $.."\n"
		f:write(str)
		
		str = "pso_prefs_inputs \""
		for i = 1, #ipt_list
			
			str = $..(p.pso.inputs[ipt_list[i]])
			
			if i < #ipt_list
				str = $.." "
			end
		end
		
		str = $.."\""
		str = $.."\n"
		f:write(str)
		
		f:close()
		print("Preferences succesfully saved.")
	end
end

PSO.lib.playerLoadPrefs = function(p)
	
	p.pso.alloweditinputs = true
	
	if p == consoleplayer
		
		loadingprefs = true
		
		local f = io.openlocal("client/"..PSO.info.playerPrefFile, "r")
		if not f return end	-- file was not created, first time joiner / fine w default config? :)
		
		-- execute the contents of the file
		local r = f:read()
		while r
			
			COM_BufInsertText(p, r)
			r = f:read()
		end
		
		-- send this command to end the loading phase.
		COM_BufInsertText(p, "pso_end_input")
		f:close()
	end
end

