-- Technically a bunch of hacks.
-- We use these for AIS actions

local function sword_trail(mo, pos, prevswordpos, overend)
	
	local spr = overend and SPR_GRNT or SPR_STRL
	local frame = overend and B or A
	local wep = PSO.lib.getPlayerActiveWeapon(mo.player)
	local winfo = PSO.lib.itemInfo(wep)
	local steps = overend and 3 or 5
	local tr = overend and TR_TRANS30|FF_ADD or TR_TRANS30
	
	for i = 0, steps
							
		local x = PSO.lib.lerp(mo.x + FixedMul(prevswordpos[1], mo.scale*4), mo.x + FixedMul(pos[2], mo.scale*4), FRACUNIT/steps *i)
		local y = PSO.lib.lerp(mo.y + FixedMul(prevswordpos[2], mo.scale*4), mo.y + FixedMul(pos[3], mo.scale*4), FRACUNIT/steps *i)
		local z = PSO.lib.lerp(mo.z + FixedMul(prevswordpos[3], mo.scale*4), mo.z + FixedMul(pos[4], mo.scale*4), FRACUNIT/steps *i)
		local a = PSO.lib.lerp(prevswordpos[4], pos[6], FRACUNIT/steps *i)
							
		local trail = P_SpawnMobj(x, y, z - mo.scale*8*4, MT_THOK)
		
		if pos[7] and pos[7].use
			
			if overend
				frame = C
			end
			
			P_CreateFloorSpriteSlope(trail)
						
			trail.flags2 = $ | MF2_SPLAT
			trail.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
			trail.floorspriteslope.o = pos[7].o
			trail.floorspriteslope.xydirection = pos[7].xy
			trail.floorspriteslope.zangle = pos[7].za
						
			trail.sprite = spr
			trail.frame = frame|tr
			
			trail.angle = 0	
			trail.rollangle = a			
			PSO.lib.fixSplatScale(trail)
			
		else
			trail.sprite = spr
			trail.frame = frame|tr|FF_PAPERSPRITE
			trail.angle = mo.player.drawangle + pos[5]
			trail.spritexscale = FRACUNIT
			trail.spriteyscale = FRACUNIT
			
			trail.rollangle = a
		end
		
		if overend
			trail.colorized = true
		end
		
		trail.tics = 10
		trail.fuse = 10						
		trail.color = SKINCOLOR_MASTER
		trail.scale = $*2
	end
end

PSO.info.photonArts["ais_shield"] = {
		name = "Reflect Shield",
		desc = "AIS Reflect Shield",
		cost = 10,
		potency = 1000,
		speed = 0,	-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_AISA4",

		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					local holdtime = TICRATE/3
					
					if timer == 1
						-- play lockon sound...
						
						p.pso.superarmor = true
						p.pso.aisreflect = {}	-- must also be cleared in softreset
						p.pso.aisreflectend = nil
						
						local f = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
						f.state = S_FORC1
						f.colorized = true
						f.color = SKINCOLOR_MASTER
						f.scale = 1
						f.destscale = mo.scale*4*12/10
						f.scalespeed = FRACUNIT
						
						mo.aisshield = f
						
						local g = P_SpawnGhostMobj(f)
						g.destscale = mo.scale*2*4
						g.scalespeed = f.scalespeed*2
					end
					
					if timer < holdtime
						local vis = mo.aisvis
						if vis and vis.valid
							vis.frame = U
						end
						
						local tx = mo.x - 8*cos(mo.angle)
						local ty = mo.y - 8*sin(mo.angle)
						P_MoveOrigin(mo.aisshield, tx, ty, mo.z)
						
						if #p.pso.aisreflect
							
							local e = P_SpawnMobj(mo.x - 4*cos(mo.angle), mo.y - 4*sin(mo.angle), mo.z, MT_THOK)
							e.sprite = SPR_ELEC
							e.frame = (leveltime/2) % L
							e.colorized = true
							e.color = SKINCOLOR_MASTER
							e.scale = mo.scale/2
						end
						
						p.pso.pp = max(0, $-4)

						
					elseif timer == holdtime
					and hold
					and p.pso.pp
						
						p.pso.actiontimer = holdtime-2
						timer = $-2
						
						local vis = mo.aisvis
						if vis and vis.valid
							vis.frame = U
						end
						
					
					elseif timer > holdtime

						local newt = timer - holdtime
						local f = min(U, S + (newt / 3))
						
						local vis = mo.aisvis
						if vis and vis.valid
							vis.frame = f
						end
						
						if newt == 1
							mo.aisshield.destscale = $*4
							mo.aisshield.fuse = 8
							mo.aisshield = nil
							p.pso.aisreflectend = true
							mo.aisreflected = {}
						end
						
						local limit = max(TICRATE/4, #p.pso.aisreflect*2 + TICRATE/6)
						
						for i = 1, #p.pso.aisreflect
							
							local en = p.pso.aisreflect[i]
							
							if not en or not en.valid continue end
							
							if newt == 2*i
								mo.aisreflected[en] = $ and $+1 or 1
								mo.aisreflected[en] = min($, 8)
								
								local fn = function(s)
									s.sprite = SPR_THOK
									s.frame = FF_FULLBRIGHT
									s.color = SKINCOLOR_MASTER
									s.destscale = 1
									s.scalespeed = FRACUNIT/12
									s.fuse = 12
									s.tics = 12
								end
								
								S_StartSound(mo, sfx_s3k54)
								
								PSO.lib.spawnLine(mo, en, 64, fn)
								
								local hb = PSO.lib.spawnHurtBox(en.x, en.y, en.z, 80<<FRACBITS, 40<<FRACBITS, mo, potency / mo.aisreflected[en], DMT_RANGED, 3, RT_STAGGER)								
								hb.pso.combobreaker = true
								hb.pso.ppregen = 15
							end
							
						end
						
						if newt > limit
							p.pso.aisreflect = nil
							return true
						end
					end
				end,				
}

PSO.info.photonArts["ais_tblast"] = {
		name = "Target Blast",
		desc = "AIS Lockon Blasts",
		cost = 50,
		potency = 620,
		speed = 100,	-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_AISA3",

		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					local holdtime = TICRATE/3
					local delay = 2	-- delay between each target
					local range = 2048
					local ang = 60
					local maxtargets = 16
					
					if timer == 1
						-- play lockon sound...
						
						p.pso.aislockon = {}	-- must also be cleared in softreset
						S_StartSound(mo, sfx_s3k5a)
						
						local start_a = mo.angle - ANG1*60
						local num_proj = 12
						
						for i = 1, num_proj
							local t = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
							t.tics = 12
							t.fuse = 12
							t.color = SKINCOLOR_MASTER
							t.angle = start_a + (120 / num_proj)*(i-1)*ANG1
							P_InstaThrust(t, t.angle, FRACUNIT*60)
						end
					end
					
					if timer < holdtime
						
						-- maintain the target list.
						local i = #p.pso.aislockon
						while i
							
							local en = p.pso.aislockon[i]
							
							if not en or not en.valid or not P_CheckSight(mo, en)
								table.remove(p.pso.aislockon, i)
							end
							
							i = $-1
						end
						
						if mo.ais_lockondelay
							mo.ais_lockondelay = $-1
							return
						end
						
						-- max targets reached, do not scan anymore
						if p.pso.aislockon and #p.pso.aislockon >= maxtargets
							return
						end
						
						-- scan for enemies

						local enemies = {}
						-- use searchblockmap to find enemies within our range...
						
						local cx = mo.x + range/2 * FixedMul(mo.scale, cos(mo.angle))
						local cy = mo.y + range/2 * FixedMul(mo.scale, sin(mo.angle))
						
						local x1 = cx - (range/2 *mo.scale)
						local x2 = cx + (range/2 *mo.scale)
						local y1 = cy - (range/2 *mo.scale)
						local y2 = cy + (range/2 *mo.scale)
						
						local function search(ref, found)
							
							if found and found.valid and (found.flags & (MF_ENEMY|MF_SHOOTABLE)) and found.type ~= MT_PLAYER
							
								if not PSO.info.enemies[found.type] or not PSO.info.enemies[found.type].notarget
								
									-- check our current target list...
									for i = 1, #p.pso.aislockon
										if p.pso.aislockon[i] and p.pso.aislockon[i].valid and p.pso.aislockon[i] == found
											return	-- do not continue
										end
									end
									
									-- check angle
									local angle_diff = (p.cmd.angleturn*FRACUNIT) - R_PointToAngle2(mo.x, mo.y, found.x, found.y)
									
									if (PSO.lib.angToInt(angle_diff) > 180)
										angle_diff = InvAngle(angle_diff)
									end
												
									if (PSO.lib.angToInt(angle_diff) < ang)
									and (found == p.pso.lockon or P_CheckSight(mo, found))
										enemies[#enemies+1] = found
									end
								end
							end
						end
						
						searchBlockmap("objects", search, mo, x1, x2, y1, y2)
						
						-- sort enemies by distance / angle... give them some sort of score.
						local scores = {}
						for i = 1, #enemies
							
							scores[i] = {i, 0}
							scores[i][2] = $ + FixedDiv(R_PointToDist2(mo.x, mo.y, enemies[i].x, enemies[i].y), mo.scale) / FRACUNIT / 4	-- angle matters more
							scores[i][2] = $ + abs(mo.z - enemies[i].z) / FRACUNIT	-- z diff matters too
							scores[i][2] = $ + abs((mo.angle - R_PointToAngle2(mo.x, mo.y, enemies[i].x, enemies[i].y)) / ANG1)
							
							if not (enemies[i].flags & MF_ENEMY)	-- another damageable thing? crate? It's very low priority.
								scores[i][2] = $*4
							end
							--print("enemy "..i.." score: "..scores[i])
						end
						
						table.sort(scores, function(a, b) return a[2] < b[2] end)
						
						if scores and scores[1]
							local final_target = enemies[scores[1][1]]
							if final_target and final_target.valid
							
								S_StartSound(nil, sfx_targ, p)
								p.pso.aislockon[#p.pso.aislockon+1] = final_target
								mo.ais_lockondelay = delay
							end
						end
						
						
					elseif timer == holdtime
					and hold
						
						p.pso.actiontimer = holdtime-2
						timer = $-2
					
					elseif timer > holdtime
						
						local newt = timer - holdtime
						local f = min(U, S + (newt / 3))
						
						local vis = mo.aisvis
						if vis and vis.valid
							vis.frame = f
						end
						
						if newt == 1
							S_StartSound(mo, sfx_s3k7c)
						end
						
						p.pso.superarmor = true
						
						for i = 1, #p.pso.aislockon
							
							if newt == 3*i
								
								local en = p.pso.aislockon[i]
								
								-- paranoia
								if en and en.valid
									local msl = PSO.lib.spawnMissile(mo, MT_PSO_BFLOW_EXPLOSION, 0, 0, potency, DMT_RANGED, 0, 0, 0)
									if msl and msl.valid
										msl.angle = mo.angle
										P_SetOrigin(msl, en.x, en.y, en.z)
									end
								end
							end
						end
						
						if newt > 10 + #p.pso.aislockon*3
							p.pso.aislockon = {}
							return true
						end
					end
				end,
}
				
PSO.info.photonArts["ais_sword"] = {
		name = "Leech Blade",
		desc = "AIS Sword swing",
		cost = 50,
		potency = 750,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		combo = TICRATE*20,	-- hack for the 3-hit combo
		icon = "H_AISA2",

		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					-- slash 1:
					if not combo
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle + ANG1*90,	-- tilt sideways
							za = ANG1*30,				-- tilt by 30 degrees
						}
						
						local ang

						if mo.swordangle == nil
							mo.swordangle = 0
						end
						
						/*if timer < 3
							mo.swordangle = -ANG1*120
						elseif timer < TICRATE/2
							local nt = timer-3
							mo.swordangle = $ + max(0, ANG1*(30 - (nt-2)*4))
						end*/

						if timer < 3
							mo.swordangle = -ANG1*160
						elseif timer < TICRATE/3
							mo.swordangle = $ + ANG1
						elseif timer < TICRATE
							local nt = timer-TICRATE/3
							
							mo.swordangle = $ + max(0, ANG1*(40 - (nt-2)*8))
						end
						
						local ang = p.drawangle + mo.swordangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90
						
						-- damage box:
						if timer == TICRATE/3
							--local x = mo.x + FixedMul(mo.scale, 400*cos(p.drawangle))
							--local y = mo.y + FixedMul(mo.scale, 400*sin(p.drawangle))
							
							--(x, y, z, w, t, source, potency, dtype, duration)
							-- spawn in a fan pattern in front...
							local a = p.drawangle - 60*ANG1
							local dist = 128
							
							local hbl = {}
							
							for i = 1, 4
								for j = 1, i*3
									local sx = mo.x + FixedMul(mo.scale, dist*cos(a))
									local sy = mo.y + FixedMul(mo.scale, dist*sin(a))
									
									local hb = PSO.lib.spawnHurtBox(sx, sy, mo.z-mo.scale*16, 512<<FRACBITS, 512<<FRACBITS, mo, potency, DMT_STRIKE, 8)
									hb.pso.potency = potency	-- normals shouldn't benefit from PA%
									hb.pso.combobreaker = true
									hb.pso.lifesteal = 15	-- 15% lifesteal
									hbl[#hbl+1] = hb
									hb.pso.links = hbl
									--hb.pso.locks = 4
									hb.angle = p.drawangle
									
									local max_i = (i*3)
									
									a = $ + (120 / i)*ANG1
								end
								a = p.drawangle - 60*ANG1
								dist = $+224
							end
							
							S_StartSound(mo, sfx_sword4)
							
							if p == consoleplayer
								P_StartQuake(FRACUNIT*40, 6)
							end
						end
						
						if timer > TICRATE/2
						and timer < TICRATE*20
							p.pso.actiontimer = TICRATE*30 - TICRATE/4
						end
					
					-- slash 2:
					elseif combo == 1
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle + ANG1*90,	-- tilt sideways
							za = ANG1*30,				-- tilt by 30 degrees
						}
						
						local ang

						if mo.swordangle == nil
							mo.swordangle = 0
						end
						
						/*if timer < 3
							mo.swordangle = -ANG1*120
						elseif timer < TICRATE/2
							local nt = timer-3
							mo.swordangle = $ + max(0, ANG1*(30 - (nt-2)*4))
						end*/

						if timer < 3
							mo.swordangle = ANG1*160
						elseif timer < TICRATE/3
							mo.swordangle = $ - ANG1
						elseif timer < TICRATE
							local nt = timer-TICRATE/3
							
							mo.swordangle = $ - max(0, ANG1*(40 - (nt-2)*8))
							pos[7].za = $ - ANG1*2*nt
						end
						
						local ang = p.drawangle + mo.swordangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90
						
						-- damage box:
						if timer == TICRATE/3
							local a = p.drawangle - 60*ANG1
							local dist = 128
							
							local hbl = {}
							
							for i = 1, 4
								for j = 1, i*3
									local sx = mo.x + FixedMul(mo.scale, dist*cos(a))
									local sy = mo.y + FixedMul(mo.scale, dist*sin(a))
									
									local hb = PSO.lib.spawnHurtBox(sx, sy, mo.z-mo.scale*16, 512<<FRACBITS, 512<<FRACBITS, mo, potency, DMT_STRIKE, 8)
									hb.pso.potency = potency	-- normals shouldn't benefit from PA%
									hb.pso.combobreaker = true
									hb.pso.lifesteal = 40	-- 40% lifesteal
									hbl[#hbl+1] = hb
									hb.pso.links = hbl
									--hb.pso.locks = 4
									hb.angle = p.drawangle
									
									local max_i = (i*3)
									
									a = $ + (120 / i)*ANG1
								end
								a = p.drawangle - 60*ANG1
								dist = $+224
							end
							
							S_StartSound(mo, sfx_sword4)
							
							if p == consoleplayer
								P_StartQuake(FRACUNIT*40, 6)
							end
						end
						
						if timer > TICRATE/2
						and timer < TICRATE*20
							p.pso.actiontimer = TICRATE*30 - TICRATE/4
						end				
					
					elseif combo == 2
						
						p.pso.actionspeed = 0
						
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = mo.angle + ANG1*90,
							za = 0,
						}
						
						local ang

						if mo.swordangle == nil
							mo.swordangle = 0
						end
						
						if timer < 3
							mo.swordangle = -ANG1*160
						elseif timer < TICRATE/3
							mo.swordangle = $ + ANG1
						elseif timer < TICRATE*3/2
							local nt = timer-3
							mo.swordangle = $ + max(0, ANG1*(100 - (nt-2)*3))
							pos[7].za = $ + ANG1*nt
						end
						
						local ang = mo.angle + mo.swordangle
						p.drawangle = ang
						local x = 32 * cos(ang)
						local y = 32 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*40

						-- damage box:
						if timer == TICRATE/4
						or timer == TICRATE/2
						or timer == TICRATE*3/4
							
							if p == consoleplayer
								P_StartQuake(FRACUNIT*40, 3)
							end
							
							--(x, y, z, w, t, source, potency, dtype, duration)
							local a = 45*ANG1
							local hbl = {}
							
							for i = 1, 4
								local sx = mo.x + FixedMul(mo.scale, 300*cos(p.drawangle +a))
								local sy = mo.y + FixedMul(mo.scale, 300*sin(p.drawangle +a))
								
								local hb = PSO.lib.spawnHurtBox(sx, sy, mo.z-mo.scale*16, 512<<FRACBITS, 512<<FRACBITS, mo, potency, DMT_STRIKE, 8, RT_KNOCKBACK)
								hb.pso.potency = potency	-- normals shouldn't benefit from PA%
								hb.pso.combobreaker = true
								hb.pso.reactionradialangle = true
								hb.pso.lifesteal = 60	-- 60% lifesteal
								hbl[#hbl+1] = hb
								hb.pso.links = hbl
								--hb.pso.locks = 4
								hb.angle = p.drawangle
								
								a = $ + 90*ANG1
							end
							
							S_StartSound(mo, sfx_sword4)
						end
						
						if timer == TICRATE	
							return true
						end
					end
					
					-- sword trail:
					if timer > 1
						sword_trail(mo, pos, prevswordpos, true)
					end
					
					if timer == 30*TICRATE
						return true
					end
					
					--P_SpawnMobj(mo.x+pos[2], mo.y+pos[3], mo.z+pos[4], MT_THOK)
					
				end,
}

PSO.info.photonArts["ais_shot"] = {
		name = "Vulkan Shot",
		desc = "AIS shot",
		cost = 0,
		normal = true,
		potency = 180,
		speed = 100,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_AISA1",
		combo = 18,		-- can be reused after 17 frames on the timer!
		
		-- p: player
		-- timer: how long the animation has played for
		-- hold: if true, button is being held down, if not, it's been released
		-- input: timer on how long the button has been held for
		-- combo: non-zero if the attack was performed from a combo.
					-- useful to create attacks that are faster/different if used repeatedly.
		
		-- return true to end the animation
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[HAND_LEFT]
					local potency = PSO.info.photonArts[p.pso.action].potency
					--local wep = PSO.lib.getPlayerActiveWeapon(p)
					--local winfo = PSO.lib.itemInfo(wep)
					
					local vis = mo.aisvis
					if vis and vis.valid
						vis.frame = 26
					end
					
					--print(timer)
					-- set new weapon pos:
					
					if combo
					and timer < 14
						p.pso.actiontimer = 14
						timer = 14
					end
					
					
					if timer == 4
					or timer == 9
					or timer == 14
						
						-- fire the bullet!
						local msl = PSO.lib.spawnMissile(mo, MT_PSO_RIFLESHOT, p.drawangle, 75*FRACUNIT, potency/3, DMT_RANGED, 0, 0, mo.scale*10)
						--msl.scale = $/3
						msl.color = SKINCOLOR_MASTER
						msl.pso.potency = potency	-- normals shouldn't benefit from PA%
						msl.pso.combobreaker = true
						msl.pso.ppregen = 5
						msl.radius = $*2
						msl.height = $*2
						
						-- teleport the missile to where the gun is.
						local x = mo.x + FixedMul(mo.scale*2, cos(p.drawangle))*64 + FixedMul(mo.scale*2, cos(p.drawangle + 270*ANG1))*32
						local y = mo.y + FixedMul(mo.scale*2, sin(p.drawangle))*64 + FixedMul(mo.scale*2, sin(p.drawangle + 270*ANG1))*32
						local z = mo.z + 80*mo.scale*2
						
						P_SetOrigin(msl, x, y, z)
						
						PSO.lib.aimMissile(msl, p.pso.target)
						S_StartSound(mo, sfx_brakrl, p)

						-- make the missile fade after it gets out of the range.
						--msl.fuse = FixedDiv(range*FRACUNIT, max(1, FixedHypot(msl.momx, msl.momy)))/FRACUNIT
						
					end
					
					if timer == TICRATE*2/3
						return true
					end
				end,
}