freeslot("SPR_DSTL")

local function saber_trail(mo, pos, prevswordpos, da)
	
	local wep = PSO.lib.getPlayerActiveWeapon(mo.player)
	local winfo = PSO.lib.itemInfo(wep)
	
	for i = 0, 5
							
		local x = PSO.lib.lerp(mo.x + FixedMul(prevswordpos[1], mo.scale), mo.x + FixedMul(pos[2], mo.scale), FRACUNIT/5 *i)
		local y = PSO.lib.lerp(mo.y + FixedMul(prevswordpos[2], mo.scale), mo.y + FixedMul(pos[3], mo.scale), FRACUNIT/5 *i)
		local z = PSO.lib.lerp(mo.z + FixedMul(prevswordpos[3], mo.scale), mo.z + FixedMul(pos[4], mo.scale), FRACUNIT/5 *i)
		local a = PSO.lib.lerp(prevswordpos[4], pos[6], FRACUNIT/5 *i)
							
		local trail = P_SpawnMobj(x, y, z - mo.scale*8, MT_THOK)
		
		if pos[7] and pos[7].use
			P_CreateFloorSpriteSlope(trail)
						
			trail.flags2 = $ | MF2_SPLAT
			trail.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
			trail.floorspriteslope.o = pos[7].o
			trail.floorspriteslope.xydirection = pos[7].xy
			trail.floorspriteslope.zangle = pos[7].za
						
			trail.sprite = SPR_DSTL
			trail.frame = A|TR_TRANS30
			
			trail.angle = 0	
			trail.rollangle = a
			PSO.lib.fixSplatScale(trail)

		else
			trail.sprite = SPR_DSTL
			trail.frame = A|TR_TRANS30|FF_PAPERSPRITE
			trail.angle = mo.player.drawangle + pos[5]
			trail.rollangle = a
			trail.spritexscale = FRACUNIT
			trail.spriteyscale = FRACUNIT			
		end
		
		trail.tics = 10
		trail.fuse = 10						
		trail.color = winfo.effectcolor or SKINCOLOR_CYAN
		
		if da
			trail.destscale = $*3
		end
	end
end

freeslot("MT_PSO_SABERQUICKGASH")
mobjinfo[MT_PSO_SABERQUICKGASH] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	radius = 16<<FRACBITS,
	height = 16<<FRACBITS,
	flags = MF_NOGRAVITY,
	spawnhealth = 1000,
}

addHook("MobjThinker", function(mo)
	
	mo.extravalue1 = $+1
	
	if mo.extravalue1 == 1
		mo.layers = {}
		S_StartSound(mo, sfx_s3kcel)
	end
	print(mo.pso.savewpn)
	
	if leveltime%3 == 0
	and mo.extravalue2 > 1
		local a = P_RandomRange(1, 359)*ANG1
		local x = mo.x + 8*cos(a)
		local y = mo.y + 8*sin(a)
		local l = P_SpawnMobj(x, y, mo.z, MT_DUSTLAYER)
		l.colorized = true
		l.color = mo.color
		l.dist = 8*FRACUNIT
		l.angle = a
		l.momz = mo.scale*3
		l.scale = mo.scale/4
		l.destscale = mo.scale
		mo.layers[#mo.layers+1] = l
	end
	
	local i = #mo.layers
	while i
		
		local l = mo.layers[i]
		if not l or not l.valid
			table.remove(mo.layers, i)
			i = $-1
			continue
		end
		
		local x = mo.x + FixedMul(l.dist, cos(l.angle))
		local y = mo.y + FixedMul(l.dist, sin(l.angle))
		P_MoveOrigin(l, x, y, l.z)
		
		l.angle = $ + ANG1*20
		l.dist = $ + FRACUNIT/2
		l.tics = min($, 12)
		
		i = $-1
	end
	
	if mo.extravalue1%20 == 0
		local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z - mo.scale*64, 128<<FRACBITS, 140<<FRACBITS, mo.target, mo.pso.potency/6, DMT_STRIKE, 3)
		--print(mo.pso.savewpn)
		--print(PSO.lib.getItemName(mo.pso.savewpn))
		PSO.lib.copyWeaponProperties(mo, hb)
		hb.pso.combobreaker = true	
		hb.pso.potency = mo.pso.potency/6
		mo.extravalue2 = $-1
		
		if not mo.extravalue2
			P_RemoveMobj(mo)
		end
	end
	
end, MT_PSO_SABERQUICKGASH)

PSO.info.photonArts["dsaber_pa_quickgash"] = {
		name = "Quick Gash",
		desc = "A quick swing before leaping backwards, leaving a tornado dealing damage over time on the field.",
		cost = 25,
		potency = 1000,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_DSABR6",
		
		use = 	function(p, timer, hold, input, combo)
					
					local slamtime = TICRATE
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					-- set pos floorsprite
					
					if timer == 1
						mo.momx = $/6
						mo.momy = $/6
					end
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}

					
					pos[7] = {
						use = true,
						o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
						xy = p.drawangle + ANG1*120,	-- tilt sideways
						za = ANG1*60,
					}
						
					local ang

					if mo.swordangle == nil
						mo.swordangle = 0
					end
						
					if timer < 3
						mo.swordangle = -ANG1*140
					elseif timer < TICRATE/2
						local nt = timer-3
						mo.swordangle = $ + max(0, ANG1*(40 - (nt-2)*5))
					end
						
					local ang = p.drawangle + mo.swordangle
					local x = 64 * cos(ang)
					local y = 64 * sin(ang)
						
					pos[2] = x
					pos[3] = y
					pos[4] = mo.height/2
					pos[5] = 0
					pos[6] = ang
					
					if timer == TICRATE/6
						mo.momz = mo.scale*6
						mo.state = S_PLAY_SPRING
						P_InstaThrust(mo, mo.angle, -FRACUNIT*8)
						
						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						S_StartSound(mo, sfx_s3ka0)

						local x = mo.x + 96*cos(p.drawangle)
						local y = mo.y + 96*sin(p.drawangle)
						local hb = PSO.lib.spawnHurtBox(x, y, mo.z - mo.scale*64, 140<<FRACBITS, 384<<FRACBITS, mo, potency/6, DMT_STRIKE, 3)
						hb.pso.combobreaker = true
						hb.angle = mo.angle
						hb.pso.hitlag = 4
						hb.pso.screenshake = {intensity = FRACUNIT*4, time=4}						
							
						local da = p.drawangle - ANG1*45
						for i = 1, 16
							local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
							P_InstaThrust(d, da, FRACUNIT*P_RandomRange(96, 128))
							d.momz = P_RandomRange(0, 4)*mo.scale
							d.scale = mo.scale*2
							d.renderflags = $|RF_PAPERSPRITE
							d.angle = da + ANG1*90
							d.tics = $ + P_RandomRange(1, 6)
							d.destscale = mo.scale*3
								
							da = $ + (90/16)*ANG1
						end	
						
						if mo.quickgash and mo.quickgash.valid
							P_RemoveMobj(mo.quickgash)
						end
						
						local w = PSO.lib.spawnMissile(mo, MT_PSO_SABERQUICKGASH, p.drawangle, 0, potency, DMT_STRIKE, 0, 0, 0)
						mo.quickgash = w
						P_SetOrigin(w, hb.x, hb.y, hb.z+FRACUNIT*64)
						w.extravalue2 = 5
						w.color = winfo.effectcolor or SKINCOLOR_CYAN
						
						
					elseif timer >= TICRATE/6
						if leveltime & 1
							local g = P_SpawnGhostMobj(mo)
							g.colorized = true
						end
						mo.momz = $ - P_GetMobjGravity(mo)/2
					end
					
					if timer > 1
						saber_trail(mo, pos, prevswordpos)
					end
					
					if timer == TICRATE*3/4 -5
						return true
					end
					--end
				end,
}

PSO.info.photonArts["dsaber_pa_surprisedunk"] = {
		name = "Surprise Dunk",
		desc = "Leap towards the target and plunge your blade into them, closing the distance quickly.",
		icon = "H_DSABR5",
		cost = 20,
		potency = 550,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still

		use = 	function(p, timer, hold, input, combo)

					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))

					-- for interpolation.
					local prevsaberpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}					
					
					if timer == 1
					
						pos[2] = 0
						pos[3] = 0
						pos[4] = mo.height*12/10
						pos[5] = 0
						pos[6] = 0
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height*12/10},
							xy = 0,
							za = 0,
						}
						
						S_StartSound(mo, sfx_s3ka0)
						p.pso.avengerguard = 1	-- lasts for 7f, only useful if the player has arts avenger.
						p.pso.iframes = TICRATE/2	-- .5s of iframes
						
						-- compute where we're going to land...
						if p.pso.target and p.pso.target.valid
							
							local f_ang = R_PointToAngle2(mo.x, mo.y, p.pso.target.x, p.pso.target.y)
							
							local dist = p.pso.target.radius + FRACUNIT*48
							local tx = p.pso.target.x - FixedMul(dist, cos(f_ang))
							local ty = p.pso.target.y - FixedMul(dist, sin(f_ang))
							local tz = p.pso.target.z
							
							mo.jumptarget = P_SpawnMobj(tx, ty, tz, MT_THOK)
							mo.jumptarget.state = S_INVISIBLE
							mo.jumptarget.tics = 2
						else
							
							-- make up a target in front of us
							local dist = 512
							local tx = mo.x + dist*cos(p.drawangle)
							local ty = mo.y + dist*sin(p.drawangle)
							local tz = mo.z
							
							mo.jumptarget = P_SpawnMobj(tx, ty, tz, MT_THOK)
							mo.jumptarget.state = S_INVISIBLE
							mo.jumptarget.tics = 2
						end
						
						-- leap towards the target
						local airtime = TICRATE/2
						local t = mo.jumptarget
						
						local a = R_PointToAngle2(mo.x, mo.y, t.x, t.y)
						local dist = min(mo.scale*680, R_PointToDist2(mo.x, mo.y, t.x, t.y))
						local horz = dist / airtime
						
						local gravity = -P_GetMobjGravity(mo)*2	-- 2x gravity will make this look cooler
						local vert = FixedMul((gravity*airtime)/2, mo.scale)
						
						P_InstaThrust(mo, a, horz)
						p.drawangle = a
						mo.state = S_PLAY_SPRING
						mo.momz = vert
						mo.z = $+1
						mo.groundtimer = 0
					else
						
						if not P_IsObjectOnGround(mo)
							
							if timer < TICRATE/4
								pos[7] = {
									use = true,
									o = {x = mo.x, y = mo.y, z = mo.z + mo.height*12/10},
									xy = p.drawangle,
									za = ANG1*30,
								}
								
								pos[6] = $ + ANG1*45
								
								if timer%5 == 0
								and winfo.sound
									S_StartSound(mo, winfo.sound)
								end
								
							else
								local t2 = timer - TICRATE/4
								local h_an = p.drawangle
								local v_an = (-30 + min(t2, 7)*13)*ANG1
								local dist = 64
								
								local posa = FixedMul(mo.scale, sin(v_an)*dist)
								local tx = FixedMul(cos(h_an), posa)
								local ty = FixedMul(sin(h_an), posa)
								local tz = mo.height/2 + FixedMul(mo.scale, dist*cos(v_an))
								
								pos[2] = tx
								pos[3] = ty
								pos[4] = tz
								pos[5] = ANG1*5
								pos[6] = -(v_an)	
								pos[7] = {use=false}
							end
							
							if leveltime & 1
								local g = P_SpawnGhostMobj(mo)
								g.colorized = true
							end
							mo.momz = $ + P_GetMobjGravity(mo)
						else
							P_InstaThrust(mo, 0, 0)
							
							mo.groundtimer = $+1
							
							if mo.groundtimer == 1
								p.pso.cancancel = 4

								local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
								local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
								local hb = PSO.lib.spawnHurtBox(x, y, mo.z - mo.scale*64, 166<<FRACBITS, 140<<FRACBITS, mo, potency, DMT_STRIKE, 2, RT_BLOWDOWN)
								hb.pso.reactionstrength = 7
								hb.angle = p.drawangle
								hb.pso.combobreaker = true
								
								for i = 1, 16
									
									local xp = x + P_RandomRange(-64, 64)*mo.scale
									local yp = y + P_RandomRange(-64, 64)*mo.scale
									local s = P_SpawnMobj(xp, yp, mo.z, MT_SPINDUST)
									
									s.momx = P_RandomRange(-32, 32)*mo.scale
									s.momy = P_RandomRange(-32, 32)*mo.scale
									s.momz = P_RandomRange(2, 9)*mo.scale
								end
								
								for i = 1, 2
									for j = 1, 16
										
										local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
										local a = (360/16)*j*ANG1
										d.angle = a + ANG1*90
										d.renderflags = $|RF_PAPERSPRITE
										
										P_InstaThrust(d, a, 24*FRACUNIT*i)
										d.momx = $ + mo.momx
										d.momy = $ + mo.momy
									end
								end
								
								S_StartSound(mo, sfx_pstop)
								
							end
							
							if mo.groundtimer >= TICRATE/3
								return true
							end
						end
						
					end
					
					if timer > 1
						saber_trail(mo, pos, prevsaberpos)
					end
				end,
}



PSO.info.photonArts["dsaber_pa_tornadodance"] = {
		name = "Tornado Dance",
		desc = "Throw the Saber in a circular motion around you, damaging and knocking away nearby enemies.",
		cost = 0,
		icon = "H_DSABR4",
		cost = 30,
		potency = 850,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still

		use = 	function(p, timer, hold, input, combo)

					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))

					-- for interpolation.
					local prevsaberpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}					
					
					if timer == 1
						p.pso.avengerguard = 1	-- lasts for 7f, only useful if the player has arts avenger.
						S_StartSound(mo, sfx_s3ka0)
					end
						
					if timer <= 3
						-- quickly swing the saber by our side.
						mo.swordangle = nil
						local ang = p.drawangle + ANG1*180 + (180/4)*(timer-1)*ANG1
							
						local x = 32*cos(ang)
						local y = 32*sin(ang)
						local z = FixedMul(FixedDiv(mo.height, mo.scale), FRACUNIT/4 * (timer-1))
							
						pos[2] = x
						pos[3] = y
						pos[4] = z
						pos[5] = ang + ANG1*90 - p.drawangle
						pos[6] = -ANG1*30
						pos[7] = {use = false}
					end
					if timer < TICRATE/4
							
						local t = (timer - 3)
						local ang = p.drawangle - ANG1*max(0, 20-t*3)
						local dist = 32-(t*8)
							
						local px = dist*cos(ang)
						local py = dist*sin(ang)
						local pz = FixedMul(FixedDiv(mo.height, mo.scale), FRACUNIT*3/4 + t*FRACUNIT/6)							
							
						pos[2] = px
						pos[3] = py
						pos[4] = pz
						pos[5] = 0
						pos[6] = -ANG1*30 + (t*48)*ANG1
							
						pos[7] = {
							use = true,
							o = {x = mo.x + px, y = mo.y + py, z = mo.z + pz},	-- the center of the slope is the center of the player.
							xy = p.drawangle,
							za = -ANG1*max(0, (45 - t*8))
						}
					elseif timer < TICRATE*3/4 -12

						local t = timer - TICRATE/4
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height*3/4},	-- the center of the slope is the center of the player.
							xy = p.drawangle - ANG1*90,	-- tilt sideways
							za = ANG1*min(t*5, 10),
						}
						
						if mo.swordangle == nil
							mo.swordangle = $ or -ANG1*20
						end
						mo.swordangle = $ - ANG1*max(0, (35 - t*4))
							
						local ang = p.drawangle + mo.swordangle
						local x = 24 * cos(ang)
						local y = 24 * sin(ang)
							
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height*3/4
						pos[5] = 0
						pos[6] = ang

					-- spawn the fake
					elseif timer == TICRATE*3/4 -12
						-- hack: make the saber invisible by sending it like 398201413271892 feet underground
						pos[4] = -9999*FRACUNIT
						
						-- spawn a fake boomerang sb!
						local fake = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height, MT_THOK)
						fake.sprite = winfo.sprite
						if winfo.splatcombatframe
							fake.frame = winfo.combatsplatframe
						elseif winfo.comboframe
							fake.frame = winfo.combatframe
						elseif winfo.splatframe
							fake.frame = winfo.splatframe
						else
							fake.frame = winfo.frame
						end
						
						fake.color = winfo.color or SKINCOLOR_NONE
						
						P_CreateFloorSpriteSlope(fake)
						fake.flags2 = $ | MF2_SPLAT
						fake.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
						
						mo.fakesaber = fake
						fake.ta = R_PointToAngle2(mo.x, mo.y, fake.x, fake.y)
						fake.dist = R_PointToDist2(mo.x, mo.y, fake.x, fake.y)

						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						
						S_StartSound(mo, sfx_s3k81)
						--S_StartSoundAtVolume(mo, sfx_s3k8e, 127)
					end
					
					if timer >= TICRATE*3/4 -12
						local t = timer - (TICRATE*3/4 - 12)
						
						
						if mo.saberangle == nil
							mo.saberangle = p.drawangle
						end
						
						local fake = mo.fakesaber	
						
						-- shouldn't happen???
						if not fake or not fake.valid
							return true
						end

						-- for interpolation.
						local prevsaberpos = {
							fake.x - mo.x,
							fake.y - mo.y,
							fake.z - mo.z,
							fake.rollangle,	-- rollangle
						}
						
						fake.floorspriteslope.o = {x = fake.x, y = fake.y, z = fake.z}
						fake.floorspriteslope.xydirection = fake.ta
						fake.floorspriteslope.zangle = min(timer, 10)*ANG1						
						fake.rollangle = $ + ANG1*45
						fake.tics = 5
						
						local xpos = mo.x + FixedMul(fake.dist, cos(fake.ta))
						local ypos = mo.y + FixedMul(fake.dist, sin(fake.ta))
						P_MoveOrigin(fake, xpos, ypos, mo.z + mo.height)
						
						fake.ta = $ + ANG1*20
						
						if t < TICRATE/2
							fake.dist = min(FRACUNIT*96, $+FRACUNIT*16)
						else
							fake.dist = max(0, $ - FRACUNIT*6)
						end
						
						if t == 1
						or t == TICRATE/2
							local h = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z - mo.scale*64, 455<<FRACBITS, 140<<FRACBITS, mo, potency/4, DMT_STRIKE, 4)
							h.pso.combobreaker = true
							h.pso.hitlag = 4
							h.pso.screenshake = {intensity = FRACUNIT*4, time=4}
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end	
							
							
						elseif t == TICRATE
							local h = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z - mo.scale*64, 455<<FRACBITS, 140<<FRACBITS, mo, potency/2, DMT_STRIKE, 4, RT_BLOWDOWN)
							h.pso.reactionradialangle = true
							h.pso.combobreaker = true
							h.pso.hitlag = 4
							h.pso.screenshake = {intensity = FRACUNIT*6, time=6}
							
							S_StartSound(mo, sfx_s3kb6)
							
							for i = 1, 2
								for j = 1, 16
									
									local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
									local a = (360/16)*j*ANG1
									d.angle = a + ANG1*90
									d.renderflags = $|RF_PAPERSPRITE
									
									if i > 1
										d.spritexscale = $*2
									end
									
									d.destscale = $*4
									
									P_InstaThrust(d, a, 32*FRACUNIT*i)
									d.momx = $ + mo.momx
									d.momy = $ + mo.momy
								end
							end
							
							return true
						end
						
						-- it's all make believe!
						local fakepos = {
							nil,
							fake.x - mo.x + fake.momx,
							fake.y - mo.y + fake.momy,
							fake.z - mo.z + fake.momz,
							0,
							fake.rollangle,
							{
								use = true,
								o = {x = fake.x, y = fake.y, z = fake.z},
								xy = fake.floorspriteslope.xydirection,
								za = fake.floorspriteslope.zangle,
							}
						}
						
						saber_trail(mo, fakepos, prevsaberpos, true)
					end
					
				end,
}

PSO.info.photonArts["dsaber_pa_spinadvance"] = {
		name = "Spin Advance",
		desc = "Push forward, spinning the Saber in front of yourself to push enemies along with you, negating damage coming from the front.",
		icon = "H_DSABR2",
		cost = 30,
		potency = 900,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still

		use = 	function(p, timer, hold, input, combo)

					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))

					-- for interpolation.
					local prevsaberpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}					
					
					if timer == 1
						mo.saberangle = p.drawangle
						
						local dist = 32
						local x = dist*cos(mo.saberangle)
						local y = dist*sin(mo.saberangle)
						local z = mo.height/2
						
						pos[2] = x
						pos[3] = y
						pos[4] = z
						pos[5] = ANG1*90
						
						mo.state = S_PLAY_WALK
						
						p.pso.avengerguard = 1
						p.pso.mitigations = {
							{p.mo.angle - ANG1*60, p.mo.angle + ANG1*60}
						}
					end
					
					if mo.saberangle == nil
						mo.saberangle = p.drawangle
					end
					
					p.cmd.angleturn = mo.saberangle/FRACUNIT
					pos[6] = $ + ANG1*45
					
					if FixedHypot(mo.momx, mo.momy) < mo.scale*12
						P_InstaThrust(mo, mo.saberangle, mo.scale*12)
					end
					
					-- trail
					if timer > 1
						saber_trail(mo, pos, prevsaberpos)
					end

					for i = 1, 5
						if timer == (TICRATE/5 -1)* i
							local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
							local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z - mo.scale*64, 166<<FRACBITS, 140<<FRACBITS, mo, potency/5, DMT_STRIKE, 2, RT_KNOCKBACK)
							hb.angle = p.drawangle
							hb.pso.combobreaker = true
							hb.pso.reactionstrength = i == 5 and 40 or 12
							hb.pso.hitlag = 4
							hb.pso.screenshake = {intensity = FRACUNIT*4, time=4}							

							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end		
						end
					end
					
					if timer == TICRATE
						return true
					end
				end,
}

freeslot("MT_PSO_DEADLYARCHER")
mobjinfo[MT_PSO_DEADLYARCHER] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 32<<FRACBITS,
	height = 32<<FRACBITS,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT,
}

addHook("MobjThinker", function(mo)
	
	if not mo.target or not mo.target.valid
	or not mo.target.player
	or not mo.target.player.pso
	or mo.target.player.pso.action ~= "dsaber_pa_deadlyarcher"
		P_RemoveMobj(mo)
		return
	end
	
	mo.timer = $ or 1
	mo.prevtimer = $ or 0	-- used for attack speeds below 100%
	mo.saveacttimer = mo.target.player.pso.actiontimer	--$ and $+1 or 1
	mo.tics = -1
	
	local diff = max(1, mo.saveacttimer - mo.prevtimer)
	-- process logic multiple times for attack speeds ABOVE 100%....
	for k = 1, diff
		
		--print(mo.prevtimer.." | "..mo.timer)
		--print("t: "..mo.timer..", iter: "..diff.." ("..k..")")
		
		local prevsaberpos = {
			mo.x - mo.target.x,
			mo.y - mo.target.y,
			mo.z - mo.target.z,
			mo.rollangle,	-- rollangle
		}
						
		mo.floorspriteslope.o = {x = mo.x, y = mo.y, z = mo.z}
		mo.floorspriteslope.xydirection = mo.ta + ANG1*90
		mo.floorspriteslope.zangle = min(mo.timer, 30)*ANG1
		if not mo.fakehitlag
			mo.rollangle = $ + ANG1*45
		end
						
		--local ang = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
		--P_Thrust(mo, ang, FRACUNIT*6/10)
		local returning =  mo.timer >= TICRATE/2 + 22
		
		if mo.fakehitlag
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			mo.fakehitlag = $-1
			if not mo.fakehitlag
				mo.momx = mo.retainmom[1]
				mo.momy = mo.retainmom[2]
				mo.momz = mo.retainmom[3]
			end
			
		elseif not returning
			mo.momx = $*92/100
			mo.momy = $*92/100
			mo.momz = $*92/100
		else
			local frames = 10
			local progress = mo.timer - (TICRATE/2 +22)
			
			local scale = progress*FRACUNIT/frames
			mo.momx = ease.inoutsine(scale, mo.x, mo.target.x) - mo.x
			mo.momy = ease.inoutsine(scale, mo.y, mo.target.y) - mo.y
			mo.momz = ease.inoutsine(scale, mo.z, mo.target.z+mo.target.height/2) - mo.z
			
		end
						
		-- it's all make believe!
		local fakepos = {
			nil,
			mo.x - mo.target.x + mo.momx,
			mo.y - mo.target.y + mo.momy,
			mo.z - mo.target.z + mo.momz,
			0,
			mo.rollangle,
			{
				use = true,
				o = {x = mo.x, y = mo.y, z = mo.z},
				xy = mo.floorspriteslope.xydirection,
				za = mo.floorspriteslope.zangle,
			}
		}
		
		if not returning and not mo.fakehitlag
			saber_trail(mo.target, fakepos, prevsaberpos, true)
		end

		for i = 1, 5
			if mo.timer == (TICRATE/2) + (i-1)*4
			and mo.timer ~= mo.prevtimer
				local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z-mo.scale*64, 255<<FRACBITS, 140<<FRACBITS, mo.target, mo.pso.potency/5, DMT_STRIKE, 2)
				hb.angle = mo.target.player.drawangle
				hb.pso.locks = 2
				hb.pso.combobreaker = true
				hb.pso.screenshake = {intensity = FRACUNIT*4, time=4}
				P_SetOrigin(hb, hb.x, hb.y, hb.z)
				if hb.pso.whitelist	-- we hit something~
					-- hitlag!
					mo.fakehitlag = 3
					mo.retainmom = {mo.momx, mo.momy, mo.momz}
				end

				/*if winfo.sound
					S_StartSound(mo, winfo.sound)
				end	*/
								
			end
		end
		mo.prevtimer = mo.timer
		if (mo.saveacttimer - mo.prevtimer > 0)
			mo.timer = $+1
		end
	end
	
end, MT_PSO_DEADLYARCHER)

PSO.info.photonArts["dsaber_pa_deadlyarcher"] = {
		name = "Deadly Archer",
		desc = "Throw the Saber forward like a boomerang, shreadding the enemy in its wake.",
		icon = "H_DSABR3",
		potency = 810,
		cost = 30,
		speed = 30,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		use = 	function(p, timer, hold, input, combo)

					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					-- set pos floorsprite
										
					if timer == 1
						-- hack: make the saber invisible by sending it like 398201413271892 feet underground
						pos[4] = -9999*FRACUNIT
						
						mo.momx = $/3
						mo.momy = $/3
						
						-- spawn a fake boomerang sb!
						--local fake = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height, MT_PSO_DEADLYARCHER)
						local fake = PSO.lib.spawnMissile(mo, MT_PSO_DEADLYARCHER, 0, 0, potency, DMT_MELEE, 0, 0, 0)
						P_SetOrigin(fake, mo.x, mo.y, mo.z+mo.height)
						fake.sprite = winfo.sprite
						if winfo.splatcombatframe
							fake.frame = winfo.combatsplatframe
						elseif winfo.comboframe
							fake.frame = winfo.combatframe
						elseif winfo.splatframe
							fake.frame = winfo.splatframe
						else
							fake.frame = winfo.frame
						end
						
						fake.color = winfo.color or SKINCOLOR_NONE
						
						P_CreateFloorSpriteSlope(fake)
						fake.flags2 = $ | MF2_SPLAT
						fake.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
						
						mo.fakesaber = fake
						local spd = FixedHypot(mo.momx, mo.momy)
						P_InstaThrust(fake, p.drawangle, mo.scale*13 + spd)
						fake.ta = p.drawangle

						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end	
						
						S_StartSound(mo, sfx_s3k81)
						--S_StartSoundAtVolume(mo, sfx_s3k8e, 127)
						
						p.pso.avengerguard = 1
					end

					if mo.saberangle == nil
						mo.saberangle = p.drawangle
					end
					
					local fake = mo.fakesaber
					
					-- shouldn't happen???
					if not fake or not fake.valid
						return true
					end
					
					if timer == TICRATE*3/2-5
						return true
					end
					
		end,
}

PSO.info.photonArts["dsaber_normal"] = {
		name = "Attack",
		desc = "A series of stylish slashes that can be used up to 3 times in a row.",
		cost = 0,
		normal = true,
		potency = 300,
		speed = 30,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		combo = TICRATE*20,	-- hack for the 3-hit combo
		icon = "H_DSABR1",

		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevsaberpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					-- slash 1:
					if not combo
						
						if timer <= 3
							-- quickly swing the saber by our side.
							mo.swordangle = nil
							local ang = p.drawangle + ANG1*180 + (180/4)*(timer-1)*ANG1
							
							local x = 32*cos(ang)
							local y = 32*sin(ang)
							local z = FixedMul(FixedDiv(mo.height, mo.scale), FRACUNIT/4 * (timer-1))
							
							pos[2] = x
							pos[3] = y
							pos[4] = z
							pos[5] = ang + ANG1*90 - p.drawangle
							pos[6] = -ANG1*30
							pos[7] = {use = false}
						end
						if timer < TICRATE/4
							
							if timer == 3
							or timer == 7
								local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
								local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
								local hb = PSO.lib.spawnHurtBox(x, y, mo.z - mo.scale*64, 166<<FRACBITS, 140<<FRACBITS, mo, potency/4, DMT_STRIKE, 2)
								--hb.pso.potency = potency	-- normals shouldn't benefit from PA%
								hb.pso.ppregen = 4
								hb.pso.locks = 3
								hb.angle = p.drawangle
								hb.pso.hitlag = 2
								hb.pso.screenshake = {intensity = FRACUNIT*4, time=2}									
								
								if winfo.sound
									S_StartSound(mo, winfo.sound)
								end
								
								if timer == 7	
									p.pso.cancancel = 6
								end
							end
							
							local t = (timer - 3)
							local ang = p.drawangle - ANG1*max(0, 20-t*3)
							local dist = 32-(t*8)
							
							local px = dist*cos(ang)
							local py = dist*sin(ang)
							local pz = FixedMul(FixedDiv(mo.height, mo.scale), FRACUNIT*3/4 + t*FRACUNIT/6)							
							
							pos[2] = px
							pos[3] = py
							pos[4] = pz
							pos[5] = 0
							pos[6] = -ANG1*30 + (t*48)*ANG1
							
							pos[7] = {
								use = true,
								o = {x = mo.x + px, y = mo.y + py, z = mo.z + pz},	-- the center of the slope is the center of the player.
								xy = p.drawangle,
								za = -ANG1*max(0, (45 - t*8))
							}
						
						elseif timer < TICRATE*3/4 -5

							local t = timer - TICRATE/4
							pos[7] = {
								use = true,
								o = {x = mo.x, y = mo.y, z = mo.z + mo.height*3/4},	-- the center of the slope is the center of the player.
								xy = p.drawangle - ANG1*90,	-- tilt sideways
								za = ANG1*min(t*5, 30),
							}
						
							if mo.swordangle == nil
								mo.swordangle = $ or ANG1*20
							end
							mo.swordangle = $ + ANG1*max(0, (30 - t*4))
							
							local ang = p.drawangle + mo.swordangle
							local x = 24 * cos(ang)
							local y = 24 * sin(ang)
							
							pos[2] = x
							pos[3] = y
							pos[4] = mo.height*3/4
							pos[5] = 0
							pos[6] = ang
							
							if timer == TICRATE*3/4
								local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
								local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
								local hb = PSO.lib.spawnHurtBox(x, y, mo.z - mo.scale*64, 166<<FRACBITS, 140<<FRACBITS, mo, potency/2, DMT_STRIKE, 2)
								--hb.pso.potency = potency	-- normals shouldn't benefit from PA%
								hb.pso.ppregen = 5
								hb.angle = p.drawangle	
								hb.pso.locks = 3
								hb.pso.hitlag = 2
								hb.pso.screenshake = {intensity = FRACUNIT*4, time=2}								

								if winfo.sound
									S_StartSound(mo, winfo.sound)
								end
								
								p.pso.cancancel = 4
								
							end
							
						elseif timer < TICRATE
							p.pso.actiontimer = TICRATE*30 - (TICRATE/4)
						end
					
					-- 2nd slash
					elseif combo == 1

						
						if timer <= 3
							-- quickly swing the saber by our side.
							mo.swordangle = nil
							local ang = p.drawangle + ANG1*180 - (180/4)*(timer-1)*ANG1
							
							local x = 32*cos(ang)
							local y = 32*sin(ang)
							local z = FixedMul(FixedDiv(mo.height, mo.scale), FRACUNIT/4 * (timer-1))
							
							pos[2] = x
							pos[3] = y
							pos[4] = z
							pos[5] = ang + ANG1*90 - p.drawangle
							pos[6] = -ANG1*30
							pos[7] = {use = false}
						end
						
						if timer < TICRATE/4
							
							local t = (timer - 3)
							local ang = p.drawangle + ANG1*max(0, 20-t*3)
							local dist = 32-(t*8)
							
							local px = dist*cos(ang)
							local py = dist*sin(ang)
							local pz = FixedMul(FixedDiv(mo.height, mo.scale), FRACUNIT*3/4 + t*FRACUNIT/6)							
							
							pos[2] = px
							pos[3] = py
							pos[4] = pz
							pos[5] = 0
							pos[6] = -ANG1*30 - (t*48)*ANG1
							
							pos[7] = {
								use = true,
								o = {x = mo.x + px, y = mo.y + py, z = mo.z + pz},	-- the center of the slope is the center of the player.
								xy = p.drawangle,
								za = -ANG1*max(0, (45 - t*8))
							}

							if timer == 3
							or timer == 7
								local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
								local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
								local hb = PSO.lib.spawnHurtBox(x, y, mo.z - mo.scale*64, 166<<FRACBITS, 140<<FRACBITS, mo, potency/4, DMT_STRIKE, 2)
								--hb.pso.potency = potency	-- normals shouldn't benefit from PA%
								hb.pso.ppregen = 4
								hb.angle = p.drawangle
								hb.pso.locks = 3
								hb.pso.hitlag = 2
								hb.pso.screenshake = {intensity = FRACUNIT*4, time=2}								

								if winfo.sound
									S_StartSound(mo, winfo.sound)
								end

								if timer == 7	
									p.pso.cancancel = 6
								end
								
							end
						
						elseif timer < TICRATE*3/4 -5

							local t = timer - TICRATE/4
							pos[7] = {
								use = true,
								o = {x = mo.x, y = mo.y, z = mo.z + mo.height*3/4},	-- the center of the slope is the center of the player.
								xy = p.drawangle - ANG1*90,	-- tilt sideways
								za = ANG1*min(t*5, 10),
							}
						
							if mo.swordangle == nil
								mo.swordangle = $ or -ANG1*20
							end
							mo.swordangle = $ - ANG1*max(0, (35 - t*4))
							
							local ang = p.drawangle + mo.swordangle
							local x = 24 * cos(ang)
							local y = 24 * sin(ang)
							
							pos[2] = x
							pos[3] = y
							pos[4] = mo.height*3/4
							pos[5] = 0
							pos[6] = ang

							if timer == TICRATE*3/4
								local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
								local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
								local hb = PSO.lib.spawnHurtBox(x, y, mo.z - mo.scale*64, 166<<FRACBITS, 140<<FRACBITS, mo, potency/2, DMT_STRIKE, 2)
								--hb.pso.potency = potency	-- normals shouldn't benefit from PA%
								hb.pso.ppregen = 6
								hb.pso.locks = 1
								hb.angle = p.drawangle	
								hb.pso.hitlag = 2
								hb.pso.screenshake = {intensity = FRACUNIT*4, time=2}								

								if winfo.sound
									S_StartSound(mo, winfo.sound)
								end
								
								p.pso.cancancel = 4
								
							end
							
						elseif timer < TICRATE
							p.pso.actiontimer = TICRATE*30 - (TICRATE/4)
						end
					
					-- 3rd slash
					elseif combo == 2

						
						if timer <= 10
							-- quickly swing the saber by our side.
							mo.swordangle = nil
							local ang = p.drawangle + ANG1*180 + (180/6)*(timer-1)*ANG1
							
							local x = 32*cos(ang)
							local y = 32*sin(ang)
							local z = FixedMul(FixedDiv(mo.height, mo.scale), FRACUNIT/6 * (timer-1))
							
							pos[2] = x
							pos[3] = y
							pos[4] = z
							pos[5] = ang + ANG1*90 - p.drawangle
							pos[6] = -ANG1*30
							pos[7] = {use = false}
							
						elseif timer < TICRATE*3/4
							
							local t = (timer - 10)
							local ang = p.drawangle - ANG1*max(0, 20-t*3)
							local dist = max(0, 32-(t*8))
							
							local px = dist*cos(ang)
							local py = dist*sin(ang)
							local pz = FixedMul(FixedDiv(mo.height, mo.scale), min(FRACUNIT*12/10, FRACUNIT*3/4 + t*FRACUNIT/9))					
							
							pos[2] = px
							pos[3] = py
							pos[4] = pz
							pos[5] = 0
							pos[6] = -ANG1*30 + (t*48)*ANG1
							
							pos[7] = {
								use = true,
								o = {x = mo.x + px, y = mo.y + py, z = mo.z + pz},	-- the center of the slope is the center of the player.
								xy = p.drawangle,
								za = -ANG1*max(0, (45 - t*8))
							}

							if timer == 12
							or timer == 16
							or timer == 21
								local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
								local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
								local hb = PSO.lib.spawnHurtBox(x, y, mo.z - mo.scale*64, 166<<FRACBITS, 140<<FRACBITS, mo, potency/2, DMT_STRIKE, 2)
								hb.pso.potency = potency/2	-- normals shouldn't benefit from PA%
								hb.pso.ppregen = 5
								hb.angle = p.drawangle
								hb.pso.hitlag = 4
								hb.pso.screenshake = {intensity = FRACUNIT*5, time=2}								

								if winfo.sound
									S_StartSound(mo, winfo.sound)
								end
								
							end
						
						elseif timer < TICRATE

							local t = timer - TICRATE*3/4
							pos[7] = {
								use = true,
								o = {x = mo.x, y = mo.y, z = mo.z + mo.height*3/4},	-- the center of the slope is the center of the player.
								xy = p.drawangle - ANG1*90,	-- tilt sideways
								za = ANG1*min(t*5, 30),
							}
						
							if mo.swordangle == nil
								mo.swordangle = $ or ANG1*20
							end
							mo.swordangle = $ + ANG1*max(0, (30 - t*4))
							
							local ang = p.drawangle + mo.swordangle
							local x = 24 * cos(ang)
							local y = 24 * sin(ang)
							
							pos[2] = x
							pos[3] = y
							pos[4] = mo.height*3/4
							pos[5] = 0
							pos[6] = ang

							if timer == TICRATE-6
								local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
								local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
								local hb = PSO.lib.spawnHurtBox(x, y, mo.z - mo.scale*64, 166<<FRACBITS, 140<<FRACBITS, mo, potency/2, DMT_STRIKE, 2)
								--hb.pso.potency = potency	-- normals shouldn't benefit from PA%
								hb.pso.ppregen = 5
								hb.angle = p.drawangle	
								hb.pso.hitlag = 2
								hb.pso.screenshake = {intensity = FRACUNIT*4, time=2}								

								if winfo.sound
									S_StartSound(mo, winfo.sound)
								end
								
								p.pso.cancancel = 7
								
							end
							
						elseif timer == TICRATE*3/2 + TICRATE/4
							return true
						end
					end
					
					-- trail
					if timer > 1
						saber_trail(mo, pos, prevsaberpos)
					end
					
					if timer == TICRATE*30
						return true
					end
					
					--P_SpawnMobj(mo.x+pos[2], mo.y+pos[3], mo.z+pos[4], MT_THOK)
					
				end,
}