-- Launcher Photon Arts

-- stuff for megido
freeslot("SPR_MEGI")
for i = 1, 10 do
	freeslot("S_MEGISTAR"..i)
end
for i = 1, 10 do
	states[S_MEGISTAR1+(i-1)] = {SPR_MEGI, (i-1)|FF_FULLBRIGHT, 2, nil, 0, 0, i < 4 and S_MEGISTAR1+i or S_NULL}
end

for i = 1, 4
	freeslot("S_PSO_LAEXPL"..i)
end

local durations = {3, 2, 1, 3, 3, 2}

for i = 1, 4
	states[S_PSO_LAEXPL1 + (i-1)] = {SPR_BARX, (i-1)|FF_FULLBRIGHT, durations[i], nil, 0, 0, (i < 4 and (S_PSO_LAEXPL1 +i) or S_NULL)}
end

freeslot("MT_PSO_LAUNCHERSHOT")
freeslot("S_PSO_LAUNCHERSHOT", "S_PSO_LAUNCHERSHOT_EXPLODE")
mobjinfo[MT_PSO_LAUNCHERSHOT] = {
	doomednum = -1,
	spawnstate = S_PSO_LAUNCHERSHOT,
	deathstate = S_PSO_LAUNCHERSHOT_EXPLODE,
	xdeathstate = S_PSO_LAUNCHERSHOT_EXPLODE,
	height = 64*FRACUNIT,
	radius = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_MISSILE,
	spawnhealth = 1000,
}

local homing_speed = FRACUNIT*64
local homing_accel = FRACUNIT*8

function A_LauncherShotVisual(actor, var1, var2)
	
	actor.renderflags = $|RF_FULLBRIGHT
		
	-- spawn some particle trail...
	local x = actor.x + P_RandomRange(-32, 32)*actor.scale
	local y = actor.y + P_RandomRange(-32, 32)*actor.scale
	local z = actor.z + P_RandomRange(-32, 32)*actor.scale
		
	local trail = P_SpawnMobj(x, y, z, MT_THOK)
	trail.scale = actor.scale*3/4
	trail.scalespeed = actor.scale/12
	trail.tics = 10
	trail.fuse = 10
	trail.frame = A|FF_FULLBRIGHT
	trail.color = actor.color
	

	if leveltime & 1
		
		local trail = P_SpawnMobj(actor.x, actor.y, actor.z, MT_THOK)
		trail.color = SKINCOLOR_WHITE
		trail.scale = actor.scale*3/2
		trail.tics = 2
		trail.fuse = 2
		trail.frame = A|FF_FULLBRIGHT
		
	end
	
	if actor.prevpos
		for i = 0, 5
			local x = PSO.lib.lerp(actor.prevpos[1], actor.x, FRACUNIT/5 *i)
			local y = PSO.lib.lerp(actor.prevpos[2], actor.y, FRACUNIT/5 *i)
			local z = PSO.lib.lerp(actor.prevpos[3], actor.z, FRACUNIT/5 *i)
			
			local trail = P_SpawnMobj(x, y, z, MT_THOK)
			trail.scale = actor.scale*3/4
			trail.destscale = 1
			trail.scalespeed = actor.scale/12
			trail.tics = 10
			trail.fuse = 10
			trail.frame = A|TR_TRANS50|FF_FULLBRIGHT
			trail.color = actor.color
		end
	end

	if actor.tracer and actor.tracer.valid
		local target = actor.tracer
		local dist = P_AproxDistance(P_AproxDistance(target.x - actor.x, target.y - actor.y), target.z - actor.z)
		
		-- normalize vakues
		local dx = FixedDiv(target.x - actor.x, dist)
		local dy = FixedDiv(target.y - actor.y, dist)
		local dz = FixedDiv(target.z - actor.z, dist)
		
		-- the values we want:
		local desired_momx = FixedMul(dx, homing_speed)
		local desired_momy = FixedMul(dy, homing_speed)
		local desired_momz = FixedMul(dz, homing_speed)
		
		-- how much we'd have to change by
		local steeringx = desired_momx - actor.momx
		local steeringy = desired_momy - actor.momy
		local steeringz = desired_momz - actor.momz
		
		-- cap acceleration
		if abs(steeringx) > homing_accel
			steeringx = (steeringx > 0 and 1 or -1) * homing_accel
		end

		if abs(steeringy) > homing_accel
			steeringy = (steeringy > 0 and 1 or -1) * homing_accel
		end
		
		if abs(steeringz) > homing_accel
			steeringz = (steeringz > 0 and 1 or -1) * homing_accel
		end	
		
		-- apply
		actor.momx = $ + steeringx
		actor.momy = $ + steeringy
		actor.momz = $ + steeringz
	end
	
	actor.frame = $|FF_FULLBRIGHT
	actor.prevpos = {actor.x, actor.y, actor.z}
end

function A_LauncherShotExplode(actor, var1, var2)
	
	local range = 64
	local scalefac = 1
	local hitradius = 600
	local reaction = RT_STAGGER
	
	if actor.extravalue1
		range = 128
		scalefac = 2
		hitradius = 1024
		reaction = RT_BLOWDOWN
	end
	
	for i = 1, 32
		local t = P_SpawnMobj(actor.x, actor.y, actor.z, MT_THOK)
		t.color = i & 1 and SKINCOLOR_WHITE or actor.color
		t.scale = actor.scale*scalefac
		t.destscale = 1
		t.scalespeed = actor.scale/8
		t.momx = P_RandomRange(-range, range)*actor.scale
		t.momy = P_RandomRange(-range, range)*actor.scale
		t.momz = P_RandomRange(-range, range)*actor.scale
		t.frame = A|TR_TRANS10|FF_FULLBRIGHT
		t.fuse = 20
		t.tics = 20
	end	
	
	local s = P_SpawnMobj(actor.x, actor.y, actor.z-actor.scale*420, MT_THOK)
	s.state = S_MEGISTAR1
	s.color = SKINCOLOR_WHITE
	s.scale = FRACUNIT*16
	s.destscale = 1
	s.scalespeed = FRACUNIT*3
	
	s = P_SpawnMobj(actor.x, actor.y, actor.z, MT_THOK)
	s.state = S_PSO_LAEXPL1
	s.colorized = true
	s.color = actor.color
	s.scale = scalefac*FRACUNIT
	
	local soundhelp = P_SpawnMobj(actor.x, actor.y, actor.z, MT_THOK)
	soundhelp.state = S_INVISIBLE
	soundhelp.tics = TICRATE*2
	S_StartSound(soundhelp, sfx_s3k4e)
	
	if not actor.pso return end
	
	-- spawn an explosion hitbox:
	local h = PSO.lib.spawnHurtBox(actor.x, actor.y, actor.z, hitradius<<FRACBITS, hitradius/8<<FRACBITS, actor.target, actor.pso.potency, DMT_RANGED, 4, reaction)
	PSO.lib.copyWeaponProperties(actor, h)
	if h.pso.whitelist
		actor.pso.whitelist = h.pso.whitelist
	else
		if not actor.pso.whitelist
			actor.pso.whitelist = {}
		end
		h.pso.whitelist = actor.pso.whitelist
	end
	h.pso.potency = actor.pso.potency
	h.pso.reactionradialangle = true
	h.pso.inflictjellen = actor.pso.inflictjellen
	h.pso.inflictzalure = actor.pso.inflictzalure
	h.pso.blight = actor.pso.blight
	
	h.pso.combobreaker = actor.pso.combobreaker
	
	if actor.extravalue1
		h.pso.combobreaker = true
		
		if consoleplayer and R_PointToDist2(consoleplayer.mo.x, consoleplayer.mo.y, actor.x, actor.y) < FRACUNIT*4096
			P_StartQuake(FRACUNIT*32, 10)
		end
		
		for i = 1, 8
			
			local d = P_SpawnMobj(actor.x + P_RandomRange(-256, 256)*FRACUNIT, actor.y + P_RandomRange(-256, 256)*FRACUNIT, actor.z + P_RandomRange(0, 256)*FRACUNIT, MT_TNTDUST)
			d.scale = P_RandomRange(3, 7)*FRACUNIT
			d.momz = P_RandomRange(1, 8)*FRACUNIT
			
			if consolepyaer and consoleplayer.mo
			and actor.target ~= consoleplayer.mo
				d.flags2 = $|MF2_DONTDRAW
			end
		end
		
	else
		if consoleplayer and R_PointToDist2(consoleplayer.mo.x, consoleplayer.mo.y, actor.x, actor.y) < FRACUNIT*1024
			P_StartQuake(FRACUNIT*10, 4)
		end	
	end
end

states[S_PSO_LAUNCHERSHOT] 		= {SPR_THOK, A|TR_TRANS30, 1, A_LauncherShotVisual, 0, 0, S_PSO_LAUNCHERSHOT}
states[S_PSO_LAUNCHERSHOT_EXPLODE] = {SPR_THOK, A|TR_TRANS30, 1, A_LauncherShotExplode, 0, 0, S_NULL}

PSO.info.photonArts["launcher_normal"] = {
		name = "Shot",
		desc = "Fires an explosive that can hit multiple targets with a blast.",
		normal = true,
		cost = 10,
		potency = 350,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_LAATK1",
		combo = TICRATE*3/4,
		
		-- p: player
		-- timer: how long the animation has played for
		-- hold: if true, button is being held down, if not, it's been released
		-- input: timer on how long the button has been held for
		-- combo: non-zero if the attack was performed from a combo.
					-- useful to create attacks that are faster/different if used repeatedly.
		
		-- return true to end the animation
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					--print(timer)
					-- set new weapon pos:
					local ang = p.drawangle - ANG1*50
					local x = 16*cos(ang)
					local y = 16*sin(ang)
					
					pos[2] = x
					pos[3] = y
					pos[5] = ANG1*5	-- lat. angle
					
					if timer == 1
						
						if combo
							--pos[5] = FixedDiv(mo.height, mo.scale)/2
							pos[6] = 0
							
						else	-- we've just started that attack
							local z = FixedDiv(mo.height/2, mo.scale)
							pos[4] = z
								
							-- set angle
							pos[6] = ANG1*90 -- vert. angle
						end
					end
					
					if timer < 10
					and not combo
						pos[6] = $ - ANG1*10
						pos[4] = $ - FixedDiv(mo.height, mo.scale)/20
					elseif timer == 10
						pos[6] = 0
					end
					
					
					if timer == 17
						pos[6] = ANG1*30
						
						p.pso.cancancel = 8
						
						-- fire the bullet!
						local msl = PSO.lib.spawnMissile(mo, MT_PSO_LAUNCHERSHOT, p.drawangle, 65*FRACUNIT, potency, DMT_RANGED, pos[2], pos[3], mo.scale*8)

						if PSO.lib.hasSkill(p, "ra_jellenshot")
							msl.pso.inflictjellen = TICRATE*3
						end

						if PSO.lib.hasSkill(p, "ra_zalureshot")
							msl.pso.inflictzalure = TICRATE*3
						end
						
						if winfo.effectcolor
							msl.color = winfo.effectcolor
						else
							msl.color = PSO.info.elementColours[wep.element]
						end	

						
						for i = 1, 8
							local t = P_SpawnMobj(msl.x, msl.y, msl.z, MT_THOK)
							t.color = msl.color
							t.angle = p.drawangle + P_RandomRange(-30, 30)*ANG1
							t.momz = P_RandomRange(-10, 10)*mo.scale
							P_InstaThrust(t, t.angle, P_RandomRange(5, 16)*mo.scale)
							t.scale = $/3
							t.tics = 16
							t.fuse = 16
						end

						-- small shockwave...
						local t = P_SpawnMobj(msl.x, msl.y, msl.z, MT_THOK)
						t.sprite = SPR_NTHK
						t.frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE
						t.color = msl.color
						t.scale = mo.scale/8
						t.destscale = mo.scale*8
						t.scalespeed = mo.scale/4
						t.tics = 10
						t.fuse = 10
						t.momz = mo.scale*4
						t.angle = msl.angle + ANG1*90
						t.momx = msl.momx/8 + mo.momx
						t.momy = msl.momy/8 + mo.momy
							
						msl.pso.potency = potency	-- normals shouldn't benefit from PA%

						msl.pso.blight = p.pso.blightround
						p.pso.blightround = nil
												
						PSO.lib.aimMissile(msl, p.pso.target)

						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						S_StartSound(mo, sfx_s23d)
						
						if p == displayplayer
							P_StartQuake(FRACUNIT*10, 4)
						end

						-- make the missile fade after it gets out of the range.
						local range = wep.range or 512
						msl.fuse = FixedDiv(range*FRACUNIT, max(1, FixedHypot(msl.momx, msl.momy)))/FRACUNIT
						
						if p.pso.lockon
						and PSO.lib.activeWeaponPotential(p, "heatseeker")
							msl.tracer = p.pso.lockon
						end
						
					elseif timer > 17 and timer < 21
						pos[6] = $ - ANG1*10
					end
					
					if timer == TICRATE
						return true
					end
				end,
}

local feraser_range = 2048
local feraser_step = 24
local feraser_loop = feraser_range/feraser_step

PSO.info.photonArts["launcher_pa_feareraser"] = {
		name = "Fear Eraser",
		desc = "Charges and fires a devastating beam of condensed photons at the target. Turning speed greatly reduced while firing.",
		cost = 45,
		potency = 4250,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_LAATK6",
		
		-- p: player
		-- timer: how long the animation has played for
		-- hold: if true, button is being held down, if not, it's been released
		-- input: timer on how long the button has been held for
		-- combo: non-zero if the attack was performed from a combo.
					-- useful to create attacks that are faster/different if used repeatedly.
		
		-- return true to end the animation
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					--print(timer)
					-- set new weapon pos:
					local ang = p.drawangle - ANG1*50
					local x = 16*cos(ang)
					local y = 16*sin(ang)
					
					pos[2] = x
					pos[3] = y
					pos[5] = ANG1*5	-- lat. angle
					
					if timer == 1
						mo.prevangle = p.drawangle
						if combo
							--pos[5] = FixedDiv(mo.height, mo.scale)/2
							pos[6] = 0
							
						else	-- we've just started that attack
							local z = FixedDiv(mo.height/2, mo.scale)
							pos[4] = z
								
							-- set angle
							pos[6] = ANG1*90 -- vert. angle
						end
						
						S_StartSound(mo, sfx_s3k53)
					end
					
					if timer < 10
					and not combo
						pos[6] = $ - ANG1*10
						pos[4] = $ - FixedDiv(mo.height, mo.scale)/20
					elseif timer == 10
						pos[6] = 0
					end
					
					-- limit turning...
					local diff = p.drawangle - mo.prevangle
					local maxang = ANG1*2
					
					if diff > maxang
						diff = maxang
					elseif diff < -maxang
						diff = -maxang
					end
					
					p.drawangle = mo.prevangle + diff
					mo.prevangle = p.drawangle
					
					
					
					if timer >= 17
					and timer <= TICRATE*6
						

						
						local t = timer-(TICRATE*2)
						local x = mo.x + 64*cos(p.drawangle)
						local y = mo.y + 64*sin(p.drawangle)
						
						if t == TICRATE/2 - 10
							local s = P_SpawnMobj(mo.x+pos[2], mo.y+pos[3], mo.z-mo.scale*420, MT_THOK)
							s.state = S_MEGISTAR1
							s.color = SKINCOLOR_WHITE
							s.scale = FRACUNIT*16
							s.destscale = 1
							s.scalespeed = FRACUNIT*3						
						end
						
						if t == TICRATE-6
							S_StartSound(mo, sfx_s3k54)
							S_StartSound(mo, sfx_bshot)
							if p == displayplayer
								P_StartQuake(FRACUNIT*30, TICRATE/4)
							end
						end
						
						if t > TICRATE-6 and t % 10 == 0
							S_StartSound(mo, sfx_s3kc4s)
							if p == displayplayer
								P_StartQuake(FRACUNIT*10, 10)
							end							
						end
						
						if t < TICRATE
							
							local s = P_SpawnMobj(x + P_RandomRange(-64, 64)*mo.scale, y + P_RandomRange(-64, 64)*mo.scale, P_RandomRange(-64, 64)*mo.scale, MT_THOK)
							s.color = winfo.effectcolor or PSO.info.elementColours[wep.element]
							s.colorized = true
							
							s.momx = (mo.x - s.x)/16
							s.momy = (mo.y - s.y)/16
							s.momz = (mo.z - s.z)/16
							s.destscale = 1
							s.tics = 16
							s.fuse = 16
						end
						
						if t >= TICRATE-6
							
							if t % 10 == 0	
								local t = P_SpawnMobj(x, y, z + mo.scale*32, MT_THOK)
								t.sprite = SPR_NTHK
								t.frame = B|TR_TRANS30|FF_FULLBRIGHT
								t.color = winfo.effectcolor or PSO.info.elementColours[wep.element]
								t.scale = 1
								t.destscale = FRACUNIT*4
								t.scalespeed = FRACUNIT/6
								t.fuse = TICRATE/2
								t.tics = t.fuse
								t.momz = mo.scale*4
							end
							
							local dist = 32
							local hitboxes = {}
							local za = 0
							local zdiff = 0
							local dist = 0
							
							if p.pso.target
							and p.pso.target.valid
							and p.pso.target.lockon
								zdiff = p.pso.target.z - mo.z
								dist = R_PointToDist2(mo.x, mo.y, p.pso.target.x, p.pso.target.y)
							end
							
							if zdiff and abs(zdiff) > 64*FRACUNIT
								
								local steps_to_target = dist / feraser_step
								za = FixedDiv(zdiff, steps_to_target)
							end
							
							
							for i = 1, feraser_loop
								
								local x2 = x + dist*cos(p.drawangle)
								local y2 = y + dist*sin(p.drawangle)
										
								local d = P_SpawnMobj(x2, y2, mo.z + mo.scale*16 +za*(i-1), MT_THOK)
								d.sprite = SPR_ENRG
								d.frame = A|FF_ADD|TR_TRANS30
								d.colorized = true
								d.color = winfo.effectcolor or PSO.info.elementColours[wep.element]
								d.scale = mo.scale/24 * min(i, 12) + mo.scale/4 + cos(leveltime*ANG1*20 + i*ANG1*8)/64
								d.z = $ - d.scale*64
								d.tics = 2
								
								if timer == TICRATE*4
									d.tics = TICRATE
									d.fuse = TICRATE
									d.destscale = 1
									d.momx = P_RandomRange(-8, 8)*mo.scale
									d.momy = P_RandomRange(-8, 8)*mo.scale
									d.momz = P_RandomRange(-8, 8)*mo.scale
								end
								
								if not P_CheckSight(mo, d)
									break
								end
								
								if P_RandomRange(0, 16) == 0
									local s = P_SpawnMobj(x2 + P_RandomRange(-128, 128)*mo.scale, y2 + P_RandomRange(-128, 128)*mo.scale, d.z + P_RandomRange(-32, 32)*mo.scale, MT_THOK)
									s.color = winfo.effectcolor or PSO.info.elementColours[wep.element]
									s.colorized = true
									s.frame = $|FF_FULLBRIGHT
									s.destscale = 1
									P_InstaThrust(s, p.drawangle, P_RandomRange(96, 256)*mo.scale)
								end
								
								if t % (TICRATE/2) == 0
									local hb = PSO.lib.spawnHurtBox(x2, y2, mo.z + za*(i-1), (feraser_step*6)<<FRACBITS, 140<<FRACBITS, mo, potency/7, DMT_RANGED, 4)
									hitboxes[#hitboxes+1] = hb
									hb.pso.combobreaker = true
									hb.pso.links = hitboxes
								end
								
								dist = $ + feraser_step
							end
						end
					
					elseif timer > TICRATE*4 + TICRATE/2
						return true
					end
				end,
}

freeslot("MT_PSO_FALLENIMPACT")
mobjinfo[MT_PSO_FALLENIMPACT] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	flags = MF_NOGRAVITY,
	radius = FRACUNIT*24,
	height = FRACUNIT*48,
}

addHook("MobjThinker", function(mo)
	
	if not mo.target or not mo.target.valid
		P_RemoveMobj(mo)
		return
	end
	
	if mo.tracer and mo.tracer.valid
		P_SetOrigin(mo, mo.tracer.x, mo.tracer.y, mo.tracer.z)
	end
	
	if mo.cvmem < TICRATE
		
		local scale = FRACUNIT - (mo.cvmem*FRACUNIT/30)
		
		if mo.cvmem%3 == 0
			for i = 1, 64
				local s = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*8*i, MT_THOK)
				s.frame = $|FF_FULLBRIGHT
				s.color = mo.color
				s.scale = scale
				s.destscale = 1
				s.fuse = 11
				s.tics = 11
			end
		end
		
		if mo.cvmem == TICRATE/2

			for i = 1, 4
				for j = 1, 16
										
					local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
					local a = (360/16)*j*ANG1
					d.angle = a + ANG1*90
					d.renderflags = $|RF_PAPERSPRITE
										
					if i > 1
						d.spritexscale = $*2
					end
										
					d.destscale = $*4
					d.momz = (8-i)*FRACUNIT
										
					P_InstaThrust(d, a, 32*FRACUNIT*i)
					d.momx = $ + mo.momx
					d.momy = $ + mo.momy
				end
			end
		end
		
		mo.cvmem = $+1
		
		return
	end
	if mo.extravalue1 % 7 == 0
		mo.extravalue2 = $+1

		local msl = PSO.lib.spawnMissile(mo.target, MT_PSO_LAUNCHERSHOT, 0, 0, mo.pso.potency/7, DMT_RANGED, 0, 0, 0)
		local zh = min(mo.ceilingz - msl.height, mo.z + mo.scale*512)
		P_SetOrigin(msl, mo.x, mo.y, zh)
		msl.pso.combobreaker = true
		msl.pso.potency = mo.pso.potency/7
		
		msl.momx = 0
		msl.momy = 0
		msl.momz = -mo.scale*32
		msl.color = mo.color
					
		if mo.extravalue2 >= 7
			P_RemoveMobj(mo)
			return
		end
	end	
	
	mo.extravalue1 = $+1
	
end, MT_PSO_FALLENIMPACT)

PSO.info.photonArts["launcher_pa_fallenimpact"] = {
		name = "Fallen Impact",
		desc = "Fires a rain of mortars on the target after a delay.",
		cost = 30,
		potency = 850,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_LAATK5",
		
		-- p: player
		-- timer: how long the animation has played for
		-- hold: if true, button is being held down, if not, it's been released
		-- input: timer on how long the button has been held for
		-- combo: non-zero if the attack was performed from a combo.
					-- useful to create attacks that are faster/different if used repeatedly.
		
		-- return true to end the animation
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					--print(timer)
					-- set new weapon pos:
					local ang = p.drawangle - ANG1*50
					local x = 16*cos(ang)
					local y = 16*sin(ang)
					
					pos[2] = x
					pos[3] = y
					pos[5] = ANG1*5	-- lat. angle
					
					if timer == 1
						
						if combo
							--pos[5] = FixedDiv(mo.height, mo.scale)/2
							pos[6] = 0
							
						else	-- we've just started that attack
							local z = FixedDiv(mo.height/2, mo.scale)
							pos[4] = z
								
							-- set angle
							pos[6] = ANG1*90 -- vert. angle
						end
					end
					
					
					if timer == 17
						pos[6] = ANG1*30
						
						-- fire the bullet!
						local msl = P_SpawnMobj(mo.x + pos[2], mo.y + pos[3], mo.z + pos[4], MT_PSO_LAUNCHERSHOT)
						msl.momz = FRACUNIT*32
						msl.fuse = TICRATE
						msl.flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
						
						if winfo.effectcolor
							msl.color = winfo.effectcolor
						else
							msl.color = PSO.info.elementColours[wep.element]
						end	

						
						for i = 1, 8
							local t = P_SpawnMobj(msl.x, msl.y, msl.z, MT_THOK)
							t.color = msl.color
							t.angle = P_RandomRange(0, 359)*ANG1
							t.momz = P_RandomRange(5, 16)*mo.scale
							P_InstaThrust(t, t.angle, P_RandomRange(5, 16)*mo.scale)
							t.scale = $/3
							t.tics = 16
							t.fuse = 16
						end

						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						S_StartSound(mo, sfx_s23d)
						
						if p == displayplayer
							P_StartQuake(FRACUNIT*10, 4)
						end						
						
						mo.saveang = p.drawangle
						P_InstaThrust(mo, mo.saveang, -FRACUNIT*20)
						mo.state = S_PLAY_WALK

						local t = P_SpawnMobj(msl.x, msl.y, msl.z, MT_THOK)
						t.sprite = SPR_NTHK
						t.frame = B|FF_FULLBRIGHT
						t.flags2 = $ | MF2_SPLAT
						t.renderflags = $|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD						
						t.color = msl.color
						t.scale = mo.scale/8
						t.destscale = mo.scale*4
						t.scalespeed = mo.scale/4
						t.tics = 10
						t.fuse = 10
						t.momx = $+p.mo.momx
						t.momy = $+p.mo.momy
						t.momz = FRACUNIT*8						
						
					elseif timer > 17 and timer < TICRATE

						
						local t = timer-(TICRATE-17)
						local ang = p.drawangle - ANG1*30 - t*ANG1*8
						local x = 24*cos(ang)
						local y = 24*sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[5] = ANG1*10 - t*ANG1*8	-- lat. angle
						pos[6] = ANG1*90 - t*ANG1*8
						
						p.drawangle = mo.saveang
					end
					
					if timer == TICRATE*3/4 +5

						p.pso.cancancel = 2
						local t = p.pso.target
						
						if not t or not t.valid
							local x = mo.x + 512*cos(p.drawangle)
							local y = mo.y + 512*sin(p.drawangle)
							
							t = P_SpawnMobj(x, y, mo.z, MT_THOK)
							t.state = S_INVISIBLE
							t.fuse = 2
						end
						
						local r = PSO.lib.spawnMissile(mo, MT_PSO_FALLENIMPACT, 0, 0, potency, DMT_RANGED, 0, 0, 0)
						P_SetOrigin(r, t.x, t.y, t.z)

						if p.pso.lockon
						and PSO.lib.activeWeaponPotential(p, "heatseeker")
							r.tracer = p.pso.lockon
						end
						
						r.color = winfo.effectcolor or PSO.info.elementColours[wep.element]
						r.tics = -1
						r.fuse = -1
					end
					
					if timer == TICRATE
						return true
					end
				end,
}

PSO.info.photonArts["launcher_pa_divinelauncher"] = {
		name = "Divine Cannon",
		desc = "Fires a high power explosive with a large blast radius that sends enemies flying",
		cost = 40,
		potency = 800,
		speed = 0,		-- speed % multiplier. (hack in this case because we'll set it to 0 mid-action)
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_LAATK2",
		
		-- p: player
		-- timer: how long the animation has played for
		-- hold: if true, button is being held down, if not, it's been released
		-- input: timer on how long the button has been held for
		-- combo: non-zero if the attack was performed from a combo.
					-- useful to create attacks that are faster/different if used repeatedly.
		
		-- return true to end the animation
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					--print(timer)
					-- set new weapon pos:
					
					if timer < TICRATE/2	-- cock the launcher
						
						local ang = p.drawangle - ANG1*80
						local dist = 10*sin(timer*ANG1*10)
						
						local x = (48 - dist/FRACUNIT)*cos(ang)
						local y = (48 - dist/FRACUNIT)*sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height - dist
						pos[5] = -ANG1*70	-- lat. angle
						pos[6] = ANG1*70
						
						if timer == TICRATE/5
							S_StartSound(mo, sfx_rabr)
						end
					else
						
						local t = timer - (TICRATE/2)
						
						if t < 10

							local ang = p.drawangle - ANG1*(80 - t*3)
							
							local x = (48 - t*3)*cos(ang)
							local y = (48 - t*3)*sin(ang)
							
							pos[2] = x
							pos[3] = y
							pos[5] = $ + ANG1*7
							pos[6] = $ - ANG1*7
							pos[4] = $ - FRACUNIT*4
						elseif t == 10
							-- fire the bullet!
							local msl = PSO.lib.spawnMissile(mo, MT_PSO_LAUNCHERSHOT, p.drawangle, 65*FRACUNIT, potency, DMT_RANGED, pos[2], pos[3], mo.scale*8)
							msl.extravalue1 = 1
							msl.pso.combobreaker = true

							if p.pso.lockon
							and PSO.lib.activeWeaponPotential(p, "heatseeker")
								msl.tracer = p.pso.lockon
							end
							
							if winfo.effectcolor
								msl.color = winfo.effectcolor
							else
								msl.color = PSO.info.elementColours[wep.element]
							end	

							if p == consoleplayer
								P_StartQuake(FRACUNIT*32, 8)
							end							

							-- small shockwave...
							local t = P_SpawnMobj(msl.x, msl.y, msl.z, MT_THOK)
							t.sprite = SPR_NTHK
							t.frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE
							t.color = msl.color
							t.scale = mo.scale/8
							t.destscale = mo.scale*8
							t.scalespeed = mo.scale/4
							t.tics = 10
							t.fuse = 10
							t.momz = mo.scale*4
							t.angle = msl.angle + ANG1*90
							t.momx = msl.momx/8 + mo.momx
							t.momy = msl.momy/8 + mo.momy							
							
							for i = 1, 32
								local t = P_SpawnMobj(msl.x, msl.y, msl.z, MT_THOK)
								t.color = msl.color
								t.angle = p.drawangle + P_RandomRange(-30, 30)*ANG1
								t.momz = P_RandomRange(-32, 32)*mo.scale
								P_InstaThrust(t, t.angle, 32*mo.scale)
								t.scale = $/3
								t.tics = 16
								t.fuse = 16
							end
													
							PSO.lib.aimMissile(msl, p.pso.target)
							
							p.pso.cancancel = TICRATE/2
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
							S_StartSound(mo, sfx_brakrl)

							-- make the missile fade after it gets out of the range.
							local range = wep.range or 512
							msl.fuse = FixedDiv(range*FRACUNIT, max(1, FixedHypot(msl.momx, msl.momy)))/FRACUNIT	
							
							mo.lockangle = p.drawangle
							P_InstaThrust(mo, mo.angle, -FRACUNIT*64)
							mo.state = S_PLAY_WALK
						end
						
						if t >= 10
						and t < TICRATE
							
							if t < 13
								pos[6] = $ + ANG1*20
								pos[5] = $ - ANG1*20
								pos[4] = $ + FRACUNIT*10
							end
							
							mo.momx = $*95/100
							mo.momy = $*95/100
							p.drawangle = mo.lockangle
						elseif t >= TICRATE
							
							pos[6] = $ - ANG1*3
							pos[5] = $ + ANG1*2
							pos[4] = $ - FRACUNIT
							
							if t == TICRATE+10
								return true
							end
						end
						
					end
				end,
}

freeslot("MT_PSO_INFERNOQUAKE")
mobjinfo[MT_PSO_INFERNOQUAKE] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	radius = 32<<FRACBITS,
	height = 32<<FRACBITS,
	flags = MF_NOGRAVITY
}

addHook("MobjThinker", function(mo)
	
	local pmo = mo.target
	local p = pmo.player
	
	if mo.extravalue1
		mo.extravalue1 = $-1
		
		if mo.tracer and mo.tracer.valid
			P_SetOrigin(mo, mo.tracer.x, mo.tracer.y, max(pmo.floorz, mo.tracer.floorz))
		end
		
		if mo.extravalue1 == 0
			if p == consoleplayer
				P_StartQuake(FRACUNIT*16, 8)
			end	
									
									
			for i = 1, 8
				local e = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				e.state = S_SONIC3KBOSSEXPLOSION1
				e.scale = $*3/4
				local a = 360/8 *i *ANG1
				P_InstaThrust(e, a, FRACUNIT*32)
			end	
									
			for i = 1, 24
				local e = P_SpawnMobj(mo.x + P_RandomRange(-32, 32)*FRACUNIT, mo.y + P_RandomRange(-32, 32)*FRACUNIT, mo.z, MT_THOK)
				e.state = S_SONIC3KBOSSEXPLOSION1									
				e.momz = P_RandomRange(4, 32)*FRACUNIT
				e.destscale = FRACUNIT*12
				e.scalespeed = FRACUNIT/12
										
				e.tics = $ + P_RandomRange(0, 4)
				e.spriteyscale = P_RandomRange(1, 5)*FRACUNIT
										
				if i == 1
					S_StartSound(e, sfx_foie)
					S_StartSound(e, sfx_brakrx)
				end
			end

			for i = 1, 2
				for j = 1, 16
									
					local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
					local a = (360/16)*j*ANG1
					d.state = S_SONIC3KBOSSEXPLOSION1
					d.angle = a + ANG1*90
					d.renderflags = $|RF_PAPERSPRITE
									
					if i > 1
						d.spritexscale = $*2
					end
									
					d.destscale = $*4
									
					P_InstaThrust(d, a, 32*FRACUNIT*i)
					d.momx = $ + mo.momx
					d.momy = $ + mo.momy
					if i == 1
						d.momz = FRACUNIT*4
					end
				end
			end	
									
			local h = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 255<<FRACBITS, 128<<FRACBITS, mo.target, mo.pso.potency, DMT_RANGED, 4, RT_BLOWDOWN)
			PSO.lib.copyWeaponProperties(mo, h)
			h.angle = p.drawangle
			h.pso.combobreaker = true
			
			P_RemoveMobj(mo)
		end
	end
end, MT_PSO_INFERNOQUAKE)

PSO.info.photonArts["launcher_pa_infernoquake"] = {
		name = "Inferno Quake",
		desc = "Leap into the air and send a discharge into the ground, erupting explosions forward.",
		cost = 30,
		potency = 680,
		speed = 30,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_LAATK3",
		
		-- p: player
		-- timer: how long the animation has played for
		-- hold: if true, button is being held down, if not, it's been released
		-- input: timer on how long the button has been held for
		-- combo: non-zero if the attack was performed from a combo.
					-- useful to create attacks that are faster/different if used repeatedly.
		
		-- return true to end the animation
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					if timer == 1
						
						mo.state = S_PLAY_SPRING
						mo.momz = mo.scale*25
						mo.z = $+1
						mo.groundcheck = nil

						local ang = p.drawangle - ANG1*80
						local x = 24*cos(ang)
						local y = 24*sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[5] = ANG1*50	-- lat. angle
						pos[6] = -ANG1*140
						S_StartSound(mo, sfx_beflap)
						
					else
						
						if mo.groundcheck
							
							local t = timer - mo.groundcheck
							p.drawangle = mo.groundangle
							
							if t == 1
								for i = 1, 4
									
									local dist = 128*i
									local x = mo.x + dist*cos(mo.groundangle)
									local y = mo.y + dist*sin(mo.groundangle)
									
									local msl = PSO.lib.spawnMissile(mo, MT_PSO_INFERNOQUAKE, p.drawangle, 0, potency, DMT_RANGED, pos[2], pos[3], mo.scale*8)
									P_SetOrigin(msl, x, y, mo.z)
									if p.pso.lockon
									and PSO.lib.activeWeaponPotential(p, "heatseeker")
										msl.tracer = p.pso.lockon
									end
									
									msl.extravalue1 = 12*i
								end
							end
							
							if t > TICRATE*3/2
								return true
							end
						else
							
							if mo.momz > 0
								mo.momz = $ - FRACUNIT
							else
								mo.momz = $ - FRACUNIT*4
							end
							if leveltime & 1
								local g = P_SpawnGhostMobj(mo)
								g.colorized = true
							end
							
							if P_IsObjectOnGround(mo)
								mo.groundcheck = timer
								mo.groundangle = p.drawangle
								P_InstaThrust(mo, 0, 0)

								if winfo.sound
									S_StartSound(mo, winfo.sound)
								end

								if p == consoleplayer
									P_StartQuake(FRACUNIT*32, 8)
								end	
								
								local sx = mo.x + pos[2] - 32*cos(p.drawangle)
								local sy = mo.y + pos[3] - 32*sin(p.drawangle)
								
								local s = P_SpawnMobj(sx, sy, mo.z, MT_THOK)
								s.state = S_MEGISTAR1
								s.color = SKINCOLOR_WHITE
								
								local boom = P_SpawnMobj(sx, sy, mo.z, MT_THOK)
								boom.state = S_PSO_LAEXPL1
								boom.colorized = true
								if winfo.effectcolor
									boom.color = winfo.effectcolor
								else
									boom.color = PSO.info.elementColours[wep.element]
								end	

								boom.flags2 = $ | MF2_SPLAT
								boom.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
								
								p.pso.cancancel = TICRATE/3
							end
								
		
							
							if timer > TICRATE/4
							and timer < TICRATE/2 + TICRATE/8 -1
								pos[6] = $ - ANG1*30
							end
						end	
						
					end
				end,
}

PSO.info.photonArts["launcher_pa_homerunhavoc"] = {
		name = "Homerun Havoc",
		desc = "Swing the Launcher's full weight to knock enemies in the air and follow up with an air shot. The projectile will home in if you lock onto the target.",
		cost = 20,
		potency = 1330,
		speed = 20,
		
		icon = "H_LAATK4",
		
		use = 	function(p, timer, hold, input)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					--print(timer)
					-- set new weapon pos:
					
					if timer < TICRATE/2 +5
						
						if timer == 1
							mo.swingangle = p.drawangle - ANG1*60
						end
						
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle + ANG1*150,	-- tilt sideways
							za = ANG1*30,
						}
						
						if timer < TICRATE/4 +5
							mo.swingangle = $ - max(ANG1*2, (20*sin(timer*22*ANG1) /FRACUNIT)*ANG1)
						elseif timer < TICRATE/2 +5
							local t = timer - (TICRATE/4 + 5)
							mo.swingangle = $ + (60*sin(t*22*ANG1) /FRACUNIT)*ANG1
						end
						
						if timer == TICRATE/8
							S_StartSound(mo, sfx_s3k61)
						end
						
						if timer == TICRATE/2
							
							local x = 64 * cos(p.drawangle)
							local y = 64 * sin(p.drawangle)							
							
							local hb = PSO.lib.spawnHurtBox(mo.x+x, mo.y+y, mo.z, 140<<FRACBITS, 40<<FRACBITS, mo, potency/3, DMT_RANGED, 8, RT_BLOWDOWN)
							hb.angle = p.drawangle						
							hb.pso.reactionstrength = 14
							hb.pso.combobreaker = true
							hb.pso.hitlag = 6
							hb.pso.screenshake = {intensity = FRACUNIT*12, time=5}		
						end
						
						local dist = 64
						pos[2] = dist*cos(mo.swingangle)
						pos[3] = dist*sin(mo.swingangle)
						pos[6] = mo.swingangle - ANG1*90
						
						if leveltime & 1
							local g = P_SpawnGhostMobj(pos[1])
							g.colorized = true

							P_CreateFloorSpriteSlope(g)
							g.flags2 = $ | MF2_SPLAT
							g.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD						

							g.floorspriteslope.o = pos[7].o
							g.floorspriteslope.xydirection = pos[7].xy
							g.floorspriteslope.zangle = pos[7].za
						end
						
						if timer == TICRATE/2 +4
							
							mo.lockangle = p.drawangle
							P_InstaThrust(mo, mo.lockangle, -9*FRACUNIT)
							mo.momz = FRACUNIT*4
							mo.state = S_PLAY_FALL
							S_StartSound(mo, sfx_s3k82)
							
							mo.savepos = {
								nil, pos[2], pos[3], pos[4], pos[5], pos[6]
							}
							
						end

					elseif timer < TICRATE/2 +18
						
						local t = timer - (TICRATE/2 +5)
						
						pos[7] = {use=false}
						
						pos[5] = ANG1*50 - t*ANG1*4
						pos[6] = ANG1*180  -ANG1*45 *t
						
						local relative_dist = 7*t
						local move_angle = p.drawangle - ANG1*45
						
						local relative_xpos = relative_dist*cos(move_angle)
						local relative_ypos = relative_dist*sin(move_angle)
						local relative_zpos = 55*sin(t*ANG1*20)
						
						pos[2] = mo.savepos[2] + relative_xpos
						pos[3] = mo.savepos[3] + relative_ypos
						pos[4] = mo.savepos[4] + relative_zpos + FRACUNIT*32
						
					elseif timer < TICRATE*5/2	
						
						
						local t = timer - (TICRATE/2 + 18)
						
						local ang = p.drawangle - ANG1*50
						local x = 16*cos(ang)
						local y = 16*sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[5] = ANG1*5	-- lat. angle
						
						p.drawangle = mo.lockangle
						
						if t == 1
							S_StartSound(mo, sfx_s3k91)
							
						elseif t == 10
							
							p.pso.cancancel = 12
							
							-- fire the bullet!
							local msl = PSO.lib.spawnMissile(mo, MT_PSO_LAUNCHERSHOT, p.drawangle, 110*FRACUNIT, potency*2/3, DMT_RANGED, pos[2], pos[3], mo.scale*8)
							msl.pso.combobreaker = true

							if p.pso.lockon
							--and PSO.lib.activeWeaponPotential(p, "heatseeker")
								msl.tracer = p.pso.lockon
							end
							
							if winfo.effectcolor
								msl.color = winfo.effectcolor
							else
								msl.color = PSO.info.elementColours[wep.element]
							end	

							if p == consoleplayer
								P_StartQuake(FRACUNIT*32, 8)
							end							
							
							
							for i = 1, 32
								local t = P_SpawnMobj(msl.x, msl.y, msl.z, MT_THOK)
								t.color = msl.color
								t.angle = p.drawangle + P_RandomRange(-30, 30)*ANG1
								t.momz = P_RandomRange(-32, 32)*mo.scale
								P_InstaThrust(t, t.angle, 32*mo.scale)
								t.scale = $/3
								t.tics = 16
								t.fuse = 16
							end
			
							PSO.lib.aimMissile(msl, p.pso.target)

							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
							S_StartSound(mo, sfx_befall)

							-- small shockwave...
							local t = P_SpawnMobj(msl.x, msl.y, msl.z, MT_THOK)
							t.sprite = SPR_NTHK
							t.frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE
							t.color = msl.color
							t.scale = mo.scale/8
							t.destscale = mo.scale*8
							t.scalespeed = mo.scale/4
							t.tics = 10
							t.fuse = 10
							t.momz = mo.scale*4
							t.angle = msl.angle + ANG1*90
							t.momx = msl.momx/8 + mo.momx
							t.momy = msl.momy/8 + mo.momy

							-- make the missile fade after it gets out of the range.
							local range = wep.range or 512
							msl.fuse = FixedDiv(range*FRACUNIT, max(1, FixedHypot(msl.momx, msl.momy)))/FRACUNIT	
							
							mo.lockangle = p.drawangle
							P_InstaThrust(mo, mo.angle, -FRACUNIT*64)
							mo.state = S_PLAY_WALK
							
							pos[6] = ANG1*120
							pos[4] = mo.height
						elseif t > 10
							p.drawangle = mo.lockangle
							mo.momx = $*95/100
							mo.momy = $*95/100
							mo.momz = $*95/100
							
							if t < 17
								pos[6] = $ - ANG1*20
								pos[4] = $ - FRACUNIT*5
							end
						end
						
					else	
						return true
					end
				end,
		
}