PSO.info.photonArts["shotgun_normal"] = {
		name = "Shot",
		desc = "A cluster of Photon bullets that can hit multiple targets. Targets can be hit up to 2 times based on how close they are.",
		normal = true,
		cost = 6,
		potency = 220,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SHTG1",
		combo = TICRATE*3/5,		-- can be reused after 21 frames on the timer!
		
		-- p: player
		-- timer: how long the animation has played for
		-- hold: if true, button is being held down, if not, it's been released
		-- input: timer on how long the button has been held for
		-- combo: non-zero if the attack was performed from a combo.
					-- useful to create attacks that are faster/different if used repeatedly.
		
		-- return true to end the animation
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					--print(timer)
					-- set new weapon pos:
					local ang = p.drawangle - ANG1*30
					local x = 24*cos(ang)
					local y = 24*sin(ang)
					
					pos[2] = x
					pos[3] = y
					pos[5] = ANG1*10	-- lat. angle
					
					if timer == 1
						
						if combo
							--pos[5] = FixedDiv(mo.height, mo.scale)/2
							pos[6] = 0
							
						else	-- we've just started that attack
							local z = FixedDiv(mo.height, mo.scale)
							pos[4] = z
								
							-- set angle
							pos[6] = ANG1*90 -- vert. angle
						end
					end
					
					if timer < 5
					and not combo
						pos[6] = $ - ANG1*20
						pos[4] = $ - FixedDiv(mo.height, mo.scale)/10
					elseif timer == 5
						pos[6] = 0
					end
					
					
					if timer == 9
						pos[6] = ANG1*30
						local range = winfo.range or 512
						
						for i = 1, 2
							
							local hitboxes = {}
							local angle = -30
							local pot = i == 1 and potency/3 or (potency*2/3) +1
							
							for j = 1, 12
								local hb = PSO.lib.spawnHurtBox(mo.x + pos[2], mo.y + pos[3], mo.z + pos[4]*2/3, 64<<FRACBITS, 200<<FRACBITS, mo, pot, DMT_RANGED, TICRATE/2)
								--hb.scale = FRACUNIT/8
								--hb.destscale = FRACUNIT*2
								--hb.flags = $|MF_SLIDEME
								hb.angle = p.drawangle + angle*ANG1

								if PSO.lib.hasSkill(p, "ra_zalureshot")
									hb.pso.inflictzalure = TICRATE*3
								end

								if PSO.lib.hasSkill(p, "ra_jellenshot")
									hb.pso.inflictjellen = TICRATE*3
								end
								
								hb.pso.blight = p.pso.blightround
								
								P_InstaThrust(hb, hb.angle, mo.scale*48)
								hb.fuse = FixedDiv(range*FRACUNIT, FixedHypot(hb.momx, hb.momy))/FRACUNIT
											
								if i > 1
									hb.fuse = $/4
								end
								
								hitboxes[#hitboxes+1] = hb
								hb.pso.links = hitboxes
								
								angle = $+5
							end
						end	
							
						p.pso.cancancel = 10

						local msl
						for i = 1, 16
							local bullet = P_SpawnMobj(mo.x + pos[2], mo.y + pos[3], mo.z + pos[4], MT_PSO_RIFLESHOT)
							bullet.flags = MF_NOGRAVITY|MF_NOCLIPTHING
							bullet.angle = p.drawangle + ANG1*P_RandomRange(-30, 30)
							P_InstaThrust(bullet, bullet.angle, P_RandomRange(48, 76)*FRACUNIT)
							bullet.momz = P_RandomRange(-6, 6)*FRACUNIT
							bullet.scale = $/3
							bullet.fuse = P_RandomRange(3, 9)
							if winfo.effectcolor
								bullet.color = winfo.effectcolor
							else
								bullet.color = PSO.info.elementColours[wep.element]
							end	
							
							msl = bullet
						end

						-- small shockwave...
						local t = P_SpawnMobj(msl.x, msl.y, msl.z, MT_THOK)
						t.sprite = SPR_NTHK
						t.frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE
						t.color = msl.color
						t.scale = mo.scale/8
						t.destscale = mo.scale*4
						t.scalespeed = mo.scale/4
						t.tics = 10
						t.fuse = 10
						t.momz = mo.scale*4
						t.angle = msl.angle + ANG1*90
						P_InstaThrust(t, p.drawangle, FRACUNIT*20)
						t.momx = $+p.mo.momx
						t.momy = $+p.mo.momy

						local da = p.drawangle - ANG1*20
						for i = 1, 8
							local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
							P_InstaThrust(d, da, FRACUNIT*P_RandomRange(96, 128))
							d.momz = P_RandomRange(0, 2)*mo.scale
							d.renderflags = $|RF_PAPERSPRITE
							d.angle = da + ANG1*90
							d.tics = $ + P_RandomRange(1, 6)
								
							da = $ + (40/8)*ANG1
						end	
						
						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						S_StartSound(mo, sfx_turhit)
						
						if p == displayplayer
							P_StartQuake(FRACUNIT*6, 4)
						end

						p.pso.blightround = nil

						-- make the missile fade after it gets out of the range.
						--local range = wep.range or 512
						--msl.fuse = FixedDiv(range*FRACUNIT, FixedHypot(msl.momx, msl.momy))/FRACUNIT
						
					elseif timer > 9 and timer < 13
						pos[6] = $ - ANG1*10
					end
					
					if timer == TICRATE
						return true
					end
				end,
}

PSO.info.photonArts["shotgun_pa_trickblast"] = {
		name = "Trick Blast",
		desc = "Fire backwards, using the recoil of the shot to propel yourself towards the enemy and shoot them point blank.",
		cost = 20,
		potency = 480,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SHTG6",
		
		-- p: player
		-- timer: how long the animation has played for
		-- hold: if true, button is being held down, if not, it's been released
		-- input: timer on how long the button has been held for
		-- combo: non-zero if the attack was performed from a combo.
					-- useful to create attacks that are faster/different if used repeatedly.
		
		-- return true to end the animation
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					--print(timer)
					-- set new weapon pos:
					local ang = p.drawangle - ANG1*30
					local x = 24*cos(ang)
					local y = 24*sin(ang)
					
					pos[2] = x
					pos[3] = y
					pos[5] = ANG1*10	-- lat. angle
					
					if timer == 1
						-- we've just started that attack
						local z = FixedDiv(mo.height, mo.scale)
						pos[4] = z
								
						-- set angle
						pos[6] = ANG1*90 -- vert. angle
						
						-- face target frame 1
						if p.pso.target and p.pso.target.valid
							p.drawangle = R_PointToAngle2(mo.x, mo.y, p.pso.target.x, p.pso.target.y)
						end
						
						mo.momz = FRACUNIT*3
						mo.state = S_PLAY_FALL
						mo.ogangle = p.drawangle
					end
					
					if timer < 6
						pos[6] = $ + ANG1*20
						pos[4] = $ - FixedDiv(mo.height, mo.scale)/10
						
						p.drawangle = mo.ogangle + (180/4)*ANG1 *timer
						mo.rollangle = (180/5)*ANG1*timer
						
					end
					
					
					if timer == 6
						
						local a = mo.ogangle + ANG1*180
						local x = mo.x + 128*cos(a)
						local y = mo.y + 128*sin(a)
						local z = mo.z - 32*mo.scale
						
						local hb = PSO.lib.spawnHurtBox(x, y, z, 255<<FRACBITS, 40<<FRACBITS, mo, potency, DMT_RANGED, TICRATE/2)
						hb.pso.combobreaker = true
						
						local msl
						for i = 1, 16
							local bullet = P_SpawnMobj(mo.x + pos[2], mo.y + pos[3], mo.z + pos[4], MT_PSO_RIFLESHOT)
							bullet.flags = MF_NOGRAVITY|MF_NOCLIPTHING
							bullet.angle = a + ANG1*P_RandomRange(-30, 30)
							P_InstaThrust(bullet, bullet.angle, P_RandomRange(48, 76)*FRACUNIT)
							bullet.momz = P_RandomRange(-6, 6)*FRACUNIT
							bullet.scale = $/3
							bullet.fuse = P_RandomRange(3, 9)
							if winfo.effectcolor
								bullet.color = winfo.effectcolor
							else
								bullet.color = PSO.info.elementColours[wep.element]
							end
							msl = bullet
						end
						
						local s = P_SpawnMobj(mo.x + pos[2], mo.y + pos[3], mo.z + 64*mo.scale, MT_THOK)
						s.sprite = SPR_NTHK
						s.frame = B|FF_FULLBRIGHT
						s.color = winfo.effectcolor or PSO.info.elementColours[wep.element]
						s.fuse = 10
						s.tics = 10
						s.scale = 1
						s.destscale = mo.scale*10
						s.scalespeed = mo.scale/4
						
						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						S_StartSound(mo, sfx_turhit)

						-- small shockwave...
						local t = P_SpawnMobj(msl.x, msl.y, msl.z, MT_THOK)
						t.sprite = SPR_NTHK
						t.frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE
						t.color = msl.color
						t.scale = mo.scale/8
						t.destscale = mo.scale*4
						t.scalespeed = mo.scale/4
						t.tics = 10
						t.fuse = 10
						t.momz = mo.scale*4
						t.angle = msl.angle + ANG1*90
						P_InstaThrust(t, p.drawangle, FRACUNIT*20)
						t.momx = $+p.mo.momx
						t.momy = $+p.mo.momy

						local da = p.drawangle - ANG1*20 + ANG1*180
						for i = 1, 8
							local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
							P_InstaThrust(d, da, FRACUNIT*P_RandomRange(96, 128))
							d.momz = P_RandomRange(0, 2)*mo.scale
							d.renderflags = $|RF_PAPERSPRITE
							d.angle = da + ANG1*90
							d.tics = $ + P_RandomRange(1, 6)
								
							da = $ + (40/8)*ANG1
						end	

						if p == displayplayer
							P_StartQuake(FRACUNIT*10, 5)
						end

						-- compute where we're going to land...
						if p.pso.target and p.pso.target.valid
							
							local f_ang = R_PointToAngle2(mo.x, mo.y, p.pso.target.x, p.pso.target.y)
							
							local dist = p.pso.target.radius + FRACUNIT*130
							local tx = p.pso.target.x - FixedMul(dist, cos(f_ang))
							local ty = p.pso.target.y - FixedMul(dist, sin(f_ang))
							local tz = p.pso.target.z
							
							mo.jumptarget = P_SpawnMobj(tx, ty, tz, MT_THOK)
							mo.jumptarget.state = S_INVISIBLE
							mo.jumptarget.tics = 2
						else
							
							-- make up a target in front of us
							local dist = 512
							local tx = mo.x + dist*cos(mo.ogangle)
							local ty = mo.y + dist*sin(mo.ogangle)
							local tz = mo.z
							
							mo.jumptarget = P_SpawnMobj(tx, ty, tz, MT_THOK)
							mo.jumptarget.state = S_INVISIBLE
							mo.jumptarget.tics = 2
						end
						
						-- leap towards the target
						local airtime = TICRATE/2
						local t = mo.jumptarget
						
						local a = R_PointToAngle2(mo.x, mo.y, t.x, t.y)
						local dist = min(mo.scale*680, R_PointToDist2(mo.x, mo.y, t.x, t.y))
						local horz = dist / airtime
						
						local gravity = -P_GetMobjGravity(mo)*2	-- 2x gravity will make this look cooler
						local vert = FixedMul((gravity*airtime)/2, mo.scale)
						
						P_InstaThrust(mo, a, horz)
						mo.state = S_PLAY_FALL
						mo.momz = vert
						mo.z = $+1
						mo.groundtimer = 0
						
					end
					
					if timer > 6
						
						if not mo.groundtimer
							mo.rollangle = $ + ANG1*50
							p.drawangle = $ + ANG1*30
							mo.momz = $ + P_GetMobjGravity(mo)
							
							if leveltime & 1
								local g = P_SpawnGhostMobj(mo)
								g.colorized = true
							end
						end
						
						if P_IsObjectOnGround(mo)
							
							if not mo.groundtimer
								
								p.drawangle = mo.ogangle
								mo.rollangle = 0

								if timer == 1-- we've just started that attack
									local z = FixedDiv(mo.height, mo.scale)
									pos[4] = z
											
									-- set angle
									pos[6] = ANG1*90 -- vert. angle
								end
								mo.momx = $/5
								mo.momy = $/5
							end

							if mo.groundtimer < 3
								pos[6] = $ - ANG1*30
								pos[4] = $ - FixedDiv(mo.height, mo.scale)/10
							elseif mo.groundtimer == 3
								pos[6] = 0

								local a = p.drawangle
								local x = mo.x + 128*cos(a)
								local y = mo.y + 128*sin(a)
								local z = mo.z - 32*mo.scale
								
								local hb = PSO.lib.spawnHurtBox(x, y, z, 255<<FRACBITS, 40<<FRACBITS, mo, potency, DMT_RANGED, TICRATE/2)
								hb.pso.combobreaker = true
								
								for i = 1, 16
									local bullet = P_SpawnMobj(mo.x + pos[2], mo.y + pos[3], mo.z + pos[4], MT_PSO_RIFLESHOT)
									bullet.flags = MF_NOGRAVITY|MF_NOCLIPTHING
									bullet.angle = a + ANG1*P_RandomRange(-30, 30)
									P_InstaThrust(bullet, bullet.angle, P_RandomRange(48, 76)*FRACUNIT)
									bullet.momz = P_RandomRange(-6, 6)*FRACUNIT
									bullet.scale = $/3
									bullet.fuse = P_RandomRange(3, 9)
									if winfo.effectcolor
										bullet.color = winfo.effectcolor
									else
										bullet.color = PSO.info.elementColours[wep.element]
									end	
								end
								
								if winfo.sound
									S_StartSound(mo, winfo.sound)
								end
								
								for i = 1, 2
									local s = P_SpawnMobj(x, y, z + mo.scale*64, MT_THOK)
									s.sprite = SPR_NTHK
									s.frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE
									s.color = winfo.effectcolor or PSO.info.elementColours[wep.element]
									s.angle = p.drawangle + ANG1*90
									s.fuse = 10*i
									s.tics = 10*i
									s.scale = 1
									s.destscale = mo.scale*10*i
									s.scalespeed = (mo.scale/4)*i
									P_InstaThrust(s, p.drawangle, -mo.scale*13*i)
								end

								S_StartSound(mo, sfx_turhit)

								local da = p.drawangle - ANG1*20
								for i = 1, 8
									local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
									P_InstaThrust(d, da, FRACUNIT*P_RandomRange(96, 128))
									d.momz = P_RandomRange(0, 2)*mo.scale
									d.renderflags = $|RF_PAPERSPRITE
									d.angle = da + ANG1*90
									d.tics = $ + P_RandomRange(1, 6)
										
									da = $ + (40/8)*ANG1
								end	

								if p == displayplayer
									P_StartQuake(FRACUNIT*10, 5)
								end
								
								mo.momx = 0
								mo.momy = 0
								p.pso.cancancel = 4
							end	
							
							mo.groundtimer = $+1
							
							if mo.groundtimer >= TICRATE/2
								return true
							end
						end
						
					end
				end,
}

freeslot("MT_PSO_SLUGBURST")
mobjinfo[MT_PSO_SLUGBURST] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	flags = MF_NOGRAVITY,
	radius = FRACUNIT*24,
	height = FRACUNIT*48,
}

freeslot("MT_PSO_SLUGBURST_EXPLOSION")
mobjinfo[MT_PSO_SLUGBURST_EXPLOSION] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	flags = MF_NOGRAVITY,
	radius = FRACUNIT*24,
	height = FRACUNIT*48,
}

local function slugburst_Collide(mo1, mo2)
	
	if mo1 and mo1.valid and mo1.type == MT_PSO_SLUGBURST
	and mo2 and mo2.valid and mo2.flags & (MF_ENEMY|MF_SHOOTABLE)
	and mo1.target and mo1.target.valid
	and mo2.type ~= MT_PLAYER
		mo1.whitelist = $ or {}
		
		if mo1.whitelist[mo2] return false end	-- no, we've already damaged this enemy
		
		-- damage the enemy
		local listlen = 0
		for k,v in pairs(mo1.whitelist)
			listlen = $+1
		end
		
		mo1.whitelist[mo2] = true
		
		local hb = PSO.lib.spawnHurtBox(mo2.x, mo2.y, mo2.z, 8<<FRACBITS, 8<<FRACBITS, mo1.target, mo1.pso.potency, DMT_RANGED, 2)
		PSO.lib.copyWeaponProperties(mo1, hb)
		hb.pso.combobreaker = true
		hb.pso.potency = mo1.pso.potency
		
		local expl = PSO.lib.spawnMissile(mo1.target, MT_PSO_SLUGBURST_EXPLOSION, 0, 0, mo1.pso.potency, DMT_RANGED, 0, 0, 0)
		PSO.lib.copyWeaponProperties(mo1, expl)
		P_SetOrigin(expl, mo2.x, mo2.y, mo2.z)
		expl.extravalue1 = TICRATE + listlen*(TICRATE/6)
		expl.target = mo1.target
		expl.pso.potency = mo1.pso.potency
	end
end

addHook("MobjCollide", slugburst_Collide, MT_PSO_SLUGBURST)
addHook("MobjMoveCollide", slugburst_Collide, MT_PSO_SLUGBURST)

addHook("MobjThinker", function(mo)
	
	if not mo.target or not mo.target.valid
		P_RemoveMobj(mo)
		return
	end
	
	mo.extravalue1 = $-1
	
	if not mo.extravalue1
		for i = 1, 16
			local e = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SONIC3KBOSSEXPLODE)
			e.scale = mo.scale*3/2
			e.destscale = 1
			e.scalespeed = mo.scale/12
			e.momx = P_RandomRange(-32, 32)*mo.scale
			e.momy = P_RandomRange(-32, 32)*mo.scale
			e.momz = P_RandomRange(-32, 32)*mo.scale
		end	
		
		local s = P_SpawnMobj(mo.x, mo.y, mo.z-mo.scale*420, MT_THOK)
		s.state = S_MEGISTAR1
		s.color = SKINCOLOR_WHITE
		s.scale = FRACUNIT*16
		s.destscale = 1
		s.scalespeed = FRACUNIT*3
		
		-- this is a nasty hack but it beats duplicating a bunch of logic.
		if mo.target.player
		and PSO.lib.activeWeaponPotential(mo.target.player, "traditional slugs")
			mo.pso.potency = $*4/3
		end
		
		-- spawn an explosion hitbox:
		local h = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 224<<FRACBITS, 80<<FRACBITS, mo.target, mo.pso.potency, DMT_RANGED, 2)	
		PSO.lib.copyWeaponProperties(mo, h)
		h.pso.combobreaker = true
		h.pso.potency = mo.pso.potency
		
		mo.fuse = TICRATE/2
		S_StartSound(actor, sfx_sblst2)
	end
	
end, MT_PSO_SLUGBURST_EXPLOSION)

PSO.info.photonArts["shotgun_pa_slugburst"] = {
		name = "Slug Burst",
		desc = "Fires slugs packed with explosives. Targets will explode after a brief delay, dealing damage to other surrounding enemies.",
		cost = 30,
		potency = 170,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SHTG5",
		
		-- p: player
		-- timer: how long the animation has played for
		-- hold: if true, button is being held down, if not, it's been released
		-- input: timer on how long the button has been held for
		-- combo: non-zero if the attack was performed from a combo.
					-- useful to create attacks that are faster/different if used repeatedly.
		
		-- return true to end the animation
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					--print(timer)
					-- set new weapon pos:
					local ang = p.drawangle - ANG1*30
					local x = 24*cos(ang)
					local y = 24*sin(ang)
					
					pos[2] = x
					pos[3] = y
					pos[5] = ANG1*10	-- lat. angle
					
					if timer == 1
						
						if combo
							pos[5] = FixedDiv(mo.height, mo.scale)/2
							pos[6] = 0
							
						else	-- we've just started that attack
							local z = FixedDiv(mo.height, mo.scale)
							pos[4] = z
								
							-- set angle
							pos[6] = ANG1*90 -- vert. angle
						end
					end
					
					if timer < 5
					and not combo
						pos[6] = $ - ANG1*20
						pos[4] = $ - FixedDiv(mo.height, mo.scale)/10
					elseif timer == 5
						pos[6] = 0
					end
					
					
					if timer == 9
						pos[6] = ANG1*30
						
						--local hb = PSO.lib.spawnHurtBox(mo.x + pos[2], mo.y + pos[3], mo.z + pos[4]*2/3, 255<<FRACBITS, 40<<FRACBITS, mo, potency, DMT_RANGED, TICRATE/2)
						local hb = PSO.lib.spawnMissile(mo, MT_PSO_SLUGBURST, 0, 0, potency, DMT_RANGED, 0, 0, 0)
						P_SetOrigin(hb, mo.x + pos[2], mo.y + pos[3], mo.z)
						hb.radius = 127<<FRACBITS
						hb.height = 50<<FRACBITS
						hb.target = mo
						hb.scale = FRACUNIT/8
						hb.destscale = FRACUNIT*2
						hb.color = winfo.effectcolor or PSO.info.elementColours[wep.element]
						
						P_InstaThrust(hb, p.drawangle, mo.scale*48)

						local range = winfo.range or 512
						hb.fuse = FixedDiv(range*FRACUNIT, FixedHypot(hb.momx, hb.momy))/FRACUNIT
						
						local msl
						for i = 1, 24
							local bullet = P_SpawnMobj(mo.x + pos[2], mo.y + pos[3], mo.z + pos[4], MT_PSO_RIFLESHOT)
							bullet.flags = MF_NOGRAVITY|MF_NOCLIPTHING
							bullet.angle = p.drawangle + ANG1*P_RandomRange(-30, 30)
							P_InstaThrust(bullet, bullet.angle, P_RandomRange(70, 90)*FRACUNIT)
							bullet.momz = P_RandomRange(-6, 6)*FRACUNIT
							bullet.scale = $/6
							bullet.fuse = P_RandomRange(3, 9)
							if winfo.effectcolor
								bullet.color = winfo.effectcolor
							else
								bullet.color = PSO.info.elementColours[wep.element]
							end	
							msl = bullet

							local t = P_SpawnMobj(bullet.x, bullet.y, bullet.z, MT_THOK)
							t.sprite = SPR_TRLS
							t.frame = A
							t.tics = bullet.fuse
							t.scale = mo.scale
							t.momx = bullet.momx
							t.momy = bullet.momy
							t.momz = bullet.momz
							t.color = SKINCOLOR_GREY
							
						end
						
						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						S_StartSoundAtVolume(mo, sfx_cburst, 96)
						S_StartSound(mo, sfx_cannon)

						-- small shockwave...
						local t = P_SpawnMobj(msl.x, msl.y, msl.z, MT_THOK)
						t.sprite = SPR_NTHK
						t.frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE
						t.color = msl.color
						t.scale = mo.scale/8
						t.destscale = mo.scale*4
						t.scalespeed = mo.scale/4
						t.tics = 10
						t.fuse = 10
						t.momz = mo.scale*4
						t.angle = msl.angle + ANG1*90
						P_InstaThrust(t, p.drawangle, FRACUNIT*20)
						t.momx = $+p.mo.momx
						t.momy = $+p.mo.momy

						local da = p.drawangle - ANG1*20
						for i = 1, 8
							local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
							P_InstaThrust(d, da, FRACUNIT*P_RandomRange(96, 128))
							d.momz = P_RandomRange(0, 2)*mo.scale
							d.renderflags = $|RF_PAPERSPRITE
							d.angle = da + ANG1*90
							d.tics = $ + P_RandomRange(1, 6)
								
							da = $ + (40/8)*ANG1
						end	

						if p == displayplayer
							P_StartQuake(FRACUNIT*10, 5)
						end	

						-- make the missile fade after it gets out of the range.
						--local range = wep.range or 512
						--msl.fuse = FixedDiv(range*FRACUNIT, FixedHypot(msl.momx, msl.momy))/FRACUNIT
						
					elseif timer > 9 and timer < 13
						pos[6] = $ - ANG1*10
					end
					
					if timer == TICRATE
						return true
					end
				end,
}

PSO.info.photonArts["shotgun_pa_gloriousrain"] = {
		name = "Glorious Rain",
		desc = "A stylish jump above your enemies as you rain down bullets. Invulnerable on startup.",
		cost = 25,
		potency = 500,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SHTG4",
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					--print(timer)
					-- set new weapon pos:
					local ang = p.drawangle -ANG1*90
					local x = 32*cos(ang)
					local y = 32*sin(ang)
					
					pos[2] = x
					pos[3] = y
					pos[5] = ANG1*90	-- lat. angle
					
					if timer == 1

						local z = FixedDiv(mo.height, mo.scale)
						pos[4] = z
								
						-- set angle
						--pos[6] = -ANG1*90 -- vert. angle
						pos[4] = -9999*FRACUNIT	-- make it invisible
						
						mo.momz = mo.scale*10
						mo.state = S_PLAY_SPRING
						P_InstaThrust(mo, p.drawangle, mo.scale*8)
						
						S_StartSound(mo, sfx_s3ka0)
						
						p.pso.iframes = TICRATE*3/4

						for j = 1, 16
									
							local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
							local a = (360/16)*j*ANG1
							d.angle = a + ANG1*90
							d.renderflags = $|RF_PAPERSPRITE
									
							d.destscale = $*4
									
							P_InstaThrust(d, a, 32*FRACUNIT*i)
							d.momx = $ + mo.momx
							d.momy = $ + mo.momy
						end
						
					end
					
					if timer > 1
						if leveltime & 1
							local g = P_SpawnGhostMobj(mo)
							g.colorized = true
							g.rollangle = mo.rollangle
						end
						
						mo.momz = max(0, $)
						
						if timer < TICRATE/4 +1
							mo.rollangle = $ + ANG1*20
						end
						
						if timer >= TICRATE/8
						and timer < TICRATE/8 + 10
							pos[4] = mo.height/2
							pos[6] = $ - ANG1*45
						end
						
						if timer == TICRATE/8 + 11
							pos[6] = -ANG1*90
						end
					end
					
					if timer == TICRATE/4 +5
					or timer == TICRATE/2 +5
					or timer == TICRATE*3/4 +5
						
						local hbx = mo.x
						local hby = mo.y 
						local hbz = mo.z - 256*mo.scale
						
						local hb = PSO.lib.spawnHurtBox(hbx, hby, hbz, 512<<FRACBITS, 256<<FRACBITS, mo, potency/3, DMT_RANGED, 4)
						hb.pso.locks = 5
						hb.pso.combobreaker = true
						hb.angle = p.drawangle
						
						local refb
						for i = 1, 16
							local bullet = P_SpawnMobj(mo.x + pos[2], mo.y + pos[3], mo.z + pos[4], MT_PSO_RIFLESHOT)
							bullet.flags = MF_NOGRAVITY|MF_NOCLIPTHING
							bullet.angle = p.drawangle + ANG1*P_RandomRange(-30, 30)
							P_InstaThrust(bullet, bullet.angle, P_RandomRange(-40, 40)*FRACUNIT)
							bullet.momz = P_RandomRange(-36, -12)*FRACUNIT
							bullet.scale = $/3
							bullet.fuse = P_RandomRange(3, 9)
							if winfo.effectcolor
								bullet.color = winfo.effectcolor
							else
								bullet.color = PSO.info.elementColours[wep.element]
							end	
							refb = bullet
						end
						
						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						S_StartSound(mo, sfx_turhit)

						local t = P_SpawnMobj(mo.x + pos[2], mo.y + pos[3], mo.z, MT_THOK)
						t.sprite = SPR_NTHK
						t.frame = B|FF_FULLBRIGHT
						t.flags2 = $ | MF2_SPLAT
						t.renderflags = $|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD						
						t.color = refb.color
						t.scale = mo.scale/8
						t.destscale = mo.scale*4
						t.scalespeed = mo.scale/4
						t.tics = 10
						t.fuse = 10
						t.momx = $+p.mo.momx
						t.momy = $+p.mo.momy
						t.momz = FRACUNIT*4

						if p == displayplayer
							P_StartQuake(FRACUNIT*10, 5)
						end						
						
						if timer == TICRATE*3/4 + 5
							mo.state = S_PLAY_ROLL
							mo.rollangle = 0
							mo.momz = $ + mo.scale*4
							return true
						end
						
						-- make the missile fade after it gets out of the range.
						--local range = wep.range or 512
						--msl.fuse = FixedDiv(range*FRACUNIT, FixedHypot(msl.momx, msl.momy))/FRACUNIT
					end
					/*elseif timer > TICRATE/3 and timer < TICRATE/3 + 4
						pos[6] = $ + ANG1*10
					end*/
					
					/*if timer == TICRATE
						return true
					end*/
				end,
}

PSO.info.photonArts["shotgun_pa_impactrecoil"] = {
		name = "Impact Recoil",
		desc = "Jump and fire a powerful shot that sends both your enemy and yourself away from each other to create distance.",
		cost = 25,
		potency = 600,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SHTG3",
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					--print(timer)
					-- set new weapon pos:
					local ang = p.drawangle - ANG1*30
					local x = 24*cos(ang)
					local y = 24*sin(ang)
					
					pos[2] = x
					pos[3] = y
					pos[5] = ANG1*10	-- lat. angle
					
					if timer == 1

						local z = FixedDiv(mo.height, mo.scale)
						pos[4] = z
								
						-- set angle
						pos[6] = ANG1*90 -- vert. angle
						
						mo.momz = mo.scale*10
						mo.state = S_PLAY_SPRING
						
						S_StartSound(mo, sfx_s3ka0)
					end
					
					if timer < 5
						pos[6] = $ - ANG1*30
						pos[4] = $ - FixedDiv(mo.height, mo.scale)/10
					end
					
					if timer == TICRATE/3
						pos[6] = ANG1*30
						
						local hbx = mo.x + 128*cos(p.drawangle)
						local hby = mo.y + 128*sin(p.drawangle)
						local hbz = mo.z - 128*mo.scale
						
						local hb = PSO.lib.spawnHurtBox(hbx, hby, hbz, 320<<FRACBITS, 80<<FRACBITS, mo, potency, DMT_RANGED, 4, RT_BLOWDOWN)
						hb.pso.locks = 5
						hb.pso.combobreaker = true
						hb.angle = p.drawangle
						
						local zd
						for i = 1, 16
							local bullet = P_SpawnMobj(mo.x + pos[2], mo.y + pos[3], mo.z + pos[4], MT_PSO_RIFLESHOT)
							bullet.flags = MF_NOGRAVITY|MF_NOCLIPTHING
							bullet.angle = p.drawangle + ANG1*P_RandomRange(-30, 30)
							P_InstaThrust(bullet, bullet.angle, P_RandomRange(48, 76)*FRACUNIT)
							bullet.momz = -mo.scale*32 + P_RandomRange(-6, 6)*FRACUNIT
							bullet.scale = $/3
							bullet.fuse = P_RandomRange(3, 9)
							if winfo.effectcolor
								bullet.color = winfo.effectcolor
							else
								bullet.color = PSO.info.elementColours[wep.element]
							end	
							zd = bullet
						end

						local t = P_SpawnMobj(zd.x, zd.y, zd.z, MT_THOK)
						t.sprite = SPR_NTHK
						t.frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE
						t.color = zd.color
						t.scale = mo.scale/8
						t.destscale = mo.scale*4
						t.scalespeed = mo.scale/4
						t.tics = 10
						t.fuse = 10
						t.momz = mo.scale*4
						t.angle = p.drawangle + ANG1*90
						P_InstaThrust(t, p.drawangle, FRACUNIT*20)
						t.momx = $+p.mo.momx
						t.momy = $+p.mo.momy
						
						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						S_StartSound(mo, sfx_turhit)
						
						P_InstaThrust(mo, p.drawangle, -mo.scale*10)
						mo.state = S_PLAY_FALL
						
						-- make the missile fade after it gets out of the range.
						--local range = wep.range or 512
						--msl.fuse = FixedDiv(range*FRACUNIT, FixedHypot(msl.momx, msl.momy))/FRACUNIT
						
					elseif timer > TICRATE/3 and timer < TICRATE/3 + 4
						pos[6] = $ - ANG1*10
					end
					
					if timer == TICRATE
						return true
					end
				end,
}

freeslot("MT_PSO_ZERODISTANCE", "S_PSO_ZERODISTANCE1", "S_PSO_ZERODISTANCE2", "S_PSO_ZERODISTANCE3")
mobjinfo[MT_PSO_ZERODISTANCE] = {
	doomednum = -1,
	spawnstate = S_PSO_ZERODISTANCE1,
	spawnhealth = 1000,
	radius = 1,
	height = 1,
	flags = MF_NOGRAVITY,
}

function A_ZeroDistanceExplosion(actor)
	S_StartSound(actor, sfx_sblst2)
	S_StartSound(actor, sfx_cybdth)
	for i = 1, 32
		local t = P_SpawnMobj(actor.x, actor.y, actor.z - actor.target.height/2, i & 1 and MT_SONIC3KBOSSEXPLODE or MT_THOK)
		t.color = actor.color
		t.scale = actor.scale
		t.destscale = i&1 and actor.scale*8 or 1
		t.scalespeed = actor.scale/12
		t.momx = P_RandomRange(-16, 16)*actor.scale
		t.momy = P_RandomRange(-16, 16)*actor.scale
		t.momz = P_RandomRange(-16, 16)*actor.scale
		if not (i & 1)
			t.frame = A|TR_TRANS10
			t.fuse = 20
			t.tics = 20	
		end
	end
	
	-- spawn the hitbox
	local h = PSO.lib.spawnHurtBox(actor.x, actor.y, actor.z, 320<<FRACBITS, 192<<FRACBITS, actor.target, actor.potency, DMT_RANGED, 4)
	PSO.lib.copyWeaponProperties(actor, h)
	h.pso.combobreaker = true
	h.pso.potency = actor.potency

	local t = P_SpawnMobj(actor.x, actor.y, actor.z, MT_THOK)
	t.sprite = SPR_NTHK
	t.frame = B|FF_FULLBRIGHT
	t.color = actor.color
	t.destscale = actor.scale*8
	t.scalespeed = actor.scale/2
	t.tics = 14
	t.fuse = 14
	t.momz = actor.scale*6	
			
	local p = consoleplayer
	if actor.target and actor.target.player == p
	and R_PointToDist2(actor.x, actor.y, actor.target.x, actor.target.y) < actor.scale*1024
		P_StartQuake(FRACUNIT*16, 5)
	end
end

function A_ZeroDistanceCheckRespawn(actor)
	if actor.extravalue1 > 0
		actor.state = S_PSO_ZERODISTANCE1
		actor.extravalue1 = $-1
	end
end

states[S_PSO_ZERODISTANCE1] = {SPR_NULL, A, 1, nil, 0, 0, S_PSO_ZERODISTANCE2}
states[S_PSO_ZERODISTANCE2] = {SPR_NULL, A, TICRATE/3, A_ZeroDistanceExplosion, 0, 0, S_PSO_ZERODISTANCE3}
states[S_PSO_ZERODISTANCE3] = {SPR_NULL, A, 1, A_ZeroDistanceCheckRespawn, 0, 0, S_NULL}

PSO.info.photonArts["shotgun_pa_zerodistance"] = {
		name = "Zero Distance",
		desc = "Fires a devastating close range blast right in front of you. Charge the attack to increase the potency.",
		cost = 30,
		potency = 550,
		speed = 100,
		
		icon = "H_SHTG2",
		
		use = 	function(p, timer, hold, input)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					local chargethreshold = PSO.lib.hasSkill(p, "ra_quickload") and TICRATE*2/3 or TICRATE
					
					--print(timer)
					-- set new weapon pos:
					local ang = p.drawangle - ANG1*30
					local x = 24*cos(ang)
					local y = 24*sin(ang)
					
					pos[2] = x
					pos[3] = y
					pos[5] = ANG1*10	-- lat. angle
					
					if timer == 1
						local z = FixedDiv(mo.height, mo.scale)
						pos[4] = z
							
						-- set angle
						pos[6] = ANG1*90 -- vert. angle
					end
					
					if timer < 5
						pos[6] = $ - ANG1*20
						pos[4] = $ - FixedDiv(mo.height, mo.scale)/10
					elseif timer == 5
						pos[6] = 0
					end
					
					if timer >= 5
					and timer < chargethreshold

						if timer == 5
							S_StartSound(mo, sfx_s3ka3)
						end
						
						-- show the charge...
						local cang = p.drawangle - ANG1*5
						local cx = 50*cos(cang)
						local cy = 50*sin(cang)
						
						if leveltime & 1
							local t = P_SpawnMobj(mo.x + FixedMul(cx, mo.scale), mo.y + FixedMul(cy, mo.scale), mo.z + mo.height*2/3, MT_THOK)
							t.tics = 2
							t.fuse = 2
							t.scale = mo.scale/3
							t.frame = A
							t.color = PSO.info.elementColours[wep.element]
							
							local t2 = P_SpawnMobj(t.x + P_RandomRange(-64, 64)*mo.scale, t.y + P_RandomRange(-64, 64)*mo.scale, t.z + P_RandomRange(-64, 64)*mo.scale, MT_THOK)
							t2.scale = mo.scale/4
							t2.destscale = mo.scale/8
							t2.scalespeed = mo.scale/12
							t2.frame = A
							
							if winfo.effectcolor
								t2.color = winfo.effectcolor
							else
								t2.color = PSO.info.elementColours[wep.element]
							end
							
							t2.momx = (t.x - t2.x)/10
							t2.momy = (t.y - t2.y)/10
							t2.momz = (t.z - t2.z)/10
							
							t2.fuse = 10
							t2.tics = 10
							
						end
					end
					
					if timer >= chargethreshold/3
					and timer < TICRATE*20
					and not hold
						-- just let it go.
						p.pso.actiontimer = TICRATE*30	-- first firing state.
						pos[6] = ANG1*90
						
						local x = 96*cos(p.drawangle)
						local y = 96*sin(p.drawangle)
						
						local zd = P_SpawnMobj(mo.x + x, mo.y + y, mo.z + mo.scale*30, MT_PSO_ZERODISTANCE)
						zd.target = mo
						zd.potency = potency		
						zd.color = PSO.info.elementColours[wep.element]

						local s = P_SpawnMobj(zd.x, zd.y, zd.z-zd.scale*420, MT_THOK)
						s.state = S_MEGISTAR1
						s.color = SKINCOLOR_WHITE
						s.scale = FRACUNIT*16
						s.destscale = 1
						s.scalespeed = FRACUNIT*3

						if timer >= chargethreshold
							zd.potency = $*3/4
							zd.extravalue1 = 2
						end

						P_InstaThrust(mo, p.drawangle, -16*FRACUNIT)
						p.skidtime = 20
						mo.saveang = p.drawangle
						p.pso.actionspeed = 0	-- remove all cmd prompts.
						p.drawangle = mo.angle
						mo.state = S_PLAY_WALK

						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						S_StartSound(mo, sfx_cannon)

						local t = P_SpawnMobj(zd.x, zd.y, zd.z, MT_THOK)
						t.sprite = SPR_NTHK
						t.frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE
						t.color = zd.color
						t.scale = mo.scale/8
						t.destscale = mo.scale*4
						t.scalespeed = mo.scale/4
						t.tics = 10
						t.fuse = 10
						t.momz = mo.scale*4
						t.angle = p.drawangle + ANG1*90
						P_InstaThrust(t, p.drawangle, FRACUNIT*20)
						t.momx = $+p.mo.momx
						t.momy = $+p.mo.momy

						local da = p.drawangle - ANG1*45
						for i = 1, 16
							local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
							P_InstaThrust(d, da, FRACUNIT*P_RandomRange(96, 128))
							d.momz = P_RandomRange(0, 4)*mo.scale
							d.scale = mo.scale*2
							d.renderflags = $|RF_PAPERSPRITE
							d.angle = da + ANG1*90
							d.tics = $ + P_RandomRange(1, 6)
							d.destscale = mo.scale*3
								
							da = $ + (90/16)*ANG1
						end	
						
						if p == displayplayer
							P_StartQuake(FRACUNIT*30, 5)
						end
						
						p.pso.cancancel = TICRATE/4
					end
					
					-- if we keep holding we'll eventually reach full charge!
					if timer == chargethreshold
						S_StopSound(mo)
						local g = P_SpawnGhostMobj(mo)
						g.destscale = mo.scale*4
						g.scalespeed = mo.scale/12
						S_StartSound(mo, sfx_s3ka8)
					end
					
					if timer >= TICRATE*20
					and timer < TICRATE*20 + 5
						pos[6] = $ - ANG1*10
					elseif timer == TICRATE*21
						return true
					end
					
					
					if timer >= TICRATE*30
					and timer < TICRATE*31
						p.drawangle = mo.saveang
						p.cmd.angleturn = mo.saveang/ANG1
					end	
					
					if timer >= TICRATE*30
					and timer < TICRATE*30 + 10
						pos[6] = $ - ANG1*10
					elseif timer == TICRATE*31
						P_InstaThrust(mo, 0, 0)
						p.drawangle = mo.saveang
						return true
					end
					
					-- hack to prevent us from reaching firing states.
					if p.pso.actiontimer > TICRATE*10
					and p.pso.actiontimer < TICRATE*20	-- if we're past here, don't do it.
						p.pso.actiontimer = TICRATE*10
					end
				end,
		
}