-- Sword photon arts
--PSO.info.photonArts = {}

freeslot("SPR_STRL")

PSO.lib.sword_trail = function(mo, pos, prevswordpos, overend)
	
	local spr = overend and SPR_GRNT or SPR_STRL
	local frame = overend and B or A
	local wep = PSO.lib.getPlayerActiveWeapon(mo.player)
	local winfo = PSO.lib.itemInfo(wep)
	local steps = overend and 3 or 5
	local tr = overend and TR_TRANS30|FF_ADD or TR_TRANS30
	
	for i = 0, steps
							
		local x = PSO.lib.lerp(mo.x + FixedMul(prevswordpos[1], mo.scale), mo.x + FixedMul(pos[2], mo.scale), FRACUNIT/steps *i)
		local y = PSO.lib.lerp(mo.y + FixedMul(prevswordpos[2], mo.scale), mo.y + FixedMul(pos[3], mo.scale), FRACUNIT/steps *i)
		local z = PSO.lib.lerp(mo.z + FixedMul(prevswordpos[3], mo.scale), mo.z + FixedMul(pos[4], mo.scale), FRACUNIT/steps *i)
		local a = PSO.lib.lerp(prevswordpos[4], pos[6], FRACUNIT/steps *i)
							
		local trail = P_SpawnMobj(x, y, z - mo.scale*8, MT_THOK)
		
		if pos[7] and pos[7].use
			
			if overend
				frame = C
			end
			
			P_CreateFloorSpriteSlope(trail)
						
			trail.flags2 = $ | MF2_SPLAT
			trail.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
			trail.floorspriteslope.o = pos[7].o
			trail.floorspriteslope.xydirection = pos[7].xy
			trail.floorspriteslope.zangle = pos[7].za
						
			trail.sprite = spr
			trail.frame = frame|tr
			
			trail.angle = 0	
			trail.rollangle = a			
			PSO.lib.fixSplatScale(trail)
			
		else
			trail.sprite = spr
			trail.frame = frame|tr|FF_PAPERSPRITE
			trail.angle = mo.player.drawangle + pos[5]
			trail.spritexscale = FRACUNIT
			trail.spriteyscale = FRACUNIT
			
			trail.rollangle = a
		end
		
		if overend
			trail.colorized = true
		end
		
		trail.tics = 10
		trail.fuse = 10						
		trail.color = winfo.effectcolor or SKINCOLOR_CYAN
	end
end

PSO.info.photonArts["sword_normal"] = {
		name = "Attack",
		desc = "A wide swing that can be chained up to 3 times to launch alternative attacks. Restores PP on hit.",
		cost = 0,
		normal = true,
		potency = 275,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		combo = TICRATE*20,	-- hack for the 3-hit combo
		icon = "H_SWATK1",

		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					-- slash 1:
					if not combo
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle + ANG1*90,	-- tilt sideways
							za = ANG1*30,				-- tilt by 30 degrees
						}
						
						local ang

						if mo.swordangle == nil
							mo.swordangle = 0
						end
						
						if timer < 3
							mo.swordangle = -ANG1*120
						elseif timer < TICRATE/2
							local nt = timer-3
							mo.swordangle = $ + max(0, ANG1*(30 - (nt-2)*4))
						end
						
						local ang = p.drawangle + mo.swordangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90
						
						-- damage box:
						if timer == TICRATE/8
							local x = mo.x + FixedMul(mo.scale, 100*cos(p.drawangle))
							local y = mo.y + FixedMul(mo.scale, 100*sin(p.drawangle))
							
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z-mo.scale*64, 140<<FRACBITS, 128<<FRACBITS, mo, potency, DMT_STRIKE, 8)
							hb.pso.potency = potency	-- normals shouldn't benefit from PA%
							hb.pso.ppregen = 10
							hb.pso.locks = 4
							hb.angle = p.drawangle
							hb.pso.hitlag = 4
							hb.pso.screenshake = {intensity = FRACUNIT*8, time=5}
							
							p.pso.cancancel = 3
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
						end
						
						if timer > TICRATE/2
						and timer < TICRATE*20
							p.pso.actiontimer = TICRATE*30 - TICRATE/4
						end
					
					-- slash 2:
					elseif combo == 1
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle - ANG1*90,	-- tilt sideways
							za = ANG1*30,				-- tilt by 30 degrees
						}
						
						local ang

						if mo.swordangle == nil
							mo.swordangle = 0
						end
						
						if timer < 3
							mo.swordangle = ANG1*120
						elseif timer < TICRATE/2
							local nt = timer-3
							mo.swordangle = $ - max(0, ANG1*(30 - (nt-2)*4))
						end
						
						local ang = p.drawangle + mo.swordangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90

						-- damage box:
						if timer == TICRATE/8
							local x = mo.x + FixedMul(mo.scale, 100*cos(p.drawangle))
							local y = mo.y + FixedMul(mo.scale, 100*sin(p.drawangle))
							
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z-mo.scale*64, 140<<FRACBITS, 128<<FRACBITS, mo, potency, DMT_STRIKE, 8)
							hb.pso.potency = potency	-- normals shouldn't benefit from PA%
							hb.pso.ppregen = 10
							hb.pso.locks = 4
							hb.angle = p.drawangle
							hb.pso.hitlag = 4
							hb.pso.screenshake = {intensity = FRACUNIT*8, time=5}							
							
							p.pso.cancancel = 3
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
						end
						
						if timer > TICRATE/2
						and timer < TICRATE*20
							p.pso.actiontimer = TICRATE*30 - TICRATE/4
						end					
					
					elseif combo == 2
						
						p.pso.actionspeed = 0
						
						if timer == 1
							p.mo.swordhangle = p.drawangle
							if P_IsObjectOnGround(mo)
								mo.momz = FRACUNIT*4
								mo.state = S_PLAY_SPRING
							end
						end
						
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle + ANG1*90,
							za = -ANG1*25,
						}
						
						local ang

						if mo.swordangle == nil
							mo.swordangle = 0
						end
						
						if timer < 3
							mo.swordangle = -ANG1*120
						elseif timer < TICRATE
							local nt = timer-3
							mo.swordangle = $ + max(0, ANG1*(47 - (nt-2)*3))
						end
						
						local ang = mo.angle + mo.swordangle + ANG1*70
						p.drawangle = ang
						local x = 32 * cos(ang)
						local y = 32 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*40

						-- damage box:
						if timer == TICRATE/4
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z-mo.scale*64, 340<<FRACBITS, 128<<FRACBITS, mo, potency*3, DMT_STRIKE, 8, RT_KNOCKBACK)
							hb.pso.potency = potency*3	-- normals shouldn't benefit from PA%
							hb.pso.ppregen = 15
							hb.pso.locks = 6
							hb.pso.reactionradialangle = true
							hb.pso.hitlag = 6
							hb.pso.screenshake = {intensity = FRACUNIT*16, time=5}							
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
						end
						
						if timer == TICRATE	
							return true
						end
					end
					
					-- sword trail:
					if timer > 1
						PSO.lib.sword_trail(mo, pos, prevswordpos)
					end
					
					if timer == 30*TICRATE
						return true
					end
					
					--P_SpawnMobj(mo.x+pos[2], mo.y+pos[3], mo.z+pos[4], MT_THOK)
					
				end,
}

PSO.info.photonArts["sword_pa_overend"] = {
		name = "Over End",
		desc = "Executes a lenghty 3 hit combo that slashes enemies with a massive blade of Photons",
		cost = 40,
		potency = 2800,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still

		icon = "H_SWATK6",
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					if timer == 1
						
						pos[2] = 0
						pos[3] = 0
						pos[4] = FRACUNIT*100
						pos[5] = ANG1*90
						pos[6] = ANG1*90	
						p.pso.superarmor = true
						p.pso.avengerguard = 1	-- lasts for 7f, only useful if the player has arts avenger.
						
					end
					
					if timer == TICRATE/5
						
						local g = P_SpawnMobj(pos[1].x, pos[1].y, pos[1].z, MT_THOK)
						g.sprite = SPR_GRNT
						g.frame = B|FF_PAPERSPRITE|FF_ADD|TR_TRANS20
						g.color = winfo.effectcolor or SKINCOLOR_CYAN
						g.angle = pos[1].angle
						g.destscale = pos[1].scale*8
						g.rollangle = pos[1].rollangle
						g.fuse = 10
						g.tics = 10
						g.spriteyscale = $*2
						
						S_StartSound(mo, sfx_s3k9f)
						
						-- The Xenoblade.
						/*if winfo.monadobuster
							p.pso.actiontimer = TICRATE*3/2
						end*/
					end
					
					

					-- slash 1:
					if timer > TICRATE/2 and timer < TICRATE
						local t = timer - TICRATE/2
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle + ANG1*90,	-- tilt sideways
							za = ANG1*30,				-- tilt by 30 degrees
						}
						
						local ang

						if mo.swordangle == nil
							mo.swordangle = 0
						end
						
						if t < 3
							mo.swordangle = -ANG1*120
						elseif t < TICRATE/2
							local nt = t-3
							mo.swordangle = $ + max(0, ANG1*(30 - (nt-2)*4))
						end
						
						local ang = p.drawangle + mo.swordangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90
						
						-- damage box:
						if t == TICRATE/8
							local x = mo.x + FixedMul(mo.scale, 160*cos(p.drawangle))
							local y = mo.y + FixedMul(mo.scale, 160*sin(p.drawangle))
							
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z-mo.scale*64, 256<<FRACBITS, 192<<FRACBITS, mo, potency/6, DMT_STRIKE, 8)
							hb.pso.combobreaker = true
							hb.pso.locks = 4
							hb.angle = p.drawangle
							hb.pso.hitlag = 6
							hb.pso.screenshake = {intensity = FRACUNIT*20, time=5}
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
							S_StartSound(mo, sfx_s3ka8)
						end

					-- slash 2:
					elseif timer >= TICRATE
					and timer <= TICRATE*3/2
						local t = timer - TICRATE
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle - ANG1*90,	-- tilt sideways
							za = ANG1*30,				-- tilt by 30 degrees
						}
						
						local ang

						if mo.swordangle == nil
							mo.swordangle = 0
						end
						
						if t < 3
							mo.swordangle = ANG1*120
						elseif t < TICRATE/2
							local nt = t-3
							mo.swordangle = $ - max(0, ANG1*(30 - (nt-2)*4))
						end
						
						local ang = p.drawangle + mo.swordangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90

						-- damage box:
						if t == TICRATE/8
							local x = mo.x + FixedMul(mo.scale, 100*cos(p.drawangle))
							local y = mo.y + FixedMul(mo.scale, 100*sin(p.drawangle))
							
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z - mo.scale*64, 256<<FRACBITS, 192<<FRACBITS, mo, potency/6, DMT_STRIKE, 8)
							hb.pso.combobreaker = true
							hb.pso.locks = 4
							hb.angle = p.drawangle
							hb.pso.hitlag = 6
							hb.pso.screenshake = {intensity = FRACUNIT*20, time=5}
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
							S_StartSound(mo, sfx_s3ka8)

							hb.pso.hitlag = 7
							hb.pso.screenshake = {intensity = FRACUNIT*20, time=7}
							
						end
					elseif timer >= TICRATE*3/2
						
						local t = timer - TICRATE*3/2
						
						if t == 1
							S_StartSound(mo, sfx_s3k8e)
						end
						
						if t < TICRATE*3/4
							mo.groundtimer = 0
							pos[7] = {use=false}
							pos[2] = 0
							pos[3] = 0
							pos[4] = FRACUNIT*100
							pos[5] = ANG1*90
							pos[6] = ANG1*90	
							
							if timer%10 == 0
								local g = P_SpawnMobj(pos[1].x, pos[1].y, pos[1].z, MT_THOK)
								g.sprite = SPR_GRNT
								g.frame = B|FF_PAPERSPRITE|FF_ADD|TR_TRANS20
								g.color = winfo.effectcolor or SKINCOLOR_CYAN
								g.angle = pos[1].angle
								g.destscale = pos[1].scale*8
								g.rollangle = pos[1].rollangle
								g.color = winfo.color or SKINCOLOR_CYAN
								g.fuse = 10
								g.tics = 10
								g.spriteyscale = $*2						
							end
						end
						
						local s = P_SpawnMobj(pos[1].x + P_RandomRange(-32, 32)*mo.scale, pos[1].y + P_RandomRange(-32, 32)*mo.scale, pos[1].z, MT_SUPERSPARK)
						s.colorized = true
						s.color = winfo.effectcolor or SKINCOLOR_CYAN
						s.momx = P_RandomRange(-4, 4)*mo.scale
						s.momy = P_RandomRange(-4, 4)*mo.scale
						s.momz = P_RandomRange(4, 24)*mo.scale
						
						
						if t == TICRATE*3/4
							mo.momz = mo.scale*12
							mo.state = S_PLAY_SPRING
						end
						
						if t > TICRATE*3/4
						and t <= TICRATE
							pos[5] = $ - (ANG1*45) /4
						end
						
						if t >= TICRATE
							
							local t2 = t - TICRATE
							local h_an = p.drawangle
							local v_an = (-30 + min(t2, 10)*13)*ANG1
							local dist = 64
							
							local posa = FixedMul(mo.scale, sin(v_an)*dist)
							local tx = FixedMul(cos(h_an), posa)
							local ty = FixedMul(sin(h_an), posa)
							local tz = mo.height/2 + FixedMul(mo.scale, dist*cos(v_an))
							
							pos[2] = tx
							pos[3] = ty
							pos[4] = tz
							pos[5] = ANG1*5
							pos[6] = -(v_an - ANG1*90)
							
							if leveltime & 1
							and not P_IsObjectOnGround(mo)
								local g = P_SpawnGhostMobj(mo)
								g.colorized = true
							end
							mo.momz = $ + P_GetMobjGravity(mo)*2
							
							
							if P_IsObjectOnGround(mo)
								
								if mo.groundtimer == 0
									S_StartSound(mo, sfx_s3k9b)
									S_StartSound(mo, sfx_s3k83)
									
									if p == consoleplayer
										P_StartQuake(FRACUNIT*60, 10)
									end
									
									local hbs = {}
									for i = 1, 64
										local range = 32*i
										local x = mo.x + range*cos(p.drawangle)
										local y = mo.y + range*sin(p.drawangle)

										local hb = PSO.lib.spawnHurtBox(x, y, mo.z-mo.scale*64, 192<<FRACBITS, 192<<FRACBITS, mo, potency*2/3, DMT_STRIKE, 8, RT_BLOWDOWN)
										hb.pso.combobreaker = true
										hbs[#hbs+1] = hb
										hb.pso.links = hbs
										hb.angle = p.drawangle
										
										local s = P_SpawnMobj(x + P_RandomRange(-32, 32)*mo.scale, y + P_RandomRange(-32, 32)*mo.scale, mo.z, MT_SUPERSPARK)
										s.color = winfo.effectcolor or SKINCOLOR_CYAN
										s.colorized = true
										s.angle = mo.angle + ANG1*90 * (i&1 and 1 or -1)
										P_InstaThrust(s, s.angle, P_RandomRange(8, 16)*mo.scale)
										--s.momx = P_RandomRange(-8, 8)*mo.scale
										--s.momy = P_RandomRange(-8, 8)*mo.scale
										s.momz = P_RandomRange(4, 16)*mo.scale
										
										
										for j = 1, 2
											s = P_SpawnMobj(x + P_RandomRange(-32, 32)*mo.scale, y + P_RandomRange(-32, 32)*mo.scale, mo.z, MT_SPINDUST)
											s.angle = mo.angle + ANG1*90 * (i&1 and 1 or -1)
											P_InstaThrust(s, s.angle, (80 - i)*mo.scale)
											s.renderflags = $|RF_PAPERSPRITE
											s.scale = mo.scale*3
											s.destscale = mo.scale*8
											s.momz = P_RandomRange(2, 6)*mo.scale
											s.angle = $+ANG1*90
										end
									end
								end
								
								mo.groundtimer = $+1
								
								if mo.groundtimer >= TICRATE*3/4
									return true
								end
							end
							
						end
					end
					
					--P_SpawnMobj(mo.x+pos[2], mo.y+pos[3], mo.z+pos[4], MT_THOK)*/
					
					if timer > TICRATE/5
						PSO.lib.sword_trail(mo, pos, prevswordpos, true)
					end
					
				end,
}

PSO.info.photonArts["sword_pa_risingedge"] = {
		name = "Rising Edge",
		desc = "A quick upwards slash that sends the enemy tumbling upwards.",
		cost = 25,
		potency = 700,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SWATK5",
		
		use = 	function(p, timer, hold, input, combo)
					
					local slamtime = TICRATE
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					-- set pos floorsprite
					
					if timer == 1
						mo.momx = $*3/4
						mo.momy = $*3/4
						p.pso.avengerguard = 1	-- lasts for 7f, only useful if the player has arts avenger.
					end
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}

					
					pos[7] = {
						use = true,
						o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
						xy = p.drawangle + ANG1*120,	-- tilt sideways
						za = ANG1*60,
					}
						
					local ang

					if mo.swordangle == nil
						mo.swordangle = 0
					end
						
					if timer < 3
						mo.swordangle = -ANG1*140
					elseif timer < TICRATE/2
						local nt = timer-3
						mo.swordangle = $ + max(0, ANG1*(30 - (nt-2)*4))
					end
						
					local ang = p.drawangle + mo.swordangle
					local x = 64 * cos(ang)
					local y = 64 * sin(ang)
						
					pos[2] = x
					pos[3] = y
					pos[4] = mo.height/2
					pos[5] = 0
					pos[6] = ang + ANG1*90	
					
					if timer == TICRATE/4
						mo.momz = mo.scale*10
						mo.state = S_PLAY_SPRING
						
						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						S_StartSound(mo, sfx_s3ka2)
						
						if p == displayplayer
							P_StartQuake(FRACUNIT*20, 8)
						end

						local x = mo.x + 96*cos(p.drawangle)
						local y = mo.y + 96*sin(p.drawangle)
						local hb = PSO.lib.spawnHurtBox(x, y, mo.z - mo.scale*64, 140<<FRACBITS, 384<<FRACBITS, mo, potency, DMT_STRIKE, 3, RT_BLOWDOWN)
						hb.pso.combobreaker = true
						hb.angle = mo.angle
						hb.pso.locks = 2
						hb.pso.reactionstrength = 10
						hb.pso.hitlag = 6
						hb.pso.screenshake = {intensity = FRACUNIT*20, time=5}
						
							
						local da = p.drawangle - ANG1*45
						for i = 1, 16
							local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
							P_InstaThrust(d, da, FRACUNIT*P_RandomRange(96, 128))
							d.momz = P_RandomRange(0, 4)*mo.scale
							d.scale = mo.scale*2
							d.renderflags = $|RF_PAPERSPRITE
							d.angle = da + ANG1*90
							d.tics = $ + P_RandomRange(1, 6)
							d.destscale = mo.scale*3
								
							da = $ + (90/16)*ANG1
						end				
						
						
					elseif timer >= TICRATE/4
					and timer <= TICRATE/4 + 10
						local t = timer-(TICRATE/4)
						mo.player.drawangle = mo.angle + t*ANG1*36
					end
					
					if timer > 1
						PSO.lib.sword_trail(mo, pos, prevswordpos)
					end
					
					if timer == TICRATE*3/4
						return true
					end
					--end
				end,
}

PSO.info.photonArts["sword_pa_spindrop"] = {
		name = "Spin Drop",
		desc = "A forward spinning jump culminating in a power slash slamming the ground.",
		cost = 25,
		potency = 850,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SWATK4",
		
		use = 	function(p, timer, hold, input, combo)
					
					local slamtime = TICRATE
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					if timer == 1
						
						mo.momx = $/2
						mo.momy = $/2
						
						if not P_IsObjectOnGround(mo)
							p.pso.actiontimer = TICRATE/4 -1
						else
							mo.momz = FRACUNIT*10
							mo.state = S_PLAY_SPRING
						end
						
						mo.groundtimer = nil
						p.pso.avengerguard = 1	-- lasts for 7f, only useful if the player has arts avenger.
						
					end
					
					if timer >= 1
					and timer < slamtime
						mo.momz = max(0, $)
					elseif timer == slamtime
						mo.momz = -FRACUNIT*20
						mo.state = S_PLAY_FALL
						mo.momx = 0
						mo.momy = 0
						S_StartSound(mo, sfx_s23c)
					end
					
					if timer == TICRATE/4
						--S_StartSoundAtVolume(mo, sfx_mswarp, 160)
						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end						
					end	
					
					if timer >= TICRATE/4
						if timer < slamtime
						and mo.state ~= S_PLAY_ROLL
							mo.state = S_PLAY_ROLL
						end
						
						local h_an = p.drawangle
						local v_an = min(TICRATE-10, (timer - TICRATE/4)) *ANG1*32
						local dist = 64
						
						local posa = FixedMul(mo.scale, sin(v_an)*dist)
						local tx = FixedMul(cos(h_an), posa)
						local ty = FixedMul(sin(h_an), posa)
						local tz = mo.height/2 + FixedMul(mo.scale, dist*cos(v_an))
						
						pos[2] = tx
						pos[3] = ty
						pos[4] = tz
						pos[5] = ANG1*5
						pos[6] = -(v_an - ANG1*90)
						
						PSO.lib.sword_trail(mo, pos, prevswordpos)
					end
					
					if timer == TICRATE/4 *2
					or timer == TICRATE/4 *3
						-- spawn a hitbox in front of and another behind the player
						local hpotency = potency/4	-- 1/4th of the damage
						
						local ang = p.drawangle
						for i = 1, 2
							
							local x = mo.x + 96*cos(ang)
							local y = mo.y + 96*sin(ang)							
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z-mo.scale*128, 140<<FRACBITS, 384<<FRACBITS, mo, hpotency, DMT_STRIKE, 3)
							hb.pso.combobreaker = true
							hb.pso.locks = 1
							hb.pso.hitlag = 4
							hb.pso.screenshake = {intensity = FRACUNIT*8, time=5}
							
							ang = $ + ANG1*180
						end	

						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						
					end
					
					if timer > slamtime
						if P_IsObjectOnGround(mo)
						and not mo.groundtimer
							mo.groundtimer = timer
							S_StartSound(mo, sfx_pstop)
							S_StartSound(mo, sfx_s3k59)
							
							local x = mo.x + 96*cos(p.drawangle)
							local y = mo.y + 96*sin(p.drawangle)
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z - mo.scale*32, 140<<FRACBITS, 384<<FRACBITS, mo, potency/2, DMT_STRIKE, 3)
							hb.pso.combobreaker = true
							hb.pso.locks = 2
							
							if p == displayplayer
								P_StartQuake(FRACUNIT*30, 10)
							end
							
							local da = p.drawangle - ANG1*45
							for i = 1, 16
								local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
								P_InstaThrust(d, da, FRACUNIT*P_RandomRange(96, 128))
								d.momz = P_RandomRange(0, 4)*mo.scale
								d.scale = mo.scale*2
								d.renderflags = $|RF_PAPERSPRITE
								d.angle = da + ANG1*90
								d.tics = $ + P_RandomRange(1, 6)
								d.destscale = mo.scale*3
								
								da = $ + (90/16)*ANG1
							end

							for i = 1, 2
								for j = 1, 16
									
									local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
									local a = (360/16)*j*ANG1
									d.angle = a + ANG1*90
									d.renderflags = $|RF_PAPERSPRITE
									
									if i > 1
										d.spritexscale = $*2
									end
									
									d.destscale = $*4
									
									P_InstaThrust(d, a, 32*FRACUNIT*i)
									d.momx = $ + mo.momx
									d.momy = $ + mo.momy
								end
							end							
							
							p.pso.cancancel = 1
						elseif not P_IsObjectOnGround(mo)
						and leveltime & 1
							local g = P_SpawnGhostMobj(mo)
							g.colorized = true
							g.tics = 4
						
						end
						
						if mo.groundtimer
						and timer == mo.groundtimer + TICRATE/4
							mo.groundtimer = nil
							return true
						end
					end
					
					--P_SpawnMobj(mo.x+pos[2], mo.y+pos[3], mo.z+pos[4], MT_THOK)
						
				end,
}

-- extend cutter slash
freeslot("MT_SWORDEXTENDCUTTER", "S_EXTENDCUTTER", "SPR_SWSL")
mobjinfo[MT_SWORDEXTENDCUTTER] = {
	doomednum = -1,
	spawnstate = S_EXTENDCUTTER,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	radius = 5<<FRACBITS,
	height = 10<<FRACBITS,
	flags = MF_MISSILE|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP,
}

-- disable collision for barta
addHook("MobjCollide", function(mo1, mo2) return false end, MT_SWORDEXTENDCUTTER)
addHook("MobjMoveCollide", function(mo1, mo2) return false end, MT_SWORDEXTENDCUTTER)

function A_ExtendCutter(mo)

	if not mo.pso return end

	mo.floorspriteslope.o = {x = mo.x, y = mo.y, z = mo.z}

	local trail = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	P_CreateFloorSpriteSlope(trail)
					
	trail.flags2 = $ | MF2_SPLAT
	trail.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
					
	trail.sprite = mo.sprite
	trail.frame = A|TR_TRANS30
	trail.tics = 20
	trail.fuse = 20
	trail.floorspriteslope.o = {x=mo.floorspriteslope.o.x, y=mo.floorspriteslope.o.y, z=mo.floorspriteslope.o.z}
	trail.floorspriteslope.xydirection = mo.floorspriteslope.xydirection
	trail.floorspriteslope.zangle = mo.floorspriteslope.zangle
	trail.rollangle = mo.rollangle
	trail.angle = 0
	trail.color = mo.color
	trail.destscale = mo.scale*8
	
	mo.friction = FRACUNIT	-- no slowdown
	if not mo.hurtbox
		if mo.elysion
			mo.hurtbox = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 192<<FRACBITS, 192<<FRACBITS, mo.target, mo.pso.potency, DMT_STRIKE, TICRATE*999, RT_KNOCKBACK)
			mo.hurtbox.pso.combobreaker = false
			mo.hurtbox.pso.reactionstrength = 60
			mo.hurtbox.angle = mo.angle
		else
			mo.hurtbox = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 192<<FRACBITS, 192<<FRACBITS, mo.target, mo.pso.potency, DMT_STRIKE, TICRATE*999)
			mo.hurtbox.pso.combobreaker = true
		end
		mo.hurtbox.pso.potency = mo.pso.potency
	else
		mo.hurtbox.fuse = 2
		P_MoveOrigin(mo.hurtbox, mo.x, mo.y, mo.z)
	end
end

states[S_EXTENDCUTTER] = {SPR_SWSL, A|FF_ADD, 1, A_ExtendCutter, 0, 0, S_EXTENDCUTTER}

PSO.info.photonArts["sword_pa_extendcutter"] = {
		name = "Extend Cutter",
		desc = "A powerful slash that generates a medium range shockwave.",
		cost = 20,
		potency = 650,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SWATK3",
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					pos[7] = {
						use = true,
						o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
						xy = p.drawangle + ANG1*90,	-- tilt sideways
						za = ANG1*40,				-- tilt by 30 degrees
					}
						
					local ang

					if mo.swordangle == nil
						mo.swordangle = 0
					end
					
					if timer == 1
						p.pso.avengerguard = 1	-- lasts for 7f, only useful if the player has arts avenger.
						S_StartSound(mo, sfx_s3k60)
					end
					
					if timer < TICRATE/2
						mo.swordangle = -ANG1*150
					elseif timer < TICRATE*2
						local nt = timer-TICRATE/2
						mo.swordangle = $ + max(0, ANG1*(35 - (nt-2)*4))
					end
						
					local ang = p.drawangle + mo.swordangle
					local x = 64 * cos(ang)
					local y = 64 * sin(ang)
						
					pos[2] = x
					pos[3] = y
					pos[4] = mo.height/2
					pos[5] = 0
					pos[6] = ang + ANG1*90
						
					-- damage box:
					if timer == TICRATE/2
						local x = FixedMul(mo.scale, 32*cos(p.drawangle))
						local y = FixedMul(mo.scale, 32*sin(p.drawangle))
							
						--(x, y, z, w, t, source, potency, dtype, duration)
						local trail = PSO.lib.spawnMissile(mo, MT_SWORDEXTENDCUTTER, p.drawangle, 32*FRACUNIT, potency, DMT_STRIKE, x, y, mo.height/2)
						P_CreateFloorSpriteSlope(trail)
										
						trail.flags2 = $ | MF2_SPLAT
						trail.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
						trail.floorspriteslope.o = pos[7].o
						trail.floorspriteslope.xydirection = pos[7].xy
						trail.floorspriteslope.zangle = pos[7].za	
						trail.rollangle = p.drawangle + ANG1*90
						trail.angle = 0
						trail.color = winfo.effectcolor or SKINCOLOR_CYAN
						
						P_InstaThrust(trail, p.drawangle, FRACUNIT*45)
						PSO.lib.aimMissile(trail, p.pso.target)
						trail.fuse = TICRATE
							
						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						S_StartSound(mo, sfx_s3ka2)
						
						if p == displayplayer
							P_StartQuake(FRACUNIT*20, 8)
						end

						local da = p.drawangle - ANG1*45
						for i = 1, 16
							local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
							P_InstaThrust(d, da, FRACUNIT*P_RandomRange(96, 128))
							d.momz = P_RandomRange(0, 4)*mo.scale
							d.scale = mo.scale*2
							d.renderflags = $|RF_PAPERSPRITE
							d.angle = da + ANG1*90
							d.tics = $ + P_RandomRange(1, 6)
							d.destscale = mo.scale*3
								
							da = $ + (90/16)*ANG1
						end
						
					end
					
					-- sword trail:
					if timer > 1
						PSO.lib.sword_trail(mo, pos, prevswordpos)
					end
					
					if timer == TICRATE*3/4
						p.pso.cancancel = 1
					end
					
					if timer == TICRATE*3/2
						return true
					end
						
					--P_SpawnMobj(mo.x+pos[2], mo.y+pos[3], mo.z+pos[4], MT_THOK)
						
				end,
}
		
PSO.info.photonArts["sword_pa_spiralbreak"] = {
		name = "Spiral Break",
		desc = "Swing in a circular motion before leaping and crashing down in an area of effect.",
		cost = 30,
		potency = 950,
		speed = 10,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SWATK2",
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					
					if timer == 1
						mo.initangle = p.drawangle
						mo.state = S_PLAY_FALL
						mo.groundtimer = 0
						p.pso.avengerguard = 1	-- lasts for 7f, only useful if the player has arts avenger.
						S_StartSound(mo, sfx_beflap)
					end
					
					if timer < TICRATE*3/4
						
						local ang = mo.initangle + timer*ANG1*30
						p.drawangle = ang
						
						local sx = 32*cos(ang)
						local sy = 32*sin(ang)

						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = mo.initangle + ANG1*45,
							za = min(ANG1*45, timer*ANG1*2),
						}
						
						pos[2] = sx
						pos[3] = sy
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*40						
						
						local momz = (TICRATE*3/4 - timer)*mo.scale / 6
						mo.momz = momz
						
						if timer == 4
						or timer == 17
							local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z-mo.scale*192, 320<<FRACBITS, 384<<FRACBITS, mo, potency/5, DMT_STRIKE, 8)
							hb.pso.combobreaker = true
							hb.pso.locks = 4
							hb.pso.hitlag = 4
							hb.pso.screenshake = {intensity = FRACUNIT*8, time=5}							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
						end
						
					elseif timer >= TICRATE*3/4
						
						if timer == TICRATE*3/4
							mo.momz = mo.scale*48
							S_StartSound(mo, sfx_zoom)
						end
						
						mo.momz = $ - mo.scale*6
						
						pos[7] = {
							use = false,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = 0,
							za = 0,
						}
						
						pos[2] = 0
						pos[3] = 0
						pos[4] = 0
						pos[5] = ANG1*90
						pos[6] = -ANG1*90
						
						if P_IsObjectOnGround(mo)
							if not mo.groundtimer
								mo.groundtimer = timer
								local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z - mo.scale*32, 320<<FRACBITS, 120<<FRACBITS, mo, potency*3/5, DMT_STRIKE, 8, RT_BLOWDOWN)
								hb.pso.combobreaker = true
								hb.pso.reactionradialangle = true
								S_StartSound(mo, sfx_pstop)
								S_StartSound(mo, sfx_s3k59)
								
								p.pso.cancancel = TICRATE/8
								
								if p == displayplayer
									P_StartQuake(FRACUNIT*30, 10)
								end

								for i = 1, 4
									for j = 1, 16
										
										local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
										local a = (360/16)*j*ANG1
										d.angle = a + ANG1*90
										d.renderflags = $|RF_PAPERSPRITE
										
										if i > 1
											d.spritexscale = $*2
										end
										
										d.destscale = $*4
										d.momz = (8-i)*FRACUNIT
										
										P_InstaThrust(d, a, 32*FRACUNIT*i)
										d.momx = $ + mo.momx
										d.momy = $ + mo.momy
									end
								end	
							end
						end
						
						if mo.groundtimer
						and timer > mo.groundtimer + TICRATE/2
							return true
						end
					end	

					if timer > 1
					and timer < TICRATE*3/4
						PSO.lib.sword_trail(mo, pos, prevswordpos)
					end
					
				end,
}
