-- Rod/Wand cast and base technique definition

PSO.info.photonArts["rod_cast"] = {
		name = "Cast (Rod)",
		desc = "Cast a Technique",
		cost = 0,
		potency = 120,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SWATK1",

		use = 	function(p, timer, hold, input, combo)
					local mo = p.mo
					local pos = p.pso.weaponpos[1]
					local tech = PSO.info.photonArts[p.pso.taction]
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					
					if not tech
						return true
					end
					
					local object = tech.object
					local potency = tech.potency*PSO.info.photonArts[p.pso.action].potency/100	-- rod cast bonus
					local casttime = tech.casttime or TICRATE/2
					local swingtime = TICRATE*10
					
					-- for held techs
					local held = tech.held
					local heldmin = tech.heldmin or TICRATE
					local helddelay = tech.helddelay or TICRATE/4
					local drain = tech.helddrain or 0
					local drainf = tech.helddrainf or 0
					local heldfn = tech.heldfunc 
					
					local nc = {casttime}
					PSO.lib.runHook("playerCastTime", p, tech, nc)
					casttime = nc[1]
					
					-- force PB reduces cast time
					if PSO.lib.usingPB(p) == "fo_photonflare"
						casttime = max(1, $*8/10)
					end
					
					-- phantom cast nullifies it!
					if p.pso.phantomcast
					and timer == 1
						casttime = 1
					end
					
					-- fo TAJA does that too!
					if PSO.lib.hasSkill(p, "fo_techartsalt")
					and p.pso.lastelement and p.pso.lastelement ~= tech.element
						casttime = max(1, $/2)
					end
					
					if timer <= casttime
						
						local x = FixedMul(mo.scale, 8*cos(p.drawangle - ANG1*40))
						local y = FixedMul(mo.scale, 8*sin(p.drawangle - ANG1*40))
						local z = FixedDiv(mo.height*12/10, mo.scale)
						
						pos[2] = x
						pos[3] = y
						pos[4] = z
						pos[5] = ANG1*90
						pos[6] = ANG1*90
						
						p.pso.cancancel = 1
						
					end
					
					if timer == casttime
						p.pso.actiontimer = swingtime
						p.pso.cancancel = nil
						if p.pso.phantomcast
						and timer == 1
							p.pso.phantomcast = $-1
						end
					end
					
					p.pso.actionspeed = (tech.actionspeed or 30)
					
					-- swing the rod and cast the tech!
					if timer >= swingtime
						-- swing rod from top to bottom!
						local newtimer = timer-swingtime
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle + ANG1*90,	-- tilt sideways
							za = -ANG1*45,				-- tilt by 30 degrees
						}			

						
						local ang
						
						if newtimer < 3
							mo.rodangle = -ANG1*80
						elseif newtimer < TICRATE/2
							local nt = newtimer-3
							mo.rodangle = $ + max(0, ANG1*(20 - (nt-2)*4))
						end
						
						local ang = p.drawangle + mo.rodangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90
						
						local firetime = swingtime + TICRATE/4
						local firing = timer == firetime
						
						-- held techs
						local heldfor
						if held
							heldfor = timer - firetime
							
							if heldfor % helddelay == 0
								firing = true
							end
						end
						
						-- spawn the tech effect
						if firing
							
							local dist = tech.spawndist or 0
							local offx = dist*cos(p.drawangle)
							local offy = dist*sin(p.drawangle)
							local offz = FixedDiv(48*FRACUNIT*(tech.spawnheight or 0)/100, mo.scale)
							
							local spd = tech.speed
							if spd == nil
								spd = 40	-- 0 spd is still valid
							end
							
							local msl = PSO.lib.spawnMissile(mo, object, p.drawangle, spd*FRACUNIT, potency, DMT_TECHNIQUE, offx, offy, offz, tech.reaction)
							if tech.aim
								PSO.lib.aimMissile(msl, p.pso.target)
							end

							if tech.element
								msl.pso.element = tech.element
							end
								
							local range = wep.range or 512
							if range and spd
								msl.fuse = FixedDiv(range*FRACUNIT, max(1, FixedHypot(msl.momx, msl.momy)))/FRACUNIT
							end
								
							-- tech is a combo breaker is it's NOT actions 1 or 4
							-- yes it's magic numbers but also that's never changing so who cares.
							if p.pso.actionnum % 3 ~= 1	-- if we ever add more for some reason lol
								msl.pso.combobreaker = true
							end
								
							if tech.spawntarget
							and p.pso.target
							and p.pso.target.valid	-- make sure the target is alive.
								P_MoveOrigin(msl, p.pso.target.x, p.pso.target.y, p.pso.target.z)
							end
							
							PSO.lib.runHook("playerTechnique", p, msl, (held and heldfor/helddelay or 0))
							
							if msl and msl.valid
								if tech.sound
									S_StartSound(mo, tech.sound)
								end
								
								if tech.spawnfunc
									tech.spawnfunc(msl)
								end
							end
							
							if not held
								p.pso.cancancel = 1
							end
							
						end
						
						if held
							local heldfor = timer - firetime
							
							if heldfor >= 0
								
								if heldfn
									heldfn(mo)
								end
								
								if heldfor % drainf == 0
									p.pso.pp = max(0, $ - drain)
									
									if heldfor > heldmin*3
										local draint = heldfor - (heldmin*3)
										local adrain = 1 + draint/(heldmin*10)
										p.pso.pp = max(0, $ - adrain)
									end	
								end
								
								if ((timer - firetime) >= heldmin and not hold or not p.pso.pp)
									return true
								end
							end
						end
						
						if not held and timer == swingtime + TICRATE/2
							return true
						end
					end
				end,
}

PSO.info.photonArts["wand_cast"] = {
		name = "Cast (Wand)",
		desc = "Cast a Technique",
		cost = 0,
		potency = 0,	-- +no extra potency when casting with a wand
		speed = 40,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SWATK1",

		use = 	function(p, timer, hold, input, combo)
					local mo = p.mo
					local pos = p.pso.weaponpos[HAND_RIGHT]
					local tech = PSO.info.photonArts[p.pso.taction]
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					
					if not tech
						return true
					end
					
					local object = tech.object
					local potency = tech.potency +PSO.info.photonArts[p.pso.action].potency	--cast bonus
					local casttime = (tech.casttime or TICRATE/2) *7/10	-- 30% faster
					local swingtime = TICRATE*10
				
					-- for held techs
					local held = tech.held
					local heldmin = tech.heldmin or TICRATE
					local helddelay = tech.helddelay or TICRATE/4
					local drain = tech.helddrain or 0
					local drainf = tech.helddrainf or 0
					local heldfn = tech.heldfunc 

					local nc = {casttime}
					PSO.lib.runHook("playerCastTime", p, tech, nc)
					casttime = nc[1]
					
					-- force PB reduces cast time
					if PSO.lib.usingPB(p) == "fo_photonflare"
						casttime = max(1, $*8/10)
					end
					
					-- phantom cast nullifies it!
					if p.pso.phantomcast
					and timer == 1
						casttime = 1
					end
					
					-- fo TAJA does that too!
					if PSO.lib.hasSkill(p, "fo_techartsalt")
					and p.pso.lastelement and p.pso.lastelement ~= tech.element
						casttime = max(1, $/2)
					end
					
					if timer <= casttime
						
						local x = FixedMul(mo.scale, 8*cos(p.drawangle - ANG1*40))
						local y = FixedMul(mo.scale, 8*sin(p.drawangle - ANG1*40))
						local z = FixedDiv(mo.height*12/10, mo.scale)
						
						pos[2] = x
						pos[3] = y
						pos[4] = z
						pos[5] = ANG1*90
						pos[6] = ANG1*90
						
						p.pso.cancancel = 1
						
					end
					
					if timer == casttime
						p.pso.actiontimer = swingtime
						p.pso.cancancel = nil
						if p.pso.phantomcast
						and timer == 1
							p.pso.phantomcast = $-1
						end
					end
					
					p.pso.actionspeed = (tech.actionspeed or 30)
					
					-- swing the rod and cast the tech!
					if timer >= swingtime
						-- swing rod from top to bottom!
						local newtimer = timer-swingtime
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle + ANG1*90,	-- tilt sideways
							za = -ANG1*45,				-- tilt by 30 degrees
						}			

						
						local ang
						
						if newtimer < 3
							mo.rodangle = -ANG1*80
						elseif newtimer < TICRATE/2
							local nt = newtimer-3
							mo.rodangle = $ + max(0, ANG1*(20 - (nt-2)*4))
						end
						
						local ang = p.drawangle + mo.rodangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90
						
						local firetime = swingtime + TICRATE/4
						local firing = timer == firetime
						
						-- held techs
						local heldfor
						if held
							heldfor = timer - firetime
							
							if heldfor % helddelay == 0
								firing = true
							end
						end
						
						-- spawn the tech effect
						if firing
							
							local dist = tech.spawndist or 0
							local offx = dist*cos(p.drawangle)
							local offy = dist*sin(p.drawangle)
							local offz = FixedDiv(48*FRACUNIT*(tech.spawnheight or 0)/100, mo.scale)
							
							local spd = tech.speed
							if spd == nil
								spd = 40	-- 0 spd is still valid
							end
							
							local msl = PSO.lib.spawnMissile(mo, object, p.drawangle, spd*FRACUNIT, potency, DMT_TECHNIQUE, offx, offy, offz, tech.reaction)
							if tech.aim
								PSO.lib.aimMissile(msl, p.pso.target)
							end

							if tech.element
								msl.pso.element = tech.element
							end
								
							local range = wep.range or 512
							if range and spd
								msl.fuse = FixedDiv(range*FRACUNIT, max(1, FixedHypot(msl.momx, msl.momy)))/FRACUNIT
							end
								
							-- tech is a combo breaker is it's NOT actions 1 or 4
							-- yes it's magic numbers but also that's never changing so who cares.
							if p.pso.actionnum % 3 ~= 1	-- if we ever add more for some reason lol
								msl.pso.combobreaker = true
							end
								
							if tech.spawntarget
							and p.pso.target
							and p.pso.target.valid	-- make sure the target is alive.
								P_MoveOrigin(msl, p.pso.target.x, p.pso.target.y, p.pso.target.z)
							end
							
							PSO.lib.runHook("playerTechnique", p, msl, (held and heldfor/helddelay or 0))
							
							if msl and msl.valid
								if tech.sound
									S_StartSound(mo, tech.sound)
								end
								
								if tech.spawnfunc
									tech.spawnfunc(msl)
								end
							end
							
							if not held
								p.pso.cancancel = 1
							end
							
						end
						
						if held
							local heldfor = timer - firetime
							
							if heldfor >= 0
								
								if heldfn
									heldfn(mo)
								end
								
								if heldfor % drainf == 0
									p.pso.pp = max(0, $ - drain)
									
									if heldfor > heldmin*3
										local draint = heldfor - (heldmin*3)
										local adrain = 1 + draint/(heldmin*10)
										p.pso.pp = max(0, $ - adrain)
									end	
								end
								
								if ((timer - firetime) >= heldmin and not hold or not p.pso.pp)
									return true
								end
							end
						end
						
						if not held and timer == swingtime + TICRATE/2
							return true
						end
					end
				end,
}

PSO.info.photonArts["wand_normal"] = {
		name = "Attack",
		desc = "A series of slow, heavy swings that restore PP finished by a slam attack hitting in a large radius.",
		cost = 0,
		potency = 305,
		normal = true,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		combo = TICRATE*20,	-- hack for the 3-hit combo
		icon = "H_WAND1",

		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- sabers are weapon slot 2
					local pos = p.pso.weaponpos[HAND_RIGHT]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					-- slash 1:
					if not combo
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle + ANG1*90,	-- tilt sideways
							za = ANG1*30,				-- tilt by 30 degrees
						}
						
						local ang
						
						if mo.swordangle == nil
							mo.swordangle = 0
						end
						
						if timer < 3
							mo.swordangle = -ANG1*120
						elseif timer < TICRATE/4
							local nt = timer-3
							mo.swordangle = $ + max(0, ANG1*(40 - (nt-2)*4))
						end
						
						local ang = p.drawangle + mo.swordangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90
						
						-- damage box:
						if timer == TICRATE/5
							local x = mo.x + FixedMul(mo.scale, 100*cos(p.drawangle))
							local y = mo.y + FixedMul(mo.scale, 100*sin(p.drawangle))
							
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z, 120<<FRACBITS, 120<<FRACBITS, mo, potency, DMT_STRIKE, 8)
							hb.pso.potency = potency	-- normals shouldn't benefit from PA%
							hb.pso.ppregen = 5
							hb.pso.locks = 4
							hb.angle = p.drawangle
							hb.pso.hitlag = 3
							hb.pso.screenshake = {intensity = FRACUNIT*5, time=5}							
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
							
							p.pso.cancancel = 3
						end
						
						if timer > TICRATE/3
						and timer < TICRATE*20
							p.pso.actiontimer = TICRATE*30 - TICRATE/3
						end
					
					-- slash 2:
					elseif combo == 1
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle - ANG1*90,	-- tilt sideways
							za = ANG1*30,				-- tilt by 30 degrees
						}
						
						local ang
						
						if timer < 3
							mo.swordangle = ANG1*120
						elseif timer < TICRATE/4
							local nt = timer-3
							mo.swordangle = $ - max(0, ANG1*(40 - (nt-2)*4))
						end
						
						local ang = p.drawangle + mo.swordangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90

						-- damage box:
						if timer == TICRATE/5
							local x = mo.x + FixedMul(mo.scale, 100*cos(p.drawangle))
							local y = mo.y + FixedMul(mo.scale, 100*sin(p.drawangle))
							
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z, 120<<FRACBITS, 100<<FRACBITS, mo, potency, DMT_STRIKE, 8)
							hb.pso.potency = potency	-- normals shouldn't benefit from PA%
							hb.pso.ppregen = 5
							hb.pso.locks = 4
							hb.angle = p.drawangle
							hb.pso.hitlag = 3
							hb.pso.screenshake = {intensity = FRACUNIT*5, time=5}								
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
							
							p.pso.cancancel = 3
						end
						
						if timer > TICRATE/3
						and timer < TICRATE*20
							p.pso.actiontimer = TICRATE*30 - TICRATE/3
						end					
					
					elseif combo == 2
						
						pos[7] = {use = false}
						
						local ang = p.drawangle - ANG1*30
						local x = 24*cos(ang)
						local y = 24*sin(ang)
						
						-- further dist for the skewer:
						x = x + (min(4, timer)*cos(p.drawangle)*16)
						y = y + (min(4, timer)*sin(p.drawangle)*16)

						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = ANG1*10
						pos[6] = 0

						-- damage box:
						if timer == TICRATE/8
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(mo.x+x, mo.y+y, mo.z+z, 140<<FRACBITS, 120<<FRACBITS, mo, potency*2, DMT_STRIKE, 8, RT_KNOCKBACK)
							hb.pso.potency = potency*2	-- normals shouldn't benefit from PA%
							hb.pso.ppregen = 6
							hb.pso.reactionangle = p.drawangle
							hb.pso.hitlag = 4
							hb.pso.screenshake = {intensity = FRACUNIT*8, time=5}								
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
						end
						
						if timer == TICRATE*3/4
							return true
						end
					end
					
					-- sword trail:
					if timer > 1 and combo < 2
						saber_trail(mo, pos, prevswordpos)
					end
					
					if timer >= 30*TICRATE
						return true
					end
					
					--P_SpawnMobj(mo.x+pos[2], mo.y+pos[3], mo.z+pos[4], MT_THOK)
					
				end,
}

PSO.info.photonArts["tmag_cast"] = {
		name = "Cast (TMag)",
		desc = "Cast a Technique",
		cost = 0,
		potency = 0,	-- +no extra potency when casting with a mag
		speed = 40,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SWATK1",

		use = 	function(p, timer, hold, input, combo)
					local mo = p.mo
					local pos = p.pso.weaponpos[HAND_LEFT]
					local tech = PSO.info.photonArts[p.pso.taction]
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					if not tech
						return true
					end
					
					local object = tech.object
					local potency = tech.potency +PSO.info.photonArts[p.pso.action].potency	--cast bonus
					local casttime = (tech.casttime or TICRATE/2) *7/10	-- 30% faster
					local swingtime = TICRATE*10
				
					-- for held techs
					local held = tech.held
					local heldmin = tech.heldmin or TICRATE
					local helddelay = tech.helddelay or TICRATE/4
					local drain = tech.helddrain or 0
					local drainf = tech.helddrainf or 0
					local heldfn = tech.heldfunc 

					local nc = {casttime}
					PSO.lib.runHook("playerCastTime", p, tech, nc)
					casttime = nc[1]
					
					-- force PB reduces cast time
					if PSO.lib.usingPB(p) == "fo_photonflare"
						casttime = max(1, $*8/10)
					end

					-- phantom cast nullifies it!
					if p.pso.phantomcast
					and timer == 1
						casttime = 1
					end
					
					-- fo TAJA does that too!
					if PSO.lib.hasSkill(p, "fo_techartsalt")
					and p.pso.lastelement and p.pso.lastelement ~= tech.element
						casttime = max(1, $/2)
					end
					
					if 1	--timer <= casttime
						
						local x = FixedMul(mo.scale, 48*cos(p.drawangle))
						local y = FixedMul(mo.scale, 48*sin(p.drawangle))
						local z = FixedDiv(mo.height*2/10, mo.scale)
						
						pos[2] = x
						pos[3] = y
						pos[4] = z
						pos[5] = 0
						pos[6] = 0
						
						local sx = pos[1].x + P_RandomRange(-64, 64)*mo.scale
						local sy = pos[1].y + P_RandomRange(-64, 64)*mo.scale
						local sz = pos[1].z + P_RandomRange(-64, 64)*mo.scale
						local s = P_SpawnMobj(sx, sy, sz, MT_THOK)
						s.tics = 5
						s.fuse = 5
						s.momx = (pos[1].x -sx)/5
						s.momy = (pos[1].y -sy)/5
						s.momz = (pos[1].z -sz)/5
						s.scale = mo.scale/2
						s.destscale = 1
						s.color = winfo.effectcolor or SKINCOLOR_CYAN
						
						p.pso.cancancel = 1
						
					end
					
					if timer == casttime
						p.pso.actiontimer = swingtime
						p.pso.cancancel = nil
						
						if p.pso.phantomcast
						and timer == 1
							p.pso.phantomcast = $-1
						end
					end
					
					p.pso.actionspeed = (tech.actionspeed or 30)
					
					-- swing the rod and cast the tech!
					if timer >= swingtime
						-- swing rod from top to bottom!
						local newtimer = timer-swingtime
						
						local firetime = swingtime + TICRATE/4
						local firing = timer == firetime
						
						-- held techs
						local heldfor
						if held
							heldfor = timer - firetime
							
							if heldfor % helddelay == 0
								firing = true
							end
						end
						
						-- spawn the tech effect
						if firing
							
							local dist = tech.spawndist or 0
							local offx = dist*cos(p.drawangle)
							local offy = dist*sin(p.drawangle)
							local offz = FixedDiv(48*FRACUNIT*(tech.spawnheight or 0)/100, mo.scale)
							
							local spd = tech.speed
							if spd == nil
								spd = 40	-- 0 spd is still valid
							end
							
							local msl = PSO.lib.spawnMissile(mo, object, p.drawangle, spd*FRACUNIT, potency, DMT_TECHNIQUE, offx, offy, offz, tech.reaction)
							if tech.aim
								PSO.lib.aimMissile(msl, p.pso.target)
							end

							if tech.element
								msl.pso.element = tech.element
							end
								
							local range = wep.range or 512
							if range and spd
								msl.fuse = FixedDiv(range*FRACUNIT, max(1, FixedHypot(msl.momx, msl.momy)))/FRACUNIT
							end
								
							-- tech is a combo breaker is it's NOT actions 1 or 4
							-- yes it's magic numbers but also that's never changing so who cares.
							if p.pso.actionnum % 3 ~= 1	-- if we ever add more for some reason lol
								msl.pso.combobreaker = true
							end
								
							if tech.spawntarget
							and p.pso.target
							and p.pso.target.valid	-- make sure the target is alive.
								P_MoveOrigin(msl, p.pso.target.x, p.pso.target.y, p.pso.target.z)
							end
							
							PSO.lib.runHook("playerTechnique", p, msl, (held and heldfor/helddelay or 0))
							
							if msl and msl.valid
								if tech.sound
									S_StartSound(mo, tech.sound)
								end
								
								if tech.spawnfunc
									tech.spawnfunc(msl)
								end
							end
							
							if not held
								p.pso.cancancel = 1
							end
							
						end
						
						if held
							local heldfor = timer - firetime
							
							if heldfor >= 0
								
								if heldfn
									heldfn(mo)
								end
								
								if heldfor % drainf == 0
									p.pso.pp = max(0, $ - drain)
									
									if heldfor > heldmin*3
										local draint = heldfor - (heldmin*3)
										local adrain = 1 + draint/(heldmin*10)
										p.pso.pp = max(0, $ - adrain)
									end	
								end
								
								if ((timer - firetime) >= heldmin and not hold or not p.pso.pp)
									return true
								end
							end
						end
						
						if not held and timer == swingtime + TICRATE/2
							return true
						end
					end
				end,
}