freeslot("MT_PSO_MEGID", "SPR_MEGD")
mobjinfo[MT_PSO_MEGID] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16<<FRACBITS,
	height = 16<<FRACBITS,
	flags = MF_NOGRAVITY|MF_MISSILE,
}

addHook("MobjThinker", function(mo)
	
	mo.sprite = SPR_MEGD
	mo.frame = (leveltime%32 /2)|TR_TRANS20|FF_SUBTRACT
	mo.color = SKINCOLOR_MAGENTA
	
	if leveltime & 1
		local g = P_SpawnGhostMobj(mo)
		g.color = SKINCOLOR_RED
		g.momx = P_RandomRange(-2, 2)*mo.scale
		g.momy = P_RandomRange(-2, 2)*mo.scale
		g.momz = P_RandomRange(-4, 0)*mo.scale
		g.destscale = 1
		g.fuse = 12
	end
	
	if not mo.extravalue1
		
		if leveltime% (TICRATE/4) == 0 and not (mo.nohitbox)
			local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z-mo.height, 256<<FRACBITS, 80<<FRACBITS, mo.target, mo.pso.potency, DMT_TECHNIQUE, TICRATE/2, RT_STAGGER)
			PSO.lib.copyWeaponProperties(mo, hb)
			hb.pso.combobreaker = mo.pso.combobreaker
			hb.pso.element = mo.pso.element	
			hb.pso.potency = mo.pso.potency
			hb.pso.pierceref = mo
			local link = {hb}
			hb.pso.links = link
			
			if mo.samegid
				
				for i = 1, #mo.samegid
					local sam = mo.samegid[i]
					
					if not sam or not sam.valid continue end

					local hb2 = PSO.lib.spawnHurtBox(sam.x, sam.y, sam.z-sam.height, 256<<FRACBITS, 80<<FRACBITS, mo.target, mo.pso.potency, DMT_TECHNIQUE, TICRATE/2, RT_STAGGER)
					PSO.lib.copyWeaponProperties(mo, hb)
					link[#link+1] = hb2
					hb2.pso.combobreaker = mo.pso.combobreaker
					hb2.pso.element = mo.pso.element
					hb2.pso.links = link
					hb2.pso.potency = mo.pso.potency
					hb2.pso.pierceref = mo
					
				end
			end
		end
	else
		if P_IsObjectOnGround(mo)
			for i = 1, 8
				local x = mo.x + P_RandomRange(-8, 8)*mo.scale
				local y = mo.y + P_RandomRange(-8, 8)*mo.scale
				
				local s = P_SpawnMobj(x, y, mo.z, MT_THOK)
				s.sprite = SPR_MEGD
				s.frame = P_RandomRange(A, P) | TR_TRANS20 | FF_SUBTRACT
				s.color = SKINCOLOR_RED
				s.scale = $/2
				s.momx = P_RandomRange(-4, 4)*mo.scale
				s.momy = P_RandomRange(-4, 4)*mo.scale
				s.momz = P_RandomRange(4, 10)*mo.scale
				s.fuse = 10
				s.tics = 10
				s.destscale = 1
			end	
			P_RemoveMobj(mo)
			return
		end
	end
		
end, MT_PSO_MEGID)

addHook("MobjCollide", function(mo1, mo2) return false end, MT_PSO_MEGID)
addHook("MobjMoveCollide", function(mo1, mo2) return false end, MT_PSO_MEGID)

PSO.info.photonArts["megid"] = {
		-- PA is a technique
		technique = true,
		name = "Megid",
		desc = "Dark Technique. Launches a slow projectile that pierces and can hit the same enemy multiple times.",
		cost = 20,
		actionspeed = 30,
		potency = 50,
		icon = "H_TMEGID",
		casttime = TICRATE*2/3,
		
		sound = sfx_s3k7a,
		
		object = MT_PSO_MEGID,
		element = ELEM_DARK,
		speed = 15,	-- projectile speed
		spawndist = 32,			-- distance to spawn from the player if spawntarget is false
		spawnheight = 50,
		aim = true,
}

freeslot("MT_PSO_GIMEGID")
mobjinfo[MT_PSO_GIMEGID] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16<<FRACBITS,
	height = 16<<FRACBITS,
	flags = MF_NOGRAVITY,
}

addHook("MobjThinker", function(mo)
	
	if not mo.target or not mo.target.valid
		P_RemoveMobj(mo)
		return
	end
	
	if not mo.extravalue1
		mo.nodes = {}
		mo.fuse = -1
		mo.tics = -1
	end
	
	for i = 1, 3
		
		if mo.extravalue1 == (i-1)*4
			
			local a = mo.angle + i*(360/3)*ANG1
			local x = mo.x + 96*cos(a)
			local y = mo.y + 96*sin(a)
			local z = mo.z + 256*mo.scale
			
			local node = P_SpawnMobj(x, y, z, MT_THOK)
			node.scale = 1
			node.destscale = FRACUNIT/2
			mo.nodes[#mo.nodes+1] = node
		end
	end
	
	mo.extravalue1 = $+1
	
	for i = 1, #mo.nodes
		local node = mo.nodes[i]
		
		if not node or not node.valid
			continue
		end
		
		node.sprite = SPR_MEGD
		node.tics = -1
		node.frame = (leveltime%32 /2)|TR_TRANS20|FF_SUBTRACT
		node.color = SKINCOLOR_MAGENTA		
		
		if mo.extravalue1 < TICRATE*3/2 - 8 - 10
			node.fuse = 11
		end
		
		if leveltime & 1
			local g = P_SpawnGhostMobj(node)
			g.scale = node.scale/3
			g.color = SKINCOLOR_RED
			g.momx = P_RandomRange(-2, 2)*mo.scale
			g.momy = P_RandomRange(-2, 2)*mo.scale
			g.momz = P_RandomRange(-4, 0)*mo.scale
			g.destscale = 1
			g.fuse = 12
		end
		
		if mo.extravalue1 == TICRATE*3/4
		
			local g = P_SpawnGhostMobj(node)
			g.destscale = FRACUNIT*8
			g.scalespeed = FRACUNIT/3

		
			local steps = 32
			local x = node.x
			local y = node.y
			local z = node.z
			
			local xdiff = mo.x - node.x
			local ydiff = mo.y - node.y
			local zdiff = mo.z - node.z
			
			for j = 1, steps
				x = $ + xdiff/steps
				y = $ + ydiff/steps
				z = $ + zdiff/steps
				
				local s = P_SpawnMobj(x, y, z, MT_THOK)
				s.sprite = SPR_MEGD
				s.frame = (leveltime%32 /2)|TR_TRANS20|FF_SUBTRACT
				s.color = SKINCOLOR_MAGENTA		
				s.scale = mo.scale/4
				s.fuse = 10
				s.tics = s.fuse
			end
		end
	end
	
	if mo.extravalue1 == TICRATE*3/4
		local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z-mo.height, 256<<FRACBITS, 80<<FRACBITS, mo.target, mo.pso.potency, DMT_TECHNIQUE, TICRATE/2, RT_STAGGER)
		PSO.lib.copyWeaponProperties(mo, hb)
		hb.pso.combobreaker = mo.pso.combobreaker
		hb.pso.element = mo.pso.element
		hb.pso.potency = mo.pso.potency
	end
	
	if mo.extravalue1 >= TICRATE*3/4
	and mo.extravalue1 <= TICRATE*3/2
		
		for i = 1, 3
			local x = mo.x + P_RandomRange(-96, 96)*mo.scale
			local y = mo.y + P_RandomRange(-96, 96)*mo.scale
			
			local s = P_SpawnMobj(x, y, mo.z, MT_THOK)
			s.sprite = SPR_MEGD
			s.frame = P_RandomRange(A, P) | TR_TRANS20 | FF_SUBTRACT
			s.color = SKINCOLOR_RED
			s.scale = $/2
			s.momx = P_RandomRange(-4, 4)*mo.scale
			s.momy = P_RandomRange(-4, 4)*mo.scale
			s.momz = P_RandomRange(0, 6)*mo.scale
			s.fuse = 10
			s.tics = 10
			s.destscale = 1
		end
	end
	
	if mo.extravalue1 >= (TICRATE*2 -8)
		P_RemoveMobj(mo)
		return
	end
	
end, MT_PSO_GIMEGID)	

PSO.info.photonArts["gimegid"] = {
		-- PA is a technique
		technique = true,
		name = "Gimegid",
		desc = "Dark Technique. Targets the enemy with delayed condensed lasers of darkness.",
		cost = 24,
		actionspeed = 30,
		potency = 435,
		icon = "H_TGMEGI",
		casttime = TICRATE*2/3,
		
		sound = sfx_s3k7a,
		
		object = MT_PSO_GIMEGID,
		element = ELEM_DARK,
		spawndist = 380,			-- distance to spawn from the player if spawntarget is false
		speed = 0,
		spawntarget = true,
}

freeslot("MT_PSO_RAMEGID")
mobjinfo[MT_PSO_RAMEGID] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16<<FRACBITS,
	height = 16<<FRACBITS,
	flags = MF_NOGRAVITY,
}

addHook("MobjThinker", function(mo)
	
	if not mo.target or not mo.target.valid
		P_RemoveMobj(mo)
		return
	end
	
	if leveltime%4 == 0
		
		local x = mo.x + P_RandomRange(-320, 320)*mo.scale
		local y = mo.y + P_RandomRange(-320, 320)*mo.scale
		local z = mo.z + mo.scale*512
		
		local s = P_SpawnMobj(x, y, z, MT_PSO_MEGID)
		s.extravalue1 = 1
		s.flags = 0
		S_StartSound(s, sfx_s3k7a)
	end
	
	mo.extravalue1 = $+1
	
	if mo.extravalue1 >= TICRATE*3/4 -1
		
		if mo.extravalue1 % (TICRATE*3/4) == 0
			local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z-mo.height, 512<<FRACBITS, 80<<FRACBITS, mo.target, mo.pso.potency/3, DMT_TECHNIQUE, TICRATE/2, RT_STAGGER)
			PSO.lib.copyWeaponProperties(mo, hb)
			hb.pso.combobreaker = mo.pso.combobreaker
			hb.pso.element = mo.pso.element
			hb.pso.potency = mo.pso.potency/3
			mo.extravalue2 = $+1
			
			if mo.extravalue2 >= 3
				P_RemoveMobj(mo)
				return
			end	
		end
	end
	
	
end, MT_PSO_RAMEGID)

PSO.info.photonArts["ramegid"] = {
		-- PA is a technique
		technique = true,
		name = "Ramegid",
		desc = "Dark Technique. Rains exploding projectiles around the target.",
		cost = 20,
		actionspeed = 30,
		potency = 370,
		icon = "H_TRMEGI",
		casttime = TICRATE*2/3,
		
		sound = sfx_s3k7a,
		
		object = MT_PSO_RAMEGID,
		element = ELEM_DARK,
		spawndist = 0,			-- distance to spawn from the player if spawntarget is false
		speed = 0,
		spawntarget = true,

		spawnfunc = function(msl)
			-- make sure razonde cannot have more than 1 instance per player
			/*local mo = msl.target
			
			if mo.ramegid
			and mo.ramegid.valid
				P_RemoveMobj(mo.ramegid)	-- don't stack!!
			end
			
			mo.ramegid = msl*/
		end,
		
}

PSO.info.photonArts["samegid"] = {
		-- PA is a technique
		technique = true,
		name = "Samegid",
		desc = "Dark Technique. Launches 3 slow projectiles that pierce and can hit the same enemy multiple times.",
		cost = 32,
		actionspeed = 30,
		potency = 30,
		icon = "H_TSMEGI",
		casttime = TICRATE*2/3,
		
		sound = sfx_s3k7a,
		
		object = MT_PSO_MEGID,
		element = ELEM_DARK,
		speed = 15,	-- projectile speed
		spawndist = 32,			-- distance to spawn from the player if spawntarget is false
		spawnheight = 50,
		
		spawnfunc = function(msl)
			
			local mo = msl.target	
			local dist = 128
			local a = msl.angle - ANG1*90
			
			msl.samegid = {msl}
			
			for i = 1, 2
				
				local msl2 = PSO.lib.spawnMissile(mo, MT_PSO_MEGID, mo.angle, 0, msl.pso.potency, DMT_TECHNIQUE, 0, 0, 0, RT_NONE)
				msl2.pso.element = msl.pso.element
				msl2.target = msl.target
				msl2.pso.combobreaker = msl.pso.combobreaker
				msl2.pso.potency = msl.pso.potency
				
				local x = mo.x + dist*cos(a)
				local y = mo.y + dist*sin(a)
				P_SetOrigin(msl2, x, y, msl.z)
				
				msl2.momx = msl.momx
				msl2.momy = msl.momy
				msl2.momz = msl.momz
				msl2.angle = msl.angle
				msl2.fuse = msl.fuse
				msl2.scale = 1
				msl2.destscale = msl.scale
				msl2.scalespeed = msl.scale/12
				
				a = $ + ANG1*180
				
				msl.samegid[#msl.samegid+1] = msl2
				msl2.nohitbox = true
			end
		end,
}

freeslot("MT_PSO_ILLMEGID")
mobjinfo[MT_PSO_ILLMEGID] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16<<FRACBITS,
	height = 16<<FRACBITS,
	flags = MF_NOGRAVITY,
}

local illmegid_delay = TICRATE*3/4
local illmegid_hits = 5

addHook("MobjThinker", function(mo)
	
	mo.sprite = SPR_MEGD
	mo.frame = (leveltime%32 /2)|TR_TRANS20|FF_SUBTRACT
	mo.color = SKINCOLOR_MAGENTA
	mo.scale = FRACUNIT*2
	mo.fuse = -1
	mo.tics = -1
	mo.momx = 0
	mo.momy = 0
	mo.momz = 0
	
	if leveltime & 1
		local g = P_SpawnGhostMobj(mo)
		g.color = SKINCOLOR_RED
		g.momx = P_RandomRange(-2, 2)*mo.scale
		g.momy = P_RandomRange(-2, 2)*mo.scale
		g.momz = P_RandomRange(0, 4)*mo.scale
		g.destscale = 1
		g.fuse = 12
	end
	
	if mo.extravalue1 % illmegid_delay == 0
		local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z-mo.height, 192<<FRACBITS, 80<<FRACBITS, mo.target, mo.pso.potency/5, DMT_TECHNIQUE, TICRATE/2, RT_STAGGER)
		PSO.lib.copyWeaponProperties(mo, hb)
		hb.pso.combobreaker = mo.pso.combobreaker
		hb.pso.element = mo.pso.element
		hb.pso.potency = mo.pso.potency/5
		mo.extravalue2 = $+1
		
		local g = P_SpawnGhostMobj(mo)
		g.color = SKINCOLOR_RED
		g.destscale = FRACUNIT*8
		g.fuse = 12
		g.frame = $ & ~FF_SUBTRACT
		
		if mo.extravalue2 >= illmegid_hits
			P_RemoveMobj(mo)
			return
		end
	end
	
	mo.extravalue1 = $+1
	
end, MT_PSO_ILLMEGID)

PSO.info.photonArts["ilmegid"] = {
		-- PA is a technique
		technique = true,
		name = "Ilmegid",
		desc = "Dark Technique. Creates an orb of darkness at the target's location that continuously deal damage.",
		cost = 25,
		actionspeed = 30,
		potency = 600,
		icon = "H_TIMEGI",
		casttime = TICRATE*3/4,
		
		sound = sfx_s3k7a,
		
		object = MT_PSO_ILLMEGID,
		element = ELEM_DARK,
		spawndist = 192,			-- distance to spawn from the player if spawntarget is false
		speed = 0,
		spawntarget = true,

		spawnfunc = function(msl)
			-- make sure razonde cannot have more than 1 instance per player
			/*local mo = msl.target
			
			if mo.illmegid
			and mo.illmegid.valid
				P_RemoveMobj(mo.illmegid)	-- don't stack!!
			end
			
			mo.illmegid = msl*/
		end,
		
}