freeslot("MT_BARTA", "S_BARTA")
mobjinfo[MT_BARTA] = {
	doomednum = -1,
	spawnstate = S_BARTA,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	radius = 48<<FRACBITS,
	height = 48<<FRACBITS,
	flags = MF_MISSILE|MF_GRENADEBOUNCE,
}

-- disable collision for barta
addHook("MobjCollide", function(mo1, mo2) return false end, MT_BARTA)
addHook("MobjMoveCollide", function(mo1, mo2) return false end, MT_BARTA)

function A_Barta(mo)
	
	mo.friction = FRACUNIT	-- no slowdown
	if mo.target and mo.target.valid 
		if not mo.hurtbox or not mo.hurtbox.valid	-- huh.
			mo.hurtbox = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 96<<FRACBITS, 64<<FRACBITS, mo.target, mo.pso.potency, DMT_TECHNIQUE, 10)
			mo.hurtbox.pso.combobreaker = mo.pso.combobreaker
			mo.hurtbox.pso.element = mo.pso.element
			mo.hurtbox.pso.potency = mo.pso.potency
			mo.hurtbox.pso.pierceref = mo.hurtbox
		else
			mo.hurtbox.fuse = 3
			mo.hurtbox.tics = 10
			P_MoveOrigin(mo.hurtbox, mo.x, mo.y, mo.z)
		end
	end
	
	if mo.momz*P_MobjFlip(mo) > 0
		mo.momz = 0
	end
	
	if leveltime & 1
		
		local d = P_SpawnMobj(mo.x + P_RandomRange(-12, 12)*mo.scale, mo.y + P_RandomRange(-12, 12)*mo.scale, mo.z + P_RandomRange(0, 12)*mo.scale, MT_THOK)
		d.sprite = SPR_BARD
		d.frame = A|TR_TRANS20|FF_ADD|FF_FULLBRIGHT
		d.scale = FRACUNIT/3
		d.fuse = TICRATE/2
		d.tics = d.fuse
		d.rollangle = P_RandomRange(0, 359)*ANG1
		d.destscale = FRACUNIT
		d.momx = P_RandomRange(-2, 2)*mo.scale
		d.momy = P_RandomRange(-2, 2)*mo.scale
		d.momz = P_RandomRange(1, 4)*mo.scale
		d.colorized = true
		d.color = SKINCOLOR_CYAN
	end
end

states[S_BARTA] = {SPR_FHZI, A|TR_TRANS10|FF_FULLBRIGHT, 1, A_Barta, 0, 0, S_BARTA}


PSO.info.photonArts["barta"] = {
		-- PA is a technique
		technique = true,
		name = "Barta",
		desc = "Ice Technique. Launches an icicle that pierces through enemies.",
		cost = 10,
		actionspeed = 30,
		potency = 240,
		icon = "H_TBARTA",
		casttime = TICRATE/3,
		
		sound = sfx_barta,
		
		object = MT_BARTA,
		element = ELEM_ICE,
		speed = 30,	-- projectile speed
		spawndist = 32,			-- distance to spawn from the player if spawntarget is false
}

freeslot("MT_PSO_GIBARTA")
mobjinfo[MT_PSO_GIBARTA] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 32<<FRACBITS,
	height = 32<<FRACBITS,
	flags = MF_NOGRAVITY
}	

local gibarta_duration = TICRATE*5/2
local range = 512

addHook("MobjThinker", function(mo)
	
	mo.extravalue1 = $+1
	
	if not mo.target or not mo.target.valid
		P_RemoveMobj(mo)
		return
	end

	if leveltime%6 == 0
		S_StartSound(mo, sfx_s3kc2s)
	end
	
	if leveltime % 3 == 0
		local s = P_SpawnMobj(mo.x + P_RandomRange(-32, 32)*mo.scale, mo.y + P_RandomRange(-32, 32)*mo.scale, mo.z + 32*mo.scale, MT_THOK)
		s.sprite = SPR_BARD
		s.frame = A|TR_TRANS20|FF_ADD|FF_FULLBRIGHT
		s.scale = FRACUNIT/4
		s.fuse = TICRATE
		s.tics = s.fuse
		s.rollangle = P_RandomRange(0, 359)*ANG1
		s.destscale = FRACUNIT*2
		s.scalespeed = FRACUNIT/6
		s.angle = mo.angle + P_RandomRange(-20, 20)*ANG1
		s.colorized = true
		s.color = SKINCOLOR_CYAN
		s.momz = P_RandomRange(-2, 2)*mo.scale
		P_InstaThrust(s, s.angle, P_RandomRange(8, 16)*mo.scale)
	end
	
	local f = P_SpawnMobj(mo.x + P_RandomRange(-32, 32)*mo.scale, mo.y + P_RandomRange(-32, 32)*mo.scale, mo.z + P_RandomRange(0, 64)*mo.scale, MT_THOK)
	f.sprite = SPR_SNO1
	f.frame = P_RandomRange(A, C)
	f.angle = mo.angle + P_RandomRange(-30, 30)*ANG1
	f.fuse = TICRATE
	f.tics = TICRATE
	f.momz = P_RandomRange(-1, 1)*mo.scale
	P_InstaThrust(f, f.angle, P_RandomRange(8, 16)*mo.scale)
	
		
	if mo.extravalue1 == 5
	or mo.extravalue1 == gibarta_duration/4
	or mo.extravalue1 == gibarta_duration/2
	or mo.extravalue1 == gibarta_duration*3/4
	or mo.extravalue1 == gibarta_duration-5
		local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 255<<FRACBITS, 80<<FRACBITS, mo.target, mo.pso.potency/5, DMT_TECHNIQUE, TICRATE/2, RT_STAGGER)
		PSO.lib.copyWeaponProperties(mo, hb)
		hb.pso.combobreaker = mo.pso.combobreaker
		hb.pso.element = mo.pso.element
		hb.scale = FRACUNIT/8
		hb.destscale = FRACUNIT*2
		hb.pso.locks = 5
		hb.pso.potency = mo.pso.potency/5
		P_InstaThrust(hb, mo.angle, mo.scale*24)
	end
		
	
	if mo.extravalue1 > gibarta_duration
		P_RemoveMobj(mo)
		return
	end
		
end, MT_PSO_GIBARTA)

PSO.info.photonArts["gibarta"] = {
		-- PA is a technique
		technique = true,
		name = "Gibarta",
		desc = "Ice Technique. Creates an area that generates icy wind in a cone in front of the user for a short duration, damaging enemies.",
		cost = 19,
		actionspeed = 30,
		speed = 0,
		potency = 420,
		icon = "H_TGBART",
		casttime = TICRATE/2,
		
		sound = sfx_barta,
		
		object = MT_PSO_GIBARTA,
		element = ELEM_ICE,
		spawntarget = false,
		spawndist = 32,			-- distance to spawn from the player if spawntarget is false
		spawnheight = 16,

		-- don't allow stacking this object
		spawnfunc = function(msl)
			
			local target = msl.target
			if not target or not target.valid
				P_RemoveMobj(msl)
				return
			end
			
			if target.gibarta and target.gibarta.valid
				P_RemoveMobj(target.gibarta)
			end
			target.gibarta = msl
		end,	
}

freeslot("MT_PSO_RABARTA")
mobjinfo[MT_PSO_RABARTA] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 32<<FRACBITS,
	height = 32<<FRACBITS,
	flags = MF_NOGRAVITY,
}

local rabarta_duration = TICRATE*3

addHook("MobjThinker", function(mo)
	
	if not mo.extravalue1
		mo.snowflakes = {}
	end
	mo.extravalue1 = $+1
	
	if not mo.target or not mo.target.valid
		P_RemoveMobj(mo)
		return
	end	
	
	if leveltime%6 == 0
		S_StartSound(mo, sfx_s3kc2s)
	end
	
	-- ground "smoke"
	for i = 1, 2
		
		local a = P_RandomRange(0, 359)*ANG1
		local x = mo.x + 32*cos(a)
		local y = mo.y + 32*sin(a)
		
		local d = P_SpawnMobj(x, y, mo.z, MT_THOK)
		d.sprite = SPR_BARD
		d.frame = A|TR_TRANS20|FF_ADD|FF_FULLBRIGHT
		d.scale = FRACUNIT/2
		d.fuse = TICRATE*3/4
		d.tics = d.fuse
		d.rollangle = P_RandomRange(0, 359)*ANG1
		d.destscale = FRACUNIT*3/2
		P_InstaThrust(d, a, P_RandomRange(8, 16)*mo.scale)
		d.colorized = true
		d.color = SKINCOLOR_CYAN
	end
	
	-- snowflakes
	if mo.extravalue1 < rabarta_duration - TICRATE
			
		local d = P_RandomRange(128, 300)
		local a = P_RandomRange(0, 359)*ANG1
		local x = mo.x + d*cos(a)
		local y = mo.y + d*sin(a)
			
		local s = P_SpawnMobj(x, y, mo.z, MT_THOK)
		s.sprite = SPR_SNO1
		s.frame = P_RandomRange(A, C)|FF_FULLBRIGHT
		s.fuse = TICRATE
		s.tics = TICRATE
		
		s.dist = d
		s.angle = a
		s.momz = mo.scale*5
			
		mo.snowflakes[#mo.snowflakes+1] = s
	end
	
	local i = #mo.snowflakes
	while i
		
		local s = mo.snowflakes[i]
		
		if not s or not s.valid
			table.remove(mo.snowflakes, i)
			i = $-1
			continue
		end
		
		s.angle = $ + ANG1*6
		s.tics = 2
		local sx = mo.x + s.dist*cos(s.angle)
		local sy = mo.y + s.dist*sin(s.angle)
		P_MoveOrigin(s, sx, sy, s.z)
		i = $-1
	end
	
	if mo.extravalue1 == 3
	or mo.extravalue1 == rabarta_duration/4
	or mo.extravalue1 == rabarta_duration/2
	or mo.extravalue1 == rabarta_duration*3/4
	or mo.extravalue1 == rabarta_duration-1
		local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z-80*FRACUNIT, 768<<FRACBITS, 256<<FRACBITS, mo.target, mo.pso.potency/5, DMT_TECHNIQUE, 2, RT_STAGGER)
		PSO.lib.copyWeaponProperties(mo, hb)
		hb.pso.combobreaker = mo.pso.combobreaker
		hb.pso.element = mo.pso.element
		hb.pso.locks = 5
		hb.pso.potency = mo.pso.potency/5
	end	
	
	if mo.extravalue1 > rabarta_duration
		P_RemoveMobj(mo)
		return
	end	
	
end, MT_PSO_RABARTA)

PSO.info.photonArts["rabarta"] = {
		-- PA is a technique
		technique = true,
		name = "Rabarta",
		desc = "Ice technique. Creates an area that generates strong icy winds on the user's position, damaging enemies over time.",
		cost = 16,
		actionspeed = 35,
		potency = 450,
		icon = "H_TRBART",
		casttime = TICRATE/2,	-- how long it takes before the tech weapon swings to cast.
		
		sound = sfx_barta,
		
		element = ELEM_ICE,
		spawndist = 0,		-- distance to spawn from the player if spawntarget is false

		object = MT_PSO_RABARTA,
		speed = 0,
		
		spawnfunc = function(msl)
			
			local target = msl.target
			if not target or not target.valid
				P_RemoveMobj(msl)
				return
			end
			
			if target.rabarta and target.rabarta.valid
				P_RemoveMobj(target.rabarta)
			end
			target.rabarta = msl
		end,	
	
}

freeslot("MT_PSO_SABARTA")
mobjinfo[MT_PSO_SABARTA] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 32<<FRACBITS,
	height = 32<<FRACBITS,
	flags = MF_NOGRAVITY,
}

addHook("MobjThinker", function(mo)
	
	mo.extravalue1 = $+1
	
	local basean = R_PointToAngle(mo.x, mo.y)
	
	local v_an = {basean + ANG1*90, basean - ANG1*90, 0}
	local rollan = {-ANG1*145, ANG1*145, ANG1*180}
	local t = mo.tracer or mo
	
	if not t or not t.valid
	or not mo.target or not mo.target.valid
		P_RemoveMobj(mo)
		return
	end
	
	--P_SetOrigin(mo, t.x, t.y, t.z + t.height/2)
	
	for i = 1, 3
		
		local delay = (i-1)*10
		local time = mo.extravalue1 - delay
		
		local dist = i < 3 and 48 or 0
		local an = v_an[i]
		local dfac = 0
		
		--print(time)
		
		if time == 16
			
			local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 128<<FRACBITS, 80<<FRACBITS, mo.target, mo.pso.potency/3, DMT_TECHNIQUE, 2, RT_STAGGER)
			PSO.lib.copyWeaponProperties(mo, hb)
			hb.pso.combobreaker = mo.pso.combobreaker
			hb.pso.element = mo.pso.element
			hb.pso.locks = 1
			hb.pso.potency = mo.pso.potency/3
			
			local px = t.x + P_RandomRange(-32, 32)*mo.scale
			local py = t.y + P_RandomRange(-32, 32)*mo.scale
			local pz = t.z + t.height + P_RandomRange(-32, 32)*mo.scale
			
			local s = P_SpawnMobj(px, py, pz, MT_THOK)
			s.sprite = SPR_NTHK
			s.frame = B|TR_TRANS30
			s.fuse = TICRATE/2
			s.tics = s.fuse
			s.scale = 1
			s.destscale = FRACUNIT*3
			s.scalespeed = FRACUNIT/6
			s.color = SKINCOLOR_WHITE
			S_StartSound(s, sfx_shattr)
			
			for j = 1, 5
				local s = P_SpawnMobj(px, py, pz, MT_SUPERSPARK)
				s.colorized = true
				s.color = SKINCOLOR_CYAN
				s.scale = FRACUNIT/2
				s.destscale = 1
				s.momx = P_RandomRange(-32, 32)*FRACUNIT
				s.momy = P_RandomRange(-32, 32)*FRACUNIT
				s.momz = P_RandomRange(-32, 32)*FRACUNIT
			end
			
			continue
			
		elseif time > 16
			continue
		end
		
		if time > 0
			dfac = (96*cos(time*ANG1*11 - ANG1*90)) /FRACUNIT
		end
		
		local z = t.z + t.height + dfac*FRACUNIT
		
		-- hack...
		if i == 3
			dfac = 0
		end
		
		local x = t.x + (dist+dfac)*cos(an)
		local y = t.y + (dist+dfac)*sin(an)
		
		
		local rot_time = 8 - time
		
		local s = P_SpawnMobj(x, y, z, MT_THOK)
		s.sprite = SPR_USPK
		s.scale = FRACUNIT*3/2
		s.frame = A|FF_ADD
		s.color = SKINCOLOR_CYAN
		s.colorized = true
		s.rollangle = rollan[i] + max(0, rot_time)*ANG1*50
		s.tics = 2
		
		if rot_time == 0
			S_StartSound(mo, sfx_zoom)
		end
		
		if rot_time <= 0
		and leveltime & 1
			local g = P_SpawnGhostMobj(s)
		end
	end
	
	if mo.extravalue1 > TICRATE*2
		P_RemoveMobj(mo)
	end
	
end, MT_PSO_SABARTA)

PSO.info.photonArts["sabarta"] = {
		-- PA is a technique
		technique = true,
		name = "Sabarta",
		desc = "Ice technique. Generates 3 icicles that crash down on the target without fail.",
		cost = 25,
		actionspeed = 35,
		potency = 340,
		icon = "H_TSBART",
		casttime = TICRATE/2,	-- how long it takes before the tech weapon swings to cast.
		
		sound = sfx_barta,
		
		element = ELEM_ICE,
		spawntarget = true,
		spawndist = 128,

		object = MT_PSO_SABARTA,
		speed = 0,
		
		spawnfunc = function(msl)
			local t = msl.target
			
			if t.player
				msl.tracer = t.player.pso.target
			else
				msl.tracer = t.pso.target	--!?
			end
		end,
}

freeslot("MT_PSO_NABARTA")
mobjinfo[MT_PSO_NABARTA] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 32<<FRACBITS,
	height = 32<<FRACBITS,
	flags = MF_NOGRAVITY|MF_SLIDEME,
}

addHook("MobjThinker", function(mo)
	if mo.target and mo.target.valid 
		if not mo.hurtbox
			mo.hurtbox = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 255<<FRACBITS, 128<<FRACBITS, mo.target, mo.pso.potency, DMT_TECHNIQUE, TICRATE*999)
			mo.hurtbox.pso.combobreaker = mo.pso.combobreaker
			mo.hurtbox.pso.element = mo.pso.element
		else
			mo.hurtbox.fuse = 3
			P_MoveOrigin(mo.hurtbox, mo.x, mo.y, mo.z)
		end
	end
end, MT_PSO_NABARTA)

PSO.info.photonArts["nabarta"] = {
		-- PA is a technique
		technique = true,
		name = "Nabarta",
		desc = "Ice technique. Hold to generate a continuous stream of freezing wind while draining PP.",
		cost = 20,
		actionspeed = 100,
		potency = 440,
		icon = "H_TNBART",
		casttime = TICRATE/2,	-- how long it takes before the tech weapon swings to cast.
		
		--sound = sfx_barta,
		
		element = ELEM_ICE,
		spawndist = 32,

		object = MT_PSO_NABARTA,
		speed = 45,
		
		held = true,
		heldmin = TICRATE,			-- min time the tech will be "held" for regardless of user input
		helddelay = TICRATE/3 +2,	-- how much time between each cast?
		helddrain = 1,			-- 2 pp
		helddrainf = 3,			-- per 3 frames
		
		spawnfunc = function(msl)
			if msl and msl.valid
				msl.pso.potency = $/4
			end
		end,
		
		heldfunc = function(mo)
			
			if leveltime % 3 == 0
				
				S_StartSound(mo, sfx_s3k7f)
				
				local s = P_SpawnMobj(mo.x + P_RandomRange(-32, 32)*mo.scale, mo.y + P_RandomRange(-32, 32)*mo.scale, mo.z + 32*mo.scale, MT_THOK)
				s.sprite = SPR_BARD
				s.frame = A|TR_TRANS20|FF_ADD|FF_FULLBRIGHT
				s.scale = FRACUNIT/3
				s.fuse = TICRATE
				s.tics = s.fuse
				s.rollangle = P_RandomRange(0, 359)*ANG1
				s.destscale = FRACUNIT*2
				s.scalespeed = FRACUNIT/6
				s.angle = mo.player.drawangle
				s.colorized = true
				s.color = SKINCOLOR_CYAN
				s.momz = P_RandomRange(-2, 2)*mo.scale
				P_InstaThrust(s, s.angle, P_RandomRange(12, 18)*mo.scale)
			end
			
			local f = P_SpawnMobj(mo.x + P_RandomRange(-32, 32)*mo.scale, mo.y + P_RandomRange(-32, 32)*mo.scale, mo.z + P_RandomRange(0, 64)*mo.scale, MT_THOK)
			f.sprite = SPR_SNO1
			f.frame = P_RandomRange(A, C)
			f.angle = mo.angle + P_RandomRange(-5, 5)*ANG1
			f.fuse = TICRATE
			f.tics = TICRATE
			f.momz = P_RandomRange(-1, 1)*mo.scale
			P_InstaThrust(f, f.angle, P_RandomRange(12, 18)*mo.scale)			
			
		end,
}

PSO.info.photonArts["deband"] = {
		-- PA is a technique
		technique = true,
		name = "Deband",
		desc = "Ice Technique. Caster and nearby allies recover HP when detonating Chains based on Chain and Player counts for 1:30.",
		cost = 25,
		potency = 100+PSO.info.DEBAND,
		icon = "H_TDEBND",
		casttime = TICRATE*3/4,	-- how long it takes before the tech weapon swings to cast.
		
		sound = sfx_deband,
		
		element = ELEM_ICE,
		spawndist = 0,
		speed = 30,
		
		object = MT_THOK,
		
		spawnfunc = function(msl)
			-- make sure razonde cannot have more than 1 instance per player
			local mo = msl.target
			local mop = mo.player
			
			if not mop return end
			
			local range = 768
			if PSO.lib.hasSkill(mop, "fo_territoryburst")
				range = $*3
			end			
			
			for i = 1, 16
				local ang = (360/16)*i*ANG1
				
				local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SUPERSPARK)
				s.color = SKINCOLOR_BLUE
				s.colorized = true
				
				P_InstaThrust(s, ang, FRACUNIT*32)
			end
			
			
			-- gib deband
			local duration = TICRATE*90
			if PSO.lib.hasSkill(mop, "fo_supportbitch")
				duration = $*2
			end
			
			for p in players.iterate do
				
				if p and p.mo and p.mo.valid
				and R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y) < range*mo.scale
					PSO.lib.addDeband(p.mo, duration)
				end
			end
			
			P_RemoveMobj(msl)
		end,	
}

PSO.info.photonArts["zalure"] = {
		-- PA is a technique
		technique = true,
		name = "Zalure",
		desc = "Ice Technique. Increases Photon Blast gauge generation by 10% when hitting affected enemies.",
		cost = 20,
		potency = 100+PSO.info.ZALURE,
		icon = "H_TZAL",
		casttime = TICRATE/2,	-- how long it takes before the tech weapon swings to cast.
		
		sound = sfx_kc59,
		
		element = ELEM_FIRE,
		spawndist = 0,
		speed = 30,
		
		object = MT_THOK,
		
		spawnfunc = function(msl)
			-- make sure razonde cannot have more than 1 instance per player
			local mo = msl.target
			local mop = mo.player
			
			if not mop return end
			
			local range = 768
			if PSO.lib.hasSkill(mop, "fo_territoryburst")
				range = $*3
			end
			
			for i = 1, 16
				local ang = (360/16)*i*ANG1
				
				local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SUPERSPARK)
				s.color = SKINCOLOR_DUSK
				s.colorized = true
				
				P_InstaThrust(s, ang, FRACUNIT*32)
			end
			
			
			-- gib jellen
			local duration = TICRATE*90
			/*if PSO.lib.hasSkill(mop, "fo_supportbitch")
				duration = $*2
			end*/

			local x1 = mo.x - range*FRACUNIT
			local x2 = mo.x + range*FRACUNIT
			local y1 = mo.y - range*FRACUNIT
			local y2 = mo.y + range*FRACUNIT
				
			local fn = function(mo, found)
					
				if found and found.valid
				and R_PointToDist2(mo.x, mo.y, found.x, found.y) < range*FRACUNIT
				and found.flags & MF_ENEMY
						
					PSO.lib.addZalure(found, duration)
				end
			end
				
			searchBlockmap("objects", fn, mo, x1, x2, y1, y2)		
			
			P_RemoveMobj(msl)
		end,	
}