
freeslot("MT_PSO_GRANTS")
mobjinfo[MT_PSO_GRANTS] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16<<FRACBITS,
	height = 16<<FRACBITS,
	flags = MF_NOGRAVITY,
}

addHook("MobjThinker", function(mo)
	
	if not mo.target or not mo.target.valid
		P_RemoveMobj(mo)
		return
	end
	
	mo.extravalue1 = $+1
	
	if mo.extravalue1 < TICRATE/2
	and leveltime%4 == 0
		
		local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		s.sprite = SPR_SSPK
		s.frame = B|FF_FULLBRIGHT|TR_TRANS20|FF_ADD
		s.colorized = true
		s.color = SKINCOLOR_TAN
		s.fuse = 14
		s.tics = s.fuse
		s.scale = mo.scale/2
		s.destscale = FRACUNIT*6
		s.scalespeed = FRACUNIT/3
		s.momz = s.scalespeed*4
	end	
	
	if mo.extravalue1 == TICRATE-4
		
		for i = 1, 16
			local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SUPERSPARK)
			s.colorized = true
			s.color = SKINCOLOR_TAN
			s.momx = P_RandomRange(-32, 32)*mo.scale
			s.momy = P_RandomRange(-32, 32)*mo.scale
			s.momz = P_RandomRange(-32, 32)*mo.scale
		end
		
		local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 455<<FRACBITS, 180<<FRACBITS, mo.target, mo.pso.potency, DMT_TECHNIQUE, 4)
		PSO.lib.copyWeaponProperties(mo, hb)
		hb.pso.combobreaker = mo.pso.combobreaker
		hb.pso.element = mo.pso.element
		hb.pso.potency = mo.pso.potency
		
		S_StartSound(mo, sfx_s3k9f)
		mo.fuse = TICRATE/2
	end
	
end, MT_PSO_GRANTS)

PSO.info.photonArts["grants"] = {
		-- PA is a technique
		technique = true,
		name = "Grants",
		desc = "Light Technique. Summons a delayed explosion of light at the target's location.",
		cost = 19,
		potency = 445,
		actionspeed = 40,
		icon = "H_TGRANT",
		casttime = TICRATE/2,
		sound = sfx_s243,

		element = ELEM_LIGHT,
		spawntarget = true,
		speed = 0,
		spawndist = 96,
		
		object = MT_PSO_GRANTS,
}

freeslot("MT_PSO_GIGRANTS", "SPR_GRNT")
mobjinfo[MT_PSO_GIGRANTS] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16<<FRACBITS,
	height = 16<<FRACBITS,
	flags = MF_NOGRAVITY,
}

local gigrants_range = 600
local aspeed = ANG1*30
local spintics = 360 / (aspeed/ANG1)

addHook("MobjThinker", function(mo)
	
	if not mo.target or not mo.target.valid
		P_RemoveMobj(mo)
		return
	end
	
	P_SetOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
	
	mo.extravalue1 = $+1	
	
	local dist = 6
	local xp = mo.x + dist*cos(mo.angle)
	local yp = mo.y + dist*sin(mo.angle)
	
	local b = P_SpawnMobj(xp, yp, mo.z + mo.scale*16, MT_THOK)
	
	b.sprite = SPR_GRNT
	b.frame = A|FF_FULLBRIGHT|FF_ADD|TR_TRANS20
	b.colorized = true
	b.color = SKINCOLOR_TAN
	b.flags2 = $ | MF2_SPLAT
	b.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
	b.angle = 0
	b.rollangle = mo.angle + ANG1*90
	b.spritexscale = $*min(mo.extravalue1, 4)
	b.tics = 2
	
	if mo.extravalue1 > TICRATE/2
	and mo.extravalue1 <= TICRATE/2 + spintics
		
		for i = 1, 10
			mo.angle = $ + aspeed/10
						
			xp = mo.x + dist*cos(mo.angle)
			yp = mo.y + dist*sin(mo.angle)
			P_SetOrigin(b, xp, yp, b.z)
			b.rollangle = mo.angle + ANG1*90
			local g = P_SpawnGhostMobj(b)
			g.renderflags = b.renderflags
			
			local px = mo.x + gigrants_range*cos(mo.angle)
			local py = mo.y + gigrants_range*sin(mo.angle)
			
			local s = P_SpawnMobj(px, py, mo.z, MT_SUPERSPARK)
			s.color = SKINCOLOR_TAN
			s.colorized = true
			
		end
	end
	
	if mo.extravalue1 == TICRATE/2 + spintics/2
		local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, gigrants_range<<FRACBITS, 180<<FRACBITS, mo.target, mo.pso.potency, DMT_TECHNIQUE, 4)
		PSO.lib.copyWeaponProperties(mo, hb)
		hb.pso.combobreaker = mo.pso.combobreaker
		hb.pso.element = mo.pso.element
		hb.pso.potency = mo.pso.potency
	end
	
	if mo.extravalue1 == TICRATE/2 + spintics+5
		P_RemoveMobj(mo)
	end	
	--print(mo.angle/ANG1)
	
end, MT_PSO_GIGRANTS)

PSO.info.photonArts["gigrants"] = {
		-- PA is a technique
		technique = true,
		name = "Gigrants",
		desc = "Light Technique. Rotates a blade of light around the caster, damaging nearby enemies",
		cost = 26,
		potency = 400,
		actionspeed = 40,
		icon = "H_TGGRAN",
		casttime = TICRATE/2,
		sound = sfx_s243,

		element = ELEM_LIGHT,
		spawndist = 0,
		speed = 0,
		
		object = MT_PSO_GIGRANTS,

		spawnfunc = function(msl)
			-- make sure razonde cannot have more than 1 instance per player
			local mo = msl.target
			
			if mo.giggrants
			and mo.gigrants.valid
				P_RemoveMobj(mo.gigrants)	-- don't stack!!
			end
		end,
		
}

freeslot("MT_PSO_RAGRANTS")
mobjinfo[MT_PSO_RAGRANTS] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16<<FRACBITS,
	height = 16<<FRACBITS,
	flags = MF_NOGRAVITY,
}

local ragrants_range = 768
local ragrants_step = 12
local ragrants_loop = ragrants_range/ragrants_step

addHook("MobjThinker", function(mo)
	
	if not mo.target or not mo.target.valid
		P_RemoveMobj(mo)
		return
	end
	
	mo.extravalue1 = $+1
	P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
	
	if mo.target.player
		mo.angle = mo.target.player.drawangle
	end
	
	if mo.extravalue1 < TICRATE/3
		
		local s = P_SpawnMobj(mo.x + P_RandomRange(-64, 64)*mo.scale, mo.y + P_RandomRange(-64, 64)*mo.scale, P_RandomRange(-64, 64)*mo.scale, MT_SUPERSPARK)
		s.color = SKINCOLOR_TAN
		s.colorized = true
		
		s.momx = (mo.x - s.x)/16
		s.momy = (mo.y - s.y)/16
		s.momz = (mo.z - s.z)/16
	end
	
	if mo.extravalue1 >= TICRATE/2
		
		if mo.extravalue1 % 10 == 0	
			local t = P_SpawnMobj(mo.x, mo.y, mo.z + mo.scale*32, MT_THOK)
			t.sprite = SPR_NTHK
			t.frame = B|TR_TRANS30
			t.color = SKINCOLOR_WHITE
			t.scale = 1
			t.destscale = FRACUNIT*4
			t.scalespeed = FRACUNIT/6
			t.fuse = TICRATE/2
			t.tics = t.fuse
			t.momz = mo.scale*4
		end
		
		local dist = 32
		local hitboxes = {}
		local za = 0
		
		if mo.target.player.pso.target and mo.target.player.pso.target.valid
			local tt = mo.target.player.pso.target
			mo.zdiff = tt.z - mo.z
			mo.dist = R_PointToDist2(mo.x, mo.y, tt.x, tt.y)
			mo.angle = R_PointToAngle2(mo.x, mo.y, tt.x, tt.y)
		end
		
		if mo.zdiff and abs(mo.zdiff) > 64*FRACUNIT
			
			local steps_to_target = mo.dist / ragrants_step
			za = FixedDiv(mo.zdiff, steps_to_target)
		end
		
		
		for i = 1, ragrants_loop
			
			local x = mo.x + dist*cos(mo.angle)
			local y = mo.y + dist*sin(mo.angle)
					
			local t = P_SpawnMobj(x, y, mo.z + mo.scale*16 +za*(i-1), MT_THOK)
			if t and t.valid
				t.sprite = SPR_ENRG
				t.frame = A|FF_ADD|TR_TRANS30
				t.colorized = true
				t.color = SKINCOLOR_TAN
				t.scale = mo.scale/3 + cos(leveltime*ANG1*20 + i*ANG1*8)/64
				t.tics = 2
				
				if not P_CheckSight(mo, t)
					break
				end
			end
			
			if P_RandomRange(0, 16) == 0
				local s = P_SpawnMobj(x + P_RandomRange(-64, 64)*mo.scale, y + P_RandomRange(-64, 64)*mo.scale, t.z + P_RandomRange(-32, 32)*mo.scale, MT_SUPERSPARK)
				s.color = SKINCOLOR_TAN
				s.colorized = true
				s.scale = $*2/3
				P_InstaThrust(s, mo.angle, P_RandomRange(16, 48)*mo.scale)
			end
			
			if mo.extravalue1 % (TICRATE/2) == 0
				local hb = PSO.lib.spawnHurtBox(x, y, mo.z + za*(i-1), (ragrants_step*6)<<FRACBITS, 140<<FRACBITS, mo.target, mo.pso.potency/3, DMT_TECHNIQUE, 4)
				PSO.lib.copyWeaponProperties(mo, hb)
				hitboxes[#hitboxes+1] = hb
				hb.pso.combobreaker = mo.pso.combobreaker
				hb.pso.element = mo.pso.element
				hb.pso.links = hitboxes
				hb.pso.potency = mo.pso.potency/3
				hb.pso.pierceref = mo
			end
			
			dist = $ + ragrants_step
		end
		
		if mo.extravalue1 >= TICRATE*2 - 10
			P_RemoveMobj(mo)
			return
		end
	end
end, MT_PSO_RAGRANTS)

PSO.info.photonArts["ragrants"] = {
		-- PA is a technique
		technique = true,
		name = "Ragrants",
		desc = "Light Technique. Fires a piercing beam of light that pierces through enemies.",
		cost = 35,
		potency = 620,
		actionspeed = 40,
		icon = "H_TRGRAN",
		casttime = TICRATE*3/4,
		sound = sfx_s243,

		element = ELEM_LIGHT,
		spawndist = 0,
		speed = 0,
		spawnheight = 0,
		
		object = MT_PSO_RAGRANTS,

		spawnfunc = function(msl)
			-- make sure razonde cannot have more than 1 instance per player
			local mo = msl.target
			
			if mo.ragrants
			and mo.ragrants.valid
				P_RemoveMobj(mo.ragrants)	-- don't stack!!
			end
			
			if mo.player.pso.target
			and mo.player.pso.target.valid
			and mo.player.pso.lockon
				
				msl.zdiff = mo.player.pso.target.z - mo.z
				msl.dist = R_PointToDist2(mo.x, mo.y, mo.player.pso.target.x, mo.player.pso.target.y)
			end
			
		end,
}

freeslot("MT_PSO_ILLGRANTS", "MT_PSO_ILLGRANTS_PROJECTILE")
mobjinfo[MT_PSO_ILLGRANTS] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16<<FRACBITS,
	height = 16<<FRACBITS,
	flags = MF_NOGRAVITY,
}

mobjinfo[MT_PSO_ILLGRANTS_PROJECTILE] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 24<<FRACBITS,
	height = 64<<FRACBITS,
	flags = MF_NOGRAVITY|MF_MISSILE,
}

addHook("MobjThinker", function(mo)
	
	if not mo.tracer 
	or not mo.tracer.valid
		P_RemoveMobj(mo)
		return
	end
	
	local dist = R_PointToDist2(mo.x, mo.y, mo.tracer.x, mo.tracer.y)
	
	if mo.extravalue1 % 6 == 0
		local msl = PSO.lib.spawnMissile(mo, MT_PSO_ILLGRANTS_PROJECTILE, mo.angle, 0, mo.pso.potency/5, DMT_TECHNIQUE, 0, 0, 0, RT_NONE)
		msl.pso.element = mo.pso.element
		msl.target = mo.target
		msl.tracer = mo.tracer
		msl.pso.combobreaker = mo.pso.combobreaker
		msl.pso.potency = mo.pso.potency/5
		msl.tics = TICRATE*12
		
		-- initial speed
		local acap = min(30, dist/10 /FRACUNIT)
		msl.angle = $ + P_RandomRange(-acap, acap)*ANG1
		msl.momz = $ + P_RandomRange(0, max(0, acap-4)/2)*FRACUNIT
		P_InstaThrust(msl, msl.angle, FRACUNIT*24)
		
		mo.extravalue2 = $+1
		
		if mo.extravalue2 >= 5
			P_RemoveMobj(mo)
		end
	end
	
end, MT_PSO_ILLGRANTS)

local illgrants_speed = 12*FRACUNIT
local illgrants_accel = FRACUNIT*2/3

-- basic chase thinker for illgrants
addHook("MobjThinker", function(mo)
	
	local target = mo.tracer
	if not target or not target.valid
		P_RemoveMobj(mo)
		return
	end
	
	local dist = P_AproxDistance(P_AproxDistance(target.x - mo.x, target.y - mo.y), target.z - mo.z)
	
	-- normalize vakues
	local dx = FixedDiv(target.x - mo.x, dist)
	local dy = FixedDiv(target.y - mo.y, dist)
	local dz = FixedDiv((target.z + target.height*6/10) - mo.z, dist)
	
	-- the values we want:
	local desired_momx = FixedMul(dx, illgrants_speed)
	local desired_momy = FixedMul(dy, illgrants_speed)
	local desired_momz = FixedMul(dz, illgrants_speed)
	
	-- how much we'd have to change by
	local steeringx = desired_momx - mo.momx
	local steeringy = desired_momy - mo.momy
	local steeringz = desired_momz - mo.momz
	
	-- cap acceleration
	if abs(steeringx) > illgrants_accel
		steeringx = (steeringx > 0 and 1 or -1) * illgrants_accel
	end

	if abs(steeringy) > illgrants_accel
		steeringy = (steeringy > 0 and 1 or -1) * illgrants_accel
	end
	
	if abs(steeringz) > illgrants_accel
		steeringz = (steeringz > 0 and 1 or -1) * illgrants_accel
	end	
	
	-- apply
	mo.momx = $ + steeringx
	mo.momy = $ + steeringy
	mo.momz = $ + steeringz
	
	local preva = (leveltime-1)*ANG1*20
	local a = leveltime*ANG1*20
	local dists = 4
	
	local sx = mo.x + dists*cos(a)
	local sy = mo.y + dists*cos(a)
	local sz = mo.z + dists*cos(a)
	
	local s = P_SpawnMobj(sx, sy, sz, MT_THOK)
	s.tics = 2
	s.color = SKINCOLOR_TAN
	s.colorized = true
	s.sprite = SPR_SSPK
	s.frame = B|FF_FULLBRIGHT|FF_ADD
	s.scale = mo.scale + cos(a)/16
	
	-- trail
	if mo.prevx ~= nil
		for i = 1, 5
			
			local x = PSO.lib.lerp(mo.prevx, sx, FRACUNIT/5 *i)
			local y = PSO.lib.lerp(mo.prevy, sy, FRACUNIT/5 *i)
			local z = PSO.lib.lerp(mo.prevz, sz, FRACUNIT/5 *i)
			
			local t = P_SpawnMobj(x, y, z + mo.scale*12, MT_THOK)
			if t and t.valid
				t.fuse = 20
				t.scale = $/6
				t.destscale = 1
				t.scalespeed = FRACUNIT/64
				t.colorized = true
				t.color = SKINCOLOR_TAN
				t.sprite = SPR_ENRG
				t.frame = $|FF_ADD|FF_FULLBRIGHT
			end
		end
	end
		
	mo.prevx = sx
	mo.prevy = sy
	mo.prevz = sz
	
	sx = $ + P_RandomRange(-32, 32)*mo.scale
	sy = $ + P_RandomRange(-32, 32)*mo.scale
	sz = $ + P_RandomRange(-32, 32)*mo.scale
	
	if leveltime%4 == 0
		local s = P_SpawnMobj(sx, sy, sz, MT_SUPERSPARK)
		s.scale = $/2
		s.color = SKINCOLOR_PINK
		s.colorized = true
	end
	
	--print(dist)
	if mo.tracer and mo.tracer.valid and mo.tracer.type == MT_THOK
	and dist < mo.scale*48
		P_RemoveMobj(mo)
	end
	
end, MT_PSO_ILLGRANTS_PROJECTILE)


PSO.info.photonArts["ilgrants"] = {
		-- PA is a technique
		technique = true,
		name = "Ilgrants",
		desc = "Light Technique. Fires light projectiles that home in on the target.",
		cost = 30,
		potency = 360,
		actionspeed = 40,
		icon = "H_TIGRAN",
		casttime = TICRATE*3/4,
		sound = sfx_s243,

		element = ELEM_LIGHT,
		spawndist = 32,
		speed = 0,
		spawnheight = 32,
		
		object = MT_PSO_ILLGRANTS,

		spawnfunc = function(msl)
			-- make sure razonde cannot have more than 1 instance per player
			local mo = msl.target
			
			if mo.player.pso.target
				msl.tracer = mo.player.pso.target
			else
				local dist = 512
				local x = mo.x + dist*cos(mo.angle)
				local y = mo.y + dist*sin(mo.angle)
				local t = P_SpawnMobj(x, y, mo.z + mo.scale*48, MT_THOK)
				t.state = S_INVISIBLE
				t.color = SKINCOLOR_RED
				t.tics = TICRATE*10
				msl.tracer = t
			end
		end,
}

PSO.info.photonArts["resta"] = {
		-- PA is a technique
		technique = true,
		name = "Resta",
		desc = "Light Technique. Heals the caster and nearby allies depending on the caster's T-ATK stat.",
		cost = 50,
		potency = 50,
		actionspeed = 10,
		icon = "H_TRESTA",
		casttime = TICRATE*2,
		sound = sfx_heal,

		element = ELEM_LIGHT,
		spawndist = 0,
		speed = 30,
		
		object = MT_THOK,
		
		spawnfunc = function(msl)
			-- make sure razonde cannot have more than 1 instance per player
			local mo = msl.target
			local mop = mo.player
			
			if not mop return end
			
			local range = 768
			if PSO.lib.hasSkill(mop, "fo_territoryburst")
				range = $*3
			end			
			
			local whiff
			if not PSO.lib.usingPB(mop)
				if PSO.lib.arenaQuestActive() and mop.pso.pb ~= nil and mop.pso.pb < PSO.info.MAXPB/4
					whiff = true
				elseif PSO.lib.arenaQuestActive()
					mop.pso.pb = $-PSO.info.MAXPB/4
				end
			end
			
			for i = 1, 16
				local ang = (360/16)*i*ANG1
				
				local s = P_SpawnMobj(mo.x, mo.y, mo.z, whiff and MT_SPINDUST or MT_SUPERSPARK)
				
				if not whiff
					s.color = SKINCOLOR_GREEN
					s.colorized = true
				end
				
				P_InstaThrust(s, ang, FRACUNIT*32)
			end
			
			if whiff return true end
			
			
			-- get the player's weapon
			local wep = PSO.lib.getPlayerActiveWeapon(mop)
			local tatk = mop.pso.tatk
			
			if PSO.info.weaponDamageType[wep.weapontype] == DMT_TECHNIQUE
				tatk = $ + wep.atk
			end
			
			local heal_amount = msl.pso.potency*tatk / 100
			heal_amount = $ + P_RandomRange(-heal_amount/10, heal_amount/10)	-- variance
			
			for p in players.iterate do
				
				if p and p.mo and p.mo.valid
				and R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y) < range*mo.scale
					PSO.lib.healObject(p.mo, p.mo, heal_amount)
				end
			end
			
			P_RemoveMobj(msl)
		end,
}