-- Shows status & buff tooltips
-- TODO: Add party info.

hud.disable("rankings")
hud.disable("coopemeralds")
hud.disable("tokens")
hud.disable("tabemblems")

local function HU_tooltips(v)
	
	local p = consoleplayer
	
	v.drawString(2, 190, "^ PLAYER STATUS INFORMATION ^", V_YELLOWMAP|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "thin")
	v.drawString(2, 2, "V ENEMY STATUS INFORMATION V", V_YELLOWMAP|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "thin")
	
	-- status conditions:
	local statusx = 2
	local statusy = 175
	local initstatusy = 175
	
	if p.pso.condition
	--and (p.pso.conditiontimer > TICRATE*3 or p.pso.conditiontimer & 1)
		local info = PSO.info.statusConditions[p.pso.condition]
		v.drawFill(statusx, statusy, 180, 12, 253|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		v.draw(statusx, statusy+1, v.cachePatch("H_STATUS"..p.pso.condition), V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		
		local str = "\x82"..info.name.."\x80: "..info.tip
		v.drawString(statusx + 12, statusy+3, str, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
		
		statusy = $ - 14
	end
	

	-- s/d j/z
	local st = {"matesickness", "shifta", "deband", "jellen", "zalure", "rweakness", "rbrink", "levelsynch"}
	local pp = {"H_MSICK", "H_STATUS8", "H_STATUS16", "H_STATUS32", "H_STATUS64", "H_REV1", "H_REV2", "H_LSYNCH"}
	local lookup = {COND_MATESICKNESS, COND_SHIFTA, COND_DEBAND, COND_JELLEN, COND_ZALURE, COND_WEAKNESS, COND_BRINKOFDEATH, COND_LEVELSYNCH}
	local sx = statusx
	
	for i = 1, #st
		if p.pso[st[i]]
			local patch = pp[i]
			local cond  = lookup[i]
			
			local info = PSO.info.statusConditions[cond]
			v.drawFill(statusx, statusy, 180, 12, 253|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
			v.draw(statusx, statusy+1, v.cachePatch(patch), V_SNAPTOBOTTOM|V_SNAPTOLEFT)
			
			local tip = info.tip
			
			if st[i] == "levelsynch"
				tip = "Lv"..p.pso.levelsynch.." equivalent."
			end
			
			local str = "\x82"..info.name.."\x80: "..tip
			v.drawString(statusx + 12, statusy+3, str, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
			
			statusy = $ - 14
		end
	end
	
	if statusy == initstatusy
		v.drawString(2, statusy, "No status inflicted", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
	end
	
	local enemystatusy = 14
	local enemystatusinit = enemystatusy
	
	-- enemy
	if consoleplayer.pso and consoleplayer.pso.target and consoleplayer.pso.target.valid
		local en = consoleplayer.pso.target
		if en.flags & MF_ENEMY
		and en.pso
			
			if en.pso.condition
			--and (p.pso.conditiontimer > TICRATE*3 or p.pso.conditiontimer & 1)
				local info = PSO.info.statusConditions[en.pso.condition]
				v.drawFill(statusx, enemystatusy, 180, 12, 253|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
				v.draw(statusx, enemystatusy+1, v.cachePatch("H_STATUS"..en.pso.condition), V_SNAPTOBOTTOM|V_SNAPTOLEFT)
				
				local str = "\x82"..info.name.."\x82: \x80"..(info.etip or info.tip)
				v.drawString(statusx + 12, enemystatusy+3, str, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
				
				enemystatusy = $ + 14
			end
			

			-- s/d j/z
			local st = {"matesickness", "shifta", "deband", "jellen", "zalure", "rweakness", "rbrink", "levelsynch"}
			local pp = {"H_MSICK", "H_STATUS8", "H_STATUS16", "H_STATUS32", "H_STATUS64", "H_REV1", "H_REV2", "H_LSYNCH"}
			local lookup = {COND_MATESICKNESS, COND_SHIFTA, COND_DEBAND, COND_JELLEN, COND_ZALURE, COND_WEAKNESS, COND_BRINKOFDEATH, COND_LEVELSYNCH}
			local sx = statusx
			
			for i = 1, #st
				if en.pso[st[i]]
					local patch = pp[i]
					local cond  = lookup[i]
					
					local info = PSO.info.statusConditions[cond]
					v.drawFill(statusx, enemystatusy, 180, 12, 253|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
					v.draw(statusx, enemystatusy+1, v.cachePatch(patch), V_SNAPTOBOTTOM|V_SNAPTOLEFT)
					
					local str = "\x82"..info.name.."\x80: "..(info.etip or info.tip)
					v.drawString(statusx + 12, enemystatusy+3, str, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
					
					enemystatusy = $ + 14
				end
			end			
			
		end
	end

	if enemystatusy == enemystatusinit
		v.drawString(2, enemystatusy, "No status inflicted", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
	end	
end

local function HU_playerList(v, p, c)
	
	local y = 16
	
	--for i = 1, 32
		--local p2 = players[0]
	for p2 in players.iterate
		PSO.lib.drawPlayerStatus(v, nil, p2, 200, y, true, V_SNAPTOTOP|V_SNAPTORIGHT)
		v.draw(186, y+1, v.cachePatch("H_CLASS"..p2.pso.type), V_SNAPTOTOP|V_SNAPTORIGHT)
		y = $ + 16
		
	end
end

hud.add(function(v)
	
	local x = 8
	local y = 12
	
	local w = 80
	local h = 12
	
	v.fadeScreen(31, 7)
	
	HU_playerList(v, p, c)
	HU_tooltips(v)
end, "scores")