-- Rare Drip KOI KOI!

freeslot("SPR_RDRS")	-- RDR shine. Needs to be cached as a sprite for rotations.

PSO.lib.startRareDropAnim = function(p, rarity)
	if not p.mo return end

	-- play sound
	S_StartSound(nil, sfx_rdrp0, p)
	
	-- disable rare drop anim if the player doesn't want it!
	if p.pso.pref_raredrop and rarity < p.pso.pref_raredrop
		return
	end
	
	if rarity >= 7
		if rarity < 10 or rarity > 12
			S_StartSound(nil, sfx_rdrp1, p)
		else
			S_StartSound(nil, sfx_rdrp2, p)
		end

		if rarity >= 13 and rarity <= 14
			S_StartSound(nil, sfx_rdrp3, p)
		elseif rarity >= 15
			S_StartSound(nil, sfx_rdrp4, p)
		end

		if not p.mo.pso2_raredroptimer or p.mo.pso2_rarity and rarity >= p.mo.pso2_rarity
			-- Start the animation only if it either isn't playing or if you just got a higher or same rarity item
			p.mo.pso2_raredroptimer = TICRATE*3
			p.mo.pso2_rarity = rarity
		end
	end
end

PSO.lib.playerHandleRareDropAnim = function(p)
	local mo = p.mo
	if p.mo.pso2_raredroptimer
		p.mo.pso2_raredroptimer = $-1
	end
end

local gold = {
	
	SKINCOLOR_YELLOW,
	SKINCOLOR_YELLOW,
	SKINCOLOR_YELLOW,
	SKINCOLOR_YELLOW,
	SKINCOLOR_GOLDENROD,
	SKINCOLOR_LEMON,
	SKINCOLOR_HEADLIGHT,
	SKINCOLOR_CLOUDY,
	SKINCOLOR_WHITE,
	SKINCOLOR_CLOUDY,
	SKINCOLOR_HEADLIGHT,
	SKINCOLOR_LEMON,
	SKINCOLOR_GOLDENROD,
}

local rainbow = {
	SKINCOLOR_PINK,
	SKINCOLOR_YOGURT,
	SKINCOLOR_TAN,
	SKINCOLOR_MOSS,
	SKINCOLOR_AQUA,
	SKINCOLOR_LILAC,
}


local lastindex
local prefix = "EMRF"
rawset(_G, "V_drawRDString", function(v, x, y, str, flags, alignment, scale, colormap, rarity, timer)
	timer = $ or 0
	str = tostring(str)
	if not (v and tonumber(x)~=nil and tonumber(y)~=nil and str and prefix) return end
	scale = $ or FRACUNIT

	x = $<<FRACBITS
	y = $<<FRACBITS	-- don't break compability...

	local xoffs = 0
	local yoffs = 0

	-- alignment coordinate adjustment:
	if alignment == "right"
		x = $ - V_emergencyStringWidth(v, str, flags, scale)
	elseif alignment == "center"
		x = $ - V_emergencyStringWidth(v, str, flags, scale)/2
	end

	if rarity >= 13	-- rainbow text...
		lastindex = leveltime % ((#rainbow)*2) /2 +1
	elseif rarity >= 10
		lastindex = leveltime % ((#gold)*2) /2+1
	end

	if timer
		str = str:sub(1, timer/2)
	end

	for i = 1, str:len()
		local s = str:sub(i, i)
		local let_time = timer - 2*(i-1)

		if s == "\n"	-- line break
			yoffs = $+16*scale
			xoffs = 0
			continue
		end

		if not v.patchExists(prefix..ascii_03d[s:byte()]) -- patch doesn't exist, assume it's a space:
			xoffs = $+10*scale
			continue
		end

		if rarity >= 13
			colormap = v.getColormap(TC_RAINBOW, rainbow[lastindex])
			lastindex = $-1
			if lastindex < 1
				lastindex = #rainbow
			end
		elseif rarity >= 10
			colormap = v.getColormap(TC_RAINBOW, gold[lastindex])
			lastindex = $-1
			if lastindex < 1
				lastindex = #gold
			end		
		end

		local specialoffset = 0
		if let_time >= 0 and let_time <= 6
		and timer
			local fakeang = let_time * 55 * ANG1 -- = 55
			specialoffset = $ + FixedMul(scale, sin(fakeang))*8
		end

		V_drawEmergencyLetter(v, (x+xoffs), (y+yoffs+specialoffset), s, flags, scale, colormap)	-- letter
		local pp = v.cachePatch(prefix..ascii_03d[s:byte()])
		xoffs = $+ pp.width*scale + FRACUNIT

	end
end)

-- anim test...

local patchcache = {}

local function handleRareDropAnimation(v, x, y, timer, rarity)
	-- cache the rotating bits
	if not #patchcache or not patchcache[1].valid	-- wtf
		for i = 1, 32
			patchcache[i] = v.getSpritePatch(SPR_RDRS, C, 0, (360/32 *i)*ANG1)
		end
	end

	if rarity < 7 return end
	

	local excl = (rarity-1)%3 and string.rep("!", (rarity-1)%3) or ""
	
	if rarity > 15	-- for 16*s in 10 years lmfaoooo
		excl = "!!!"
	end
	
	local t = TICRATE*3 - timer
	local str = "RARE DROP"..excl
	local strw = (V_emergencyStringWidth(v, str)/2)/FRACUNIT
	local patchscale = FRACUNIT
	local fade = 0

	if t < 5
		patchscale = FRACUNIT/4 *t
	end
	if timer < 10
		fade = (10 - timer) << V_ALPHASHIFT
	end


	local frame = (leveltime % 18) / 3 +1
	local patch = v.cachePatch("RDRA"..frame)
	local patchg = v.cachePatch("RDRGA"..frame)
	local patchr = v.cachePatch("RDRRA"..frame)

	if rarity <= 9
		v.drawScaled(x<<FRACBITS, (y + (8*sin(leveltime*ANG1*16)/FRACUNIT))<<FRACBITS, patchscale, patch, fade)
	
	elseif rarity <= 12
		v.drawScaled(x<<FRACBITS, (y + (8*sin(leveltime*ANG1*16)/FRACUNIT))<<FRACBITS, patchscale, patchg, fade)
	else
		
		-- if rarity >= 10, gold drop
		-- if rarity >= 13, rainbow drop

		local tt = rarity >= 13 and rainbow or gold

		-- attempt at rainbow drop
		local colour = tt[leveltime % (10*(#tt)) / 10 +1]
		local tcolour = tt[(leveltime+10) % (10*(#tt)) / 10 +1]
		local trans = (((leveltime % 10)))

		-- 15* aura
		if rarity >= 15
			for i = 1, 2

				local timer = leveltime + (i-1)*3

				local shinecolour = tt[timer % (2*(#tt)) / 2 +1]
				local shinescale = FRACUNIT/2 + (timer%6) *FRACUNIT/6
				local shinetrans = (2 + (timer%8) -1)
				if shinetrans and (shinetrans) < 10
					local pname = "RAURA3"	--..max(1, shinetrans)	-- use gradually darker patches for additive translucency
					v.drawScaled(x<<FRACBITS, (y)<<FRACBITS, shinescale, v.cachePatch(pname), V_ADD|trans, v.getColormap(TC_RAINBOW, shinecolour))
				end
			end
		end

		-- the shine...
		local shinecolour = tt[leveltime % (4*(#tt)) / 4 +1]
		local shinescale = FRACUNIT/2 + (leveltime%10) *FRACUNIT/6
		local shineframe = leveltime% (32*4) /4 +1
		local shinetrans = ((leveltime%10)) << V_ALPHASHIFT
		if shinetrans and (shinetrans) < (10 << V_ALPHASHIFT)
			--print(shinetrans.."|"..shineframe)
			local patch = patchcache[shineframe]
			v.drawScaled(x<<FRACBITS, (y-10)<<FRACBITS, shinescale, patch, V_ADD|shinetrans, v.getColormap(TC_RAINBOW, shinecolour))
		end

		v.drawScaled(x<<FRACBITS, (y + (8*sin(leveltime*ANG1*16)/FRACUNIT))<<FRACBITS, patchscale, patchr, 0, v.getColormap(TC_RAINBOW, colour))
		-- translucent layer
		if leveltime%10
			v.drawScaled(x<<FRACBITS, (y + (8*sin(leveltime*ANG1*16)/FRACUNIT))<<FRACBITS, patchscale, patchr, (10-trans)<<V_ALPHASHIFT, v.getColormap(TC_RAINBOW, tcolour))
		end
	end
	-- the text...
	-- defaults to tc_rainbow black, special makes it rainbow if rarity > 9
	V_drawRDString(v, x-strw, y+10, str:sub(1, t/2), fade, nil, nil, v.getColormap(TC_RAINBOW, SKINCOLOR_GREY), rarity, t)

end

local function HU_rareDropAnim(v, p, c)
	if p and p.mo and p.mo.pso2_raredroptimer
		handleRareDropAnimation(v, 160, 40, p.mo.pso2_raredroptimer, p.mo.pso2_rarity)
	end
end

PSO.lib.registerHudFunc(HU_rareDropAnim)

-- drop names
PSO.lib.addDropText = function(p, rarity, text)
	
	p.mo.droptextqueue = $ or {}
	local delay = 0
	
	local prev = p.mo.droptextqueue[#p.mo.droptextqueue]
	if prev
		local y = prev[4]
		if y < FRACUNIT*9
			y = (FRACUNIT*9 -y)/FRACUNIT
			delay = y*3 + prev[5]
		end	
	end
	--print(delay)
	p.mo.droptextqueue[#p.mo.droptextqueue+1] = {rarity, text, TICRATE*2, 0, delay}
end

PSO.lib.playerHandleDropText = function(p)
	if p.mo.droptextqueue
		local i = #p.mo.droptextqueue
		local d = p.mo.droptextqueue
		
		while i
			
			if not d[i]
				break
			end	-- ???????	
			
			-- delay
			if d[i][5]
				d[i][5] = $-1
				i = $-1
				continue
			end
			
			d[i][3] = $-1
			if not d[i][3]
				table.remove(d, i)
				continue
			end
			d[i][4] = $ + FRACUNIT/3
			
			i = $-1
		end	
	end
end

local function HU_dropText(v, p, c)
	if p.mo.droptextqueue
		
		local t = p.mo.droptextqueue
		for i = 1, #t
			
			local d = t[i]
			
			if d[5]
				continue
			end
			
			local x = (160 + 40)*FRACUNIT
			local y = 130*FRACUNIT - d[4]	--(TICRATE*2 - d[3])/3
			local tflag = 0
			if d[3] < 10
				tflag = (10 - d[3])
				tflag = max($, 0)
				tflag = min($, 9)
				tflag = $<<V_ALPHASHIFT
			end	
			
			if d[1] < 0
				v.drawScaled(x-(10*FRACUNIT), y, FRACUNIT, v.cachePatch("H_MST"), tflag)
			else
				v.drawScaled(x-(10*FRACUNIT), y, FRACUNIT, v.cachePatch("H_NSTAR"..d[1]), tflag)
			end
			v.drawString(x, y, d[2], tflag|V_ALLOWLOWERCASE, "thin-fixed")
		end	
	end
end
PSO.lib.registerHudFunc(HU_dropText)

COM_AddCommand("funny2", function(p, arg)
	PSO.lib.startRareDropAnim(p, tonumber(arg))
end)
