-- Used when the player asks to be healed!

local choices = {
		"PROCEED",
		"CANCEL",
}

local w = 270
local h = 80
local function drawArenaMenu(v, p, c, choice, timer)
	
	local x = 160-(w/2)
	local y = 100-(h/2)
	
	v.drawFill(x, y, w, h, 253)
	
	v.drawString(160, y+4, "WARNING!", V_YELLOWMAP, "center")
	v.drawString(160, y+12, "Entering the Arena. Make sure you", V_ALLOWLOWERCASE, "center")
	v.drawString(160, y+20, "have finished your preparations", V_ALLOWLOWERCASE, "center")
	v.drawString(160, y+28, "using the item counter.", V_ALLOWLOWERCASE, "center")
	v.drawString(160, y+36, "The quest will fail if all players", V_ALLOWLOWERCASE, "center")
	v.drawString(160, y+44, "are incapacitated or time runs out.", V_ALLOWLOWERCASE, "center")
	
	local cy = y+58
	for i = 1, #choices
		
		v.drawString(160, cy, (i == choice and "\x82"..">" or "")..choices[i], 0, "center")
		cy = $+10
	end
end

local w2 = 160
local h2 = 32
local function drawWaitMenu(v, p, c, choice, timer)

	local x = 160-(w2/2)
	local y = 100-(h2/2)
		
	if p.mo.tptime	
		
		-- draw countdown!
		local patches = {"H_CNUM3", "H_CNUM2", "H_CNUM1", "H_CNUMG"}
		for i = 1, #patches
			
			local tmr = p.mo.tptime - TICRATE*i
			local pp = v.cachePatch(patches[i])
			
			local scale1 = min(FRACUNIT, tmr*FRACUNIT/4)
			local scale2 = min(FRACUNIT*3, tmr*FRACUNIT/4)
			local tflag1 = 0
			local tflag2 = 5 << V_ALPHASHIFT
			
			if tmr >= TICRATE-10
				tflag1 = min(9, (tmr - (TICRATE-10))) << V_ALPHASHIFT
			end
			
			if tmr > 4
				tflag2 = $ + (tmr/4)<<V_ALPHASHIFT
			end
			
			if tmr >= 0
			and tmr < TICRATE
				v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale1, pp, tflag1)
			end
			
			if tmr >= 0
			and tmr < TICRATE/3
				v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale2, pp, tflag2)
			end
			
		end
	else	-- show how many players are missing
		v.drawFill(x, y, w2, h2, 253)
		
		v.drawString(160, y+4, "WAITING FOR PLAYERS...", V_YELLOWMAP, "center")
		
		local count = 0
		local accepted = 0
		
		for pl in players.iterate do
			
			if pl and pl.mo and pl.mo.valid
				count = $+1
				
				if pl.mo.tpok
					accepted = $+1
				end
				
			end
		end
		
		v.drawString(160, y+12, accepted.."/"..count, 0, "center")
	end
end

freeslot("sfx_cnt1", "sfx_cnt2", "sfx_cnt3", "sfx_cntgo") 

local cam_dist = 2752

PSO.info.menus["arena"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
	
		if p.mo.arenatp return end
	
		if p.mo.tpok
			drawWaitMenu(v, p, c, choice, timer)
		else
			drawArenaMenu(v, p, c, choice, timer)
		end
	end,
	
	openfunc = function(p)
		p.mo.tptime = nil
		p.mo.tpok = nil
		p.mo.currentindex = server.questdata.arenaindex
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if p.mo.tpok
			
			local count = 0
			local accepted = 0
			local firstaccept
			
			for pl in players.iterate do
				
				if pl and pl.mo and pl.mo.valid
					count = $+1
					
					if pl.mo.tpok
						accepted = $+1
						if not firstaccept or not firstaccept.valid
							firstaccept = pl
						end
						
					end
					
				end
			end	
			
			if accepted >= count
				p.mo.tptime = $ and $+1 or 1
				
				if p.mo.tptime == TICRATE
					S_StartSound(nil, sfx_cnt3, p)
				elseif p.mo.tptime == TICRATE*2
					S_StartSound(nil, sfx_cnt2, p)				
				elseif p.mo.tptime == TICRATE*3
					S_StartSound(nil, sfx_cnt1, p)	
				elseif p.mo.tptime == TICRATE*4
					S_StartSound(nil, sfx_cntgo, p)
				elseif p.mo.tptime == TICRATE*5
					
					local viewbase
					for m in mapthings.tagged(0)
						--print(m.type.." | "..MT_ALTVIEWMAN)
						if m and m.mobj and m.mobj.valid and m.mobj.type == MT_ALTVIEWMAN
							viewbase = m.mobj
							break
						end
					end	
					
					S_FadeOutStopMusic(1000)
					
					local a = ANG1*270	-- yeah all that shit is hardcoded and bad.
					local ax = viewbase.x + cam_dist*cos(a)
					local ay = viewbase.y + cam_dist*sin(a)
					local az = viewbase.z
					
					local viewpoint = P_SpawnMobj(ax, ay, az, MT_THOK)
					viewpoint.tics = TICRATE*10
					viewpoint.sprite = SPR_NULL
					viewpoint.angle = R_PointToAngle2(viewpoint.x, viewpoint.y, viewbase.x, viewbase.y)
					p.awayviewmobj = viewpoint
					p.awayviewtics = TICRATE*10	-- for now.
					
					P_InstaThrust(viewpoint, viewpoint.angle, -FRACUNIT*30)
					
					P_SetOrigin(p.mo, viewpoint.x, viewpoint.y, viewpoint.floorz)
					p.pso.target = nil
					p.powers[pw_nocontrol] = 32767
					
					
					/*PSO.lib.softResetPlayer(p)
					p.pso.teleport = 1
					p.pso.teleporttype = 0	-- make sure this is done or we're going to have problems!
					p.pso.teleporttarget = p.pso.teletarget.target
					
					-- the bodies were never found
					if p.pso.teletarget and p.pso.teletarget.valid
						p.pso.teletarget.fuse = 4
					end
					
					if server.questdata	-- happens during testing
						server.questdata.noreturn = true	-- no going back now~
						p.pso.quest.timer_on = true	-- start timer if not done yet
					end
					
					PSO.lib.closeMenu(p)*/
				elseif p.mo.tptime > TICRATE*5
					
					P_Thrust(p.awayviewmobj, p.awayviewmobj.angle, FRACUNIT)
					--print(p.mo.tptime - TICRATE*5)
					
					local tt = p.mo.tptime - TICRATE*7
					
					if tt > 0
					and tt % 3 == 0
					and tt < TICRATE
						p.mo.fadecolor = 135
						p.mo.fadestrength = $ and min(10, $+1) or 1
					elseif tt > TICRATE
					and p.mo.fadestrength
						p.mo.fadestrength = max(0, $-1)
					end
					
					if tt == TICRATE
						
						local targettp = server.questdata.arenaindex-1 +10
						--print(targettp)
						
						local tp
						-- try to find a destination!
						for m in mobjs.iterate()
							if m and m.valid and m.type == MT_PSO_TELEPORT_DEST
							and m.mtangle == targettp
								tp = m
								break
							end
						end
						
						p.awayviewtics = 0
						P_SetOrigin(p.mo, tp.x, tp.y, tp.z)
						PSO.lib.playerRoomAngleSet(p)
						p.pso.pitcoords = {p.mo.x, p.mo.y, p.mo.z, p.mo.angle}
						p.pso.bckuppitcoords = {p.mo.x, p.mo.y, p.mo.z, p.mo.angle}
						
						-- sick and tired of this lmao.
						if p == firstaccept
							server.keycheckpoint = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
							server.keycheckpoint.state = S_INVISIBLE
							server.keycheckpoint.tics = -1
							server.defaultspawnpoint = {server.keycheckpoint.x, server.keycheckpoint.y, server.keycheckpoint.z, server.keycheckpoint.angle}
						end
						
						p.powers[pw_nocontrol] = 0
						
						
						-- this is only used for gyrrey glardia but issss necessary nonetheless, haha
						if tp.options & 1
							PSO.lib.playerActivateAIS(p, true)
						end

						if server.questdata	-- happens during testing
							
							local qinfo = PSO.lib.questInfo()
							server.questdata.arenatimer = qinfo.arenatimers[server.questdata.arenaindex]
						
							server.questdata.noreturn = true	-- no going back now~
							server.questdata.arenatimer_on = true
							
							p.pso.quest.timer_on = true	-- start timer if not done yet
						end
						
						if p == firstaccept
							local mus = ((server.questdata.arenaindex-1) % 4) +1
							S_ChangeMusic("BOSSR"..mus, true)
						end
					end
					--print(tt)
					
					
					if tt > TICRATE + 11
						
						if p == firstaccept
							server.questdata.arenaindex = p.mo.currentindex+1
						end
						
						p.mo.tptime = nil
						PSO.lib.closeMenu(p)
						return
					end
				end
			else
				p.mo.tptime = 0
			end
			return true	-- can't do shit!
		end
		
		if input(p, IPT_CONFIRM) == 1
			
			if p.pso.menu.choice == 1
				S_StartSound(nil, sfx_mconf, p)
				p.mo.tpok = true
			else				
				S_StartSound(nil, sfx_mconf, p)
				PSO.lib.closeMenu(p)
			end
		end
	end,
	
	choices = choices,
}