-- exchange stuff

-- exch constants...

local azul_exchange = {

	name = "Azul Series Exchange",
	level = 3,	-- level at which exchange is unlocked...
		
	contents = {
			
		/*
		{
			what you get from the trade
			{item, [qty], [display]},		* if the item is a weapon/armor, it has to be generated directly, and qty cannot be used.
			* display overwrites the item name shown to the specified string.
				
			what you need for the trade
			{
				{item1, [qty], [display]},	* use ref. for weapon/armor, qty is grind level requirement.
				{item2, [qty], [display]},
				{...}
					
				for requirements where multiple items can be used for 1 requirement, set it up like so
				{-1, {{item1, qty...}, {item2, qty}, {item3, qty}, [...]}}
				this makes it so either item1, item2... or [itemn] can be used to fulfill the requirement.
				
				for a specific rarity of items...
				{rarity, IT_type}
				
			}
		}
		*/
		
		-- weapon -> stone exchange
		{
			-- what you receive
			target = {"azul core"},
				
			-- what you need...
			requirements = {
				{-1, 
					{
						{"azul ledge"},
						{"azul cutter"},
						{"azul lance"},
						{"azul bullet"},
						{"azul burst"},
						{"azul proud"},
						{"azul staff"},
						{"azul cutlass"},
						{"azul brave"},
						{"azul baguette"},
					},
					"Azul arms",
				}
			},
		},
			
		-- stone -> weapon exchange
		{
			target = {PSO.lib.makeItem("azul ledge", {ELEM_ICE, 20})},
			requirements = {{"azul core", 2}},
		},

		{
			target = {PSO.lib.makeItem("azul cutter", {ELEM_ICE, 20})},
			requirements = {{"azul core", 2}},
		},		

		{
			target = {PSO.lib.makeItem("azul lance", {ELEM_ICE, 20})},
			requirements = {{"azul core", 2}},
		},

		{
			target = {PSO.lib.makeItem("azul bullet", {ELEM_ICE, 20})},
			requirements = {{"azul core", 2}},
		},

		{
			target = {PSO.lib.makeItem("azul burst", {ELEM_ICE, 20})},
			requirements = {{"azul core", 2}},
		},

		{
			target = {PSO.lib.makeItem("azul proud", {ELEM_ICE, 20})},
			requirements = {{"azul core", 2}},
		},

		{
			target = {PSO.lib.makeItem("azul staff", {ELEM_ICE, 20})},
			requirements = {{"azul core", 2}},
		},

		{
			target = {PSO.lib.makeItem("azul cutlass", {ELEM_ICE, 20})},
			requirements = {{"azul core", 2}},
		},

		{
			target = {PSO.lib.makeItem("azul brave", {ELEM_ICE, 20})},
			requirements = {{"azul core", 2}},
		},

		{
			target = {PSO.lib.makeItem("azul baguette", {ELEM_ICE, 20})},
			requirements = {{"azul core", 2}},
		},
		
	},
}

local exiled_exchange = {

	name = "Exiled Series Exchange",
	level = 8,	-- level at which exchange is unlocked...
		
	contents = {		
		-- weapon -> stone exchange
		{
			-- what you receive
			target = {"exiled remnants"},
				
			-- what you need...
			requirements = {
				{-1, 
					{
						{"exiled ledge"},
						{"exiled cutter"},
						{"exiled lance"},
						{"exiled bullet"},
						{"exiled burst"},
						{"exiled proud"},
						{"exiled staff"},
						{"exiled cutlass"},
						{"exiled brave"},
						{"exiled baguette"},
					},
					"Exiled arms",
				}
			},
		},
			
		-- stone -> weapon exchange
		{
			target = {PSO.lib.makeItem("exiled ledge", {ELEM_EARTH, 20})},
			requirements = {{"exiled remnants", 2}},
		},

		{
			target = {PSO.lib.makeItem("exiled cutter", {ELEM_EARTH, 20})},
			requirements = {{"exiled remnants", 2}},
		},		

		{
			target = {PSO.lib.makeItem("exiled lance", {ELEM_EARTH, 20})},
			requirements = {{"exiled remnants", 2}},
		},

		{
			target = {PSO.lib.makeItem("exiled bullet", {ELEM_EARTH, 20})},
			requirements = {{"exiled remnants", 2}},
		},

		{
			target = {PSO.lib.makeItem("exiled burst", {ELEM_EARTH, 20})},
			requirements = {{"exiled remnants", 2}},
		},

		{
			target = {PSO.lib.makeItem("exiled proud", {ELEM_EARTH, 20})},
			requirements = {{"exiled remnants", 2}},
		},

		{
			target = {PSO.lib.makeItem("exiled staff", {ELEM_EARTH, 20})},
			requirements = {{"exiled remnants", 2}},
		},

		{
			target = {PSO.lib.makeItem("exiled cutlass", {ELEM_EARTH, 20})},
			requirements = {{"exiled remnants", 2}},
		},

		{
			target = {PSO.lib.makeItem("exiled brave", {ELEM_EARTH, 20})},
			requirements = {{"exiled remnants", 2}},
		},

		{
			target = {PSO.lib.makeItem("exiled baguette", {ELEM_EARTH, 20})},
			requirements = {{"exiled remnants", 2}},
		},
		
	},
}


local boreal_exchange = {

	name = "Boreal Series Exchange",
	level = 15,	-- level at which exchange is unlocked...
		
	contents = {		
		-- weapon -> stone exchange
		{
			-- what you receive
			target = {"boreal diamond"},
				
			-- what you need...
			requirements = {
				{-1, 
					{
						{"boreal ledge"},
						{"boreal cutter"},
						{"boreal lance"},
						{"boreal bullet"},
						{"boreal burst"},
						{"boreal proud"},
						{"boreal staff"},
						{"boreal cutlass"},
						{"boreal brave"},
						{"boreal baguette"},
					},
					"Boreal arms",
				}
			},
		},
			
		-- stone -> weapon exchange
		{
			target = {PSO.lib.makeItem("boreal ledge", {ELEM_ICE, 20})},
			requirements = {{"boreal diamond", 2}},
		},

		{
			target = {PSO.lib.makeItem("boreal cutter", {ELEM_ICE, 20})},
			requirements = {{"boreal diamond", 2}},
		},		

		{
			target = {PSO.lib.makeItem("boreal lance", {ELEM_ICE, 20})},
			requirements = {{"boreal diamond", 2}},
		},

		{
			target = {PSO.lib.makeItem("boreal bullet", {ELEM_ICE, 20})},
			requirements = {{"boreal diamond", 2}},
		},

		{
			target = {PSO.lib.makeItem("boreal burst", {ELEM_ICE, 20})},
			requirements = {{"boreal diamond", 2}},
		},

		{
			target = {PSO.lib.makeItem("boreal proud", {ELEM_ICE, 20})},
			requirements = {{"boreal diamond", 2}},
		},

		{
			target = {PSO.lib.makeItem("boreal staff", {ELEM_ICE, 20})},
			requirements = {{"boreal diamond", 2}},
		},

		{
			target = {PSO.lib.makeItem("boreal cutlass", {ELEM_ICE, 20})},
			requirements = {{"boreal diamond", 2}},
		},

		{
			target = {PSO.lib.makeItem("boreal brave", {ELEM_ICE, 20})},
			requirements = {{"boreal diamond", 2}},
		},

		{
			target = {PSO.lib.makeItem("boreal baguette", {ELEM_ICE, 20})},
			requirements = {{"boreal diamond", 2}},
		},
		
	},
}

local fusiel_exchange = {

	name = "Fusiel Series Creation",
	level = 35,	-- level at which exchange is unlocked...
		
	contents = {		
			
		-- stone -> weapon exchange
		{
			target = {PSO.lib.makeItem("fusiel ledge", {ELEM_ICE, 50})},
			requirements = {{"azul ledge"}, {"exiled ledge"}, {"boreal ledge"}, {"black matter"}},
		},

		{
			target = {PSO.lib.makeItem("fusiel cutter", {ELEM_ICE, 50})},
			requirements = {{"azul cutter"}, {"exiled cutter"}, {"boreal cutter"}, {"black matter"}},
		},	

		{
			target = {PSO.lib.makeItem("fusiel lance", {ELEM_ICE, 50})},
			requirements = {{"azul lance"}, {"exiled lance"}, {"boreal lance"}, {"black matter"}},
		},

		{
			target = {PSO.lib.makeItem("fusiel bullet", {ELEM_ICE, 50})},
			requirements = {{"azul bullet"}, {"exiled bullet"}, {"boreal bullet"}, {"black matter"}},
		},

		{
			target = {PSO.lib.makeItem("fusiel burst", {ELEM_ICE, 50})},
			requirements = {{"azul burst"}, {"exiled burst"}, {"boreal burst"}, {"black matter"}},
		},

		{
			target = {PSO.lib.makeItem("fusiel proud", {ELEM_ICE, 50})},
			requirements = {{"azul proud"}, {"exiled proud"}, {"boreal proud"}, {"black matter"}},
		},

		{
			target = {PSO.lib.makeItem("fusiel staff", {ELEM_ICE, 50})},
			requirements = {{"azul staff"}, {"exiled staff"}, {"boreal staff"}, {"black matter"}},
		},

		{
			target = {PSO.lib.makeItem("fusiel cutlass", {ELEM_ICE, 50})},
			requirements = {{"azul cutlass"}, {"exiled cutlass"}, {"boreal cutlass"}, {"black matter"}},
		},

		{
			target = {PSO.lib.makeItem("fusiel brave", {ELEM_ICE, 50})},
			requirements = {{"azul brave"}, {"exiled brave"}, {"boreal brave"}, {"black matter"}},
		},

		{
			target = {PSO.lib.makeItem("fusiel baguette", {ELEM_ICE, 50})},
			requirements = {{"azul baguette"}, {"exiled baguette"}, {"boreal baguette"}, {"black matter"}},
		},
		
	},
}

local resurgent_exchange = {

	name = "Resurgent Series Exchange",
	level = 25,	-- level at which exchange is unlocked...
		
	contents = {		
		-- weapon -> stone exchange
		{
			-- what you receive
			target = {"resurgent cell"},
				
			-- what you need...
			requirements = {
				{-1, 
					{
						{"resurgent ledge"},
						{"resurgent cutter"},
						{"resurgent lance"},
						{"resurgent bullet"},
						{"resurgent burst"},
						{"resurgent proud"},
						{"resurgent staff"},
						{"resurgent cutlass"},
						{"resurgent brave"},
						{"resurgent baguette"},
					},
					"Resurgent arms",
				}
			},
		},
			
		-- stone -> weapon exchange
		{
			target = {PSO.lib.makeItem("resurgent ledge", {ELEM_FIRE, 40})},
			requirements = {{"resurgent cell", 2}},
		},

		{
			target = {PSO.lib.makeItem("resurgent cutter", {ELEM_FIRE, 40})},
			requirements = {{"resurgent cell", 2}},
		},		

		{
			target = {PSO.lib.makeItem("resurgent lance", {ELEM_FIRE, 40})},
			requirements = {{"resurgent cell", 2}},
		},

		{
			target = {PSO.lib.makeItem("resurgent bullet", {ELEM_FIRE, 40})},
			requirements = {{"resurgent cell", 2}},
		},

		{
			target = {PSO.lib.makeItem("resurgent burst", {ELEM_FIRE, 40})},
			requirements = {{"resurgent cell", 2}},
		},

		{
			target = {PSO.lib.makeItem("resurgent proud", {ELEM_FIRE, 40})},
			requirements = {{"resurgent cell", 2}},
		},

		{
			target = {PSO.lib.makeItem("resurgent staff", {ELEM_FIRE, 40})},
			requirements = {{"resurgent cell", 2}},
		},

		{
			target = {PSO.lib.makeItem("resurgent cutlass", {ELEM_FIRE, 40})},
			requirements = {{"resurgent cell", 2}},
		},

		{
			target = {PSO.lib.makeItem("resurgent brave", {ELEM_FIRE, 40})},
			requirements = {{"resurgent cell", 2}},
		},

		{
			target = {PSO.lib.makeItem("resurgent baguette", {ELEM_FIRE, 40})},
			requirements = {{"resurgent cell", 2}},
		},
		
	},
}

local prototype_exchange = {

	name = "Prototype Weapons Exchange",
	level = 34,	-- level at which exchange is unlocked...
		
	contents = {		
		-- weapon -> stone exchange
		{
			-- what you receive
			target = {"prototype chip"},
				
			-- what you need...
			requirements = {
				{-1, 
					{
						{"sword proto 1"},
						{"sword proto 2"},
						{"sword proto 3"},
						{"doublesaber proto 1"},
						{"doublesaber proto 2"},
						{"doublesaber proto 3"},
						{"spear proto 1"},
						{"spear proto 2"},
						{"spear proto 3"},
						{"saber proto 1"},
						{"saber proto 2"},
						{"saber proto 3"},
						{"rifle proto 1"},
						{"rifle proto 2"},
						{"rifle proto 3"},
						{"shotgun proto 1"},
						{"shotgun proto 2"},
						{"shotgun proto 3"},
						{"launcher proto 1"},
						{"launcher proto 2"},
						{"launcher proto 3"},
						{"handgun proto 1"},
						{"handgun proto 2"},
						{"handgun proto 3"},
						{"rod proto 1"},
						{"rod proto 2"},
						{"rod proto 3"},
						{"wand proto 1"},
						{"wand proto 2"},
						{"wand proto 3"},
					},
					"Proto 001~003",
				}
			},
		},
			
		-- stone -> weapon exchange
		{
			target = {PSO.lib.makeItem("sword proto 1", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("sword proto 2", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("sword proto 3", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("sword proto 4", {ELEM_ELEC, 50})},
			requirements = {{"sword proto 1"}, {"sword proto 2"}, {"sword proto 3"}},
		},
		{
			target = {PSO.lib.makeItem("sword proto 5", {ELEM_ELEC, 50})},
			requirements = {{"sword proto 1"}, {"sword proto 2"}, {"sword proto 3"}},
		},

		{
			target = {PSO.lib.makeItem("doublesaber proto 1", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("doublesaber proto 2", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("doublesaber proto 3", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("doublesaber proto 4", {ELEM_ELEC, 50})},
			requirements = {{"doublesaber proto 1"}, {"doublesaber proto 2"}, {"doublesaber proto 3"}},
		},
		{
			target = {PSO.lib.makeItem("doublesaber proto 5", {ELEM_ELEC, 50})},
			requirements = {{"doublesaber proto 1"}, {"doublesaber proto 2"}, {"doublesaber proto 3"}},
		},

		{
			target = {PSO.lib.makeItem("spear proto 1", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},		
		{
			target = {PSO.lib.makeItem("spear proto 2", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},	
		{
			target = {PSO.lib.makeItem("spear proto 3", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("spear proto 4", {ELEM_ELEC, 50})},
			requirements = {{"spear proto 1"}, {"spear proto 2"}, {"spear proto 3"}},
		},		
		{
			target = {PSO.lib.makeItem("spear proto 5", {ELEM_ELEC, 50})},
			requirements = {{"spear proto 1"}, {"spear proto 2"}, {"spear proto 3"}},
		},	


		{
			target = {PSO.lib.makeItem("rifle proto 1", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},	
		{
			target = {PSO.lib.makeItem("rifle proto 2", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},	
		{
			target = {PSO.lib.makeItem("rifle proto 3", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},	
		{
			target = {PSO.lib.makeItem("rifle proto 4", {ELEM_ELEC, 50})},
			requirements = {{"rifle proto 1"}, {"rifle proto 2"}, {"rifle proto 3"}},
		},		
		{
			target = {PSO.lib.makeItem("rifle proto 5", {ELEM_ELEC, 50})},
			requirements = {{"rifle proto 1"}, {"rifle proto 2"}, {"rifle proto 3"}},
		},	

		{
			target = {PSO.lib.makeItem("shotgun proto 1", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},			
		{
			target = {PSO.lib.makeItem("shotgun proto 2", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("shotgun proto 3", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("shotgun proto 4", {ELEM_ELEC, 50})},
			requirements = {{"shotgun proto 1"}, {"shotgun proto 2"}, {"shotgun proto 3"}},
		},			
		{
			target = {PSO.lib.makeItem("shotgun proto 5", {ELEM_ELEC, 50})},
			requirements = {{"shotgun proto 1"}, {"shotgun proto 2"}, {"shotgun proto 3"}},
		},		


		{
			target = {PSO.lib.makeItem("launcher proto 1", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},	
		{
			target = {PSO.lib.makeItem("launcher proto 2", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("launcher proto 3", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("launcher proto 4", {ELEM_ELEC, 50})},
			requirements = {{"launcher proto 1"}, {"launcher proto 2"}, {"launcher proto 3"}},
		},
		{
			target = {PSO.lib.makeItem("launcher proto 5", {ELEM_ELEC, 50})},
			requirements = {{"launcher proto 1"}, {"launcher proto 2"}, {"launcher proto 3"}},
		},


		{
			target = {PSO.lib.makeItem("rod proto 1", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},	
		{
			target = {PSO.lib.makeItem("rod proto 2", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("rod proto 3", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("rod proto 4", {ELEM_ELEC, 50})},
			requirements = {{"rod proto 1"}, {"rod proto 2"}, {"rod proto 3"}},
		},
		{
			target = {PSO.lib.makeItem("rod proto 5", {ELEM_ELEC, 50})},
			requirements = {{"rod proto 1"}, {"rod proto 2"}, {"rod proto 3"}},
		},

		{
			target = {PSO.lib.makeItem("saber proto 1", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},	
		{
			target = {PSO.lib.makeItem("saber proto 2", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},	
		{
			target = {PSO.lib.makeItem("saber proto 3", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},			
		{
			target = {PSO.lib.makeItem("saber proto 4", {ELEM_ELEC, 50})},
			requirements = {{"saber proto 1"}, {"saber proto 2"}, {"saber proto 3"}},
		},
		{
			target = {PSO.lib.makeItem("saber proto 5", {ELEM_ELEC, 50})},
			requirements = {{"saber proto 1"}, {"saber proto 2"}, {"saber proto 3"}},
		},


		{
			target = {PSO.lib.makeItem("handgun proto 1", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("handgun proto 2", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("handgun proto 3", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},		
		{
			target = {PSO.lib.makeItem("handgun proto 4", {ELEM_ELEC, 50})},
			requirements = {{"handgun proto 1"}, {"handgun proto 2"}, {"handgun proto 3"}},
		},
		{
			target = {PSO.lib.makeItem("handgun proto 5", {ELEM_ELEC, 50})},
			requirements = {{"handgun proto 1"}, {"handgun proto 2"}, {"handgun proto 3"}},
		},


		{
			target = {PSO.lib.makeItem("wand proto 1", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("wand proto 2", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("wand proto 3", {ELEM_ELEC, 50})},
			requirements = {{"prototype chip", 2}},
		},
		{
			target = {PSO.lib.makeItem("wand proto 4", {ELEM_ELEC, 50})},
			requirements = {{"wand proto 1"}, {"wand proto 2"}, {"wand proto 3"}},
		},
		{
			target = {PSO.lib.makeItem("wand proto 5", {ELEM_ELEC, 50})},
			requirements = {{"wand proto 1"}, {"wand proto 2"}, {"wand proto 3"}},
		},

	},
}

local gyras_exchange = {

	name = "Gyras Series Exchange",
	level = 40,	-- level at which exchange is unlocked...
		
	contents = {		
		-- weapon -> stone exchange
		{
			-- what you receive
			target = {"light fragment"},
				
			-- what you need...
			requirements = {
				{-1, 
					{
						{"gyras ledge"},
						{"gyras cutter"},
						{"gyras lance"},
						{"gyras bullet"},
						{"gyras burst"},
						{"gyras proud"},
						{"gyras staff"},
						{"gyras cutlass"},
						{"gyras brave"},
						{"gyras baguette"},
					},
					"Gyras arms",
				}
			},
		},
			
		-- stone -> weapon exchange
		{
			target = {PSO.lib.makeItem("gyras ledge", {ELEM_LIGHT, 50})},
			requirements = {{"light fragment", 2}},
		},

		{
			target = {PSO.lib.makeItem("gyras cutter", {ELEM_LIGHT, 50})},
			requirements = {{"light fragment", 2}},
		},		

		{
			target = {PSO.lib.makeItem("gyras lance", {ELEM_LIGHT, 50})},
			requirements = {{"light fragment", 2}},
		},

		{
			target = {PSO.lib.makeItem("gyras bullet", {ELEM_LIGHT, 50})},
			requirements = {{"light fragment", 2}},
		},

		{
			target = {PSO.lib.makeItem("gyras burst", {ELEM_LIGHT, 50})},
			requirements = {{"light fragment", 2}},
		},

		{
			target = {PSO.lib.makeItem("gyras proud", {ELEM_LIGHT, 50})},
			requirements = {{"light fragment", 2}},
		},

		{
			target = {PSO.lib.makeItem("gyras staff", {ELEM_LIGHT, 50})},
			requirements = {{"light fragment", 2}},
		},

		{
			target = {PSO.lib.makeItem("gyras cutlass", {ELEM_LIGHT, 50})},
			requirements = {{"light fragment", 2}},
		},

		{
			target = {PSO.lib.makeItem("gyras brave", {ELEM_LIGHT, 50})},
			requirements = {{"light fragment", 2}},
		},

		{
			target = {PSO.lib.makeItem("gyras baguette", {ELEM_LIGHT, 50})},
			requirements = {{"light fragment", 2}},
		},
		
	},
}

local resplendant_exchange = {

	name = "Resplendant Series Creation",
	level = 55,	-- level at which exchange is unlocked...
		
	contents = {		
			
		-- stone -> weapon exchange
		{
			target = {PSO.lib.makeItem("resplendant ledge", {ELEM_LIGHT, 50})},
			requirements = {{"resurgent ledge"}, {"sword proto 5"}, {"gyras ledge"}, {"chaos shard"}},
		},

		{
			target = {PSO.lib.makeItem("resplendant cutter", {ELEM_LIGHT, 50})},
			requirements = {{"resurgent cutter"}, {"doublesaber proto 5"}, {"gyras cutter"}, {"chaos shard"}},
		},

		{
			target = {PSO.lib.makeItem("resplendant lance", {ELEM_LIGHT, 50})},
			requirements = {{"resurgent lance"}, {"spear proto 5"}, {"gyras lance"}, {"chaos shard"}},
		},

		{
			target = {PSO.lib.makeItem("resplendant bullet", {ELEM_LIGHT, 50})},
			requirements = {{"resurgent bullet"}, {"rifle proto 5"}, {"gyras bullet"}, {"chaos shard"}},
		},

		{
			target = {PSO.lib.makeItem("resplendant burst", {ELEM_LIGHT, 50})},
			requirements = {{"resurgent burst"}, {"shotgun proto 5"}, {"gyras burst"}, {"chaos shard"}},
		},

		{
			target = {PSO.lib.makeItem("resplendant proud", {ELEM_LIGHT, 50})},
			requirements = {{"resurgent proud"}, {"launcher proto 5"}, {"gyras proud"}, {"chaos shard"}},
		},

		{
			target = {PSO.lib.makeItem("resplendant staff", {ELEM_LIGHT, 50})},
			requirements = {{"resurgent staff"}, {"rod proto 5"}, {"gyras staff"}, {"chaos shard"}},
		},

		{
			target = {PSO.lib.makeItem("resplendant cutlass", {ELEM_LIGHT, 50})},
			requirements = {{"resurgent cutlass"}, {"saber proto 5"}, {"gyras cutlass"}, {"chaos shard"}},
		},

		{
			target = {PSO.lib.makeItem("resplendant brave", {ELEM_LIGHT, 50})},
			requirements = {{"resurgent brave"}, {"handgun proto 5"}, {"gyras brave"}, {"chaos shard"}},
		},

		{
			target = {PSO.lib.makeItem("resplendant baguette", {ELEM_LIGHT, 50})},
			requirements = {{"resurgent baguette"}, {"wand proto 5"}, {"gyras baguette"}, {"chaos shard"}},
		},
	},
}

local lumiel_exchange = {

	name = "Lumiel Series Creation",
	level = 80,	-- level at which exchange is unlocked...
		
	contents = {		
			

		{
			target = {PSO.lib.makeItem("lumiel ledge", {ELEM_LIGHT, 50})},
			requirements = {{"fusiel ledge"}, {"resplendant ledge"}, {"excube", 5}, {"chaos cluster"}},
		},

		{
			target = {PSO.lib.makeItem("lumiel cutter", {ELEM_LIGHT, 50})},
			requirements = {{"fusiel cutter"}, {"resplendant cutter"}, {"excube", 5}, {"chaos cluster"}},
		},

		{
			target = {PSO.lib.makeItem("lumiel lance", {ELEM_LIGHT, 50})},
			requirements = {{"fusiel lance"}, {"resplendant lance"}, {"excube", 5}, {"chaos cluster"}},
		},

		{
			target = {PSO.lib.makeItem("lumiel bullet", {ELEM_LIGHT, 50})},
			requirements = {{"fusiel bullet"}, {"resplendant bullet"}, {"excube", 5}, {"chaos cluster"}},
		},

		{
			target = {PSO.lib.makeItem("lumiel burst", {ELEM_LIGHT, 50})},
			requirements = {{"fusiel burst"}, {"resplendant burst"}, {"excube", 5}, {"chaos cluster"}},
		},

		{
			target = {PSO.lib.makeItem("lumiel proud", {ELEM_LIGHT, 50})},
			requirements = {{"fusiel proud"}, {"resplendant proud"}, {"excube", 5}, {"chaos cluster"}},
		},

		{
			target = {PSO.lib.makeItem("lumiel staff", {ELEM_LIGHT, 50})},
			requirements = {{"fusiel staff"}, {"resplendant staff"}, {"excube", 5}, {"chaos cluster"}},
		},

		{
			target = {PSO.lib.makeItem("lumiel cutlass", {ELEM_LIGHT, 50})},
			requirements = {{"fusiel cutlass"}, {"resplendant cutlass"}, {"excube", 5}, {"chaos cluster"}},
		},

		{
			target = {PSO.lib.makeItem("lumiel brave", {ELEM_LIGHT, 50})},
			requirements = {{"fusiel brave"}, {"resplendant brave"}, {"excube", 5}, {"chaos cluster"}},
		},

		{
			target = {PSO.lib.makeItem("lumiel baguette", {ELEM_LIGHT, 50})},
			requirements = {{"fusiel baguette"}, {"resplendant baguette"}, {"excube", 5}, {"chaos cluster"}},
		},

	},
}

local crimson_badge_exchange = {
	name = "Crimson Medal Exchange",
	level = 55,	-- level at which exchange is unlocked...
		
	contents = {
		
		-- swords
		{
			target = {PSO.lib.makeItem("orakl sword", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},

		{
			target = {PSO.lib.makeItem("vulture basher", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},
	
		{
			target = {PSO.lib.makeItem("seal case", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("steel hearts", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("zanba", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},

		{
			target = {PSO.lib.makeItem("last survivor", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},
		
		-- dsaber
		{
			target = {PSO.lib.makeItem("orakl doublesaber", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},

		{
			target = {PSO.lib.makeItem("double driller", {ELEM_EARTH, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},
	
		{
			target = {PSO.lib.makeItem("girasole", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("monkey king bar", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("d. saber legacy", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},

		{
			target = {PSO.lib.makeItem("eternal heat", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},
		
		-- spear
		{
			target = {PSO.lib.makeItem("orakl partizan", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},

		{
			target = {PSO.lib.makeItem("ice lancer", {ELEM_ICE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},
	
		{
			target = {PSO.lib.makeItem("longinus", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("basilleon", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("meteor lancer", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},

		{
			target = {PSO.lib.makeItem("brionac", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},		

		-- saber
		{
			target = {PSO.lib.makeItem("orakl soaringblade", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},

		{
			target = {PSO.lib.makeItem("winginator", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},
	
		{
			target = {PSO.lib.makeItem("sarblight", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("forblight", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("grand cross", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},

		{
			target = {PSO.lib.makeItem("red saber", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},	
		
		-- rifle
		{
			target = {PSO.lib.makeItem("orakl rifle", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},

		{
			target = {PSO.lib.makeItem("sneg zapper", {ELEM_ELEC, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},
	
		{
			target = {PSO.lib.makeItem("assassin", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("full cylinder", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("strauss", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},

		{
			target = {PSO.lib.makeItem("yasminkov 3000r", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},			
		
		
		-- shotgun
		{
			target = {PSO.lib.makeItem("orakl shot", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},

		{
			target = {PSO.lib.makeItem("command shot", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},
	
		{
			target = {PSO.lib.makeItem("heimdall", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("wide smack", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("barett", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},

		{
			target = {PSO.lib.makeItem("crush bullet", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},
			

		-- launcher
		{
			target = {PSO.lib.makeItem("orakl launcher", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},

		{
			target = {PSO.lib.makeItem("hatted cannon", {ELEM_ICE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},
	
		{
			target = {PSO.lib.makeItem("saint kilda", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("photon launcher", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("charge howzer", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},

		{
			target = {PSO.lib.makeItem("gur bazga", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},

		--- handgun
		{
			target = {PSO.lib.makeItem("orakl orphan", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},

		{
			target = {PSO.lib.makeItem("poss shooter", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},
	
		{
			target = {PSO.lib.makeItem("sarcueid", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("yasminkov 2000h", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("varista", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},

		{
			target = {PSO.lib.makeItem("bravace", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},

		--- rod
		{
			target = {PSO.lib.makeItem("orakl rod", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},

		{
			target = {PSO.lib.makeItem("ice stabberrod", {ELEM_ICE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},
	
		{
			target = {PSO.lib.makeItem("clarita visas", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("red processor", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("battle verge", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},

		{
			target = {PSO.lib.makeItem("brave hammer", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},			

		-- wand
		{
			target = {PSO.lib.makeItem("orakl wand", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},

		{
			target = {PSO.lib.makeItem("asterod", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},
	
		{
			target = {PSO.lib.makeItem("windmill", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("hexigraph", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("serdote", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},

		{
			target = {PSO.lib.makeItem("rose quartz", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},

		--- tcsm
		{
			target = {PSO.lib.makeItem("orakl tcsm", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},

		{
			target = {PSO.lib.makeItem("tcsm_crawla3", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 15}},
		},

		{
			target = {PSO.lib.makeItem("tcsm_crawla4", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 35}},
		},

		{
			target = {PSO.lib.makeItem("tcsm_omochao", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 75}},
		},

		{
			target = {PSO.lib.makeItem("makel frame", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 50}},
		},

		{
			target = {PSO.lib.makeItem("crimson frame", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 50}},
		},

		{
			target = {PSO.lib.makeItem("daybreak frame", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 99}},
		},

		{
			target = {PSO.lib.makeItem("fulgurant frame", {ELEM_FIRE, 30})},
			requirements = {{"weaponsbadge_1", 99}},
		},
	},
}

local arena_exchange = {
	name = "Arena Badge Exchange",
	level = 55,	-- level at which exchange is unlocked...
		
	contents = {
		
		-- swords
		{
			target = {"element+5"},
			requirements = {{"arenabadge_1", 3}},
		},

		{
			target = {"element+10"},
			requirements = {{"arenabadge_1", 5}},
		},

		{
			target = {"element1"},
			requirements = {{"arenabadge_1", 15}},
		},

		{
			target = {"element2"},
			requirements = {{"arenabadge_1", 15}},
		},

		{
			target = {"element3"},
			requirements = {{"arenabadge_1", 15}},
		},

		{
			target = {"element4"},
			requirements = {{"arenabadge_1", 15}},
		},

		{
			target = {"element5"},
			requirements = {{"arenabadge_1", 15}},
		},

		{
			target = {"element6"},
			requirements = {{"arenabadge_1", 15}},
		},

		{
			target = {"element0"},
			requirements = {{"arenabadge_1", 15}},
		},
		
	}
}

local excube_exchange = {
	name = "EX-Cube Exchange",
	level = 80,	-- level at which exchange is unlocked...
		
	contents = {

		{
			-- what you receive
			target = {"excube"},
				
			-- what you need...
			requirements = {
				{10, IT_WEAPON, "10* weapon"}
			},
		},
		
		{
			target = {"element+30"},
			requirements = {{"excube", 1}},
		},

		{
			target = {"extend code"},
			requirements = {{"excube", 3}},
		},
		
		{
			target = {PSO.lib.makeItem("chainsawd", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},		

		{
			target = {PSO.lib.makeItem("dragon slayer", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("double cannon", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("vivienne", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("soul eater", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("vjaya", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("firearms", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("frozen shooter", {ELEM_ICE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("spread needle", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("final impact", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("inferno bazooka", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("sspm launcher", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("siren hammer", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("demonic fork", {ELEM_DARK, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("axeon", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("elysion", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("ruby bullet", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("pandora extreme", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("rykros staff", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},

		{
			target = {PSO.lib.makeItem("evil curst", {ELEM_FIRE, 10})},
			requirements = {{"excube", 5}},
		},
		
	}
}

local anomalous_weapons = {
	PSO.lib.makeItem("xenoblade"),
	PSO.lib.makeItem("hope glaive"),
	PSO.lib.makeItem("gungnir"),
	PSO.lib.makeItem("ms. confille"),
	PSO.lib.makeItem("fortress panic"),
	PSO.lib.makeItem("fortress crocket"),
	PSO.lib.makeItem("tryshta"),
	PSO.lib.makeItem("fortress gardener"),
	PSO.lib.makeItem("evoker"),
	PSO.lib.makeItem("crimson demon staff"),
	PSO.lib.makeItem("tcsm_angel"),
}

for i = 1, #anomalous_weapons
	anomalous_weapons[i].unidentified = true
end

local anomaly_exchange = {
	name = "Anomalous Arms Exchange",
	level = 74,	-- level at which exchange is unlocked...
		
	contents = {
		
		{
			target = {anomalous_weapons[1]},
			requirements = {{"abnormal shard", 1}},
		},	

		{
			target = {anomalous_weapons[2]},
			requirements = {{"abnormal shard", 1}},
		},	

		{
			target = {anomalous_weapons[3]},
			requirements = {{"abnormal shard", 1}},
		},	

		{
			target = {anomalous_weapons[4]},
			requirements = {{"abnormal shard", 1}},
		},			

		{
			target = {anomalous_weapons[5]},
			requirements = {{"abnormal shard", 1}},
		},	

		{
			target = {anomalous_weapons[6]},
			requirements = {{"abnormal shard", 1}},
		},			

		{
			target = {anomalous_weapons[7]},
			requirements = {{"abnormal shard", 1}},
		},	

		{
			target = {anomalous_weapons[8]},
			requirements = {{"abnormal shard", 1}},
		},	
		
		{
			target = {anomalous_weapons[9]},
			requirements = {{"abnormal shard", 1}},
		},	
		
		{
			target = {anomalous_weapons[10]},
			requirements = {{"abnormal shard", 1}},
		},	

		{
			target = {anomalous_weapons[11]},
			requirements = {{"abnormal shard", 1}},
		},			
	},
}

PSO.info.exchanges = {
	
	{
		name = "Field drop exchanges",
		exchanges = {
	
			azul_exchange,
			exiled_exchange,
			boreal_exchange,
			fusiel_exchange,
			resurgent_exchange,
			prototype_exchange,
			gyras_exchange,
			resplendant_exchange,
			lumiel_exchange,
		},
	},
	
	{
		name = "Currency exchanges",
		exchanges = {
			crimson_badge_exchange,
			arena_exchange,
			excube_exchange,
		},
	},
	
	{
		name = "Other exchanges",
		exchanges = {
			anomaly_exchange,
		},
	},
}


-- now the menu itself

local choices = {
		"Exchange Items",
		"Client Orders",
		"Leave",
}

local w = 140
local h = 50
local function drawCafeMenu(v, p, c, choice, timer)
	
	local x = 160-(w/2)
	local y = 100-(h/2)
	
	v.drawFill(x, y, w, h, 253)
	
	v.drawString(160, y+4, "CAFE", V_YELLOWMAP, "center")
	
	local cy = y+16
	for i = 1, #choices
		v.drawString(160, cy, (i == choice and "\x82"..">" or "")..choices[i], i==2 and V_50TRANS or 0, "center")
		cy = $+10
	end
end

PSO.info.menus["cafe"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawCafeMenu(v, p, c, choice, timer)
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if p.pso.menu.choice < 3
		and input(p, IPT_CONFIRM) == 1
			
			-- not yet...
			if p.pso.menu.choice == 2
				S_StartSound(nil, sfx_mnot, p)
				return true
			end
			
			PSO.lib.changeMenu(p, "cafe_exchange_1", true, true)
			S_StartSound(nil, sfx_mconf, p)
			return true
			
		elseif input(p, IPT_BACK) == 1
		or (input(p, IPT_CONFIRM) and p.pso.menu.choice == 3)
			S_StartSound(nil, sfx_mback, p)
			PSO.lib.closeMenu(p)
		end
	end,
	
	choices = choices,
}

-- menu that lists all the available exchanges.
PSO.info.menus["cafe_exchange_1"] = {
	
	-- build the list of exchanges
	openfunc =	function(p)
		local c = {}
		
		for i = 1, #PSO.info.exchanges
			
			local e = PSO.info.exchanges[i]
			c[#c+1] = e.name
		end
		
		c[#c+1] = "Back"
		p.pso.menu.minchoice = 1
		p.pso.menu.maxchoice = #c
		p.pso.menu.choices = c
		
		p.pso.hidehud = true
	end,
	
	hudfunc = function(v, p, c, choices, choice, timer)

		local w = 210
		local h = 90
		local x = 160-(w/2)
		local y = 100-(h/2)
		local choices = p.pso.menu.choices
		
		v.drawFill(x, y, w, h, 253)
		
		v.drawString(160, y+4, "EXCHANGE ITEMS", V_YELLOWMAP, "center")
		
		local cy = y+16
		for i = 1+p.pso.menu.scroll, min(7 + p.pso.menu.scroll, #choices)
			v.drawString(160, cy, (i == choice and "\x82"..">" or "")..choices[i], V_ALLOWLOWERCASE, "center")
			cy = $+10
		end
	end,
	
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if input(p, IPT_CONFIRM) == 1
		and p.pso.menu.choice < #p.pso.menu.choices
			p.pso.cafeexchange_category = p.pso.menu.choice
			S_StartSound(nil, sfx_mconf, p)
			PSO.lib.changeMenu(p, "cafe_exchange_2", true, true)
			return true
			
		elseif input(p, IPT_BACK) == 1
		or (input(p, IPT_CONFIRM) and p.pso.menu.choice == #p.pso.menu.choices)
			S_StartSound(nil, sfx_mback, p)
			PSO.lib.changeMenu(p, "cafe", true, true)
			p.pso.hidehud = nil
		end
	end,
	
	scroll = 7,
}

-- menu that lists all the available exchanges.
PSO.info.menus["cafe_exchange_2"] = {
	
	-- build the list of exchanges
	openfunc =	function(p)
		local c = {}
		local tt = PSO.info.exchanges[p.pso.cafeexchange_category].exchanges
		
		for i = 1, #tt
			
			local e = tt[i]
			if p.pso.level < e.level
				c[#c+1] = {"??? (Lv"..e.level..")", 0}
			else
				c[#c+1] = {e.name, 1}
			end
		end
		
		c[#c+1] = {"Back", -1}
		p.pso.menu.minchoice = 1
		p.pso.menu.maxchoice = #c
		p.pso.menu.choices = c
		
		p.pso.hidehud = true
	end,
	
	hudfunc = function(v, p, c, choices, choice, timer)

		local w = 210
		local h = 90
		local x = 160-(w/2)
		local y = 100-(h/2)
		local choices = p.pso.menu.choices
		
		v.drawFill(x, y, w, h, 253)
		
		v.drawString(160, y+4, "EXCHANGE ITEMS", V_YELLOWMAP, "center")
		
		local cy = y+16
		for i = 1+p.pso.menu.scroll, min(7 + p.pso.menu.scroll, #choices)
			v.drawString(160, cy, (i == choice and "\x82"..">" or "")..choices[i][1], (not choices[i][2] and V_50TRANS or 0)|V_ALLOWLOWERCASE, "thin-center")
			cy = $+10
		end
	end,
	
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if input(p, IPT_CONFIRM) == 1
		and p.pso.menu.choice < #p.pso.menu.choices
		
			if not p.pso.menu.choices[p.pso.menu.choice][2]
				S_StartSound(nil, sfx_mnot, p)
				return true
			else
		
				p.pso.cafeexchange = p.pso.menu.choice
				S_StartSound(nil, sfx_mconf, p)
				PSO.lib.changeMenu(p, "cafe_exchange_3", true, true)
				return true
			end
			
		elseif input(p, IPT_BACK) == 1
		or (input(p, IPT_CONFIRM) and p.pso.menu.choice == #p.pso.menu.choices)
			S_StartSound(nil, sfx_mback, p)
			PSO.lib.changeMenu(p, "cafe", true, true)
			p.pso.hidehud = nil
		end
	end,
	
	scroll = 7,
}

-- check if we have the items and where they are in our inventory.
local function exch_preCheckItems(p, exch)
	
	local res = {}
	local oks = 0
	
	for i = 1, #exch.requirements
		
		local req = exch.requirements[i]
		
		if req[1] ~= -1
			
			if type(req[1]) ~= "number"	-- normal stuff
				
				local search = PSO.lib.findItemInstancesInTable(p, req[1], "inventory")
				
				if #search
					res[i] = {}
					local count = 0
					for j = 1, #search
						res[i][j] = search[j] --invslot[2] or 1
						count = $+ (p.pso.inventory[search[j]][2] or 1)
						--print(search[j])
					end
					
					if count >= (req[2] or 1)
						oks = $+1
					end
				else
					res[i] = {0}
				end
			
			else	-- search by rarity and type.....
				
				local srare = req[1]
				local stype = req[2]
				local search = PSO.lib.findRarityTypeInTable(p, srare, stype, "inventory")

				if #search
					res[i] = {}
					for j = 1, #search
						res[i][j] = search[j]
					end
					oks = $+1
				else
					res[i] = {0}
				end
				
				
			end
		else	-- the annoying one!!!!!
			
			for j = 1, #req[2]
				local curr_req = req[2][j]
				local search = PSO.lib.findItemInstancesInTable(p, curr_req[1], "inventory")
				
				if #search
					res[i] = $ or {}
					for k = 1, #search
						table.insert(res[i], search[k])
					end
					oks = $+1
				else
					res[i] = $ or {}
				end	
			end
		end
	end
	
	return res, oks >= #exch.requirements	-- all requirements fulfilled or not.
end

-- builds the list of actual items from the list of inventory slots
local function exch_itemListFromInv(p, list)
	
	local l = {}
	for i = 1, #list
		l[#l+1] = {p.pso.inventory[list[i]][1], 1}
		--print(list[i])
	end
	
	return l
end

-- proceeds with the exchange.
-- "ilist" is the inventory slot of each requirement item.
-- does not check again if everything makes sense, it just does it.
local function exch_doExchange(p, exch, ilist)
	
	-- first, lose our items.
	
	for i = 1, #exch.requirements
		
		local req = exch.requirements[i]
		local qty = 1
		
		if req[1] ~= -1
		and req[2]
			qty = req[2]
		end
		
		-- we cannot call the regular function, instead we have to do two passes.
		local it = p.pso.inventory[ilist[i]][1]
		if it and type(it) == "table"
		and it.equipped
			if it.locked	-- woops
				S_StartSound(nil, sfx_mnot, p)
				return
			else
				PSO.lib.playerUnequipRef(p, it)
			end
		end
		
		p.pso.inventory[ilist[i]][2] = $ - qty	-- remove the item quantity
		--PSO.lib.playerLoseItem(p, ilist[i], qty)	-- 22/09: NO DO NOT DO THIS LMAO
	end
	
	-- now do an inventory pass, we can safely remove any item which has <= 0 of itself.
	-- go through the inventory in reverse
	local i = #p.pso.inventory
	while i
		
		if not p.pso.inventory[i][2] --<= 0
		or p.pso.inventory[i][2] <= 0	-- who knows.
			table.remove(p.pso.inventory, i)
		end
		i = $-1
	end
	
	-- we don't need to re-sort the inventory here, getting the new item from the exchange will take care of that for us.
	-- 10/02: turns out, we DO need to do that or shit EXPLODES
	PSO.lib.playerSortInventory(p)
	
	-- then, get our reward!
	local it = exch.target[1]
	local itinfo = PSO.lib.itemInfo(it)
	PSO.lib.addDropText(p, itinfo.rarity, PSO.lib.getItemName(it))
	
	if type(it) == "table"
		it = PSO.lib.copyTable($)
	end
	
	PSO.lib.playerGetItem(p, it, exch.target[2] or 1)
end

-- shows the items...
PSO.info.menus["cafe_exchange_3"] = {
	
	openfunc = function(p)
		
		p.pso.exchange = {}
		local exch = PSO.info.exchanges[p.pso.cafeexchange_category].exchanges[p.pso.cafeexchange]
		
		for i = 1, #exch.contents
			local it = exch.contents[i]
			
			p.pso.exchange[#p.pso.exchange+1] = {it.target[1], it.target[2] or 1}
		end
		
		p.pso.menu.choices = p.pso.exchange
		p.pso.menu.minchoice = 1
		p.pso.menu.maxchoice = #p.pso.exchange
		p.pso.exchange_prevchoice = 1
		
		p.pso.exchange_display, p.pso.exchange_ok = exch_preCheckItems(p, exch.contents[1])
		
		p.pso.exchangestate = 0	-- browsering
		p.pso.exchangestep = 0	-- used when we have to select items...
		
		p.pso.exchange_select = 0			-- ditto
		p.pso.exchange_select_scroll = 0	-- ditto
		p.pso.exchange_select_warn = 0		-- ditto
	end,
	
	runfunc = function(p)


		local input = PSO.lib.playerInputDown		
		-- final selection handler.
		if p.pso.exchange_select_warn
			
			if input(p, "up") == 1
			or input(p, "down") == 1
				p.pso.exchange_select_warn = p.pso.exchange_select_warn == 1 and 2 or 1
				S_StartSound(nil, sfx_mhvr, p)
			end
			
			if input(p, IPT_CONFIRM) == 1 and p.pso.exchange_select_warn == 2
			or input(p, IPT_BACK) == 1
				S_StartSound(nil, sfx_mback, p)
				p.pso.exchange_select_warn = 0
			
			elseif input(p, IPT_CONFIRM) == 1
				
				-- long exchange? add the item to the list of things we will exchange...
				--PSO.lib.playerUnequipRef
				if p.pso.exchange_long_inv
					p.pso.exchange_long_choices[p.pso.exchange_long] = p.pso.exchange_display[p.pso.exchange_long][p.pso.exchange_long_sel]
					
					--print("LE: "..(#p.pso.exchange_long_choices).." / "..(#p.pso.exchange_long_list))
					
					if #p.pso.exchange_long_choices >= #p.pso.exchange_long_list	-- we selected everything!
						
						-- build the ilist and do it!
						p.pso.exchange_select_ilist = {}
						local long_index = 1
						
						for i = 1, #p.pso.exchange_display
							
							if #p.pso.exchange_display[i] > 1
								p.pso.exchange_select_ilist[i] = p.pso.exchange_long_choices[long_index]
								PSO.lib.playerUnequipRef(p, p.pso.inventory[p.pso.exchange_select_ilist[i]][1])	-- ensure we unequip that reference....
								
								long_index = $+1	-- next long choice
							else
							
								p.pso.exchange_select_ilist[i] = p.pso.exchange_display[i][1]	-- we can make this safe assumption.
							end
						end
						
						-- and that's everything.....
						local exch = PSO.info.exchanges[p.pso.cafeexchange_category].exchanges[p.pso.cafeexchange]
						exch_doExchange(p, exch.contents[p.pso.menu.choice], p.pso.exchange_select_ilist)

						p.pso.exchange_long = nil
						p.pso.exchange_long_sel = nil
						p.pso.exchange_long_scroll = nil
						p.pso.exchange_long_list = nil
						p.pso.exchange_long_inv = nil
						p.pso.exchange_long_choices = nil
						
						S_StartSound(nil, sfx_chchng, p)
						p.pso.hidehud = nil
						PSO.lib.closeMenu(p)
						
					else	-- we still have to do some of them...
						p.pso.exchange_long = $+1
						p.pso.exchange_long_sel = 1
						p.pso.exchange_long_scroll = 0
						p.pso.exchange_long_inv = exch_itemListFromInv(p, p.pso.exchange_display[p.pso.exchange_long_list[p.pso.exchange_long]])
					end
					
				else
					
					S_StartSound(nil, sfx_chchng, p)
					-- proceed with the exchange.
					local exch = PSO.info.exchanges[p.pso.cafeexchange_category].exchanges[p.pso.cafeexchange]
					exch_doExchange(p, exch.contents[p.pso.menu.choice], p.pso.exchange_select_ilist, true)
					p.pso.hidehud = nil
					PSO.lib.closeMenu(p)
				end
				p.pso.exchange_select_warn = 0
				S_StartSound(nil, sfx_mconf, p)
				
				return
			end
			
			return true
		end
		
		-- long exchange handler...
		if p.pso.exchange_long
			
			-- we have to reinvint the wheel here a little bit....
			local inv = p.pso.exchange_long_inv
			local minchoice = 1
			local maxchoice = #inv
			local scroll = 7
			local scrollstart = minchoice + scroll/2
			local scrollback = maxchoice - scroll/2
			local maxscroll = (maxchoice - (minchoice-1)) - scroll

			
			if input(p, "up") == 1
				S_StartSound(nil, sfx_mhvr, p)
				
				if p.pso.exchange_long_sel <= minchoice
					p.pso.exchange_long_sel = maxchoice
					p.pso.exchange_long_scroll = max(0, maxscroll)
				else
					p.pso.exchange_long_sel = $-1
					if p.pso.exchange_long_scroll
						p.pso.exchange_long_scroll = $-1
					end
				end
				--print(p.pso.exchange_long_sel)
				
			elseif input(p, "down") == 1
				S_StartSound(nil, sfx_mhvr, p)
				
				if p.pso.exchange_long_sel >= maxchoice
					p.pso.exchange_long_sel = minchoice
					p.pso.exchange_long_scroll = 0
				else
					p.pso.exchange_long_sel = $+1
					
					if p.pso.exchange_long_sel >= scrollstart
						if p.pso.exchange_long_scroll < maxscroll
							p.pso.exchange_long_scroll = $+1
						end
					end
				end
			
			elseif input(p, IPT_BACK) == 1
				
				p.pso.exchange_long = $-1
				S_StartSound(nil, sfx_mback, p)
				
				if not p.pso.exchange_long	-- clear data.
					p.pso.exchange_long = nil
					p.pso.exchange_long_sel = nil
					p.pso.exchange_long_scroll = nil
					p.pso.exchange_long_list = nil
					p.pso.exchange_long_inv = nil
					p.pso.exchange_long_choices = nil
				end
				
			elseif input(p, IPT_CONFIRM) == 1
				
				p.pso.exchange_select_eqwarn = nil
				
				local checkitem = p.pso.exchange_long_inv[p.pso.exchange_long_sel][1]
				if type(checkitem) == "table"
					if checkitem.locked
						S_StartSound(nil, sfx_mnot, p)
						return	-- item is locked!!
					else
						p.pso.exchange_select_eqwarn = true
					end
				end
				
				S_StartSound(nil, sfx_mconf, p)	
				p.pso.exchange_select_warn = 1	-- do warning.
			
			elseif input(p, IPT_MEXTRA) == 1
				p.pso.exchange_viewpot = (not p.pso.exchange_viewpot) and true or false
				S_StartSound(nil, sfx_mhvr, p)
			end
			
			return true
		end
		
		-- make sure to keep that updated.
		if p.pso.menu.choice ~= p.pso.exchange_prevchoice
			local exch = PSO.info.exchanges[p.pso.cafeexchange_category].exchanges[p.pso.cafeexchange]
			p.pso.exchange_prevchoice = p.pso.menu.choice
			p.pso.exchange_display, p.pso.exchange_ok = exch_preCheckItems(p, exch.contents[p.pso.menu.choice])
		end
		
		if input(p, IPT_CONFIRM) == 1	
			
			local long_exch = {}	-- long exchanges
			
			if not p.pso.exchange_ok	-- we can't do it!
				--print("exch NOK")
				S_StartSound(nil, sfx_mnot, p)
				return
			end
			
			-- check our exchange display, if any of them have multiple entries on a requirement, we need to let the player choose.
			for i = 1, #p.pso.exchange_display
				local curr = p.pso.exchange_display[i]				
				if #curr and #curr > 1
					-- go to long exchange!
					table.insert(long_exch, i)	-- this exchange must be done by selecting something!
					--print("LE: "..i)
				end
			end
			
			if #long_exch
				
				-- this SUCKS.
				S_StartSound(nil, sfx_mconf, p)
				--print("long exch")
				p.pso.exchange_long = 1
				p.pso.exchange_long_sel = 1
				p.pso.exchange_long_scroll = 0
				p.pso.exchange_long_list = long_exch
				p.pso.exchange_long_inv = exch_itemListFromInv(p, p.pso.exchange_display[long_exch[1]])
				p.pso.exchange_long_choices = {}	-- the things we ended up going with!
				return
			end
			
			-- exchange is ok
			S_StartSound(nil, sfx_mconf, p)
			p.pso.exchange_select_warn = 1
			
			-- build item list...
			p.pso.exchange_select_ilist = {}
			for i = 1, #p.pso.exchange_display
				p.pso.exchange_select_ilist[i] = p.pso.exchange_display[i][1]	-- we can make this safe assumption.
			end
			
			--print("exch OK")
		
		elseif input(p, IPT_BACK) == 1
			S_StartSound(nil, sfx_mback, p)
			PSO.lib.changeMenu(p, "cafe_exchange_2", true, true)
			
		elseif input(p, IPT_MEXTRA) == 1
			p.pso.exchange_viewpot = (not p.pso.exchange_viewpot) and true or false
			S_StartSound(nil, sfx_mhvr, p)
		end
	end,
	
	hudfunc = function(v, p, c, choices, choice, timer)


		if p.pso.exchange_select_warn

			local w = 210
			local h = 55
			local x = 160-(w/2)
			local y = 100-(h/2)
			local choices = {"PROCEED", "BACK"}
			
			v.drawFill(x, y, w, h, 253)
			
			v.drawString(160, y+4, "CONFIRMATION", V_YELLOWMAP, "center")
			v.drawString(160, y+14, "The selected item(s)", V_ALLOWLOWERCASE, "center")
			v.drawString(160, y+22, "will be exchanged. Proceed?", V_ALLOWLOWERCASE, "center")
			
			local cy = y+32
			for i = 1, #choices
				v.drawString(160, cy, (i == p.pso.exchange_select_warn and "\x82"..">" or "")..choices[i], V_ALLOWLOWERCASE, "center")
				cy = $+10
			end
		
			return
		end
		
		if p.pso.exchange_long
			-- selecting which to exchange...
			PSO.lib.HUDDrawInventory(v, p, "exchange_long_inv", tab, p.pso.exchange_long_sel, p.pso.exchange_long_scroll, nil, nil, p.pso.exchange_viewpot, true)
			v.drawString(4, 22, "SELECT ITEM", V_SNAPTOLEFT|V_YELLOWMAP)
		else
			-- normal exch hud
			PSO.lib.HUDDrawInventory(v, p, "exchange", tab, p.pso.menu.choice, p.pso.menu.scroll, nil, nil, p.pso.exchange_viewpot, true)
			v.drawString(4, 22, "EXCHANGE ITEMS", V_SNAPTOLEFT|V_YELLOWMAP)
		end
		
		-- the items we need...
		v.drawFill(220, 20, 98, 90, 253|V_SNAPTOLEFT)
		
		-- now draw the required items...
		v.drawString(222, 22, "REQUIREMENTS", V_SNAPTOLEFT|V_YELLOWMAP)
		v.drawFill(222, 31, 98-4, 2, 27|V_SNAPTOLEFT)
		v.drawFill(222, 31, 98-4, 1, 0|V_SNAPTOLEFT)
		
		local dy = 34
		local exch = PSO.info.exchanges[p.pso.cafeexchange_category].exchanges[p.pso.cafeexchange]
		local reqs = exch.contents[p.pso.menu.choice].requirements
		for i = 1, #reqs
		
			local curr = reqs[i]
			
			local check_regroup = p.pso.exchange_display[i]
			local check = 0
			
			if check_regroup and #check_regroup
				for j = 1, #check_regroup
					local curr_check = check_regroup[j]
					
					if curr_check
						local inv = p.pso.inventory[curr_check]
						check = $ + (inv[2] or 1)
					end
				end
			end
			
			local amount = curr[2] or 1
			-- special case
			if type(amount) == "table"
				amount = 1
			end
			
			local col = check >= amount and V_GREENMAP or V_REDMAP
			
			local display = "INVALID"
			if curr[3]
				display = curr[3]
				display = $.." "..(check or 0).."/"..amount
			elseif PSO.lib.itemInfo(curr[1])
				display = PSO.lib.itemInfo(curr[1]).name
				display = $.." "..(check or 0).."/"..amount
				
				-- star rarity
				local pname = "H_NSTAR"
				pname = $..PSO.lib.itemInfo(curr[1]).rarity
				v.draw(222, dy, v.cachePatch(pname), V_SNAPTOLEFT)				
				
			end
			
			v.drawString(232, dy, display, V_SNAPTOLEFT|V_ALLOWLOWERCASE|col, "thin")
			
			dy = $+10
		end
	end,
	
	scroll = 7,
	
	
}