-- Contains a function to draw the inventory because it's pretty messy.
-- This is used by the inventory & the storage

PSO.lib.inventoryPotential = function(p, where)
	local input = PSO.lib.playerInputDown
	local maxs = 3	-- 3 sections in the inventory
	local tab = where.."section"
	
	if p.pso[tab] == 1
		if input(p, IPT_MEXTRA) == 1
			if p.pso.showpot
				p.pso.showpot = nil
			else
				p.pso.showpot = 1
			end
			
			S_StartSound(nil, sfx_mhvr, p)
		end
	else
		p.pso.showpot = nil
	end
	
end

PSO.lib.navigateInventoryTabs = function(p, where)
	local input = PSO.lib.playerInputDown
	local maxs = 3	-- 3 sections in the inventory
	local tab = where.."section"
	local sections = where.."_sections"
	
	p.pso[tab] = $ or 0
	
	if input(p, "right") == 1
		p.pso[tab] = $+1
			
		if p.pso[tab] > maxs
			p.pso[tab] = 1
		end

		-- update bounds
		p.pso.menu.minchoice = p.pso[sections][p.pso[tab]]
		p.pso.menu.maxchoice = max(p.pso.menu.minchoice, p.pso[sections][p.pso[tab]+1] -1)
			
		p.pso.menu.choice = p.pso.menu.minchoice
		p.pso.menu.scroll = 0
		S_StartSound(nil, sfx_mhvr, p)
			
		return true
	elseif input(p, "left") == 1
		p.pso[tab] = $-1
			
		if not p.pso[tab]
			p.pso[tab] = maxs
		end
			
		-- update bounds
		p.pso.menu.minchoice = p.pso[sections][p.pso[tab]]
		p.pso.menu.maxchoice = max(p.pso.menu.minchoice, p.pso[sections][p.pso[tab]+1] -1)
			
		p.pso.menu.choice = p.pso.menu.minchoice
		p.pso.menu.scroll = 0
		S_StartSound(nil, sfx_mhvr, p)
			
		return true
	end
	return false
end

PSO.lib.HUDDrawWeapon = function(v, wx, bgy, flags, info, unidentified)
	local rot_angle
	local side_angle = 0
	local flip
				
				
	if info.weapontype == WPT_TECHMAG
		rot_angle = 0
		side_angle = 2
	elseif info.previewangle
		rot_angle = previewangle
	elseif info.splatframe	-- bad hack........
	or info.weapontype == WPT_DOUBLESABER
		rot_angle = 45
		side_angle = 7
	else
		rot_angle = 45
		side_angle = 7
	end
				
	if info.previewflip
		flip = true
	/*elseif info.splatframe == nil and info.previewflip ~= false
		flip = true*/
	end
	--print(flip)
				
	local drawr = v.getSpritePatch(info.sprite, info.frame, side_angle, 0)	-- reference patch
	local draws = v.getSpritePatch(info.sprite, info.frame, side_angle, (rot_angle)*ANG1)
	local drawc = v.getColormap(TC_DEFAULT, info.color, unidentified and "Black" or nil)	
				
	--local bx = xpos+w
				
	local max_size = 120	-- maximum width of the weapon
	local scale = FRACUNIT
				
	if drawr.width > max_size
		scale = max(FRACUNIT/2, FixedDiv(max_size*FRACUNIT, drawr.width*FRACUNIT))
	end
				
	local bgw = max_size*3/4
	local bgx = wx - bgw/2
	local wy = bgy + bgw/2
	v.drawFill(bgx, bgy, bgw, bgw, 253|flags)
				
	local colours = {
		SKINCOLOR_BLUEBELL,
		SKINCOLOR_GREEN,
		SKINCOLOR_CRIMSON,
		SKINCOLOR_GOLDENROD,
		SKINCOLOR_WHITE,
	}
				
	local col = colours[((info.rarity-1)/3) +1] or SKINCOLOR_WHITE
				
	v.draw(bgx+2, bgy+2, v.cachePatch("H_WBACK"), flags, v.getColormap(TC_DEFAULT, unidentified and SKINCOLOR_CARBON or col))
	local cx = wx
	local cy = wy
				
	-- weapon background...
				
	-- rarity-based vfx!
	-- 4~6*	(also drawn on >= 10*!)
	if (info.rarity >= 4 and info.rarity <= 6 or info.rarity >= 10)
	and not unidentified
					
		-- center
		local coords = {
			{cx, cy},
			{cx - bgw/4, cy - bgw/4},
			{cx + bgw/4, cy + bgw/4},
			{cx - bgw/4, cy + bgw/4},
			{cx + bgw/4, cy - bgw/4},
		}
					
		for i = 1, 5
					
			local base = leveltime + (i*50)
			local scale = FRACUNIT*3/4 + cos((base*ANG1))*105/100
			local trans = min(9, 8 - (cos(base*ANG1)*2 -10000) /FRACUNIT)
						
			if scale > 0
				v.drawScaled(coords[i][1]*FRACUNIT, coords[i][2]*FRACUNIT, scale, v.cachePatch("H_WFX01"), V_ADD|(trans<<V_ALPHASHIFT)|flags, v.getColormap(TC_DEFAULT, col))
			end
		end
	end
				
	-- 7~9* (also drawn on >= 10*)
	if info.rarity >= 7
	and not unidentified
					
		-- middle
		local base = leveltime
		local scale = FRACUNIT/2 + cos(base*ANG1*2)/2
		local trans = min(9, 7 - (cos(base*ANG1*2)*3 -10000) /FRACUNIT)
					
		if scale > 0
			v.drawStretched(cx*FRACUNIT, cy*FRACUNIT, FRACUNIT, scale, v.cachePatch("H_WFX02"), V_ADD|(trans<<V_ALPHASHIFT)|flags, v.getColormap(TC_DEFAULT, col))
		end
					
		-- streaks!
					
		local speeds = {3, 2, 4, 2, 3, 4, 2, 3}
		for i = 1, 8
						
			local x = cx - (bgw/2) + i* bgw/9
			local base = leveltime + i*20
			local speed = speeds[i]
						
			-- this makes it wrap
			local y = cy + bgw*2 - ((speeds[i]*base) % (bgw*4))
			local trans = 5
						
			local pp = v.cachePatch("H_WFX03")
						
			-- check if the patch is in bounds!
			if y + pp.height/2 < (cy- bgw/2)
			or y - pp.height/2 > (cy+ bgw/2)
				continue	-- dont draw
			end
						
			-- otherwise, start getting our stuff!

			local clipy = 0
			local drawy = pp.height
						
			if y - pp.height/2 < (cy-(bgw/2))	-- this clips the top
				clipy = (cy-bgw/2) - (y-pp.height/2)
			elseif y + pp.height/2 > (cy+bgw/2)	-- this clips the bottom
				drawy = pp.height - ((y+pp.height/2) - (cy+bgw/2))
			end
						
			v.drawCropped(x*FRACUNIT, (y+clipy)*FRACUNIT, FRACUNIT, FRACUNIT, pp, V_ADD|(trans<<V_ALPHASHIFT)|flags, v.getColormap(TC_DEFAULT, col), 0, clipy*FRACUNIT, pp.width*FRACUNIT, drawy*FRACUNIT)
		end
	end
				
	v.drawScaled((wx + (info.ixoffset or 0) - (exchange and 75 or 0))*FRACUNIT, (wy + draws.topoffset/5 + (info.iyoffset or 0))*FRACUNIT, scale, draws, flags|(flip and V_FLIP or 0), drawc)
end

-- draws an inventory at the default coords
-- if we shop, display prices as well
-- (1 for buying, 2 for selling, so reduced price)
-- exchange changes a lot of the display to make things smaller.
PSO.lib.HUDDrawInventory = function(v, p, where, tab, index, scroll, shoptype, storage, showpot, exchange)
	local xpos = 2
	local w = 178
	v.drawFill(xpos, 20, w - (exchange and 50 or 0), 90, 253|V_SNAPTOLEFT)
		
	-- draw all items!
	local inv = p.pso[where]
	
	local sect = where.."_sections"
	
	local start = 1 + scroll
	local finish = #p.pso[where]+1
	
	if p.pso[sect]
		start = p.pso[sect][tab] + scroll
		finish = p.pso[sect][tab+1] or #p.pso[where]
	end
		
	local y = 34
		
	v.drawFill(xpos+2, 31, w-4 - (exchange and 50 or 0), 2, 27|V_SNAPTOLEFT)
	v.drawFill(xpos+2, 31, w-5 - (exchange and 50 or 0), 1, 0|V_SNAPTOLEFT)
		
	local sx = xpos + 14
	
	if not exchange
		for i = 1, 3
			v.draw(sx, 21, v.cachePatch("H_ITAB"..i..(tab == i and "2" or "")), V_SNAPTOLEFT)
			sx = $ + 14
		end
	end

	if start ~= finish
		for i = start, min(start + 6, finish-1)
			-- inv[i][1] = item ref / userdata (if wep/armor)
			-- inv[i][2] = quantity (if applicable)
			local it = inv[i][1]
			local qty = inv[i][2]
			local xoffs = 0
			local info
			local tflag = 0	
				
			if type(it) == "string"	-- item is a direct reference
				info = PSO.lib.itemInfo(it)	--PSO.info.items[it]
				xoffs = not exchange and -10 or 0
				
				if info.patype and not info.canuse(p)
					tflag = V_50TRANS
				end

				local pname = "H_NSTAR"
				pname = $..info.rarity
				v.draw(xpos+2, y, v.cachePatch(pname), V_SNAPTOLEFT)				
				
			else	-- userdata
				info = PSO.lib.itemInfo(it)	--PSO.info.items[it.ref]
				
				if not exchange
					
					if it.equipped
						v.draw(xpos+2, y, v.cachePatch("H_EQ"..(it.locked and "L" or "")), V_SNAPTOLEFT)
					elseif it.locked
						v.draw(xpos+2, y, v.cachePatch("H_LCK"), V_SNAPTOLEFT)
						
						if not PSO.lib.canEquip(p, it)	-- this needs to be checked here just in case lol.
							tflag = V_50TRANS
						end
					elseif not PSO.lib.canEquip(p, it)
						tflag = V_50TRANS
						v.draw(xpos+2, y, v.cachePatch("H_NEQ"), V_SNAPTOLEFT)
					end
				end
				
				if it.type == IT_WEAPON
				or it.type == IT_ARMOR
				or it.type == IT_UNIT
					-- for equipment restriction..
					if it.type == IT_WEAPON
						xoffs = $+9
					end
					
					local pname = "H_NSTAR"
					if it.unidentified
						pname = $.."0"
					else
						pname = $..info.rarity
					end
					
					-- exchange hack, draw equipped/locked instead of rarity
					if exchange
						if it.equipped
							pname = "H_EQ"..(it.locked and "L" or "")
						elseif it.locked
							pname = "H_LCK"
						end
					end
					
					v.draw(xpos+2+(not exchange and 10 or 0), y, v.cachePatch(pname), V_SNAPTOLEFT)
				end
			end
				
			local itname = PSO.lib.getItemName(it)
			local ico = PSO.lib.getItemIcon(it)
			local sel = i == index
				
			v.draw(xpos+22+xoffs - (exchange and 10 or 0), y, v.cachePatch(ico..(sel and "B" or "")), V_SNAPTOLEFT|tflag)

			-- show atk or def
			if not shoptype and not exchange
				if it.type == IT_WEAPON
					
					-- level synch
					local atk = it.atk
					local col = ""
					if p.pso.levelsynch
						local satk = PSO.lib.lvSynchWeapon(p, p.pso.levelsynch, it)
						if satk
							atk = satk
							col = "\x82"
							v.draw(xpos +w -53, y-1, v.cachePatch("H_LSYNCH"), V_SNAPTOLEFT)
						end
					end
					
					v.drawString(xpos + w - 6, y, (sel and "\x82" or "").."ATK: "..(it.unidentified and "???" or (col..string.format("%03d", atk))), V_SNAPTOLEFT|tflag, "thin-right")	
				
				elseif it.type == IT_ARMOR

					local def = it.def
					local col = ""
					if p.pso.levelsynch
						local sdef = PSO.lib.lvSynchArmour(p, p.pso.levelsynch, it)
						if sdef
							def = sdef
							col = "\x82"
							v.draw(xpos +w -53, y-1, v.cachePatch("H_LSYNCH"), V_SNAPTOLEFT)
						end
					end				
					v.drawString(xpos + w - 6, y, (sel and "\x82" or "").."DEF: "..(col..string.format("%03d", def)), V_SNAPTOLEFT|tflag, "thin-right")	
				
				elseif it.type == IT_UNIT
					
					if p.pso.levelsynch
					and PSO.lib.getPlayerArmor(p)

						local curr_armor = PSO.lib.getPlayerArmor(p)
						
						local nslots = 0
						for n = 1, (PSO.info.items[curr_armor.ref].slots or 0)
							if curr_armor.slots[n]
								nslots = $+1
							end
						end
						
						local test = PSO.lib.lvSynchUnit(p, p.pso.levelsynch, it, nslots)
						
						if test
							v.draw(xpos +w -53, y-1, v.cachePatch("H_LSYNCH"), V_SNAPTOLEFT)
						end
					end
				end	
			end
				
			if info.type >= IT_CONSUMABLE and type(it) == "string"
			and not shoptype
				local qtylimit = info.carrylimit
				
				local qstr = (sel and "\x82" or "").."x"..qty..((not storage and qtylimit) and ("/"..qtylimit) or "")
				v.drawString(xpos + w - 2 - (exchange and 50 or 0), y, qstr, V_ALLOWLOWERCASE|V_SNAPTOLEFT|tflag, "thin-right")
		
			elseif shoptype
				
				local price = PSO.lib.itemPrice(it)
				if shoptype == 2
					price = max(1, $/8)
				end
				
				-- add the quantity to the name directly
				if info.type >= IT_CONSUMABLE
					itname = $.." ("..qty..")"
				end

				-- draw amount of meseta
				local ico = PSO.lib.arenaQuestActive() and "H_AP" or "H_MST"
				v.draw(xpos + w - 12, y-1, v.cachePatch(ico), V_SNAPTOLEFT)
				v.drawString(xpos + w - 14, y, (sel and "\x82" or "")..PSO.lib.numCommas(price), V_SNAPTOLEFT, "thin-right")				
			end
			
			-- item name
			--local fontsize = shoptype and "thin" or nil
			local fontsize = "thin"
			
			if exchange
				xoffs = 0
			end
			
			v.drawString(xpos + 32+xoffs, y, (sel and "\x82" or "")..itname, V_SNAPTOLEFT|V_ALLOWLOWERCASE|tflag, fontsize)
				
			y = $+10
		end
	end
		
	local y2 = 114
	v.drawFill(xpos, y2, w, 82, 253|V_SNAPTOLEFT)
		
		
	local slot = p.pso[where][index]
	local selected
	local info
		
	if slot and start ~= finish
		selected = slot[1]
		info = PSO.lib.itemInfo(selected)	--PSO.info.items[selected]
			
		--v.drawString(xpos+2, 130, desc, V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")
			
		-- display specific info based on what item we're selecting:
		if info.type == IT_WEAPON

			-- level synch
			local datk = selected.atk
			local col = nil
			if p.pso.levelsynch
				local satk = PSO.lib.lvSynchWeapon(p, p.pso.levelsynch, selected)
				if satk
					datk = satk
					col = "\x82"
				end
			end
				
			local atk = (col or "")..string.format("%03d", datk)
			local elm = string.format("%02d", (selected.elementv or 0))
			local id = not selected.unidentified

			local cost = 100
			local cost_col = "\x80"
					
			local power = 100
			local power_col = "\x80"
					
			if selected.pa_cost and id
				cost = selected.pa_cost
				if cost < 100
					cost_col = "\x87"
				elseif cost > 100
					cost_col = "\x84"
				end
			end
			if selected.pa_damage and id
				power = selected.pa_damage
				if power > 100
					power_col = "\x87"
				elseif power < 100
					power_col = "\x84"
				end					
			end
			
			local maxgrind = selected.maxgrind or PSO.info.MAXGRIND
			
			-- if 'col' is set then we're levelsynched.
			if col
				v.draw(xpos+2, y2+1, v.cachePatch("H_LSYNCH"), V_SNAPTOLEFT)
			end
			local atkstring = "ATK:"
			local wpt = PSO.info.weaponDamageType[selected.weapontype]
			if wpt == DMT_STRIKE
				atkstring = "S.ATK:"
			elseif wpt == DMT_RANGED
				atkstring = "R.ATK:"
			elseif wpt == DMT_TECHNIQUE
				atkstring = "T.ATK:"
			end
			
			v.drawString(xpos+2 + (col and 12 or 0), y2+2, "\x82"..atkstring.." \x80"..(id and atk or "???").."\x82".." /", V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
				
			if elm
				if id
					v.draw(xpos+44+8 + (col and 12 or 0), y2+2, v.cachePatch("H_ELEM"..selected.element), V_SNAPTOLEFT)
				end
				v.drawString(xpos+51+8 + (col and 12 or 0), y2+2, (id and elm or "??").."%".."\x82".." / GRIND: "..(selected.grind >= maxgrind and "\x87" or "\x80")..selected.grind.."/"..maxgrind, V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
			end
			
			local canequip, reason = PSO.lib.canEquip(p, selected)
			
			if canequip or not id
				v.drawString(xpos+2, y2+12, "\x82".."Equipment Level: "..(selected.equiplevel and "\x87" or "\x80")..(id and (selected.equiplevel or info.req or 1) or "???"), V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
			else
				local s = ""
				if reason == 1	-- level
					s = "Level ("..p.pso.level.."/"..(selected.equiplevel or info.req or 1)..")"
				else
					s = "Proficiency too low"
				end
				
				v.drawString(xpos+2, y2+12, "\x85".."Cannot equip: "..s, V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
			end
			

			if info.potential and not selected.unidentified
				local pot = PSO.info.potentials[info.potential]
				v.draw(xpos+2, y2+21, v.cachePatch("H_POT"), V_SNAPTOLEFT)
				v.drawString(xpos+11, y2+22, pot.name, V_YELLOWMAP|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
				
				local infobt = PSO.lib.playerButtonIcon(p, IPT_MEXTRA, true)
				if (not showpot) or leveltime%10 < 5
					v.draw(xpos+w - 28, y2+19, v.cachePatch(infobt), V_SNAPTOLEFT)
				end
				v.drawString(xpos+w - 28, y2+22, showpot and "BACK" or "INFO", V_SNAPTOLEFT, "thin-right")
				
				if showpot
					local desc = PSO.lib.wordWrap(v, pot.desc or "", w-8, V_ALLOWLOWERCASE, "thin")
					v.drawString(xpos + 2, y2+32, desc, V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "thin")					
				end
				
			end
			
			-- get the cost/power
			if id and not showpot
				--v.drawString(xpos+2, y2+22, "\x82".."ARTS", V_SNAPTOLEFT)
				v.drawString(xpos+2, y2+32, "\x82".."Arts (PP cost: "..cost_col..(id and cost or "???").."%\x82 / Power: "..power_col..(id and power or "???").."%".."\x82"..")", V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
					
				local ay = y2+42
				local base_ay = ay
				local ax = xpos+2
				
				local hand = PSO.info.weaponHand[selected.weapontype]
				
				for i = 1, (hand == HAND_BOTH and 6 or 3)
						
					--local bt = PSO.lib.playerButtonIcon(p, IPT_ATTACK + (i-1)%3, true)
					local dta = PSO.info.photonArts[selected.actions[i]]
					local ico
					local str = "---"
					
					if (hand == HAND_BOTH)
						if i == 1
							v.drawString(ax, ay, "Front", V_YELLOWMAP|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
							ay = $+10
						elseif i == 4
							v.drawString(ax, ay, "Back", V_YELLOWMAP|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
							ay = $+10
						end
					end
					
					if dta
						ico = v.cachePatch(dta.icon)
						str = dta.name
					elseif selected.actions[i]
						str = "INVALID ART"
					end
						
					if ico
						v.draw(ax, ay-3, ico, V_SNAPTOLEFT)
					end
					v.drawString(ax + 16, ay, str, V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")
						
					--v.draw(ax, ay-3, v.cachePatch(bt), V_SNAPTOLEFT)
					ay = $+10
					
					if i == 3
						ay = base_ay
						ax = $ + 75
					end
				end
			end
			
			-- finally, draw an image of the weapon.
			-- if we can, that is
			PSO.lib.HUDDrawWeapon(v, (xpos+w+320)/2 - (exchange and 75 or 0), 20, V_SNAPTOLEFT, info, selected.unidentified)
			
				
		elseif info.type == IT_ARMOR
			-- level synch
			local ddef = selected.def
			local col = nil
			if p.pso.levelsynch
				local sdef = PSO.lib.lvSynchArmour(p, p.pso.levelsynch, selected)
				if sdef
					ddef = sdef
					col = "\x82"
				end
			end
				
			local def = (col or "")..string.format("%03d", ddef)
			local elm = string.format("%02d", (selected.elementv or 0))
			
			local maxgrind = selected.maxgrind or PSO.info.MAXGRIND
			
			-- if 'col' is set then we're levelsynched.
			if col
				v.draw(xpos+2, y2+1, v.cachePatch("H_LSYNCH"), V_SNAPTOLEFT)
			end
			v.drawString(xpos+2 + (col and 12 or 0), y2+2, "\x82".."DEF: \x80"..def.."\x82".." /", V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
				
			if elm
				v.draw(xpos+44 + (col and 12 or 0), y2+2, v.cachePatch("H_ELEM"..selected.element), V_SNAPTOLEFT)
				v.drawString(xpos+51 + (col and 12 or 0), y2+2, elm.."%".."\x82".." / GRIND: "..(selected.grind >= maxgrind and "\x87" or "\x80")..selected.grind.."/"..maxgrind, V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
			end
			
			local canequip, reason = PSO.lib.canEquip(p, selected)
			
			if canequip
				v.drawString(xpos+2, y2+12, "\x82".."Equipment Level: "..(selected.equiplevel and "\x87" or "\x80")..(selected.equiplevel or info.req or 1), V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
			else
				local s = ""
				if reason == 1	-- level
					s = "Level ("..p.pso.level.."/"..(selected.equiplevel or info.req or 1)..")"
				else
					s = "Proficiency too low"
				end
				
				v.drawString(xpos+2, y2+12, "\x85".."Cannot equip: "..s, V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
			end
			
			local uhp = info.hp or 0
			local upp = info.pp or 0
			
			if p.pso.levelsynch
				local w, ehp, epp = PSO.lib.lvSynchArmour(p, p.pso.levelsynch, selected)
				uhp = ehp or 0
				upp = epp or 0
				
				v.draw(xpos+52, y2+21, v.cachePatch("H_LSYNCH"), V_SNAPTOLEFT)
			end
			
			local hpsign = "\x80+"
			if uhp > 0
				hpsign = "\x87".."+"
			elseif uhp < 0
				hpsign = "\x84"
			end

			local ppsign = "\x80+"
			if upp > 0
				ppsign = "\x87".."+"
			elseif upp < 0
				ppsign = "\x84"
			end
			
			local hppp = (p.pso.levelsynch and "      " or "").."(HP: "..hpsign..uhp.."\x82 / PP: "..ppsign..upp.."\x82)"
			
			if info.slots
				v.drawString(xpos+2, y2+22, "\x82".."Unit slots "..hppp, V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
					
				local ay = y2+32
				for i = 1, info.slots or 0
					local str = "---"
					local rarity = 0
					
					if selected.slots and selected.slots[i]
						str = selected.slots[i].name
						rarity = selected.slots[i].rarity
						v.draw(xpos+2, ay, v.cachePatch("H_NSTAR"..rarity), V_SNAPTOLEFT)
					end
					
					v.drawString(xpos+12, ay, str, V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")
					ay = $+10
				end
			else
				v.drawString(xpos+2, y2+22, "\x82".."- -No unit slot- - "..hppp, V_SNAPTOLEFT, "thin")
			end

		elseif info.type == IT_UNIT
			local stats = {"hp", "pp", "satk", "ratk", "tatk", "critrate", "critdamage", "ppregen", "actionspd"}
			local statnames = {"HP", "PP", "S-ATK", "R-ATK", "T-ATK", "CRIT RATE", "CRIT DMG", "PP REGEN", "ATK SPEED"}
			
			local synch
			if p.pso.levelsynch
			and PSO.lib.getPlayerArmor(p)
				local curr_armor = PSO.lib.getPlayerArmor(p)
				
				local nslots = 0
				for n = 1, (PSO.info.items[curr_armor.ref].slots or 0)
					if curr_armor.slots[n]
						nslots = $+1
					end
				end
				
				synch = PSO.lib.lvSynchUnit(p, p.pso.levelsynch, selected, nslots)
			end
			
			for i = 1, #stats
				
				v.drawString(xpos+2, y2+2+(i-1)*8, "\x82"..statnames[i]..":", V_SNAPTOLEFT, "thin")
				
				local stat = info[stats[i]] or 0
				
				local str = ""
				local strp = i >= 6 and "%" or ""
				
				if stat > 0
					str = "\x87".."+"..stat
				elseif stat < 0
					str = "\x84"..stat
				else
					str = stat
				end
				
				v.drawString(xpos+2 + 75, y2+2+(i-1)*8, str..strp, V_SNAPTOLEFT, "thin")
				
				if synch and synch[stats[i]]
					v.draw(xpos+2 +62, y2+1+(i-1)*8, v.cachePatch("H_LSYNCH"), V_SNAPTOLEFT)
					--stat = synch[stat] or 0
					v.drawString(xpos+2 +75 +30, y2+2+(i-1)*8, " -> ".."\x82"..(stat > 0 and "+" or "")..synch[stats[i]], V_SNAPTOLEFT, "thin")
				end
			end
				
		else
		
			local desc = info.desc or "MISSING ITEM DESCRIPTION"
			if info == PSO.info.items["noref"]
				desc = $.."\n\x82".."Internal name: \'"..(type(selected) == "string" and selected or selected.ref).."\'"
			end
		
			desc = PSO.lib.wordWrap(v, desc or "", w-8, V_ALLOWLOWERCASE|V_RETURN8, "thin")
			v.drawString(xpos + 2, y2+2, desc, V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "thin")
				
			PSO.lib.HUD_drawItemRarity(v, xpos+2, y2+70, V_SNAPTOLEFT, info.rarity or 0)	
		end
			
		if info.type and info.type < IT_CONSUMABLE
			-- draw desc + rarity:
			local w2 = 320 - xpos - w - 2
			v.drawFill(xpos+w, y2, w2, 82, 253|V_SNAPTOLEFT)
				
			v.drawFill(xpos+w -1, y2+1, 2, 80, 27|V_SNAPTOLEFT)
			v.drawFill(xpos+w -1, y2+1, 1, 79, 0|V_SNAPTOLEFT)
			
			if selected.unidentified
				local str = "A weapon unusable in its current state, bring it to the Tekker in the Low Orbit Station to appraise it and uncover its true power."
				local desc = PSO.lib.wordWrap(v, str, w2-8, V_ALLOWLOWERCASE, "thin")
				v.drawString(xpos + w + 2, y2+2, desc, V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "thin")
					
				PSO.lib.HUD_drawItemRarity(v, xpos+w+2, y2+70, V_SNAPTOLEFT, 0)			
			else
				local desc = PSO.lib.wordWrap(v, info.desc or "", w2-8, V_ALLOWLOWERCASE, "thin")
				v.drawString(xpos + w + 2, y2+2, desc, V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "thin")
					
				PSO.lib.HUD_drawItemRarity(v, xpos+w+2, y2+70, V_SNAPTOLEFT, info.rarity or 0)
			end
		end	
	end
end