freeslot("sfx_qload", "sfx_qacpt", "sfx_qfail")

-- closes the menu if this guy ain't our leader!
local function noLeaderClose(p)
	if p != PSO.lib.getLeader()
		PSO.lib.closeMenu(p)
		return true
	end
	return false
end

PSO.info.menus["quest_map"] = {
	
	openfunc = function(p)
		
		if PSO.lib.arenaQuestActive()
			PSO.lib.changeMenu(p, "arena")
			return
		end
			
		if server.questdata and server.questdata.complete
		and not p.exiting
			PSO.lib.changeMenu(p, "turnin")
			return
		end
		
		-- no, nooooo...
		if p ~= PSO.lib.getLeader()			
		or server.questdata	-- quest ongoing and we can't turn it in.
			PSO.lib.closeMenu(p)
			return
		end
		
		-- test, comment out
		--PSO.info.questmaps = {2}
		
		-- build the list of maps:
		local choices = {}
		/*for i = 1, #PSO.info.questmaps
			
			local mapnum = PSO.info.questmaps[i][1]
			local lock = PSO.info.questmaps[i][2]
			
			if lock and not PSO.lib.questUnlocked(mapnum)
				continue
			end
			
			local name = mapheaderinfo[mapnum].lvlttl or "INVALID MAP"
			
			table.insert(choices, {name, mapnum})
		end*/
		
		for i = 1, #PSO.info.quests
			
			local info = PSO.info.quests[i]
			table.insert(choices, {info.title, info.tip, i})
			
		end
		
		table.insert(choices, {"Cancel", 0})
		
		p.pso.menu.minchoice = 1
		p.pso.menu.maxchoice = #choices
		p.pso.menu.choices = choices
	end,
	
	-- closefunc not needed, p.pso.menu is purged on clsoe
	
	hudfunc = function(v, p, c, choices, choice, timer)
		local w = 240
		local h = 100
		local x = 160-(w/2)
		local y = 80-(h/2)
		
		choices = p.pso.menu.choices
		local info = {}		
		
		v.drawFill(x, y, w, h, 253)
		
		v.drawString(160, y+4, "QUEST COUNTER", V_YELLOWMAP, "center")
		
		local cy = y+16
		for i = p.pso.menu.scroll+1, min(#choices, p.pso.menu.scroll +6)
			
			local locked
			if i ~= #choices
				info = PSO.info.quests[choices[i][3]]
				locked = not PSO.lib.questUnlocked(i) --info.unlocked
			end
		
			v.drawString(80, cy, (i == choice and "\x82"..">" or "")..choices[i][1], V_ALLOWLOWERCASE|(locked and V_50TRANS or 0))
			cy = $+10
		end
		
		v.drawFill(x+2, y+82, w-4, 2, 28)
		v.drawFill(x+2, y+82, w-5, 1, 0)
		
		if choice ~= #choices
			--local pic = G_BuildMapName(choices[choice][2]).."P"
			
			--v.drawScaled(160<<FRACBITS, (y+16)<<FRACBITS, FRACUNIT/2, v.cachePatch(pic))
			local tip = choices[choice][2]
			if tip
				v.drawString(160, y+86, tip, V_ALLOWLOWERCASE, "thin-center")
			end
		end
		
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
			
		if noLeaderClose(p)
			return true
		end
		
		if input(p, IPT_CONFIRM) == 1
		and p.pso.menu.choice < #p.pso.menu.choices
			
			--p.pso.questmap = PSO.info.questmaps[p.pso.menu.choice][1]
			p.pso.questmap = p.pso.menu.choices[p.pso.menu.choice][3]
			
			-- check if we have this unlocked
			if PSO.lib.questUnlocked(p.pso.menu.choice)
			
				-- open the next menu:
				PSO.lib.changeMenu(p, "quest_select", true, true)
				S_StartSound(nil, sfx_mconf, p)
			else
				S_StartSound(nil, sfx_mnot, p)
			end
			
			return true		
			
		elseif input(p, IPT_BACK) == 1
		or (input(p, IPT_CONFIRM) and p.pso.menu.choice == #p.pso.menu.choices)
			S_StartSound(nil, sfx_mback, p)
			PSO.lib.closeMenu(p)
		end
	end,
	
	scroll = 6,
}

local difficultynames = {
	[DIFF_NORMAL] = "NORMAL",
	[DIFF_HARD] = "HARD",
	[DIFF_VERYHARD] = "VERY HARD",
	[DIFF_SUPERHARD] = "SUPER HARD",
	[DIFF_EXTREMELYHARD] = "EXTREMELY HARD",
	[DIFF_ULTRAHARD] = "ULTRA HARD"
}

PSO.info.menus["quest_select"] = {
	
	scroll = 5,
	
	openfunc = function(p)
		
		-- build the list of quests:
		local choices = {}
		for i = 1, #PSO.info.quests[p.pso.questmap].quests
			-- is that quest, uh, unlocked?
			local q = PSO.info.quests[p.pso.questmap].quests[i]
			
			if q.locked and not PSO.lib.questUnlocked(p.pso.questmap, i)
				continue
			end
			
			table.insert(choices, i)	-- save the index of the quest
		end
		table.insert(choices, 0)
		
		p.pso.menu.minchoice = 1
		p.pso.menu.maxchoice = #choices
		p.pso.menu.choices = choices

		p.pso.acceptquest = nil
		p.pso.questdifficulties = nil
		p.pso.questdifficulty = nil	
	
	end,
	
	closefunc = function(p)
		p.pso.acceptquest = nil
		p.pso.questdifficulties = nil
		p.pso.questdifficulty = nil
	end,

	hudfunc = function(v, p, c, choices, choice, timer)
		local w = 120
		local h = 140
		local x = 2
		local y = 12
		
		local mapname = ""	--mapheaderinfo[p.pso.questmap].lvlttl

		if p.pso.acceptquest
			
			local aw = 160
			local ah = 30
			local ax = 160 - aw/2
			local ay = 100 - ah/2
			
			v.drawFill(ax, ay, aw, ah, 253)
			
			if p.pso.acceptquest < TICRATE*2
			
				v.drawString(160, 90, "\x82".."LOADING...", 0, "center")
				
				
				
				local barlen = min(aw-7, p.pso.acceptquest*(aw-7)/(TICRATE*2))
				local percentage = p.pso.acceptquest*100/(TICRATE*2)
				
				v.drawFill(ax+2, 108, aw-6, 2, 26)
				v.drawFill(ax+2, 108, barlen, 1, 73)
				v.drawString(160, 98, "\x82"..string.format("%03d", percentage).."%", 0, "center")
				
			elseif leveltime%4 < 2
				v.drawString(160, 96, "\x82".."QUEST ACCEPTED!", 0, "center")
			end
			
			return
		end
		
		v.drawFill(x, y, w, h, 253|V_SNAPTOLEFT)
		
		local qy = y + 21
				
		if p.pso.questdifficulties
			
			v.drawString(x+2, y+2, "\x82".."DIFFICULTY", V_RETURN8|V_SNAPTOLEFT)
			
			for i = 1, #p.pso.questdifficulties+1
				
				local display
				local lvdisplay --= "MISSING INFO"
				
				if i <= #p.pso.questdifficulties
					local diff = p.pso.questdifficulties[i]
					local rlvl = 1
					
					if PSO.info.quests[p.pso.questmap].quests[p.pso.menu.choices[choice]].recommended
						rlvl = PSO.info.quests[p.pso.questmap].quests[p.pso.menu.choices[choice]].recommended[diff]
					end
					local lvl = PSO.info.quests[p.pso.questmap].quests[p.pso.menu.choices[choice]].levels[diff]
					
					display = difficultynames[diff]	--.."\n".."  ENEMY LV"..lvl
					lvdisplay = "Enemy Lv"..lvl.." / (Rec. Lv"..rlvl.."+)"
				else
					display = "BACK"
				end
				v.drawString(x+2, qy-8, (p.pso.questdifficulty == i and "\x82>" or "")..display, V_SNAPTOLEFT|V_RETURN8)
				
				if lvdisplay
					v.drawString(x+2, qy, lvdisplay, (p.pso.questdifficulty == i and V_YELLOWMAP or 0)|V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")
				end
				qy = $ + 18
			end
		else
			v.drawString(x+2, y+2, "\x82".."QUEST LIST", V_RETURN8|V_SNAPTOLEFT)
			for i = p.pso.menu.scroll+1, min(p.pso.menu.scroll+5, #p.pso.menu.choices)
				
				local qindex = p.pso.menu.choices[i]
				local name = "INVALID QUEST"
				
				local quest = PSO.info.quests[p.pso.questmap].quests[qindex]
				
				if qindex == 0
					name = "BACK"
				elseif quest
					name = quest.name or "INVALID Q NAME"
				end
				
				-- display lowest enemy level
				if quest and quest.levels
					for i = DIFF_NORMAL, DIFF_ULTRAHARD
						if quest.levels[i]
							name = $.."\n".."Enemy Lv"..quest.levels[i].."+"
							break
						end
					end
				end
				
				if i == 1
					v.drawFill(x+2, qy -3, w-6, 2, 28|V_SNAPTOLEFT)
					v.drawFill(x+2, qy -3, w-7, 1, V_SNAPTOLEFT)
				end
				v.drawString(x+2, qy, (choice == i and ("\x82"..">") or "")..name, V_SNAPTOLEFT|V_RETURN8|V_ALLOWLOWERCASE, "thin")
				
				if i < #p.pso.menu.choices
					v.drawFill(x+2, qy +16, w-6, 2, 28|V_SNAPTOLEFT)
					v.drawFill(x+2, qy +16, w-7, 1, V_SNAPTOLEFT)
				end
				
				qy = $+20
			end
		end
		
		local squest = p.pso.menu.choices[choice]
		
		if squest and PSO.info.quests[p.pso.questmap].quests[squest]
			-- display quest info:
			
			local nx = x + w + 2
			local nw = 320 - nx - 2
			local q = PSO.info.quests[p.pso.questmap].quests[squest]
			
			v.drawFill(nx, y, nw, h, 253|V_SNAPTOLEFT)

			local pic = G_BuildMapName(q.map).."P"
			
			v.drawScaled((nx+2)<<FRACBITS, (y+2)<<FRACBITS, FRACUNIT/4, v.cachePatch(pic), V_SNAPTOLEFT)
			
			v.drawString(nx+48, y+2, "\x82".."QUEST INFO", V_SNAPTOLEFT)
			v.drawString(nx+48, y+10, q.name, V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")

			v.drawFill(nx+48, y+20, nw-52, 2, 28|V_SNAPTOLEFT)
			v.drawFill(nx+48, y+20, nw-53, 1, V_SNAPTOLEFT)
			
			if p.pso.questdifficulties and p.pso.questdifficulty < #p.pso.questdifficulties+1
				
				v.drawString(nx+2, y+32, "\x82".."RESTRICTIONS:", V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8)
				
				-- @TODO
				local levelsynch = "N/A"
				local timelimit = "N/A"
				local incaplimit = "N/A"
				
				if q.levelsynch and q.levelsynch[p.pso.questdifficulty]
					levelsynch = q.levelsynch[p.pso.questdifficulty][1].."\x82".." ~ \x80"..q.levelsynch[p.pso.questdifficulty][2]
					if q.levelsynch[p.pso.questdifficulty][3]
						levelsynch = $.." (".."\x82GRIND:\x80".." +"..q.levelsynch[p.pso.questdifficulty][3]..")"
					end
				end
				
				v.drawString(nx+2, y+40, "\x82".."TIME LIMIT: \x80", V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "thin")
				v.drawString(nx+2, y+48, "\x82".."INCAPACITATION LIMIT: \x80", V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "thin")
				v.drawString(nx+2, y+56, "\x82".."LEVEL SYNCH: \x80", V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "thin")
				
				-- level synch on/off
				local synchbt = PSO.lib.playerButtonIcon(p, IPT_MEXTRA, true)
				v.draw(nx+150, y+53, v.cachePatch(synchbt), V_SNAPTOLEFT)
				v.drawString(nx+168, y+56, (server.uselevelsynch and "\x82".."ON" or "\x85".."OFF"), V_SNAPTOLEFT, "thin")

				v.drawString(nx+110, y+40, timelimit, V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "thin")
				v.drawString(nx+110, y+48, incaplimit, V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "thin")
				v.drawString(nx+110, y+56, levelsynch, V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "thin")

				v.drawFill(nx+2, y+66, nw-4, 2, 28|V_SNAPTOLEFT)
				v.drawFill(nx+2, y+66, nw-5, 1, V_SNAPTOLEFT)
				
				v.drawString(nx+2, y+69, "\x82".."FEATURED ITEMS:", V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8)
				
				local arr_r = leveltime%10 < 5 and ">" or " >"
				local arr_l = leveltime%10 < 5 and "<" or "< "
				v.drawString(nx+150, y+69, arr_l..p.pso.questitemtab.."/4"..arr_r, V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "center")
				
				local itemy = y + 78
				local itemx = nx+2
				local range = {{1, 1}, {2, 2}, {3, 3}, {4, 4}}
				
				for i = range[p.pso.questitemtab][1], range[p.pso.questitemtab][2]
					local drawn
					local iconshift = (i==1 and 19 or 11)
					
					for j = 1, min(5, #p.pso.dropslookup[i])
						drawn = true
						local info = PSO.lib.itemInfo(p.pso.dropslookup[i][j])
						local star = "H_NSTAR"..info.rarity
						local ico = PSO.lib.getItemIcon(p.pso.dropslookup[i][j])
						
						v.draw(itemx+2, itemy, v.cachePatch(star), V_SNAPTOLEFT)
						v.draw(itemx+iconshift, itemy, v.cachePatch(ico), V_SNAPTOLEFT)
						v.drawString(itemx+iconshift+10, itemy, info.name, V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "thin")
						
						itemy = $+11
					end
					
					if not drawn
						v.drawString(itemx, itemy, "   N/A", V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "thin")
					end
					
					itemx = $+95
					itemy = y+78
				end
				
			else
				
				local dstr = PSO.lib.wordWrap(v, q.desc, nw-8, 0, "thin")
				v.drawString(nx+2, y+32, "\x82".."DESCRIPTION:", V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8)
				v.drawString(nx+2, y+40, dstr, V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "thin")

				v.drawFill(nx+2, y+97, nw-4, 2, 28|V_SNAPTOLEFT)
				v.drawFill(nx+2, y+97, nw-5, 1, V_SNAPTOLEFT)
				
				dstr = PSO.lib.wordWrap(v, q.objective, nw-8, 0, "thin")
				v.drawString(nx+2, y+100, "\x82".."OBJECTIVE:", V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8)
				v.drawString(nx+2, y+108, dstr, V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8, "thin")
			end
		end
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown

		if noLeaderClose(p)
			return true
		end
		
		if p.pso.acceptquest
			local q = PSO.info.quests[p.pso.questmap].quests[p.pso.menu.choices[p.pso.menu.choice]]
			p.pso.acceptquest = $+1
			
			if p.pso.acceptquest == TICRATE*2
				-- accept quest
				PSO.lib.acceptQuest(p.pso.questmap, p.pso.menu.choices[p.pso.menu.choice], q.map, p.pso.questdifficulties[p.pso.questdifficulty], server.uselevelsynch)
				
			elseif p.pso.acceptquest == TICRATE*3
				local q = PSO.info.quests[p.pso.questmap].quests[p.pso.menu.choices[p.pso.menu.choice]]
				for p2 in players.iterate
					if p2 and p2.mo.valid
						PSO.lib.playerNotification(p2, "\x82".."QUEST START: ".."\x80"..q.name)	
					end
				end
				
				PSO.lib.closeMenu(p)
			end
			
			return true
		end
		
		if p.pso.questdifficulties

		
			if input(p, IPT_MEXTRA) == 1
				server.uselevelsynch = server.uselevelsynch == false and true or false
				S_StartSound(nil, sfx_mhvr, p)
			end
			
			local quest = PSO.info.quests[p.pso.questmap].quests[p.pso.menu.choices[p.pso.menu.choice]]
						
			if input(p, "down") == 1
				S_StartSound(nil, sfx_mhvr, p)
				p.pso.questdifficulty = $+1
				if p.pso.questdifficulty > #p.pso.questdifficulties+1
					p.pso.questdifficulty = 1
				end
				
				if p.pso.questdifficulty < #p.pso.questdifficulties+1
					p.pso.dropslookup = PSO.lib.bestQuestDrops(quest, p.pso.questdifficulties[p.pso.questdifficulty])
					p.pso.questitemtab = 1
				end
				
			elseif input(p, "up") == 1
				S_StartSound(nil, sfx_mhvr, p)
				p.pso.questdifficulty = $-1
				if p.pso.questdifficulty <= 0
					p.pso.questdifficulty = #p.pso.questdifficulties+1
				end	
				
				if p.pso.questdifficulty < #p.pso.questdifficulties+1
					p.pso.dropslookup = PSO.lib.bestQuestDrops(quest, p.pso.questdifficulties[p.pso.questdifficulty])
					p.pso.questitemtab = 1
				end
			
			elseif input(p, "left") == 1
				S_StartSound(nil, sfx_mhvr, p)
				p.pso.questitemtab = $-1
				if p.pso.questitemtab < 1
					p.pso.questitemtab = 4
				end
			
			elseif input(p, "right") == 1
				S_StartSound(nil, sfx_mhvr, p)
				p.pso.questitemtab = $+1
				if p.pso.questitemtab > 4
					p.pso.questitemtab = 1
				end
			end
			
			if input(p, IPT_CONFIRM) == 1
			and p.pso.questdifficulty <= #p.pso.questdifficulties
				
				p.pso.acceptquest = 1
				S_StartSound(nil, sfx_qload, p)
				
			elseif input(p, IPT_BACK) == 1
			or input(p, IPT_CONFIRM) == 1 and p.pso.questdifficulty > #p.pso.questdifficulties
				p.pso.questdifficulties = nil
				S_StartSound(nil, sfx_mback, p)
			end
			
			return true
		end
		
		if input(p, IPT_CONFIRM) == 1
		and p.pso.menu.choice < #p.pso.menu.choices
			
			p.pso.questdifficulty = 1
			p.pso.questitemtab = 1
			-- find out which difficulties are available for the quest...
			
			local quest = PSO.info.quests[p.pso.questmap].quests[p.pso.menu.choices[p.pso.menu.choice]]
			local diffs = {}
			if quest and quest.levels
				for i = DIFF_NORMAL, DIFF_ULTRAHARD
					
					if quest.locked
						local diffu = PSO.lib.questUnlocked(p.pso.questmap, p.pso.menu.choices[p.pso.menu.choice])
						if not diffu or diffu < i
							break
						end
					else
						-- this prevents normal quests from having hard unlocked at the start of the game etc...
						if PSO.lib.maxDifficultyUnlocked() < i
							break
						end
					end
					
					if quest.levels[i]
						diffs[#diffs+1] = i
					end
				end
			end
			
			if diffs[#diffs]
				p.pso.dropslookup = PSO.lib.bestQuestDrops(quest, diffs[#diffs])
				p.pso.questdifficulty = #diffs	-- take the highest one by default.
				--print(p.pso.dropslookup[3][1])
			end
			
			p.pso.questdifficulties = diffs
			
			S_StartSound(nil, sfx_mconf, p)
			return true		
			
		elseif input(p, IPT_BACK) == 1
		or (input(p, IPT_CONFIRM) and p.pso.menu.choice == #p.pso.menu.choices)
			S_StartSound(nil, sfx_mback, p)
			PSO.lib.closeMenu(p)
		end	
	end,
}