-- Salon Menu

-- Only intended for use in SINGLEPLAYER.
-- The menu should CATEGORICALLY REFUSE TO OPEN IN NETGAMES

local choices = {
	"Base Genome",
	"Colour",
	"Confirm",
}

local function drawSalon(v, p, c, choices, choice, timer)
	
	v.drawScaled(0, 0, FRACUNIT/2, v.cachePatch("PSTTLBG"), V_SNAPTOLEFT|V_SNAPTOTOP)
	
	if p.pso.type_initialized
		v.drawString(2, 2, "SALON", V_YELLOWMAP|V_SNAPTOTOP|V_SNAPTOLEFT)
	else
		v.drawString(2, 2, "ESTABLISH YOURSELF...", V_YELLOWMAP|V_SNAPTOTOP|V_SNAPTOLEFT)
	end
	
	-- idiotproofing
	local infobt = PSO.lib.playerButtonIcon(p, IPT_CONFIRM)
	v.draw(2, 188, v.cachePatch(infobt), V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	v.drawString(19, 190, "CONFIRM", V_YELLOWMAP|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	
	-- draw player
	local px = 50
	local py = 150
	
	-- if the player has a follow item, draw that first.
	if skins[p.pso.salongenome].followitem
		local sprite = v.getSprite2Patch(p.pso.salongenome, SPR2_TAL0, false, B, 2)
		if sprite
			v.draw(px, py, sprite, 0, v.getColormap(p.pso.salongenome, p.pso.saloncolours[p.pso.saloncolour]))
		end
	end
	
	local sprite = v.getSprite2Patch(p.pso.salongenome, SPR2_STND, false, A, 2)
	
	v.draw(px, py, sprite, 0, v.getColormap(p.pso.salongenome, p.pso.saloncolours[p.pso.saloncolour]))
	
	local cx = 160
	local cy = 40
	
	for i = 1, #choices
		local selected = choice == i
		
		v.drawString(cx, cy, (selected and "\x82"..">" or "")..choices[i])
		
		if i == 1	-- skin
			local arrl = ""
			local arrr = ""
			if selected
				arrl = leveltime%10 < 5 and "< " or "<"
				arrr = leveltime%10 < 5 and " >" or ">"
			end
			
			v.drawString(cx+48, cy+8, (selected and "\x82" or "")..arrl.."TYPE #"..p.pso.salongenome..arrr, 0, "center")
		
		elseif i == 2	-- colour
			
			local arrl = ""
			local arrr = ""
			if selected
				arrl = leveltime%10 < 5 and "< " or "<"
				arrr = leveltime%10 < 5 and " >" or ">"
			end
			
			v.drawString(cx+48, cy+8, (selected and "\x82" or "")..arrl..skincolors[p.pso.saloncolours[p.pso.saloncolour]].name..arrr, 0, "center")			
			
			-- display current colour
			local cpatch = v.cachePatch("H_SCOL")
			local basex = cx+48 -16
			
			for j = 1, 4
				v.draw(basex + (j-1)*8, cy+18, cpatch, 0, v.getColormap(TC_DEFAULT, p.pso.saloncolours[p.pso.saloncolour]))
			end
			
			-- display colours before...
			local ccol = p.pso.saloncolour
			
			for j = 1, 8
				ccol = $-1
				if ccol <= 0
					ccol = #p.pso.saloncolours
				end
				
				local tflag = 0
				if j > 4
					tflag = ((j-4)*2) << V_ALPHASHIFT
				end
				
				v.draw(basex-(8*j), cy+18, cpatch, tflag, v.getColormap(TC_DEFAULT, p.pso.saloncolours[ccol]))
			end

			local ccol = p.pso.saloncolour
			
			for j = 1, 8
				ccol = $+1
				if ccol > #p.pso.saloncolours
					ccol = 1
				end

				local tflag = 0
				if j > 4
					tflag = ((j-4)*2) << V_ALPHASHIFT
				end
				
				v.draw(basex+24+(8*(j-1)), cy+18, cpatch, tflag, v.getColormap(TC_DEFAULT, p.pso.saloncolours[ccol]))
			end
			
			cy = $+18
			
		end
		
		cy = $+20
	end

	-- draw warnings?
	local strings = {
		"-Appearance can be changed at any time.",
		"-Player name must be changed from SRB2's menus.",
	}
	for i = 1, #strings
		v.drawString(2, py+16+(i-1)*8, strings[i], (leveltime%10<5 and V_YELLOWMAP or V_ORANGEMAP)|V_50TRANS|V_ALLOWLOWERCASE, "thin")
	end
	
end

PSO.info.menus["salon"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawSalon(v, p, c, choices, choice, timer)
	end,
	
	openfunc = function(p)
		
		S_ChangeMusic("HERO", true, p)
	
		p.pso.salongenome = p.skin
		p.pso.saloncolour = 1	-- by default, assume we have whatever the first colour is.
		-- we will change it as we build our colour table
		
		-- find out what the max skin is?
		p.pso.maxgenome = #skins
		local minskin = 0
		for i = minskin, #skins
			if not skins[i] or not skins[i].valid
				p.pso.maxgenome = i-1
				break
			end
		end
		
		-- build colours list for convenience...
		p.pso.saloncolours = {}
		local nextcol = 1
		
		while nextcol
			p.pso.saloncolours[#p.pso.saloncolours+1] = nextcol
			
			-- if that's my colour, set the index here
			if nextcol == p.skincolor
				p.pso.saloncolour = #p.pso.saloncolours
			end
			
			nextcol = M_GetColorAfter(nextcol)
			if nextcol and skincolors[nextcol]
				while nextcol and not skincolors[nextcol].accessible
					nextcol = M_GetColorAfter(nextcol)
				end
			end
		end
		
		--table.remove(p.pso.saloncolours, #p.pso.saloncolours)
		p.pso.maxcolour = #p.pso.saloncolours	-- please work like that
		
	end,
	
	runfunc = function(p)
	
	
		local input = PSO.lib.playerInputDown
		local c = p.pso.menu.choice
		
		if c == 1	-- skin type
			
			if input(p, "left") == 1
			or input(p, "left") > TICRATE/2
				p.pso.salongenome = $-1
				if p.pso.salongenome < 0
					p.pso.salongenome = p.pso.maxgenome
				end
				S_StartSound(nil, sfx_mhvr, p)
			elseif input(p, "right") == 1
			or input(p, "right") > TICRATE/2
				p.pso.salongenome = $+1
				if p.pso.salongenome > p.pso.maxgenome
					p.pso.salongenome = 0
				end
				S_StartSound(nil, sfx_mhvr, p)
			end
		
		elseif c == 2	-- colour
			if input(p, "left") == 1
			or input(p, "left") > TICRATE/2
				p.pso.saloncolour = $-1
				if p.pso.saloncolour < 1
					p.pso.saloncolour = p.pso.maxcolour
				end
				S_StartSound(nil, sfx_mhvr, p)
			elseif input(p, "right") == 1
			or input(p, "right") > TICRATE/2
				p.pso.saloncolour = $+1
				if p.pso.saloncolour > p.pso.maxcolour
					p.pso.saloncolour = 1
				end
				S_StartSound(nil, sfx_mhvr, p)
			end		
		elseif c == 3
		and input(p, IPT_CONFIRM) == 1
		or input(p, IPT_BACK) == 1

			R_SetPlayerSkin(p, p.pso.salongenome)
			p.skincolor = p.pso.saloncolours[p.pso.saloncolour]
			p.mo.color = p.skincolor
		
			if not p.pso.type_initialized
				S_StartSound(nil, sfx_mconf, p)
				PSO.lib.changeMenu(p, "type_set")
			else
		
				S_StartSound(nil, sfx_mback, p)
					
				PSO.lib.closeMenu(p)
				S_ChangeMusic("LOBBY", true, p)
			end
		end
	end,
	
	choices = choices,
}