-- settings related menus

local function playerLeaderSelectable(p)
	if not p and p.valid
		return false
	end

	if p.quittime
		return false
	end

	if p == PSO.lib.getLeader()
		return false
	end

	if PSO.lib.playerAFK(p)
		return false
	end

	return true
end

PSO.info.menus["social"] = {
	openfunc = function(p)
		local choices = {
			{"SYMBOL ARTS", "social_sa"},
		}

		if PSO.lib.getLeader() == p
			table.insert(choices, {"GIVE LEADER", "social_leader"})
		else
			table.insert(choices, {"TAKE LEADER", nil})
		end

		p.pso.menu.minchoice = 1
		p.pso.menu.maxchoice = #choices
		p.pso.menu.choices = choices
	end,

	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, 5, 999)

		choices = p.pso.menu.choices

		local xpos = 2
		local w = 128
		local y = 20
		local h = 22

		v.drawFill(xpos, y, w, h, 253|V_SNAPTOLEFT)

		for i = 1, #choices

			local tflag = 0

			if i == 1 and (not server.sa_data or not #server.sa_data or not netgame)
			or i == 2 and (PSO.lib.getLeader() ~= p and server ~= p and not IsPlayerAdmin(p) or not netgame)
				tflag = V_50TRANS
			end

			v.drawString(xpos + 2, y+4, (i == choice and "\x82"..">" or "")..choices[i][1], V_SNAPTOLEFT|tflag)
			y = $ + 8
		end
	end,

	runfunc = function(p)
		local input = PSO.lib.playerInputDown

		if input(p, IPT_BACK) == 1

			PSO.lib.changeMenu(p, "main", true, true)
			p.pso.menu.timer = TICRATE*10	-- cheat.
			p.pso.menu.choice = 5
			S_StartSound(nil, sfx_mback, p)

		elseif input(p, IPT_CONFIRM) == 1

			if p.pso.menu.choice == 1
			and (not server.sa_data or not #server.sa_data or not netgame)
				S_StartSound(nil, sfx_mnot, p)
				return true
			end

			if p.pso.menu.choice == 2
				if (PSO.lib.getLeader() ~= p or not netgame)
					if not netgame
					or (server ~= p and not IsPlayerAdmin(p))
						S_StartSound(nil, sfx_mnot, p)
						return true
					end

					PSO.lib.setLeader(p, true)
					PSO.lib.closeMenu(p)
					return true
				end
			end

			PSO.lib.changeMenu(p, p.pso.menu.choices[p.pso.menu.choice][2])
			S_StartSound(nil, sfx_mconf, p)
		end
	end,
}

PSO.info.menus["social_sa"] = {

	openfunc = function(p)

		p.pso.sa_preview = 1

	end,

	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, 5, 999)

		local xpos = 2
		local w = 158
		local y = 20
		local h = 90

		v.drawFill(xpos, y, w, h, 253|V_SNAPTOLEFT)

		for i = 1, #choices

			local tflag = 0

			if i == 1
				-- a
			end

			v.drawString(xpos + 2, y+4, (i == choice and "\x82"..">" or "")..choices[i][1], V_SNAPTOLEFT|tflag)
			if i == 1

				if server.sa_data
				and server.sa_data[p.pso.sa_preview]

					v.drawString(xpos + 2, y+12, server.sa_data[p.pso.sa_preview].name, V_SNAPTOLEFT|V_YELLOWMAP|V_ALLOWLOWERCASE|tflag, "thin")
					PSO.lib.drawSymbolArt(v, xpos+12, y+4+20, p.pso.sa_preview, V_SNAPTOLEFT)
				end

				if i == choice
					local arrl = (leveltime%10 < 5) and "< " or "<"
					local arrr = (leveltime%10 < 5) and " >" or ">"

					v.drawString(xpos+128, y+4, "\x82"..arrl..p.pso.sa_preview..arrr, V_SNAPTOLEFT, "center")
				else
					v.drawString(xpos+128, y+4, p.pso.sa_preview, V_SNAPTOLEFT, "center")
				end

				y = $+60
			end
			y = $ + 8
		end
	end,

	runfunc = function(p)
		local input = PSO.lib.playerInputDown

		if input(p, IPT_BACK) == 1
		or input(p, IPT_CONFIRM) == 1 and p.pso.menu.choice == 3

			PSO.lib.changeMenu(p, "social", true, true)
			p.pso.menu.timer = TICRATE*10	-- cheat.
			S_StartSound(nil, sfx_mback, p)

		elseif p.pso.menu.choice == 1
		and (input(p, "left") == 1 or input(p, "right") == 1)

			if not server.sa_data
			or not #server.sa_data	-- br
				return
			end

			S_StartSound(nil, sfx_mhvr, p)
			if input(p, "left") == 1
				p.pso.sa_preview = $-1

				if p.pso.sa_preview < 1
					p.pso.sa_preview = #server.sa_data
				end
			elseif input(p, "right") == 1
				p.pso.sa_preview = $+1

				if p.pso.sa_preview > #server.sa_data
					p.pso.sa_preview = 1
				end
			end


		elseif input(p, IPT_CONFIRM) == 1

			if p.pso.menu.choice == 2
				if server.sa_data
				and server.sa_data[p.pso.sa_preview]
					COM_BufInsertText(p, "say /symbol"..p.pso.sa_preview)
					PSO.lib.closeMenu(p)
				else
					S_StartSound(nil, sfx_mnot, p)
				end
			end
		end
	end,

	choices = {

		{"Symbol Art #"},
		{"Send"},
		{"Back"},
	},
}

PSO.info.menus["social_leader"] = {

	openfunc = function(p)
		if p ~= PSO.lib.getLeader()
			PSO.lib.closeMenu(p)
			return
		end

		local choices = {}
		for player in players.iterate do
			table.insert(choices, {player.name, player})
		end
		
		-- test
		/*for i = 1, 32
			table.insert(choices, {"Player "..i, server})
		end*/
		table.insert(choices, {"Back", nil})

		p.pso.menu.minchoice = 1
		p.pso.menu.maxchoice = #choices
		p.pso.menu.choices = choices
	end,

	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, 5, 999)

		choices = p.pso.menu.choices

		local xpos = 2
		local w = 158
		local y = 20
		local h = 46

		v.drawFill(xpos, y, w, h, 253|V_SNAPTOLEFT)

		local showchoices = 5
		local start = p.pso.menu.scroll +1
		local finish = start + showchoices-1

		for i = start, min(#choices, finish)

			local tflag = 0
			local a = "thin"
			if (i == p.pso.menu.maxchoice)
				a = "left"
			elseif not playerLeaderSelectable(choices[i][2])
				tflag = V_50TRANS
			end

			v.drawString(xpos + 2, y+4, (i == choice and "\x82"..">" or "")..choices[i][1], V_SNAPTOLEFT|tflag, a)
			y = $ + 8
		end
	end,
	
	scroll = 5,
	
	runfunc = function(p)
		if p ~= PSO.lib.getLeader()
		and p ~= server
		and IsPlayerAdmin(p)	-- servr & admin can access this menu still
			PSO.lib.closeMenu(p)
			return
		end

		local input = PSO.lib.playerInputDown

		if input(p, IPT_BACK) == 1
		or input(p, IPT_CONFIRM) == 1 and p.pso.menu.choice == p.pso.menu.maxchoice

			PSO.lib.changeMenu(p, "social", true, true)
			p.pso.menu.timer = TICRATE*10	-- cheat.
			S_StartSound(nil, sfx_mback, p)

		elseif input(p, IPT_CONFIRM) == 1

			if playerLeaderSelectable(p.pso.menu.choices[p.pso.menu.choice][2])
				PSO.lib.setLeader(p.pso.menu.choices[p.pso.menu.choice][2], true)
				PSO.lib.closeMenu(p)
			else
				S_StartSound(nil, sfx_mnot, p)
			end

		end
	end,
}
