-- Used when the player asks to be healed!

local choices = {
		"BOARD",
		"CANCEL",
}

local w = 270
local h = 70
local function drawAISMenu(v, p, c, choice, timer)
	
	local x = 160-(w/2)
	local y = 100-(h/2)
	
	v.drawFill(x, y, w, h, 253)
	
	v.drawString(160, y+4, "BOARDING AIS", V_YELLOWMAP, "center")
	v.drawString(160, y+12, "Boarding the AIS will", V_ALLOWLOWERCASE, "center")
	v.drawString(160, y+20, "prevent you from returning.", V_ALLOWLOWERCASE, "center")
	v.drawString(160, y+28, "You will revive automatically if", V_ALLOWLOWERCASE, "center")
	v.drawString(160, y+36, "you become incapacitated.", V_ALLOWLOWERCASE, "center")
	
	local cy = y+50
	for i = 1, #choices
		
		v.drawString(160, cy, (i == choice and "\x82"..">" or "")..choices[i], 0, "center")
		cy = $+10
	end
end

local w2 = 160
local h2 = 32
local function drawWaitMenu(v, p, c, choice, timer)

	local x = 160-(w2/2)
	local y = 100-(h2/2)
	
	-- cutscene borders
	if p.mo.aiscutscene
		
		local t = p.mo.aiscutscene
		local h = min(20, t*2)
		
		v.drawFill(0, 0, 999, h, 31|V_SNAPTOTOP|V_SNAPTOLEFT)
		v.drawFill(0, 200-h, 999, h, 31|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		
		if t > TICRATE*6 -10 and t < TICRATE*6
			local str = t - (TICRATE*6-10)
			v.fadeScreen(0, min(10, str))
		elseif t >= TICRATE*6 and t < TICRATE*6 +10
			local str = t - (TICRATE*6)
			v.fadeScreen(0, max(0, 10-str))		
		end
		
	end
	
	if p.mo.tptime	
		
		-- draw countdown!
		local patches = {"H_CNUM3", "H_CNUM2", "H_CNUM1", "H_CNUMG"}
		for i = 1, #patches
			
			local tmr = p.mo.tptime - TICRATE*i
			local pp = v.cachePatch(patches[i])
			
			local scale1 = min(FRACUNIT, tmr*FRACUNIT/4)
			local scale2 = min(FRACUNIT*3, tmr*FRACUNIT/4)
			local tflag1 = 0
			local tflag2 = 5 << V_ALPHASHIFT
			
			if tmr >= TICRATE-10
				tflag1 = min(9, (tmr - (TICRATE-10))) << V_ALPHASHIFT
			end
			
			if tmr > 4
				tflag2 = $ + (tmr/4)<<V_ALPHASHIFT
			end
			
			if tmr >= 0
			and tmr < TICRATE
				v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale1, pp, tflag1)
			end
			
			if tmr >= 0
			and tmr < TICRATE/3
				v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale2, pp, tflag2)
			end
			
		end
	else	-- show how many players are missing
		v.drawFill(x, y, w2, h2, 253)
		
		v.drawString(160, y+4, "WAITING FOR PLAYERS...", V_YELLOWMAP, "center")
		
		local count = 0
		local accepted = 0
		
		for pl in players.iterate do
			
			if pl and pl.mo and pl.mo.valid
				count = $+1
				
				if pl.mo.tpok
					accepted = $+1
				end
				
			end
		end
		
		v.drawString(160, y+12, accepted.."/"..count, 0, "center")
	end
end

freeslot("sfx_cnt1", "sfx_cnt2", "sfx_cnt3", "sfx_cntgo") 

PSO.info.menus["boardais"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		if p.mo.tpok
			drawWaitMenu(v, p, c, choice, timer)
		else
			drawAISMenu(v, p, c, choice, timer)
		end
	end,
	
	closefunc = function(p)
		--p.pso.aistarget = nil
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if p.mo.aiscutscene
			
			local ais = p.pso.aistarget
			local t = p.mo.aiscutscene
			
			
			-- only perform actions for ONE player
			if not ais.targetp or not ais.targetp.valid
				ais.targetp = p
			end
			
			-- main "cutscene" loop
			if ais.targetp == p
				
				-- spawn away viewpoint
				if t == 1
					
					S_ChangeMusic("AIS", true, nil, 0, 0, 200)
					
					local vx = ais.x + 400*FRACUNIT
					local vy = ais.y - 320*FRACUNIT
					local viewpoint = P_SpawnMobj(vx, vy, ais.z, MT_THOK)
					viewpoint.flags = $ & ~MF_NOCLIPHEIGHT
					viewpoint.state = S_INVISIBLE
					viewpoint.tics = -1
					viewpoint.angle = ais.angle + ANG1*24
					
					for p2 in players.iterate
						p2.awayviewmobj = viewpoint
						p2.awayviewtics = -1
					end

					for m in mobjs.iterate()
						--print(m.type.."|"..MT_TELEPORTMAN)
						if m and m.valid and m.type == MT_PSO_AIS --and m.extrainfo == ais.extrainfo
						and m.options & 8 and m.extrainfo == ais.extrainfo
							for p2 in players.iterate
								P_SetOrigin(p2.mo, m.x, m.y, m.z)
							end
							break
						end
					end
					
					ais.flags = $|MF_NOGRAVITY
				
				elseif t == TICRATE/3
					
					-- have to call it twice for some fucking reason lol
					P_LinedefExecute(4151, p.mo)
					P_LinedefExecute(4151, ais)
					ais.targz = ais.z + FRACUNIT*32
					S_StartSound(nil, sfx_s3k50)
					S_StartSound(nil, sfx_s3k93)
					
					for i = 1, 16
						
						local d = P_SpawnMobj(ais.x, ais.y, ais.z, MT_SPINDUST)
						d.scale = $*8
						P_InstaThrust(d, P_RandomRange(0, 359)*ANG1, P_RandomRange(8, 16)*FRACUNIT)
						d.momz = P_RandomRange(2, 8)*FRACUNIT
					end
					
				elseif t > TICRATE/3 and t < TICRATE
					
					ais.momz = (ais.targz - ais.z)/6
				
				elseif t == TICRATE
					ais.momz = 0
					-- spawn wings

					-- spawn ais wings
					ais.wings = {}
					for i = 1, 4
						
						local w = P_SpawnMobj(ais.x, ais.y, ais.z, MT_THOK)
						w.tics = -1
						w.fuse = -1
						w.sprite = SPR_BFLW
						w.frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE|FF_ADD
						w.flags = $|MF_NOCLIPHEIGHT|MF_NOCLIP
						w.flags2 = $|MF2_DONTDRAW	-- wings are invisible by default unless necessary
						
						ais.wings[#ais.wings+1] = w
					end
				
				elseif t >= TICRATE*2
				and t < TICRATE*4
				
					if t == TICRATE*2
						local g = P_SpawnGhostMobj(ais)
						g.colorized = true
						g.destscale = ais.scale*8
						g.scalespeed = FRACUNIT
						
						P_StartQuake(FRACUNIT*20, TICRATE)
						S_StartSound(nil, sfx_s3k60)
						S_StartSound(nil, sfx_s3k81)
					
					elseif t == TICRATE*4 -1
						
						P_StartQuake(FRACUNIT*40, 8)
						S_StartSound(nil, sfx_s3k9c)
						for p2 in players.iterate do
							P_FlashPal(p2, 1, 4)
						end
					end
				
					P_Thrust(ais, ais.angle, FRACUNIT*3)
					ais.destscale = 1
					ais.scalespeed = FRACUNIT/128
					
					if leveltime & 1
						local g = P_SpawnGhostMobj(ais)
						g.colorized = true
						g.color = SKINCOLOR_MASTER
					end
					
				elseif t >= TICRATE*4					
					if t == (TICRATE*4) +1
						ais.scale = FRACUNIT*2
					end
					
					ais.sprite = SPR_SSPK
					ais.frame = (leveltime/2 % 3)|FF_FULLBRIGHT
					ais.colorized = true
					ais.color = SKINCOLOR_MASTER
					ais.spritexscale = FRACUNIT*4
					ais.spriteyscale = FRACUNIT*4
					ais.momx = $/32
					ais.momy = $/32
					ais.momz = FRACUNIT*5
					ais.destscale = 1
				end

					
				if t == TICRATE*6-10
					for p2 in players.iterate
						p2.awayviewtics = 10
						PSO.lib.playerActivateAIS(p2, true)
						p2.pso.hidehud = false
					end
						
				elseif t == TICRATE*6
						
					for p2 in players.iterate
						p2.pso.quest.timer_on = true	-- start timer if not done yet
						p2.mo.aiscutscene = nil
						PSO.lib.closeMenu(p2)
					end						
						
					return
				end
				
				-- update wings position
				if ais.wings

					-- handle wings
					local behind_dist = 80
					
					for i = 1, 2
						local rot = ANG1*20
						local dist = 120
						local ang = ais.angle + ANG1*90 + ANG1*180*(i-1)
						local zpos = ais.z + 160*FRACUNIT
						
						for j = 1, 2
							
							local wing = ais.wings[(i-1)*2 +j]
							local behindx = ais.x - behind_dist*cos(ais.angle)
							local behindy = ais.y - behind_dist*sin(ais.angle)
							
							local wx = behindx + dist*cos(ang)
							local wy = behindy + dist*sin(ang)
							P_MoveOrigin(wing, wx, wy, zpos)
							wing.angle = ang
							wing.rollangle = rot
							wing.spritexscale = ais.spritexscale
							wing.spriteyscale = ais.spriteyscale
							
							if t < TICRATE*4
								wing.flags2 = $ & ~MF2_DONTDRAW
							else
								wing.flags2 = $|MF2_DONTDRAW	
							end
							
							dist = $ + 80
							rot = $+ANG1*20
							zpos = $ + FRACUNIT*40
							
							
							if leveltime & 1
							or t == TICRATE
							or t >= TICRATE*2
							
								if t < TICRATE*4
									local g = P_SpawnGhostMobj(wing)
									
									if t == TICRATE	
										g.destscale = ais.scale*8
										g.scalespeed = FRACUNIT*2
									else
										P_InstaThrust(g, ais.angle, -FRACUNIT*32)
									end
								end
							end
						end
					end
				
				end
			end
			
			
			p.mo.aiscutscene = $+1
			--print(p.mo.aiscutscene)
			return true
		end
		
		-- ACCEPTANCE LOOP & COUNTDOWN
		if p.mo.tpok
			
			local count = 0
			local accepted = 0
			
			for pl in players.iterate do
				
				if pl and pl.mo and pl.mo.valid
					count = $+1
					
					if pl.mo.tpok
						accepted = $+1
					end
					
				end
			end	
			
			if accepted >= count

				p.mo.tptime = $ and $+1 or 1
				
				if p.mo.tptime == TICRATE
					S_StartSound(nil, sfx_cnt3, p)
				elseif p.mo.tptime == TICRATE*2
					S_StartSound(nil, sfx_cnt2, p)				
				elseif p.mo.tptime == TICRATE*3
					S_StartSound(nil, sfx_cnt1, p)	
				elseif p.mo.tptime == TICRATE*4
					S_StartSound(nil, sfx_cntgo, p)	
				elseif p.mo.tptime == TICRATE*5
				or not (p.pso.aistarget.options & 1)	-- regular AIS does not have countdown
					
					if p.pso.aistarget.options & 1
						-- begin cutscene...
						p.mo.aiscutscene = 1
						p.pso.hidehud = true	-- hide the hud
						
					else	-- normal AIS behaviour
						PSO.lib.softResetPlayer(p)
						p.pso.teleport = 1
						p.pso.teleporttype = 0	-- otherwise this will mess with the music, potentially!
						p.pso.teleporttarget = p.pso.aistarget
						p.pso.aistarget.flags = $ & ~MF_SOLID
						p.pso.aistarget.fuse = 10
							
						if server.questdata	-- happens during testing
							-- this forces any late joiner to spawn in in an AIS
							server.questdata.forceais = true
						end
						
						p.pso.quest.timer_on = true	-- start timer if not done yet
							
						PSO.lib.closeMenu(p)
					end
				end
			else
				p.mo.tptime = 0
			end
			return true	-- can't do shit!
		end
		
		if input(p, IPT_CONFIRM) == 1
			
			if p.pso.menu.choice == 1
				S_StartSound(nil, sfx_mconf, p)
				p.mo.tpok = true
			else				
				S_StartSound(nil, sfx_mconf, p)
				p.pso.aistarget = nil
				PSO.lib.closeMenu(p)
			end
		end
	end,
	
	choices = choices,
}