local max_push_notifs = 3

local function playerSlideNotificationsHUD(v, p)
	
	if p.pso.slidenotifications
		
		local starty = 70
		local i = min(max_push_notifs, #p.pso.slidenotifications)
		
		while i
			
			local tt = p.pso.slidenotifications[i]
			local x = 220 + tt.slidetimer*28
			local height = 12 + 8*(tt.nlines-1)
			
			local timer = tt.timer
			local fadeout = 0
			local fadeflag = 0
			
			if timer < 10
				fadeout = 10 - timer
				if fadeout > 0 and fadeout < 10
					fadeflag = fadeout<<V_ALPHASHIFT
				end
			end
			
			v.drawFill(x, starty + fadeout/2, 999, height - fadeout, 253|V_SNAPTORIGHT)
			if fadeout < 10
				v.drawString(x+4, starty+3, tt.text, V_SNAPTORIGHT|V_ALLOWLOWERCASE|V_RETURN8|fadeflag, "thin")
			end
			
			local antitimer = TICRATE/3 - tt.slidetimer
			starty = $ + (antitimer*(height+2)) / (TICRATE/3)
			
			i = $-1
		end
	end
end

local function playerNotificationHUD(v, p)
	
	if p.pso.notification
		local t = TICRATE*4 - p.pso.notification.timer
		
		local linx = 0
		local linw = 0
		
		local bannerh = 16
		if t < 8
			bannerh = t*2
		end
		
		if t > 8
		and t < 24
			linw = (t-8)*32
		elseif t >= 24
			linw = 999
		end
		
		if p.pso.notification.timer < 8
			bannerh = p.pso.notification.timer*2
		end
		
		if p.pso.notification.timer <= 16
			linx = (16-p.pso.notification.timer)*32
		end
		
		if bannerh
			v.drawFill(0, 100-(bannerh/2), 999, bannerh, 253|V_SNAPTOLEFT)
		end
		
		if linw
			for i = 1, 2
				v.drawFill(linx, 100 - (bannerh/2)+1 + (i-1)*(bannerh-3), linw, 1, 73|V_SNAPTOLEFT)
			end
		end
		
		if t > 7
		and (t & 1 or t > 20)
		and p.pso.notification.timer > 8
		and (p.pso.notification.timer > 16 or t & 1)
			v.drawString(160, 96, p.pso.notification.text, V_ALLOWLOWERCASE, "center")
		end
	end
end

PSO.lib.registerHudFunc(playerSlideNotificationsHUD)
PSO.lib.registerHudFunc(playerNotificationHUD)