

table.insert(PSO.info.quests[3].quests, {
	
	name = "The Arena",
	desc = "Using the battle data you collected, ARKS has put together a relentless training regimen, The Arena. \x82".."There are specific rules in The Arena, be sure to read the Datapods when you get there to learn about them.",
	objective = "Emerge victorious in the simulation!",
	
	map = 12,
	locked = true,
	timer_off = true,
	
	prog = 17,	-- hack, this is a quest unlocked only after 8-X.
	
	arena = true,	-- is an arena quest.
	-- this has several effects:
	/*
		- All consumable items are confiscated upon entering.
			-> Consumable items are restored the instant the quest is complete or abandonned
			-> Consumable items earned during the quest are lost.
			-> Saving is disabled until the quest is marked complete
		- Telepipes cannot be used, ever.
		- Items cannot be dropped or sent to storage.
		- Enemy EXP -60%
		- Enemy EXP is only awarded at the end of the quest
		- Using Resta costs 2 segments of the PB gauge.
		- Enables Arena Points currency (all players start with 10,000 AP)
			-> AP is earned by defeating bosses and spent in the item shop.
	*/
	
	arenalist = {
		MT_PSO_SNAPPERBOSS,
		MT_PSO_VIPERBOSS,
		MT_PSO_ICESTABBER,
		MT_PSO_DARKFALZ,
		MT_PSO_EXECUTOR,
		MT_PSO_ANGE,
		MT_PSO_GYRREY_GLARDIA_MAIN,
		MT_PSO_DARKFALZ_FINAL,
	},
	
	arenatimers = {
		TICRATE*60*5,
		TICRATE*60*5,
		TICRATE*60*5,
		TICRATE*60*8,
		TICRATE*60*6,
		TICRATE*60*4,
		TICRATE*60*6,
		TICRATE*60*12,
	},
	
	
	--unlocks = {{1, 2}},	-- unlocks 1-2
	
	levels = {
		[DIFF_NORMAL] = 50,
		[DIFF_HARD] = 80,
	},
	
	-- recommended level...
	recommended = {
		[DIFF_NORMAL] = 45,
		[DIFF_HARD] = 70,
	},
	
	-- levelsynch
	-- {low, high, maxgrind}
	-- "low" is ONLY used for netgames, players below that level are set to it.
	-- maxgrind is the maximum equipment level WHEN SYNCHED.
	-- (set to off by default in SP, on by default in MP)
	levelsynch = {
		[DIFF_NORMAL] = {40, 59},	-- min: 1, max 4
		[DIFF_HARD] = {45, 80},
	},

	grading = {
		{QG_DAMAGETAKEN, 20, 0, 3500, 7000},
	},
	
	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {"arenabadge_1", 4},
		[DIFF_HARD] = 	{"arenabadge_1", 10},
	},
	
	datapods = {
		{-193, -403, 0,
		"Welcome to the Arena! In this training program, you will fight against all the major threats you've encountered throughout your adventure."
		},

		{95, 66, 0,
		"\x85".."Your consumable items have been removed and will be given back to you after the quest finishes!".."\x8F".." You can use ".."\x84".."Arena Points (AP)".."\x8F".." to purchase consumables from the counter to the left. Consumables purchased here will be discarded once the quest ends.",
		},		

		{-97, 449, 0,
		"Furthermore, the ".."\x82".."Resta Technique will cost 25% of your Photon Blast gauge in addition to the regular PP cost, ".."\x8F".."so carefully consider whether you need to use it before acting!",
		},	

		{95, 613, 0,
		"Head to the counter to your right once your preparations are complete to get to fighting. You have a time limit to defeat your foe, so be quick. You will be rewarded with ".."\x84".."Arena Points".."\x8F".." based on how quickly you win!",
		},

		{-161, 1024, 0,
		"Keep in mind that the quest will end up in ".."\x85".."failure".."\x8F".." if all players are incapacitated or if time runs out. You will only earn rewards you can keep if you defeat all the bosses, so stay sharp!",
		},
		
	},

	npcdialogue = {
	
		["ogi"] = {
			"The Arena was actually something you contributed to without even knowing! No one else would have collected battle data from Dark Falz, after all.",
			"I trust you put on a good show?",
		},
		
		["alis"] = {
			"This new training program is ruthless...",
			"I assume you cleared it effortlessly? Knowing your adversaries in advance does help, haha.",
		},
		
		["ursula"] = {
			"We're hoping to build a stronger ARKS by training on the threats you faced.",
			"You're definitely setting the right example, breezing through it. I should give it a shot when I've got the time.",
		},
		
		["lumia"] = {
			"Competing in the Arena? I'm sure you'll steal the show, haha. ...But don't get too confident, I'll smash your record one day.",
			"Did you see me in the crowd? Of course you did!",
		},
		
		["flowen"] = {
			"It's good to know we have these battle records to train ARKS, even if it's just disguised as entertainment, we don't know what the future holds.",
			"I assume this is routine training for you at that point, haha.",
		},
		
		["bernie"] = {
			"I'm not doing anything today so I thought I'd swing by and watch you bully Dark Falz.",
			"Ha, you make it look so easy.",
		},
		
		["lukot"] = {
			"The arena's a great training regimen. It's all VR so there are no real injuries, while still being seemingly real to teach anyone trying it a good lesson.",
			"I assume for you, this is just another day.",
		},
		
		["sue"] = {
			"Competing, eh? Sure, I'll come and watch. But you better do the same when I do.",
			"What a showoff you are, pfft.",
		},
		
		["pharia"] = {
			"I helped put together the data for The Arena... I'm sure you'll find it fun...",
			"Remember not to get complacent... You may know the patterns, but you must be ready for future, unpredictable threats, too...",
		},
		
		["garoa"] = {
			"I'll be watching, so don't go fumbling early on, got it?",
			"What a show that was!",
		},
	},
	
	drops = {
		[DIFF_NORMAL] = {
			
			{"poss shooter", 0, 0, 1, 100},
			{"command shot", 0, 0, 1, 100},
			{"steel hearts", 51, 79,1, 400},
			{"seal case", 51, 79,1, 400},
			{"zanba", 51, 79, 1, 1000},
			{"last survivor", 51, 79, 1, 1000},
			{"monkey king bar", 51, 79,1, 400},
			{"girasole", 51, 79,1, 400},
			{"d. saber legacy", 51, 79, 1, 1000},
			{"eternal heat", 51, 79, 1, 1000},		
			{"basilleon", 51, 79,1, 400},
			{"longinus", 51, 79,1, 400},
			{"meteor lancer", 51, 79, 1, 1000},
			{"brionac", 51, 79, 1, 1000},			
			{"sarblight", 51, 79,1, 400},
			{"forblight", 51, 79,1, 400},	
			{"grand cross", 51, 79, 1, 1000},
			{"red saber", 51, 79, 1, 1000},
			{"full cylinder", 51, 79,1, 400},
			{"assassin", 51, 79,1, 400},
			{"yasminkov 3000r", 51, 79, 1, 1000},
			{"strauss", 51, 79, 1, 1000},			
			{"wide smack", 51, 79,1, 400},
			{"heimdall", 51, 79,1, 400},
			{"barett", 51, 79, 1, 1000},		
			{"photon launcher", 51, 79,1, 400},
			{"saint kilda", 51, 79,1, 400},
			{"charge howzer", 51, 79, 1, 1000},
			{"gur bazga", 51, 79, 1, 1000},		
			{"yasminkov 2000h", 51, 79,1, 400},
			{"sarcueid", 51, 79,1, 400},
			{"varista", 51, 79, 1, 1000},
			{"bravace", 51, 79, 1, 1000},			
			{"clarita visas", 51, 79,1, 400},
			{"red processor", 51, 79,1, 400},
			{"battle verge", 51, 79, 1, 1000},
			{"brave hammer", 51, 79, 1, 1000},
			{"windmill", 51, 79,1, 400},
			{"hexigraph", 51, 79,1, 400},
			{"serdote", 51, 79, 1, 1000},
			{"rose quartz", 51, 79, 1, 1000},		
			{"tcsm_crawla4", 51, 79,1, 400},
			{"tcsm_omochao", 51, 79, 1, 1000},

			{"unit_hp_3", 1, 0, 2, 50},
			{"unit_pp_3", 1, 0, 2, 50},
			{"unit_satk_3", 1, 0, 2, 50},
			{"unit_tatk_3", 1, 0, 2, 50},
			{"unit_ratk_3", 1, 0, 2, 50},	

			{"monogrinder", 0, 0, 6, 50},
			{"digrinder", 0, 0, 3, 50},
			{"trigrinder", 0, 0, 1, 50},
			{"scape doll", 0, 0, 1, 50},
			
			{2000, nil, nil, 1, 5},
			{"trimate", nil, nil, 1, 5},
		},

		[DIFF_HARD] = {
			
			{"warrior's epee", 0, 0, 1, 600},
			{"warrior's double", 0, 0, 1, 600},
			{"warrior's lance", 0, 0, 1, 600},
			{"warrior's sabre", 0, 0, 1, 600},
			{"warrior's fusil", 0, 0, 1, 600},
			{"warrior's pompe", 0, 0, 1, 600},
			{"warrior's lanceur", 0, 0, 1, 600},
			{"warrior's pistolet", 0, 0, 1, 600},
			{"warrior's cane", 0, 0, 1, 600},
			{"warrior's baguette", 0, 0, 1, 600},
			
			{"poss shooter", 0, 0, 1, 100},
			{"command shot", 0, 0, 1, 100},
			{"steel hearts", 51, 79,1, 200},
			{"seal case", 51, 79,1, 200},
			{"zanba", 51, 79, 1, 400},
			{"last survivor", 51, 79, 1, 400},
			{"monkey king bar", 51, 79,1, 200},
			{"girasole", 51, 79,1, 200},
			{"d. saber legacy", 51, 79, 1, 4000},
			{"eternal heat", 51, 79, 1, 4000},		
			{"basilleon", 51, 79,1, 200},
			{"longinus", 51, 79,1, 200},
			{"meteor lancer", 51, 79, 1, 400},
			{"brionac", 51, 79, 1, 400},			
			{"sarblight", 51, 79,1, 200},
			{"forblight", 51, 79,1, 200},	
			{"grand cross", 51, 79, 1, 400},
			{"red saber", 51, 79, 1, 400},
			{"full cylinder", 51, 79,1, 200},
			{"assassin", 51, 79,1, 200},
			{"yasminkov 3000r", 51, 79, 1, 400},
			{"strauss", 51, 79, 1, 400},			
			{"wide smack", 51, 79,1, 200},
			{"heimdall", 51, 79,1, 200},
			{"barett", 51, 79, 1, 400},		
			{"photon launcher", 51, 79,1, 200},
			{"saint kilda", 51, 79,1, 200},
			{"charge howzer", 51, 79, 1, 400},
			{"gur bazga", 51, 79, 1, 400},		
			{"yasminkov 2000h", 51, 79,1, 200},
			{"sarcueid", 51, 79,1, 200},
			{"varista", 51, 79, 1, 400},
			{"bravace", 51, 79, 1, 400},			
			{"clarita visas", 51, 79,1, 200},
			{"red processor", 51, 79,1, 200},
			{"battle verge", 51, 79, 1, 400},
			{"brave hammer", 51, 79, 1, 400},
			{"windmill", 51, 79,1, 200},
			{"hexigraph", 51, 79,1, 200},
			{"serdote", 51, 79, 1, 400},
			{"rose quartz", 51, 79, 1, 400},		
			{"tcsm_crawla4", 51, 79,1, 200},
			{"tcsm_omochao", 51, 79, 1, 400},

			{"unit_hp_3", 1, 0, 2, 50},
			{"unit_pp_3", 1, 0, 2, 50},
			{"unit_satk_3", 1, 0, 2, 50},
			{"unit_tatk_3", 1, 0, 2, 50},
			{"unit_ratk_3", 1, 0, 2, 50},	

			{"monogrinder", 0, 0, 6, 50},
			{"digrinder", 0, 0, 3, 50},
			{"trigrinder", 0, 0, 1, 50},
			{"scape doll", 0, 0, 1, 50},
			
			{2000, nil, nil, 1, 5},
			{"trimate", nil, nil, 1, 5},
		},	
		
	},
	
	layout = {
	}
})