local mapnum = 7

/*
	quest format:
	{
		>>COSMETIC STUFF
		name: 		quest name
		objective:	description of the objective
		desc: 		description
	
	
		>>ACTUAL GAMEPLAY RELEVANT STUFF
		map:		map number the quest takes place in
					(players will be warped to it as soon as everyone gets to the teleporter)
		
		layout = {}: 	object layout for the map.
						worth noting the object layout CANNOT be changed in the lobby.
		
		levels = {                                                                    ,..,.,.,.,.,.,..        
			[DIFF_NORMAL] = x,
			[DIFF_HARD] = x,
			[...]
		}: enemy level per difficulty
		
		
		
	}
*/

/*table.insert(PSO.info.quests[mapnum], {
	
	name = "Test quest",
	desc = "Doesn't load object layout, enemy level matches player level",
	objective = "Test your shit",
	
	map = 1,
	
	levels = {
		[DIFF_NORMAL] = 1,
		[DIFF_HARD] = 1,
		--[DIFF_VERYHARD] = 1,
		[DIFF_SUPERHARD] = 1,
		[DIFF_EXTREMELYHARD] = 1,
		[DIFF_ULTRAHARD] = 1,
	},
})*/


table.insert(PSO.info.quests[1].quests, {
	
	name = "5-1: Plant infiltration",
	desc = "Leveraging the defeat of the command unit, causing Badniks to wander about aimlessly, command wants to seize control of a power plant in the old overrun capital city rumoured to have a weapon capable of standing up to the remaining enemies hidden somewhere.",
	objective = "Search for the experimental weapon",
	
	map = mapnum,
	prog = 10,

	locked = true,		-- initially locked
	unlocks = {{1,12 }},	-- unlocks 5-2

	drops = {
		[DIFF_NORMAL] = {
			{"unit_hp_2", 1, 0, 2, 50},
			{"unit_pp_2", 1, 0, 2, 50},
			{"unit_satk_2", 1, 0, 2, 50},
			{"unit_tatk_2", 1, 0, 2, 50},
			{"unit_ratk_2", 1, 0, 2, 50},	

			{"monogrinder", 0, 0, 6, 50},
			{"digrinder", 0, 0, 3, 50},
			{"trigrinder", 0, 0, 1, 50},
			{"scape doll", 0, 0, 1, 50},
			
			{"poss shooter", 0, 0, 1, 100},
			{"command shot", 0, 0, 1, 100},
			{"hart frame", 0, 0, 1, 100},
			
			{2000, nil, nil, 1, 5},
			{"trimate", nil, nil, 1, 5},
		},

		[DIFF_HARD] = {	
			{"unit_hp_3", 1, 0, 2, 50},
			{"unit_pp_3", 1, 0, 2, 50},
			{"unit_satk_3", 1, 0, 2, 50},
			{"unit_tatk_3", 1, 0, 2, 50},
			{"unit_ratk_3", 1, 0, 2, 50},	

			{"trigrinder", 0, 0, 6, 50},
			{"scape doll", 0, 0, 1, 50},
			
			{"poss shooter", 0, 0, 4, 100},
			{"command shot", 0, 0, 4, 100},
			
			{"abnormal shard", 0, 0, 1, 600},
			{"steel hearts", 51, 79,1, 700},
			{"seal case", 51, 79,1, 700},
			{"zanba", 51, 79, 1, 1000},
			{"last survivor", 51, 79, 1, 1000},
			{"chainsawd", 51, 79, 1, 2000},
			{"dragon slayer", 51, 79, 1, 2000},
			{"monkey king bar", 51, 79,1, 700},
			{"girasole", 51, 79,1, 700},
			{"d. saber legacy", 51, 79, 1, 1000},
			{"eternal heat", 51, 79, 1, 1000},
			{"vivienne", 51, 79, 1, 2000},
			{"double cannon", 51, 79, 1, 2000},			
			{"basilleon", 51, 79,1, 700},
			{"longinus", 51, 79,1, 700},
			{"meteor lancer", 51, 79, 1, 1000},
			{"brionac", 51, 79, 1, 1000},
			{"vjaya", 51, 79, 1, 2000},
			{"soul eater", 51, 79, 1, 2000},			
			{"sarblight", 51, 79,1, 700},
			{"forblight", 51, 79,1, 700},	
			{"grand cross", 51, 79, 1, 1000},
			{"red saber", 51, 79, 1, 1000},
			{"elysion", 51, 79, 1, 2000},
			{"axeon", 51, 79, 1, 2000},
			{"full cylinder", 51, 79,1, 700},
			{"assassin", 51, 79,1, 700},
			{"yasminkov 3000r", 51, 79, 1, 1000},
			{"strauss", 51, 79, 1, 1000},
			{"firearms", 51, 79, 1, 2000},
			{"frozen shooter", 51, 79, 1, 2000},			
			{"wide smack", 51, 79,1, 700},
			{"heimdall", 51, 79,1, 700},
			{"barett", 51, 79, 1, 1000},
			{"crush bullet", 51, 79, 1, 1000},
			{"spread needle", 51, 79, 1, 2000},
			{"final impact", 51, 79, 1, 2000},			
			{"photon launcher", 51, 79,1, 700},
			{"saint kilda", 51, 79,1, 700},
			{"charge howzer", 51, 79, 1, 1000},
			{"gur bazga", 51, 79, 1, 1000},
			{"sspm launcher", 51, 79, 1, 2000},
			{"inferno bazooka", 51, 79, 1, 2000},			
			{"yasminkov 2000h", 51, 79,1, 700},
			{"sarcueid", 51, 79,1, 700},
			{"varista", 51, 79, 1, 1000},
			{"bravace", 51, 79, 1, 1000},
			{"pandora extreme", 51, 79, 1, 2000},
			{"ruby bullet", 51, 79, 1, 2000},			
			{"clarita visas", 51, 79,1, 700},
			{"red processor", 51, 79,1, 700},
			{"battle verge", 51, 79, 1, 1000},
			{"brave hammer", 51, 79, 1, 1000},
			{"siren hammer", 51, 79, 1, 2000},
			{"demonic fork", 51, 79, 1, 2000},
			{"windmill", 51, 79,1, 700},
			{"hexigraph", 51, 79,1, 700},
			{"serdote", 51, 79, 1, 1000},
			{"rose quartz", 51, 79, 1, 1000},
			{"rykros staff", 51, 79, 1, 2000},
			{"evil curst", 51, 79, 1, 2000},		
			{"tcsm_crawla4", 51, 79,1, 700},
			{"tcsm_omochao", 51, 79, 1, 1000},
			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},
			{"unit_critr_special1", 0, 0, 1, 400},
			{"unit_speed_special1", 0, 0, 1, 400},
			{"unit_speed_3", 0, 0, 1, 300},
			{"unit_critr_3", 0, 0, 1, 300},
			{"unit_critd_3", 0, 0, 1, 300},
			{"unit_all_3", 0, 0, 1, 300},
			{"unit_hppp_2", 0, 0, 1, 100},
			{"unit_hppp_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_2", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},
			
			{2000, nil, nil, 1, 5},
			{"trimate", nil, nil, 1, 5},
		},

		[DIFF_VERYHARD] = {	
			{"unit_hp_3", 1, 0, 2, 50},
			{"unit_pp_3", 1, 0, 2, 50},
			{"unit_satk_3", 1, 0, 2, 50},
			{"unit_tatk_3", 1, 0, 2, 50},
			{"unit_ratk_3", 1, 0, 2, 50},	

			{"trigrinder", 0, 0, 6, 50},
			{"scape doll", 0, 0, 1, 50},
			
			{"poss shooter", 0, 0, 4, 100},
			{"command shot", 0, 0, 4, 100},
			
			{"steel hearts", 0, 0, 1, 600},
			{"full cylinder", 0, 0, 1, 600},
			{"red processor", 0, 0, 1, 600},
			{"makel frame", 0, 0, 1, 500},
			{"hart frame", 0, 0, 1, 50},
			
			{2000, nil, nil, 1, 5},
			{"trimate", nil, nil, 1, 5},
		},
		
	},

	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {nil, nil},
		[DIFF_HARD] = 	{"weaponsbadge_1", 4},
	},

	levelsynch = {
		[DIFF_NORMAL] = {23, 36},
		[DIFF_HARD] = {45, 79},
	},

	recommended = {
		[DIFF_NORMAL] = 27,
		[DIFF_HARD] = 65,
		[DIFF_VERYHARD] = 70,
	},
	
	levels = {
		[DIFF_NORMAL] = 31,
		[DIFF_HARD] = 71,
		[DIFF_VERYHARD] = 101,
	},

	grading = {
		{QG_TIME, 50, 0, TICRATE*60*20, TICRATE*60*25},
		{QG_DAMAGETAKEN, 40, 0, 1000, 2000},
		{QG_NOINCAP, 10},
	},

	datapods = {
		{-11359, 1496, 24,
		"Honestly, what are we even defending anymore? The entire city's in ruins and we've lost three quarters of our troops... I should've left for that space station...",
		},

		{-4969, 93, -448,
		"These !@#!@!#@ destroyed the water treatment plant, leaking toxic garbage inside, and now that's all that's left here. What are we supposed to do without water!?",
		},
		
		{-6017, 2928, -448,
		"My weapon's out of power... These magma batteries really don't hold out very long... All I can do is stay here and hope these monsters trip on the laser traps... Someone, please help...",
		},		
		
		{-11350, 2147, 8,
		"Why are our turrets firing at us now!? It started ignoring Badniks and going straight for us instead?!?? Did they just overwrite it!?!?",
		},

		{-801, 9253, 8,
		"Badniks keep trying to force their way into the power plant up ahead... Whatever so called super weapon they're working on, they better finish it quick...",
		},

		{-4408, 6149, 0,
		"In the end we couldn't prevent them from forcing their way in... Almost no one left here is in fighting shape...",
		},
	},

	npcdialogue = {
	
		["ogi"] = {
			"Thanks to you, the Badniks are in complete disarray, this might be our best chance to seize the power plant.",
			"The city used to be near unaprocheable, but the defence lines are so speratic that cleaning it up was almost too easy.",
		},
		
		["alis"] = {
			"The city has many defence systems still active on top of Badniks, so do be careful.",
			"Now that we have access to the power plant itself, we should start to be able looking for this weapon...",
		},
		
		["ursula"] = {
			"The power plant is looking for is the place where the first of our weapons were created initially. You might be able to find some...",
			"Hearing some of these datapod logs sure was some whiplash...",
		},
		
		["lumia"] = {
			"It's exciting to think we might be reclaiming a part of our planet thanks to you!",
			"The place is pretty run down, huh... At least we've cleaned up most of the straggling Badniks from it.",
		},
		
		["flowen"] = {
			"I didn't think I would live to see the day where we'd consider a full on assault on the Capital.",
			"We're a step closer to ending this once and for all.",
		},
		
		["bernie"] = {
			"A full on assault, huh. I'm in.",
			"The enemies can't seem to regroup or do much of anything once scattered, this might be our best chance yet...",
		},
		
		["lukot"] = {
			"I can't say I know much about the Capital. All I know is that it's in ruins.",
			"...Some of these datapod logs were distressing.",
		},
		
		["sue"] = {
			"I'm all for kicking these scrap heaps out of what should rightfully be ours.",
			"I was literally tearing through 'em!",
		},
		
		["pharia"] = {
			"That city is where the first weapons effective against Badniks were developped. ...Many people were tasked with protecting it, but none returned...",
			"There isn't much left in the city, I hope the plant and the weapon we're looking for are intact...",
		},
		
		["garoa"] = {
			"An assault on the city, eh? And just in time for my recovery! I still have regular check-ups to do, but I'm allowed back on the field, now.",
			"This felt invigorating! To be back on the field and on such an important mission!",
		},
	},

	layout = {
		{0, -11744, -184, 90, 0, 0, 0, 1},
		{MT_PSO_CRATE, -11712, 1224, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -11904, 1288, 45, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -10432, 1000, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -8736, -440, 0, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, -8832, -296, 0, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8832, -152, 1, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8832, -8, 2, 0, 0, 1, 2504},
		{7, -9648, 504, 180, 0, 0, 0, 101},
		{7, -9648, 120, 180, 0, 0, 0, 101},
		{17, -9088, 808, 0, 0, 0, 0, 111},
		{17, -9088, -264, 0, 0, 0, 0, 111},
		{17, -10240, -280, 0, 0, 0, 0, 111},
		{17, -10240, 808, 0, 0, 0, 0, 111},
		{9, -9440, 488, 180, 0, 16, 1, 103},
		{9, -9440, 168, 180, 0, 16, 1, 103},
		{18, -9568, 328, 180, 0, 0, 1, 112},
		{18, -10080, 776, 315, 0, 0, 2, 112},
		{18, -10080, -216, 45, 0, 0, 2, 112},
		{17, -9152, 872, 0, 0, 0, 2, 111},
		{17, -8992, 744, 0, 0, 0, 2, 111},
		{17, -8960, -88, 0, 0, 0, 2, 111},
		{17, -9184, -312, 0, 0, 0, 2, 111},
		{MT_PSO_CRATE, -7584, 1032, 45, 0, 0, 0, 2505},
		{MT_PSO_UNLOCKCARD, -9408, -120, 1, 0, 0, 2, 2502},
		{MT_PSO_CARDREADER, -8896, 40, 180, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, -6144, 1576, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -4640, -440, 1, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, -5648, 1224, 10, 1, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -5504, 1224, 11, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -5360, 1224, 12, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -4864, 760, 20, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4864, 632, 21, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4864, 504, 22, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -5648, -56, 30, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -5520, -56, 31, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -5392, -56, 32, 0, 0, 1, 2504},
		{7, -5344, 808, 180, 0, 0, 0, 101},
		{7, -5344, 488, 180, 0, 0, 0, 101},
		{11, -5216, 648, 180, 0, 0, 0, 105},
		{9, -5344, 968, 225, 0, 16, 1, 103},
		{9, -5344, 328, 135, 0, 16, 1, 103},
		{12, -5152, 648, 180, 0, 0, 1, 106},
		{17, -5056, 1096, 0, 0, 0, 2, 111},
		{17, -5056, 104, 0, 0, 0, 2, 111},
		{11, -5216, 520, 180, 0, 0, 2, 105},
		{12, -5216, 744, 180, 0, 0, 2, 106},
		{MT_PSO_LASERTOWER, -5648, 1288, 40, 1, 0, 3, 2504},
		{MT_PSO_LASERTOWER, -5504, 1288, 41, 0, 0, 3, 2504},
		{MT_PSO_LASERTOWER, -5360, 1288, 42, 0, 0, 3, 2504},
		{MT_PSO_CARDREADER, -5024, 40, 135, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -5472, 648, 1, 0, 0, 2, 2502},
		{MT_PSO_ROOMANCHOR, -5728, -664, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -3744, -1528, 2, 0, 0, 0, 2500},
		{9, -4800, -824, 180, 0, 16, 0, 103},
		{9, -4384, -824, 180, 0, 16, 0, 103},
		{7, -4128, -1368, 180, 0, 0, 1, 101},
		{7, -4096, -1144, 180, 0, 0, 1, 101},
		{12, -4992, -856, 315, 0, 0, 0, 106},
		{MT_PSO_UNLOCKCARD, -3968, -1240, 2, 0, 0, 1, 2502},
		{MT_PSO_ROOMANCHOR, -4704, 1992, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -2976, -120, 3, 0, 0, 0, 2500},
		{9, -3712, 1064, 180, 0, 16, 0, 103},
		{9, -3712, 744, 180, 0, 16, 0, 103},
		{17, -3296, 1448, 0, 0, 0, 0, 111},
		{17, -3264, 328, 0, 0, 0, 0, 111},
		{11, -3776, 1832, 270, 0, 0, 1, 105},
		{11, -3776, 8, 90, 0, 0, 1, 105},
		{12, -3520, 872, 180, 0, 0, 1, 106},
		{MT_PSO_UNLOCKCARD, -4128, 616, 3, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, -5728, 1160, 270, 0, 0, 2, 2503},
		{MT_PSO_CARDREADER, -5248, 1160, 270, 0, 0, 3, 2503},
		{MT_PSO_CRATE, -6336, 2760, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -5856, 2856, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -10848, 2696, 315, 0, 0, 0, 2505},
		{MT_PSO_LASERTRAP, -6752, 2056, 0, 0, 0, 0, 2530},
		{MT_PSO_LASERTRAP_START, -7136, 2056, 0, 0, 70, 0, 2531},
		{MT_PSO_LASERTRAP_END, -6688, 2056, 0, 1, 5, 0, 2532},
		{MT_PSO_LASERTRAP, -7936, 2408, 1, 0, 0, 0, 2530},
		{MT_PSO_LASERTRAP_START, -7552, 2408, 1, 0, 70, 0, 2531},
		{MT_PSO_LASERTRAP_END, -8000, 2408, 1, 1, 5, 0, 2532},
		{MT_PSO_ROOMANCHOR, -9504, 3720, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -7648, 2472, 4, 0, 0, 0, 2500},
		{7, -8928, 3368, 270, 0, 0, 0, 101},
		{7, -8256, 3368, 270, 0, 0, 0, 101},
		{9, -8608, 3368, 270, 0, 16, 0, 103},
		{9, -9280, 3272, 315, 0, 16, 1, 103},
		{9, -7904, 3272, 225, 0, 16, 1, 103},
		{12, -9280, 3528, 315, 0, 0, 1, 106},
		{12, -7904, 3528, 225, 0, 0, 1, 106},
		{17, -9120, 2536, 0, 0, 0, 1, 111},
		{17, -8064, 2536, 0, 0, 0, 1, 111},
		{MT_PSO_HEAVYWEAPONS_CRAWLA, -8608, 3464, 270, 0, 0, 2, 107},
		{MT_PSO_TELEPORT_DEST, -11744, -280, 0, 0, 0, 0, 2511},
		{MT_PSO_CRATE, -2752, 3512, 0, 5, 0, 0, 2505},
		{11, -8608, 2664, 90, 0, 0, 2, 105},
		{MT_PSO_LASERTOWER, -8736, 3672, 50, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8576, 3672, 51, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8416, 3672, 52, 0, 0, 1, 2504},
		{MT_PSO_LASERTRAP, -9280, 3960, 2, 0, 0, 0, 2530},
		{MT_PSO_LASERTRAP_START, -9696, 3960, 2, 0, 70, 0, 2531},
		{MT_PSO_LASERTRAP_END, -9216, 3960, 2, 1, 5, 0, 2532},
		{MT_PSO_LASERTRAP, -10048, 3272, 4, 0, 0, 0, 2530},
		{MT_PSO_LASERTRAP_START, -10240, 3272, 4, 0, 0, 0, 2531},
		{MT_PSO_LASERTRAP_END, -9984, 3272, 4, 4, 5, 0, 2532},
		{MT_PSO_CRATE, -11648, 2248, 315, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -12224, 6696, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -11264, 2824, 5, 0, 0, 0, 2500},
		{MT_PSO_UNLOCKCARD, -8608, 2824, 1, 0, 0, 2, 2502},
		{17, -11648, 3752, 0, 0, 0, 0, 111},
		{17, -11520, 3752, 0, 0, 0, 0, 111},
		{17, -11968, 5032, 0, 0, 0, 1, 111},
		{17, -11840, 5032, 0, 0, 0, 1, 111},
		{MT_PSO_TURRET, -11744, 6232, 270, 0, 0, 1, 2535},
		{MT_PSO_LASERTOWER, -11312, 5704, 60, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -11312, 5496, 61, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -11312, 5256, 62, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -11312, 4792, 63, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -11312, 5000, 64, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, -11904, 5000, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, -11808, 5032, 270, 0, 0, 1, 2503},
		{MT_PSO_CRATE, -10976, 5384, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -10816, 5096, 315, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, -8496, 5704, 74, 0, 0, 4, 2504},
		{MT_PSO_LASERTOWER, -8496, 5512, 73, 0, 0, 4, 2504},
		{MT_PSO_LASERTOWER, -8496, 5288, 72, 0, 0, 4, 2504},
		{MT_PSO_LASERTOWER, -8496, 4824, 70, 1, 0, 4, 2504},
		{MT_PSO_LASERTOWER, -8496, 5048, 71, 0, 0, 4, 2504},
		{MT_PSO_LASERTOWER, -9360, 5704, 80, 1, 0, 4, 2504},
		{MT_PSO_LASERTOWER, -9136, 5704, 81, 0, 0, 4, 2504},
		{MT_PSO_LASERTOWER, -8928, 5704, 82, 0, 0, 4, 2504},
		{MT_PSO_LASERTOWER, -8496, 5704, 83, 0, 0, 4, 2504},
		{MT_PSO_LASERTOWER, -8704, 5704, 84, 0, 0, 4, 2504},
		{MT_PSO_ROOMANCHOR, -9568, 5608, 6, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -8672, 4904, 6, 0, 0, 0, 2500},
		{7, -9200, 5432, 180, 0, 0, 0, 101},
		{7, -8960, 5112, 180, 0, 0, 0, 101},
		{12, -8944, 5384, 180, 0, 0, 1, 106},
		{12, -8800, 5208, 180, 0, 0, 1, 106},
		{17, -9536, 5528, 0, 0, 0, 2, 111},
		{17, -9536, 5032, 0, 0, 0, 2, 111},
		{11, -9376, 5352, 0, 0, 0, 2, 105},
		{12, -9376, 5224, 0, 0, 0, 2, 106},
		{MT_PSO_UNLOCKCARD, -8992, 5256, 4, 0, 0, 2, 2502},
		{MT_PSO_ROOMANCHOR, -9408, 5736, 7, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -8448, 5608, 7, 0, 0, 0, 2500},
		{MT_PSO_CARDREADER, -9312, 5640, 270, 0, 0, 4, 2503},
		{MT_PSO_CARDREADER, -8544, 4872, 180, 0, 0, 4, 2503},
		{MT_PSO_ROOMANCHOR, -8576, 5736, 8, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -8384, 4776, 8, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -7136, 5832, 9, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -6016, 4776, 9, 0, 0, 0, 2500},
		{7, -6720, 5416, 225, 0, 0, 0, 101},
		{7, -6368, 5064, 225, 0, 0, 0, 101},
		{9, -6432, 5352, 225, 0, 1, 0, 103},
		{12, -6592, 5512, 225, 0, 0, 1, 106},
		{12, -6272, 5192, 225, 0, 0, 1, 106},
		{MT_PSO_LASERTOWER, -6928, 5704, 90, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -6704, 5704, 91, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -6496, 5704, 92, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -6304, 5704, 93, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -6064, 5704, 94, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, -6432, 5464, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, -6864, 5640, 270, 0, 0, 1, 2503},
		{MT_PSO_LASERTRAP, -9360, 6616, 10, 0, 0, 0, 2530},
		{MT_PSO_LASERTRAP_START, -9360, 7480, 10, 0, 20, 0, 2531},
		{MT_PSO_LASERTRAP_END, -9360, 6552, 10, 1, 2, 0, 2532},
		{MT_PSO_LASERTRAP, -8928, 7912, 20, 0, 8, 0, 2530},
		{MT_PSO_LASERTRAP_START, -8928, 8360, 20, 0, 70, 0, 2531},
		{MT_PSO_LASERTRAP_END, -8928, 7848, 20, 5, 4, 0, 2532},
		{MT_PSO_LASERTRAP, -8096, 7912, 30, 0, 8, 0, 2530},
		{MT_PSO_LASERTRAP_START, -8096, 8360, 30, 0, 70, 0, 2531},
		{MT_PSO_LASERTRAP_END, -8096, 7848, 30, 1, 4, 0, 2532},
		{MT_PSO_CRATE, -6240, 5960, 135, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6688, 6088, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6880, 5960, 270, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -5952, 8296, 10, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -5056, 7432, 10, 0, 0, 0, 2500},
		{18, -5408, 7976, 180, 0, 0, 0, 112},
		{11, -5504, 8072, 225, 0, 0, 0, 105},
		{11, -5312, 7880, 225, 0, 0, 0, 105},
		{17, -5696, 7560, 0, 0, 0, 1, 111},
		{17, -5504, 7560, 0, 0, 0, 1, 111},
		{17, -5312, 7560, 0, 0, 0, 1, 111},
		{17, -5120, 7560, 0, 0, 0, 1, 111},
		{7, -5600, 8104, 225, 0, 0, 1, 101},
		{7, -5280, 8104, 225, 0, 0, 1, 101},
		{12, -5216, 7976, 225, 0, 0, 2, 106},
		{12, -5376, 8168, 225, 0, 0, 2, 106},
		{7, -5504, 7912, 225, 0, 0, 2, 101},
		{7, -5568, 7976, 225, 0, 0, 2, 101},
		{7, -5440, 7848, 225, 0, 0, 2, 101},
		{MT_PSO_LASERTOWER, -5792, 8376, 100, 1, 0, 3, 2504},
		{MT_PSO_LASERTOWER, -5584, 8376, 101, 0, 0, 3, 2504},
		{MT_PSO_LASERTOWER, -5344, 8376, 102, 0, 0, 3, 2504},
		{MT_PSO_LASERTOWER, -5120, 8376, 103, 0, 0, 3, 2504},
		{MT_PSO_LASERTOWER, -4896, 8376, 104, 0, 0, 3, 2504},
		{MT_PSO_LASERTOWER, -4896, 7512, 110, 1, 0, 3, 2504},
		{MT_PSO_LASERTOWER, -4896, 7736, 111, 0, 0, 3, 2504},
		{MT_PSO_LASERTOWER, -4896, 7928, 112, 0, 0, 3, 2504},
		{MT_PSO_LASERTOWER, -4896, 8136, 113, 0, 0, 3, 2504},
		{MT_PSO_LASERTOWER, -4896, 8376, 114, 0, 0, 3, 2504},
		{MT_PSO_ROOMANCHOR, -5824, 8424, 11, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -4848, 8280, 11, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -5008, 8424, 12, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -4864, 7480, 12, 0, 0, 0, 2500},
		{MT_PSO_UNLOCKCARD, -5360, 8040, 3, 0, 0, 2, 2502},
		{MT_PSO_CARDREADER, -5760, 8320, 270, 0, 0, 3, 2503},
		{MT_PSO_CARDREADER, -4960, 7560, 180, 0, 0, 3, 2503},
		{MT_PSO_LASERTRAP, -3936, 7912, 40, 0, 8, 0, 2530},
		{MT_PSO_LASERTRAP_START, -3936, 8360, 40, 0, 70, 0, 2531},
		{MT_PSO_LASERTRAP_END, -3936, 7848, 40, 1, 4, 0, 2532},
		{MT_PSO_LASERTRAP, -3328, 8360, 50, 0, 8, 0, 2530},
		{MT_PSO_LASERTRAP_START, -3328, 7528, 50, 0, 70, 0, 2531},
		{MT_PSO_LASERTRAP_END, -3264, 8360, 50, 1, 4, 0, 2532},
		{MT_PSO_ROOMANCHOR, -5824, 11112, 13, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -4704, 10120, 13, 0, 0, 0, 2500},
		{18, -5312, 10760, 225, 0, 0, 0, 112},
		{18, -5120, 10536, 225, 0, 0, 0, 112},
		{12, -5024, 10728, 225, 0, 0, 1, 106},
		{12, -5536, 10248, 45, 0, 0, 1, 106},
		{9, -5504, 10856, 315, 0, 1, 1, 103},
		{9, -4992, 10280, 135, 0, 1, 1, 103},
		{MT_PSO_UNLOCKCARD, -5312, 10600, 1, 0, 0, 1, 2502},
		{MT_PSO_LASERTOWER, -4912, 11064, 120, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4912, 10840, 121, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4912, 10632, 122, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4912, 10440, 123, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4912, 10200, 124, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -4992, 11016, 180, 0, 0, 1, 2503},
		{MT_PSO_CRATE, -4544, 10888, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -4352, 10408, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -3008, 10312, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -3232, 9992, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -672, 9768, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -608, 9416, 270, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, -736, 11064, 130, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -736, 10840, 131, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -736, 10632, 132, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -736, 10440, 133, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -736, 10200, 134, 0, 0, 1, 2504},
		{MT_PSO_CRATE, -768, 9576, 270, 0, 0, 0, 2505},
		{MT_PSO_TURRET, -1024, 8072, 90, 0, 0, 2, 2535},
		{MT_PSO_ROOMANCHOR, -2208, 9000, 14, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 384, 7016, 14, 0, 0, 0, 2500},
		{7, -1760, 8488, 45, 0, 0, 0, 101},
		{7, -192, 8520, 135, 0, 0, 0, 101},
		{7, 192, 7624, 90, 0, 0, 0, 101},
		{7, -2048, 7560, 90, 0, 0, 0, 101},
		{17, -480, 7432, 0, 0, 0, 1, 111},
		{17, -1248, 7432, 0, 0, 0, 1, 111},
		{17, -1696, 7880, 0, 0, 0, 1, 111},
		{17, 0, 8200, 0, 0, 0, 1, 111},
		{41, -64, 7528, 135, 0, 0, 1, 123},
		{41, -1600, 7624, 45, 0, 0, 1, 123},
		{12, -640, 8712, 270, 0, 0, 2, 106},
		{12, -1952, 8296, 0, 0, 0, 2, 106},
		{7, -160, 7368, 135, 0, 0, 2, 101},
		{7, -1376, 7560, 90, 0, 0, 2, 101},
		{MT_PSO_UNLOCKCARD, -1280, 7560, 1, 0, 0, 2, 2502},
		{MT_PSO_LASERTOWER, -1968, 7064, 140, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1760, 7064, 141, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1552, 7064, 142, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -1440, 7112, 90, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, -3632, 6520, 15, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -2160, 6056, 15, 0, 0, 0, 2500},
		{18, -3360, 6424, 0, 0, 0, 0, 112},
		{18, -3360, 6152, 0, 0, 0, 0, 112},
		{9, -2336, 6408, 180, 0, 1, 1, 103},
		{9, -2336, 6152, 180, 0, 1, 1, 103},
		{17, -3472, 6392, 0, 0, 0, 1, 111},
		{17, -3472, 6184, 0, 0, 0, 1, 111},
		{MT_PSO_ROOMANCHOR, -4832, 5192, 16, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -1952, 3336, 16, 1, 0, 0, 2500},
		{12, -3456, 4360, 135, 0, 0, 0, 106},
		{11, -2656, 4552, 180, 0, 0, 0, 105},
		{11, -3168, 3720, 135, 0, 0, 0, 105},
		{7, -4224, 4232, 90, 0, 0, 0, 101},
		{7, -3328, 4584, 135, 0, 0, 0, 101},
		{41, -4416, 5032, 315, 0, 0, 1, 123},
		{41, -2816, 4104, 135, 0, 0, 1, 123},
		{18, -3040, 4552, 180, 0, 0, 1, 112},
		{18, -3744, 4232, 135, 0, 0, 1, 112},
		{17, -3360, 5064, 0, 0, 0, 1, 111},
		{17, -2240, 4136, 0, 0, 0, 1, 111},
		{17, -3328, 3976, 0, 0, 0, 1, 111},
		{17, -4512, 4648, 0, 0, 0, 1, 111},
		{MT_CRAWLACOMMANDER, -3360, 4424, 135, 0, 0, 2, 107},
		{12, -3840, 4328, 135, 0, 0, 2, 106},
		{12, -3168, 4680, 135, 0, 0, 2, 106},
		{MT_PSO_LASERTOWER, -3584, 6456, 150, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3584, 6280, 151, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3584, 6104, 152, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, -3168, 6280, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, -3520, 6424, 0, 0, 0, 1, 2503},
		{MT_PSO_LASERTOWER, -2048, 4312, 160, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2048, 4152, 161, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2048, 3944, 162, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2048, 3736, 163, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2048, 3528, 164, 0, 0, 0, 2504},
		{MT_PSO_TELEPORTER, -11744, -360, 1, 1, 0, 0, 2510},
		{MT_PSO_TELEPORTER, -2304, 3640, 1, 1, 0, 3, 2510},
		{MT_PSO_CRATE, -2800, 3784, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -2672, 4136, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -2592, 3912, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -2432, 4200, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -2384, 3992, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -2224, 3880, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -2912, 4216, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -2816, 4376, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -2368, 4360, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -2624, 3672, 0, 5, 0, 2, 2505},
		{MT_PSO_CARDREADER, -8800, 3624, 270, 0, 0, 1, 2503},
	}
})

table.insert(PSO.info.quests[1].quests, {
	
	name = "5-2: Plant takeover",
	desc = "Readings indicate that the weapon is located within the power plant found during the last expedition. You are to recover it.",
	objective = "Secure the powerful weapon",
	
	map = mapnum,
	questmusic = "MINES",

	prog = 11,

	locked = true,		-- initially locked
	unlocks = {{1,13 }},	-- unlocks 6-1

	drops = {},

	levelsynch = {
		[DIFF_NORMAL] = {26, 40},
		[DIFF_HARD] = {45, 79},
	},

	recommended = {
		[DIFF_NORMAL] = 30,
		[DIFF_HARD] = 65,
		[DIFF_VERYHARD] = 70,
	},
	
	levels = {
		[DIFF_NORMAL] = 34,
		[DIFF_HARD] = 73,
		[DIFF_VERYHARD] = 101,
	},

	grading = {
		{QG_TIME, 50, 0, TICRATE*60*20, TICRATE*60*25},
		{QG_DAMAGETAKEN, 40, 0, 1000, 2000},
		{QG_NOINCAP, 10},
	},

	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {nil, nil},
		[DIFF_HARD] = 	{"weaponsbadge_1", 6},
	},

	datapods = {
		{1634, 4463, -136,
		"We're trying our best to keep up with the demand for weapons, but we're losing them -and soldiers- faster than we can keep up with...",
		},

		{4716, 4881, -136,
		"Notice to all personnel: Defensive mines have been installed. They'll only be activated in case of emergencies, causing them blow up if anything passes near. You can faintly see them if you pay attention, so mind your surroundings if an evacuation order is issued.",
		},

		{4810, 250, -136,
		"We wanted to deploy our S-PODs to support soldiers in the fields, but Badniks are somehow able to hack into them... Red ones enhancing their speed and blue ones making them impossible to flinch with attacks... We'll have to work on a better design.",
		},

		{6703, 6971, -136,
		"This is chaos, we've been completely invaded, all those able to fight have fallen and I hear nothing but screams that start and abruptly end...",
		},

		{6365, 6971, -136,
		"Some kind of virus is rapidly taking control over the whole facility, we have weapons ready and can't even use them... This is madness, we're all done for, we're all done for"
		},

		{9913, 8364, -136,
		"A long time ago, heroes defeated armies of Badniks to free the land and one of them retrieved a schematic of a manned armour. We think it could be our fighting chance.",
		},

		{10236, 7376, -136,
		"Several prototype units have been completed so far, we're waiting for an opportunity to test them in real combat to gauge whether we should seek to mass produce them or rework our designs...",
		},

		{10817, 8364, -136,
		"...The test was a disaster... Officially, the armour malfunctionned and had to be abandonned. But in reality, it was hacked and taken over by Badniks... Anytime we find a countermeasure, they find another bypass... How are they adapting that fast!?",
		},

	},

	npcdialogue = {
	
		["ogi"] = {
			"If such a weapon exists, sweeping away the remainder of the Badniks could be made a lot easier.",
			"So a virus of sorts was controlling the whole facility... At least, the weapon is now secured.",
		},
		
		["alis"] = {
			"Some quick scans indicate the plant is still partly functionning, and so too could its defence systems, so be wise and watch your step.",
			"Whatever happened there at the time must have been quite horrible to live through...",
		},
		
		["ursula"] = {
			"Rumour has it the weapon we're looking for is something quite big, so I think it'll be hard to miss.",
			"So this weapon was actually the same thing you fought under the Peaks... Did that virus hack it and send it out?",
		},
		
		["lumia"] = {
			"So, so, what do you think this weapon is going to be? It's probably huuuuge if we're sending so many people out for it!",
			"Mmhh... It's eerily similar to that thing you defeated not long ago, huh.",
		},
		
		["flowen"] = {
			"If such a weapon truly exists, we could potentially finish the job once and for all...",
			"I knew a few of the people working down there, so reading some of these logs was distressing. But we did what we came here for.",
		},
		
		["bernie"] = {
			"The power plant is probably full of tight spaces like the city's sewer system. I'll get myself some close range weaponry just in case...",
			"So Badniks are just able to hack that technology, huh. I'm not so sure taking this weapon was such a great idea after all.",
		},
		
		["lukot"] = {
			"A lot of people used to work at this plant for research and development, not a single one survived unfortunately. ...I'd like to find out what happened, alongside our primary mission.",
			"...So they just got overpowered and had their own weapons turned against them. That's truly horrible...",
		},
		
		["sue"] = {
			"I hear the plant's full of defence mechanisms and Badniks.",
			"That virus thing seemed to have these Badniks be a lot more coordinated than those outside the plant.",
		},
		
		["pharia"] = {
			"Whatever weapon is housed inside is definitely worth studying even if it's in a bad state...",
			"...This is the same thing from your report from the Peaks... It's being studied as we speak with proper antivirus measures so that it can be used, eventually...",
		},
		
		["garoa"] = {
			"Close quarters is what I'm best at, and this plant should be the perfect place to do that.",
			"Truly horrible things seem to have happened down there. I'm glad we could at least recover what we came for.",
		},
	},
	
	layout = {
		{0, -64, 3936, 0, 0, 0, 0, 1},
		{MT_PSO_TELEPORT_DEST, -320, 3944, 0, 0, 0, 0, 2511},
		{MT_PSO_TELEPORTER, -448, 3944, 1, 1, 0, 0, 2510},
		{MT_PSO_ROOMANCHOR, 2192, 4648, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 3760, 3272, 0, 0, 0, 0, 2500},
		{MT_PSO_CRATE, 4912, 4808, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 4624, 3992, 45, 0, 0, 0, 2505},
		{41, 2960, 3944, 180, 0, 0, 0, 123},
		{7, 2864, 4200, 180, 0, 0, 0, 101},
		{7, 2848, 3688, 180, 0, 0, 0, 101},
		{18, 2864, 4472, 270, 0, 0, 1, 112},
		{18, 2880, 3448, 90, 0, 0, 1, 112},
		{41, 3168, 4200, 225, 0, 0, 1, 123},
		{41, 3168, 3688, 135, 0, 0, 1, 123},
		{17, 2400, 4488, 0, 0, 0, 2, 111},
		{17, 2400, 3400, 0, 0, 0, 2, 111},
		{7, 2496, 3944, 0, 0, 0, 2, 101},
		{MT_PSO_LASERTOWER, 3696, 4056, 0, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3696, 3832, 1, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, 3328, 3944, 1, 0, 0, 2, 2502},
		{MT_PSO_CRATE, 4208, 4776, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 4544, 4920, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 3968, 2984, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 6400, 1464, 1, 0, 0, 0, 2500},
		{6, 4480, 1736, 90, 0, 0, 0, 100},
		{6, 4928, 1736, 90, 0, 0, 0, 100},
		{6, 5264, 1736, 90, 0, 0, 0, 100},
		{7, 5248, 2568, 180, 0, 0, 0, 101},
		{7, 5104, 2840, 180, 0, 0, 0, 101},
		{12, 4432, 2744, 315, 0, 0, 1, 106},
		{12, 4608, 1736, 90, 0, 0, 1, 106},
		{MT_PSO_BUFFPOD, 5856, 2216, 90, 0, 408, 1, 2700},
		{41, 5872, 2776, 270, 0, 0, 1, 123},
		{41, 5984, 1640, 90, 0, 0, 1, 123},
		{MT_PSO_LASERTOWER, 4400, 1496, 10, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4624, 1496, 11, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, 5472, 1736, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, 3616, 3752, 180, 0, 0, 1, 2503},
		{MT_PSO_CARDREADER, 4320, 1544, 90, 0, 0, 1, 2503},
		{MT_PSO_CRATE, 5456, 1112, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 5888, 1144, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 4032, 1240, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 7296, 168, 2, 0, 0, 0, 2500},
		{MT_PSO_BUFFPOD, 6432, 712, 0, 1, 0, 0, 2700},
		{6, 6544, 664, 180, 1, 0, 0, 100},
		{6, 6544, 776, 180, 1, 0, 0, 100},
		{7, 5776, 536, 180, 1, 0, 0, 101},
		{7, 5760, 856, 180, 1, 0, 0, 101},
		{7, 5616, 712, 180, 1, 0, 0, 101},
		{41, 4432, 872, 0, 0, 0, 1, 123},
		{41, 6656, 856, 180, 0, 0, 1, 123},
		{11, 6672, 696, 180, 0, 0, 1, 105},
		{11, 4432, 728, 0, 0, 0, 1, 105},
		{MT_PSO_BUFFPOD, 4528, 744, 0, 0, 0, 2, 2700},
		{MT_PSO_BUFFPOD, 6720, 728, 0, 0, 0, 2, 2700},
		{17, 6416, 1032, 0, 0, 0, 2, 111},
		{17, 6464, 904, 0, 0, 0, 2, 111},
		{17, 6432, 280, 0, 0, 0, 2, 111},
		{17, 6112, 280, 0, 0, 0, 2, 111},
		{17, 5760, 280, 0, 0, 0, 2, 111},
		{17, 4720, 952, 0, 0, 0, 2, 111},
		{17, 4800, 1080, 0, 0, 0, 2, 111},
		{17, 4704, 280, 0, 0, 0, 2, 111},
		{17, 5024, 280, 0, 0, 0, 2, 111},
		{17, 5360, 280, 0, 0, 0, 2, 111},
		{MT_PSO_LASERTOWER, 6768, 1208, 20, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6992, 1208, 21, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 7072, 1176, 270, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 6880, 728, 1, 0, 0, 2, 2502},
		{MT_PSO_ROOMANCHOR, 5184, 5624, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 7248, 3480, 3, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 5496, 5528, 30, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 5704, 5528, 31, 0, 0, 1, 2504},
		{9, 5536, 4872, 315, 0, 1552, 0, 103},
		{9, 5856, 5192, 315, 0, 1552, 0, 103},
		{7, 6208, 4776, 315, 0, 1552, 0, 101},
		{7, 5984, 4488, 315, 0, 1552, 0, 101},
		{MT_PSO_BUFFPOD, 7008, 5288, 0, 0, 1552, 0, 2700},
		{MT_PSO_BUFFPOD, 5472, 3752, 0, 1, 1552, 0, 2700},
		{41, 6656, 3880, 135, 0, 1552, 1, 123},
		{41, 5856, 5096, 315, 0, 1552, 1, 123},
		{9, 5632, 4712, 315, 0, 1552, 1, 103},
		{9, 6848, 4168, 135, 0, 1552, 1, 103},
		{MT_PSO_BUFFPOD, 6976, 5256, 315, 1, 1552, 2, 2700},
		{MT_PSO_BUFFPOD, 5504, 3784, 315, 0, 1552, 2, 2700},
		{MT_CRAWLACOMMANDER, 6240, 4488, 270, 0, 1552, 2, 107},
		{9, 5984, 5160, 270, 0, 1552, 2, 103},
		{12, 6528, 3816, 90, 0, 1552, 2, 106},
		{MT_PSO_UNLOCKCARD, 6240, 4488, 1, 0, 1552, 2, 2502},
		{MT_PSO_CRATE, 6400, 6792, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 6560, 6952, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 6656, 6760, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 6848, 6920, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 2848, 6056, 45, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 3232, 6088, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4768, 5256, 4, 0, 0, 0, 2500},
		{41, 4352, 5960, 90, 0, 1552, 0, 123},
		{41, 4576, 5960, 90, 0, 1552, 0, 123},
		{MT_PSO_BUFFPOD, 4608, 5384, 90, 8, 1552, 0, 2700},
		{6, 4288, 5448, 90, 0, 1552, 0, 100},
		{6, 4544, 5512, 90, 0, 1552, 0, 100},
		{MT_PSO_CRATE, 4320, 6504, 45, 0, 1536, 0, 2505},
		{MT_PSO_CRATE, 4544, 6536, 45, 0, 1536, 0, 2505},
		{7, 3776, 5672, 0, 0, 1552, 0, 101},
		{7, 3776, 5416, 0, 0, 1552, 1, 101},
		{17, 4352, 5864, 0, 0, 1552, 1, 111},
		{17, 4576, 5864, 0, 0, 1552, 1, 111},
		{MT_PSO_BUFFPOD, 4480, 6024, 0, 9, 1552, 0, 2700},
		{MT_PSO_LASERTOWER, 3312, 5440, 40, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3312, 5648, 41, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, 3504, 5544, 1, 0, 1552, 1, 2502},
		{MT_PSO_CARDREADER, 3360, 5648, 0, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, 3280, 7096, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4208, 5816, 5, 0, 0, 0, 2500},
		{41, 3856, 6632, 270, 0, 0, 0, 123},
		{18, 4048, 6632, 270, 0, 0, 0, 112},
		{18, 3328, 6344, 0, 0, 0, 1, 112},
		{18, 3344, 6168, 0, 0, 0, 1, 112},
		{18, 3408, 6888, 0, 0, 0, 1, 112},
		{18, 3408, 6696, 0, 0, 0, 1, 112},
		{MT_PSO_BUFFPOD, 3632, 6264, 0, 1, 0, 1, 2700},
		{MT_PSO_BUFFPOD, 3632, 6792, 0, 1, 0, 1, 2700},
		{MT_PSO_MINETRAP, 4320, 3944, 180, 0, 0, 0, 2536},
		{MT_PSO_MINETRAP, 4416, 1832, 0, 0, 0, 0, 2536},
		{MT_PSO_MINETRAP, 6624, 6296, 180, 0, 0, 0, 2536},
		{MT_PSO_MINETRAP, 6080, 696, 180, 0, 0, 0, 2536},
		{MT_PSO_MINETRAP, 3856, 6344, 270, 0, 0, 0, 2536},
		{MT_PSO_LASERTOWER, 3312, 6656, 50, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3312, 6928, 51, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 3392, 6984, 0, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 3968, 6776, 1, 0, 0, 1, 2502},
		{MT_PSO_ROOMANCHOR, 2192, 9640, 6, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 3264, 6376, 6, 0, 0, 0, 2500},
		{17, 2688, 8728, 0, 0, 0, 0, 111},
		{17, 2896, 8728, 0, 0, 0, 0, 111},
		{17, 3104, 8728, 0, 0, 0, 0, 111},
		{12, 2784, 7608, 270, 0, 0, 0, 106},
		{12, 3024, 7608, 270, 0, 0, 0, 106},
		{MT_PSO_BUFFPOD, 2928, 6840, 90, 0, 0, 1, 2700},
		{41, 2720, 7144, 90, 0, 0, 1, 123},
		{41, 3072, 7144, 90, 0, 0, 1, 123},
		{9, 2288, 7736, 0, 0, 1, 1, 103},
		{9, 2304, 8152, 0, 0, 1, 1, 103},
		{9, 2304, 8552, 0, 0, 1, 1, 103},
		{9, 2720, 9192, 270, 0, 1, 2, 103},
		{9, 3040, 9176, 270, 0, 1, 2, 103},
		{MT_PSO_BUFFPOD, 3200, 7816, 90, 1, 0, 2, 2700},
		{MT_PSO_BUFFPOD, 2592, 7816, 90, 0, 0, 2, 2700},
		{7, 2720, 7992, 90, 0, 0, 2, 101},
		{7, 3024, 7976, 90, 0, 0, 2, 101},
		{12, 2720, 7608, 90, 0, 0, 2, 106},
		{12, 3088, 7608, 90, 0, 0, 2, 106},
		{MT_PSO_BUFFPOD, 2848, 7976, 0, 1, 0, 0, 2700},
		{MT_PSO_MINETRAP, 2976, 9544, 0, 0, 0, 0, 2536},
		{MT_PSO_CRATE, 2880, 9544, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3072, 9544, 45, 0, 0, 0, 2505},
		{MT_PSO_UNLOCKCARD, 2864, 9160, 1, 0, 0, 2, 2502},
		{MT_PSO_LASERTOWER, 3248, 9304, 60, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3248, 9016, 61, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 3184, 9352, 180, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, 5328, 9592, 7, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 7520, 7464, 7, 0, 0, 0, 2500},
		{7, 6800, 9048, 225, 0, 1552, 0, 101},
		{7, 6800, 8040, 135, 0, 1552, 0, 101},
		{17, 7184, 9160, 0, 0, 0, 0, 111},
		{17, 7184, 7880, 0, 0, 0, 0, 111},
		{17, 5616, 7880, 0, 0, 0, 0, 111},
		{9, 5568, 7928, 45, 0, 1, 0, 103},
		{9, 7184, 7944, 135, 0, 0, 1, 103},
		{9, 7184, 9096, 225, 0, 0, 1, 103},
		{MT_PSO_BUFFPOD, 6400, 9288, 270, 4, 1552, 1, 2700},
		{MT_PSO_BUFFPOD, 6400, 7752, 90, 4, 1552, 0, 2700},
		{41, 6880, 8936, 180, 0, 1552, 1, 123},
		{41, 7024, 8520, 180, 0, 1552, 1, 123},
		{41, 6896, 8152, 180, 0, 1552, 1, 123},
		{11, 5760, 8968, 0, 0, 1552, 1, 105},
		{11, 5664, 8536, 0, 0, 1552, 1, 105},
		{11, 5744, 8120, 0, 0, 1552, 1, 105},
		{MT_PSO_BUFFPOD, 6368, 9288, 270, 8, 1552, 2, 2700},
		{MT_PSO_BUFFPOD, 6368, 7752, 90, 8, 1552, 2, 2700},
		{MT_PSO_BUFFPOD, 7168, 8520, 180, 8, 1552, 2, 2700},
		{MT_PSO_BUFFPOD, 5616, 8536, 0, 8, 1552, 2, 2700},
		{MT_CRAWLACOMMANDER, 6368, 8520, 180, 8, 1552, 2, 107},
		{7, 6576, 8792, 180, 8, 1552, 2, 101},
		{7, 6592, 8264, 180, 8, 1552, 2, 101},
		{7, 6128, 8264, 180, 8, 1552, 2, 101},
		{7, 6128, 8792, 180, 8, 1552, 2, 101},
		{MT_PSO_LASERTOWER, 5392, 7984, 70, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 5392, 7776, 71, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 5440, 7984, 0, 0, 0, 1, 2503},
		{MT_PSO_CARDREADER, 7376, 9272, 180, 0, 0, 1, 2503},
		{MT_PSO_LASERTOWER, 7472, 9272, 80, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 7472, 9048, 81, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 7328, 7992, 180, 0, 0, 2, 2503},
		{MT_PSO_CARDREADER, 7328, 7768, 180, 0, 0, 3, 2503},
		{MT_PSO_LASERTOWER, 7392, 7992, 90, 1, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 7392, 7768, 91, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 7472, 7992, 100, 1, 0, 3, 2504},
		{MT_PSO_LASERTOWER, 7472, 7768, 101, 0, 0, 3, 2504},
		{MT_PSO_UNLOCKCARD, 6368, 8520, 1, 0, 1552, 2, 2502},
		{MT_PSO_ROOMANCHOR, 3472, 8664, 8, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 5248, 7256, 8, 0, 0, 0, 2500},
		{18, 4528, 8440, 315, 0, 1552, 0, 112},
		{18, 4672, 7944, 0, 0, 1552, 0, 112},
		{18, 4432, 7560, 0, 0, 1552, 0, 112},
		{17, 3648, 8504, 0, 0, 1552, 0, 111},
		{17, 3648, 8264, 0, 0, 1552, 0, 111},
		{17, 3648, 7752, 0, 0, 1552, 0, 111},
		{17, 3648, 7464, 0, 0, 1552, 0, 111},
		{41, 3952, 8504, 0, 0, 1552, 1, 123},
		{41, 3920, 7416, 0, 0, 1552, 1, 123},
		{MT_PSO_BUFFPOD, 4128, 7960, 90, 8, 1552, 1, 2700},
		{7, 4704, 8264, 180, 8, 1552, 1, 101},
		{7, 4672, 7576, 180, 8, 1552, 1, 101},
		{MT_PSO_UNLOCKCARD, 5152, 7880, 2, 0, 0, 1, 2502},
		{MT_PSO_ROOMANCHOR, 7488, 11080, 9, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 9024, 8648, 9, 0, 0, 0, 2500},
		{17, 8576, 9960, 0, 0, 0, 0, 111},
		{17, 8576, 9624, 0, 0, 0, 0, 111},
		{17, 8576, 9352, 0, 0, 0, 0, 111},
		{41, 7616, 10200, 270, 0, 0, 0, 123},
		{41, 7840, 9912, 270, 0, 0, 0, 123},
		{7, 8800, 10040, 180, 0, 0, 1, 101},
		{7, 8816, 9448, 180, 0, 0, 1, 101},
		{41, 7616, 9864, 0, 0, 0, 1, 123},
		{41, 7616, 9448, 0, 0, 0, 1, 123},
		{MT_PSO_BUFFPOD, 7760, 10632, 0, 8, 0, 0, 2700},
		{MT_PSO_BUFFPOD, 8752, 10616, 0, 8, 0, 1, 2700},
		{MT_PSO_UNLOCKCARD, 7600, 9160, 3, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, 5496, 5416, 270, 0, 0, 1, 2503},
		{MT_PSO_MINETRAP, 10720, 7880, 180, 0, 0, 0, 2536},
		{MT_PSO_TELEPORTER, 11584, 7872, 1000, 0, 0, 0, 2510},
		{MT_PSO_TELEPORT_DEST, 9984, 4352, 1000, 0, 0, 0, 2511},
		{MT_PSO_ROOMANCHOR, 9536, 6080, 8, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 12928, 2496, 8, 1, 0, 0, 2500},
		{MT_PSO_EXECUTOR, 10688, 4352, 180, 1, 0, 0, 2555},
		{56, 11520, 4352, 1, 1, 128, 0, 290},
		{56, 11328, 4352, 2, 1, 0, 0, 290},
		{56, 10688, 4992, 3, 1, 0, 0, 290},
		{56, 10688, 3712, 4, 1, 0, 0, 290},
		{56, 10688, 3712, 3, 1, 0, 0, 290},
		{59, 10144, 6208, 270, 0, 96, 0, 293},
		{59, 10688, 6208, 270, 8, 96, 1, 293},
		{59, 11232, 6208, 270, 0, 96, 0, 293},
		{59, 11776, 6208, 270, 0, 96, 0, 293},
		{59, 12320, 6208, 270, 0, 96, 0, 293},
		{59, 13024, 5440, 180, 0, 96, 0, 293},
		{59, 13024, 4896, 180, 0, 96, 0, 293},
		{59, 13024, 4352, 180, 8, 96, 1, 293},
		{59, 13024, 3808, 180, 0, 96, 0, 293},
		{59, 13024, 3264, 180, 0, 96, 0, 293},
		{59, 12320, 2560, 90, 0, 96, 0, 293},
		{59, 11776, 2560, 90, 0, 96, 0, 293},
		{59, 11232, 2560, 90, 0, 96, 0, 293},
		{59, 10688, 2560, 90, 8, 96, 1, 293},
		{59, 10144, 2560, 90, 0, 96, 0, 293},
		{57, 11328, 4992, 0, 0, 0, 0, 291},
		{57, 10688, 4992, 0, 0, 0, 0, 291},
		{57, 10048, 4992, 0, 0, 0, 0, 291},
		{57, 10048, 4352, 0, 0, 0, 0, 291},
		{57, 10048, 3712, 0, 0, 0, 0, 291},
		{57, 10688, 3712, 0, 0, 0, 0, 291},
		{57, 11344, 3712, 0, 0, 0, 0, 291},
		{57, 11328, 4352, 0, 0, 0, 0, 291},
		{MT_PSO_CRATE, 9952, 5088, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 10144, 4896, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 10688, 5088, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 10688, 4896, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 11232, 4896, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 11424, 5088, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 11232, 4352, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 11424, 4352, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 11232, 3808, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 11424, 3616, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 10688, 3808, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 10688, 3616, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 10144, 3808, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 9952, 3616, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 10144, 4352, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 9920, 4352, 0, 1, 0, 0, 2505},
		{MT_PSO_TELEPORTER, 10944, 4352, 1, 1, 0, 1, 2510},
	}
})

PSO.info.crateDropTables[mapnum] = {
		[DIFF_NORMAL] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 5},
			{"monomate", 0, 0, 1, 20},
			{"dimate", 0, 0, 1, 30},
			{"trimate", 0, 0, 1, 50},
			
			{"scape doll", 0, 0, 1, 100},

			{"resurgent ledge", 0, 0, 1, 300},
			{"resurgent lance", 0, 0, 1, 300},
			{"resurgent cutter", 0, 0, 1, 300},
			{"resurgent bullet", 0, 0, 1, 300},
			{"resurgent burst", 0, 0, 1, 300},
			{"resurgent proud", 0, 0, 1, 300},
			{"resurgent staff", 0, 0, 1, 300},
			{"resurgent cutlass", 0, 0, 1, 300},
			{"resurgent brave", 0, 0, 1, 300},
			{"resurgent baguette", 0, 0, 1, 300},

			{"sword_pa_risingedge", 0, 0, 1, 300},
			{"dsaber_pa_surprisedunk", 0, 0, 1, 300},
			{"spear_pa_bandersnatch", 0, 0, 1, 300},
			{"rifle_pa_skyfiresalvo", 0, 0, 1, 300},
			{"shotgun_pa_slugburst", 0, 0, 1, 300},
			{"launcher_pa_fallenimpact", 0, 0, 1, 300},
			{"ilgrants", 0, 0, 1, 300},
			{"samegid", 0, 0, 1, 300},
			{"safoie", 0, 0, 1, 300},
			{"sabarta", 0, 0, 1, 300},
			{"nazonde", 0, 0, 1, 300},
			{"nosdiga", 0, 0, 1, 300},
			{"shifta", 0, 0, 1, 300},
			{"deband", 0, 0, 1, 300},
			
			{"unit_hppp_2", 0, 0, 1, 100},
			{"unit_rainbow_2", 0, 0, 1, 100},
			{"unit_power_2", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_critr_2", 0, 0, 1, 50},
			{"unit_critd_2", 0, 0, 1, 200},
			{"unit_speed_2", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 20},
			{"star atomizer", 0, 0, 1, 20},
			{"sol atomizer", 0, 0, 1, 50},
			{"shiftaride", 0, 0, 1, 50},
			{"debanride", 0, 0, 1, 50},
			
			{"pine", 0, 0, 1, 100},
			{"alva pine", 0, 0, 1, 100},
			{"shooter", 0, 0, 1, 100},
			{"alva shooter", 0, 0, 1, 100},
			{"crest", 0, 0, 1, 100},
			{"alva crest", 0, 0, 1, 100},
			{"hammer", 0, 0, 1, 100},
			{"alva hammer", 0, 0, 1, 100},
			{"claw", 0, 0, 1, 100},
			{"alva claw", 0, 0, 1, 100},
			{"peacekeeper", 0, 0, 1, 100},
			{"alva peacekeeper", 0, 0, 1, 100},
			{"fork", 0, 0, 1, 100},
			{"grenade", 0, 0, 1, 100},			
			{"alva fork", 0, 0, 1, 100},
			{"alva grenade", 0, 0, 1, 100},	

		},

		[DIFF_HARD] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 5},
			{"monomate", 0, 0, 1, 30},
			{"dimate", 0, 0, 1, 50},
			{"trimate", 0, 0, 1, 80},
			
			{"scape doll", 0, 0, 1, 100},

			{"resurgent ledge", 0, 0, 1, 300},
			{"resurgent lance", 0, 0, 1, 300},
			{"resurgent cutter", 0, 0, 1, 300},
			{"resurgent bullet", 0, 0, 1, 300},
			{"resurgent burst", 0, 0, 1, 300},
			{"resurgent proud", 0, 0, 1, 300},
			{"resurgent staff", 0, 0, 1, 300},
			{"resurgent cutlass", 0, 0, 1, 300},
			{"resurgent brave", 0, 0, 1, 300},
			{"resurgent baguette", 0, 0, 1, 300},

			{"baston frame", 0, 0, 1, 500},
			{"makel frame", 0, 0, 1, 1000},
			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},
			{"unit_critr_special1", 0, 0, 1, 400},
			{"unit_speed_special1", 0, 0, 1, 400},
			{"unit_speed_3", 0, 0, 1, 300},
			{"unit_critr_3", 0, 0, 1, 300},
			{"unit_critd_3", 0, 0, 1, 300},
			{"unit_all_3", 0, 0, 1, 300},
			{"unit_hppp_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},
			{"unit_ppratk_3", 0, 0, 1, 100},
			{"unit_ppsatk_3", 0, 0, 1, 100},
			{"unit_pptatk_3", 0, 0, 1, 100},

			{"unit_satk_3", 0, 0, 1, 100},
			{"unit_ratk_3", 0, 0, 1, 100},
			{"unit_tatk_3", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 20},
			{"star atomizer", 0, 0, 1, 20},
			{"sol atomizer", 0, 0, 1, 50},
			{"shiftaride", 0, 0, 1, 50},
			{"debanride", 0, 0, 1, 50},
			
			{"vita pine", 0, 0, 1, 100},
			{"vita shooter", 0, 0, 1, 100},
			{"vita crest", 0, 0, 1, 100},
			{"vita hammer", 0, 0, 1, 100},
			{"vita claw", 0, 0, 1, 100},
			{"vita peacekeeper", 0, 0, 1, 100},	
			{"vita fork", 0, 0, 1, 100},
			{"vita grenade", 0, 0, 1, 100},			
		},

		[DIFF_VERYHARD] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 5},
			{"monomate", 0, 0, 1, 40},
			{"dimate", 0, 0, 1, 60},
			{"trimate", 0, 0, 1, 80},
			
			{"scape doll", 0, 0, 1, 100},

			{"resurgent ledge", 0, 0, 1, 300},
			{"resurgent lance", 0, 0, 1, 300},
			{"resurgent cutter", 0, 0, 1, 300},
			{"resurgent bullet", 0, 0, 1, 300},
			{"resurgent burst", 0, 0, 1, 300},
			{"resurgent proud", 0, 0, 1, 300},
			{"resurgent staff", 0, 0, 1, 300},
			{"resurgent cutlass", 0, 0, 1, 300},
			{"resurgent brave", 0, 0, 1, 300},
			{"resurgent baguette", 0, 0, 1, 300},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 20},
			{"star atomizer", 0, 0, 1, 20},
			
			{"vita pine", 0, 0, 1, 100},
			{"vita shooter", 0, 0, 1, 100},
			{"vita crest", 0, 0, 1, 100},
			{"vita hammer", 0, 0, 1, 100},
			{"vita claw", 0, 0, 1, 100},
			{"vita peacekeeper", 0, 0, 1, 100},	
			{"vita fork", 0, 0, 1, 100},
			{"vita grenade", 0, 0, 1, 100},	
			
			{"baston frame", 0, 0, 1, 300},
			{"makel frame", 0, 0, 1, 1000},
			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},
			{"unit_all_3", 0, 0, 1, 300},
			{"unit_hppp_2", 0, 0, 1, 100},
			{"unit_hppp_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_2", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},			
		},
		
}