local mapnum = 2
--table.insert(PSO.info.questmaps, {mapnum})
--PSO.info.quests[mapnum] = {}

/*
	quest format:
	{
		>>COSMETIC STUFF
		name: 		quest name
		objective:	description of the objective
		desc: 		description
	
	
		>>ACTUAL GAMEPLAY RELEVANT STUFF
		map:		map number the quest takes place in
					(players will be warped to it as soon as everyone gets to the teleporter)
		
		layout = {}: 	object layout for the map.
						worth noting the object layout CANNOT be changed in the lobby.
		
		unlocks = {{map, quest, [diff]}, {map, quest, [diff]}, ...}:
		finishing this quest unlocks the specified quests # of the specified maps for the specified difficulty
		only works if that quest was marked as locked to begin with
		
		levels = {                                                                    ,..,.,.,.,.,.,..        
			[DIFF_NORMAL] = x,
			[DIFF_HARD] = x,
			[...]
		}: enemy level per difficulty
		
		
		
	}
*/

/*table.insert(PSO.info.quests[mapnum], {
	
	name = "Test quest",
	desc = "Doesn't load object layout, enemy level matches player level",
	objective = "Test your shit",
	
	map = 1,
	
	levels = {
		[DIFF_NORMAL] = 1,
		[DIFF_HARD] = 1,
		--[DIFF_VERYHARD] = 1,
		[DIFF_SUPERHARD] = 1,
		[DIFF_EXTREMELYHARD] = 1,
		[DIFF_ULTRAHARD] = 1,
	},
})*/

--print("Crawla commander....")
--print(MT_CRAWLACOMMANDER)

table.insert(PSO.info.quests[1].quests, {
	
	name = "1-1: Integration sweep",
	desc = "Command wants to send new recruits on a sweep-up operation on the western coast where Badnik activity is low to build combat practice.",
	objective = "Defeat the Badnik command unit",
	
	map = mapnum,
	prog = 0,	-- progress set to this value upon unlocking this quest for the first time
	-- only to be used with campaign quests!!
	
	unlocks = {{1, 2}},	-- unlocks 1-2
	
	levels = {
		[DIFF_NORMAL] = 1,
		[DIFF_HARD] = 55,
		[DIFF_VERYHARD] = 101,
	},
	
	-- recommended level...
	recommended = {
		[DIFF_NORMAL] = 1,
		[DIFF_HARD] = 50,
		[DIFF_VERYHARD] = 70,
	},
	
	-- levelsynch
	-- {low, high, maxgrind}
	-- "low" is ONLY used for netgames, players below that level are set to it.
	-- maxgrind is the maximum equipment level WHEN SYNCHED.
	-- (set to off by default in SP, on by default in MP)
	levelsynch = {
		[DIFF_NORMAL] = {1, 4},	-- min: 1, max 4
		[DIFF_HARD] = {45, 69},
	},

	grading = {
		{QG_TIME, 20, 0, TICRATE*60*12, TICRATE*60*15},
		{QG_DAMAGETAKEN, 20, 0, 350, 600},
		{QG_NOINCAP, 10},
	},
	
	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {nil, nil},	-- normal: jack shit
		[DIFF_HARD] = 	{"weaponsbadge_1", 2},	-- hard: 2 crimson weapons badge
	},
	
	datapods = {
		{-5831, 445, 0, 
		"Supplies are often sent directly on the field via crates, whatever's inside is yours after you smash them open with an attack!"
		},
		
		{255, 2095, 0,
		"New recruits are sent here for training missions, but as of late, the Badnik activity here has gotten much higher...",
		},

		{-3321, 4770, 129,
		"Badniks are able to build these laser fences out of basically thin air... Everytime we're sent anywhere, we have to use a different path...",
		},

		{3705, 7538, -264,
		"Apparently, there have been sightings of a particularly strong enemy here... Maybe we should pull back...",
		},
	},
	
	-- ["npcname"] = {quest undertaken dialogue, quest clear dialogue}
	npcdialogue = {
	
		["ogi"] = {
			"No need to worry, the enemies around that area aren't very dangerous. Remember your training and things will be alright!",
			"Congratulations on finishing your first assignment. I'm sure we'll be working together before long.",
		},
		
		["alis"] = {
			"Initiation, mh? Remember to stock up on items before heading out.",
			"I hear you did well for your first mission!",
		},
		
		["ursula"] = {
			"Going out on training? Remember to check for enemies' weaknesses, weapons and Techniques matching the elemental weakness will be far more effective!",
			"See? You did just fine!",
		},
		
		["lumia"] = {
			"You're the rookie aren't you? Don't worry, everyone's been through one of these.",
			"You did just fine it seems! Guess we might end up working together someday...",
		},
		
		["flowen"] = {
			"Training? Ah, that brings me back... Well, remember to stay focused. Small enemies can usually be interrupted out of their attacks by attacking them yourself, so keep up the pressure.",
			"Someone seems in high spirits. I take it it went well?",
		},
		
		["bernie"] = {
			"That's just training. Don't worry about it, it'll be fine.",
			"Well? How'd it go? Found anything good?",
		},
		
		["lukot"] = {
			"That's your first mission is it not? Remember to be careful. If you're in danger and out of supplies, use a Telepipe to return here and get what you need...",
			"It's good to see you're capable. It's always worrying not knowing whether a new recruit is going to come back unharmed or not...",
		},
		
		["sue"] = {
			"Training eh? Careful out there, I heard some don't make it out alive, hehe.",
			"Well, seems like you came back with your head still attached to your body!",
		},
		
		["pharia"] = {
			"First mission? Good luck...",
			"Ah, you came back. Good.",
		},
		
		["garoa"] = {
			"First mission, right? You'll do just fine. Just watch your back, you wouldn't want to break yours like I did, haha!",
			"Well well, it seems we have someone capable!",
		},
	},
	
	layout = {
		{MT_PSO_LASERTOWER, 1056, 1280, 4, 0, 0, 0, 2504},
		{0, -5632, -64, 0, 0, 0, 0, 1},
		{6, 608, 4416, 270, 0, 0, 0, 100},
		{7, -2528, 5152, 270, 0, 0, 0, 101},
		{MT_PSO_ROOMANCHOR, -1888, 1504, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 1408, -768, 0, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 96, 1280, 0, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 320, 1280, 1, 0, 0, 0, 2504},
		{MT_PSO_CARDREADER, 32, 1120, 270, 1, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 0, 832, 1, 0, 0, 1, 2502},
		{MT_PSO_LASERTOWER, 576, 1280, 2, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 800, 1280, 3, 0, 0, 0, 2504},
		{MT_PSO_CRATE, -4864, 608, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -5376, 576, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 320, 4064, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 768, 4096, 315, 0, 0, 0, 2505},
		{6, -160, 544, 180, 0, 0, 0, 100},
		{6, -96, 192, 180, 0, 0, 0, 100},
		{6, 576, 1088, 270, 0, 0, 1, 100},
		{6, 224, 1088, 270, 0, 0, 1, 100},
		{6, 928, 1088, 270, 0, 0, 1, 100},
		{17, 352, 4256, 90, 0, 0, 0, 111},
		{17, 800, 4256, 90, 0, 0, 0, 111},
		{7, 608, 3488, 90, 0, 0, 1, 101},
		{MT_PSO_UNLOCKCARD, 544, 3904, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, 128, 4800, 0, 1, 0, 1, 2503},
		{MT_PSO_LASERTOWER, -64, 4864, 15, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -64, 3872, 11, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -64, 4096, 12, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -64, 4352, 13, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -64, 4608, 14, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, -160, 4928, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 1728, 3232, 1, 0, 0, 0, 2500},
		{6, -2752, 4864, 315, 0, 0, 0, 100},
		{6, -2752, 4608, 0, 0, 0, 0, 100},
		{17, -3136, 4960, 0, 0, 0, 1, 111},
		{17, -3136, 4512, 0, 0, 0, 1, 111},
		{7, -2880, 4704, 0, 0, 0, 1, 101},
		{6, -2848, 5280, 315, 0, 0, 1, 100},
		{MT_PSO_CRATE, -3424, 5312, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -3200, 5312, 0, 0, 0, 0, 2505},
		{MT_PSO_CARDREADER, -2912, 5344, 270, 1, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -2528, 4832, 1, 0, 0, 1, 2502},
		{MT_PSO_LASERTOWER, -2016, 5504, 25, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2976, 5504, 21, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2752, 5504, 22, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2496, 5504, 23, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2240, 5504, 24, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3552, 5152, 30, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3328, 5152, 31, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3104, 5408, 33, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, -3648, 5568, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -1920, 3808, 2, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, -3104, 5152, 32, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3968, 8480, 40, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3616, 8480, 41, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3296, 8480, 42, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3008, 8480, 43, 0, 0, 0, 2504},
		{7, -3520, 8224, 315, 0, 0, 0, 101},
		{7, -2944, 8224, 315, 0, 0, 0, 101},
		{9, -3104, 8032, 315, 16, 1, 1, 103},
		{17, -3392, 8224, 0, 0, 0, 1, 111},
		{17, -3040, 8224, 0, 0, 0, 1, 111},
		{MT_PSO_UNLOCKCARD, -3232, 8288, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, -3008, 8416, 270, 1, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, -4096, 8544, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -1920, 7456, 3, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, -2400, 10368, 50, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -1920, 10368, 51, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -1440, 10368, 52, 0, 0, 0, 2504},
		{MT_PSO_CRATE, -1536, 10176, 0, 0, 0, 0, 2505},
		{9, 1184, 9408, 180, 512, 32, 0, 103},
		{9, 1184, 8736, 180, 512, 32, 0, 103},
		{9, 1536, 9120, 180, 512, 32, 1, 103},
		{17, -1312, 9440, 0, 0, 0, 1, 111},
		{17, -1312, 8608, 0, 0, 0, 1, 111},
		{MT_PSO_LASERTOWER, 672, 10176, 60, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, 10176, 61, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1632, 10176, 62, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, -1344, 9568, 4, 8832, 552, 0, 2500},
		{MT_PSO_ROOMANCHOR, 2336, 8352, 4, 0, 0, 0, 2500},
		{17, 4352, 10688, 0, 0, 0, 0, 111},
		{17, 4352, 10688, 0, 0, 0, 0, 111},
		{17, 4352, 10368, 0, 0, 0, 0, 111},
		{9, 3392, 10368, 270, 512, 32, 0, 103},
		{9, 3968, 10368, 270, 512, 32, 0, 103},
		{MT_PSO_UNLOCKCARD, 3712, 10688, 1, 0, 0, 0, 2502},
		{MT_PSO_ROOMANCHOR, 3008, 11264, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 5184, 9472, 5, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 1568, 8448, 70, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1792, 8448, 71, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2016, 8448, 72, 0, 0, 0, 2504},
		{MT_PSO_CARDREADER, 2112, 8576, 90, 1, 0, 1, 2503},
		{MT_PSO_LASERTOWER, 5056, 7008, 100, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 5056, 6720, 101, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5056, 6432, 102, 0, 0, 0, 2504},
		{MT_PSO_CARDREADER, 4928, 6944, 180, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, 3296, 7424, 6, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 5280, 6304, 6, 0, 0, 0, 2500},
		{MT_PSO_CRATE, 3904, 8000, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3872, 7712, 0, 0, 0, 0, 2505},
		{MT_PSO_UNLOCKCARD, 1760, 9120, 1, 0, 0, 1, 2502},
		{6, 4512, 6880, 180, 0, 0, 0, 100},
		{6, 4512, 6528, 180, 0, 0, 0, 100},
		{7, 4736, 6688, 180, 0, 0, 0, 101},
		{MT_PSO_LASERTOWER, -3552, 3968, 1000, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3552, 4352, 1001, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3552, 4704, 1002, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4352, 11200, 1100, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4672, 11200, 1101, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4992, 11200, 1102, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, 736, 2300, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, 256, 2301, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, -192, 2302, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, -576, 2303, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, -896, 2304, 256, 16, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, -1344, 2305, 256, 16, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, -1632, 2306, 256, 16, 0, 2504},
		{MT_PSO_LASERTOWER, 1728, 4256, 2310, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1728, 4416, 2311, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1728, 4640, 2312, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1728, 4832, 2313, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6176, 4224, 3001, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6912, 4224, 3002, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7488, 4224, 3003, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8000, 4224, 3004, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 4224, 3005, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 4608, 3006, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 5056, 3007, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 5504, 3008, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 5888, 3009, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 6272, 3010, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 6656, 3011, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 7040, 3012, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 7424, 3013, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 7904, 3014, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, 6720, 7936, 7, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 8704, 4160, 7, 0, 0, 0, 2500},
		{MT_CRAWLACOMMANDER, 7680, 6080, 135, 1, 0, 2, 107},
		{MT_PSO_CRATE, 7232, 5824, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 7616, 5824, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 8000, 5824, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 7232, 5440, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 8000, 5440, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 7616, 5440, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 7232, 5056, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 7616, 5056, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 8000, 5056, 0, 1, 0, 2, 2505},
		{7, 7232, 5248, 135, 1, 0, 0, 101},
		{7, 8000, 5248, 135, 1, 0, 0, 101},
		{7, 7616, 7232, 270, 1, 0, 0, 101},
		{17, 6976, 7616, 0, 1, 0, 1, 111},
		{17, 8064, 7616, 0, 1, 0, 1, 111},
		{17, 8000, 4736, 0, 1, 0, 1, 111},
		{17, 7040, 4736, 0, 1, 0, 1, 111},
		{9, 8128, 6016, 180, 513, 32, 1, 103},
		{9, 8128, 6912, 180, 513, 32, 1, 103},
		{MT_PSO_LASERTOWER, -5472, 1024, 4000, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -5056, 1024, 4001, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -4640, 1024, 4002, 0, 0, 0, 2504},
		{MT_PSO_TELEPORTER, -5856, -64, 1, 1, 0, 1, 2510},
		{MT_PSO_TELEPORT_DEST, -5760, -64, 0, 0, 0, 0, 2511},
		{MT_PSO_TELEPORTER, 8288, 5440, 1, 1, 0, 3, 2510},
}
	
})

table.insert(PSO.info.quests[1].quests, {
	
	name = "1-2: Waterfall cleanup",
	desc = "A surge of Badnik activity has been detected on the coast. All units are dispatched to investigate. You are tasked with eliminating the stragglers towards the east.",
	objective = "Defeat the enemies at the target location",
	
	map = mapnum,
	prog = 1,	-- progress set to this value upon unlocking this quest for the first time
	-- only to be used with campaign quests!!
	
	locked = true,		-- initially locked
	unlocks = {{1, 3}},	-- unlocks 1-3
	
	levels = {
		[DIFF_NORMAL] = 4,
		[DIFF_HARD] = 57,
		[DIFF_VERYHARD] = 101,
	},

	-- recommended level...
	recommended = {
		[DIFF_NORMAL] = 3,
		[DIFF_HARD] = 50,
		[DIFF_VERYHARD] = 70,
	},

	levelsynch = {
		[DIFF_NORMAL] = {1, 7},
		[DIFF_HARD] = {45, 69},
	},

	grading = {
		{QG_TIME, 25, 0, TICRATE*60*15, TICRATE*60*20},
		{QG_DAMAGETAKEN, 25, 0, 400, 600},
		{QG_NOINCAP, 10},
	},

	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {nil, nil},
		[DIFF_HARD] = 	{"weaponsbadge_1", 2},
	},
	
	-- quest specific drops for use in boxes after the last room is cleared.
	-- useful if the last room doesn't contain a boss enemy
	drops = {
		[DIFF_NORMAL] = {
			{"calibur", 0, 0, 1, 50},
			{"burst", 0, 0, 1, 50},
			{"cane", 0, 0, 1, 50},		

			{"gigush", 1, 0, 6, 50},
			{"beam", 0, 0, 6, 50},
			{"baton", 0, 0, 6, 50},			

			{"giga calibur", 0, 0, 2, 50},
			{"burstbeam", 0, 0, 2, 50},
			{"helixen", 0, 0, 2, 50},	
			{"tcsm_crawla1", 0, 0, 2, 50},
			{"tcsm_crawla2", 0, 0, 2, 50},
			
			{1000, nil, nil, 1, 5},
			{"dimate", nil, nil, 1, 5},
		},

		[DIFF_HARD] = {
			{"unit_hp_2", 1, 0, 2, 50},
			{"unit_pp_2", 1, 0, 2, 50},
			{"unit_satk_2", 1, 0, 2, 50},
			{"unit_tatk_2", 1, 0, 2, 50},
			{"unit_ratk_2", 1, 0, 2, 50},	

			{"monogrinder", 0, 0, 6, 50},
			{"digrinder", 0, 0, 3, 50},
			{"trigrinder", 0, 0, 1, 50},
			{"scape doll", 0, 0, 1, 50},
			
			{"abnormal shard", 0, 0, 1, 600},
			{"dragon slayer", 0, 0, 1, 600},
			{"siren hammer", 0, 0, 1, 600},
			{"firearms", 0, 0, 1, 600},
			
			{"poss shooter", 0, 0, 1, 100},
			{"command shot", 0, 0, 1, 100},
			{"steel hearts", 51, 79,1, 700},
			{"seal case", 51, 79,1, 700},
			{"zanba", 51, 79, 1, 1000},
			{"last survivor", 51, 79, 1, 1000},
			{"monkey king bar", 51, 79,1, 700},
			{"girasole", 51, 79,1, 700},
			{"d. saber legacy", 51, 79, 1, 1000},
			{"eternal heat", 51, 79, 1, 1000},		
			{"basilleon", 51, 79,1, 700},
			{"longinus", 51, 79,1, 700},
			{"meteor lancer", 51, 79, 1, 1000},
			{"brionac", 51, 79, 1, 1000},			
			{"sarblight", 51, 79,1, 700},
			{"forblight", 51, 79,1, 700},	
			{"grand cross", 51, 79, 1, 1000},
			{"red saber", 51, 79, 1, 1000},
			{"full cylinder", 51, 79,1, 700},
			{"assassin", 51, 79,1, 700},
			{"yasminkov 3000r", 51, 79, 1, 1000},
			{"strauss", 51, 79, 1, 1000},			
			{"wide smack", 51, 79,1, 700},
			{"heimdall", 51, 79,1, 700},
			{"barett", 51, 79, 1, 1000},		
			{"photon launcher", 51, 79,1, 700},
			{"saint kilda", 51, 79,1, 700},
			{"charge howzer", 51, 79, 1, 1000},
			{"gur bazga", 51, 79, 1, 1000},		
			{"yasminkov 2000h", 51, 79,1, 700},
			{"sarcueid", 51, 79,1, 700},
			{"varista", 51, 79, 1, 1000},
			{"bravace", 51, 79, 1, 1000},			
			{"clarita visas", 51, 79,1, 700},
			{"red processor", 51, 79,1, 700},
			{"battle verge", 51, 79, 1, 1000},
			{"brave hammer", 51, 79, 1, 1000},
			{"windmill", 51, 79,1, 700},
			{"hexigraph", 51, 79,1, 700},
			{"serdote", 51, 79, 1, 1000},
			{"rose quartz", 51, 79, 1, 1000},		
			{"tcsm_crawla4", 51, 79,1, 700},
			{"tcsm_omochao", 51, 79, 1, 1000},
			
			{2000, nil, nil, 1, 5},
			{"trimate", nil, nil, 1, 5},
		},

		[DIFF_VERYHARD] = {
			{"unit_hp_3", 1, 0, 2, 50},
			{"unit_pp_3", 1, 0, 2, 50},
			{"unit_satk_3", 1, 0, 2, 50},
			{"unit_tatk_3", 1, 0, 2, 50},
			{"unit_ratk_3", 1, 0, 2, 50},	

			{"trigrinder", 0, 0, 6, 50},
			{"scape doll", 0, 0, 1, 50},
			
			{"poss shooter", 0, 0, 4, 100},
			{"command shot", 0, 0, 4, 100},
			
			{"steel hearts", 0, 0, 1, 600},
			{"full cylinder", 0, 0, 1, 600},
			{"red processor", 0, 0, 1, 600},
			{"makel frame", 0, 0, 1, 500},
			{"hart frame", 0, 0, 1, 50},
			
			{2000, nil, nil, 1, 5},
			{"trimate", nil, nil, 1, 5},
		},
		
	},

	datapods = {
		{8284, 5940, 0, 
		"I don't understand how a place that remote can be infested with so many scrap heaps... "
		},

		{1688, 8028, 0, 
		"These damned fences keep getting set up everywhere as soon as we stop looking for even a second... Guess we'll have to take another way... "
		},		

		{-5133, 12841, 0, 
		"That fish-like Badnik is a pain to fight with melee weapons... I really wish I had a Handgun or a Wand right about now... "
		},

		{-8468, 9188, -184, 
		"...I heard some kind of roar from this way. ...Honestly I'm glad this seems to be fenced off for now... "
		},

		{-7569, 4103, -200, 
		"I heard rumours that sometimes weird rocks from this place end up inside item crates and fuse with the weapons inside, creating some pretty unique results. ...Might be worth checking orange crates? These always have weapons inside. "
		},
	},

	npcdialogue = {
	
		["ogi"] = {
			"Routine operations like these happen every so often... We aren't quite sure why Badniks congregate in certain areas and not others.",
			"Done and dusted, I sure wish every day was as peaceful as this one.",
		},
		
		["alis"] = {
			"It's actually impressive just how many of these Badniks there are, for each one you destroy, three more pop up...",
			"You should get used to it, clean-up operations like these are commonplace these days...",
		},
		
		["ursula"] = {
			"I've been studying Badnik patterns for a while but I still can't really make any sense of what they're doing, really.",
			"Well? Did anything interesting happen?",
		},
		
		["lumia"] = {
			"Yeah, that's just the usual mission briefing, guess I'll be going too. See you around!",
			"So? How was your first ACTUAL mission?",
		},
		
		["flowen"] = {
			"There are always surges of activity every now and then, this has been going for years and years... Only now, we're far more prepared to deal with it than ever.",
			"How far we've come, that newcomers like you can handle clean-up operations that used to take whole squadrons due to our primitive weaponry...",
		},
		
		["bernie"] = {
			"Clean up operation again, eh? Well, I guess I'll head out soon... You've got your own area to take care of, eh?",
			"So, how'd yours go? Mine was thankfully pretty uneventful...",
		},
		
		["lukot"] = {
			"A lot of operatives are being sent out for this clean-up operation, huh... It seems you've been tasked with a relatively calm area, that said, so I'm sure you'll be fine!",
			"Good to see you safe and sound!",
		},
		
		["sue"] = {
			"Another mop-up op... Eh, gotta make money I suppose...",
			"The pay for this one was miserable! How am I supposed to upgrade my gear for when something actually important happens!?",
		},
		
		["pharia"] = {
			"Badnik activity again...",
			"That was a breeze...",
		},
		
		["garoa"] = {
			"Don't underestimate mundane tasks like these... It's by letting your guard down by thinking it'll be easy that you end up hurt.",
			"Seems you did well!",
		},
	},
	
	layout = {
		{0, 7712, 6464, 180, 0, 0, 0, 1},
		{MT_PSO_TELEPORT_DEST, 7840, 6464, 0, 0, 0, 0, 2511},
		{MT_PSO_TELEPORTER, 7968, 6464, 1, 1, 0, 0, 2510},
		{MT_PSO_LASERTOWER, 6304, 5760, 0, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6816, 5760, 1, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7264, 5760, 2, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7840, 5760, 3, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8544, 5760, 4, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8544, 6208, 5, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8544, 6656, 6, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8544, 7136, 7, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8544, 7488, 8, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7968, 7488, 9, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7456, 7488, 10, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6912, 7488, 11, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6336, 7488, 12, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2016, 8480, 100, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1792, 8480, 101, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1568, 8480, 102, 0, 0, 0, 2504},
		{MT_PSO_CRATE, 1664, 8352, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1888, 8352, 0, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 3936, 9440, 120, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3712, 9440, 121, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3488, 9440, 122, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 3520, 9280, 270, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, 3232, 7328, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4448, 9536, 0, 0, 0, 0, 2500},
		{7, 3520, 8960, 270, 0, 0, 0, 101},
		{7, 3872, 8960, 270, 0, 0, 0, 101},
		{6, 3392, 7840, 0, 0, 0, 0, 100},
		{17, 3552, 7424, 90, 0, 0, 1, 111},
		{17, 3840, 7424, 90, 0, 0, 1, 111},
		{9, 3712, 8640, 270, 256, 16, 1, 103},
		{MT_PSO_UNLOCKCARD, 3712, 8800, 1, 0, 0, 1, 2502},
		{MT_PSO_ROOMANCHOR, 4352, 10784, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 5088, 12160, 1, 0, 0, 0, 2500},
		{17, 4512, 12128, 90, 0, 0, 0, 111},
		{17, 4704, 12128, 90, 0, 0, 0, 111},
		{17, 4928, 12128, 90, 0, 0, 0, 111},
		{6, 4704, 11872, 270, 0, 0, 0, 100},
		{MT_PSO_CRATE, 3936, 10720, 0, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 1632, 12128, 130, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, 12128, 131, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 672, 12128, 132, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -1440, 12128, 140, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -1920, 12128, 141, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2400, 12128, 142, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, 2272, 12160, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -3104, 13920, 2, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, -2976, 12960, 150, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2976, 13280, 151, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2976, 13600, 152, 0, 0, 1, 2504},
		{MT_PSO_CRATE, 832, 12320, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1152, 12320, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1408, 12320, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -2816, 12320, 0, 0, 0, 0, 2505},
		{9, -416, 13568, 0, 256, 16, 1, 103},
		{9, -416, 12992, 180, 256, 16, 1, 103},
		{6, 896, 12640, 90, 0, 0, 0, 100},
		{17, -1600, 13568, 90, 0, 0, 1, 111},
		{17, -1600, 13088, 90, 0, 0, 1, 111},
		{17, 896, 13568, 90, 0, 0, 1, 111},
		{17, 864, 13056, 90, 0, 0, 1, 111},
		{9, -416, 13280, 0, 256, 16, 0, 103},
		{MT_PSO_UNLOCKCARD, -832, 13280, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, -2784, 12960, 0, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, -4416, 14176, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -8896, 12544, 3, 0, 0, 0, 2500},
		{8, -6528, 13664, 0, 0, 0, 0, 102},
		{6, -5856, 13824, 0, 0, 0, 0, 100},
		{6, -5792, 13120, 0, 0, 0, 0, 100},
		{7, -7488, 13792, 0, 0, 0, 1, 101},
		{7, -7456, 13216, 0, 0, 0, 1, 101},
		{MT_PSO_UNLOCKCARD, -8096, 13536, 1, 0, 0, 1, 2502},
		{MT_PSO_LASERTOWER, -8128, 12640, 160, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8448, 12640, 161, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8736, 12640, 162, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -8128, 12768, 90, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, -8864, 11744, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -4320, 10208, 4, 0, 0, 0, 2500},
		{17, -7616, 11488, 0, 0, 0, 0, 111},
		{17, -7648, 10560, 0, 0, 0, 0, 111},
		{17, -5024, 11072, 0, 0, 0, 0, 111},
		{MT_PSO_CRATE, -4672, 11456, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -4672, 11168, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -4672, 10880, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -4640, 10528, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -6784, 10592, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -4832, 9056, 5, 0, 0, 0, 2500},
		{7, -5472, 9792, 135, 0, 0, 0, 101},
		{6, -5728, 9856, 135, 0, 0, 0, 100},
		{6, -5568, 10144, 135, 0, 0, 0, 100},
		{MT_PSO_LASERTOWER, -8736, 9056, 170, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8736, 9376, 171, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8736, 9696, 172, 0, 0, 1, 2504},
		{MT_PSO_CRATE, -7904, 4096, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -8000, 4288, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -7680, 4544, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -7872, 4512, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -7712, 4320, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -7680, 3968, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -8192, 4160, 0, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, -7520, 3904, 180, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -7520, 4288, 181, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -7520, 4640, 182, 0, 0, 1, 2504},
		{MT_PSO_ROOMANCHOR, -9984, 8416, 6, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -6528, 5472, 6, 0, 0, 0, 2500},
		{17, -8800, 6112, 0, 0, 0, 0, 111},
		{17, -7936, 6144, 0, 0, 0, 0, 111},
		{9, -8192, 6144, 90, 256, 16, 0, 103},
		{7, -8832, 6560, 90, 0, 0, 0, 101},
		{7, -7456, 7264, 180, 0, 0, 0, 101},
		{MT_PSO_UNLOCKCARD, -9408, 6656, 1, 0, 0, 0, 2502},
		{MT_PSO_LASERTOWER, -9824, 6272, 190, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -9824, 5920, 191, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -9824, 5536, 192, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -9376, 5536, 193, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8992, 5536, 194, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8928, 6112, 200, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -8928, 5824, 201, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -8928, 5536, 202, 0, 0, 0, 2504},
		{MT_PSO_CARDREADER, -9696, 5760, 90, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, -14464, 6336, 7, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -10112, 4448, 7, 1, 0, 0, 2500},
		{8, -13152, 5568, 0, 0, 0, 0, 102},
		{8, -12608, 4864, 0, 1024, 64, 0, 102},
		{8, -11936, 5248, 0, 0, 0, 0, 102},
		{6, -12256, 5760, 0, 0, 0, 0, 100},
		{17, -13920, 5376, 0, 0, 0, 1, 111},
		{17, -13856, 4704, 0, 0, 0, 1, 111},
		{9, -13056, 5248, 0, 0, 0, 1, 103},
		{7, -10784, 5280, 180, 0, 0, 1, 101},
		{8, -12672, 5696, 180, 0, 0, 1, 102},
		{8, -11712, 5664, 180, 0, 0, 1, 102},
		{17, -10304, 5952, 180, 0, 0, 2, 111},
		{17, -10432, 5376, 180, 0, 0, 2, 111},
		{17, -10240, 4896, 180, 0, 0, 2, 111},
		{8, -13824, 5856, 180, 0, 0, 2, 102},
		{8, -13664, 5216, 180, 0, 0, 2, 102},
		{8, -13184, 4608, 180, 0, 0, 2, 102},
		{MT_PSO_TELEPORTER, -13952, 4992, 1, 1, 0, 3, 2510},
		{MT_PSO_CRATE, -12640, 5792, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -12192, 5792, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -11744, 5792, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -12640, 5472, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -12192, 5472, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -11744, 5472, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -12640, 5184, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -12192, 5184, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -11744, 5184, 0, 5, 0, 2, 2505},
	},

})

table.insert(PSO.info.quests[1].quests, {
	
	name = "1-3: Coastal caves Tyrant",
	desc = "A report came in detailing roars coming from the depths of the coastal caves. No particular activity has been detected, but operatives willing to undertake the mission are free to investigate.",
	objective = "Investigate the target location",
	
	map = mapnum,

	prog = 2,	-- progress set to this value upon unlocking this quest for the first time
	-- only to be used with campaign quests!!

	locked = true,		-- initially locked
	unlocks = {{1, 4}},	-- unlocks 2-1

	levelsynch = {
		[DIFF_NORMAL] = {2, 10},
		[DIFF_HARD] = {45, 69},
	},

	-- recommended level...
	recommended = {
		[DIFF_NORMAL] = 4,
		[DIFF_HARD] = 50,
		[DIFF_VERYHARD] = 70,
	},
	
	levels = {
		[DIFF_NORMAL] = 7,
		[DIFF_HARD] = 59,
		[DIFF_VERYHARD] = 101,
	},

	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {nil, nil},
		[DIFF_HARD] = 	{"weaponsbadge_1", 4},
	},

	grading = {
		{QG_TIME, 35, 0, TICRATE*60*15, TICRATE*60*20},
		{QG_DAMAGETAKEN, 25, 0, 400, 600},
		{QG_NOINCAP, 10},
	},

	datapods = {
		{5700, -137, 0, 
		"Badnik enemy formations in large areas like these usually have turrets in back lines... Get rid of them first, they're a real hassle in the long run..."
		},

		{-11039, 9264, -184, 
		"Yeah, no, I'm using a Telepipe and getting the hell out of here. Whatever is beyond that teleporter accross the bridge is far above my pay grade..."
		},
		
	},

	npcdialogue = {
	
		["ogi"] = {
			"A tough enemy in the Coast? Unfortunately I have another important mission, but I'm sure you'll handle this just fine.",
			"Interesting, so there really was something. It's impressive that you managed to take it out.",
		},
		
		["alis"] = {
			"Reports of a tough enemy in the Coast? Unlikely... Are you sure you aren't wasting your time?",
			"An immense Badnik was actually there? AND you took it out? You might be more than meets the eye...",
		},
		
		["ursula"] = {
			"Someone heard roars? It's probably just some wildlife fighting against Badniks... I wouldn't bother checking it out...",
			"So there actually was one there? Well, make that your first crowning achievement.",
		},
		
		["lumia"] = {
			"A tough Badnik in the Coast? Yeah, no way...",
			"Yes way? There actually was a tough Badnik in the Coast?? That's unheard of!",
		},
		
		["flowen"] = {
			"Heading out on a quest based on rumours? Well, at worst you'd just be getting combat experience from the fodder you'd find along the way.",
			"Impressive, I heard you actually took out a large Badnik. ...We used to call these Tyrant-Class back in my day. Now of course, we have the technology to have one person dispatch them...",
		},
		
		["bernie"] = {
			"Going out based on a rumour? I think it's worth checking out either way. I can't be going with you though, I have other business.",
			"Well, well, we've got ourselves a Tyrant slayer in our ranks!",
		},
		
		["lukot"] = {
			"Personally, I believe that rumour. The person in question seemed legitimately distressed when they came back...",
			"So it was not baseless after all... To think you slayed a Tyrant is amazing...!",
		},
		
		["sue"] = {
			"And now we're getting quests posted based off of rumours. Seriously, we're never taking this planet back.",
			"No way, there actually was something? And you took it out? I'm almost stumped.",
		},
		
		["pharia"] = {
			"Some reports came in that there is a large energy signature around the spot the initial report spoke about...",
			"So you handled it... I was thinking of going...",
		},
		
		["garoa"] = {
			"I don't know about any operative that would chicken out from anything not remotely serious. So watch your back out there.",
			"So even the Coast's got some nasty ones now, huh...",
		},
	},
	
	layout = {
		{0, 6560, 0, 90, 0, 0, 0, 1},
		{MT_PSO_SNAPPERBOSS, -12224, 13472, 270, 1, 0, 0, 2550},
		{MT_PSO_ROOMANCHOR, 1984, 3008, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 7840, 576, 0, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 2064, 768, 0, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2400, 768, 1, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2784, 768, 2, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3168, 768, 3, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3552, 768, 4, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3552, 480, 5, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3552, 192, 6, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3552, -160, 7, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3552, -480, 8, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3552, -960, 9, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4032, -960, 10, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4512, -960, 11, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4960, -960, 12, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5408, -960, 13, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5824, -960, 14, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6336, -960, 15, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6880, -960, 16, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7296, -960, 17, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, -960, 18, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, -608, 19, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, -224, 20, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 160, 21, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 512, 22, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 864, 23, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 1152, 24, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 1440, 25, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 1760, 26, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 2080, 27, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 2464, 28, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 2848, 29, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7360, 2848, 30, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6944, 2848, 31, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6592, 2848, 32, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6272, 2848, 33, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6272, 2912, 34, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4288, 2912, 100, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4864, 2912, 101, 0, 0, 1, 2504},
		{6, 3712, 1440, 315, 0, 0, 0, 100},
		{6, 4864, 1792, 270, 0, 0, 0, 100},
		{6, 5952, 1728, 270, 0, 0, 0, 100},
		{8, 4576, 1024, 0, 0, 0, 1, 102},
		{8, 5728, 1216, 0, 0, 0, 1, 102},
		{7, 4512, 1920, 270, 0, 0, 1, 101},
		{7, 5568, 2048, 270, 0, 0, 1, 101},
		{17, 3200, 1600, 0, 0, 0, 2, 111},
		{17, 4608, 2464, 0, 0, 0, 2, 111},
		{17, 6784, 1920, 0, 0, 0, 2, 111},
		{7, 3776, 2240, 315, 0, 0, 2, 101},
		{7, 5920, 2336, 270, 0, 0, 2, 101},
		{MT_PSO_CRATE, 7584, 2688, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7328, 2688, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7072, 2688, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 2144, 992, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 2144, 1216, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 2144, 1408, 270, 0, 0, 0, 2505},
		{MT_PSO_UNLOCKCARD, 4608, 2624, 1, 0, 0, 2, 2502},
		{MT_PSO_CARDREADER, 4288, 2848, 270, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, 2624, 4992, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4256, 3424, 1, 0, 0, 0, 2500},
		{9, 3296, 4576, 0, 512, 32, 0, 103},
		{17, 3328, 4256, 0, 0, 0, 0, 111},
		{6, 3296, 3808, 0, 0, 0, 0, 100},
		{MT_PSO_LASERTOWER, 2656, 4896, 150, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2656, 4224, 151, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, 2976, 4576, 1, 0, 0, 0, 2502},
		{MT_PSO_CARDREADER, 2816, 4832, 0, 0, 0, 1, 2503},
		{MT_PSO_CRATE, 2912, 3616, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 224, 4032, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 512, 4032, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 800, 4032, 270, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 96, 3232, 200, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 576, 3232, 201, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1056, 3232, 202, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, -3680, 5536, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -480, 3808, 2, 0, 0, 0, 2500},
		{9, -2624, 4768, 0, 512, 32, 0, 103},
		{9, -2752, 4448, 0, 512, 32, 0, 103},
		{9, -2944, 4640, 0, 512, 32, 0, 103},
		{17, -3136, 5024, 0, 0, 0, 0, 111},
		{17, -3168, 4576, 0, 0, 0, 0, 111},
		{MT_PSO_CRATE, -2912, 5312, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -2624, 5312, 270, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, -2976, 5472, 210, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2496, 5472, 211, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2016, 5472, 212, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3552, 4672, 220, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3552, 4352, 221, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3552, 4000, 222, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -3424, 3936, 0, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -3328, 4832, 1, 0, 0, 0, 2502},
		{MT_PSO_LASERTOWER, -5440, 2752, 230, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -5024, 2752, 231, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -4544, 2752, 232, 0, 0, 0, 2504},
		{MT_PSO_CRATE, -5248, 2880, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -4768, 2880, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -5248, 3072, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -4768, 3072, 270, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -7488, 5312, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -6176, 3360, 3, 0, 0, 0, 2500},
		{9, -7264, 4352, 0, 512, 32, 0, 103},
		{9, -7264, 4096, 0, 512, 32, 0, 103},
		{MT_PSO_LASERTOWER, -8928, 5536, 260, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -8928, 5824, 261, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -8928, 6112, 262, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -8992, 5536, 270, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -9440, 5536, 271, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -9824, 5536, 272, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -9824, 5792, 273, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -9824, 6048, 274, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -9824, 6304, 275, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -8192, 8288, 280, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -7872, 8288, 281, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -7552, 8288, 282, 0, 0, 1, 2504},
		{MT_PSO_HEAVYWEAPONS_CRAWLA, -8256, 7008, 270, 0, 0, 0, 107},
		{17, -8608, 7872, 0, 0, 0, 0, 111},
		{17, -7744, 7808, 0, 0, 0, 0, 111},
		{17, -6944, 7840, 0, 0, 0, 0, 111},
		{MT_PSO_ROOMANCHOR, -9888, 8384, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -6432, 5472, 4, 0, 0, 0, 2500},
		{MT_PSO_UNLOCKCARD, -8704, 8064, 1, 0, 0, 0, 2502},
		{MT_PSO_CARDREADER, -8192, 8160, 270, 0, 0, 1, 2503},
		{MT_PSO_LASERTOWER, -7520, 8992, 290, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -7520, 9248, 291, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -7520, 9568, 292, 0, 0, 0, 2504},
		{MT_PSO_CRATE, -8704, 6016, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -8704, 5824, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -8704, 5632, 270, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -10272, 6944, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -14432, 9856, 5, 0, 0, 0, 2500},
		{MT_PSO_CRATE, -11584, 14560, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -11424, 14560, 0, 1, 0, 0, 2505},
		{6, -12544, 7744, 0, 0, 0, 0, 100},
		{MT_PSO_LASERTOWER, -14336, 9760, 300, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -14048, 9760, 301, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -13760, 9760, 302, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -14304, 9664, 270, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -13888, 8096, 1, 0, 0, 0, 2502},
		{MT_PSO_TELEPORTER, 6560, -288, 1, 1, 0, 0, 2510},
		{MT_PSO_TELEPORTER, -12192, 10112, 3, 0, 0, 0, 2510},
		{MT_PSO_TELEPORT_DEST, -12224, 12032, 3, 0, 0, 0, 2511},
		{MT_PSO_ROOMANCHOR, -14368, 15648, 6, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -9760, 11520, 6, 1, 0, 0, 2500},
		{MT_PSO_TELEPORTER, -12160, 14720, 1, 1, 0, 1, 2510},
		{MT_PSO_CRATE, -12864, 14848, 0, 1, 0, 1, 2505},
		{MT_PSO_CRATE, -12704, 14848, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -12544, 14848, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -12864, 14720, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -12704, 14720, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -12544, 14720, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -12864, 14592, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -12704, 14592, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -12544, 14592, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -11744, 14816, 0, 1, 0, 1, 2505},
		{MT_PSO_CRATE, -11584, 14816, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -11424, 14816, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -11744, 14688, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -11584, 14688, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -11424, 14688, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -11744, 14560, 0, 1, 0, 0, 2505},
		{9, -12768, 8128, 0, 512, 32, 0, 103},
		{9, -12800, 7520, 0, 512, 32, 0, 103},
		{MT_PSO_TELEPORT_DEST, 6560, -192, 0, 1, 0, 0, 2511},
	},
})

-- crates
PSO.info.crateDropTables[mapnum] = {
		[DIFF_NORMAL] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{20, 0, 0, 1, 8},

			
			{"azul ledge", 0, 0, 1, 300},
			{"azul lance", 0, 0, 1, 300},
			{"azul cutter", 0, 0, 1, 300},
			{"azul bullet", 0, 0, 1, 300},
			{"azul burst", 0, 0, 1, 300},
			{"azul proud", 0, 0, 1, 300},
			{"azul staff", 0, 0, 1, 300},
			{"azul cutlass", 0, 0, 1, 300},
			{"azul brave", 0, 0, 1, 300},
			{"azul baguette", 0, 0, 1, 300},
			
			{"sword_pa_extendcutter", 0, 0, 1, 300},
			{"dsaber_pa_spinadvance", 0, 0, 1, 300},
			{"spear_pa_raptorthrow", 0, 0, 1, 300},
			{"rifle_pa_piercinground", 0, 0, 1, 300},
			{"shotgun_pa_gloriousrain", 0, 0, 1, 300},
			{"launcher_pa_infernoquake", 0, 0, 1, 300},
			{"saber_pa_ragedance", 0, 0, 1, 300},
			{"handgun_pa_ricochet", 0, 0, 1, 300},
			{"gifoie", 0, 0, 1, 300},
			{"gibarta", 0, 0, 1, 300},
			{"gizonde", 0, 0, 1, 300},
			{"gidiga", 0, 0, 1, 300},
			
			{"monomate", 0, 0, 1, 20},
			{"dimate", 0, 0, 1, 40},
			{"monogrinder", 0, 0, 1, 50},
			{"digrinder", 0, 0, 1, 50},
			{"telepipe", 0, 0, 1, 30},
			
			{"moon atomizer", 0, 0, 1, 10},
			{"sword", 0, 0, 2, 100},
			{"gigush", 0, 0, 1, 100},
			{"calibur", 0, 0, 1, 100},
			{"rifle", 0, 0, 2, 100},
			{"burst", 0, 0, 1, 100},
			{"beam", 0, 0, 1, 100},
			{"rod", 0, 0, 2, 100},
			{"helixen", 0, 0, 2, 100},
			{"cane", 0, 0, 1, 100},
			{"saber", 0, 0, 2, 100},
			{"handgun", 0, 0, 2, 100},
			{"wand", 0, 0, 2, 100},
			{"spear", 0, 0, 2, 100},
			{"launcher", 0, 0, 2, 100},
		},
		
		[DIFF_HARD] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 8},

			{"azul ledge", 0, 0, 1, 300},
			{"azul lance", 0, 0, 1, 300},
			{"azul cutter", 0, 0, 1, 300},
			{"azul bullet", 0, 0, 1, 300},
			{"azul burst", 0, 0, 1, 300},
			{"azul proud", 0, 0, 1, 300},
			{"azul staff", 0, 0, 1, 300},
			{"azul cutlass", 0, 0, 1, 300},
			{"azul brave", 0, 0, 1, 300},
			{"azul baguette", 0, 0, 1, 300},	

			{"baston frame", 0, 0, 1, 500},
			{"makel frame", 0, 0, 1, 1000},
			{"unit_satk_3", 0, 0, 1, 100},
			{"unit_ratk_3", 0, 0, 1, 100},
			{"unit_tatk_3", 0, 0, 1, 100},
			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},
			{"unit_critr_special1", 0, 0, 1, 400},
			{"unit_speed_special1", 0, 0, 1, 400},
			{"unit_speed_3", 0, 0, 1, 300},
			{"unit_critr_3", 0, 0, 1, 300},
			{"unit_critd_3", 0, 0, 1, 300},
			{"unit_all_3", 0, 0, 1, 300},
			{"unit_hppp_2", 0, 0, 1, 100},
			{"unit_hppp_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_2", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},	
			
			{"monomate", 0, 0, 1, 30},
			{"dimate", 0, 0, 1, 20},
			{"trimate", 0, 0, 1, 30},
			{"telepipe", 0, 0, 1, 30},
			
			{"scape doll", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 50},
			{"star atomizer", 0, 0, 1, 50},
			{"sol atomizer", 0, 0, 1, 50},
			{"shiftaride", 0, 0, 1, 50},
			{"debanride", 0, 0, 1, 50},
			
			{"vita pine", 0, 0, 1, 100},
			{"vita shooter", 0, 0, 1, 100},
			{"vita crest", 0, 0, 1, 100},
			{"vita hammer", 0, 0, 1, 100},
			{"vita claw", 0, 0, 1, 100},
			{"vita peacekeeper", 0, 0, 1, 100},	
			{"vita fork", 0, 0, 1, 100},
			{"vita grenade", 0, 0, 1, 100},		

		},

		[DIFF_VERYHARD] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 8},

			{"azul ledge", 0, 0, 1, 300},
			{"azul lance", 0, 0, 1, 300},
			{"azul cutter", 0, 0, 1, 300},
			{"azul bullet", 0, 0, 1, 300},
			{"azul burst", 0, 0, 1, 300},
			{"azul proud", 0, 0, 1, 300},
			{"azul staff", 0, 0, 1, 300},
			{"azul cutlass", 0, 0, 1, 300},
			{"azul brave", 0, 0, 1, 300},
			{"azul baguette", 0, 0, 1, 300},	

			{"baston frame", 0, 0, 1, 300},
			{"makel frame", 0, 0, 1, 1000},
			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},
			{"unit_all_3", 0, 0, 1, 300},
			{"unit_hppp_2", 0, 0, 1, 100},
			{"unit_hppp_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_2", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},	
			
			{"monomate", 0, 0, 1, 30},
			{"dimate", 0, 0, 1, 30},
			{"trimate", 0, 0, 1, 30},
			{"telepipe", 0, 0, 1, 30},
			
			{"scape doll", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 50},
			{"star atomizer", 0, 0, 1, 50},
			{"sol atomizer", 0, 0, 1, 50},
			{"shiftaride", 0, 0, 1, 50},
			{"debanride", 0, 0, 1, 50},
			
			{"vita pine", 0, 0, 1, 100},
			{"vita shooter", 0, 0, 1, 100},
			{"vita crest", 0, 0, 1, 100},
			{"vita hammer", 0, 0, 1, 100},
			{"vita claw", 0, 0, 1, 100},
			{"vita peacekeeper", 0, 0, 1, 100},	
			{"vita fork", 0, 0, 1, 100},
			{"vita grenade", 0, 0, 1, 100},	
					
		},
		
}