local mapnum = 5

/*
	quest format:
	{
		>>COSMETIC STUFF
		name: 		quest name
		objective:	description of the objective
		desc: 		description
	
	
		>>ACTUAL GAMEPLAY RELEVANT STUFF
		map:		map number the quest takes place in
					(players will be warped to it as soon as everyone gets to the teleporter)
		
		layout = {}: 	object layout for the map.
						worth noting the object layout CANNOT be changed in the lobby.
		
		levels = {                                                                    ,..,.,.,.,.,.,..        
			[DIFF_NORMAL] = x,
			[DIFF_HARD] = x,
			[...]
		}: enemy level per difficulty
		
		
		
	}
*/

/*table.insert(PSO.info.quests[mapnum], {
	
	name = "Test quest",
	desc = "Doesn't load object layout, enemy level matches player level",
	objective = "Test your shit",
	
	map = 1,
	
	levels = {
		[DIFF_NORMAL] = 1,
		[DIFF_HARD] = 1,
		--[DIFF_VERYHARD] = 1,
		[DIFF_SUPERHARD] = 1,
		[DIFF_EXTREMELYHARD] = 1,
		[DIFF_ULTRAHARD] = 1,
	},
})*/


table.insert(PSO.info.quests[1].quests, {
	
	name = "4-X: Command origin",
	desc = "The signal's origin seems to be coming from within the tallest peak of the recently surveyed area. Destroying whatever is responsible could severely damage the Badnik's network, and so you decide to venture inside the mountain...",
	objective = "Destroy the source of the signal",
	
	map = mapnum,
	target = MT_PSO_DARKFALZ,

	prog = 9,
	
	timer_off = true,	-- timer starts disabled until we enter a teleporter.

	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {nil, nil},
		[DIFF_HARD] = 	{"weaponsbadge_1", 4},
	},

	locked = true,		-- initially locked
	unlocks = {
	{1, 11},
	/*{1, 1, DIFF_HARD}, {1, 11}, {3, 1}, -- unlocks 1-1 HARD MODE & boss rush
	{2, 1, DIFF_VERYHARD, DIFF_HARD},
	{2, 2, DIFF_VERYHARD, DIFF_HARD},
	{2, 3, DIFF_VERYHARD, DIFF_HARD},

	{3, 1, DIFF_VERYHARD, DIFF_HARD},
	{3, 2, DIFF_VERYHARD, DIFF_HARD},
	{3, 3, DIFF_VERYHARD, DIFF_HARD},

	{4, 1, DIFF_VERYHARD, DIFF_HARD},
	{4, 2, DIFF_VERYHARD, DIFF_HARD},
	{4, 3, DIFF_VERYHARD, DIFF_HARD},

	{5, 1, DIFF_VERYHARD, DIFF_HARD},	
	
	{7, 1},*/
	},

	npcdialogue = {
	
		["ogi"] = {
			"Well, your intuition's never led you astray so far, so whatever you think is going on is definitely worth investigating.",
			"Not only did you destroy an unprecedented threat on your own, but it seems to have brought very valuable data, too...",
		},
		
		["alis"] = {
			"So this previous Tyrant was actually acting as both a command unit, and a jammer to make it impossible to pinpoint the actual signal's origin... I see.",
			"And as expected, you found an even stronger command unit in there... I applaud you.",
		},
		
		["ursula"] = {
			"The data indicates that the Tyrant you defeated last time was less of a command unit and more of a jammer. That explains why it ran away from us last time, it was trying to hide what you just uncovered.",
			"As predicted, since you destroyed that command unit, Badniks from all over have been acting less coordinated, and that includes other Tyrants.",
		},
		
		["lumia"] = {
			"Found something else to go after already? Sheesh, you're restless!",
			"While I was out on the field, Badniks spontaneously seemed to get disorganized after some point. I take it you've got sooooomething to do with that...",
		},
		
		["flowen"] = {
			"So you think something that important was hiding right below our noses all that time? If that's the case, this is a more elaborate ploy than I gave it any credit for...",
			"There are reports all over that your actions have disturbed the Badniks' network. This may be a turning point for us.",
		},
		
		["bernie"] = {
			"Finally a day off from supervising the mines. ...I think I'll just do nothing for a change.",
			"I ended up parusing the data from what you just did after all, that whole place you discovered could be interesting...",
		},
		
		["lukot"] = {
			"Are you sure you aren't pushing yourself too hard? You just took out a Tyrant and are heading to fight what could be another one.",
			"For all the good you did, I still think you should rest up a bit.",
		},
		
		["sue"] = {
			"Couldn't help but overhear about whatever important assignment you're on. You sure it isn't more than you can chew?",
			"Well, I suppose it's only natural you'd succeed after... how many was it? three or so Tyrants destroyed already?",
		},
		
		["pharia"] = {
			"So the signal was being jammed all along... It's definitely a set of commands for Badniks...",
			"Looking through the data... The enemy you defeated... wasn't functionning. ...Something else must've been... animating it...",
		},
		
		["garoa"] = {
			"So you found soemthing worth tackling, huh. Good luck out there.",
			"I hope this brings us a step closer...",
		},
	},

	drops = {},
	
	levelsynch = {
		[DIFF_NORMAL] = {20, 34},
		[DIFF_HARD] = {45, 75},
	},

	-- recommended level...
	recommended = {
		[DIFF_NORMAL] = 25,
		[DIFF_HARD] = 65,
		[DIFF_VERYHARD] = 70,
	},
	
	levels = {
		[DIFF_NORMAL] = 30,
		[DIFF_HARD] = 70,
		[DIFF_VERYHARD] = 101,
	},

	grading = {
		{QG_TIME, 125, 0, TICRATE*60*15, TICRATE*60*20},
		{QG_DAMAGETAKEN, 125, 0, 1500, 4000},
	},
	
	layout = {},
})