local mapnum = 8

/*
	quest format:
	{
		>>COSMETIC STUFF
		name: 		quest name
		objective:	description of the objective
		desc: 		description
	
	
		>>ACTUAL GAMEPLAY RELEVANT STUFF
		map:		map number the quest takes place in
					(players will be warped to it as soon as everyone gets to the teleporter)
		
		layout = {}: 	object layout for the map.
						worth noting the object layout CANNOT be changed in the lobby.
		
		levels = {                                                                    ,..,.,.,.,.,.,..        
			[DIFF_NORMAL] = x,
			[DIFF_HARD] = x,
			[...]
		}: enemy level per difficulty
		
		
		
	}
*/

/*table.insert(PSO.info.quests[mapnum], {
	
	name = "Test quest",
	desc = "Doesn't load object layout, enemy level matches player level",
	objective = "Test your shit",
	
	map = 1,
	
	levels = {
		[DIFF_NORMAL] = 1,
		[DIFF_HARD] = 1,
		--[DIFF_VERYHARD] = 1,
		[DIFF_SUPERHARD] = 1,
		[DIFF_EXTREMELYHARD] = 1,
		[DIFF_ULTRAHARD] = 1,
	},
})*/


table.insert(PSO.info.quests[1].quests, {
	
	name = "6-1: Growing Corruption",
	desc = "The neighbouring space station factory in charge of studying the armour is under attack. Locate and secure the armour before it is destroyed.",
	objective = "Secure the armour!",
	
	map = mapnum,

	prog = 12,

	locked = true,		-- initially locked
	unlocks = {{1,14 }},	-- unlocks 6-2

	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {nil, nil},
		[DIFF_HARD] = 	{"weaponsbadge_1", 6},
	},

	drops = {
		[DIFF_NORMAL] = {	

			{"sword proto 1", 0, 0, 1, 400},
			{"sword proto 2", 0, 0, 1, 400},
			{"sword proto 3", 0, 0, 1, 400},
			{"spear proto 1", 0, 0, 1, 400},
			{"spear proto 2", 0, 0, 1, 400},
			{"spear proto 3", 0, 0, 1, 400},
			{"doublesaber proto 1", 0, 0, 1, 400},
			{"doublesaber proto 2", 0, 0, 1, 400},
			{"doublesaber proto 3", 0, 0, 1, 400},
			{"rifle proto 1", 0, 0, 1, 400},
			{"rifle proto 2", 0, 0, 1, 400},
			{"rifle proto 3", 0, 0, 1, 400},
			{"shotgun proto 1", 0, 0, 1, 400},
			{"shotgun proto 2", 0, 0, 1, 400},
			{"shotgun proto 3", 0, 0, 1, 400},
			{"launcher proto 1", 0, 0, 1, 400},
			{"launcher proto 2", 0, 0, 1, 400},
			{"launcher proto 3", 0, 0, 1, 400},
			{"rod proto 1", 0, 0, 1, 400},
			{"rod proto 2", 0, 0, 1, 400},
			{"rod proto 3", 0, 0, 1, 400},
			{"saber proto 1", 0, 0, 1, 400},
			{"saber proto 2", 0, 0, 1, 400},
			{"saber proto 3", 0, 0, 1, 400},
			{"handgun proto 1", 0, 0, 1, 400},
			{"handgun proto 2", 0, 0, 1, 400},
			{"handgun proto 3", 0, 0, 1, 400},
			{"wand proto 1", 0, 0, 1, 400},
			{"wand proto 2", 0, 0, 1, 400},
			{"wand proto 3", 0, 0, 1, 400},
		
			{"pine", 1, 0, 5, 100},
			{"burster", 1, 0, 5, 100},
			{"crest", 1, 0, 5, 100},
			{"claw", 0, 0, 5, 100},
			{"peacekeeper", 0, 0, 5, 100},
			{"hammer", 0, 0, 5, 100},			
			
			{"unit_hp_2", 1, 0, 2, 50},
			{"unit_pp_2", 1, 0, 2, 50},
			{"unit_satk_2", 1, 0, 2, 50},
			{"unit_tatk_2", 1, 0, 2, 50},
			{"unit_ratk_2", 1, 0, 2, 50},
			
			{"icicle frame", 1, 0, 1, 50},
		},

		[DIFF_HARD] = {	

			{"sword proto 1", 0, 0, 1, 400},
			{"sword proto 2", 0, 0, 1, 400},
			{"sword proto 3", 0, 0, 1, 400},
			{"spear proto 1", 0, 0, 1, 400},
			{"spear proto 2", 0, 0, 1, 400},
			{"spear proto 3", 0, 0, 1, 400},
			{"doublesaber proto 1", 0, 0, 1, 400},
			{"doublesaber proto 2", 0, 0, 1, 400},
			{"doublesaber proto 3", 0, 0, 1, 400},
			{"rifle proto 1", 0, 0, 1, 400},
			{"rifle proto 2", 0, 0, 1, 400},
			{"rifle proto 3", 0, 0, 1, 400},
			{"shotgun proto 1", 0, 0, 1, 400},
			{"shotgun proto 2", 0, 0, 1, 400},
			{"shotgun proto 3", 0, 0, 1, 400},
			{"launcher proto 1", 0, 0, 1, 400},
			{"launcher proto 2", 0, 0, 1, 400},
			{"launcher proto 3", 0, 0, 1, 400},
			{"rod proto 1", 0, 0, 1, 400},
			{"rod proto 2", 0, 0, 1, 400},
			{"rod proto 3", 0, 0, 1, 400},
			{"saber proto 1", 0, 0, 1, 400},
			{"saber proto 2", 0, 0, 1, 400},
			{"saber proto 3", 0, 0, 1, 400},
			{"handgun proto 1", 0, 0, 1, 400},
			{"handgun proto 2", 0, 0, 1, 400},
			{"handgun proto 3", 0, 0, 1, 400},
			{"wand proto 1", 0, 0, 1, 400},
			{"wand proto 2", 0, 0, 1, 400},
			{"wand proto 3", 0, 0, 1, 400},
		
			{"alva pine", 1, 0, 5, 50},
			{"alva burster", 0, 0, 5, 50},
			{"alva crest", 0, 0, 5, 50},			

			{"alva doubliss", 1, 0, 5, 100},
			{"alva concentrator", 1, 0, 5, 100},
			
			{"abnormal shard", 0, 0, 1, 500},
			{"steel hearts", 51, 79,1, 700},
			{"seal case", 51, 79,1, 700},
			{"zanba", 51, 79, 1, 1000},
			{"last survivor", 51, 79, 1, 1000},
			{"chainsawd", 51, 79, 1, 2000},
			{"dragon slayer", 51, 79, 1, 2000},
			{"monkey king bar", 51, 79,1, 700},
			{"girasole", 51, 79,1, 700},
			{"d. saber legacy", 51, 79, 1, 1000},
			{"eternal heat", 51, 79, 1, 1000},
			{"vivienne", 51, 79, 1, 2000},
			{"double cannon", 51, 79, 1, 2000},			
			{"basilleon", 51, 79,1, 700},
			{"longinus", 51, 79,1, 700},
			{"meteor lancer", 51, 79, 1, 1000},
			{"brionac", 51, 79, 1, 1000},
			{"vjaya", 51, 79, 1, 2000},
			{"soul eater", 51, 79, 1, 2000},			
			{"sarblight", 51, 79,1, 700},
			{"forblight", 51, 79,1, 700},	
			{"grand cross", 51, 79, 1, 1000},
			{"red saber", 51, 79, 1, 1000},
			{"elysion", 51, 79, 1, 2000},
			{"axeon", 51, 79, 1, 2000},
			{"full cylinder", 51, 79,1, 700},
			{"assassin", 51, 79,1, 700},
			{"yasminkov 3000r", 51, 79, 1, 1000},
			{"strauss", 51, 79, 1, 1000},
			{"firearms", 51, 79, 1, 2000},
			{"frozen shooter", 51, 79, 1, 2000},			
			{"wide smack", 51, 79,1, 700},
			{"heimdall", 51, 79,1, 700},
			{"barett", 51, 79, 1, 1000},
			{"crush bullet", 51, 79, 1, 1000},
			{"spread needle", 51, 79, 1, 2000},
			{"final impact", 51, 79, 1, 2000},			
			{"photon launcher", 51, 79,1, 700},
			{"saint kilda", 51, 79,1, 700},
			{"charge howzer", 51, 79, 1, 1000},
			{"gur bazga", 51, 79, 1, 1000},
			{"sspm launcher", 51, 79, 1, 2000},
			{"inferno bazooka", 51, 79, 1, 2000},			
			{"yasminkov 2000h", 51, 79,1, 700},
			{"sarcueid", 51, 79,1, 700},
			{"varista", 51, 79, 1, 1000},
			{"bravace", 51, 79, 1, 1000},
			{"pandora extreme", 51, 79, 1, 2000},
			{"ruby bullet", 51, 79, 1, 2000},			
			{"clarita visas", 51, 79,1, 700},
			{"red processor", 51, 79,1, 700},
			{"battle verge", 51, 79, 1, 1000},
			{"brave hammer", 51, 79, 1, 1000},
			{"siren hammer", 51, 79, 1, 2000},
			{"demonic fork", 51, 79, 1, 2000},
			{"windmill", 51, 79,1, 700},
			{"hexigraph", 51, 79,1, 700},
			{"serdote", 51, 79, 1, 1000},
			{"rose quartz", 51, 79, 1, 1000},
			{"rykros staff", 51, 79, 1, 2000},
			{"evil curst", 51, 79, 1, 2000},		
			{"tcsm_crawla4", 51, 79,1, 700},
			{"tcsm_omochao", 51, 79, 1, 1000},
			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},
			{"unit_critr_special1", 0, 0, 1, 400},
			{"unit_speed_special1", 0, 0, 1, 400},
			{"unit_speed_3", 0, 0, 1, 300},
			{"unit_critr_3", 0, 0, 1, 300},
			{"unit_critd_3", 0, 0, 1, 300},
			{"unit_all_3", 0, 0, 1, 300},
			{"unit_hppp_2", 0, 0, 1, 100},
			{"unit_hppp_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_2", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},

			{"winginator", 1, 0, 1, 100},
			{"asterod", 1, 0, 1, 100},
			{"fehler frame", 1, 0, 5, 100},
			
			{6000, nil, nil, 1, 5},
		},

		[DIFF_VERYHARD] = {	
			{"alva pine", 1, 0, 5, 50},
			{"alva burster", 0, 0, 5, 50},
			{"alva crest", 0, 0, 5, 50},			

			{"alva doubliss", 1, 0, 5, 100},
			{"alva concentrator", 1, 0, 5, 100},
			
			{"unit_ppsatk_2", 1, 0, 7, 50},
			{"unit_pptatk_2", 1, 0, 7, 50},
			{"unit_ppratk_2", 1, 0, 7, 50},
			{"unit_rainbow_2", 1, 0, 7, 50},

			{"winginator", 1, 0, 1, 100},
			{"asterod", 1, 0, 1, 100},
			{"fehler frame", 1, 0, 5, 100},
			
			{6000, nil, nil, 1, 5},
		},
		
	},

	levelsynch = {
		[DIFF_NORMAL] = {29, 42},
		[DIFF_HARD] = {45, 79},
	},

	recommended = {
		[DIFF_NORMAL] = 34,
		[DIFF_HARD] = 65,
		[DIFF_VERYHARD] = 70,
	},
	
	levels = {
		[DIFF_NORMAL] = 37,
		[DIFF_HARD] = 75,
		[DIFF_VERYHARD] = 101,
	},

	grading = {
		{QG_TIME, 100, 0, TICRATE*60*20, TICRATE*60*25},
		{QG_DAMAGETAKEN, 80, 0, 3000, 5000},
		{QG_NOINCAP, 20},
	},

	datapods = {
		{737, 18950, 880,
		"We've been trying to create new, more effective weapons using existing designs to save on development costs. The results aren't very stable so far but it certainly makes for... unique items.",
		},

		{-2518, 17754, 688,
		"We've got Photons stored here in this tank that powers the entire station. Problem is, we've been using more than what we can produce lately, so that oil deposit that was found not long ago has been a great help...",
		},

		{-1037, 13699, 953,
		"That armour that was recovered was hacked by Badniks through and through and was sending signals that brought a bunch of them here... We had just about enough time to cleanse it and it SHOULD be usable, but we still have to evacuate due to the number of Badniks still present...",
		},

		{1237, 12418, 953,
		"After bringing the armour in, we found out that it emitted waves that were not only a beacon for other Badniks, but also corrupted Photons... We can cleanse the reserves, but it will take a while.",
		},

		{-5822, 8007, 953,
		"Badniks that enter contact with corrupted Photons sometimes get influenced by them and exhibit different behaviours... They don't seem to be any stronger, but people who fought them off reported their equipment malfunctioning after sustaining even minor injuries from them.",
		},

		{-4142, 1739, 816,
		"This stupid armour better be worth it, the amount of overtime I'll have to work purifying all these Photons... Dear god...",
		},

		{1390, 7414, 953,
		"How I wish we got to test the armour in combat ourselves before evacuating... We even found a cool name for it! The ARKS Interception Silhouhette, or A.I.S. for short!",
		},
		
	},

	npcdialogue = {
	
		["ogi"] = {
			"Something is definitely off, Badniks were somehow teleported inside of a space station. This makes no logical sense...",
			"The Badniks I fought were weirdly coordinated unlike the ones from the city. Something else seems to be pulling the strings now...",
		},
		
		["alis"] = {
			"We've never had a situation where Badniks ever made it in the station in any capacity... They all seem to be stragglers, so we should have it under control at least.",
			"So Badniks can get corrupted and exhibit new behaviours when they do... Interesting...",
		},
		
		["ursula"] = {
			"We can't afford to let anything happen to the station, this is where all of our energy supply is produced.",
			"It's good to know that the armour was able to be operated in a pinch to be extracted.",
		},
		
		["lumia"] = {
			"How did Badniks even get in here? We're in space!",
			"A part of the place was definitely damaged, but apparently it's nothing that can't be fixed... Phew...",
		},
		
		["flowen"] = {
			"In all my years here, I've never seen Badniks make it on board. We need to act fast.",
			"Something or someone is definitely aware of our posession of the armour and really isn't happy about it.",
		},
		
		["bernie"] = {
			"I can't say I've ever had any mission whatsoever happening directly in the station.",
			"A new breed of Badniks, huh. In all my time, I've never seen any quite like these.",
		},
		
		["lukot"] = {
			"Thankfully, the personnel in the area was able to safely evacuate the research team, but the armour had to be left behind.",
			"I had no idea corrupted Photons could affect Badniks like that, this is a first for me...",
		},
		
		["sue"] = {
			"And just when things were going our way. Seems whatever you brought back from the power plant, someone isn't happy about it.",
			"Well, I just hope they won't take from our paychecks to repair the mess.",
		},
		
		["pharia"] = {
			"The weapon was apparently hacked from the start... But it was too late when that was found out, Badniks had already started being teleported in by... something.",
			"At least this confirms the armour is operational. I took care to install jammers all over to mask our position for some time...",
		},
		
		["garoa"] = {
			"Well, that's a first, enemies on board, huh.",
			"I haven't been out of commission for that long, and Badniks are already showing some signs of evolution...",
		},
	},

	layout = {
		{0, 256, 24800, 270, 18560, 1160, 0, 1},
		{MT_PSO_CRATE, 576, 18880, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 544, 19104, 315, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -4448, 19712, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -2336, 17632, 0, 0, 0, 0, 2500},
		{7, -3712, 19328, 0, 0, 0, 0, 101},
		{7, -3712, 18816, 0, 0, 0, 0, 101},
		{41, -3904, 19072, 0, 0, 0, 0, 123},
		{18, -3968, 19584, 315, 0, 0, 1, 112},
		{18, -4032, 18624, 45, 0, 0, 1, 112},
		{12, -3712, 18528, 90, 0, 0, 1, 106},
		{41, -3808, 17952, 90, 0, 0, 2, 123},
		{41, -3616, 17952, 90, 0, 0, 2, 123},
		{17, -4128, 19456, 0, 0, 0, 2, 111},
		{17, -3296, 19456, 0, 0, 0, 2, 111},
		{MT_PSO_UNLOCKCARD, -2880, 17920, 1, 0, 0, 2, 2502},
		{MT_PSO_LASERTOWER, -3968, 19680, 0, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3712, 19680, 1, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3456, 19680, 2, 0, 0, 1, 2504},
		{MT_PSO_ROOMANCHOR, -7008, 21440, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -5600, 19008, 1, 0, 0, 0, 2500},
		{12, -6592, 20736, 1, 0, 0, 0, 106},
		{12, -6400, 21152, 315, 0, 0, 0, 106},
		{12, -6432, 20384, 45, 0, 0, 0, 106},
		{17, -6848, 20736, 0, 0, 0, 1, 111},
		{17, -6656, 21152, 0, 0, 0, 1, 111},
		{17, -6272, 21312, 0, 0, 0, 1, 111},
		{17, -5856, 21120, 0, 0, 0, 1, 111},
		{17, -5856, 20352, 0, 0, 0, 1, 111},
		{17, -6656, 20320, 0, 0, 0, 1, 111},
		{41, -6272, 20736, 0, 0, 0, 1, 123},
		{26, -6400, 19360, 90, 0, 0, 2, 115},
		{26, -6144, 19360, 90, 0, 0, 2, 115},
		{7, -6432, 19872, 90, 0, 0, 2, 101},
		{7, -6112, 19872, 90, 0, 0, 2, 101},
		{MT_PSO_UNLOCKCARD, -6272, 19680, 1, 0, 0, 2, 2502},
		{MT_PSO_CARDREADER, -3424, 19616, 270, 0, 0, 1, 2503},
		{MT_PSO_CARDREADER, -5984, 19520, 180, 0, 0, 1, 2503},
		{MT_PSO_LASERTOWER, -5888, 19560, 10, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -5888, 19328, 11, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -5888, 19096, 12, 0, 0, 1, 2504},
		{MT_PSO_ROOMANCHOR, -6400, 18328, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -4704, 16576, 2, 0, 0, 0, 2500},
		{18, -6224, 18080, 0, 0, 0, 0, 112},
		{18, -6224, 17808, 0, 0, 0, 0, 112},
		{18, -6224, 17552, 0, 0, 0, 0, 112},
		{18, -6224, 17232, 0, 0, 0, 0, 112},
		{18, -5840, 16864, 90, 0, 0, 0, 112},
		{18, -5600, 16864, 90, 0, 0, 0, 112},
		{18, -5376, 16864, 90, 0, 0, 0, 112},
		{18, -5104, 16864, 90, 0, 0, 0, 112},
		{12, -5888, 18192, 270, 0, 0, 1, 106},
		{12, -4816, 17520, 180, 0, 0, 1, 106},
		{26, -5024, 18064, 225, 0, 0, 1, 115},
		{26, -6160, 16944, 45, 0, 0, 1, 115},
		{9, -4912, 16912, 135, 0, 1, 1, 103},
		{9, -6176, 18160, 315, 0, 1, 1, 103},
		{MT_CRAWLACOMMANDER, -5856, 17552, 45, 0, 0, 2, 107},
		{MT_CRAWLACOMMANDER, -5424, 17296, 45, 0, 0, 2, 107},
		{17, -5632, 18208, 0, 0, 0, 2, 111},
		{17, -5344, 18208, 0, 0, 0, 2, 111},
		{17, -5696, 16784, 0, 0, 0, 2, 111},
		{17, -5296, 16784, 0, 0, 0, 2, 111},
		{MT_PSO_UNLOCKCARD, -6112, 17024, 1, 0, 0, 2, 2502},
		{MT_PSO_LASERTOWER, -6344, 16664, 20, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -6112, 16664, 21, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -5880, 16664, 22, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -6320, 16752, 90, 0, 0, 1, 2503},
		{MT_PSO_CRATE, -6240, 15360, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -5888, 15248, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -5856, 15600, 315, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -4448, 16896, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -2160, 13424, 3, 0, 0, 0, 2500},
		{41, -3648, 15424, 180, 0, 0, 0, 123},
		{26, -3712, 16352, 270, 0, 0, 0, 115},
		{26, -3712, 14272, 90, 0, 0, 0, 115},
		{41, -3712, 16560, 270, 0, 0, 1, 123},
		{41, -3712, 13968, 90, 0, 0, 1, 123},
		{7, -3408, 15616, 180, 0, 0, 1, 101},
		{7, -3408, 15152, 180, 0, 0, 1, 101},
		{MT_PSO_CRATE, -2608, 16784, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -2848, 16752, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -2640, 16448, 315, 0, 0, 0, 2505},
		{MT_PSO_LASERTRAP, -3776, 15424, 1, 0, 0, 1, 2530},
		{MT_PSO_LASERTRAP_START, -4272, 15424, 1, 0, 0, 1, 2531},
		{MT_PSO_LASERTRAP_END, -3712, 15424, 1, 4, 2, 1, 2532},
		{MT_PSO_LASERTOWER, -3264, 14088, 30, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3264, 13856, 31, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3264, 13624, 32, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -3344, 13664, 180, 4, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -3712, 14400, 1, 4, 0, 1, 2502},
		{MT_PSO_TURRET, 32, 16928, 0, 0, 0, 0, 2535},
		{MT_PSO_ROOMANCHOR, -1760, 18208, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 1888, 14864, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 3120, 14000, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4144, 11536, 5, 0, 0, 0, 2500},
		{7, -16, 15904, 180, 0, 0, 0, 101},
		{7, -32, 15456, 180, 0, 0, 0, 101},
		{17, 1680, 16000, 1, 0, 0, 0, 111},
		{17, 1680, 15600, 1, 0, 0, 0, 111},
		{17, 1680, 15280, 1, 0, 0, 0, 111},
		{41, -1040, 15776, 1, 0, 0, 1, 123},
		{41, -1040, 15312, 1, 0, 0, 1, 123},
		{41, 1088, 15760, 180, 0, 0, 1, 123},
		{41, 1072, 15280, 180, 0, 0, 1, 123},
		{MT_PSO_UNLOCKCARD, 16, 15664, 1, 0, 0, 1, 2502},
		{MT_PSO_LASERTOWER, 1168, 14912, 40, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1408, 14912, 41, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1648, 14912, 42, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 1120, 14976, 90, 0, 0, 1, 2503},
		{MT_PSO_CRATE, 1248, 14000, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1584, 13920, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1312, 12576, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1536, 12624, 315, 0, 0, 0, 2505},
		{9, 3392, 12544, 90, 0, 0, 0, 103},
		{9, 3648, 12544, 90, 0, 0, 0, 103},
		{9, 3920, 12544, 90, 0, 0, 0, 103},
		{41, 3648, 12240, 90, 0, 0, 0, 123},
		{12, 3360, 13280, 270, 0, 0, 1, 106},
		{12, 3936, 13280, 270, 0, 0, 1, 106},
		{11, 3472, 13568, 270, 0, 0, 1, 105},
		{11, 3792, 13568, 270, 0, 0, 1, 105},
		{26, 3280, 12368, 90, 0, 0, 2, 115},
		{26, 3648, 12368, 90, 0, 0, 2, 115},
		{26, 4000, 12368, 90, 0, 0, 2, 115},
		{MT_PSO_LASERTOWER, 3152, 12416, 50, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3152, 12272, 51, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3152, 12112, 52, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3152, 11968, 53, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3152, 11848, 54, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 3184, 12368, 0, 1, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 3184, 12176, 1, 0, 0, 2, 2502},
		{MT_PSO_ROOMANCHOR, -1488, 12704, 6, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 336, 10240, 6, 0, 0, 0, 2500},
		{7, -848, 11904, 6, 8, 0, 0, 101},
		{7, -384, 11360, 45, 8, 0, 0, 101},
		{41, -1024, 11568, 45, 0, 0, 0, 123},
		{41, -896, 11392, 45, 0, 0, 0, 123},
		{17, -880, 12400, 0, 8, 0, 1, 111},
		{17, 16, 12368, 0, 8, 0, 1, 111},
		{17, -1312, 11152, 0, 8, 0, 1, 111},
		{17, -480, 10960, 0, 8, 0, 1, 111},
		{7, -192, 11216, 135, 8, 0, 1, 101},
		{7, -1040, 12000, 315, 8, 0, 1, 101},
		{MT_PSO_UNLOCKCARD, -1104, 10624, 1, 0, 0, 1, 2502},
		{MT_PSO_LASERTOWER, -1360, 10272, 60, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1104, 10272, 61, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -848, 10272, 62, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -784, 10352, 90, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, -3200, 10176, 7, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 304, 7376, 7, 0, 0, 0, 2500},
		{MT_PSO_CRATE, 15232, 16896, 135, 5, 0, 1, 2505},
		{17, -2176, 8256, 0, 8, 0, 0, 111},
		{17, -2016, 8256, 0, 8, 0, 0, 111},
		{17, -1808, 8256, 0, 8, 0, 0, 111},
		{17, -1600, 8256, 0, 8, 0, 0, 111},
		{17, -1392, 8256, 0, 8, 0, 0, 111},
		{17, -1184, 8256, 0, 8, 0, 0, 111},
		{17, -912, 8256, 0, 8, 0, 0, 111},
		{17, -592, 8256, 0, 8, 0, 0, 111},
		{7, -1888, 9472, 90, 0, 0, 0, 101},
		{7, -1440, 9472, 90, 0, 0, 0, 101},
		{7, -960, 9472, 90, 0, 0, 0, 101},
		{17, -1936, 9760, 0, 8, 0, 1, 111},
		{17, -1728, 9760, 0, 8, 0, 1, 111},
		{17, -1520, 9760, 0, 8, 0, 1, 111},
		{17, -1312, 9760, 0, 8, 0, 1, 111},
		{17, -1104, 9760, 0, 8, 0, 1, 111},
		{17, -832, 9760, 0, 8, 0, 1, 111},
		{41, -1776, 8496, 270, 8, 0, 0, 123},
		{41, -1024, 8496, 270, 8, 0, 0, 123},
		{MT_PSO_UNLOCKCARD, -2560, 7840, 1, 0, 0, 1, 2502},
		{MT_PSO_LASERTOWER, -3024, 8048, 70, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3024, 7856, 71, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3024, 7648, 72, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3024, 7488, 73, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -2928, 8096, 0, 0, 0, 1, 2503},
		{MT_PSO_CRATE, -3760, 8176, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -5440, 8240, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -5792, 8320, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -5808, 7344, 315, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -8848, 4864, 8, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -7184, 3152, 8, 0, 0, 0, 2500},
		{6, -8528, 4528, 0, 8, 0, 0, 100},
		{6, -8672, 4272, 0, 8, 0, 0, 100},
		{6, -8688, 3968, 0, 8, 0, 0, 100},
		{6, -8528, 3760, 0, 8, 0, 0, 100},
		{7, -8224, 4304, 0, 8, 0, 0, 101},
		{7, -8224, 3968, 0, 8, 0, 0, 101},
		{9, -8304, 3312, 90, 8, 0, 1, 103},
		{9, -7968, 3312, 90, 8, 0, 1, 103},
		{41, -8128, 4096, 270, 0, 0, 1, 123},
		{MT_PSO_LASERTOWER, -8360, 3232, 80, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8128, 3232, 81, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -7896, 3232, 82, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -7912, 3288, 90, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -8128, 3520, 1, 0, 0, 1, 2502},
		{MT_PSO_CRATE, -8256, 1952, 315, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -7744, 2304, 9, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -5472, 1696, 9, 0, 0, 0, 2500},
		{9, -5888, 2176, 180, 8, 0, 0, 103},
		{9, -5888, 1984, 180, 8, 0, 0, 103},
		{9, -5888, 1792, 180, 8, 0, 0, 103},
		{17, -5792, 2176, 180, 8, 0, 1, 111},
		{17, -5792, 2048, 180, 8, 0, 1, 111},
		{17, -5792, 1888, 180, 8, 0, 1, 111},
		{17, -5792, 1792, 180, 8, 0, 1, 111},
		{17, -7680, 2176, 180, 8, 0, 1, 111},
		{17, -7680, 2048, 180, 8, 0, 1, 111},
		{17, -7680, 1888, 180, 8, 0, 1, 111},
		{17, -7680, 1792, 180, 8, 0, 1, 111},
		{MT_PSO_UNLOCKCARD, -6784, 1984, 1, 8, 0, 1, 2502},
		{MT_PSO_LASERTOWER, -5536, 2216, 90, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -5536, 1984, 91, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -5544, 1752, 92, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -5600, 2176, 180, 8, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, -5440, 2688, 10, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -3872, 1264, 10, 0, 0, 0, 2500},
		{41, -4560, 1984, 180, 8, 0, 0, 123},
		{7, -4608, 2368, 225, 8, 0, 0, 101},
		{7, -4608, 1616, 135, 8, 0, 0, 101},
		{17, -5056, 2352, 0, 8, 0, 1, 111},
		{17, -5104, 1648, 0, 8, 0, 1, 111},
		{17, -4256, 1632, 0, 8, 0, 1, 111},
		{17, -4288, 2368, 0, 8, 0, 1, 111},
		{41, -4800, 1984, 0, 8, 0, 1, 123},
		{MT_PSO_LASERTOWER, -4896, 2656, 100, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4672, 2656, 101, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4432, 2656, 102, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -4384, 2544, 270, 0, 0, 1, 2503},
		{MT_PSO_CRATE, -3424, 3552, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -3104, 3584, 315, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -2400, 2704, 11, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 128, 960, 11, 0, 0, 0, 2500},
		{MT_CRAWLACOMMANDER, -1184, 1840, 135, 8, 0, 0, 107},
		{9, -176, 2272, 180, 8, 0, 0, 103},
		{9, -192, 1824, 180, 8, 0, 0, 103},
		{9, -176, 1312, 180, 8, 0, 0, 103},
		{9, -2112, 1168, 90, 8, 0, 0, 103},
		{9, -1664, 1168, 90, 8, 0, 0, 103},
		{9, -1280, 1168, 90, 8, 0, 0, 103},
		{MT_PSO_UNLOCKCARD, -320, 2464, 1, 0, 0, 0, 2502},
		{MT_PSO_LASERTOWER, -576, 2600, 110, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -320, 2600, 111, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -64, 2600, 112, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -640, 2560, 270, 0, 0, 1, 2503},
		{MT_PSO_CRATE, 224, 4592, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 704, 4384, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1008, 7872, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1328, 7984, 315, 0, 0, 0, 2505},
		{MT_PSO_AIS, 5440, 7808, 180, 0, 0, 0, 2537},
		{MT_PSO_ROOMANCHOR, 2880, 9056, 12, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 5888, 6432, 12, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 5008, 7040, 120, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4832, 7040, 121, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4832, 7264, 122, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4832, 7552, 123, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4832, 7808, 124, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4832, 8000, 125, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4832, 8352, 126, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4832, 8576, 127, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 5008, 8576, 128, 0, 0, 1, 2504},
		{17, 4128, 8480, 180, 8, 0, 0, 111},
		{17, 4352, 8320, 180, 8, 0, 0, 111},
		{17, 4544, 8096, 180, 8, 0, 0, 111},
		{17, 4608, 7808, 180, 8, 0, 0, 111},
		{17, 4128, 7136, 180, 8, 0, 0, 111},
		{17, 4352, 7296, 180, 8, 0, 0, 111},
		{17, 4544, 7520, 180, 8, 0, 0, 111},
		{7, 3936, 8192, 180, 8, 0, 0, 101},
		{7, 3936, 7552, 180, 8, 0, 0, 101},
		{9, 4256, 7808, 180, 8, 0, 0, 103},
		{17, 3280, 8624, 180, 8, 0, 1, 111},
		{17, 3504, 8624, 180, 8, 0, 1, 111},
		{17, 3728, 8624, 180, 8, 0, 1, 111},
		{17, 4016, 8624, 180, 8, 0, 1, 111},
		{17, 3152, 7088, 180, 8, 0, 1, 111},
		{17, 3376, 7088, 180, 8, 0, 1, 111},
		{17, 3600, 7088, 180, 8, 0, 1, 111},
		{17, 3888, 7088, 180, 8, 0, 1, 111},
		{9, 4448, 6944, 135, 8, 0, 1, 103},
		{9, 4576, 8672, 225, 8, 0, 1, 103},
		{41, 4224, 8032, 180, 8, 0, 1, 123},
		{41, 4224, 7584, 180, 8, 0, 1, 123},
		{MT_PSO_UNLOCKCARD, 4000, 7808, 1, 8, 0, 1, 2502},
		{MT_PSO_CARDREADER, 4928, 8704, 180, 8, 0, 1, 2503},
		{MT_PSO_CARDREADER, 4960, 6944, 180, 8, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, 5248, 14144, 13, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 6560, 10752, 13, 0, 0, 0, 2500},
		{7, 5472, 12160, 270, 0, 0, 0, 101},
		{7, 5760, 12256, 270, 0, 0, 0, 101},
		{7, 5952, 12256, 270, 0, 0, 0, 101},
		{7, 6240, 12160, 270, 0, 0, 0, 101},
		{6, 5504, 12352, 270, 0, 0, 0, 100},
		{6, 6240, 12352, 270, 0, 0, 0, 100},
		{6, 5888, 12416, 270, 0, 0, 0, 100},
		{MT_PSO_LASERTOWER, 6312, 12560, 130, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 5392, 12560, 131, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, 5872, 13760, 2, 1, 0, 1, 2502},
		{MT_PSO_UNLOCKCARD, 5888, 12336, 1, 1, 0, 0, 2502},
		{MT_PSO_LASERTOWER, 6320, 13968, 140, 1, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 5392, 13968, 141, 0, 0, 2, 2504},
		{7, 6224, 13600, 270, 0, 0, 1, 101},
		{6, 5872, 13856, 270, 0, 0, 1, 100},
		{MT_PSO_CRATE, 14848, 16896, 135, 5, 0, 1, 2505},
		{9, 5504, 13776, 270, 0, 0, 1, 103},
		{9, 5760, 13696, 270, 0, 0, 1, 103},
		{9, 5968, 13696, 270, 0, 0, 1, 103},
		{9, 6256, 13760, 270, 0, 0, 1, 103},
		{7, 6016, 13808, 270, 0, 0, 1, 101},
		{7, 5760, 13808, 270, 0, 0, 1, 101},
		{7, 5504, 13616, 270, 0, 0, 1, 101},
		{7, 5872, 13552, 270, 0, 0, 1, 101},
		{MT_PSO_ROOMANCHOR, 3136, 19456, 14, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 6976, 15552, 14, 0, 0, 0, 2500},
		{7, 4416, 17408, 315, 8, 0, 0, 101},
		{7, 4480, 17728, 315, 8, 0, 0, 101},
		{7, 4800, 17856, 315, 8, 0, 0, 101},
		{7, 5120, 17792, 315, 8, 0, 0, 101},
		{7, 4928, 17472, 315, 8, 0, 0, 101},
		{9, 4160, 18048, 315, 8, 0, 0, 103},
		{9, 4736, 18368, 315, 8, 0, 0, 103},
		{9, 4416, 16896, 315, 8, 0, 0, 103},
		{9, 5376, 17472, 315, 8, 0, 0, 103},
		{17, 5136, 18320, 0, 8, 0, 1, 111},
		{17, 5520, 17424, 0, 8, 0, 1, 111},
		{17, 5232, 16240, 0, 8, 0, 1, 111},
		{17, 3824, 17264, 0, 8, 0, 1, 111},
		{17, 3824, 17872, 0, 8, 0, 1, 111},
		{17, 4624, 16240, 0, 8, 0, 1, 111},
		{17, 6128, 17424, 0, 8, 0, 1, 111},
		{17, 5360, 18320, 0, 8, 0, 1, 111},
		{41, 4152, 18216, 315, 8, 0, 1, 123},
		{41, 4608, 18576, 315, 8, 0, 1, 123},
		{41, 4008, 17016, 0, 8, 0, 1, 123},
		{41, 5384, 17888, 270, 8, 0, 1, 123},
		{MT_PSO_ROOMANCHOR, 3904, 23616, 15, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 5984, 20544, 15, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 3936, 19296, 150, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4768, 19296, 151, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, 4352, 18976, 1, 1, 0, 1, 2502},
		{7, 4352, 22880, 270, 8, 0, 0, 101},
		{7, 4128, 22528, 270, 8, 0, 0, 101},
		{7, 4576, 22528, 270, 8, 0, 0, 101},
		{17, 5056, 22752, 0, 0, 0, 0, 111},
		{17, 5152, 22304, 0, 0, 0, 0, 111},
		{17, 5248, 21888, 0, 0, 0, 0, 111},
		{17, 5344, 21440, 0, 0, 0, 0, 111},
		{MT_PSO_LASERTOWER, 4000, 23456, 160, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4768, 23456, 161, 0, 0, 1, 2504},
		{MT_PSO_ROOMANCHOR, 4640, 25024, 16, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 8768, 22752, 16, 0, 0, 0, 2500},
		{9, 7936, 24000, 180, 8, 0, 0, 103},
		{9, 7680, 23840, 180, 8, 0, 0, 103},
		{9, 7936, 23648, 180, 8, 0, 0, 103},
		{17, 6272, 23232, 0, 0, 0, 0, 111},
		{17, 6816, 23200, 0, 0, 0, 0, 111},
		{17, 7328, 23168, 0, 0, 0, 0, 111},
		{17, 7904, 23136, 0, 0, 0, 0, 111},
		{17, 5760, 24512, 0, 0, 0, 0, 111},
		{17, 6368, 24480, 0, 0, 0, 0, 111},
		{17, 7008, 24448, 0, 0, 0, 0, 111},
		{MT_PSO_LASERTOWER, 8608, 24192, 170, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 8608, 23424, 171, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, 4352, 23328, 1, 1, 0, 0, 2502},
		{MT_PSO_UNLOCKCARD, 8416, 23840, 1, 1, 0, 0, 2502},
		{MT_PSO_ROOMANCHOR, 8832, 23104, 17, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 12032, 20672, 17, 0, 0, 0, 2500},
		{17, 10208, 22496, 0, 8, 0, 0, 111},
		{17, 10976, 21152, 0, 8, 0, 0, 111},
		{9, 11008, 21952, 180, 8, 0, 0, 103},
		{9, 11008, 21728, 180, 8, 0, 0, 103},
		{MT_PSO_LASERTOWER, 11936, 22208, 180, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 11936, 21440, 181, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, 11680, 21824, 1, 1, 0, 0, 2502},
		{MT_PSO_ROOMANCHOR, 12064, 25376, 18, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 14912, 22848, 18, 0, 0, 0, 2500},
		{41, 12416, 24736, 270, 8, 0, 0, 123},
		{41, 12736, 24640, 270, 8, 0, 0, 123},
		{17, 13440, 23968, 0, 0, 0, 0, 111},
		{17, 13536, 24096, 0, 0, 0, 0, 111},
		{MT_PSO_LASERTOWER, 14048, 24416, 190, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 14816, 24416, 191, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, 13568, 24768, 1, 1, 0, 0, 2502},
		{MT_PSO_ROOMANCHOR, 13984, 22784, 19, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 15008, 20416, 19, 0, 0, 0, 2500},
		{6, 14208, 21600, 90, 0, 0, 0, 100},
		{6, 14304, 21728, 90, 0, 0, 0, 100},
		{6, 14464, 21792, 90, 0, 0, 0, 100},
		{6, 14592, 21728, 90, 0, 0, 0, 100},
		{6, 14720, 21600, 90, 0, 0, 0, 100},
		{6, 14208, 21184, 90, 8, 0, 0, 100},
		{6, 14336, 21184, 90, 8, 0, 0, 100},
		{6, 14464, 21184, 90, 8, 0, 0, 100},
		{6, 14592, 21184, 90, 8, 0, 0, 100},
		{6, 14720, 21184, 90, 8, 0, 0, 100},
		{6, 14400, 21088, 90, 8, 0, 0, 100},
		{6, 14528, 21088, 90, 8, 0, 0, 100},
		{MT_PSO_LASERTOWER, 14080, 20448, 200, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 14848, 20448, 201, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, 14464, 20864, 1, 1, 0, 0, 2502},
		{MT_PSO_ROOMANCHOR, 13248, 18752, 20, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 16352, 15360, 20, 1, 0, 0, 2500},
		{7, 14944, 16928, 135, 8, 0, 0, 101},
		{7, 15424, 17088, 135, 8, 0, 0, 101},
		{7, 14432, 16832, 135, 8, 0, 0, 101},
		{9, 15968, 16960, 135, 8, 0, 0, 103},
		{9, 15136, 16480, 135, 8, 0, 0, 103},
		{9, 14080, 16416, 135, 8, 0, 0, 103},
		{41, 15712, 16480, 135, 8, 0, 1, 123},
		{41, 14752, 16352, 135, 8, 0, 1, 123},
		{41, 15840, 17184, 135, 8, 0, 1, 123},
		{41, 14016, 16864, 135, 8, 0, 1, 123},
		{MT_CRAWLACOMMANDER, 15168, 16704, 135, 8, 0, 1, 107},
		{MT_PSO_CRATE, 13984, 17696, 135, 5, 0, 1, 2505},
		{MT_PSO_CRATE, 14464, 17696, 135, 5, 0, 1, 2505},
		{MT_PSO_CRATE, 14848, 17696, 135, 5, 0, 1, 2505},
		{MT_PSO_CRATE, 15200, 17696, 135, 5, 0, 1, 2505},
		{MT_PSO_CRATE, 13984, 17376, 135, 5, 0, 1, 2505},
		{MT_PSO_CRATE, 14464, 17376, 135, 5, 0, 1, 2505},
		{MT_PSO_CRATE, 14848, 17376, 135, 5, 0, 1, 2505},
		{MT_PSO_CRATE, 15232, 17376, 135, 5, 0, 1, 2505},
		{MT_PSO_CRATE, 13984, 17120, 135, 5, 0, 1, 2505},
		{MT_PSO_CRATE, 14464, 17120, 135, 5, 0, 1, 2505},
		{MT_PSO_CRATE, 14848, 17120, 135, 5, 0, 1, 2505},
		{MT_PSO_CRATE, 15232, 17120, 135, 5, 0, 1, 2505},
		{MT_PSO_CRATE, 13984, 16896, 135, 5, 0, 1, 2505},
		{MT_PSO_CRATE, 14464, 16896, 135, 5, 0, 1, 2505},
		{MT_PSO_UNLOCKCARD, -4672, 1984, 1, 0, 0, 1, 2502},
		{MT_PSO_TELEPORTER, 256, 24992, 1, 1, 1160, 0, 2510},
		{MT_PSO_TELEPORT_DEST, 256, 24864, 0, 0, 1160, 0, 2511},
		{MT_PSO_TELEPORTER, 14448, 16480, 1, 1, 0, 2, 2510},
	}
})

table.insert(PSO.info.quests[1].quests, {
	
	name = "6-2: Station Assault",
	desc = "Unknown signals are heading to the Low Orbit Station from the Moon. With no time to spare, the newly recovered armour will need to be sent out for outer-space combat. You are tasked with piloting it while the rest of the crew cleans up whatever may get past you.",
	objective = "Protect the Station!",
	
	questmusic = "EMERG",
	
	timer_off = true,	-- timer starts disabled until we enter a teleporter.

	prog = 13,
	
	map = mapnum,
	unlocks = {{1,15 }},	-- unlocks 7-1

	locked = true,		-- initially locked

	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {nil, nil},
		[DIFF_HARD] = 	{"weaponsbadge_1", 4},
	},

	drops = {
		[DIFF_NORMAL] = {	

			{"sword proto 1", 1, 0, 1, 400},
			{"sword proto 2", 1, 0, 1, 400},
			{"sword proto 3", 1, 0, 1, 400},
			{"doublesaber proto 1", 1, 0, 1, 400},
			{"doublesaber proto 2", 1, 0, 1, 400},
			{"doublesaber proto 3", 1, 0, 1, 400},
			{"spear proto 1", 1, 0, 1, 400},
			{"spear proto 2", 1, 0, 1, 400},
			{"spear proto 3", 1, 0, 1, 400},
			{"saber proto 1", 1, 0, 1, 400},
			{"saber proto 2", 1, 0, 1, 400},
			{"saber proto 3", 1, 0, 1, 400},
			{"rifle proto 1", 1, 0, 1, 400},
			{"rifle proto 2", 1, 0, 1, 400},
			{"rifle proto 3", 1, 0, 1, 400},
			{"shotgun proto 1", 1, 0, 1, 400},
			{"shotgun proto 2", 1, 0, 1, 400},
			{"shotgun proto 3", 1, 0, 1, 400},
			{"launcher proto 1", 1, 0, 1, 400},
			{"launcher proto 2", 1, 0, 1, 400},
			{"launcher proto 3", 1, 0, 1, 400},
			{"handgun proto 1", 1, 0, 1, 400},
			{"handgun proto 2", 1, 0, 1, 400},
			{"handgun proto 3", 1, 0, 1, 400},
			{"rod proto 1", 1, 0, 1, 400},
			{"rod proto 2", 1, 0, 1, 400},
			{"rod proto 3", 1, 0, 1, 400},
			{"wand proto 1", 1, 0, 1, 400},
			{"wand proto 2", 1, 0, 1, 400},
			{"wand proto 3", 1, 0, 1, 400},
		
			{"vita pine", 1, 0, 5, 100},
			{"vita burster", 1, 0, 5, 100},
			{"vita crest", 1, 0, 5, 100},
			{"vita claw", 0, 0, 5, 100},
			{"vita peacekeeper", 0, 0, 5, 100},
			{"vita hammer", 0, 0, 5, 100},			
			
			{"unit_hp_3", 1, 0, 2, 50},
			{"unit_pp_3", 1, 0, 2, 50},
			{"unit_satk_3", 1, 0, 2, 50},
			{"unit_tatk_3", 1, 0, 2, 50},
			{"unit_ratk_3", 1, 0, 2, 50},	

			{"vulture basher", 36, 55, 1, 150},
			{"double driller", 36, 55, 1, 150},
			{"winginator", 36, 55, 1, 150},
			{"sneg zapper", 36, 55, 1, 150},
			{"command shot", 36, 55, 1, 150},
			{"poss shooter", 36, 55, 1, 150},
			{"ice stabberrod", 36, 55, 1, 150},
			{"tcsm_crawla3", 36, 55, 1, 150},
			{"ice lancer", 36, 55, 1, 150},
			{"hatted cannon", 36, 55, 1, 150},
			{"asterod", 36, 55, 1, 150},
			
			{"fehler frame", 1, 0, 1, 50},
			{"hart frame", 1, 0, 1, 50},
		},

		[DIFF_HARD] = {	
			
			{"unit_hpsatk_3", 1, 0, 2, 50},
			{"unit_hptatk_3", 1, 0, 2, 50},
			{"unit_hpratk_3", 1, 0, 2, 50},
			
			{"vulture basher", 1, 0, 4, 100},
			{"double driller", 1, 0, 4, 100},
			
			{"trigrinder", 1, 0, 10, 100},
			
			{"sarblight", 1, 0, 1, 600},
			{"forblight", 1, 0, 1, 600},
			{"yasminkov 2000h", 1, 0, 1, 600},
			{"sarcuied", 1, 0, 1, 600},
			{"baston frame", 1, 0, 1, 100},
			{"makel frame", 1, 0, 1, 600},
			
			{6000, nil, nil, 1, 5},
		},

		[DIFF_VERYHARD] = {	
			
			{"unit_hpsatk_3", 1, 0, 2, 50},
			{"unit_hptatk_3", 1, 0, 2, 50},
			{"unit_hpratk_3", 1, 0, 2, 50},
			
			{"vulture basher", 1, 0, 4, 100},
			{"double driller", 1, 0, 4, 100},
			
			{"trigrinder", 1, 0, 10, 100},
			
			{"sarblight", 1, 0, 1, 600},
			{"forblight", 1, 0, 1, 600},
			{"yasminkov 2000h", 1, 0, 1, 600},
			{"sarcuied", 1, 0, 1, 600},
			{"baston frame", 1, 0, 1, 100},
			{"makel frame", 1, 0, 1, 600},
			
			{6000, nil, nil, 1, 5},
		},
		
	},

	npcdialogue = {
	
		["ogi"] = {
			"Well, it would seem this is all on you. You're the only one with any experience controlling this armour.",
			"I never had any doubt that you'd win, it's just what you do at this point!",
		},
		
		["alis"] = {
			"Unknown entities aproaching... This doesn't bode well, especially when you're the only one capable of fighting them head on. We don't know how many there are...!",
			"It's good that you were able to adapt so quickly, things could've gone very sour...",
		},
		
		["ursula"] = {
			"I'm not worried, knowing you're the one in charge of this operation. I'd even stay here and have a drink, but the rest of the station is going on lockdown for security reasons soon.",
			"Some of these things did make it onto the station, but we had no real trouble fighting them off. And I see you did a remarkable job as always, too.",
		},
		
		["lumia"] = {
			"Normally I'd be worried, but you get to bring out this armour out for space combat! How exciting is that! ...Do come back alive though, okay?",
			"And it looks like I was right not to be worried!",
		},
		
		["flowen"] = {
			"You've earned my trust already. I have no qualms with your being the pilot for this mission. We'll stay back and handle whatever slips past you.",
			"So these new entities came from the moon, eh. I suppose this is where we're headed next.",
		},
		
		["bernie"] = {
			"With you as the welcome mat, I don't expect we'll have much left to clean up, haha.",
			"These new enemies are tough, if we had had to fight more of them on foot, it could've been troubling.",
		},
		
		["lukot"] = {
			"I have a full faith in you, we'll all be ready to intercept whatever makes it past you. Focus on eliminating whatever is commanding them!",
			"These enemies were unlike anything I had ever seen...",
		},
		
		["sue"] = {
			"Well, I guess there's no fighting it, you get to steal all the glory today. Go on, we're counting on ya.",
			"You did such a good job only a few of these made it in. They're quite tough but nothing I can't handle.",
		},
		
		["pharia"] = {
			"From the Moon... We never thought to look at anything about it... I don't suppose my jammers did anything...",
			"Peculiar new enemies... They seem powered by a different kind of energy, and controlled by something else...",
		},
		
		["garoa"] = {
			"I expected more Badniks, but things headed straight from the moon?",
			"These new things are pretty dangerous. We'll have to learn more about them if we're going to fight more...",
		},
	},
	
	levels = {
		[DIFF_NORMAL] = 40,
		[DIFF_HARD] = 75,
		[DIFF_VERYHARD] = 101,
	},

	grading = {
		{QG_TIME, 50, 0, TICRATE*60*9, TICRATE*60*12},
		{QG_DAMAGETAKEN, 40, 0, 14000, 25000},
		{QG_NOINCAP, 10},
	},

	layout = {
		{MT_PSO_ANGE, 15616, 2048, 270, 1, 0, 0, 2556},
		{MT_PSO_UNLOCKCARD, -8112, -9456, 1, 1, 0, 1, 2502},
		{MT_PSO_ROOMANCHOR, -20480, -8064, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -17088, -10496, 0, 0, 0, 0, 2500},
		{41, -19136, -8576, 225, 8, 0, 0, 123},
		{41, -18432, -8832, 225, 8, 0, 0, 123},
		{41, -17920, -9216, 225, 8, 0, 0, 123},
		{41, -17920, -9728, 225, 8, 0, 0, 123},
		{6, -18944, -9024, 225, 8, 0, 0, 100},
		{6, -18496, -9088, 225, 8, 0, 0, 100},
		{6, -18368, -9408, 225, 8, 0, 0, 100},
		{6, -18880, -9344, 225, 8, 0, 0, 100},
		{17, -18368, -8448, 225, 8, 0, 0, 111},
		{17, -17856, -8640, 225, 8, 0, 0, 111},
		{17, -17728, -9088, 225, 8, 0, 0, 111},
		{17, -17664, -9536, 180, 8, 0, 0, 111},
		{MT_PSO_GYLIR_CANNON, -19456, -8320, 270, 0, 96, 1, 2701},
		{MT_PSO_GYLIR_CANNON, -17344, -9984, 270, 0, 96, 1, 2701},
		{MT_PSO_GYLIR_DRILL, -19904, -8960, 270, 0, 0, 1, 2702},
		{MT_PSO_GYLIR_DRILL, -18624, -9728, 180, 0, 0, 1, 2702},
		{9, -19328, -9088, 225, 8, 0, 1, 103},
		{9, -18880, -8704, 225, 8, 0, 1, 103},
		{9, -18176, -9408, 225, 8, 0, 1, 103},
		{MT_PSO_LASERTOWER, -17680, -8208, 0, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -17680, -8528, 1, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -17680, -8816, 2, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -17680, -9168, 3, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -17408, -9168, 4, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -17168, -9168, 5, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, -18080, -8800, 1, 1, 0, 2, 2502},
		{MT_PSO_GYLIR_CANNON, -17600, -10432, 270, 0, 96, 2, 2701},
		{MT_PSO_GYLIR_CANNON, -18624, -10432, 270, 0, 96, 2, 2701},
		{MT_CRAWLACOMMANDER, -18688, -9088, 270, 8, 0, 2, 107},
		{MT_PSO_GYLIR_CANNON, -19200, -8320, 315, 0, 96, 2, 2701},
		{MT_PSO_GYLIR_CANNON, -20224, -9792, 45, 0, 96, 2, 2701},
		{MT_PSO_ROOMANCHOR, -16960, -7360, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -13504, -10800, 1, 0, 0, 0, 2500},
		{41, -15616, -7616, 180, 8, 0, 0, 123},
		{41, -15872, -8320, 180, 8, 0, 0, 123},
		{17, -13616, -7808, 180, 0, 0, 0, 111},
		{17, -13616, -8064, 180, 0, 0, 0, 111},
		{17, -13616, -8320, 180, 0, 0, 0, 111},
		{17, -13616, -8640, 180, 0, 0, 0, 111},
		{17, -13616, -9024, 180, 0, 0, 0, 111},
		{MT_PSO_GANNIL_SLASH, -15040, -8064, 180, 0, 0, 0, 2703},
		{MT_PSO_GANNIL_SLASH, -15040, -9728, 90, 0, 0, 1, 2703},
		{MT_PSO_GYLIR_DRILL, -15552, -9856, 90, 0, 0, 1, 2702},
		{MT_PSO_GYLIR_DRILL, -14848, -9792, 90, 0, 0, 1, 2702},
		{MT_PSO_GANNIL_SHOT, -13616, -7936, 225, 0, 56, 1, 2704},
		{MT_PSO_GYLIR_CANNON, -13616, -8512, 225, 0, 96, 2, 2701},
		{MT_PSO_GYLIR_CANNON, -15296, -7808, 270, 0, 96, 2, 2701},
		{MT_PSO_GYLIR_CANNON, -14656, -7808, 270, 0, 96, 2, 2701},
		{MT_PSO_GANNIL_SLASH, -15872, -10304, 45, 0, 0, 1, 2703},
		{MT_PSO_LASERTOWER, -14080, -9872, 10, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -14080, -10304, 11, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -14080, -10736, 12, 0, 0, 0, 2504},
		{MT_PSO_UNLOCKCARD, -14432, -10304, 1, 1, 0, 2, 2502},
		{MT_PSO_ROOMANCHOR, -13968, -9456, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -11792, -10800, 2, 0, 0, 0, 2500},
		{MT_PSO_GANNIL_SLASH, -12592, -9744, 180, 0, 0, 0, 2703},
		{MT_PSO_GANNIL_SLASH, -12352, -10528, 180, 0, 0, 0, 2703},
		{MT_PSO_GYLIR_CANNON, -13248, -9592, 270, 0, 96, 0, 2701},
		{MT_PSO_GYLIR_CANNON, -12960, -9592, 270, 0, 96, 0, 2701},
		{MT_PSO_GYLIR_CANNON, -12688, -9592, 270, 0, 96, 0, 2701},
		{MT_PSO_LASERTOWER, -11904, -9616, 30, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -11904, -10176, 31, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -11904, -10736, 32, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, -12032, -10176, 1, 1, 0, 0, 2502},
		{MT_PSO_GANNIL_SHOT, -9920, -8992, 1, 0, 0, 0, 2704},
		{MT_PSO_GANNIL_SHOT, -9360, -9472, 1, 0, 0, 0, 2704},
		{MT_PSO_GANNIL_SHOT, -9264, -10032, 1, 0, 0, 0, 2704},
		{MT_PSO_GYLIR_CANNON, -9200, -8576, 1, 0, 96, 0, 2701},
		{MT_PSO_GYLIR_CANNON, -8800, -8768, 1, 0, 96, 0, 2701},
		{MT_PSO_GYLIR_CANNON, -8592, -9104, 1, 0, 96, 0, 2701},
		{MT_PSO_GYLIR_CANNON, -8464, -9552, 1, 0, 96, 0, 2701},
		{MT_PSO_GYLIR_CANNON, -8528, -10048, 1, 0, 96, 0, 2701},
		{MT_PSO_GANNIL_SLASH, -10576, -9616, 180, 0, 0, 0, 2703},
		{MT_PSO_GANNIL_SLASH, -10368, -10000, 180, 0, 0, 0, 2703},
		{MT_PSO_GYLIR_DRILL, -10464, -9184, 180, 0, 0, 0, 2702},
		{MT_PSO_GYLIR_DRILL, -10144, -9392, 180, 0, 0, 0, 2702},
		{MT_PSO_GYLIR_DRILL, -9808, -9680, 180, 0, 0, 0, 2702},
		{MT_PSO_GYLIR_DRILL, -9664, -9968, 180, 0, 0, 0, 2702},
		{MT_PSO_GYLIR_DRILL, -9728, -10368, 180, 0, 0, 0, 2702},
		{MT_PSO_GYLIR_CANNON, -8320, -10592, 180, 0, 96, 1, 2701},
		{MT_PSO_GYLIR_CANNON, -8976, -10752, 180, 0, 96, 1, 2701},
		{MT_PSO_GYLIR_CANNON, -9952, -8192, 180, 0, 96, 1, 2701},
		{MT_PSO_GYLIR_CANNON, -9200, -8144, 180, 0, 96, 1, 2701},
		{MT_PSO_GANNIL_SLASH, -9280, -8944, 180, 0, 0, 1, 2703},
		{MT_PSO_GANNIL_SLASH, -8928, -9408, 180, 0, 0, 1, 2703},
		{MT_PSO_GANNIL_SLASH, -9184, -9792, 180, 0, 0, 1, 2703},
		{MT_PSO_LASERTOWER, -7888, -9072, 40, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -7888, -9440, 41, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -7888, -9808, 42, 0, 0, 1, 2504},
		{MT_PSO_CRATE, 24192, 1312, 270, 1, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -11456, -7792, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -7792, -11088, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 10464, 7520, 4, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 26496, -3584, 4, 1, 0, 0, 2500},
		{MT_PSO_AIS, 23872, 64, 90, 0, 0, 0, 2537},
		{MT_PSO_AIS, -20640, -10704, 45, 8, 0, 1, 2537},
		{MT_PSO_AIS, 23872, 768, 90, 8, 0, 15, 2537},
		{MT_PSO_CRATE, 23552, 1888, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 23872, 1888, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 24192, 1888, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 23552, 1696, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 23872, 1696, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 24192, 1696, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 23552, 1504, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 23872, 1504, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 24192, 1504, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 23552, 1312, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 23872, 1312, 270, 1, 0, 0, 2505},
		{MT_PSO_TELEPORT_DEST, 23872, 2240, 0, 0, 0, 0, 2511},
		{MT_PSO_TELEPORTER, 23872, 2416, 1, 1, 0, 0, 2510},
	}
	
	
})

PSO.info.crateDropTables[mapnum] = {
		[DIFF_NORMAL] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 5},
			{"monomate", 0, 0, 1, 20},
			{"dimate", 0, 0, 1, 30},
			{"trimate", 0, 0, 1, 40},
			{"telepipe", 0, 0, 1, 30},

			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},
			
			{"sword proto 1", 0, 0, 1, 300},
			{"sword proto 2", 0, 0, 1, 300},
			{"sword proto 3", 0, 0, 1, 300},
			{"spear proto 1", 0, 0, 1, 300},
			{"spear proto 2", 0, 0, 1, 300},
			{"spear proto 3", 0, 0, 1, 300},
			{"doublesaber proto 1", 0, 0, 1, 300},
			{"doublesaber proto 2", 0, 0, 1, 300},
			{"doublesaber proto 3", 0, 0, 1, 300},
			{"rifle proto 1", 0, 0, 1, 300},
			{"rifle proto 2", 0, 0, 1, 300},
			{"rifle proto 3", 0, 0, 1, 300},
			{"shotgun proto 1", 0, 0, 1, 300},
			{"shotgun proto 2", 0, 0, 1, 300},
			{"shotgun proto 3", 0, 0, 1, 300},
			{"launcher proto 1", 0, 0, 1, 300},
			{"launcher proto 2", 0, 0, 1, 300},
			{"launcher proto 3", 0, 0, 1, 300},
			{"rod proto 1", 0, 0, 1, 300},
			{"rod proto 2", 0, 0, 1, 300},
			{"rod proto 3", 0, 0, 1, 300},
			{"saber proto 1", 0, 0, 1, 300},
			{"saber proto 2", 0, 0, 1, 300},
			{"saber proto 3", 0, 0, 1, 300},
			{"handgun proto 1", 0, 0, 1, 300},
			{"handgun proto 2", 0, 0, 1, 300},
			{"handgun proto 3", 0, 0, 1, 300},
			{"wand proto 1", 0, 0, 1, 300},
			{"wand proto 2", 0, 0, 1, 300},
			{"wand proto 3", 0, 0, 1, 300},
			
			{"sword_pa_overend", 0, 0, 1, 300},
			{"dsaber_pa_quickgash", 0, 0, 1, 300},
			{"spear_pa_scythecleave", 0, 0, 1, 300},
			{"rifle_pa_revoltaim", 0, 0, 1, 300},
			{"shotgun_pa_trickblast", 0, 0, 1, 300},
			{"launcher_pa_feareraser", 0, 0, 1, 300},
			{"ilgrants", 0, 0, 1, 300},
			{"ilmegid", 0, 0, 1, 300},
			{"foverse", 0, 0, 1, 300},
			{"nabarta", 0, 0, 1, 300},
			{"zondeel", 0, 0, 1, 300},
			{"diverse", 0, 0, 1, 300},
			{"zalure", 0, 0, 1, 300},
			{"jellen", 0, 0, 1, 300},
			
			{"scape doll", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 20},
			{"star atomizer", 0, 0, 1, 20},
			{"sol atomizer", 0, 0, 1, 50},
			{"shiftaride", 0, 0, 1, 50},
			{"debanride", 0, 0, 1, 50},
			
			{"pine", 0, 0, 1, 100},
			{"alva pine", 0, 0, 1, 100},
			{"shooter", 0, 0, 1, 100},
			{"alva shooter", 0, 0, 1, 100},
			{"crest", 0, 0, 1, 100},
			{"alva crest", 0, 0, 1, 100},
			{"hammer", 0, 0, 1, 100},
			{"alva hammer", 0, 0, 1, 100},
			{"claw", 0, 0, 1, 100},
			{"alva claw", 0, 0, 1, 100},
			{"peacekeeper", 0, 0, 1, 100},
			{"alva peacekeeper", 0, 0, 1, 100},
			{"fork", 0, 0, 1, 100},
			{"grenade", 0, 0, 1, 100},			
			{"alva fork", 0, 0, 1, 100},
			{"alva grenade", 0, 0, 1, 100},				
			
			{"magnet frame", 0, 0, 1, 60},

			{"unit_hpsatk_3", 0, 0, 2, 100},
			{"unit_hpratk_3", 0, 0, 2, 100},
			{"unit_hptatk_3", 0, 0, 2, 100},
			{"unit_rainbow_3", 0, 0, 2, 100},
			{"unit_power_3", 0, 0, 2, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},

			{"unit_hpsatk_2", 0, 0, 2, 100},
			{"unit_hpratk_2", 0, 0, 2, 100},
			{"unit_hptatk_2", 0, 0, 2, 100},
			{"unit_rainbow_2", 0, 0, 2, 100},
			{"unit_power_2", 0, 0, 2, 100},
			{"unit_ppregen_1", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
		},

		[DIFF_HARD] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 5},
			{"monomate", 0, 0, 1, 30},
			{"dimate", 0, 0, 1, 40},
			{"trimate", 0, 0, 1, 60},
			{"telepipe", 0, 0, 1, 30},

			{"sword proto 1", 0, 0, 1, 300},
			{"sword proto 2", 0, 0, 1, 300},
			{"sword proto 3", 0, 0, 1, 300},
			{"spear proto 1", 0, 0, 1, 300},
			{"spear proto 2", 0, 0, 1, 300},
			{"spear proto 3", 0, 0, 1, 300},
			{"doublesaber proto 1", 0, 0, 1, 300},
			{"doublesaber proto 2", 0, 0, 1, 300},
			{"doublesaber proto 3", 0, 0, 1, 300},
			{"rifle proto 1", 0, 0, 1, 300},
			{"rifle proto 2", 0, 0, 1, 300},
			{"rifle proto 3", 0, 0, 1, 300},
			{"shotgun proto 1", 0, 0, 1, 300},
			{"shotgun proto 2", 0, 0, 1, 300},
			{"shotgun proto 3", 0, 0, 1, 300},
			{"launcher proto 1", 0, 0, 1, 300},
			{"launcher proto 2", 0, 0, 1, 300},
			{"launcher proto 3", 0, 0, 1, 300},
			{"rod proto 1", 0, 0, 1, 300},
			{"rod proto 2", 0, 0, 1, 300},
			{"rod proto 3", 0, 0, 1, 300},
			{"saber proto 1", 0, 0, 1, 300},
			{"saber proto 2", 0, 0, 1, 300},
			{"saber proto 3", 0, 0, 1, 300},
			{"handgun proto 1", 0, 0, 1, 300},
			{"handgun proto 2", 0, 0, 1, 300},
			{"handgun proto 3", 0, 0, 1, 300},
			{"wand proto 1", 0, 0, 1, 300},
			{"wand proto 2", 0, 0, 1, 300},
			{"wand proto 3", 0, 0, 1, 300},

			{"baston frame", 0, 0, 1, 500},
			{"makel frame", 0, 0, 1, 1000},
			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},
			{"unit_critr_special1", 0, 0, 1, 400},
			{"unit_speed_special1", 0, 0, 1, 400},
			{"unit_speed_3", 0, 0, 1, 300},
			{"unit_critr_3", 0, 0, 1, 300},
			{"unit_critd_3", 0, 0, 1, 300},
			{"unit_all_3", 0, 0, 1, 300},
			{"unit_hppp_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},
			{"unit_ppratk_3", 0, 0, 1, 100},
			{"unit_ppsatk_3", 0, 0, 1, 100},
			{"unit_pptatk_3", 0, 0, 1, 100},

			{"unit_satk_3", 0, 0, 1, 100},
			{"unit_ratk_3", 0, 0, 1, 100},
			{"unit_tatk_3", 0, 0, 1, 100},
			
			{"scape doll", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 20},
			{"star atomizer", 0, 0, 1, 20},
			{"sol atomizer", 0, 0, 1, 50},
			{"shiftaride", 0, 0, 1, 50},
			{"debanride", 0, 0, 1, 50},
			
			{"vita pine", 0, 0, 1, 100},
			{"vita shooter", 0, 0, 1, 100},
			{"vita crest", 0, 0, 1, 100},
			{"vita hammer", 0, 0, 1, 100},
			{"vita claw", 0, 0, 1, 100},
			{"vita peacekeeper", 0, 0, 1, 100},	
			{"vita fork", 0, 0, 1, 100},
			{"vita grenade", 0, 0, 1, 100},	
		},

		[DIFF_VERYHARD] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 5},
			{"monomate", 0, 0, 1, 30},
			{"dimate", 0, 0, 1, 40},
			{"trimate", 0, 0, 1, 60},
			{"telepipe", 0, 0, 1, 30},

			{"sword proto 1", 0, 0, 1, 400},
			{"sword proto 2", 0, 0, 1, 400},
			{"sword proto 3", 0, 0, 1, 400},
			{"spear proto 1", 0, 0, 1, 400},
			{"spear proto 2", 0, 0, 1, 400},
			{"spear proto 3", 0, 0, 1, 400},
			{"doublesaber proto 1", 0, 0, 1, 400},
			{"doublesaber proto 2", 0, 0, 1, 400},
			{"doublesaber proto 3", 0, 0, 1, 400},
			{"rifle proto 1", 0, 0, 1, 400},
			{"rifle proto 2", 0, 0, 1, 400},
			{"rifle proto 3", 0, 0, 1, 400},
			{"shotgun proto 1", 0, 0, 1, 400},
			{"shotgun proto 2", 0, 0, 1, 400},
			{"shotgun proto 3", 0, 0, 1, 400},
			{"launcher proto 1", 0, 0, 1, 400},
			{"launcher proto 2", 0, 0, 1, 400},
			{"launcher proto 3", 0, 0, 1, 400},
			{"rod proto 1", 0, 0, 1, 400},
			{"rod proto 2", 0, 0, 1, 400},
			{"rod proto 3", 0, 0, 1, 400},
			{"saber proto 1", 0, 0, 1, 400},
			{"saber proto 2", 0, 0, 1, 400},
			{"saber proto 3", 0, 0, 1, 400},
			{"handgun proto 1", 0, 0, 1, 400},
			{"handgun proto 2", 0, 0, 1, 400},
			{"handgun proto 3", 0, 0, 1, 400},
			{"wand proto 1", 0, 0, 1, 400},
			{"wand proto 2", 0, 0, 1, 400},
			{"wand proto 3", 0, 0, 1, 400},
			
			{"scape doll", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 20},
			{"star atomizer", 0, 0, 1, 20},
			
			{"vita pine", 0, 0, 1, 100},
			{"vita shooter", 0, 0, 1, 100},
			{"vita crest", 0, 0, 1, 100},
			{"vita hammer", 0, 0, 1, 100},
			{"vita claw", 0, 0, 1, 100},
			{"vita peacekeeper", 0, 0, 1, 100},	
			{"vita fork", 0, 0, 1, 100},
			{"vita grenade", 0, 0, 1, 100},	

			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},			
			{"baston frame", 0, 0, 1, 300},
			{"makel frame", 0, 0, 1, 1000},
			{"unit_hpsatk_3", 0, 0, 1, 100},
			{"unit_hpratk_3", 0, 0, 1, 100},
			{"unit_hptatk_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},	
			{"unit_all_3", 0, 0, 1, 300},
		},
		
}