local mapnum = 4

/*
	quest format:
	{
		>>COSMETIC STUFF
		name: 		quest name
		objective:	description of the objective
		desc: 		description
	
	
		>>ACTUAL GAMEPLAY RELEVANT STUFF
		map:		map number the quest takes place in
					(players will be warped to it as soon as everyone gets to the teleporter)
		
		layout = {}: 	object layout for the map.
						worth noting the object layout CANNOT be changed in the lobby.
		
		levels = {                                                                    ,..,.,.,.,.,.,..        
			[DIFF_NORMAL] = x,
			[DIFF_HARD] = x,
			[...]
		}: enemy level per difficulty
		
		
		
	}
*/

/*table.insert(PSO.info.quests[mapnum], {
	
	name = "Test quest",
	desc = "Doesn't load object layout, enemy level matches player level",
	objective = "Test your shit",
	
	map = 1,
	
	levels = {
		[DIFF_NORMAL] = 1,
		[DIFF_HARD] = 1,
		--[DIFF_VERYHARD] = 1,
		[DIFF_SUPERHARD] = 1,
		[DIFF_EXTREMELYHARD] = 1,
		[DIFF_ULTRAHARD] = 1,
	},
})*/


table.insert(PSO.info.quests[1].quests, {
	
	name = "3-1: Cold Expedition",
	desc = "In light of your recent accomplishments, you have been tasked with investigating an old case. Bizarre signals were found periodcally originating from a remote mountainous area, but investigations revealed nothing. Your task is to survey the area and find potential answers.",
	objective = "Make your way through the mountain.",
	
	map = mapnum,

	prog = 6,

	locked = true,		-- initially locked
	unlocks = {{1,8 }},	-- unlocks 3-2

	drops = {
		[DIFF_NORMAL] = {	
			{"pine", 1, 0, 5, 100},
			{"burster", 1, 0, 5, 100},
			{"crest", 1, 0, 5, 100},
			{"claw", 0, 0, 5, 100},
			{"peacekeeper", 0, 0, 5, 100},
			{"hammer", 0, 0, 5, 100},			
			
			{"unit_hp_2", 1, 0, 2, 50},
			{"unit_pp_2", 1, 0, 2, 50},
			{"unit_satk_2", 1, 0, 2, 50},
			{"unit_tatk_2", 1, 0, 2, 50},
			{"unit_ratk_2", 1, 0, 2, 50},
			
			{"icicle frame", 1, 0, 1, 50},
		},

		[DIFF_HARD] = {	
			{"alva pine", 1, 0, 5, 50},
			{"alva burster", 0, 0, 5, 50},
			{"alva crest", 0, 0, 5, 50},			

			{"alva doubliss", 1, 0, 5, 100},
			{"alva concentrator", 1, 0, 5, 100},
			
			{"abnormal shard", 0, 0, 1, 600},
			{"chainsawd", 0, 0, 1, 600},
			{"frozen shooter", 0, 0, 1, 600},
			{"double cannon", 0, 0, 1, 600},
			{"ruby bullet", 0, 0, 1, 600},
			
			{"steel hearts", 51, 79,1, 700},
			{"seal case", 51, 79,1, 700},
			{"zanba", 51, 79, 1, 1000},
			{"last survivor", 51, 79, 1, 1000},
			{"monkey king bar", 51, 79,1, 700},
			{"girasole", 51, 79,1, 700},
			{"d. saber legacy", 51, 79, 1, 1000},
			{"eternal heat", 51, 79, 1, 1000},		
			{"basilleon", 51, 79,1, 700},
			{"longinus", 51, 79,1, 700},
			{"meteor lancer", 51, 79, 1, 1000},
			{"brionac", 51, 79, 1, 1000},			
			{"sarblight", 51, 79,1, 700},
			{"forblight", 51, 79,1, 700},	
			{"grand cross", 51, 79, 1, 1000},
			{"red saber", 51, 79, 1, 1000},
			{"full cylinder", 51, 79,1, 700},
			{"assassin", 51, 79,1, 700},
			{"yasminkov 3000r", 51, 79, 1, 1000},
			{"strauss", 51, 79, 1, 1000},			
			{"wide smack", 51, 79,1, 700},
			{"heimdall", 51, 79,1, 700},
			{"barett", 51, 79, 1, 1000},		
			{"photon launcher", 51, 79,1, 700},
			{"saint kilda", 51, 79,1, 700},
			{"charge howzer", 51, 79, 1, 1000},
			{"gur bazga", 51, 79, 1, 1000},		
			{"yasminkov 2000h", 51, 79,1, 700},
			{"sarcueid", 51, 79,1, 700},
			{"varista", 51, 79, 1, 1000},
			{"bravace", 51, 79, 1, 1000},			
			{"clarita visas", 51, 79,1, 700},
			{"red processor", 51, 79,1, 700},
			{"battle verge", 51, 79, 1, 1000},
			{"brave hammer", 51, 79, 1, 1000},
			{"windmill", 51, 79,1, 700},
			{"hexigraph", 51, 79,1, 700},
			{"serdote", 51, 79, 1, 1000},
			{"rose quartz", 51, 79, 1, 1000},		
			{"tcsm_crawla4", 51, 79,1, 700},
			{"tcsm_omochao", 51, 79, 1, 1000},
			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},
			{"unit_critr_special1", 0, 0, 1, 400},
			{"unit_speed_special1", 0, 0, 1, 400},
			{"unit_speed_3", 0, 0, 1, 300},
			{"unit_critr_3", 0, 0, 1, 300},
			{"unit_critd_3", 0, 0, 1, 300},
			{"unit_all_3", 0, 0, 1, 300},
			{"unit_hppp_2", 0, 0, 1, 100},
			{"unit_hppp_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_2", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},

			{"winginator", 1, 0, 1, 100},
			{"asterod", 1, 0, 1, 100},
			{"hatted cannon", 1, 0, 1, 100},
			{"fehler frame", 1, 0, 5, 100},
			{"permafrost frame", 1, 0, 1, 100},
			{"hart frame", 1, 0, 1, 100},
			
			{6000, nil, nil, 1, 5},
		},

		[DIFF_VERYHARD] = {	
			
			{"unit_ppsatk_3", 1, 0, 7, 50},
			{"unit_pptatk_3", 1, 0, 7, 50},
			{"unit_ppratk_3", 1, 0, 7, 50},
			{"unit_rainbow_3", 1, 0, 7, 50},

			{"winginator", 1, 0, 4, 100},
			{"asterod", 1, 0, 4, 100},
			{"hatted cannon", 1, 0, 4, 100},
			{"permafrost frame", 1, 0, 4, 100},
			
			{"sealed case", 1, 0, 1, 600},
			{"assassin", 1, 0, 1, 600},
			{"clarita visas", 1, 0, 1, 600},

			{"fehler frame", 1, 0, 10, 100},
			{"baston frame", 1, 0, 1, 100},
			{"makel frame", 1, 0, 1, 600},
			
			{6000, nil, nil, 1, 5},
		},
		
	},
	
	datapods = {
		{4527, -2652, 0,
		"The water here is so cold and makes me feel sluggish... If you can help it, avoid walking in there...",
		},

		{1046, -4247, -176,
		"These snowman-shaped Badniks are really dangerous. If they get a clean hit on you, you'll be frozen solid for a bit... Make sure to take them out first if you see one!",
		},

		{6073, -5642, -168,
		"The ice here has Photons frozen inside, this is why it's so bright. Maybe we could use it on weapons to make them more efficient, too?",
		},

		{8764, -9711, 416,
		"A high number of Badniks always seems to congregate here. We can detect a faint signal but can't pinpoint its exact location...",
		},
		
	},

	npcdialogue = {
	
		["ogi"] = {
			"Seems your accomplishments got you to be able to take on this assignment mostly solo.",
			"High Badnik density? That's actually abnormal in this region since the cold makes them prone to failure.",
		},
		
		["alis"] = {
			"I remember heading to that region a while back. The conditions are pretty harsh, so be prepared.",
			"Well? Found anything?",
		},
		
		["ursula"] = {
			"I hear you got picked to go on a solo assignment. Good luck out there.",
			"We weren't able to find anything last time. Hopefully you eventually come up with something.",
		},
		
		["lumia"] = {
			"If it isn't our rising star! I've never been in that region since the expedition a few years ago happened before I could go on such assignments.",
			"I'm not even surprised to see you come back completely unharmed anymore, haha.",
		},
		
		["flowen"] = {
			"Going to the snowy region? Watch yourself out there, the conditions are harsh. Your movement will be impeded by the cold water or made very slippery on the ice.",
			"We didn't turn up with anything 5 years ago. While I don't doubt your skill, I doubt a single person will be able to find something a whole expedition couldn't...",
		},
		
		["bernie"] = {
			"Going solo are we? I find it relaxing to be able to go at your own pace without pressure to move as a group.",
			"Pretty refreshing is it not? I meant, being to be your own lead, not the temperature. Haha.",
		},
		
		["lukot"] = {
			"This area you're going to is pretty dangerous. There were almost no Badniks last time, but the conditions alone were problematic.",
			"You had to deal with a lot of enemies on top of the harsh weather? This is weird. There were so few last time...",
		},
		
		["sue"] = {
			"Now what job should I take...",
			"I hear you're operating solo now too.",
		},
		
		["pharia"] = {
			"Last expedition turned nothing up... But the region remains a mystery... Wish I could go, but I have other assignments...",
			"I'll be looking forward to what you may find...",
		},
		
		["garoa"] = {
			"That place, huh. Yeah, I remember it. The enemies weren't plentiful or particularly dangerous, but the conditions were atrocious.",
			"Lots of Badniks, that's atypical for an area where they have trouble operating. At least you weren't caught in a snowstorm.",
		},
	},

	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {nil, nil},
		[DIFF_HARD] = 	{"weaponsbadge_1", 3},
	},
	
	levelsynch = {
		[DIFF_NORMAL] = {14, 25},
		[DIFF_HARD] = {45, 74},
	},

	-- recommended level...
	recommended = {
		[DIFF_NORMAL] = 18,
		[DIFF_HARD] = 60,
		[DIFF_VERYHARD] = 70,
	},
	
	levels = {
		[DIFF_NORMAL] = 20,
		[DIFF_HARD] = 67,
		[DIFF_VERYHARD] = 101,
	},

	grading = {
		{QG_TIME, 50, 0, TICRATE*60*15, TICRATE*60*20},
		{QG_DAMAGETAKEN, 40, 0, 600, 1000},
		{QG_NOINCAP, 10},
	},
	
	layout = {
		{0, 9600, 384, 180, 0, 0, 0, 1},
		{MT_PSO_LASERTOWER, 5664, 96, 0, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 5664, 320, 1, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 5664, 576, 2, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 5664, 832, 3, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 5760, 192, 0, 0, 0, 1, 2503},
		{MT_PENGUINATOR, 4128, -2208, 180, 0, 0, 2, 129},
		{MT_PSO_ROOMANCHOR, 5600, 928, 1, 0, 0, 0, 2500},
		{7, 7232, 352, 0, 0, 0, 0, 101},
		{7, 7232, 704, 0, 0, 0, 0, 101},
		{MT_PENGUINATOR, 6944, 544, 0, 0, 0, 0, 129},
		{MT_PENGUINATOR, 6720, 448, 0, 0, 0, 1, 129},
		{MT_PENGUINATOR, 6720, 640, 0, 0, 0, 1, 129},
		{17, 8000, 320, 180, 0, 0, 1, 111},
		{17, 8032, 704, 180, 0, 0, 1, 111},
		{MT_PSO_UNLOCKCARD, 6144, 480, 1, 0, 0, 1, 2502},
		{MT_PSO_CRATE, 5472, 960, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 5248, 992, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 5376, 1152, 180, 0, 0, 0, 2505},
		{MT_POPHAT, 4576, -2400, 270, 0, 0, 2, 130},
		{MT_PENGUINATOR, 4128, -2656, 180, 0, 0, 2, 129},
		{9, 5504, -1952, 90, 256, 16, 0, 103},
		{9, 5024, -2016, 90, 256, 16, 0, 103},
		{MT_PENGUINATOR, 5216, -1632, 90, 0, 0, 0, 129},
		{8, 2752, -2624, 180, 0, 0, 1, 102},
		{8, 3200, -2304, 180, 0, 0, 1, 102},
		{7, 3744, -2432, 0, 0, 0, 1, 101},
		{MT_PSO_ROOMANCHOR, 8192, -64, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 320, -576, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 6080, -3360, 2, 0, 0, 0, 2500},
		{MT_PSO_UNLOCKCARD, 1280, -2336, 1, 0, 0, 2, 2502},
		{MT_PSO_LASERTOWER, 864, -2944, 10, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1120, -2944, 11, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1440, -2944, 12, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1696, -2944, 13, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 800, -2848, 90, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, 1888, -3712, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4864, -4864, 3, 0, 0, 0, 2500},
		{MT_POPHAT, 3968, -4224, 180, 0, 0, 0, 130},
		{7, 3104, -3936, 180, 0, 0, 0, 101},
		{7, 3232, -4192, 180, 0, 0, 0, 101},
		{7, 3104, -4448, 180, 0, 0, 0, 101},
		{7, 2656, -3936, 0, 0, 0, 1, 101},
		{7, 2528, -4192, 0, 0, 0, 1, 101},
		{7, 2688, -4448, 0, 0, 0, 1, 101},
		{MT_POPHAT, 1952, -4224, 0, 0, 0, 1, 130},
		{MT_PSO_JUMPPAD, 5632, -7968, 0, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 6336, -7360, 0, 5120, 320, 0, 2513},
		{MT_PSO_JUMPPAD, 7136, -7776, 0, 0, 0, 0, 2512},
		{MT_PENGUINATOR, 6144, -6848, 90, 5120, 320, 0, 129},
		{MT_PENGUINATOR, 6496, -6848, 90, 5120, 320, 0, 129},
		{MT_POPHAT, 5568, -7040, 90, 0, 0, 0, 130},
		{MT_POPHAT, 7008, -6816, 90, 0, 0, 0, 130},
		{41, 6336, -7904, 90, 5120, 320, 1, 123},
		{6, 6496, -7648, 90, 5120, 320, 1, 100},
		{6, 6176, -7648, 90, 5120, 320, 1, 100},
		{17, 5984, -6240, 0, 0, 0, 2, 111},
		{17, 6624, -6240, 0, 0, 0, 2, 111},
		{17, 6048, -8224, 0, 0, 0, 2, 111},
		{17, 6752, -8224, 0, 0, 0, 2, 111},
		{MT_PENGUINATOR, 6112, -7456, 0, 0, 0, 2, 129},
		{MT_PENGUINATOR, 6336, -7104, 0, 0, 0, 2, 129},
		{MT_PENGUINATOR, 6528, -7456, 0, 0, 0, 2, 129},
		{MT_PSO_UNLOCKCARD, 6336, -7232, 1, 0, 320, 2, 2502},
		{MT_PSO_CRATE, 5504, -6336, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 5632, -6176, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 6944, -5920, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7072, -6176, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7296, -8448, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7136, -8704, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 5536, -8480, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 5728, -8704, 180, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 4800, -3968, 20, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4800, -4160, 21, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4800, -4416, 22, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 4672, -4512, 180, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 4192, -4224, 1, 0, 0, 1, 2502},
		{MT_PSO_ROOMANCHOR, 5216, -5440, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 7776, -9184, 4, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 5696, -1440, 50, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5696, -1728, 51, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5696, -2080, 52, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5696, -2368, 53, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3168, -4800, 60, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3008, -4800, 61, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2784, -4800, 62, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2624, -4800, 63, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5376, -7328, 70, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5376, -7456, 71, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5376, -7584, 72, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5376, -7680, 73, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 928, -11104, 80, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 928, -10880, 81, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1056, -10880, 82, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1184, -10880, 83, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1184, -11104, 84, 0, 0, 1, 2504},
		{MT_PSO_ROOMANCHOR, -576, -9568, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 3264, -11136, 5, 0, 0, 0, 2500},
		{MT_PSO_CRATE, -192, -10464, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -64, -10624, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3488, -9568, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3616, -9728, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3360, -9632, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 4256, -13600, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3712, -9600, 45, 0, 0, 0, 2505},
		{MT_PENGUINATOR, 2656, -10304, 0, 0, 0, 0, 129},
		{MT_PENGUINATOR, 2656, -10688, 0, 0, 0, 0, 129},
		{MT_POPHAT, 1664, -10528, 0, 0, 0, 0, 130},
		{MT_POPHAT, 2656, -10496, 0, 0, 0, 1, 130},
		{41, 1312, -10304, 315, 0, 0, 1, 123},
		{41, 1312, -10784, 45, 0, 0, 1, 123},
		{MT_PSO_CRATE, 4416, -13440, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -64, -10304, 45, 0, 0, 0, 2505},
		{7, 1024, -10400, 0, 0, 0, 2, 101},
		{7, 1024, -10688, 0, 0, 0, 2, 101},
		{7, 2528, -10400, 180, 0, 0, 2, 101},
		{7, 2528, -10688, 180, 0, 0, 2, 101},
		{MT_POPHAT, 1856, -10176, 270, 0, 0, 2, 130},
		{MT_POPHAT, 1856, -10880, 90, 0, 0, 2, 130},
		{MT_POPHAT, 2720, -10496, 180, 0, 0, 2, 130},
		{MT_POPHAT, 928, -10528, 0, 0, 0, 2, 130},
		{MT_PSO_UNLOCKCARD, 1088, -10528, 1, 0, 0, 2, 2502},
		{MT_PSO_CARDREADER, 864, -10816, 90, 0, 0, 1, 2503},
		{MT_PSO_JUMPPAD, 1056, -11008, 50, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 320, -11008, 50, 0, 0, 0, 2513},
		{MT_PSO_ROOMANCHOR, 576, -11232, 6, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 5312, -12896, 6, 0, 0, 0, 2500},
		{7, 1760, -12384, 180, 0, 0, 0, 101},
		{7, 1696, -12608, 180, 0, 0, 0, 101},
		{17, 2080, -12480, 0, 0, 0, 0, 111},
		{17, 1344, -12256, 0, 0, 0, 1, 111},
		{17, 1280, -12608, 0, 0, 0, 1, 111},
		{7, 2176, -12192, 225, 0, 0, 1, 101},
		{7, 2400, -12448, 225, 0, 0, 1, 101},
		{17, 1632, -12384, 0, 0, 0, 2, 111},
		{17, 1600, -12576, 0, 0, 0, 2, 111},
		{17, 2784, -11424, 0, 0, 0, 2, 111},
		{17, 2848, -11808, 0, 0, 0, 2, 111},
		{MT_PENGUINATOR, 2432, -11744, 225, 0, 0, 2, 129},
		{MT_PENGUINATOR, 1696, -12480, 0, 0, 0, 2, 129},
		{MT_PENGUINATOR, 3552, -11392, 180, 0, 0, 3, 129},
		{MT_PENGUINATOR, 3520, -11616, 180, 0, 0, 3, 129},
		{17, 1952, -12224, 0, 0, 0, 3, 111},
		{17, 2496, -12192, 0, 0, 0, 3, 111},
		{MT_PSO_UNLOCKCARD, 4160, -12032, 1, 0, 0, 3, 2502},
		{MT_PSO_LASERTOWER, 4000, -12384, 120, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4160, -12384, 121, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4288, -12384, 122, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4416, -12384, 123, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 3936, -12256, 90, 0, 0, 1, 2503},
		{MT_PSO_CRATE, 4224, -13280, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 4448, -13696, 45, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 5088, -11232, 7, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 11296, -15296, 7, 0, 0, 0, 2500},
		{41, 5664, -13440, 180, 0, 0, 0, 123},
		{41, 5664, -13760, 180, 0, 0, 0, 123},
		{MT_POPHAT, 6208, -13600, 180, 0, 0, 0, 130},
		{MT_PENGUINATOR, 6048, -13408, 180, 0, 0, 1, 129},
		{MT_PENGUINATOR, 6048, -13792, 180, 0, 0, 1, 129},
		{MT_POPHAT, 5440, -13440, 0, 0, 0, 1, 130},
		{MT_POPHAT, 5440, -13760, 0, 0, 0, 1, 130},
		{MT_PSO_UNLOCKCARD, 5952, -13568, 1, 0, 0, 1, 2502},
		{MT_PSO_LASERTOWER, 6400, -13216, 130, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6400, -13472, 131, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6400, -13760, 132, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6400, -13984, 133, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 6304, -13248, 180, 1, 0, 1, 2503},
		{MT_PSO_JUMPPAD, 6624, -13568, 300, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 6752, -12896, 300, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 6752, -12672, 301, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 6720, -11968, 301, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 6912, -11808, 302, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 7872, -11712, 302, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 8032, -11872, 303, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 6368, -13952, 303, 0, 0, 0, 2513},
		{MT_PSO_CRATE, 6944, -12768, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 6688, -11680, 45, 0, 0, 0, 2505},
		{41, 8576, -11808, 180, 0, 0, 2, 123},
		{MT_POPHAT, 9024, -12608, 135, 0, 0, 2, 130},
		{MT_POPHAT, 9440, -12480, 135, 0, 0, 2, 130},
		{MT_PENGUINATOR, 8800, -11712, 180, 0, 0, 2, 129},
		{MT_PENGUINATOR, 8864, -11872, 180, 0, 0, 2, 129},
		{MT_PSO_JUMPPAD, 9440, -12000, 305, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 9600, -12512, 305, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 9280, -12512, 306, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 9312, -12000, 306, 0, 0, 0, 2513},
		{7, 9920, -12896, 90, 0, 0, 3, 101},
		{7, 8928, -12960, 90, 0, 0, 3, 101},
		{MT_POPHAT, 9056, -11904, 270, 0, 0, 3, 130},
		{MT_POPHAT, 9568, -11968, 270, 0, 0, 3, 130},
		{41, 9440, -13408, 180, 0, 0, 3, 123},
		{MT_PSO_UNLOCKCARD, 9632, -11872, 2, 0, 0, 3, 2502},
		{MT_PSO_LASERTOWER, 9408, -11616, 140, 1, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 9632, -11616, 141, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 9856, -11616, 142, 0, 0, 2, 2504},
		{MT_PSO_CARDREADER, 9888, -11680, 270, 1, 0, 2, 2503},
		{MT_PSO_CRATE, 8864, -10304, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9760, -10208, 45, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 11104, -9120, 150, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11264, -9056, 151, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11440, -8992, 152, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11584, -8960, 153, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8960, -5888, 160, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9408, -5888, 161, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9792, -5888, 162, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10240, -5888, 163, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10656, -5888, 164, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11008, -5888, 165, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11424, -5888, 166, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11840, -5888, 167, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, 7904, -5888, 8, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 12160, -9280, 8, 0, 0, 0, 2500},
		{MT_PSO_TELEPORTER, 9824, 384, 1, 1, 0, 0, 2510},
		{MT_POPHAT, 9280, -6912, 315, 0, 0, 0, 130},
		{MT_PSO_TELEPORTER, 10432, -8992, 1, 1, 0, 3, 2510},
		{MT_POPHAT, 11168, -6976, 180, 0, 0, 0, 130},
		{MT_PSO_TELEPORT_DEST, 9696, 384, 0, 0, 0, 0, 2511},
		{41, 9856, -6688, 270, 0, 0, 1, 123},
		{41, 10400, -6688, 270, 0, 0, 1, 123},
		{MT_PENGUINATOR, 8960, -7072, 315, 0, 0, 1, 129},
		{MT_PENGUINATOR, 8896, -7552, 0, 0, 0, 1, 129},
		{MT_PENGUINATOR, 11584, -7488, 180, 0, 0, 1, 129},
		{MT_PENGUINATOR, 11072, -6848, 225, 0, 0, 1, 129},
		{MT_POPHAT, 8896, -7296, 0, 0, 0, 2, 130},
		{MT_PENGUINATOR, 11360, -7264, 180, 0, 0, 1, 129},
		{41, 9856, -7776, 90, 0, 0, 2, 123},
		{41, 10496, -7776, 90, 0, 0, 2, 123},
		{MT_PSO_CRATE, 10176, -8576, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10336, -8512, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10560, -8576, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10208, -8704, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10400, -8640, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10624, -8704, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10048, -8800, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10048, -8672, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10112, -8928, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10240, -8832, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10464, -8800, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10624, -8832, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10752, -8640, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10816, -8800, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10848, -8960, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10336, -8928, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10560, -8928, 0, 5, 0, 2, 2505},
		{8, 9920, -7200, 0, 0, 0, 0, 102},
		{8, 10400, -7200, 0, 0, 0, 0, 102},
		{8, 10176, -7456, 0, 0, 0, 0, 102},
		{8, 10176, -7008, 0, 0, 0, 0, 102},
		{MT_PSO_LASERTOWER, 6016, -9152, 220, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6224, -9152, 221, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6448, -9152, 222, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6656, -9152, 223, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6864, -9152, 224, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 6048, -9056, 90, 0, 0, 1, 2503},
	}
})

table.insert(PSO.info.quests[1].quests, {
	
	name = "3-2: Freezing Cliffs",
	desc = "Your investigation seems to have stirred up Badnik activity. You decide to continue on the outer perimeter of the area and are advised to remain cautious.",
	objective = "Clear the enemies on the mountainside.",
	
	map = mapnum,

	prog = 7,

	locked = true,		-- initially locked
	unlocks = {{1, 9}},	-- unlocks 3-3

	drops = {
		[DIFF_NORMAL] = {	
			{"pine", 1, 0, 5, 100},
			{"burster", 1, 0, 5, 100},
			{"crest", 1, 0, 5, 100},
			{"claw", 0, 0, 5, 100},
			{"peacekeeper", 0, 0, 5, 100},
			{"hammer", 0, 0, 5, 100},			
			
			{"unit_hp_2", 1, 0, 2, 50},
			{"unit_pp_2", 1, 0, 2, 50},
			{"unit_satk_2", 1, 0, 2, 50},
			{"unit_tatk_2", 1, 0, 2, 50},
			{"unit_ratk_2", 1, 0, 2, 50},
			
			{"icicle frame", 1, 0, 1, 50},
		},

		[DIFF_HARD] = {	
			{"alva pine", 1, 0, 5, 50},
			{"alva burster", 0, 0, 5, 50},
			{"alva crest", 0, 0, 5, 50},			

			{"alva doubliss", 1, 0, 5, 100},
			{"alva concentrator", 1, 0, 5, 100},
			
			{"abnormal shard", 0, 0, 1, 600},
			{"axeon", 0, 0, 1, 600},
			{"vjaya", 0, 0, 1, 600},
			{"demonic fork", 0, 0, 1, 600},
			
			{"steel hearts", 51, 79,1, 700},
			{"seal case", 51, 79,1, 700},
			{"zanba", 51, 79, 1, 1000},
			{"last survivor", 51, 79, 1, 1000},
			{"monkey king bar", 51, 79,1, 700},
			{"girasole", 51, 79,1, 700},
			{"d. saber legacy", 51, 79, 1, 1000},
			{"eternal heat", 51, 79, 1, 1000},		
			{"basilleon", 51, 79,1, 700},
			{"longinus", 51, 79,1, 700},
			{"meteor lancer", 51, 79, 1, 1000},
			{"brionac", 51, 79, 1, 1000},			
			{"sarblight", 51, 79,1, 700},
			{"forblight", 51, 79,1, 700},	
			{"grand cross", 51, 79, 1, 1000},
			{"red saber", 51, 79, 1, 1000},
			{"full cylinder", 51, 79,1, 700},
			{"assassin", 51, 79,1, 700},
			{"yasminkov 3000r", 51, 79, 1, 1000},
			{"strauss", 51, 79, 1, 1000},			
			{"wide smack", 51, 79,1, 700},
			{"heimdall", 51, 79,1, 700},
			{"barett", 51, 79, 1, 1000},		
			{"photon launcher", 51, 79,1, 700},
			{"saint kilda", 51, 79,1, 700},
			{"charge howzer", 51, 79, 1, 1000},
			{"gur bazga", 51, 79, 1, 1000},		
			{"yasminkov 2000h", 51, 79,1, 700},
			{"sarcueid", 51, 79,1, 700},
			{"varista", 51, 79, 1, 1000},
			{"bravace", 51, 79, 1, 1000},			
			{"clarita visas", 51, 79,1, 700},
			{"red processor", 51, 79,1, 700},
			{"battle verge", 51, 79, 1, 1000},
			{"brave hammer", 51, 79, 1, 1000},
			{"windmill", 51, 79,1, 700},
			{"hexigraph", 51, 79,1, 700},
			{"serdote", 51, 79, 1, 1000},
			{"rose quartz", 51, 79, 1, 1000},		
			{"tcsm_crawla4", 51, 79,1, 700},
			{"tcsm_omochao", 51, 79, 1, 1000},
			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},
			{"unit_critr_special1", 0, 0, 1, 400},
			{"unit_speed_special1", 0, 0, 1, 400},
			{"unit_speed_3", 0, 0, 1, 300},
			{"unit_critr_3", 0, 0, 1, 300},
			{"unit_critd_3", 0, 0, 1, 300},
			{"unit_all_3", 0, 0, 1, 300},
			{"unit_hppp_2", 0, 0, 1, 100},
			{"unit_hppp_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_2", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},		

			{"winginator", 1, 0, 1, 100},
			{"asterod", 1, 0, 1, 100},
			{"hatted cannon", 1, 0, 1, 100},
			{"fehler frame", 1, 0, 5, 100},
			{"permafrost frame", 1, 0, 1, 100},
			{"hart frame", 1, 0, 1, 100},
			
			{6000, nil, nil, 1, 5},
		},

		[DIFF_VERYHARD] = {	
			
			{"unit_ppsatk_3", 1, 0, 7, 50},
			{"unit_pptatk_3", 1, 0, 7, 50},
			{"unit_ppratk_3", 1, 0, 7, 50},
			{"unit_rainbow_3", 1, 0, 7, 50},		

			{"winginator", 1, 0, 4, 100},
			{"asterod", 1, 0, 4, 100},
			{"hatted cannon", 1, 0, 4, 100},
			{"permafrost frame", 1, 0, 14, 100},
			
			{"saint kilda", 1, 0, 1, 600},
			{"longinus", 1, 0, 1, 600},
			{"heimdall", 1, 0, 1, 600},
			{"girasole", 1, 0, 1, 600},
			
			{"fehler frame", 1, 0, 10, 100},
			{"baston frame", 1, 0, 1, 100},
			{"makel frame", 1, 0, 1, 600},
			
			{6000, nil, nil, 1, 5},
		},
		
	},

	datapods = {
		{4903, -1851, 0,
		"These Badniks with orbiting spikeballs will throw them at you if you stand far away from them. There's a sweet spot where they're completely harmless and can be taken out with no risk using a ranged weapon!",
		},

		{1169, -5296, -184,
		"We've had to fight a bunch of enemies on ice. It used to be difficult, but we found out we could keep our movement snappy by dodge rolling. It's been a lot easier since then!",
		},
	},

	npcdialogue = {
	
		["ogi"] = {
			"If you're going to the outer area, several Jump Pads should be left over from the previous expeditions.",
			"If you're still finding Badniks, something could definitely be happening.",
		},
		
		["alis"] = {
			"Hope your investigation is going well.",
			"Turned up with anything yet?",
		},
		
		["ursula"] = {
			"Heading back out so soon? You don't let up.",
			"If you still found so many enemies, it might be worth pressing on.",
		},
		
		["lumia"] = {
			"You must like this place if you're going back. I'm almost tempted to go with you, but we've got a clean-up operation in a forest-y region.",
			"Who knew it'd be so hot in a forest, ugh... ...Probably beats whatever weather you're dealing with, huh.",
		},
		
		["flowen"] = {
			"I see you don't seem phased by your assignment.",
			"We've been quite busy lately, Badnik activity seems to be on the rise everywhere.",
		},
		
		["bernie"] = {
			"Going to oversee security in the mines today again. Things have been very quiet ever since you got rid of that Tyrant-class.",
			"Pretty uneventful, only a few Badniks turned up by sheer chance after wandering about aimlessly.",
		},
		
		["lukot"] = {
			"Well, you seem to have this all under control. Good luck out there.",
			"How was it?",
		},
		
		["sue"] = {
			"Guess I'll assist with this clean up op...",
			"So, whatever you're doing, is it going well?",
		},
		
		["pharia"] = {
			"We used to make Photon reactors out of the ice of that region... Technology has gotten better since then, though...",
			"How did it go?",
		},
		
		["garoa"] = {
			"You really do remind me of myself, with that way you're carrying yourself.",
			"Well, anything interesting?",
		},
	},

	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {nil, nil},
		[DIFF_HARD] = 	{"weaponsbadge_1", 3},
	},

	levelsynch = {
		[DIFF_NORMAL] = {16, 28},
		[DIFF_HARD] = {45, 74},
	},

	-- recommended level...
	recommended = {
		[DIFF_NORMAL] = 20,
		[DIFF_HARD] = 60,
		[DIFF_VERYHARD] = 70,
	},
	
	levels = {
		[DIFF_NORMAL] = 23,
		[DIFF_HARD] = 68,
		[DIFF_VERYHARD] = 101,
	},

	grading = {
		{QG_TIME, 55, 0, TICRATE*60*13, TICRATE*60*15},
		{QG_DAMAGETAKEN, 45, 0, 650, 900},
		{QG_NOINCAP, 10},
	},
	
	layout = {
		{0, 10208, -4000, 180, 0, 0, 0, 1},
		{MT_PSO_TELEPORTER, 10688, -4352, 1, 1, 0, 0, 2510},
		{MT_PSO_TELEPORT_DEST, 10336, -4000, 0, 0, 0, 0, 2511},
		{MT_PSO_LASERTOWER, 10016, -4864, 0, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10272, -4864, 1, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10528, -4864, 2, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10784, -4864, 3, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11008, -4864, 4, 0, 0, 0, 2504},
		{MT_PSO_CRATE, 9568, -1792, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9856, -1952, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9632, -2176, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9920, -2304, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 9536, -2944, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 6368, -1088, 0, 0, 0, 0, 2500},
		{8, 8544, -2432, 0, 0, 0, 0, 102},
		{8, 9184, -2304, 0, 0, 0, 0, 102},
		{MT_PENGUINATOR, 7808, -1984, 0, 0, 0, 0, 129},
		{MT_PENGUINATOR, 7616, -2304, 0, 0, 0, 0, 129},
		{41, 8992, -1920, 180, 0, 0, 1, 123},
		{41, 7296, -2048, 0, 0, 0, 1, 123},
		{17, 8064, -2240, 0, 0, 0, 1, 111},
		{17, 8608, -1984, 0, 0, 0, 1, 111},
		{MT_PSO_LASERTOWER, 6816, -1536, 10, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6816, -1696, 11, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6816, -1872, 12, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6816, -2064, 13, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, 7296, -1856, 1, 1, 0, 1, 2502},
		{MT_PSO_CARDREADER, 7008, -2048, 0, 1, 0, 1, 2503},
		{MT_PSO_LASERTOWER, 5600, -736, 20, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5408, -736, 21, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5184, -736, 22, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4928, -736, 23, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4480, -1920, 30, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4480, -2144, 31, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4480, -2368, 32, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4480, -2592, 33, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4480, -2848, 34, 0, 0, 0, 2504},
		{MT_PSO_CRATE, 4640, -2112, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 4672, -2496, 0, 0, 0, 0, 2505},
		{MT_PSO_JUMPPAD, 4768, -1152, 0, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 3808, -1056, 0, 0, 0, 0, 2513},
		{MT_PSO_ROOMANCHOR, -3360, 2528, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4288, -1728, 1, 0, 0, 0, 2500},
		{41, 1376, 0, 315, 0, 0, 0, 123},
		{41, 1632, 352, 315, 0, 0, 0, 123},
		{6, 2336, -224, 315, 0, 0, 0, 100},
		{6, 2144, -480, 315, 0, 0, 0, 100},
		{41, -224, 1504, 315, 0, 0, 1, 123},
		{41, -1344, -480, 45, 0, 0, 1, 123},
		{7, 160, 320, 0, 0, 0, 1, 101},
		{7, 608, 1024, 0, 0, 0, 1, 101},
		{17, 2528, -672, 0, 0, 0, 2, 111},
		{17, 2656, -512, 0, 0, 0, 2, 111},
		{17, 2784, -352, 0, 0, 0, 2, 111},
		{7, 288, 608, 315, 0, 0, 2, 101},
		{7, 288, 128, 0, 0, 0, 2, 101},
		{7, -64, 1600, 315, 0, 0, 2, 101},
		{7, -384, 1248, 0, 0, 0, 2, 101},
		{7, -1184, -224, 0, 0, 0, 2, 101},
		{7, -1088, -480, 0, 0, 0, 2, 101},
		{MT_PSO_UNLOCKCARD, 32, 224, 1, 0, 0, 2, 2502},
		{MT_PSO_LASERTOWER, -1696, -128, 50, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1696, -288, 51, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1696, -480, 52, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1696, -704, 53, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1696, -960, 54, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1696, -1184, 55, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2224, -1008, 60, 1, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -2224, -1104, 61, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -2224, -1216, 62, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -2224, -1312, 63, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -2464, -800, 70, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2624, -800, 71, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2784, -800, 72, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2944, -800, 73, 0, 0, 0, 2504},
		{MT_PSO_CARDREADER, -1600, -1088, 0, 0, 0, 1, 2503},
		{MT_PSO_CARDREADER, -2112, -1024, 0, 0, 0, 2, 2503},
		{MT_PSO_JUMPPAD, -2016, -1216, 10, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1248, -3360, 10, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -2432, -1216, 30, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 1088, -2272, 30, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -1248, -3040, 20, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1472, -416, 20, 0, 0, 0, 2513},
		{MT_PSO_ROOMANCHOR, -2272, -2912, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -768, -6144, 2, 0, 0, 0, 2500},
		{7, -1504, -3872, 90, 0, 0, 0, 101},
		{7, -1152, -3904, 90, 0, 0, 0, 101},
		{41, -1312, -4896, 90, 0, 0, 0, 123},
		{MT_POPHAT, -1344, -3776, 270, 0, 0, 1, 130},
		{MT_PENGUINATOR, -1472, -4800, 90, 0, 0, 1, 129},
		{MT_PENGUINATOR, -1152, -4800, 90, 0, 0, 1, 129},
		{MT_POPHAT, -1504, -5408, 90, 0, 0, 2, 130},
		{MT_POPHAT, -1344, -3968, 270, 0, 0, 2, 130},
		{7, -1440, -4128, 270, 0, 0, 2, 101},
		{7, -1184, -4608, 90, 0, 0, 2, 101},
		{MT_PSO_UNLOCKCARD, -1440, -5216, 2, 0, 0, 2, 2502},
		{MT_PSO_CRATE, -1888, -5632, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -1728, -5856, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -1440, -5696, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -1280, -5952, 0, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 1760, -2912, 100, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1760, -2752, 101, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1760, -2496, 102, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1760, -2272, 103, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1760, -2048, 104, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1760, -1824, 105, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3264, -4704, 110, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3264, -4512, 111, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3264, -4320, 112, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3264, -4128, 113, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3264, -3904, 114, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3264, -3680, 115, 0, 0, 0, 2504},
		{MT_PSO_CRATE, 3456, -5152, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3776, -5280, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3360, -5696, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3648, -5632, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 736, -3648, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 3392, -4800, 3, 0, 0, 0, 2500},
		{7, 1888, -4032, 180, 0, 0, 0, 101},
		{7, 1792, -4352, 180, 0, 0, 0, 101},
		{MT_POPHAT, 2688, -4192, 180, 0, 0, 0, 130},
		{41, 2464, -4032, 180, 0, 0, 1, 123},
		{41, 2496, -4320, 180, 0, 0, 1, 123},
		{MT_POPHAT, 3040, -3776, 180, 0, 0, 2, 130},
		{MT_POPHAT, 3104, -4640, 180, 0, 0, 2, 130},
		{7, 2272, -4032, 180, 0, 0, 2, 101},
		{7, 2272, -4288, 180, 0, 0, 2, 101},
		{MT_PSO_UNLOCKCARD, 2880, -4352, 1, 0, 0, 2, 2502},
		{MT_PSO_LASERTOWER, 2624, -4768, 120, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2816, -4768, 121, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3008, -4768, 122, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3168, -4768, 123, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 2656, -4704, 90, 0, 0, 1, 2503},
		{MT_PSO_JUMPPAD, 1216, -6048, 500, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 864, -7584, 500, 0, 0, 0, 2513},
		{MT_PSO_ROOMANCHOR, -384, -6240, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 2656, -9504, 4, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 320, -7424, 130, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 544, -7424, 131, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 768, -7424, 132, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 768, -7264, 133, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 768, -7072, 134, 0, 0, 1, 2504},
		{MT_PENGUINATOR, 384, -7872, 90, 0, 0, 0, 129},
		{MT_PENGUINATOR, 768, -8000, 90, 0, 0, 0, 129},
		{7, 512, -8192, 90, 0, 0, 0, 101},
		{17, 512, -8960, 0, 0, 0, 0, 111},
		{17, 1600, -8256, 0, 0, 0, 0, 111},
		{17, 2016, -7072, 0, 0, 0, 0, 111},
		{MT_PSO_JUMPPAD, 1312, -7360, 1000, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 2048, -7168, 1000, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 2144, -7168, 500, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 1600, -8320, 500, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 416, -8896, 500, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 1184, -7904, 1001, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 608, -8416, 1002, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 1760, -8352, 1001, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 480, -9056, 1002, 0, 0, 0, 2513},
		{41, 1888, -8352, 135, 0, 0, 1, 123},
		{41, 2144, -7040, 180, 0, 0, 1, 123},
		{MT_POPHAT, 416, -9024, 90, 0, 0, 1, 130},
		{41, 416, -7808, 90, 0, 0, 1, 123},
		{41, 672, -7968, 90, 0, 0, 1, 123},
		{MT_PSO_UNLOCKCARD, 672, -7712, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, 288, -7520, 270, 0, 0, 1, 2503},
		{MT_PSO_JUMPPAD, 576, -7264, 1100, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 256, -6784, 1100, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -32, -6848, 1101, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1312, -6976, 1101, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -1440, -7872, 1102, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1344, -9056, 1102, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -1344, -10048, 1103, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1568, -11072, 1103, 0, 0, 0, 2513},
		{MT_PSO_CRATE, -1728, -7424, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -1568, -7040, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -1248, -9056, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -1056, -9472, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -4320, -10752, 5, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 992, -15392, 5, 1, 0, 0, 2500},
		{MT_PSO_LASERTOWER, -2400, -12768, 200, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2176, -12768, 201, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1952, -12768, 202, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1696, -12768, 203, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1472, -12768, 204, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1248, -12768, 205, 0, 0, 1, 2504},
		{7, -1792, -11936, 90, 0, 0, 0, 101},
		{7, -1440, -11872, 90, 0, 0, 0, 101},
		{41, -1728, -12352, 90, 0, 0, 0, 123},
		{MT_POPHAT, -1920, -13856, 90, 0, 0, 1, 130},
		{MT_POPHAT, -2880, -13024, 45, 0, 0, 1, 130},
		{MT_PSO_JUMPPAD, -1952, -12960, 3000, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -2880, -13248, 3000, 0, 0, 0, 2513},
		{MT_PSO_CARDREADER, -2336, -12672, 90, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -1888, -12512, 1, 0, 0, 0, 2502},
		{7, -2112, -12640, 90, 0, 0, 1, 101},
		{7, -1696, -12640, 90, 0, 0, 1, 101},
		{MT_PENGUINATOR, -2624, -13888, 90, 0, 0, 1, 129},
		{41, -3584, -13728, 0, 0, 0, 2, 123},
		{41, -2464, -14464, 135, 0, 0, 2, 123},
		{MT_PSO_JUMPPAD, -2656, -13664, 3001, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1888, -12672, 3001, 0, 0, 0, 2513},
		{17, -2272, -12992, 0, 0, 0, 2, 111},
		{17, -1888, -13152, 0, 0, 0, 2, 111},
		{MT_PSO_LASERTOWER, -1792, -13824, 210, 1, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -1792, -13968, 211, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -1792, -14112, 212, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -1696, -14336, 220, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -1520, -14336, 221, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -1360, -14336, 222, 0, 0, 0, 2504},
		{MT_PSO_CARDREADER, -2096, -14144, 180, 0, 0, 2, 2503},
		{MT_PSO_UNLOCKCARD, -2752, -13824, 2, 0, 0, 2, 2502},
		{MT_PSO_JUMPPAD, -1504, -14112, 3002, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -32, -13824, 3002, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -192, -13408, 3001, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, -128, -13888, 3003, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -2080, -13888, 3003, 0, 0, 0, 2513},
		{MT_POPHAT, -96, -13312, 180, 0, 0, 3, 130},
		{MT_POPHAT, 64, -13920, 180, 0, 0, 3, 130},
		{MT_PENGUINATOR, 224, -13440, 180, 0, 0, 3, 129},
		{MT_PENGUINATOR, 320, -13696, 180, 0, 0, 3, 129},
		{17, -1632, -13088, 0, 0, 0, 4, 111},
		{17, -1376, -12992, 0, 0, 0, 4, 111},
		{17, -1600, -13952, 0, 0, 0, 4, 111},
		{17, -1408, -14240, 0, 0, 0, 4, 111},
		{41, 32, -13600, 180, 0, 0, 4, 123},
		{7, -2080, -12896, 315, 0, 0, 4, 101},
		{7, -1696, -12864, 315, 0, 0, 4, 101},
		{7, -2400, -13792, 0, 0, 0, 4, 101},
		{7, -2688, -14016, 0, 0, 0, 4, 101},
		{MT_PSO_CRATE, 192, -13248, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 64, -13440, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 160, -13696, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 224, -13984, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 224, -14240, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 416, -14208, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 288, -13856, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 448, -14048, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 416, -13728, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 256, -13600, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 320, -13312, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 352, -13504, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 384, -13184, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 0, -13184, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, -64, -13536, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, -32, -13728, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 64, -14016, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 160, -14144, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 384, -14336, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 384, -13952, 0, 5, 0, 4, 2505},
		{MT_PSO_TELEPORTER, 544, -13664, 1, 1, 0, 5, 2510},
	}
})

table.insert(PSO.info.quests[1].quests, {
	
	name = "3-3: Duel At the Summit",
	desc = "A Badnik unit acting as some sort of repeater from the detected signals has been sighted near the summit. Despite a seemingly small size, it gives off a powerful reading and should not be underestimated.",
	objective = "Destroy the command unit!",
	
	map = mapnum,

	prog = 8,

	locked = true,		-- initially locked
	unlocks = {{1, 10}},	-- unlocks 4-1

	levelsynch = {
		[DIFF_NORMAL] = {18, 30},
		[DIFF_HARD] = {45, 74},
	},

	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {nil, nil},
		[DIFF_HARD] = 	{"weaponsbadge_1", 5},
	},
	
	-- recommended level...
	recommended = {
		[DIFF_NORMAL] = 22,
		[DIFF_HARD] = 60,
		[DIFF_VERYHARD] = 70,
	},	
	
	levels = {
		[DIFF_NORMAL] = 25,
		[DIFF_HARD] = 69,
		[DIFF_VERYHARD] = 101,
	},

	grading = {
		{QG_TIME, 150, 0, TICRATE*60*12, TICRATE*60*15},
		{QG_DAMAGETAKEN, 50, 0, 600, 900},
		{QG_NOINCAP, 10},
	},

	datapods = {
		{55, -14049, -192,
		"When the fighting dies down, I like just watching the moon... I wonder if everyone will be able to enjoy it one day...",
		},

		{7234, -8664, -488,
		"Turns out weapons left here in boxes for too long end up affected by the ice and completely lose their original shape. Most get destroyed, but a few turn into surprisingly effective equipment!",
		},		

		{10792, -4538, 416,
		"My initial hunch was correct, there definitely is some strong enemy around here. Explains why so many enemies congregate around here..."
		},	

		{13346, -7840, 128,
		"We lost track of whatever that reading was. It's almost no bigger than a regular enemy but the conditions are just terrible. I suppose we'll head back.",
		},
	},

	npcdialogue = {
	
		["ogi"] = {
			"Ah, a reading after all? Conditions were so bad last time we lost track of our target.",
			"So, you found and destroyed it all your own after all...",
		},
		
		["alis"] = {
			"I think I'll just rest today. Good luck with your investigation once again.",
			"Word is going around that you found another Tyrant-class. Congratulations on destroying it.",
		},
		
		["ursula"] = {
			"Today I'm supposed to surpervise some new recruits. How's your investigation going?",
			"I hear you got rid of another Tyrant-class threat. ...Strong enemies come in small packages too, it seems.",
		},
		
		["lumia"] = {
			"I almost envy you, I have to go back to that super hot jungle again today...",
			"So you came accross a big fish too? So did we! Though I wasn't alone in killing it, haha.",
		},
		
		["flowen"] = {
			"If it's the same reading we got a few years ago, then the enemy in question most likely isn't very big and quite fast. Stay on your guard if you encounter it, it evaded us last time.",
			"Well, I stand corrected, you did manage to make a difference alone where we couldn't as a group before.",
		},
		
		["bernie"] = {
			"Supervising the mines is getting pretty boring. Wish I could tag along with you.",
			"The Tyrant slayer's at it again, heh.",
		},
		
		["lukot"] = {
			"I hear your investigation is going places... Watch yourself, whatever enemy may be lurking there could be more keen on ambushing you considering you're alone.",
			"So it didn't run away this time... It's great to know that you found it.",
		},
		
		["sue"] = {
			"Heard there's some commotion in the jungle area, guess I'll check it out.",
			"That makes two of us having fought Tyrants today, heh. Pay was pretty good.",
		},
		
		["pharia"] = {
			"Be careful... whatever might show up could be a tough one...",
			"Well, that makes another one dealt with...",
		},
		
		["garoa"] = {
			"Whatever's hiding in that place, it gave us the slip back then. Don't let it get away this time.",
			"A frozen-over Badnik, huh. Well, that's a new one. I've definitely encountered the model you described, but it was nor there nor frozen.",
		},
	},
	
	layout = {
		{0, -1792, -12544, 90, 0, 0, 0, 1},
		{MT_PSO_TELEPORTER, -1792, -12704, 1, 1, 0, 0, 2510},
		{MT_PSO_TELEPORT_DEST, -1792, -12608, 0, 1, 0, 0, 2511},
		{MT_PSO_JUMPPAD, -1472, -13024, 0, 1, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -96, -13664, 0, 1, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -160, -13792, 1, 1, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1792, -12800, 1, 1, 0, 0, 2513},
		{MT_PSO_CRATE, 64, -13248, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 416, -13472, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 160, -13760, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 448, -14048, 0, 0, 0, 0, 2505},
		{MT_PSO_JUMPPAD, -1664, -11136, 2, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1280, -9728, 2, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -1344, -9248, 3, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 704, -7744, 3, 0, 0, 0, 2513},
		{MT_PSO_ROOMANCHOR, -640, -6240, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 3904, -9568, 0, 0, 0, 0, 2500},
		{MT_PENGUINATOR, 832, -7264, 270, 0, 0, 0, 129},
		{MT_PENGUINATOR, 1184, -7648, 180, 0, 0, 0, 129},
		{MT_PENGUINATOR, 960, -8000, 135, 0, 0, 0, 129},
		{17, 2016, -7072, 0, 0, 0, 0, 111},
		{17, 1600, -8320, 0, 0, 0, 0, 111},
		{17, 512, -8896, 0, 0, 0, 0, 111},
		{17, 288, -6912, 0, 0, 0, 0, 111},
		{MT_PSO_JUMPPAD, 544, -7328, 10, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 192, -6752, 10, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 2240, -7040, 11, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 1344, -7392, 11, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 1184, -7904, 12, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 1824, -8384, 12, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 480, -9088, 13, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 608, -8416, 13, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 608, -8896, 3, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 1664, -8192, 3, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 2016, -6944, 3, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 384, -6784, 3, 0, 0, 0, 2512},
		{MT_POPHAT, 320, -6816, 0, 0, 0, 1, 130},
		{MT_POPHAT, 2144, -7168, 0, 0, 0, 1, 130},
		{MT_POPHAT, 1792, -8288, 0, 0, 0, 1, 130},
		{MT_POPHAT, 416, -8896, 0, 0, 0, 1, 130},
		{41, 512, -7936, 90, 0, 0, 1, 123},
		{41, 992, -7424, 180, 0, 0, 1, 123},
		{MT_PSO_LASERTOWER, 2048, -8096, 10, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2048, -8256, 11, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2048, -8480, 12, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2048, -8640, 13, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 1952, -8096, 180, 0, 0, 1, 2503},
		{MT_PSO_JUMPPAD, 2176, -8384, 20, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 3264, -7968, 20, 0, 0, 0, 2513},
		{MT_PSO_CRATE, 3200, -7136, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3488, -7104, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3616, -6976, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3360, -6944, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 5152, -5312, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 7648, -9216, 1, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 6016, -9184, 30, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6176, -9184, 31, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6368, -9184, 32, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6560, -9184, 33, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6720, -9184, 34, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6880, -9184, 35, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5952, -5536, 40, 1, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 6128, -5536, 41, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 6320, -5536, 42, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 6496, -5536, 43, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 6640, -5536, 44, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 7168, -7200, 50, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6976, -7200, 51, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6976, -7392, 52, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 7232, -7392, 53, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 6912, -7360, 180, 0, 0, 1, 2503},
		{MT_PSO_JUMPPAD, 7072, -7296, 30, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 6336, -7264, 30, 5248, 328, 0, 2513},
		{17, 5792, -6816, 0, 0, 0, 0, 111},
		{17, 6816, -6688, 0, 0, 0, 0, 111},
		{17, 5920, -8160, 0, 0, 0, 0, 111},
		{17, 6912, -7968, 0, 0, 0, 0, 111},
		{MT_PENGUINATOR, 6272, -7328, 180, 0, 0, 0, 129},
		{MT_PENGUINATOR, 6272, -7552, 180, 0, 0, 0, 129},
		{MT_PENGUINATOR, 6432, -7328, 180, 0, 0, 1, 129},
		{MT_PENGUINATOR, 6432, -7552, 180, 0, 0, 1, 129},
		{41, 6304, -6624, 270, 0, 0, 1, 123},
		{41, 6400, -8480, 90, 0, 0, 1, 123},
		{MT_PSO_UNLOCKCARD, 6592, -7264, 1, 0, 0, 1, 2502},
		{7, 6112, -6432, 270, 5248, 328, 2, 101},
		{7, 6560, -6432, 270, 5248, 328, 2, 101},
		{7, 6176, -7840, 90, 5248, 328, 2, 101},
		{7, 6624, -7840, 90, 5248, 328, 2, 101},
		{41, 6240, -8608, 90, 5248, 328, 3, 123},
		{41, 6560, -8608, 90, 5248, 328, 3, 123},
		{41, 6080, -5952, 270, 5248, 328, 3, 123},
		{41, 6528, -5952, 270, 5248, 328, 3, 123},
		{MT_PSO_UNLOCKCARD, 6304, -5728, 2, 0, 0, 3, 2502},
		{MT_PSO_CARDREADER, 5984, -5600, 270, 0, 0, 2, 2503},
		{MT_PSO_ROOMANCHOR, 1632, -3456, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4320, -4896, 2, 0, 0, 2, 2500},
		{MT_POPHAT, 1984, -3968, 0, 0, 0, 0, 130},
		{MT_POPHAT, 1952, -4480, 0, 0, 0, 0, 130},
		{8, 2528, -4032, 0, 0, 0, 0, 102},
		{8, 2528, -4288, 0, 0, 0, 0, 102},
		{8, 3360, -4032, 180, 0, 0, 1, 102},
		{8, 3360, -4288, 180, 0, 0, 1, 102},
		{MT_POPHAT, 3840, -3936, 180, 0, 0, 1, 130},
		{MT_POPHAT, 3872, -4448, 180, 0, 0, 1, 130},
		{MT_PSO_LASERTOWER, 1824, -3760, 100, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1824, -4048, 101, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1824, -4320, 102, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1824, -4560, 103, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2624, -4800, 110, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2752, -4800, 111, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2880, -4800, 112, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3040, -4800, 113, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3168, -4800, 114, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2496, -5088, 120, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2496, -5280, 121, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2496, -5504, 122, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2496, -5696, 123, 0, 0, 0, 2504},
		{MT_PSO_CRATE, 3424, -5376, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3296, -5056, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3328, -5664, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3680, -5216, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3680, -5536, 0, 0, 0, 0, 2505},
		{MT_PSO_UNLOCKCARD, 1952, -4192, 1, 0, 0, 1, 2502},
		{MT_PSO_ROOMANCHOR, 1696, -1728, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4832, -3136, 3, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 4608, -1888, 130, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4608, -2048, 131, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4608, -2240, 132, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4608, -2432, 133, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4608, -2592, 134, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4608, -2752, 135, 0, 0, 1, 2504},
		{MT_PSO_CRATE, 704, -2240, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 896, -1984, 0, 0, 0, 0, 2505},
		{8, 3680, -2048, 0, 0, 0, 0, 102},
		{8, 3712, -2560, 0, 0, 0, 0, 102},
		{41, 3168, -2144, 180, 0, 0, 0, 123},
		{41, 3168, -2432, 180, 0, 0, 0, 123},
		{41, 2016, -2144, 0, 0, 0, 1, 123},
		{41, 2016, -2464, 0, 0, 0, 1, 123},
		{MT_PENGUINATOR, 3040, -2144, 180, 0, 0, 1, 129},
		{MT_PENGUINATOR, 3040, -2432, 180, 0, 0, 1, 129},
		{MT_PSO_LASERTOWER, 5616, -1408, 140, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5440, -1408, 141, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5248, -1408, 142, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5024, -1408, 143, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4832, -1408, 144, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, 5728, -1024, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 10752, -3168, 4, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 8704, -2800, 150, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 8704, -2592, 151, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 8896, -2592, 152, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 9088, -2592, 153, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 9088, -2800, 154, 0, 0, 1, 2504},
		{MT_PSO_JUMPPAD, 8896, -2720, 500, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 8896, -3136, 500, 0, 0, 0, 2513},
		{7, 7392, -1920, 135, 0, 0, 0, 101},
		{7, 7168, -2080, 135, 0, 0, 0, 101},
		{MT_POPHAT, 7968, -2272, 180, 0, 0, 0, 130},
		{41, 6976, -1792, 315, 0, 0, 1, 123},
		{41, 8672, -1952, 180, 0, 0, 1, 123},
		{41, 9664, -2336, 180, 0, 0, 1, 123},
		{17, 9312, -1664, 0, 0, 0, 1, 111},
		{17, 9664, -1888, 0, 0, 0, 1, 111},
		{17, 7424, -2368, 0, 0, 0, 1, 111},
		{MT_PSO_UNLOCKCARD, 8896, -2432, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, 8736, -2496, 90, 0, 0, 1, 2503},
		{MT_PSO_CRATE, 9984, -3680, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 10368, -3904, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 10112, -5216, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 10144, -5568, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9728, -5632, 0, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 8720, -9440, 200, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8928, -9440, 201, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9184, -9440, 202, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9440, -9440, 203, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9680, -9440, 204, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11136, -9120, 210, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 11360, -9120, 211, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 11584, -9120, 212, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 11776, -9120, 213, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 11072, -8928, 90, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, 7936, -5920, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 12224, -9472, 5, 0, 0, 0, 2500},
		{7, 11168, -6848, 135, 0, 0, 0, 101},
		{7, 11392, -7136, 135, 0, 0, 0, 101},
		{7, 9056, -6752, 45, 0, 0, 0, 101},
		{7, 8768, -7136, 45, 0, 0, 0, 101},
		{8, 9824, -6848, 0, 0, 0, 0, 102},
		{8, 10336, -6848, 0, 0, 0, 0, 102},
		{17, 10016, -8576, 0, 0, 0, 1, 111},
		{17, 10240, -8480, 0, 0, 0, 1, 111},
		{17, 10656, -8512, 0, 0, 0, 1, 111},
		{41, 9920, -7360, 90, 0, 0, 1, 123},
		{41, 10304, -7360, 90, 0, 0, 1, 123},
		{MT_POPHAT, 8960, -7680, 90, 0, 0, 1, 130},
		{MT_POPHAT, 11616, -7776, 90, 0, 0, 1, 130},
		{MT_PSO_UNLOCKCARD, 11136, -8640, 1, 0, 0, 1, 2502},
		{MT_PSO_CRATE, 11712, -10112, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 12704, -10112, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 13888, -10784, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 14144, -10432, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 12480, -7232, 6, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 14976, -9664, 6, 0, 0, 0, 2500},
		{7, 13024, -8832, 270, 0, 0, 0, 101},
		{7, 13440, -8640, 270, 0, 0, 0, 101},
		{41, 13216, -8384, 270, 0, 0, 0, 123},
		{41, 13024, -8576, 270, 0, 0, 1, 123},
		{41, 13344, -8512, 270, 0, 0, 1, 123},
		{MT_POPHAT, 13056, -9664, 90, 0, 0, 2, 130},
		{MT_POPHAT, 13600, -9632, 90, 0, 0, 2, 130},
		{MT_PENGUINATOR, 13056, -8416, 270, 0, 0, 2, 129},
		{MT_PENGUINATOR, 13312, -8416, 270, 0, 0, 2, 129},
		{MT_PSO_LASERTOWER, 13632, -7584, 300, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 13632, -7712, 301, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 13632, -7872, 302, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 13632, -8032, 303, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 13632, -8160, 304, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 13504, -8256, 180, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 13216, -8032, 1, 0, 0, 2, 2502},
		{MT_PSO_ICESTABBER, 13920, -4768, 270, 1, 0, 0, 2552},
		{MT_PSO_ROOMANCHOR, 12448, -3392, 7, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 15936, -6816, 7, 1, 0, 0, 2500},
		{MT_PSO_CRATE, 12832, -5152, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 12896, -4768, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 13024, -4480, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 13280, -4192, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 12896, -5440, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 13024, -5760, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 13248, -5984, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 13568, -6144, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 13952, -6176, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 14336, -6144, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 14688, -6048, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 14944, -5792, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 15040, -5536, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 15072, -5248, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 15040, -4960, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 14880, -4672, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 14688, -4416, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 14432, -4192, 0, 1, 0, 0, 2505},
		{MT_PSO_TELEPORTER, 13920, -4032, 1, 1, 0, 1, 2510},
		{MT_PSO_TELEPORTER, 14240, -7712, 255, 0, 0, 0, 2510},
		{MT_PSO_TELEPORT_DEST, 13920, -5664, 255, 0, 0, 0, 2511},
		{MT_PSO_UNLOCKCARD, 1920, -8384, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, 1952, -4608, 0, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 4384, -2336, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, 4512, -1952, 180, 0, 0, 1, 2503},
	},
})

-- crates
PSO.info.crateDropTables[mapnum] = {
		[DIFF_NORMAL] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{50, 0, 0, 1, 10},
			
			{"monogrinder", 0, 0, 4, 100},
			{"digrinder", 0, 0, 2, 100},
			{"telepipe", 0, 0, 1, 60},

			{"boreal ledge", 0, 0, 1, 300},
			{"boreal lance", 0, 0, 1, 300},
			{"boreal cutter", 0, 0, 1, 300},
			{"boreal bullet", 0, 0, 1, 300},
			{"boreal burst", 0, 0, 1, 300},
			{"boreal proud", 0, 0, 1, 300},
			{"boreal staff", 0, 0, 1, 300},
			{"boreal cutlass", 0, 0, 1, 300},
			{"boreal brave", 0, 0, 1, 300},
			{"boreal baguette", 0, 0, 1, 300},

			{"sword_pa_spiralbreak", 0, 0, 1, 300},
			{"dsaber_pa_tornadodance", 0, 0, 1, 300},
			{"spear_pa_millionskewer", 0, 0, 1, 300},
			{"rifle_pa_slideshot", 0, 0, 1, 300},
			{"shotgun_pa_impactrecoil", 0, 0, 1, 300},
			{"launcher_pa_homerunhavoc", 0, 0, 1, 300},
			{"saber_pa_strezwei", 0, 0, 1, 300},
			{"handgun_pa_homingshell", 0, 0, 1, 300},
			{"ragrants", 0, 0, 1, 300},
			{"ramegid", 0, 0, 1, 300},
			{"rafoie", 0, 0, 1, 300},
			{"rabarta", 0, 0, 1, 300},
			{"razonde", 0, 0, 1, 300},
			{"radiga", 0, 0, 1, 300},

			{"unit_hp_2", 0, 0, 2, 100},
			{"unit_satk_2", 0, 0, 2, 100},
			{"unit_ratk_2", 0, 0, 2, 100},
			{"unit_tatk_2", 0, 0, 2, 100},
			{"unit_pp_2", 0, 0, 2, 100},
			{"unit_hppp_2", 0, 0, 2, 100},
			{"unit_ppregen_1", 0, 0, 1, 100},
			{"unit_critr_2", 0, 0, 1, 100},
			{"unit_critd_2", 0, 0, 1, 100},
			{"unit_speed_2", 0, 0, 1, 100},
			
			{"monomate", 0, 0, 1, 20},
			{"dimate", 0, 0, 1, 30},
			{"trimate", 0, 0, 1, 50},
			{"moon atomizer", 0, 0, 1, 30},
			{"breaker", 0, 0, 2, 100},
			{"doublegladius", 0, 0, 2, 100},
			{"laser", 0, 0, 2, 100},
			{"canon", 0, 0, 2, 100},
			{"ulrod", 0, 0, 2, 100},
			{"slash", 0, 0, 2, 100},
			{"autogun", 0, 0, 2, 100},
			{"batnara", 0, 0, 2, 100},
			
		},
		
		[DIFF_HARD] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 10},
			{"monomate", 0, 0, 1, 40},
			{"dimate", 0, 0, 1, 60},
			{"trimate", 0, 0, 1, 70},
			{"telepipe", 0, 0, 1, 60},

			{"boreal ledge", 0, 0, 1, 300},
			{"boreal lance", 0, 0, 1, 300},
			{"boreal cutter", 0, 0, 1, 300},
			{"boreal bullet", 0, 0, 1, 300},
			{"boreal burst", 0, 0, 1, 300},
			{"boreal proud", 0, 0, 1, 300},
			{"boreal staff", 0, 0, 1, 300},
			{"boreal cutlass", 0, 0, 1, 300},
			{"boreal brave", 0, 0, 1, 300},
			{"boreal baguette", 0, 0, 1, 300},

			{"permafrost frame", 0, 0, 1, 60},
			{"baston frame", 0, 0, 1, 500},
			{"makel frame", 0, 0, 1, 1000},
			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},
			{"unit_critr_special1", 0, 0, 1, 400},
			{"unit_speed_special1", 0, 0, 1, 400},
			{"unit_speed_3", 0, 0, 1, 300},
			{"unit_critr_3", 0, 0, 1, 300},
			{"unit_critd_3", 0, 0, 1, 300},
			{"unit_all_3", 0, 0, 1, 300},
			{"unit_hppp_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},
			{"unit_ppratk_3", 0, 0, 1, 100},
			{"unit_ppsatk_3", 0, 0, 1, 100},
			{"unit_pptatk_3", 0, 0, 1, 100},

			{"unit_satk_3", 0, 0, 1, 100},
			{"unit_ratk_3", 0, 0, 1, 100},
			{"unit_tatk_3", 0, 0, 1, 100},

			{"sword_pa_overend", 0, 0, 1, 300},
			{"dsaber_pa_quickgash", 0, 0, 1, 300},
			{"spear_pa_scythecleave", 0, 0, 1, 300},
			{"rifle_pa_revoltaim", 0, 0, 1, 300},
			{"shotgun_pa_trickblast", 0, 0, 1, 300},
			{"launcher_pa_feareraser", 0, 0, 1, 300},
			{"ilgrants", 0, 0, 1, 300},
			{"ilmegid", 0, 0, 1, 300},
			{"foverse", 0, 0, 1, 300},
			{"nabarta", 0, 0, 1, 300},
			{"zondeel", 0, 0, 1, 300},
			{"diverse", 0, 0, 1, 300},
			{"zalure", 0, 0, 1, 300},
			{"jellen", 0, 0, 1, 300},
			
			{"scape doll", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 20},
			{"star atomizer", 0, 0, 1, 20},
			{"sol atomizer", 0, 0, 1, 50},
			{"shiftaride", 0, 0, 1, 50},
			{"debanride", 0, 0, 1, 50},

			{"vita pine", 0, 0, 1, 100},
			{"vita shooter", 0, 0, 1, 100},
			{"vita crest", 0, 0, 1, 100},
			{"vita hammer", 0, 0, 1, 100},
			{"vita claw", 0, 0, 1, 100},
			{"vita peacekeeper", 0, 0, 1, 100},	
			{"vita fork", 0, 0, 1, 100},
			{"vita grenade", 0, 0, 1, 100},						
		},

		[DIFF_VERYHARD] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 5},
			{"monomate", 0, 0, 1, 40},
			{"dimate", 0, 0, 1, 60},
			{"trimate", 0, 0, 1, 80},
			{"telepipe", 0, 0, 1, 60},

			{"boreal ledge", 0, 0, 1, 300},
			{"boreal lance", 0, 0, 1, 300},
			{"boreal cutter", 0, 0, 1, 300},
			{"boreal bullet", 0, 0, 1, 300},
			{"boreal burst", 0, 0, 1, 300},
			{"boreal proud", 0, 0, 1, 300},
			{"boreal staff", 0, 0, 1, 300},
			{"boreal cutlass", 0, 0, 1, 300},
			{"boreal brave", 0, 0, 1, 300},
			{"boreal baguette", 0, 0, 1, 300},
			
			{"scape doll", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 20},
			{"star atomizer", 0, 0, 1, 20},
			{"sol atomizer", 0, 0, 1, 50},
			{"shiftaride", 0, 0, 1, 50},
			{"debanride", 0, 0, 1, 50},
			
			{"vita pine", 0, 0, 1, 100},
			{"vita shooter", 0, 0, 1, 100},
			{"vita crest", 0, 0, 1, 100},
			{"vita hammer", 0, 0, 1, 100},
			{"vita claw", 0, 0, 1, 100},
			{"vita peacekeeper", 0, 0, 1, 100},	
			{"vita fork", 0, 0, 1, 100},
			{"vita grenade", 0, 0, 1, 100},	

			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},			
			{"makel frame", 0, 0, 1, 1000},
			{"baston frame", 0, 0, 1, 300},
			{"permafrost frame", 0, 0, 1, 100},
			{"unit_ppsatk_3", 0, 0, 1, 100},
			{"unit_ppratk_3", 0, 0, 1, 100},
			{"unit_pptatk_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},
			{"unit_all_3", 0, 0, 1, 300},		
		},
		
}