local mapnum = 9

/*
	quest format:
	{
		>>COSMETIC STUFF
		name: 		quest name
		objective:	description of the objective
		desc: 		description
	
	
		>>ACTUAL GAMEPLAY RELEVANT STUFF
		map:		map number the quest takes place in
					(players will be warped to it as soon as everyone gets to the teleporter)
		
		layout = {}: 	object layout for the map.
						worth noting the object layout CANNOT be changed in the lobby.
		
		levels = {                                                                    ,..,.,.,.,.,.,..        
			[DIFF_NORMAL] = x,
			[DIFF_HARD] = x,
			[...]
		}: enemy level per difficulty
		
		
		
	}
*/

/*table.insert(PSO.info.quests[mapnum], {
	
	name = "Test quest",
	desc = "Doesn't load object layout, enemy level matches player level",
	objective = "Test your shit",
	
	map = 1,
	
	levels = {
		[DIFF_NORMAL] = 1,
		[DIFF_HARD] = 1,
		--[DIFF_VERYHARD] = 1,
		[DIFF_SUPERHARD] = 1,
		[DIFF_EXTREMELYHARD] = 1,
		[DIFF_ULTRAHARD] = 1,
	},
})*/


table.insert(PSO.info.quests[1].quests, {
	
	name = "7-1: Lost Utopia",
	desc = "The recent attack bringing attention to the Moon led to the discovery of an unknown structure on its surface. Numerous readings similar to the ones from attack were detected, so we're sending operatives to investigate. Mind the low gravity.",
	objective = "Explore the structure on the Moon.",
	
	map = mapnum,
	prog = 14,

	locked = true,		-- initially locked
	unlocks = {{1,16 }},	-- unlocks 7-2

	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {nil, nil},
		[DIFF_HARD] = 	{"weaponsbadge_1", 7},
	},

	drops = {
		[DIFF_NORMAL] = {	
			{"vita pine", 1, 0, 5, 100},
			{"vita burster", 1, 0, 5, 100},
			{"vita crest", 1, 0, 5, 100},
			{"vita claw", 0, 0, 5, 100},
			{"vita peacekeeper", 0, 0, 5, 100},
			{"vita hammer", 0, 0, 5, 100},			
			
			{"unit_hp_3", 1, 0, 2, 50},
			{"unit_pp_3", 1, 0, 2, 50},
			{"unit_satk_3", 1, 0, 2, 50},
			{"unit_tatk_3", 1, 0, 2, 50},
			{"unit_ratk_3", 1, 0, 2, 50},	

			{"vulture basher", 36, 55, 1, 150},
			{"double driller", 36, 55, 1, 150},
			{"winginator", 36, 55, 1, 150},
			{"sneg zapper", 36, 55, 1, 150},
			{"command shot", 36, 55, 1, 150},
			{"poss shooter", 36, 55, 1, 150},
			{"ice stabberrod", 36, 55, 1, 150},
			{"tcsm_crawla3", 36, 55, 1, 150},
			{"ice lancer", 36, 55, 1, 150},
			{"hatted cannon", 36, 55, 1, 150},
			{"asterod", 36, 55, 1, 150},
			
			{"fehler frame", 1, 0, 1, 50},
			{"hart frame", 1, 0, 1, 50},
		},

		[DIFF_HARD] = {	
			
			{"unit_hpsatk_3", 1, 0, 2, 50},
			{"unit_hptatk_3", 1, 0, 2, 50},
			{"unit_hpratk_3", 1, 0, 2, 50},

			{"abnormal shard", 0, 0, 1, 500},
			{"steel hearts", 51, 79,1, 700},
			{"seal case", 51, 79,1, 700},
			{"zanba", 51, 79, 1, 1000},
			{"last survivor", 51, 79, 1, 1000},
			{"chainsawd", 51, 79, 1, 2000},
			{"dragon slayer", 51, 79, 1, 2000},
			{"monkey king bar", 51, 79,1, 700},
			{"girasole", 51, 79,1, 700},
			{"d. saber legacy", 51, 79, 1, 1000},
			{"eternal heat", 51, 79, 1, 1000},
			{"vivienne", 51, 79, 1, 2000},
			{"double cannon", 51, 79, 1, 2000},			
			{"basilleon", 51, 79,1, 700},
			{"longinus", 51, 79,1, 700},
			{"meteor lancer", 51, 79, 1, 1000},
			{"brionac", 51, 79, 1, 1000},
			{"vjaya", 51, 79, 1, 2000},
			{"soul eater", 51, 79, 1, 2000},			
			{"sarblight", 51, 79,1, 700},
			{"forblight", 51, 79,1, 700},	
			{"grand cross", 51, 79, 1, 1000},
			{"red saber", 51, 79, 1, 1000},
			{"elysion", 51, 79, 1, 2000},
			{"axeon", 51, 79, 1, 2000},
			{"full cylinder", 51, 79,1, 700},
			{"assassin", 51, 79,1, 700},
			{"yasminkov 3000r", 51, 79, 1, 1000},
			{"strauss", 51, 79, 1, 1000},
			{"firearms", 51, 79, 1, 2000},
			{"frozen shooter", 51, 79, 1, 2000},			
			{"wide smack", 51, 79,1, 700},
			{"heimdall", 51, 79,1, 700},
			{"barett", 51, 79, 1, 1000},
			{"crush bullet", 51, 79, 1, 1000},
			{"spread needle", 51, 79, 1, 2000},
			{"final impact", 51, 79, 1, 2000},			
			{"photon launcher", 51, 79,1, 700},
			{"saint kilda", 51, 79,1, 700},
			{"charge howzer", 51, 79, 1, 1000},
			{"gur bazga", 51, 79, 1, 1000},
			{"sspm launcher", 51, 79, 1, 2000},
			{"inferno bazooka", 51, 79, 1, 2000},			
			{"yasminkov 2000h", 51, 79,1, 700},
			{"sarcueid", 51, 79,1, 700},
			{"varista", 51, 79, 1, 1000},
			{"bravace", 51, 79, 1, 1000},
			{"pandora extreme", 51, 79, 1, 2000},
			{"ruby bullet", 51, 79, 1, 2000},			
			{"clarita visas", 51, 79,1, 700},
			{"red processor", 51, 79,1, 700},
			{"battle verge", 51, 79, 1, 1000},
			{"brave hammer", 51, 79, 1, 1000},
			{"siren hammer", 51, 79, 1, 2000},
			{"demonic fork", 51, 79, 1, 2000},
			{"windmill", 51, 79,1, 700},
			{"hexigraph", 51, 79,1, 700},
			{"serdote", 51, 79, 1, 1000},
			{"rose quartz", 51, 79, 1, 1000},
			{"rykros staff", 51, 79, 1, 2000},
			{"evil curst", 51, 79, 1, 2000},		
			{"tcsm_crawla4", 51, 79,1, 700},
			{"tcsm_omochao", 51, 79, 1, 1000},
			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},
			{"unit_critr_special1", 0, 0, 1, 400},
			{"unit_speed_special1", 0, 0, 1, 400},
			{"unit_speed_3", 0, 0, 1, 300},
			{"unit_critr_3", 0, 0, 1, 300},
			{"unit_critd_3", 0, 0, 1, 300},
			{"unit_all_3", 0, 0, 1, 300},
			{"unit_hppp_2", 0, 0, 1, 100},
			{"unit_hppp_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_2", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},
			
			{"vulture basher", 1, 0, 4, 100},
			{"double driller", 1, 0, 4, 100},
			
			{"trigrinder", 1, 0, 10, 100},
			
			{6000, nil, nil, 1, 5},
		},

		[DIFF_VERYHARD] = {	
			
			{"unit_hpsatk_3", 1, 0, 2, 50},
			{"unit_hptatk_3", 1, 0, 2, 50},
			{"unit_hpratk_3", 1, 0, 2, 50},
			
			{"vulture basher", 1, 0, 4, 100},
			{"double driller", 1, 0, 4, 100},
			
			{"trigrinder", 1, 0, 10, 100},
			
			{"sarblight", 1, 0, 1, 600},
			{"forblight", 1, 0, 1, 600},
			{"yasminkov 2000h", 1, 0, 1, 600},
			{"sarcuied", 1, 0, 1, 600},
			{"baston frame", 1, 0, 1, 100},
			{"makel frame", 1, 0, 1, 600},
			
			{6000, nil, nil, 1, 5},
		},
		
	},

	datapods = {
		{938, -1928, 200,
		"Grrrah! Damn that pesky rodent and his friends! My beautiful plan, gone, once again... However, no evil genius is without a backup. This secret lunar base of mine will make for a perfect hideout until I get my revenge!!",
		},

		{3558, -966, 264,
		"I can't stand all that greenery... It's necessary for oxygen alright, but the sooner I can build my empire over this planet, the better!",
		},

		{1843, 1697, 0,
		"Some things have definitely fallen apart since I last visited... Grraah, no matter, the low gravity makes it easier to traverse anyway.",
		},

		{-3794, -2102, 224,
		"Using a Chaos Emerald I managed to get away with, I was able to locate an entity powerful enough to teach that rodent a lesson, and primitive enough to be easily controlled by my genius... Oh, how the stars align once again!",
		},

		{381, 6144, 0,
		"Ah, right, it's not that it was in disrepair, it's that I didn't finish building this place to begin with because I couldn't stand the greenery!! It's a good thing I have an oxygen mask anyway.",
		},

		{-5214, 16510, 64,
		"Oh, these springs, a marvel of my boundless genius! Using them allows me to leap again in the air! ...But why did I make them mandatory to go through that hallway anyway!?",
		},

		{7613, 13373, 920,
		"I prepared several contigency measures to leash that primordial evil in case it tries to do anything remotely idiotic! Badniks made from pure positive energy from the Chaos Emerald!",
		},

		{8058, 12798, 920,
		"These new creations of mine will not only keep that monster in check, but their remarkable strength will let me rain judgment on that hedgehog!!",
		},
		
	},

	npcdialogue = {
	
		["ogi"] = {
			"The structure found on the moon appears to be quite incomplete, it doesn't have anything to stabilize the gravity.",
			"That was definitely an experience unlike any other I've had thus far...",
		},
		
		["alis"] = {
			"Be careful, we're going onto uncharted territory, both in the area and the enemies we'll face...",
			"I found many curious logs in there, I'm not sure what they're referring to yet.",
		},
		
		["ursula"] = {
			"This place is most likely going to crawl with those things we fought off. The armour won't have enough fuel to take trips to and from there, so we'll be forced to go on foot.",
			"These enemies are definitely a step above the usual Badniks we've been fending off...",
		},
		
		["lumia"] = {
			"It's exciting to get to fight new enemies in a new place!",
			"Definitely the most dangerous place so far... fighting in the vaccum of space is not something I ever want to do again...!",
		},
		
		["flowen"] = {
			"We should prepare carefully, this place is most likely full of those new enemies.",
			"These things work in conjunction with Badniks. Whatever they are, we must be careful.",
		},
		
		["bernie"] = {
			"The first scans report there's no gravity stabilizers in this facility... Be careful not to be sent flying.",
			"Whoever built this thing is definitely eccentric, and the logs confirm that...",
		},
		
		["lukot"] = {
			"And just when things were going our way, we now face a brand new threat, huh...",
			"I hear the deeper parts of the facility do have gravity stabilizers, so we shouldn't have to float about anymore.",
		},
		
		["sue"] = {
			"Never would've imagined there was such a thing right under our nose, and we completely missed it, being so preoccupied with the actual planet and all...",
			"Fighting in low gravity is messing with all of my muscle memory... I took a few bad hits.",
		},
		
		["pharia"] = {
			"There is definitely more than meets the eye with this place... Scans indicate there are deeper levels, we must find ways to get there...",
			"Preliminary scans indicate that the journey further down is going to be long...",
		},
		
		["garoa"] = {
			"I don't exactly do well with that floatiness, I'll take it easy. Don't wanna end up bedridden again...",
			"I'm glad to hear the areas further below won't have any of that low gravity nonsense.",
		},
	},

	levelsynch = {
		[DIFF_NORMAL] = {34, 48},
		[DIFF_HARD] = {45, 80},
	},
	
	recommended = {
		[DIFF_NORMAL] = 40,
		[DIFF_HARD] = 65,
		[DIFF_VERYHARD] = 70,
	},
	
	levels = {
		[DIFF_NORMAL] = 42,
		[DIFF_HARD] = 77,
		[DIFF_VERYHARD] = 101,
	},

	grading = {
		{QG_TIME, 300, 0, TICRATE*60*30, TICRATE*60*40},
		{QG_DAMAGETAKEN, 100, 0, 6000, 10000},
		{QG_NOINCAP, 100},
	},

	layout = {}
})


table.insert(PSO.info.quests[1].quests, {
	
	name = "7-2: Lunar seal",
	desc = "Readings similar to those of the command unit subjugated in the Depths were detected far beneath the Moon's surface. We expect the path to be long and treacherous and advise operatives taking part in the mission to prepare themselves thoroughly.",
	objective = "Find the source of the signal under the Moon's surface.",
	
	map = mapnum+1,
	prog = 15,

	locked = true,		-- initially locked
	unlocks = {{1,17 }},	-- unlocks 8-X

	drops = {},
	
	levels = {
		[DIFF_NORMAL] = 45,
		[DIFF_HARD] = 78,
		--[DIFF_VERYHARD] = 70,
	},

	levelsynch = {
		[DIFF_NORMAL] = {37, 50},
		[DIFF_HARD] = {45, 80},
	},
	
	recommended = {
		[DIFF_NORMAL] = 42,
		[DIFF_HARD] = 65,
		[DIFF_VERYHARD] = 70,
	},

	grading = {
		{QG_TIME, 700, 0, TICRATE*60*45, TICRATE*60*60},
		{QG_DAMAGETAKEN, 700, 0, 15000, 30000},
		{QG_NOINCAP, 100},
	},

	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {nil, nil},
		[DIFF_HARD] = 	{"weaponsbadge_1", 15},
	},

	datapods = {
		{-2728, 35, -296,
		"The entity I summoned forth is now perfectly under my control thanks to these new Badniks. ...It exudes a tremendous dark force and unparalled power...",
		},

		{-16343, 3943, -104,
		"Through unknown means, it would seem some of my Badniks have been disconnected from my network and have started acting erratically... A strange green glow is emanating from some of them. I must investigate this.",
		},

		{-26113, 9405, -72,
		"That... thing... somehow mana#ged t-- \n*The rest of the message is unintelligible static...*",
		},

		{4288, 7680, 0,
		"46281%%-My be$$$$t efforts-@#%&*$$$ --U??8Badniks%&%$4567%%So long as they stay operational, this pure malevol*&(*(do, do(((destroy them. So768*(***this pure malevolence cann((^%$$Eot escape.",
		},
		-- Despite my best efforts, I cannot eliminate it nor send it back from whence it came... Using the last of my resources, I built Badniks capable of restraining it even through their hacked instructions.
		-- So long as they stay operational, this pure malevolence cannot escape.
		-- Whatever you do, do NOT destroy them.
	},

	npcdialogue = {
	
		["ogi"] = {
			"Apparently, the facility below is capable of producing Badniks...",
			"...So this Dark Falz essentially tricked us into freeing it... ...We're all counting on you.",
		},
		
		["alis"] = {
			"There are readings for several Tyrant-class Badniks in there, this is not going to be easy.",
			"It can't be helped, these things were clearly trying to kill you.",
		},
		
		["ursula"] = {
			"This place is absolutely gigantic... Don't be afraid to come back to resupply.",
			"So that thing... Was able to hack and control Badniks to guide us to it so we could incidentally free it...",
		},
		
		["lumia"] = {
			"This expedition just keeps on getting crazier...",
			"So that thing just used you to escape... It even modified some of the logs to make it more believable. ...J-Just what is it!?",
		},
		
		["flowen"] = {
			"Steel yourself, this is probably going to be our toughest mission yet.",
			"So some entity was pulling the strings all along...",
		},
		
		["bernie"] = {
			"I have a feeling this won't be a walk in the park. Make sure to bring Telepipes.",
			"So this thing had control over a whole army of Badniks and used it to lure us over...",
		},
		
		["lukot"] = {
			"I'm preparing a whole stash of supplies for this. I don't think this will be easy.",
			"I'm rooting for you, I know you can defeat it.",
		},
		
		["sue"] = {
			"This isn't going to be easy, even I'm being cautious with that one.",
			"So these things were actually somehow keeping something even worse in check, huh. Something about the devil we know and the devil we don't know...",
		},
		
		["pharia"] = {
			"We're unable to scan further below... Something is jamming the signals...",
			"I see... So that is the Dark Falz thing the logs spoke about... A monstrosity summoned for a plot of revenge that backfired horribly...",
		},
		
		["garoa"] = {
			"Whatever that place's got in store, I'm sure we'll overcome this.",
			"An abomination... If we leave that thing be, who knows what it'll do...",
		},
	},

	layout = {
		{MT_PSO_TELEPORTER, -1504, 12864, 401, 0, 0, 1, 2510},
		{MT_PSO_CRATE, -256, 1792, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1152, 2368, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 576, 3776, 315, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -4416, 5888, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -832, 1856, 0, 0, 0, 0, 2500},
		{17, -2880, 5056, 0, 0, 0, 0, 111},
		{17, -2368, 4992, 0, 0, 0, 0, 111},
		{17, -1728, 5248, 0, 0, 0, 0, 111},
		{17, -3264, 2752, 0, 8, 0, 0, 111},
		{17, -2752, 2816, 0, 8, 0, 0, 111},
		{17, -2240, 2688, 0, 8, 0, 0, 111},
		{MT_PSO_GANNIL_SLASH, -2560, 4096, 0, 0, 0, 0, 2703},
		{MT_PSO_ROOMANCHOR, 96, -6816, 11, 0, 0, 0, 2500},
		{MT_PSO_GANNIL_SHOT, -2432, 5312, 270, 0, 0, 1, 2704},
		{MT_PSO_CRATE, 4416, 1216, 0, 1, 0, 0, 2505},
		{MT_PSO_GYLIR_CANNON, -3392, 3968, 0, 0, 32, 1, 2701},
		{MT_PSO_GYLIR_CANNON, -1152, 3712, 180, 0, 32, 1, 2701},
		{39, -7472, -32, 0, 0, 0, 0, 122},
		{7, -7312, -400, 0, 8, 0, 0, 101},
		{7, -6912, -112, 0, 8, 0, 0, 101},
		{7, -7248, 256, 0, 8, 0, 0, 101},
		{MT_PSO_ROOMANCHOR, -16960, 7520, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -11008, 3840, 4, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, -2400, 2016, 0, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2704, 2016, 1, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3072, 2016, 2, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3408, 2016, 3, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -2288, 2208, 90, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -2896, 2400, 1, 0, 0, 1, 2502},
		{17, -8304, 96, 0, 0, 0, 0, 111},
		{17, -8160, 384, 0, 0, 0, 0, 111},
		{MT_PSO_UNLOCKCARD, -8512, 480, 1, 0, 0, 0, 2502},
		{MT_PSO_ROOMANCHOR, -9824, 1168, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -5584, -1312, 1, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, -6864, -1200, 10, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -7264, -1200, 11, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -7664, -1200, 12, 0, 0, 1, 2504},
		{MT_PSO_ROOMANCHOR, -11600, -3456, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -6208, -7920, 2, 0, 0, 0, 2500},
		{MT_PSO_GANNIL_SLASH, -8864, -4960, 45, 0, 0, 0, 2703},
		{MT_PSO_CRATE, 4928, 1024, 0, 1, 0, 0, 2505},
		{MT_PSO_GYLIR_DRILL, -9152, -5328, 45, 0, 0, 0, 2702},
		{MT_PSO_GYLIR_DRILL, -9712, -5776, 45, 0, 0, 1, 2702},
		{MT_PSO_GYLIR_DRILL, -9072, -6048, 45, 0, 0, 1, 2702},
		{MT_PSO_GANNIL_SLASH, -9232, -5840, 45, 0, 0, 1, 2703},
		{MT_PSO_GYLIR_CANNON, -10704, -6384, 0, 0, 32, 2, 2701},
		{MT_PSO_GYLIR_CANNON, -10704, -6880, 0, 0, 32, 2, 2701},
		{39, -11008, -6624, 0, 0, 0, 2, 122},
		{132, -12736, -6704, 0, 0, 0, 0, 550},
		{132, -13552, -5456, 0, 0, 0, 0, 550},
		{132, -13424, -3760, 0, 0, 0, 0, 550},
		{132, -14128, -2160, 0, 0, 0, 0, 550},
		{MT_PSO_CARDREADER, -6944, -1104, 90, 0, 0, 1, 2503},
		{MT_PSO_CRATE, -7072, -3136, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -7920, -2160, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -14736, -144, 315, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -15120, 2768, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -11456, 368, 3, 0, 0, 0, 2500},
		{MT_PSO_GYLIR_CANNON, -13552, 1584, 225, 0, 32, 0, 2701},
		{MT_PSO_GYLIR_CANNON, -12848, 1216, 225, 0, 32, 0, 2701},
		{9, -13120, 1776, 225, 8, 32, 0, 103},
		{9, -12816, 1520, 225, 8, 32, 0, 103},
		{MT_PSO_GYRREY_GLARDIA_MAIN, -1210, 21936, 270, 1, 728, 0, 2557},
		{MT_PSO_ROOMANCHOR, -4416, 22880, 300, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 2600, 15944, 300, 1, 0, 0, 2500},
		{12, -12384, 5280, 270, 0, 32, 0, 106},
		{MT_PSO_GYLIR_DRILL, 1280, -7936, 270, 0, 0, 0, 2702},
		{12, -11648, 5152, 270, 0, 0, 0, 106},
		{7, -12352, 4704, 270, 8, 0, 0, 101},
		{MT_PSO_ROOMANCHOR, 1856, -9088, 11, 0, 0, 0, 2500},
		{MT_PSO_GYLIR_DRILL, 768, -7936, 270, 0, 0, 0, 2702},
		{7, -11872, 4736, 270, 8, 0, 0, 101},
		{MT_PSO_GANNIL_SHOT, -12064, 6016, 270, 0, 0, 0, 2704},
		{0, 0, 672, 90, 0, 0, 0, 1},
		{MT_PSO_TELEPORTER, 4704, 7680, 60, 0, 0, 0, 2510},
		{MT_PSO_CRATE, 4864, 320, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 4352, 8000, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 4544, 8128, 0, 1, 0, 0, 2505},
		{MT_PSO_GANNIL_SLASH, -12480, 5920, 270, 0, 0, 1, 2703},
		{MT_PSO_GANNIL_SLASH, -11616, 5952, 270, 0, 0, 1, 2703},
		{MT_PSO_GYLIR_DRILL, -12384, 6688, 270, 0, 0, 1, 2702},
		{MT_PSO_GYLIR_DRILL, -12064, 6688, 270, 0, 0, 1, 2702},
		{39, -12608, 6272, 270, 0, 0, 1, 122},
		{39, -14816, 5472, 90, 0, 0, 2, 122},
		{9, -15040, 6016, 90, 8, 0, 2, 103},
		{9, -14528, 5856, 90, 8, 0, 2, 103},
		{41, -14944, 6528, 90, 8, 32, 2, 123},
		{41, -14432, 6368, 90, 8, 32, 2, 123},
		{132, -15488, 4224, 90, 8, 0, 0, 550},
		{MT_PSO_TELEPORTER, -16000, 4288, 10, 0, 0, 3, 2510},
		{MT_PSO_TELEPORT_DEST, -15104, 10496, 10, 0, 0, 0, 2511},
		{MT_PSO_SNAPPERBOSS, -15136, 12288, 270, 13, 0, 0, 2550},
		{MT_PSO_ROOMANCHOR, -16544, 13280, 25, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -13600, 10240, 25, 0, 0, 0, 2500},
		{MT_PSO_VIPERBOSS, -8192, 11904, 180, 13, 0, 0, 2551},
		{MT_PSO_ROOMANCHOR, -11136, 14976, 26, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -5184, 8768, 26, 0, 0, 0, 2500},
		{134, -9248, 11424, 0, 0, 0, 0, 552},
		{134, -9248, 12384, 0, 0, 0, 0, 552},
		{134, -8672, 12960, 0, 0, 0, 0, 552},
		{134, -7712, 12960, 0, 0, 0, 0, 552},
		{134, -7136, 12384, 0, 0, 0, 0, 552},
		{134, -7136, 11424, 0, 0, 0, 0, 552},
		{134, -7712, 10848, 0, 0, 0, 0, 552},
		{134, -8672, 10848, 0, 0, 0, 0, 552},
		{MT_PSO_CRATE, -15968, 12640, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -15744, 12640, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -15968, 12448, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -15744, 12448, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -14592, 12640, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -14368, 12640, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -14592, 12448, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -14368, 12448, 0, 1, 0, 0, 2505},
		{MT_PSO_TELEPORTER, -15136, 13024, 11, 0, 0, 1, 2510},
		{MT_PSO_TELEPORT_DEST, -20448, -9024, 11, 0, 0, 0, 2511},
		{MT_PSO_ROOMANCHOR, -21248, -6848, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -19328, -8608, 5, 0, 0, 0, 2500},
		{17, -20928, -7328, 0, 8, 0, 0, 111},
		{17, -20640, -7168, 0, 8, 0, 0, 111},
		{17, -20288, -7168, 0, 8, 0, 0, 111},
		{17, -19744, -7392, 0, 8, 0, 0, 111},
		{17, -19904, -7168, 0, 8, 0, 0, 111},
		{9, -20704, -7552, 270, 8, 22, 0, 103},
		{9, -20096, -7552, 270, 8, 22, 0, 103},
		{7, -20512, -8384, 90, 8, 0, 1, 101},
		{7, -20256, -8384, 90, 8, 0, 1, 101},
		{41, -20608, -7296, 270, 8, 0, 1, 123},
		{41, -20160, -7296, 270, 8, 0, 1, 123},
		{MT_PSO_BUFFPOD, -20736, -7200, 0, 1, 32, 0, 2700},
		{MT_PSO_BUFFPOD, -20000, -7200, 0, 1, 32, 0, 2700},
		{39, -20352, -7264, 270, 0, 0, 2, 122},
		{9, -20640, -7424, 270, 8, 0, 2, 103},
		{9, -20128, -7424, 270, 8, 0, 2, 103},
		{MT_PSO_BUFFPOD, -20672, -7200, 0, 1, 22, 2, 2700},
		{MT_PSO_BUFFPOD, -20064, -7200, 0, 1, 22, 2, 2700},
		{MT_PSO_GANNIL_SLASH, -20416, -7904, 270, 0, 0, 2, 2703},
		{MT_PSO_ROOMANCHOR, -21472, -1760, 6, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -18144, -6560, 6, 0, 0, 0, 2500},
		{MT_PSO_GANNIL_SHOT, -20384, -3040, 270, 0, 0, 0, 2704},
		{17, -20768, -2464, 0, 8, 0, 0, 111},
		{17, -20576, -2208, 0, 8, 0, 0, 111},
		{17, -20288, -2080, 0, 8, 0, 0, 111},
		{17, -19968, -2176, 0, 8, 0, 0, 111},
		{17, -19680, -2400, 0, 8, 0, 0, 111},
		{17, -21152, -6112, 0, 8, 0, 1, 111},
		{17, -20960, -6368, 0, 8, 0, 1, 111},
		{17, -20480, -6400, 0, 8, 0, 1, 111},
		{17, -20160, -6400, 0, 8, 0, 1, 111},
		{17, -19744, -6176, 0, 8, 0, 1, 111},
		{7, -20896, -5760, 90, 8, 0, 1, 101},
		{MT_PSO_LASERTOWER, 512, -7616, 602, 0, 0, 1, 2504},
		{7, -20064, -5888, 90, 8, 0, 1, 101},
		{MT_PSO_CARDREADER, 576, -7712, 270, 0, 0, 1, 2503},
		{37, -20384, -5664, 90, 8, 0, 2, 121},
		{MT_PSO_BUFFPOD, -20928, -5504, 90, 1, 32, 2, 2700},
		{MT_PSO_BUFFPOD, -19936, -5472, 90, 1, 32, 2, 2700},
		{MT_PSO_GANNIL_SLASH, -20448, -6208, 90, 0, 0, 2, 2703},
		{MT_PSO_GYLIR_CANNON, -20864, -2560, 90, 0, 32, 3, 2701},
		{MT_PSO_GYLIR_CANNON, -19776, -2528, 270, 0, 32, 3, 2701},
		{39, -20320, -2688, 270, 0, 0, 3, 122},
		{MT_PSO_LASERTOWER, 1472, -7616, 600, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1056, -7616, 601, 0, 0, 1, 2504},
		{MT_PSO_CRATE, -18944, -2624, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -18560, -2816, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -18656, -2464, 270, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -25024, -1696, 7, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -22656, -9856, 7, 0, 0, 0, 2500},
		{MT_PSO_UNLOCKCARD, -20320, -2368, 1, 0, 0, 3, 2502},
		{MT_PSO_GYLIR_CANNON, -24256, -4224, 90, 0, 1216, 0, 2701},
		{MT_PSO_GYLIR_CANNON, -23488, -4224, 90, 0, 1216, 0, 2701},
		{MT_PSO_GYLIR_DRILL, -24224, -2496, 0, 0, 0, 0, 2702},
		{MT_PSO_GYLIR_DRILL, -24192, -2880, 0, 0, 0, 0, 2702},
		{MT_PSO_GYLIR_CANNON, -24416, -1984, 270, 0, 32, 1, 2701},
		{MT_PSO_GYLIR_CANNON, -23936, -2048, 270, 0, 32, 1, 2701},
		{39, -23744, -4736, 90, 0, 1168, 1, 122},
		{7, -24128, -4320, 90, 0, 1168, 1, 101},
		{7, -23456, -4320, 90, 0, 1168, 1, 101},
		{17, -23968, -6912, 90, 8, 0, 2, 111},
		{17, -23552, -6912, 90, 8, 0, 2, 111},
		{17, -23200, -6976, 90, 8, 0, 2, 111},
		{6, -24064, -7520, 90, 8, 0, 2, 100},
		{6, -23744, -7328, 90, 8, 0, 2, 100},
		{6, -23360, -7520, 90, 8, 0, 2, 100},
		{MT_PSO_GYLIR_CANNON, -24032, -9312, 90, 0, 32, 3, 2701},
		{MT_PSO_GYLIR_CANNON, -23296, -9312, 90, 0, 32, 3, 2701},
		{MT_PSO_ROOMANCHOR, -4256, 14816, 12, 0, 0, 0, 2500},
		{MT_PSO_GYLIR_CANNON, -23840, -6368, 90, 0, 1176, 4, 2701},
		{MT_PSO_GYLIR_CANNON, -23104, -6368, 90, 0, 1176, 4, 2701},
		{39, -23520, -6144, 90, 0, 1176, 4, 122},
		{MT_PSO_ROOMANCHOR, 1376, 8864, 12, 0, 0, 0, 2500},
		{MT_PSO_GANNIL_SHOT, -23808, -2400, 270, 0, 0, 5, 2704},
		{MT_PSO_GANNIL_SHOT, -24192, -8320, 90, 0, 0, 6, 2704},
		{MT_PSO_UNLOCKCARD, -16000, 4512, 1, 0, 0, 2, 2502},
		{MT_PSO_UNLOCKCARD, -23744, -9088, 2, 0, 0, 6, 2502},
		{MT_PSO_LASERTOWER, -24320, -9024, 200, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -24320, -9408, 201, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -24384, -9024, 210, 1, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -24384, -9408, 211, 0, 0, 2, 2504},
		{MT_PSO_CARDREADER, -24256, -8864, 0, 0, 0, 1, 2503},
		{MT_PSO_CARDREADER, -24256, -8960, 0, 0, 0, 2, 2503},
		{MT_PSO_CRATE, -26304, -9024, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -25664, -8896, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -26240, -11072, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -25664, -11456, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -26304, -11776, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -23552, -12928, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -23392, -13408, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -26208, -13408, 270, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -25344, -14592, 8, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -19936, -17408, 8, 0, 0, 0, 2500},
		{MT_PSO_MINETRAP, 416, 3488, 8, 0, 40, 0, 2536},
		{MT_PSO_MINETRAP, -12480, 3040, 8, 0, 56, 0, 2536},
		{MT_PSO_MINETRAP, -24864, -9216, 8, 0, 48, 0, 2536},
		{MT_PSO_MINETRAP, -24896, -13120, 8, 0, 56, 0, 2536},
		{MT_PSO_GYLIR_CANNON, -24832, -16320, 90, 0, 32, 0, 2701},
		{MT_PSO_CRATE, 5056, 8000, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 4864, 8128, 0, 1, 0, 0, 2505},
		{MT_PSO_GYLIR_CANNON, -22912, -16288, 90, 0, 32, 0, 2701},
		{37, -24928, -14944, 270, 8, 0, 1, 121},
		{37, -23008, -14944, 270, 8, 0, 1, 121},
		{41, -24448, -14880, 270, 8, 0, 1, 123},
		{41, -23488, -14880, 270, 8, 0, 1, 123},
		{MT_PSO_GANNIL_SLASH, -24896, -15904, 90, 0, 0, 2, 2703},
		{MT_PSO_GANNIL_SHOT, -23040, -15904, 90, 0, 0, 2, 2704},
		{MT_PSO_LASERTOWER, -16096, 4192, 503, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -16192, 4416, 90, 0, 0, 1, 2503},
		{6, -23008, -15520, 90, 8, 0, 3, 100},
		{6, -22824, -15816, 90, 8, 0, 3, 100},
		{6, -23016, -16168, 90, 8, 0, 3, 100},
		{6, -22856, -16456, 90, 8, 0, 3, 100},
		{6, -25128, -15400, 90, 8, 0, 3, 100},
		{6, -24872, -15656, 90, 8, 0, 3, 100},
		{6, -25032, -16008, 90, 8, 0, 3, 100},
		{6, -24808, -16392, 90, 8, 0, 3, 100},
		{39, -22720, -15488, 180, 0, 0, 4, 122},
		{17, -24704, -15040, 90, 8, 0, 4, 111},
		{17, -24884, -15476, 90, 8, 0, 4, 111},
		{17, -24884, -16052, 90, 8, 0, 4, 111},
		{17, -24468, -16564, 90, 8, 0, 4, 111},
		{17, -24244, -14900, 90, 8, 0, 4, 111},
		{7, -22848, -15200, 180, 8, 0, 4, 101},
		{7, -22880, -15680, 180, 8, 0, 4, 101},
		{MT_PSO_UNLOCKCARD, -21216, -15616, 1, 0, 0, 4, 2502},
		{MT_PSO_LASERTOWER, -20160, -15072, 300, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -20160, -15616, 301, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -20160, -16096, 302, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -20640, -15264, 180, 0, 0, 1, 2503},
		{MT_PSO_CRATE, -20480, -14048, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -19840, -13440, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -20064, -12416, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -18944, -12704, 270, 0, 0, 0, 2505},
		{MT_PSO_MINETRAP, -19936, -12992, 8, 0, 64, 0, 2536},
		{MT_PSO_TELEPORTER, -18048, -13952, 30, 0, 0, 0, 2510},
		{MT_PSO_TELEPORT_DEST, -8192, 13312, 30, 0, 0, 0, 2511},
		{MT_PSO_TELEPORTER, -6784, 11904, 40, 0, 0, 1, 2510},
		{MT_PSO_TELEPORT_DEST, -1344, -4288, 40, 0, 0, 0, 2511},
		{MT_PSO_CRATE, -8480, 13312, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -7872, 13312, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -6784, 12256, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -6784, 11584, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -7872, 10496, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -8448, 10496, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -9600, 11584, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -9600, 12224, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -17952, -13248, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -18432, -13728, 270, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 1984, -2432, 9, 4, 200, 0, 2500},
		{MT_PSO_ROOMANCHOR, 6528, -5184, 9, 4, 3424, 0, 2500},
		{MT_POPHAT, 4288, -3968, 0, 8, 0, 0, 130},
		{MT_POPHAT, 4800, -3968, 0, 8, 0, 0, 130},
		{9, 4544, -3008, 180, 8, 0, 0, 103},
		{9, 5120, -3392, 180, 8, 0, 0, 103},
		{18, 5440, -3008, 180, 8, 0, 0, 112},
		{MT_PSO_GYLIR_DRILL, 5760, -2880, 180, 8, 0, 1, 2702},
		{MT_PSO_GYLIR_DRILL, 5888, -3456, 180, 8, 0, 1, 2702},
		{MT_PSO_BUFFPOD, 5440, -2816, 180, 1, 32, 0, 2700},
		{MT_PSO_BUFFPOD, 3136, -3904, 180, 1, 32, 0, 2700},
		{MT_PSO_GANNIL_SHOT, 3072, -3776, 0, 0, 0, 1, 2704},
		{MT_PSO_TELEPORT_DEST, 4672, -896, 401, 0, 0, 0, 2511},
		{MT_PSO_TELEPORTER, 1120, -7296, 400, 0, 0, 0, 2510},
		{MT_PSO_GANNIL_SLASH, 5568, -3200, 180, 0, 0, 2, 2703},
		{7, 5696, -2816, 180, 8, 0, 2, 101},
		{7, 5696, -3584, 180, 8, 0, 2, 101},
		{39, 6144, -3200, 180, 0, 0, 2, 122},
		{MT_PSO_ROOMANCHOR, 7392, -2912, 10, 4, 300, 0, 2500},
		{MT_PSO_ROOMANCHOR, 10464, -7584, 10, 0, 300, 0, 2500},
		{MT_PSO_TELEPORT_DEST, -1210, 19294, 60, 0, 0, 0, 2511},
		{MT_POPHAT, 9632, -6272, 0, 8, 0, 0, 130},
		{MT_POPHAT, 8960, -5824, 0, 8, 0, 0, 130},
		{MT_PSO_GANNIL_SLASH, 8416, -6304, 135, 0, 0, 0, 2703},
		{MT_PSO_GYLIR_DRILL, 8547, -7124, 135, 0, 0, 0, 2702},
		{MT_PSO_GYLIR_DRILL, 7840, -6400, 135, 0, 0, 0, 2702},
		{17, 8864, -4128, 0, 8, 0, 1, 111},
		{17, 8224, -4480, 0, 8, 0, 1, 111},
		{17, 7872, -5056, 0, 8, 0, 1, 111},
		{7, 7968, -6176, 315, 8, 0, 1, 101},
		{7, 8128, -6784, 315, 8, 0, 1, 101},
		{7, 8832, -6656, 315, 8, 0, 1, 101},
		{7, 9248, -6976, 135, 8, 0, 1, 101},
		{MT_PSO_GANNIL_SHOT, 8128, -4032, 270, 8, 0, 2, 2704},
		{MT_PSO_GANNIL_SHOT, 9952, -7136, 135, 8, 0, 2, 2704},
		{MT_POPHAT, 9632, -5824, 0, 8, 0, 2, 130},
		{MT_POPHAT, 8992, -5056, 0, 8, 0, 2, 130},
		{MT_PSO_GYLIR_CANNON, 9408, -6272, 0, 0, 32, 2, 2701},
		{MT_PSO_LASERTOWER, -15904, 4192, 502, 0, 0, 1, 2504},
		{MT_PSO_CRATE, 4128, -12192, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3360, -12960, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 2560, -11552, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 352, -11392, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1504, -9376, 270, 0, 0, 0, 2505},
		{MT_PSO_MINETRAP, 1280, -4320, 8, 0, 32, 0, 2536},
		{MT_PSO_MINETRAP, 3712, -12736, 8, 0, 32, 0, 2536},
		{MT_PSO_MINETRAP, 480, -10688, 8, 0, 32, 0, 2536},
		{MT_PSO_CRATE, -736, 12288, 0, 1, 0, 0, 2505},
		{MT_PSO_TELEPORT_DEST, -1472, 10336, 400, 0, 0, 0, 2511},
		{MT_PSO_ICESTABBER, -1504, 12128, 270, 13, 0, 0, 2552},
		{MT_PSO_CRATE, -2336, 12480, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2112, 12480, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2336, 12288, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2112, 12288, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -960, 12480, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -736, 12480, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -960, 12288, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 4416, 576, 0, 1, 0, 0, 2505},
		{MT_PSO_LASERTOWER, -16096, 4384, 500, 5, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -15904, 4384, 501, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, 1056, -7936, 1, 0, 0, 0, 2502},
		{MT_PSO_TELEPORTER, 0, 320, 1, 1, 0, 0, 2510},
		{MT_PSO_TELEPORT_DEST, 0, 576, 0, 0, 0, 0, 2511},
		{MT_PSO_TELEPORTER, -1200, 20048, 1, 1, 0, 1, 2510},
		{MT_PSO_CRATE, -1600, 19680, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -1200, 19680, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -832, 19680, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -1600, 19280, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -1200, 19296, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -832, 19296, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -1600, 18912, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -1216, 18912, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -816, 18912, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2000, 19680, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -1984, 19280, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -1984, 18912, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -432, 19680, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -448, 19296, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -448, 18912, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -1984, 18528, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -1600, 18528, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -1200, 18528, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -816, 18528, 270, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -448, 18528, 270, 1, 0, 0, 2505},
	}
})


table.insert(PSO.info.quests[1].quests, {
	
	name = "8-X: Corruptor of all",
	desc = "Following the expedition inside the lunar caverns, an entity of tremendous power escaped, damaging the Moon in the process. Signals indicate this entity is reponsible for controlling all Badniks and can thus only be the \"Dark Falz\" mentioned in retrieved logs.",
	objective = "Defeat Dark Falz.",
	
	map = mapnum+2,
	noquestcompletemusic = true,	-- DO NOT THE CAT.
	prog = 16,

	locked = true,		-- initially locked
	timer_off = true,
	
	-- unlocks hard mode + arena
	unlocks = {	{1,1,DIFF_HARD },
				{1,2,DIFF_HARD },
				{1,3,DIFF_HARD },
				{1,4,DIFF_HARD },
				{1,5,DIFF_HARD },
				{1,6,DIFF_HARD },
				{1,7,DIFF_HARD },
				{1,8,DIFF_HARD },
				{1,9,DIFF_HARD },
				{1,10,DIFF_HARD },
				{1,11,DIFF_HARD },
				{1,12,DIFF_HARD },
				{1,13,DIFF_HARD },
				{1,14,DIFF_HARD },
				{1,15,DIFF_HARD },	
				{1,16,DIFF_HARD },
				{1,17,DIFF_HARD },	
				{3,1, DIFF_HARD },
	},
	
	target = MT_PSO_DARKFALZ_FINAL,	-- so that we dont need a layout mask
	playcredits = true,	-- show credits in translucent text after mission is complete
	
	drops = {},
	
	levels = {
		[DIFF_NORMAL] = 50,
		[DIFF_HARD] = 80,
		--[DIFF_VERYHARD] = 70,
	},

	levelsynch = {
		[DIFF_NORMAL] = {40, 54},
		[DIFF_HARD] = {45, 80},
	},
	
	recommended = {
		[DIFF_NORMAL] = 45,
		[DIFF_HARD] = 70,
		[DIFF_VERYHARD] = 70,
	},

	grading = {
		{QG_TIME, 100, 0, TICRATE*60*11, TICRATE*60*13},
		{QG_NOINCAP, 100},
	},

	-- clear reward. multiple of 1 item can be awarded.
	reward = {
		[DIFF_NORMAL] = {nil, nil},
		[DIFF_HARD] = 	{"weaponsbadge_1", 5},
	},

	datapods = {
		{1708, -513, 128,
		"Despite my best efforts, I cannot eliminate it nor send it back from whence it came... Using the last of my resources, I built Badniks capable of restraining it even through their hacked instructions...",
		},

		{1445, -679, 128,
		"So long as they remain operational, this pure malevolence cannot escape. Whatever you do, do NOT destroy them. They are the only things keeping this world from being destroyed.",
		},		

		{1106, -238, 128,
		"I've no desire to see this world annihilated by some eldritch beast's agenda. I've underestimated its power. It was able to assimilate and amplify the power of a single Chaos Emerald to unimaginable levels... If I cannot rule this world, then this thing certainly won't! Not under my watch!",
		},

	},

	npcdialogue = {
	
		["ogi"] = {
			"...So this Dark Falz essentially tricked us into freeing it... ...We're all counting on you.",
			"Words can hardly express how impressed I am with everything you've done...",
		},
		
		["alis"] = {
			"It can't be helped, these things were clearly trying to kill you.",
			"To think you managed to defeat Dark Falz... It hasn't solved all of our problems, but that's a huge step towards reclaiming our home.",
		},
		
		["ursula"] = {
			"So that thing... Was able to hack and control Badniks to guide us to it so we could incidentally free it...",
			"With Dark Falz gone, Badniks are back to wandering about aimlessly. However, I think what we've come to know as Harbingers may become a new problem in the future...",
		},
		
		["lumia"] = {
			"So that thing just used you to escape... It even modified some of the logs to make it more believable. ...J-Just what is it!?",
			"And to think I used to call you a rookie... You've managed to turn the tides almost singlehandedly...",
		},
		
		["flowen"] = {
			"So some entity was pulling the strings all along...",
			"In all my years, never would I have expected to see so much happen in so little time... I might even see the day where this finally ends...",
		},
		
		["bernie"] = {
			"So this thing had control over a whole army of Badniks and used it to lure us over...",
			"I'm almost unimpressed by the fact you defeated an eldritch abomination. You make miracles happen just by breathing!",
		},
		
		["lukot"] = {
			"I'm rooting for you, I know you can defeat it.",
			"I can't thank you enough for bringing this much hope to everyone. Badniks all over the globe are growing disorganized... It's a matter of time until we can reclaim our home.",
		},
		
		["sue"] = {
			"So these things were actually somehow keeping something even worse in check huh. Something about the devil we know and the devil we don't know...",
			"Okay, fine, I have to admit it, you've impressed me. There, happy? ...Pleasantries aside, I don't think anyone but you could've made that happen.",
		},
		
		["pharia"] = {
			"I see... So that is the Dark Falz thing the logs spoke about... A monstrosity summoned for a plot of revenge that backfired horribly...",
			"With Dark Falz gone... Harbingers seem to be resuming normal operations... Which is to destroy any living thing. ...We have these to add to our laundry list, it seems...",
		},
		
		["garoa"] = {
			"An abomination... If we leave that thing be, who knows what it'll do...",
			"And as always, you saved the day. You'll end up with a title at some point!",
		},
	},

	layout = {}
	
})

PSO.info.crateDropTables[mapnum] = {
		
		[DIFF_NORMAL] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 8},
			{"monomate", 0, 0, 1, 20},
			{"dimate", 0, 0, 1, 40},
			{"trimate", 0, 0, 1, 50},
			{"telepipe", 0, 0, 1, 30},

			{"gyras ledge", 0, 0, 1, 300},
			{"gyras lance", 0, 0, 1, 300},
			{"gyras cutter", 0, 0, 1, 300},
			{"gyras bullet", 0, 0, 1, 300},
			{"gyras burst", 0, 0, 1, 300},
			{"gyras proud", 0, 0, 1, 300},
			{"gyras staff", 0, 0, 1, 300},
			{"gyras cutlass", 0, 0, 1, 300},
			{"gyras brave", 0, 0, 1, 300},
			{"gyras baguette", 0, 0, 1, 300},

			{"sword_pa_overend", 0, 0, 1, 300},
			{"dsaber_pa_quickgash", 0, 0, 1, 300},
			{"spear_pa_scythecleave", 0, 0, 1, 300},
			{"rifle_pa_revoltaim", 0, 0, 1, 300},
			{"shotgun_pa_trickblast", 0, 0, 1, 300},
			{"launcher_pa_feareraser", 0, 0, 1, 300},
			{"ilgrants", 0, 0, 1, 300},
			{"ilmegid", 0, 0, 1, 300},
			{"foverse", 0, 0, 1, 300},
			{"nabarta", 0, 0, 1, 300},
			{"zondeel", 0, 0, 1, 300},
			{"diverse", 0, 0, 1, 300},
			{"zalure", 0, 0, 1, 300},
			{"jellen", 0, 0, 1, 300},
			
			{"scape doll", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 20},
			{"star atomizer", 0, 0, 1, 20},
			{"sol atomizer", 0, 0, 1, 50},
			{"shiftaride", 0, 0, 1, 50},
			{"debanride", 0, 0, 1, 50},
			
			{"alva pine", 0, 0, 1, 100},
			{"vita pine", 0, 0, 1, 100},
			{"alva shooter", 0, 0, 1, 100},
			{"vita shooter", 0, 0, 1, 100},
			{"alva crest", 0, 0, 1, 100},
			{"vita crest", 0, 0, 1, 100},
			{"alva hammer", 0, 0, 1, 100},
			{"vita hammer", 0, 0, 1, 100},
			{"alva claw", 0, 0, 1, 100},
			{"vita claw", 0, 0, 1, 100},
			{"alva peacekeeper", 0, 0, 1, 100},
			{"vita peacekeeper", 0, 0, 1, 100},
			{"alva fork", 0, 0, 1, 100},
			{"alva grenade", 0, 0, 1, 100},			
			{"vita fork", 0, 0, 1, 100},
			{"vita grenade", 0, 0, 1, 100},				
			
			{"permafrost frame", 0, 0, 1, 60},
			{"unit_satk_3", 0, 0, 1, 100},
			{"unit_ratk_3", 0, 0, 1, 100},
			{"unit_tatk_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},			
			{"unit_ppsatk_2", 0, 0, 2, 100},
			{"unit_ppratk_2", 0, 0, 2, 100},
			{"unit_pptatk_2", 0, 0, 2, 100},
			{"unit_rainbow_2", 0, 0, 2, 100},
			{"unit_power_2", 0, 0, 2, 100},
			{"unit_ppregen_1", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
		},

		[DIFF_HARD] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 8},
			{"monomate", 0, 0, 1, 30},
			{"dimate", 0, 0, 1, 40},
			{"trimate", 0, 0, 1, 60},
			{"telepipe", 0, 0, 1, 30},
			
			{"scape doll", 0, 0, 1, 100},

			{"gyras ledge", 0, 0, 1, 300},
			{"gyras lance", 0, 0, 1, 300},
			{"gyras cutter", 0, 0, 1, 300},
			{"gyras bullet", 0, 0, 1, 300},
			{"gyras burst", 0, 0, 1, 300},
			{"gyras proud", 0, 0, 1, 300},
			{"gyras staff", 0, 0, 1, 300},
			{"gyras cutlass", 0, 0, 1, 300},
			{"gyras brave", 0, 0, 1, 300},
			{"gyras baguette", 0, 0, 1, 300},

			{"baston frame", 0, 0, 1, 500},
			{"makel frame", 0, 0, 1, 1000},
			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},
			{"unit_critr_special1", 0, 0, 1, 400},
			{"unit_speed_special1", 0, 0, 1, 400},
			{"unit_speed_3", 0, 0, 1, 300},
			{"unit_critr_3", 0, 0, 1, 300},
			{"unit_critd_3", 0, 0, 1, 300},
			{"unit_all_3", 0, 0, 1, 300},
			{"unit_hppp_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},
			{"unit_ppratk_3", 0, 0, 1, 100},
			{"unit_ppsatk_3", 0, 0, 1, 100},
			{"unit_pptatk_3", 0, 0, 1, 100},
			{"unit_hpratk_3", 0, 0, 1, 100},
			{"unit_hpsatk_3", 0, 0, 1, 100},
			{"unit_hptatk_3", 0, 0, 1, 100},

			{"unit_satk_3", 0, 0, 1, 100},
			{"unit_ratk_3", 0, 0, 1, 100},
			{"unit_tatk_3", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 20},
			{"star atomizer", 0, 0, 1, 20},
			{"sol atomizer", 0, 0, 1, 50},
			{"shiftaride", 0, 0, 1, 50},
			{"debanride", 0, 0, 1, 50},
			
			{"vita pine", 0, 0, 1, 100},
			{"vita shooter", 0, 0, 1, 100},
			{"vita crest", 0, 0, 1, 100},
			{"vita hammer", 0, 0, 1, 100},
			{"vita claw", 0, 0, 1, 100},
			{"vita peacekeeper", 0, 0, 1, 100},	
			{"vita fork", 0, 0, 1, 100},
			{"vita grenade", 0, 0, 1, 100},	
		},

		[DIFF_VERYHARD] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 8},
			{"monomate", 0, 0, 1, 40},
			{"dimate", 0, 0, 1, 60},
			{"trimate", 0, 0, 1, 80},
			{"telepipe", 0, 0, 1, 30},

			{"gyras ledge", 0, 0, 1, 300},
			{"gyras lance", 0, 0, 1, 300},
			{"gyras cutter", 0, 0, 1, 300},
			{"gyras bullet", 0, 0, 1, 300},
			{"gyras burst", 0, 0, 1, 300},
			{"gyras proud", 0, 0, 1, 300},
			{"gyras staff", 0, 0, 1, 300},
			{"gyras cutlass", 0, 0, 1, 300},
			{"gyras brave", 0, 0, 1, 300},
			{"gyras baguette", 0, 0, 1, 300},
			
			{"scape doll", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 20},
			{"star atomizer", 0, 0, 1, 20},
			
			{"vita pine", 0, 0, 1, 100},
			{"vita shooter", 0, 0, 1, 100},
			{"vita crest", 0, 0, 1, 100},
			{"vita hammer", 0, 0, 1, 100},
			{"vita claw", 0, 0, 1, 100},
			{"vita peacekeeper", 0, 0, 1, 100},	
			{"vita fork", 0, 0, 1, 100},
			{"vita grenade", 0, 0, 1, 100},	

			{"unit_pp_special1", 0, 0, 1, 400},
			{"unit_hp_special1", 0, 0, 1, 400},
			{"unit_ppregen_special1", 0, 0, 1, 400},			
			{"makel frame", 0, 0, 1, 1000},
			{"baston frame", 0, 0, 1, 300},
			{"unit_ppsatk_3", 0, 0, 1, 100},
			{"unit_ppratk_3", 0, 0, 1, 100},
			{"unit_pptatk_3", 0, 0, 1, 100},
			{"unit_rainbow_3", 0, 0, 1, 100},
			{"unit_power_3", 0, 0, 1, 100},
			{"unit_ppregen_2", 0, 0, 1, 100},
			{"unit_ppregen_3", 0, 0, 1, 100},
			{"unit_all_3", 0, 0, 1, 300},
		},		
}

PSO.info.crateDropTables[mapnum+1] = PSO.info.crateDropTables[mapnum]	-- cbf